Package: systemPipeR
Type: Package
Title: systemPipeR: Workflow Environment for Data Analysis and Report
        Generation
Version: 2.17.0
Date: 2025-05-26
Author: Thomas Girke
Maintainer: Thomas Girke <thomas.girke@ucr.edu>
biocViews: Genetics, Infrastructure, DataImport, Sequencing, RNASeq,
        RiboSeq, ChIPSeq, MethylSeq, SNP, GeneExpression, Coverage,
        GeneSetEnrichment, Alignment, QualityControl, ImmunoOncology,
        ReportWriting, WorkflowStep, WorkflowManagement
Description: systemPipeR is a multipurpose data analysis workflow environment that unifies R with command-line tools. It enables scientists to analyze many types of large- or small-scale data on local or distributed computer systems with a high level of reproducibility, scalability and portability. At its core is a command-line interface (CLI) that adopts the Common Workflow Language (CWL). This design allows users to choose for each analysis step the optimal R or command-line software. It supports both end-to-end and partial execution of workflows with built-in restart functionalities. Efficient management of complex analysis tasks is accomplished by a flexible workflow control container class. Handling of large numbers of input samples and experimental designs is facilitated by consistent sample annotation mechanisms. As a multi-purpose workflow toolkit, systemPipeR enables users to run existing workflows, customize them or design entirely new ones while taking advantage of widely adopted data structures within the Bioconductor ecosystem. Another important core functionality is the generation of reproducible scientific analysis and technical reports. For result interpretation, systemPipeR offers a wide range of plotting functionality, while an associated Shiny App offers many useful functionalities for interactive result exploration. The vignettes linked from this page include (1) a general introduction, (2) a description of technical details, and (3) a collection of workflow templates.
Depends: Rsamtools (>= 1.31.2), Biostrings, ShortRead (>= 1.37.1),
        methods
Imports: GenomicRanges, SummarizedExperiment, ggplot2, yaml, stringr,
        magrittr, S4Vectors, crayon, BiocGenerics, htmlwidgets
Suggests: BiocStyle, knitr, rmarkdown, systemPipeRdata,
        GenomicAlignments, grid, dplyr, testthat, rjson, annotate,
        AnnotationDbi, kableExtra, GO.db, GenomeInfoDb, DT,
        rtracklayer, limma, edgeR, DESeq2, IRanges, batchtools,
        GenomicFeatures, txdbmaker, GenomeInfoDbData, VariantAnnotation
        (>= 1.25.11)
VignetteBuilder: knitr
SystemRequirements: systemPipeR can be used to run external
        command-line software (e.g. short read aligners), but the
        corresponding tool needs to be installed on a system.
License: Artistic-2.0
URL: https://github.com/tgirke/systemPipeR
git_url: https://git.bioconductor.org/packages/systemPipeR
git_branch: devel
git_last_commit: 378a792
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-11-01 00:34:21 UTC; biocbuild

# systemPipeR <img src="https://raw.githubusercontent.com/systemPipeR/systemPipeR.github.io/main/static/images/systemPipeR.png" align="right" height="139" />

[![platforms](http://www.bioconductor.org/shields/availability/release/systemPipeR.svg)](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html#archives)
[![rank](http://www.bioconductor.org/shields/downloads/devel/systemPipeR.svg)](http://bioconductor.org/packages/stats/bioc/systemPipeR/)
[![posts](http://www.bioconductor.org/shields/posts/systemPipeR.svg)](https://support.bioconductor.org/t/systempiper/)
[![Bioc](http://www.bioconductor.org/shields/years-in-bioc/systemPipeR.svg)](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html#since)
[![build](http://www.bioconductor.org/shields/build/devel/bioc/systemPipeR.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/systemPipeR/)
[![updated](http://www.bioconductor.org/shields/lastcommit/devel/bioc/systemPipeR.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/systemPipeR/)
[![dependencies](http://www.bioconductor.org/shields/dependencies/devel/systemPipeR.svg)](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html#since)

<!-- -->
[![R-CMD-check](https://github.com/tgirke/systemPipeR/actions/workflows/R-CMD-build_check.yml/badge.svg)](https://github.com/tgirke/systemPipeR/actions/workflows/R-CMD-build_check.yml)

### Introduction

[_systemPipeR_](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html)
is an R/Bioconductor package for building and running automated *end-to-end*
analysis workflows for a wide range of research applications, including next-generation 
sequencing (NGS) experiments, such as RNA-Seq, ChIP-Seq, VAR-Seq and Ribo-Seq.
Important features include a uniform workflow interface across different data analysis 
applications, automated report generation, and support for running both R and command-line software,
such as NGS aligners or peak/variant callers, on local computers or compute
clusters. The latter supports interactive job submissions and batch submissions
to queuing systems of clusters. Efficient handling of complex sample sets and
experimental designs is facilitated by a well-defined sample annotation
infrastructure which improves reproducibility and user-friendliness of many
typical analysis workflows in the NGS area.

#### Installation 
To install the package, please use the _`BiocManager::install`_ command:
```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("systemPipeR")
```

To obtain the most recent updates immediately, one can install it directly from
github as follow:
```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("tgirke/systemPipeR", build_vignettes=TRUE, dependencies=TRUE)
```

#### Usage

Instructions for running _systemPipeR_ are given in its main
[_vignette_](http://www.bioconductor.org/packages/devel/bioc/vignettes/systemPipeR/inst/doc/systemPipeR.html) (manual).
The sample data set used in the vignette are provided by the data package [_systemPipeRdata_](http://www.bioconductor.org/packages/devel/data/experiment/html/systemPipeRdata.html).
The expected format to define NGS samples (_e.g._ FASTQ files) and their
labels are given in
[_targets.txt_](https://github.com/tgirke/systemPipeR/blob/master/inst/extdata/targets.txt)
and
[_targetsPE.txt_](https://github.com/tgirke/systemPipeR/blob/master/inst/extdata/targetsPE.txt)
(latter is for PE reads).
With the latest [Bioconductor Release 3.9](http://www.bioconductor.org/packages/release/bioc/html/systemPipeR.html), 
we are adopting for this functionality the widely used community standard 
[Common Workflow Language](https://www.commonwl.org/) (CWL) for describing 
analysis workflows in a generic and reproducible manner, introducing _`SYSargs2`_
workflow control class. Using this community standard in _`systemPipeR`_
has many advantages. For instance, the integration of CWL allows running _`sytemPipeR`_
workflows from a single specification instance either entirely from within R, from various command-line
wrappers (e.g., *cwl-runner*) or from other languages (*, e.g.,* Bash or Python).
The run parameters of command-line software are defined by param files that
have a simplified YAML name/value structure. Here is a sample param file
for _Hisat2_:
[_hisat2.cwl_](https://github.com/tgirke/systemPipeR/blob/master/inst/extdata/cwl/hisat2/hisat2-pe/hisat2-mapping-pe.cwl).
Templates for setting up custom project reports are provided by [_systemPipeRdata_](https://github.com/tgirke/systemPipeRdata).
The corresponding PDFs of these report templates are linked here:
[systemPipeRNAseq](http://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRNAseq.html),
[systemPipeRIBOseq](http://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRIBOseq.html),
[systemPipeChIPseq](http://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeChIPseq.html)
and
[systemPipeVARseq](http://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeVARseq.html).

### WorkFlow

|                                               WorkFlow                                               |                    Description                   |                                     Version                                     |                                             R-CMD-check                                            |   |
|:----------------------------------------------------------------------------------------------------:|:------------------------------------------------:|:-------------------------------------------------------------------------------:|:--------------------------------------------------------------------------------------------------:|:-:|
| [systemPipeChIPseq](https://systempiper.github.io/systemPipeChIPseq/articles/systemPipeChIPseq.html) |            ChIP-Seq Workflow Template            |        ![Stable](https://img.shields.io/badge/lifecycle-stable-green.svg)       |  ![R-CMD-check](https://github.com/systemPipeR/systemPipeChIPseq/workflows/R-CMD-check/badge.svg)  |   |
| [systemPipeRIBOseq](https://systempiper.github.io/systemPipeRIBOseq/articles/systemPipeRIBOseq.html) |            RIBO-Seq Workflow Template            |        ![Stable](https://img.shields.io/badge/lifecycle-stable-green.svg)       |  ![R-CMD-check](https://github.com/systemPipeR/systemPipeRIBOseq/workflows/R-CMD-check/badge.svg)  |   |
|   [systemPipeRNAseq](https://systempiper.github.io/systemPipeRNAseq/articles/systemPipeRNAseq.html)  |             RNA-Seq Workflow Template            |        ![Stable](https://img.shields.io/badge/lifecycle-stable-green.svg)       |   ![R-CMD-check](https://github.com/systemPipeR/systemPipeRNAseq/workflows/R-CMD-check/badge.svg)  |   |
|   [systemPipeVARseq](https://systempiper.github.io/systemPipeVARseq/articles/systemPipeVARseq.html)  |             VAR-Seq Workflow Template            |        ![Stable](https://img.shields.io/badge/lifecycle-stable-green.svg)       |   ![R-CMD-check](https://github.com/systemPipeR/systemPipeVARseq/workflows/R-CMD-check/badge.svg)  |   |
|               [systemPipeMethylseq](https://github.com/systemPipeR/systemPipeMethylseq)              |           Methyl-Seq Workflow Template           | ![Experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg) | ![R-CMD-check](https://github.com/systemPipeR/systemPipeMethylseq/workflows/R-CMD-check/badge.svg) |   |
|                  [systemPipeDeNovo](https://github.com/systemPipeR/systemPipeDeNovo)                 | De novo transcriptome assembly Workflow Template | ![Experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg) |   ![R-CMD-check](https://github.com/systemPipeR/systemPipeDeNovo/workflows/R-CMD-check/badge.svg)  |   |
|                 [systemPipeCLIPseq](https://github.com/systemPipeR/systemPipeCLIPseq)                |            CLIP-Seq Workflow Template            | ![Experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg) |  ![R-CMD-check](https://github.com/systemPipeR/systemPipeCLIPseq/workflows/R-CMD-check/badge.svg)  |   |
|               [systemPipeMetaTrans](https://github.com/systemPipeR/systemPipeMetaTrans)              |  Metatranscriptomic Sequencing Workflow Template | ![Experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg) | ![R-CMD-check](https://github.com/systemPipeR/systemPipeMetaTrans/workflows/R-CMD-check/badge.svg) |   |

#### Slides

+ [Overview Slide Show](http://girke.bioinformatics.ucr.edu/systemPipeR/pages/mydoc/systemPipeRslides.html).

########################################################
## .SYSargsList ##
########################################################
`+.SYSargsList` <- function(sal1, sal2){
    if (!inherits(sal1, "SYSargsList")) stop(crayon::red$bold("Argument 1 must be 'SYSargsList' class"))
    if (!inherits(sal2, "SYSargsList")) stop(crayon::red$bold("Argument 2 must be 'SYSargsList' class"))
    options(appendPlus = TRUE)
    appendStep(sal1) <- sal2
    return(sal1)
}

##################################################################
## addAssay: Extension accessor for SummarizedExperiment object ##
##################################################################
setGeneric(name = "addAssay", def = function(x, ...) standardGeneric("addAssay"))
setMethod(f = "addAssay", signature = "SummarizedExperiment", definition = function(x, value, xName = NULL) {
    listSE <- S4Vectors::SimpleList()
    for (i in seq_along(SummarizedExperiment::assays(x))) {
        listSE[[i]] <- SummarizedExperiment::assays(x)[[i]]
    }
    listSE[[length(listSE) + 1]] <- value
    names(listSE) <- c(SummarizedExperiment::assayNames(x), xName)
    SummarizedExperiment::assays(x, withDimnames = FALSE) <- listSE
    return(x)
})

####################################################################
## addMetadata: Extension accessor for SummarizedExperiment object ##
####################################################################
setGeneric(name = "addMetadata", def = function(x, ...) standardGeneric("addMetadata"))
setMethod(f = "addMetadata", signature = "SummarizedExperiment", definition = function(x, value, xName = NULL) {
    listSE <- list()
    for (i in seq_along(S4Vectors::metadata(x))) {
        listSE[[i]] <- S4Vectors::metadata(x)[[i]]
    }
    listSE[[length(listSE) + 1]] <- value
    names(listSE) <- c(names(S4Vectors::metadata(x)), xName)
    SummarizedExperiment::metadata(x) <- listSE
    return(x)
})

##############
## SPRdata ##
##############
SPRdata <- function(counts = S4Vectors::SimpleList(), rowData = NULL, rowRanges = GenomicRanges::GRangesList(),
                    cmp = FALSE, targetspath = NULL, SEobj = NULL, SEobjName = "default") {
    if (is.null(SEobj)) {
        if (is.null(targetspath)) {
            targets <- S4Vectors::DataFrame()
        } else {
            targets <- read.delim(targetspath, comment.char = "#")
        }
        if (cmp == FALSE) {
            metadata <- list(SPRversion = utils::packageVersion("systemPipeR"))
        } else {
            cmpMA <- systemPipeR::readComp(file = targetspath, format = "matrix", delim = "-")
            metadata <- list(SPRversion = utils::packageVersion("systemPipeR"), comparison = cmpMA)
        }
        se <- SummarizedExperiment::SummarizedExperiment(
            assays = counts,
            colData = targets,
            metadata = metadata
        )
        if (all(!length(SummarizedExperiment::assays(se))==0 & is.null(SummarizedExperiment::assayNames(se)))) SummarizedExperiment::assayNames(se) <- "counts"
        return(se)
    } else if (!is.null(SEobj)) {
        if (SEobjName == "default") SEobjName <- paste0("assays_", length(SummarizedExperiment::assays(SEobj)) + 1)
        sprSE <- addAssay(SEobj, counts, SEobjName)
    }
}

## Usage:
# Targets file
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# targets <- read.delim(targetspath, comment.char = "#")
# cmp <- systemPipeR::readComp(file=targetspath, format="matrix", delim="-")
# ## Count table file
# countMatrixPath <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
# countMatrix <- read.delim(countMatrixPath, row.names=1)
# 
# ## Create empty SummarizedExperiment
# #library(S4Vectors)
# library(SummarizedExperiment)
# sprSE <- SPRdata()
# class(sprSE)
# sprSE
# metadata(sprSE)
# ## Create an object with targets file and comparison
# sprSE <- SPRdata(cmp=TRUE, targetspath = targetspath)
# sprSE
# metadata(sprSE)
# colData(sprSE)
# assays(sprSE)
# 
# ## Create an object with targets file and comparison and count table
# sprSE <- SPRdata(counts =  countMatrix, cmp=TRUE, targetspath = targetspath, rowRanges = rowRanges)
# sprSE
# metadata(sprSE)
# colData(sprSE)
# assays(sprSE)
# assay(sprSE)
# assayNames(sprSE)
# ## Add more count table results
# dds <- DESeq2::DESeqDataSetFromMatrix(countData = countMatrix,
#                               colData = targets,
#                               design = ~Factor)
# rld <- DESeq2::rlog(dds, blind=FALSE)
# sprSE <- SPRdata(counts = assay(rld), SEobj = sprSE)
# sprSE
# metadata(sprSE)
# colData(sprSE)

# sprSE <- addAssay(sprSE, assay(rld), xName="test")
# sprSE <- addMetadata(sprSE, list(targets), xName="targets_original")

####################################################################
## Functions to construct SYSargsList objects and other utilities ##
####################################################################

##########################
## SPRproject function ##
##########################
## Detection and creation of the logs directory of the project
## This function detects an existing project or creates a project structure on the path provide
SPRproject <- function(projPath = getwd(), data = "data", param = "param", results = "results",
                       logs.dir = ".SPRproject", sys.file = "SYSargsList.yml",
                       envir = new.env(),
                       restart = FALSE, resume = FALSE,
                       load.envir = FALSE,
                       overwrite = FALSE, silent = FALSE) {
    if (!file.exists(projPath)) stop("Provide valid 'projPath' PATH.")
    projPath <- normalizePath(projPath)
    on.exit(options(projPath = projPath), add = TRUE)
    ## Main folder structure
    dirProject <- .dirProject(projPath = projPath, data = data, param = param, results = results, silent = silent)
    ## sys.file full path
    sys.file <- file.path(logs.dir, sys.file)
    ## log Folder
    logs.dir <- file.path(logs.dir)
    if (file.exists(file.path(projPath, logs.dir)) == FALSE) {
        dir.create(file.path(projPath, logs.dir), recursive = TRUE)
        if (silent != TRUE) cat("Creating directory '", file.path(projPath, logs.dir), "'", sep = "", "\n")
        ## Return SYSargsList obj - empty
        yaml::write_yaml("", file = file.path(projPath, sys.file))
        dirProject <- c(dirProject, logsDir = logs.dir, sysargslist = sys.file)
        init <- as(SYScreate("SYSargsList"), "list")
        init$projectInfo <- dirProject
        init$runInfo <- list(env = envir)
        init <- as(init, "SYSargsList")
        ## used in `importWF`
        options(linewise_importing = FALSE)
    } else if (file.exists(file.path(projPath, logs.dir)) == TRUE) {
        ## reload object from sysarglist
        if (is.null(sys.file)) stop("Provide valid 'sys.file' PATH for restart/resume the project.")
        if (!file.exists(file.path(projPath, sys.file))) stop("Provide valid 'sys.file' PATH for restart/resume the project.")
        restart.sys.file <- normalizePath(file.path(projPath, sys.file))
        ## restart OR resume OR overwrite options...
        if (all(resume == TRUE && restart == TRUE && overwrite == TRUE)) {
            stop("Please select only one action:
        'resume' OR 'restart' OR 'overwrite'")
        } else if (all(resume == FALSE && restart == FALSE && overwrite == FALSE)) {
            stop(
                file.path(projPath, logs.dir),
                " already exists.", "\n",
                "The Workflow can be resume where it was stopped, using the argument 'resume=TRUE'",
                "\n", "OR ", "restart using 'restart=TRUE'. The latter will recover the workflow object, however, it will delete all the existing logs."
            )
        } else if (all(overwrite == TRUE && resume == FALSE && restart == FALSE)) {
            ## Return SYSargsList obj - empty
            unlink(logs.dir, recursive = TRUE)
            dir.create(file.path(projPath, logs.dir), recursive = TRUE)
            if (silent != TRUE) cat("Recreating directory '", file.path(projPath, logs.dir), "'", sep = "", "\n")
            yaml::write_yaml("", file = file.path(projPath, sys.file))
            dirProject <- c(dirProject, logsDir = logs.dir, sysargslist = sys.file)
            init <- as(SYScreate("SYSargsList"), "list")
            init$projectInfo <- dirProject
            init$runInfo <- list(env = envir)
            init <- as(init, "SYSargsList")
        } else if (all(overwrite == FALSE && any(resume, restart))) {
            ## read SYSargsList object
            init <- read_SYSargsList(restart.sys.file)
            init <- as(init, "list")
            if (load.envir == TRUE) {
                if (is.null(init$projectInfo$envir)) {
                    message("We could not find any environment saved...")
                } else {
                    envir <- readRDS(init$projectInfo$envir)
                    init$runInfo <- append(init$runInfo, envir, after = 0)
                    names(init$runInfo)[[1]] <- c("env")
                }
            } else {
                init$runInfo <- append(init$runInfo, envir, after = 0)
                names(init$runInfo)[[1]] <- "env"
                init$projectInfo$envir <- NULL
            }
            init$projectInfo$project <- projPath
            init$projectInfo$logsDir <- logs.dir
            init$projectInfo$sysargslist <- sys.file
            init <- as(init, "SYSargsList")
            if (all(resume == FALSE && restart == TRUE)) {
                ## remove old logs and create a empty folder
                unlink(file.path(projPath, logs.dir), recursive = TRUE)
                dir.create(file.path(projPath, logs.dir), recursive = TRUE)
                if (silent != TRUE) cat("Creating directory '", file.path(projPath, logs.dir), "'", sep = "", "\n")
            }
        } else {
            stop("Please select only one action:
        'resume' OR 'restart' OR 'overwrite'")
        }
    }
    write_SYSargsList(init, file.path(projPath, sys.file), silent = silent)
    ## Message about the paths
    if (normalizePath(getwd()) != projPath) {
        message(
            "Your current working directory is different from the directory chosen for the Project Workflow.",
            "\n",
            "For accurate location of the files and running the Workflow, please set the working directory to ",
            "\n",
            "'setwd('", projPath, "')'"
        )
    }
    return(init)
}

## Usage:
# sal <- SPRproject()
# sal <- SPRproject(projPath = tempdir())
# sal <- importWF(sal,
#                 file_path = system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR"),
#                 verbose = FALSE)
# sal <- SPRproject(resume = TRUE)
# sal <- SPRproject(restart = TRUE)
# sal <- SPRproject(overwrite = TRUE)

##########################
## SYSargsList function ##
##########################
SYSargsList <- function(sysargs = NULL, step_name = "default",
                        targets = NULL, wf_file = NULL, input_file = NULL, dir_path = ".",
                        id = "SampleName",
                        inputvars = NULL,
                        rm_targets_col = NULL,
                        dir = TRUE,
                        dependency = NA,
                        run_step = "mandatory",
                        run_session = "management",
                        run_remote_resources = NULL,
                        silent = FALSE, projPath = getOption("projPath", getwd())) {
    ## step_name and dependency from importWF
    on.exit({
        options(replace_step = FALSE)
        options(spr_importing = FALSE)
    })
    ## check options
    run_step <- match.arg(run_step, c("mandatory", "optional"))
    run_session <- match.arg(run_session, c("management", "compute"))
    if (!is.null(run_remote_resources)) {
        if (!inherits(run_remote_resources, "list")) {
            stop("Argument 'run_remote_resources' needs to be assigned an object of class 'list'")
        }
    }
    ## sal object
    sal <- as(SYScreate("SYSargsList"), "list")
    ## Empty container
    if (all(is.null(sysargs) && is.null(wf_file) && is.null(input_file))) {
        sal <- sal ## This will not create a SPRproject.
        message("Please consider to use 'SPRproject()' function first")
        ## sal container based on a SYSargs2 container ##
    } else if (!is.null(sysargs)) {
        if (inherits(sysargs, "SYSargs2")) {
            if (length(cmdlist(sysargs)) == 0) stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargs2' after 'renderWF()'.")
            if (step_name == "default") {
                step_name <- "Step_x"
            } else {
                .checkSpecialChar(step_name)
                step_name <- step_name
            }
            sal$stepsWF <- list(sysargs)
            ## Targets
            if (length(targets(sysargs)) == 0) {
                sal$targetsWF <- list(NULL)
                sal$SE <- list()
            } else {
                sal$targetsWF <- list(as(sysargs, "DataFrame"))
                row.names(sal$targetsWF[[1]]) <- sal$targetsWF[[1]][, sysargs$files$id]
                sal$SE <- list(SummarizedExperiment::SummarizedExperiment(
                    colData = sal$targetsWF,
                    metadata = sysargs$targetsheader
                ))
            }
            ## Status
            if (length(status(sysargs)) == 0) {
                sal$statusWF <- list(.statusPending(sysargs))
            } else {
                sal$statusWF <- list(status(sysargs))
            }
            sal$dependency <- list(dependency)
            sal$outfiles <- list(.outList2DF(sysargs))
            sal$targets_connection <- list(NULL)
            sal$runInfo <- list(runOption = list(list(
                directory = dir,
                run_step = run_step,
                run_session = run_session
            )))
            if (!is.null(run_remote_resources)) {
                if (run_session == "management") {
                    message("Please note that the '", step_name, "' run_session option '", run_session, "' was replaced with 'compute' because run_remote_resources was available.")
                    run_session <- "compute"
                }
            }
            names(sal$stepsWF) <- names(sal$targetsWF) <- names(sal$statusWF) <- names(sal$dependency) <- names(sal$outfiles) <- names(sal$targets_connection) <- names(sal$runInfo$runOption) <- names(sal$SE) <- step_name
        } else {
            stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargs2'.")
        }
        ## Build the instance from files ##
    } else if (all(!is.null(wf_file) && !is.null(input_file))) {
        ## targets
        if (is.null(targets)) {
            targets <- targets
        } else if (inherits(targets, "character")) {
            if (all(is.fullPath(targets))) {
                targets <- targets
            } else if (all(all(file.exists(file.path(projPath, targets))) && length(targets) == 1)) {
                targets <- file.path(projPath, targets)
            } else { ## connection with previous steps
                targets_step <- targets
                targets <- NULL
            }
        } else if (inherits(targets, "SummarizedExperiment")) {
            se <- targets
            if (sum(dim(colData(targets))) == 0) {
                targets <- NULL
            } else {
                targets <- targets
            }
        } else {
            stop("Argument 'targets' needs to be assigned an object of class 'SummarizedExperiment', 'NULL' or 'character' PATH to tabular file.")
        }
        ## check param path
        if (is.fullPath(dir_path)) {
            dir_path <- dir_path
        } else {
            dir_path <- file.path(projPath, dir_path)
        }
        WF <- loadWF(
            targets = targets, wf_file = wf_file,
            input_file = input_file,
            dir_path = dir_path, id = id
        )
        ## Relative Path for targets and dir_path when these files are in the project folder,
        ## otherwise, keep the full path
        ## targets_path to projPath
        if (!is.null(WF$files$targets)) {
            if (!grepl(projPath, WF$files$targets)) {
                if (!is.na(WF$files$targets)) WF@files$targets <- gsub(projPath, "", WF$files$targets)
                if (all(!is.fullPath(WF$files$targets) && grepl("^/", WF$files$targets))) WF@files$targets <- sub("^(/|[A-Za-z]:|\\\\|~)", "", WF$files$targets)
            }
        }
        if (!grepl(projPath, WF$files$dir_path)) {
            ## dir_path
            if (!is.na(WF$files$dir_path)) WF@files$dir_path <- gsub(projPath, "", WF$files$dir_path)
            if (all(!is.fullPath(dir_path) && grepl("^/", WF$files$dir_path))) WF@files$dir_path <- sub("^(/|[A-Za-z]:|\\\\|~)", "", WF$files$dir_path)
        }
        WF <- renderWF(WF, inputvars = inputvars)
        if (step_name == "default") {
            step_name <- "Step_x"
        } else {
            .checkSpecialChar(step_name)
            step_name <- step_name
        }
        sal$stepsWF <- list(WF)
        names(sal$stepsWF) <- step_name
        ## Connection to previous outfiles
        if (exists("targets_step")) {
            targets_step_list <- list(targets_step = targets_step)
            new_targets_col <- names(inputvars)
            if (is.null(new_targets_col)) {
                stop("inputvars argument need to be assigned to the output column names from the previous step specified on the targets argument")
            }
            new_col <- list(new_targets_col = new_targets_col)
            if (!is.null(rm_targets_col)) {
                rm_col <- list(rm_targets_col = rm_targets_col)
            } else {
                rm_col <- list(rm_targets_col = NULL)
            }
            sal$targets_connection <- list(list(targets_step = targets_step_list, new_targets_col = new_col, rm_targets_col = rm_col))
            names(sal$targets_connection) <- step_name
        }
        if (length(sal$targets_connection) == 0) {
            sal$targets_connection <- list(NULL)
            names(sal$targets_connection) <- step_name
        }
        sal$dependency <- list(dependency)
        sal$statusWF <- list(.statusPending(WF))
        sal$runInfo <- list(runOption = list(list(
            directory = dir,
            run_step = run_step,
            run_session = run_session
        )))
        if (!is.null(run_remote_resources)) {
            if (run_session == "management") {
                message("Please note that the '", step_name, "' run_session option '", run_session, "' was replaced with 'compute' because run_remote_resources was available.")
                run_session <- "compute"
            }
            sal$runInfo <- list(runOption = list(list(
                directory = dir,
                run_step = run_step,
                run_session = run_session,
                run_remote_resources = run_remote_resources
            )))
        }
        ## names
        names(sal$statusWF) <- names(sal$dependency) <- names(sal$runInfo$runOption) <- step_name
        ## outfiles
        if (length(sal$stepsWF) > 0) {
            sal$outfiles <- .outList2DF(sal)
            ## targets
            if (length(targets(sal$stepsWF[[1]])) > 0) {
                sal$targetsWF <- list(as(sal$stepsWF[[1]], "DataFrame"))
                rownames(sal$targetsWF[[1]]) <- sal$targetsWF[[1]][, sal$stepsWF[[1]]$files$id]
                rownames(sal$outfiles[[1]]) <- sal$targetsWF[[1]][, sal$stepsWF[[1]]$files$id]
                if (exists("se", inherits = FALSE)) {
                    colData(se) <- sal$targetsWF[[1]]
                    metadata(se) <- list(metadata = metadata(se), SPRversion = utils::packageVersion("systemPipeR"), targetsheader = sal$stepsWF[[1]]$targetsheader)
                    sal$SE <- list(se)
                } else {
                    sal$SE <- list(SummarizedExperiment::SummarizedExperiment(
                        colData = sal$targetsWF[[1]],
                        metadata = list(SPRversion = utils::packageVersion("systemPipeR"), targetsheader = sal$stepsWF[[1]]$targetsheader)
                    ))
                }
            } else {
                sal$targetsWF <- list(S4Vectors::DataFrame())
                if (exists("se", inherits = FALSE)) {
                    sal$SE <- list(se)
                } else {
                    sal$SE <- list(SummarizedExperiment::SummarizedExperiment())
                }
            }
        }
        names(sal$targetsWF) <- names(sal$SE) <- step_name
    }
    sal <- as(sal, "SYSargsList")
    on.exit(return(sal))
}

####################
## runWF function ##
#####################
.renderMsg <- function(){
    warn_flag <- getOption("spr_render_msg")
    if(isTRUE(warn_flag)) return()
    cat(
        crayon::green$bold("Done with workflow running, now consider rendering logs & reports\n"),
        crayon::blue("To render logs, run:    "), "renderLogs(sal)\n",
        crayon::blue("From command-line:      "), 'Rscript -e "sal=systemPipeR::SPRproject(resume=TRUE);systemPipeR::renderLogs(sal)"\n',
        crayon::blue("To render reports, run: "), 'renderReport(sal)\n',
        crayon::blue("From command-line:      "), 'Rscript -e "sal=systemPipeR::SPRproject(resume=TRUE);systemPipeR::renderReport(sal)"\n',
        crayon::make_style("white")$bold("This message is displayed once per R session\n"),
        sep = ""
    )
    options(spr_render_msg = TRUE)
}

runWF <- function(sysargs, steps = NULL, targets = NULL,
                  force = FALSE, saveEnv = TRUE,
                  run_step = "ALL", ignore.dep = FALSE,
                  warning.stop = FALSE, error.stop = TRUE,
                  silent = FALSE, ...) {
    # Validations
    if (!inherits(sysargs, "SYSargsList")) stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargsList'")
    if (length(sysargs) == 0) message("Workflow has no steps. Please add a step before trying to execute the workflow.")
    if (is.null(projectInfo(sysargs)$project)) {
        stop("'SYSargsList' instance was not initialized with the 'SPRproject' function
           and therefore there is missing the 'projectInfo' slot information.
           Please check 'SPRproject' help file.")
    }
    if (projectInfo(sysargs)$project != normalizePath(getwd())) {
        stop(
            "Your current working directory is different from the directory chosen for the Project Workflow.",
            "\n",
            "For accurate location of the files and running the Workflow, please set the working directory to ",
            "\n",
            "'setwd('", projectInfo(sysargs)$project, "')'"
        )
    }
    if (!dir.exists(projectInfo(sysargs)$logsDir)) stop("Project logsDir doesn't exist. Something went wrong...
        It is possible to restart the workflow saving the SYSargsList object with 'write_SYSargsList()' and restarting the project with 'SPRproject()'")
    sysproj <- projectInfo(sysargs)$logsDir
    ## targets selection
    targets_internal <- targets
    ## Check steps
    if (inherits(steps, "numeric")) {
        if (!all(steps %in% seq_along(sysargs))) {
            stop(
                "Please select the 'steps' number accordingly, options are: ", "\n",
                "        ", paste0(seq_along(sysargs), collapse = ", ")
            )
        }
    } else if (inherits(steps, "character")) {
        if (!all(steps %in% stepName(sysargs))) {
            stop(
                "Please select the 'steps' name accordingly, options are: ", "\n",
                "        ", paste0(stepName(sysargs), collapse = ", ")
            )
        }
        steps <- which(stepName(sysargs) %in% steps)
    }
    ## check dependency
    for (i in seq_along(dependency(sysargs))) {
        if (all(!is.na(dependency(sysargs)[[i]]))) {
            dep_names <- unlist(dependency(sysargs)[[i]])
            if (any(!dep_names %in% names(stepsWF(sysargs)))) {
                if (length(dep_names) == 1) {
                    stop(
                        "'sysargs' has a dependency on the following step:", "\n",
                        paste0("      ", paste0(dep_names)), "\n",
                        "However, this step is not available in the workflow."
                    )
                } else if (length(dep_names) > 1) {
                    stop(
                        "'sysargs' has dependencies on the following steps::", "\n",
                        paste0("      ", paste0(dep_names, collapse = " AND ")), "\n",
                        "However, these steps are not available in the workflow."
                    )
                }
            }
        }
    }
    ## Logs
    file_log <- file.path(sysproj, paste0("_logWF_", format(Sys.time(), "%b%d%Y_%H%M"), "_", paste(sample(0:9, 4), collapse = "")))
    sysargs[["projectInfo"]]$logsFile <- file_log
    ## Select steps for the loop based on the steps argument
    args2 <- sysargs
    if (is.null(steps)) steps <- 1:length(args2)
    ## Select steps for the loop based on the run_step
    if (run_step != "ALL") {
        run_step_wf <- sapply(sysargs$runInfo$runOption, function(x) x$run_step)[steps]
        run_step_names <- names(run_step_wf[run_step_wf %in% run_step])
        if (length(run_step_names) == 0) {
            stop("No step was selected. Please check 'steps', 'run_step' arguments.")
        } else {
            steps <- which(stepName(sysargs) %in% run_step_names)
        }
    }
    ## Selecting
    for (i in seq_along(stepsWF(args2))) {
        if (i %in% steps) {
            ## check single dependency
            if (!ignore.dep) {
                if (all(!is.na(dependency(args2)[[i]]))) {
                    dep_single <- sapply(dependency(args2)[[i]], function(x) args2$statusWF[[x]]$status.summary)
                    if ("Pending" %in% dep_single) {
                        message("Previous steps:", "\n", paste0(names(dep_single), collapse = " AND "), "\n", "have been not executed yet.")
                        break()
                    }
                }
            }
            ## Printing step name
            single.step <- names(stepsWF(args2)[i])
            cat(crayon::bgMagenta("Running Step: ", single.step), "\n")
            ## Printing single.step name at log files
            cat("# ", names(stepsWF(args2)[i]), "\n", file = file_log, fill = TRUE, append = TRUE)
            args.run <- stepsWF(args2)[[i]]
            run_location <- args2$runInfo$runOption[[i]]$run_session
            run_resorces <- args2$runInfo$runOption[[i]]$run_remote_resources
            envir <- args2$runInfo$env
            ## SYSargs2 STEP
            if (inherits(args.run, "SYSargs2")) {
                ## runC arguments
                dir <- args2$runInfo$runOption[[i]]$directory
                dir.name <- single.step
                ## check run_targets
                run_targets <- targets_internal
                ## run_targets input
                if (!is.null(run_targets)) {
                    if (inherits(run_targets, c("numeric", "integer"))) {
                        if (!all(run_targets %in% seq_along(cmdlist(args.run)))) {
                            stop(
                                "Please select the 'targets' number accordingly, options are: ", "\n",
                                "        ", paste0(seq_along(cmdlist(args.run)), collapse = ", ")
                            )
                        }
                    } else if (inherits(run_targets, "character")) {
                        if (!all(run_targets %in% SampleName(args.run))) {
                            stop(
                                "Please select the 'targets' name accordingly, options are: ", "\n",
                                "        ", paste0(SampleName(args.run), collapse = ", ")
                            )
                        }
                        run_targets <- which(SampleName(args.run) %in% run_targets)
                    }
                    run_targets <- run_targets
                } else {
                    run_targets <- seq_along(cmdlist(args.run))
                }
                ## assign to the envir
                assign(x = as.character(as.list(match.call())$sysargs), args2, envir = envir)
                if (run_location == "management") {
                    cat(crayon::bgMagenta("Running Session: Management"), "\n")
                    # RUN
                    args.run <- runCommandline(args.run,
                        dir = dir, dir.name = dir.name,
                        runid = paste0("_", dir.name),
                        force = force, input_targets = run_targets, ...
                    )
                } else if (run_location == "compute") {
                    cat(crayon::bgMagenta("Running Session: Compute Session"), "\n")
                    if (is.null(run_resorces)) stop("Resources are not available for this step.")
                    reg <- clusterRun(args.run[c(run_targets)],
                        FUN = runCommandline,
                        more.args = list(
                            args = args.run[c(run_targets)], dir = dir, dir.name = dir.name,
                            runid = paste0("_", dir.name),
                            force = force, ...
                        ),
                        conffile = run_resorces$conffile,
                        template = run_resorces$template,
                        Njobs = run_resorces$Njobs, runid = paste0("_", dir.name),
                        resourceList = run_resorces
                    )
                    batchtools::waitForJobs()
                    args.run <- .clusterRunResults(args.run, reg, nTargets = length(run_targets))
                    ## time
                    args.run@status$status.time$time_start <- as.POSIXct(args.run@status$status.time$time_start, origin = "1970-01-01")
                    args.run@status$status.time$time_end <- as.POSIXct(args.run@status$status.time$time_end, origin = "1970-01-01")
                    # cat(readLines(args.run$files$log),
                    #     file = file_log, sep = "\n",
                    #     append = TRUE
                    # )
                    ## moving file #reg$file.dir to new directory
                    output_path_args <- .getPath(args.run$output[[run_targets[1]]][[1]][1])
                    output_path_reg <- .getPath(reg$file.dir)
                    if (!identical(output_path_args, output_path_reg)) {
                        file.copy(reg$file.dir, file.path(output_path_args, "_logs"), recursive = TRUE)
                        message("\n", "Moving registry to '", file.path(output_path_args, "_logs"), "'.", "\n")
                        unlink(reg$file.dir, recursive = TRUE)
                        message("Jobs completed successfully!")
                        args.run@files[["log_cluster"]] <- file.path(output_path_args, "_logs", basename(reg$file.dir))
                        args.run@files[["log"]] <- file.path(output_path_args, "_logs", basename(reg$file.dir), basename(args.run@files$log))
                    }
                    ## Printing
                    cat(crayon::blue("---- Summary ----"), "\n")
                    print(args.run$status$status.completed)
                }
                run_targets <- NULL
                ## update object
                step.status.summary <- status(args.run)$status.summary
                statusWF(args2, single.step) <- args.run$status
                stepsWF(args2, single.step) <- args.run
                args2[["outfiles"]][[single.step]] <- .outList2DF(args.run)
                args2 <- .updateAfterRunC(args2, single.step)

                ## assign to the envir
                assign(x = as.character(as.list(match.call())$sysargs), args2, envir = envir)
                ## Stop workflow
                if (is.element("Warning", unlist(step.status.summary))) {
                    if (warning.stop == TRUE) {
                        on.exit(return(args2))
                        stop("Caught an warning, stop workflow!")
                    }
                } else if (is.element("Error", unlist(step.status.summary))) {
                    if (error.stop == TRUE) {
                        on.exit(return(args2))
                        stop("Caught an error, stop workflow!")
                    }
                }
                ## logs
                cat(readLines(args2[["stepsWF"]][[single.step]]$files$log),
                		file = file_log, sep = "\n",
                		append = TRUE
                )
                cat(status_color(step.status.summary)("Step Status: ", step.status.summary, "\n"))
                ## LineWise ##
            } else if (inherits(args.run, "LineWise")) {
                if (!is.null(targets_internal)) message("'targets' argument has been ignored since this step is 'LineWise' instance.")
                ## assign to the envir
                assign(x = as.character(as.list(match.call())$sysargs), args2, envir = envir)
                if (!dir.exists(file.path(sysproj, "Rsteps"))) {
                    dir.create(file.path(sysproj, "Rsteps"))
                }
                file_log_Rcode <- file.path(sysproj, "Rsteps", paste0("_logRstep_", single.step, "_", format(Sys.time(), "%b%d%Y_%H%M%S")))
                if (run_location == "management") {
                    cat(crayon::bgMagenta("Running Session: Management"), "\n")
                    # RUN
                    args.run <- runRcode(args.run,
                        step = single.step, file_log_Rcode = file_log_Rcode,
                        envir = envir, force = force
                    )
                } else if (run_location == "compute") {
                    cat(crayon::bgMagenta("Running Session: Compute Session"), "\n")
                    loaded_pkgs <- .packages()
                    tempImage <- file.path(sysproj, "Rsteps", "step_envir.RData")
                    save(list = viewEnvir(args2, silent = TRUE), file = tempImage, envir = envir)
                    list_return <- clusterRCode(args.run,
                        step = single.step, sysproj = sysproj,
                        file_log_Rcode = file_log_Rcode, force = force,
                        tempImage = tempImage, loaded_pkgs = loaded_pkgs,
                        resources = run_resorces
                    )
                    load(file.path(list_return$tempImage))
                    lapply(list_return$loaded_pkgs, require, character.only = TRUE)
                    args.run <- list_return$args
                    time_start <- args.run$status$status.time$time_start[!is.na(args.run$status$status.time$time_start)][1]
                    time_end_length <- length(args.run$status$status.time$time_end[!is.na(args.run$status$status.time$time_end)])
                    time_end <- args.run$status$status.time$time_end[!is.na(args.run$status$status.time$time_end)][time_end_length]
                    args.run@status$total.time <- list(
                        time_start = as.POSIXct(time_start, origin = "1970-01-01"),
                        time_end = as.POSIXct(time_end, origin = "1970-01-01")
                    )
                    unlink(tempImage)
                }
                ## time - double-check
                if (is.numeric(args.run@status$total.time$time_start)) {
                    args.run@status$total.time$time_start <- as.POSIXct(args.run@status$total.time$time_start, origin = "1970-01-01")
                }
                if (is.numeric(args.run@status$total.time$time_end)) {
                    args.run@status$total.time$time_end <- as.POSIXct(args.run@status$total.time$time_start, origin = "1970-01-01")
                }
                ## assign all the new object to the envir
                assign(
                    "args2", get(as.character(as.list(match.call())$sysargs), envir),
                    environment()
                )
                ## update object
                statusWF(args2, single.step) <- args.run$status
                stepsWF(args2, single.step) <- args.run
                cat(readLines(file_log_Rcode),
                    file = file_log, sep = "\n",
                    append = TRUE
                )
                assign(
                    x = as.character(as.list(match.call())$sysargs), args2,
                    envir = envir
                )
                ## Stop workflow
                if (is.element("Warning", unlist(args.run$status$status.summary))) {
                    if (warning.stop == TRUE) {
                        on.exit(return(args2))
                        stop("Caught an warning, stop workflow!")
                    }
                } else if (is.element("Error", unlist(args.run$status$status.summary))) {
                    if (error.stop == TRUE) {
                        on.exit(return(args2))
                        stop("Caught an error, stop workflow!")
                    }
                }
                cat(status_color(args.run$status$status.summary)("Step Status: ", args.run$status$status.summary, "\n"))
                run_targets <- NULL
            }
        } else {
            ## Printing step name
            single.step <- names(stepsWF(args2)[i])
            cat(status_color("Skipping")("Skipping Step: ", single.step), "\n")
            run_targets <- NULL
        }
    }
    ## Each time the workflow is executed, a new logs report should be generated (HTML format), via sal <- renderLogs(sal)
    if(!is.null(args2$projectInfo$Report)){
    	args2@projectInfo$Report_Logs <- NA
    }
    assign(
    	x = as.character(as.list(match.call())$sysargs), args2,
    	envir = envir
    )
    if (saveEnv == TRUE) {
        envPath <- file.path(sysproj, "sysargsEnv.rds")
        if (any(as.character(as.list(match.call())$sysargs) %in% ls(sysargs@runInfo$env, all.names = TRUE))) {
            rm(list = as.character(as.list(match.call())$sysargs), envir = sysargs@runInfo$env)
        }
        saveRDS(args2$runInfo$env, envPath)
        args2[["projectInfo"]][["envir"]] <- envPath
    }
    if (!silent) .renderMsg()
    args2 <- .check_write_SYSargsList(args2, TRUE)
    on.exit(return(args2))
}
## Usage:
## runWF(sal)

############################
## clusterRCode function ##
############################
clusterRCode <- function(args.run, step, sysproj, file_log_Rcode, force, tempImage, loaded_pkgs, resources) {
    checkPkg("batchtools", quietly = FALSE)
    if (!file.exists(tempImage)) stop("Something went wrong, temporary 'image' doesn't exist.", call. = FALSE)
    if (all(args.run$status$status.summary == "Success" && !force)) {
    	## Print at the log_file
    	cat(c(
    		paste0("Time: ", paste0(format(Sys.time(), "%b%d%Y_%H%Ms%S"))), "\n",
    		"## Code: ",
    		"```{r, eval=FALSE} ",
    		utils::capture.output(codeLine(args.run)),
    		"```", "\n",
    		"## Stdout: ",
    		"```{r, eval=FALSE}",
    		"The expected output file(s) already exist", "\n"
    	), file = file_log_Rcode, sep = "\n", fill = TRUE, append = TRUE)
        ## close R chunk
        cat("```", file = file_log_Rcode, sep = "\n", append = TRUE)
        args.run@files$log <- file_log_Rcode
        list_return <- list(args = args.run, loaded_pkgs = loaded_pkgs, tempImage = tempImage)
        return(list_return)
    }
    ## Function definition
    fct <- function(i, args.run, step, file_log_Rcode, force,
                    tempImage, loaded_pkgs, ...) {
        load(file.path(tempImage))
        ls_list1 <- ls()
        lapply(loaded_pkgs, require, character.only = TRUE)
        args <- runRcode(
            args = args.run, step = step, file_log_Rcode = file_log_Rcode,
            envir = environment(), force = force
        )
        loaded_pkgs <- .packages()
        save(list = ls(all.names = TRUE), file = tempImage, envir = environment())
        ls_list2 <- ls(envir = environment())
        return(list(args = args, loaded_pkgs = loaded_pkgs, tempImage = tempImage, ls1 = ls_list1, ls2 = ls_list2))
    }
    ##
    logdir1 <- paste0(sysproj, "/submitargs", 01, "_btdb_", paste(sample(0:9, 4), collapse = ""))
    conffile <- resources$conffile
    template <- resources$template
    reg <- batchtools::makeRegistry(file.dir = logdir1, conf.file = conffile, packages = "systemPipeR")
    ids <- batchtools::batchMap(fun = fct, 1, more.args = list(
        args.run = args.run, step = step, file_log_Rcode = file_log_Rcode,
        force = force, tempImage = tempImage,
        loaded_pkgs = loaded_pkgs
    ), reg = reg)
    chunk <- batchtools::chunk(ids$job.id, n.chunks = 1, shuffle = FALSE)
    ids$chunk <- chunk
    done <- batchtools::submitJobs(ids = ids, reg = reg, resources = resources)
    batchtools::waitForJobs()
    list_return <- batchtools::loadResult(reg = reg, id = ids)
    message("Jobs completed successfully!")
    return(list_return)
}

###########################
## status_color function ##
##########################
status_color <- function(x) {
    switch(x,
        "Pending" = crayon::bgBlue,
        "Warning" = crayon::bgYellow,
        "Error" = crayon::bgRed,
        "Success" = crayon::bgGreen,
        "Skipping" = crayon::bgCyan
    )
}

# cat(status_color("Pending")("test"))
# cat(status_color("Warning")("test"))
# cat(status_color("Error")("test"))
# cat(status_color("Success")("test"))
# cat(status_color("Skipping")("test"))

#######################
## runRcode function ##
#######################
runRcode <- function(args, step = stepName(args), file_log_Rcode = NULL, envir = globalenv(), force = FALSE) {
    ## Validation for 'args'
    if (!inherits(args, "LineWise")) stop("Argument 'args' needs to be assigned an object of class 'LineWise'")
    pb <- txtProgressBar(min = 0, max = length(args), style = 3)
    ## log_file
    if (is.null(file_log_Rcode)) {
        file_log_Rcode <- paste0("_logRcode_", format(Sys.time(), "%b%d%Y_%H%M"))
    }
    ## Print at the log_file
    cat(c(
        paste0("Time: ", paste0(format(Sys.time(), "%b%d%Y_%H%Ms%S"))), "\n",
        "## Code: ",
        "```{r, eval=FALSE} ",
        utils::capture.output(codeLine(args)),
        "```", "\n",
        "## Stdout: ",
        "```{r, eval=FALSE}"
    ), file = file_log_Rcode, sep = "\n", append = TRUE)
    ## Check status of step
    if (all(args$status$status.summary == "Success" && force == FALSE)) {
        args[["status"]]$status.time$time_start <- Sys.time()
        cat("The step status is 'Success' and it was skipped.", file = file_log_Rcode, fill = TRUE, append = TRUE, sep = "\n")
        args[["status"]]$status.time$time_end <- Sys.time()
    } else {
        ## Status and time register
        step_status <- list()
        time_status <- data.frame(Step = step, time_start = NA, time_end = NA)
        time_status$time_start <- Sys.time()
        ## Running the code
        stdout <- .tryRcode(args$codeLine, envir = envir)
        ## save stdout to file
        utils::capture.output(stdout$stdout, file = file_log_Rcode, append = TRUE)
        ## save error and warning messages
        if (!is.null(stdout$error)) {
            cat("## Error", file = file_log_Rcode, sep = "\n", append = TRUE)
            cat(stdout$error, file = file_log_Rcode, sep = "\n", append = TRUE)
            step_status[["status.summary"]] <- "Error"
        } else if (!is.null(stdout$warning)) {
            cat("## Warning", file = file_log_Rcode, sep = "\n", append = TRUE)
            cat(stdout$warning, file = file_log_Rcode, sep = "\n", append = TRUE)
            step_status[["status.summary"]] <- "Warning"
        } else if (all(is.null(stdout$error) && is.null(stdout$warning))) {
            step_status[["status.summary"]] <- "Success"
        }
        ## Saving the new status
        step_status[["status.completed"]] <- data.frame(Step = step, Status = step_status[[1]])
        time_status$time_end <- Sys.time()
        step_status[["status.time"]] <- time_status
        args[["status"]] <- step_status
        args[["status"]]$total.time <- list(time_start = args$status$status.time$time_start, time_end = args$status$status.time$time_end)
    }
    utils::setTxtProgressBar(pb, length(args))
    ## close R chunk
    cat("``` \n", file = file_log_Rcode, sep = "\n", append = TRUE)
    close(pb)
    args[["files"]] <- list(log = file_log_Rcode)
    return(args)
}

#############################
## output.as.df function ##
#############################
output.as.df <- function(x) {
    out_x <- output(x)
    out_x <- S4Vectors::DataFrame(matrix(unlist(out_x), nrow = length(out_x), byrow = TRUE))
    colnames(out_x) <- x$files$output_names
    return(out_x)
}

################################
## write_SYSargsList function ##
################################
write_SYSargsList <- function(sysargs, sys.file = ".SPRproject/SYSargsList.yml", silent = TRUE) {
    ## check logDir folder
    logDir <- .getPath(sys.file, warning = FALSE, normalizePath = FALSE)
    if (!file.exists(logDir)) stop("'logs.dir': No such file or directory. Check the file PATH.")
    if (!inherits(sysargs, "SYSargsList")) stop("sysargs needs to be object of class 'SYSargsList'.")
    args2 <- sysargslist(sysargs)
    args_comp <- sapply(args2, function(x) list(NULL))
    steps <- names(stepsWF(sysargs))
    ## special case for "runInfo" slot
    yaml_slots <- c("runInfo")
    for (i in yaml_slots) {
        args_comp[[i]] <- yaml::as.yaml(args2[[i]]$runOption)
    }
    ## Simple yaml slots
    yaml_slots <- c("projectInfo")
    for (i in yaml_slots) {
        args_comp[[i]] <- yaml::as.yaml(args2[[i]])
    }
    ## Yaml Slots + steps
    yaml_slots_S <- c("statusWF", "dependency", "targets_connection")
    for (i in yaml_slots_S) {
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            steps_comp[j] <- yaml::as.yaml(args2[[i]][j])
        }
        args_comp[[i]] <- steps_comp
    }
    ## DataFrame Slots
    df_slots <- c("targetsWF", "outfiles")
    for (i in df_slots) {
        #  args_comp[[i]] <- yaml::as.yaml(as.data.frame(args2[[i]]$Mapping))
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            steps_comp[j] <- yaml::as.yaml(data.frame(args2[[i]][[j]], check.names = FALSE))
        }
        args_comp[[i]] <- steps_comp
    }
    ## SYSargs2 and LineWise
    steps_comp <- sapply(steps, function(x) list(NULL))
    for (j in steps) {
        if (inherits(args2[["stepsWF"]][[j]], "SYSargs2")) {
            step_obj <- sysargs2(args2[["stepsWF"]][[j]])
            steps_comp[[j]] <- yaml::as.yaml(step_obj)
        } else if (inherits(args2[["stepsWF"]][[j]], "LineWise")) {
            step_obj <- linewise(args2[["stepsWF"]][[j]])
            step_obj$codeLine <- as.character(step_obj$codeLine)
            steps_comp[[j]] <- yaml::as.yaml(step_obj)
        }
    }
    args_comp[["stepsWF"]] <- steps_comp
    ## SE slot
    path <- file.path(.getPath(sys.file, full_path = TRUE, normalizePath = FALSE, warning = FALSE), "SE")
    if (!dir.exists(path)) {
        dir.create(path, recursive = TRUE)
    }
    steps_comp <- sapply(steps, function(x) list(NULL))
    for (j in steps) {
        if (!is.null(args2[["SE"]][[j]])) {
            writeSE(args2[["SE"]][[j]], dir.path = path, dir.name = j, overwrite = TRUE, silent = TRUE)
            steps_comp[[j]] <- yaml::as.yaml(list(dir.path = path, dir.name = j))
        } else {
            steps_comp[j] <- yaml::as.yaml(args2[["SE"]][j])
        }
    }
    args_comp[["SE"]] <- steps_comp
    ## Save file
    yaml::write_yaml(args_comp, sys.file)
    if (silent != TRUE) cat("Creating file '", file.path(sys.file), "'", sep = "", "\n")
    return(sys.file)
}

# ## Usage:
# write_SYSargsList(sal, sys.file, silent=FALSE)

################################
## read_SYSargsList function ##
################################
read_SYSargsList <- function(sys.file) {
    args_comp_yml <- yaml::read_yaml(sys.file)
    args_comp <- sapply(args_comp_yml, function(x) list(NULL))
    steps <- names(args_comp_yml$stepsWF)
    ## Simple yaml slots
    yaml_slots <- c("projectInfo")
    for (i in yaml_slots) {
        args_comp[[i]] <- yaml::yaml.load(args_comp_yml[i])
        if (!is.null(args_comp[[i]]$rmd_lines)) {
            args_comp[[i]]$rmd_lines <- data.frame(args_comp[[i]]$rmd_lines, check.names = FALSE)
        }
    }
    ## runInfo yaml slots
    yaml_slots <- c("runInfo")
    for (i in yaml_slots) {
        args_comp[[i]] <- list(runOption = yaml::yaml.load(args_comp_yml[i]))
    }
    ## Yaml Slots + steps
    yaml_slots_S <- c("dependency", "targets_connection")
    for (i in yaml_slots_S) {
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            steps_comp[j] <- yaml::yaml.load(args_comp_yml[[i]][j])
        }
        args_comp[[i]] <- steps_comp
    }
    ## SYSargs2 and LineWise
    if (length(args_comp_yml$stepsWF) >= 1) {
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            if ("codeLine" %in% names(yaml::yaml.load(args_comp_yml[["stepsWF"]][[j]]))) {
                args <- yaml::yaml.load(args_comp_yml[["stepsWF"]][[j]])
                if (length(args$codeLine) >= 1) {
                    args$codeLine <- parse(text = args$codeLine)
                }
                if (length(args$codeChunkStart) == 0) args$codeChunkStart <- integer()
                if (length(args$files) == 0) args$files$rmdPath <- character()
                if (length(args$dependency) == 0) args$dependency <- character()
                args <- as(args, "LineWise")
                steps_comp[[j]] <- args
            } else {
                args <- yaml::yaml.load(args_comp_yml[["stepsWF"]][[j]])
                args[["status"]][[2]] <- data.frame(args[["status"]][[2]], check.names = FALSE)
                args[["status"]][[3]] <- data.frame(args[["status"]][[3]])
                if (length(names(args$targets)) != 0) {
                    df_rownames <- names(args$targets)
                } else {
                    df_rownames <- args[["status"]][[3]]$Targets
                }
                rownames(args[["status"]][[2]]) <- df_rownames
                rownames(args[["status"]][[3]]) <- df_rownames
                steps_comp[[j]] <- as(args, "SYSargs2")
            }
            args_comp[["stepsWF"]] <- steps_comp
        }
    } else if (length(args_comp_yml$stepsWF) >= 0) {
        args_comp[["stepsWF"]] <- list()
    }
    ## targetsWF Slots
    df_slots <- c("targetsWF", "outfiles")
    for (i in df_slots) {
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            steps_comp[[j]] <- S4Vectors::DataFrame(yaml::yaml.load(args_comp_yml[[i]][[j]]), check.names = FALSE)
        }
        args_comp[[i]] <- steps_comp
    }
    ## status
    yaml_slots_Status <- c("statusWF")
    for (i in yaml_slots_Status) {
        steps_comp <- sapply(steps, function(x) list(NULL))
        for (j in steps) {
            steps_comp[j] <- yaml::yaml.load(args_comp_yml[[i]][j])
            steps_comp[[j]]$status.completed <- data.frame(steps_comp[[j]]$status.completed, check.names = FALSE)
            steps_comp[[j]]$status.time <- data.frame(steps_comp[[j]]$status.time)
            if (length(steps_comp[[j]]$status.time) != 0) {
                steps_comp[[j]]$status.time$time_start <- .POSIXct(steps_comp[[j]]$status.time$time_start)
                steps_comp[[j]]$status.time$time_end <- .POSIXct(steps_comp[[j]]$status.time$time_end)
            }
            if (length(steps_comp[[j]]$total.time) != 0) {
                steps_comp[[j]]$total.time$time_start <- .POSIXct(steps_comp[[j]]$total.time$time_start)
                steps_comp[[j]]$total.time$time_end <- .POSIXct(steps_comp[[j]]$total.time$time_end)
            }
        }
        args_comp[[i]] <- steps_comp
    }
    ## rownames
    for (j in steps) {
        if (inherits(args_comp$stepsWF[[j]], "SYSargs2")) {
            rownames(args_comp$targetsWF[[j]]) <- args_comp$targetsWF[[j]][[args_comp$stepsWF[[j]]$files$id]]
            rownames(args_comp$outfiles[[j]]) <- args_comp$targetsWF[[j]][[args_comp$stepsWF[[j]]$files$id]]
            rownames(args_comp$statusWF[[j]]$status.completed) <- args_comp$targetsWF[[j]][[args_comp$stepsWF[[j]]$files$id]]
            rownames(args_comp$statusWF[[j]]$status.time) <- args_comp$targetsWF[[j]][[args_comp$stepsWF[[j]]$files$id]]
        }
    }
    ## SE slot
    steps_comp <- sapply(steps, function(x) list(NULL))
    for (j in steps) {
        steps_comp[[j]] <- yaml::yaml.load(args_comp_yml[["SE"]][[j]])
        if (!is.null(steps_comp[[j]][[1]])) {
            dir.path <- steps_comp[[j]][[1]]
            dir.name <- steps_comp[[j]][[2]]
            SE <- readSE(dir.path = dir.path, dir.name = dir.name)
            steps_comp[[j]] <- list(SE)
        } else {
            steps_comp[[j]] <- steps_comp[[j]]
        }
    }
    args_comp[["SE"]] <- sapply(steps_comp, function(x) x[[1]])
    return(as(args_comp, "SYSargsList"))
}

# ## Usage:
# sys.file=".SPRproject/SYSargsList.yml"
# sal3 <- read_SYSargsList(sys.file)

################################
## writeSE function ##
################################
writeSE <- function(SE, dir.path, dir.name, overwrite = FALSE, silent = FALSE) {
    # Validations
    if (!inherits(SE, "SummarizedExperiment")) stop("Argument 'SE' needs to be assigned an object of class 'SummarizedExperiment'")
    if (!dir.exists(dir.path)) stop("'dir.path' doesn't exist.")
    if (all(dir.exists(file.path(dir.path, dir.name)) & overwrite == FALSE)) stop("'dir.name' directory already exist. Please delete existing directory: ", dir.name, " or set 'overwrite=TRUE'")
    if (!dir.exists(file.path(dir.path, dir.name))) {
        dir.create(file.path(dir.path, dir.name))
    }
    path <- file.path(dir.path, dir.name)
    ## Counts
    if (length(SummarizedExperiment::assays(SE)) > 0) {
        for (i in length(SummarizedExperiment::assays(SE))) {
            write.table(SummarizedExperiment::assays(SE)[[i]], file.path(path, paste0("counts_", i, ".csv")),
                quote = FALSE, row.names = TRUE,
                col.names = TRUE, sep = "\t"
            )
        }
    }
    ## Metadata
    yaml::write_yaml(S4Vectors::metadata(SE), file.path(path, paste0("metadata.yml")))
    ## colData
    write.table(SummarizedExperiment::colData(SE), file.path(path, paste0("colData.csv")),
        quote = FALSE, row.names = TRUE,
        col.names = NA, sep = "\t"
    )
    ## RowRanges
    if (!is.null(SummarizedExperiment::rowRanges(SE))) {
        write.table(as.data.frame(SummarizedExperiment::rowRanges(SE)),
            file = file.path(path, paste0("rowRanges.csv")),
            sep = "\t", quote = FALSE, row.names = FALSE
        )
    }
    ## Final message
    if (silent != TRUE) cat("\t", "Written content of 'SE' to directory:", path, "\n")
}

# writeSE(rse, dir.path = getwd(), dir.name = "seobj")
#
# dir.path <- getwd()
# dir.name <- "seobj"

################################
## readSE function ##
################################
readSE <- function(dir.path, dir.name) {
    path <- file.path(dir.path, dir.name)
    if (!dir.exists(path)) stop("'dir.path' doesn't exist.")
    ## Counts
    files_counts <- list.files(path, pattern = "counts")
    if (length(files_counts) > 0) {
        counts_ls <- S4Vectors::SimpleList()
        for (i in files_counts) {
            counts_ls1 <- S4Vectors::SimpleList(as.matrix(read.table(file.path(path, i), check.names = FALSE, header = TRUE)))
            counts_ls <- append(counts_ls, counts_ls1)
        }
    } else {
        counts_ls <- S4Vectors::SimpleList()
    }
    ## Metadata
    metadata <- yaml::read_yaml(file.path(path, paste0("metadata.yml")))
    ## colData
    colData <- tryCatch(read.table(file.path(path, paste0("colData.csv")), check.names = FALSE, sep = "\t", header = TRUE),
        error = function(e) NULL
    )
    if (is.null(colData)) colData <- data.frame()
    ## rowRanges
    files_counts <- list.files(path, pattern = "rowRanges")
    if (length(files_counts) > 0) {
        rowRanges_df <- read.table(file.path(path, paste0("rowRanges.csv")), check.names = FALSE, header = TRUE)
        rowRanges <- makeGRangesFromDataFrame(rowRanges_df, keep.extra.columns = TRUE)
    } else {
        rowRanges <- GRangesList()
    }
    if (length(rowRanges) == 0) {
        SE <- SummarizedExperiment::SummarizedExperiment(
            assays = counts_ls,
            # rowRanges = rowRanges,
            colData = colData,
            metadata = metadata
        )
    } else {
        SE <- SummarizedExperiment::SummarizedExperiment(
            assays = counts_ls,
            rowRanges = rowRanges,
            colData = colData,
            metadata = metadata
        )
    }
    return(SE)
}

# nrows <- 200; ncols <- 6
# counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
# rowRanges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
#                      IRanges(floor(runif(200, 1e5, 1e6)), width=100),
#                      strand=sample(c("+", "-"), 200, TRUE),
#                      feature_id=sprintf("ID%03d", 1:200))
# colData <- DataFrame(Treatment=rep(c("ChIP", "Input"), 3),
#                      row.names=LETTERS[1:6])
# rse <- SummarizedExperiment::SummarizedExperiment(assays=S4Vectors::SimpleList(counts=counts),
#                             rowRanges=rowRanges, colData=colData)
# rse
# writeSE(rse, dir.path = getwd(), dir.name = "seobj")
# SE <- readSE(dir.path = getwd(), dir.name = "seobj")
# library(diffobj)
# diffPrint(target=SE, current=rse)

# writeSE(sal$SE$gzip, dir.path = getwd(), dir.name = "seobj")
# SE <- readSE(dir.path = getwd(), dir.name = "seobj")
# library(diffobj)
# diffPrint(target=SE, current=rse)


###########################
## writeTargets function ##
###########################
writeTargets <- function(sysargs, step, file = "default", silent = FALSE, overwrite = FALSE) {
    if (all(!inherits(sysargs, "SYSargsList"))) stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargsList")
    if (!step %in% stepName(sysargs)) stop("It was not possible to find the 'step' name in the 'sysargs' object")
    ## Workflow and Step Name
    if (file == "default") {
        file <- paste("targets_", step, ".txt", sep = "")
    } else {
        file <- file
    }
    ## SYSargsList class
    if (file.exists(file) & overwrite == FALSE) stop("I am not allowed to overwrite files; please delete existing file: ", file, " or set 'overwrite=TRUE'")
    targets <- targetsWF(sysargs)[[step]]
    targetslines <- c(paste(colnames(targets), collapse = "\t"), apply(targets, 1, paste, collapse = "\t"))
    headerlines <- sysargs$stepsWF[[step]][["targetsheader"]]
    writeLines(c(headerlines$targetsheader, targetslines), file)
    if (silent != TRUE) cat("\t", "Written content of 'targetsout(x)' to file:", file, "\n")
}

########################
## ConfigWF function ##
########################
configWF <- function(x, input_steps = "ALL", exclude_steps = NULL, silent = FALSE, ...) {
    ## Validations
    if (!inherits(x, "SYSargsList")) stop("Argument 'x' needs to be assigned an object of class 'SYSargsList'")
    utils::capture.output(steps_all <- subsetRmd(Rmd = x$sysconfig$script$path), file = ".SYSproject/.NULL")
    if ("ALL" %in% input_steps) {
        input_steps <- paste0(steps_all$t_number[1], ":", steps_all$t_number[length(steps_all$t_number)])
        save_rmd <- FALSE
        Rmd_outfile <- NULL
        Rmd_path <- x$sysconfig$script$path
    } else {
        input_steps <- input_steps
        save_rmd <- TRUE
        Rmd_outfile <- paste0(
            .getPath(x$sysconfig$script$path), "/", paste0(format(Sys.time(), "%b%d%Y")),
            "_", basename(x$sysconfig$script$path)
        )
        Rmd_path <- Rmd_outfile
    }
    utils::capture.output(steps_all <- subsetRmd(
        Rmd = x$sysconfig$script$path, input_steps = input_steps,
        exclude_steps = exclude_steps, save_Rmd = save_rmd, Rmd_outfile = Rmd_outfile
    ), file = ".NULL")
    steps_number <- steps_all$t_number[steps_all$selected]
    ## Save input_steps in the SYSconfig.yml
    if (!any(names(x$sysconfig) %in% c("input_steps", "exclude_steps"))) {
        input_file <- x$sysconfig$SYSconfig
        param <- list(input_steps = input_steps, exclude_steps = exclude_steps)
        input <- config.param(input_file = input_file, param, file = "append", silent = TRUE)
        x <- as(x, "list")
        x$sysconfig <- input
        x <- as(x, "SYSargsList")
    }
    ## STEPS
    if (is.null(x$sysconfig$script)) {
        cat("empty list")
    } else {
        steps <- paste0(
            strrep("    ", (as.numeric(steps_all$t_lvl[steps_all$selected]) - 1)), steps_all$t_number[steps_all$selected],
            ".", steps_all$t_text[steps_all$selected]
        )
    }
    names(steps_number) <- steps
    ## CODESteps
    code <- steps_all$code[steps_all$selected]
    names(code) <- steps
    x <- as(x, "list")
    script_path <- x$sysconfig$script$path
    x$sysconfig$script[["path"]] <- Rmd_path
    x$sysconfig$script[["orginal"]] <- script_path
    x$stepsWF <- steps_number
    x$codeSteps <- code
    x$dataWF <- steps_all
    # x$sysconfig$script$path <- Rmd_outfile
    return(as(x, "SYSargsList"))
}

## Usage:
# sysargslist <- configWF(x=sysargslist)

###########################
## renderReport function ##
###########################
## type: c("pdf_document", "html_document")
renderReport <- function(sysargs,
                         fileName = "SPR_Report",
                         rmd_title = "SPR workflow Template - Report",
                         rmd_author = "Author",
                         rmd_date = "Last update: `r format(Sys.time(), '%d %B, %Y')`",
                         type = c("html_document"),
                         desc = "This is a workflow template.",
                         quiet = FALSE,
                         open_file = TRUE) {
    stopifnot(is.logical(quiet) && length(quiet) == 1)
    stopifnot(is.logical(open_file) && length(open_file) == 1)
    stopifnot(inherits(sysargs, "SYSargsList"))

    if (is.null(sysargs$projectInfo$rmd_file)) return(
        sal2rmd(sysargs,
                out_path = out_path_rmd,
                rmd_title = rmd_title,
                rmd_author = rmd_author,
                rmd_date = rmd_date,
                rmd_output = type,
                desc = desc,
                verbose = !quiet
        )
    )

    ext <- sub("_.*", "", type)
    out_path <- file.path(paste0(fileName, ".", ext))
    out_path_rmd <- file.path(paste0(fileName, ".Rmd"))

    file_path <- sysargs$projectInfo$rmd_file

    lines <- readLines(file_path) ## original file
    ## get info from sysargs
    step_names <- names(sysargs$stepsWF)
    deps <- sysargs$dependency
    t_connects <- sysargs$targets_connection
    opts <- sysargs$runInfo$runOption
    ## get the first line
    chunk_start <- lines %>% stringr::str_which("^```\\{.*\\}.*")
    df <- parseRmd(file_path, verbose = FALSE)[, 1:3]
    # check steps
    df_in_sal <- df$step_name %in% step_names
    if(!all(df_in_sal)) {
        warning("Some steps exist in template but not in SYSargsList. ",
                "Step code and text of these steps will be removed in report\n",
                "Consider using `sal <- importWF(sal, 'xx.Rmd', update = TRUE)` ",
                "to sync the template and SYSargsList before rendering report\n",
                paste(df$step_name[!df_in_sal], collapse = " "), immediate. = TRUE)
    }
    # find text in between
    text_start <- c(NA, df$end + 1)
    df$text_start <- text_start[-length(text_start)]
    df$text_end <- df$start - 1
    df$text_end[1] <- NA
    # get starter lines
    rmd_text <- lines[seq(1, df$start[1] -1)]
    for (i in seq_along(step_names)) {
        appStep <- switch(class(sysargs$stepsWF[[i]]),
            "LineWise" = .sal2rmd_rstep(
                sysargs,
                con = NULL, i = i, step_name = step_names[i],
                dep = deps[[i]], req = opts[[i]]$run_step,
                prepro = opts[[i]]$prepro_lines,
                session = opts[[i]]$run_session, return = "object"
            ),
            "SYSargs2" = .sal2rmd_sysstep(
                sysargs,
                con = NULL, i = i,
                step_name = step_names[i],
                dep = deps[[i]],
                dir = opts[[i]]$directory,
                req = opts[[i]]$run_step,
                session = opts[[i]]$run_session,
                prepro = opts[[i]]$prepro_lines,
                t_con = t_connects[[i]], return = "object"
            )
        )
        # find sal step matched steps from df lines
        df_step <- df[df$step_name == step_names[i],]
        if(nrow(df_step) == 0) {
            message(crayon::yellow$bold(
                "Step name ", step_names[i], " exist in SYSargsList but not in template.\n ",
                "It will be added as a new step in report, consider add it to your template first, ",
                "and then use `sal <- importWF(sal, 'xx.Rmd', update = TRUE)`",
                "to update the template first before rendering report."
            ))
        } else if (nrow(df_step) > 1){
            stop(crayon::red$bold("Step name ", step_names[i], " has more than one match in template, something wrong?"))
        } else {
            # add text
            if(!is.na(df_step$text_start[1])) rmd_text <- c(rmd_text, lines[seq(df_step$text_start[1], df_step$text_end[1])])
        }
        # add code
        rmd_text <- c(rmd_text, if(nrow(df_step) == 0) appStep else appStep[-1])
    }
    # add tail
    rmd_text <- c(rmd_text, lines[seq(df$end[nrow(df)] + 1, length(lines))])
    writeLines(rmd_text, out_path_rmd)

    rmarkdown::render(input = out_path_rmd, c(paste0("BiocStyle::", type)), quiet = quiet, envir = new.env())
    detach("package:BiocStyle", unload = TRUE)
    if (!quiet) message(crayon::green$bold("Success! Report created at", out_path))
    sysargs <- as(sysargs, "list")
    sysargs$projectInfo[["Report"]] <- normalizePath(file.path(out_path))
    if (open_file) try(utils::browseURL(file.path(out_path)), TRUE)
    sysargs <- as(sysargs, "SYSargsList")
    write_SYSargsList(sysargs, silent = TRUE)
    return(sysargs)
}

## Usage:
# sal <- SPRproject(overwrite = TRUE)
# file_path <- system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR")
# sal <- importWF(sal, file_path = file_path, verbose = FALSE)
# targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
# appendStep(sal) <- SYSargsList(step_name = "echo",
#                               targets = targetspath, dir = TRUE,
#                               wf_file = "example/workflow_example.cwl", input_file = "example/example.yml",
#                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                               inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
# sal <- renderReport(sal)

###########################
## renderLogs function ##
###########################
renderLogs <- function(sysargs,
                       type = c("html_document", "pdf_document"),
                       fileName = "default",
                       quiet = FALSE,
                       open_file = TRUE) {
    if (!inherits(sysargs, "SYSargsList")) stop("`sysargs` must be a 'SYSargsList' object.")
    type <- match.arg(type, c("html_document", "pdf_document"))
    stopifnot(is.character(fileName) && length(fileName) == 1)
    stopifnot(is.logical(quiet) && length(quiet) == 1)
    stopifnot(is.logical(open_file) && length(open_file) == 1)
    wd <- getwd()
    if (wd != projectInfo(sysargs)$project) {
        setwd(projectInfo(sysargs)$project)
        on.exit({
            try(setwd(wd), TRUE)
        })
    }
    dir_log <- projectInfo(sysargs)$logsDir
    if (!file.exists(dir_log) == TRUE) stop("Provide valid 'SYSargsList' object. Check the initialization of the project.")
    if (is.null(projectInfo(sysargs)$logsFile)) {
        log <- ""
    } else {
        file <- projectInfo(sysargs)$logsFile
        log <- readLines(file)
    }
    if (fileName == "default") {
        fileName <- file.path(projectInfo(sysargs)$project, paste0("logs_", format(Sys.time(), "%b%d%Y_%H%M"), ".Rmd"))
    } else {
        fileName <- file.path(paste0(fileName, ".Rmd"))
    }
    if (type == "html_document") plot_path <- normalizePath(.prepareRmdPlot(sysargs, dir_log))
    writeLines(c(
        "---",
        "title: SPR Workflow Technical Report",
        paste0("date: 'Last update: ", format(Sys.time(), "%d %B, %Y"), "'"),
        "output:",
        paste0("  BiocStyle::", type, ":"),
        if (type == "html_document") paste0("    includes:\n      before_body: ", plot_path),
        "    toc: true",
        "    toc_float: true",
        "    code_folding: show",
        "package: systemPipeR",
        "fontsize: 14pt",
        "---",
        "",
        log
    ),
    con = fileName
    )
    # rmarkdown::render(input = fileName, c(paste0(type)), quiet = TRUE, envir = new.env())
    rmarkdown::render(input = fileName, c(paste0("BiocStyle::", type)), quiet = TRUE, envir = new.env())
    detach("package:BiocStyle", unload = TRUE)
    file_path <- .getPath(fileName)
    file_out <- .getFileName(fileName)
    ext <- if (type == "html_document") "html" else "pdf"
    sysargs <- as(sysargs, "list")
    sysargs$projectInfo[["Report_Logs"]] <- file.path(file_path, paste(file_out, ext, sep = "."))
    if (!quiet) cat("Written content of 'Report' to file:", "\n", paste(file_out, ext, sep = "."), "\n")
    if (open_file) try(utils::browseURL(file.path(file_path, paste(file_out, ext, sep = "."))), TRUE)
    return(as(sysargs, "SYSargsList"))
}

## Usage
# sal <- runWF(sal)
# sal <- renderLogs(sal)

########################
## subsetRmd function ##
########################
subsetRmd <- function(Rmd, input_steps = NULL, exclude_steps = NULL, Rmd_outfile = NULL, save_Rmd = TRUE) {
    . <- NULL
    # function start, check inputs
    if (!file.exists(Rmd) == TRUE) stop("Provide valid 'Rmd' file.")
    if (is.null(Rmd_outfile)) Rmd_outfile <- paste0("new", format(Sys.time(), "%Y%m%d_%H%M%S"), basename(Rmd))
    # read file
    file <- readLines(Rmd)
    # check for proper start and end
    t_start <- file %>% stringr::str_which("^#")
    if (length(t_start) == 0) stop("This Rmd does not have any '#' titles")
    # get code chunks
    chunk_start <- file %>% stringr::str_which("^```\\{.*\\}.*")
    chunk_end <- file %>% stringr::str_which("^```[[:blank:]]{0,}$")
    if (length(chunk_start) != length(chunk_end)) stop("unmatched number of code chunk starts and ends")
    for (i in seq_along(chunk_start)[-length(chunk_end)]) {
        if (chunk_start[i + 1] <= chunk_end[i]) stop("A code chunk does not end: chunk line ", chunk_start[i + 1])
    }
    # remove '#' titles in code chunk
    t_start <- t_start[!unlist(lapply(t_start, function(x) any(x >= chunk_start & x <= chunk_end)))]
    # get end
    t_end <- append((t_start - 1)[c(-1)], length(file))
    # get # levels and text
    t_text <- file[t_start] %>% stringr::str_remove("^[#]+")
    t_lvl <- file[t_start] %>%
        stringr::str_extract("^[#]+") %>%
        nchar()
    # parse levels
    for (lvl in unique(t_lvl)[-length(t_lvl)]) {
        if (lvl == min(unique(t_lvl))) {
            step_main <- which(t_lvl == lvl)
            names(t_lvl)[step_main] <- names(step_main) <- seq_along(step_main)
            step_main <- append(step_main, 9999)
        }
        sub_lvl <- lvl
        while (sub_lvl <= max(t_lvl)) {
            step_sub <- which(t_lvl == sub_lvl + 1)
            if (length(step_sub) < 1) {
                sub_lvl <- sub_lvl + 1
            } else {
                break()
            }
        }
        jump_step_glue <- if (sub_lvl - lvl == 0) {
            "."
        } else {
            rep(".1.", sub_lvl - lvl) %>%
                paste0(collapse = "") %>%
                stringr::str_replace_all("\\.\\.", "\\.")
        }
        for (i in seq_along(step_main[-1])) {
            subs <- step_sub[step_sub > step_main[i] & step_sub < step_main[i + 1]]
            names(t_lvl)[subs] <- names(step_sub)[step_sub %in% subs] <- paste0(names(step_main[i]), jump_step_glue, seq_along(subs))
        }
        step_main <- append(step_sub, 9999)
    }
    # get code in lists
    code_list <- lapply(seq_along(t_start), function(t_index) {
        code_start <- chunk_start[chunk_start %in% (t_start[t_index]:t_end[t_index])]
        code_end <- chunk_end[chunk_end %in% (t_start[t_index]:t_end[t_index])]
        code_lines <- lapply(seq_along(code_start), function(code_index) {
            (code_start[code_index] + 1):(code_end[code_index] - 1)
        }) %>% unlist()
        file[code_lines]
    })
    # create a df to store everything
    rmd_df <- data.frame(
        t_lvl = t_lvl, t_number = names(t_lvl),
        t_text = t_text, selected = FALSE,
        row.names = NULL, stringsAsFactors = FALSE
    )
    rmd_df$code <- code_list
    # add sample run/success, step link cols
    rmd_df$no_run <- NA
    rmd_df$no_run <- ifelse(sapply(rmd_df$code, length) == 0, 0, NA)
    rmd_df$no_success <- NA
    rmd_df$no_success <- ifelse(sapply(rmd_df$code, length) == 0, 0, NA)
    rmd_df$link_to <- NA
    rmd_df$link_to[1:(nrow(rmd_df) - 1)] <- rmd_df$t_number[2:nrow(rmd_df)]
    # list all steps if no input_steps
    # if (!assertthat::not_empty(input_steps)) {
    if (!is.null(input_steps)) {
        cat("No input_steps is given, list all sections and exit\n")
        cat("This file contains following sections\n")
        stringr::str_replace(t_text, "^", paste0(strrep("    ", (t_lvl - 1)), names(t_lvl), " ")) %>%
            paste0(., collapse = "\n") %>%
            stringr::str_replace("$", "\n") %>%
            cat()
        return(rmd_df)
    }
    # parse steps
    index_select <- .parse_step(t_lvl, input_steps)
    index_exclude <- .parse_step(t_lvl, exclude_steps)
    index_final <- index_select[!index_select %in% index_exclude]
    rmd_df$selected[index_final] <- TRUE
    # print again what will be write in the new file
    cat("The following sections are selected\n")
    stringr::str_replace(
        t_text[index_final], "^",
        paste0(
            strrep("    ", (t_lvl[index_final] - 1)),
            names(t_lvl[index_final]), " "
        )
    ) %>%
        paste0(collapse = "\n") %>%
        stringr::str_replace("$", "\n") %>%
        cat()
    # to print new titles and return
    if (save_Rmd == FALSE) {
        return(rmd_df)
    }
    # sebset lines
    t_start[index_final]
    t_end[index_final]
    final_lines <- mapply(seq, t_start[index_final], t_end[index_final]) %>%
        unlist() %>%
        append(1:(t_start[1] - 1), .) %>%
        unique()
    writeLines(file[final_lines], Rmd_outfile)
    cat("File write to ", file.path(Rmd_outfile), "\n")
    return(rmd_df)
}

# # Usage:
# Rmd <- system.file("extdata/workflows/rnaseq", "systemPipeRNAseq.Rmd", package="systemPipeRdata")
# newRmd <- subsetRmd(Rmd=Rmd, input_steps="1:2.1, 3.2:4, 4:6", exclude_steps="3.1", Rmd_outfile="test_out.Rmd", save_Rmd=TRUE)

###########################
## config.param function ##
###########################
config.param <- function(input_file = NULL, param, file = "default", silent = FALSE) {
    ## In the case of 'input_file' == character (file)
    if (inherits(input_file, "character")) {
        if (!file.exists(input_file)) {
            stop("Provide valid 'input_file' file. Check the file PATH.")
        }
        input <- yaml::read_yaml(file.path(input_file), eval.expr = TRUE)
        input <- out_obj <- .replace(input = input, param = param)
        path_file <- normalizePath(input_file)
        out_msg <- c("input_file")
    } else if (inherits(input_file, "list")) {
        if (is.null(names(param))) {
            stop("for each element of the 'param' list need to assign a name.")
        }
        input <- out_obj <- .replace(input = input_file, param = param)
        path_file <- normalizePath(file)
        out_msg <- c("input_file")
    } else if (inherits(input_file, "SYSargs2")) {
        input <- .replace(input = yamlinput(input_file), param = param)
        dir_path <- .getPath(files(input_file)[["yml"]])
        if (is.na(files(input_file)[["targets"]])) {
            targets <- NULL
        } else {
            targets <- targets(input_file)
        }
        args1 <- loadWorkflow(
            targets = targets, wf_file = basename(files(input_file)[["cwl"]]),
            input_file = basename(files(input_file)[["yml"]]), dir_path = dir_path
        )
        args1 <- as(args1, "list")
        args1$yamlinput <- input
        if ("ModulesToLoad" %in% names(param)) {
            for (i in seq_along(param$ModulesToLoad)) {
                args1$modules[names(param$ModulesToLoad[i])] <- param$ModulesToLoad[[i]]
            }
        }
        args1 <- out_obj <- as(args1, "SYSargs2")
        out_msg <- c("yamlinput(args1)")
        path_file <- files(input_file)[["yml"]]
    } else if (inherits(input_file, "SYSargsList")) {
        input <- out_obj <- .replace(input = input_file$sysconfig, param = param)
        path_file <- input_file$projectInfo$project
        out_msg <- c("input_file")
    } else if (all(is.null(input_file))) {
        stop("'input_file' need to be defenid as '.yml' OR 'SYSargs2 class' OR 'SYSargsList class' OR 'list class' ")
    }
    ## File and Path to be written
    if (file == "default") {
        run <- dir(.getPath(path_file))
        fileName <- paste0("_run", length(grep(
            paste0(gsub("\\..*", "", basename(path_file)), "_run"),
            run
        )) + 1)
        path <- paste0(.getPath(path_file), "/", gsub("\\..*", "", basename(path_file)), fileName, ".",
            gsub(".*\\.", "", basename(path_file)),
            collapse = "/"
        )
    } else if (file == "append") {
        path <- path_file
    } else {
        path <- file
    }
    ## Rename original file
    ## Write YML file
    yaml::write_yaml(x = input, file = path)
    if (silent != TRUE) cat("\t", "All the new param + ", out_msg, "were written to:", "\n", path, "\n")
    if (inherits(input_file, "SYSargs2")) {
        args1 <- as(args1, "list")
        args1$files$yml <- path
        args1 <- as(args1, "SYSargs2")
        out_obj <- args1
    }
    return(out_obj)
}

## Usage:
# Config param files
# targets <- system.file("extdata", "targets.txt", package="systemPipeR")
# input_file <- system.file("extdata", "cwl/hisat2/hisat2-se/hisat2-mapping-se.yml", package="systemPipeR")
# param <- list(thread=10, fq=list(class="File", path="./results2"))
# input <- config.param(input_file=input_file, param, file="default") # Example with 'input_file'

###############
## Utilities ##
###############

########################################################
## SYScreate ##
########################################################
SYScreate <- function(class) {
    if (class == "SYSargs2") {
        SYS.empty <- list(
            targets = data.frame(),
            targetsheader = list(),
            modules = list(),
            wf = list(),
            clt = list(),
            yamlinput = list(),
            cmdlist = list(NULL),
            input = list(),
            output = list(),
            files = list(),
            inputvars = list(),
            cmdToCwl = list(),
            status = data.frame(),
            internal_outfiles = list()
        )
        return(as(SYS.empty, "SYSargs2"))
    } else if (class == "SYSargsList") {
        SYS.empty <- list(
            stepsWF = list(),
            statusWF = list(),
            targetsWF = list(),
            outfiles = list(),
            SEobj = list(),
            dependency = list(),
            targets_connection = list(),
            projectInfo = list(),
            runInfo = list()
        )
        return(as(SYS.empty, "SYSargsList"))
    } else if (!class %in% c("SYSargs2", "SYSargsList")) {
        stop("Argument 'args' needs to be assigned an character 'SYSargs2' OR 'SYSargsList'")
    }
}
## Usage:
# list <- SYScreate("SYSargsList")
# list <- SYScreate("SYSargs2")

#########################################################################################
## Function to check if the command line / Software is installed and set in your PATH ##
#########################################################################################
tryCMD <- function(command, silent = FALSE) {
    if (command == "fastqc") command <- "fastqc --version"
    if (command == "gunzip") command <- "gunzip -h"
    if (command == "gzip") command <- "gzip -h"
    tryCatch(
        {
            system(command, ignore.stdout = TRUE, ignore.stderr = TRUE, timeout = 2)
            if (!silent) print("All set, proceed!")
            if (silent) (return("proceed"))
        },
        warning = function(w) {
            if (silent) invisible(return("error"))
            if (!silent) {
                cat(
                    "ERROR: ", "\n", command, ": COMMAND NOT FOUND. ", "\n",
                    "Please make sure to configure your PATH environment variable according to the software in use.",
                    "\n"
                )
            }
        }
    )
}

## Usage:
# tryCMD(command="R")
# tryCMD(command="blastp")
# tryCMD(command="fastqc")
# tryCMD(command="gzip")

tryCL <- tryCMD
########################################################
## Function to check if the Path (file or dir) exists ##
########################################################
tryPath <- function(path) {
    tryCatch(normalizePath(path),
        warning = function(w) message(path, ": ", "No such file or directory"),
        error = function(e) message(path, ": ", "Please provide a valid Path")
    )
}
## Usage:
# tryPath(path="./")


########################################################################
## Function to list/check if all cmd tools are in path for a workflow ##
########################################################################
listCmdTools <- function(
    sal,
    check_path = FALSE,
    check_module = FALSE
){
    if(!inherits(sal, "SYSargsList")) stop("ERROR: Please provide a `SYSargsList` object")
    # list of cmd steps
    all_steps <- stepsWF(sal) %>% lapply(class) %>% unlist()
    cmd_steps <- which(all_steps == "SYSargs2")
    if(length(cmd_steps) == 0) return(cat(crayon::make_style("orange")$bold("There is no commandline (SYSargs) step in this workflow, skip.\n")))
    base_cmd <- lapply(cmd_steps, function(step) {
        # step_module <- stepsWF(sal)[[step]]@modules
        # if(length(step_module) > 0)
        step_clt <- stepsWF(sal)[[step]]@clt
       lapply(step_clt, function(clt) {
            clt$baseCommand[1]
        })
    })

    base_cmd <- data.frame(
        step_name = rep(names(base_cmd), (lapply(base_cmd, length) %>% unlist(use.names = FALSE))),
        tool = base_cmd %>% unlist(use.names = FALSE),
        in_path = NA
    )
    if(!check_path) {
        cat(crayon::blue$bold("Following tools are used in steps in this workflow:\n"))
        print(base_cmd)
    }

    if(!check_path) return(invisible(base_cmd))
    cat(crayon::blue$bold("Check if they are in path:\n"))
    unique_tools <- unique(base_cmd$tool)
    path_res <- lapply(unique_tools, function(i) {
        cat(crayon::blue$bold(paste0("Checking path for ", i, "\n")))
        try_res <- tryCMD(i, silent = TRUE)
        if(try_res == "proceed") {
            cat(crayon::blue$green$bold("PASS\n"))
            return(TRUE)
        }
        cat(crayon::blue$red$bold("ERROR\n"))
        FALSE
    }) %>% unlist()

    base_cmd$in_path <- path_res[match(base_cmd$tool, unique_tools)]
    print(base_cmd)

    if (all(path_res) && check_module) return(cat(crayon::green$bold(
        "All required tools in PATH, skip module check. If you want to check modules use `listCmdModules`"
    )))

    if(!check_module) return({
        if(!all(path_res)) {
            cat(crayon::blue$bold(
                c("Not all tools required are in PATH.",
                  "If you have a modular system, turn `load_module = TRUE`",
                  "It will call `listCmdModules` to check the required tools are in your modular system.\n")))
        }
        invisible(base_cmd)
    })

    cat(crayon::blue$bold("Now check if modular system:\n"))
    listCmdModules(sal, check_module)
    invisible(base_cmd)
}

listCmdModules <- function(
    sal,
    check_module = FALSE
) {
    if(!inherits(sal, "SYSargsList")) stop("ERROR: Please provide a `SYSargsList` object")
    # list of cmd steps
    all_steps <- stepsWF(sal) %>% lapply(class) %>% unlist()
    cmd_steps <- which(all_steps == "SYSargs2")
    if(length(cmd_steps) == 0) return(cat(crayon::make_style("orange")$bold("There is no commandline (SYSargs) step in this workflow, skip.\n")))
    base_mod <- lapply(cmd_steps, function(step) {
       stepsWF(sal)[[step]]@modules
    }) %>% unlist()
    if(is.null(base_mod)) return(cat(crayon::make_style("orange")$bold("No module is listed, check your CWL yaml configuration files, skip.\n")))
    base_mod <- data.frame(
        step_name = stringr::str_remove(names(base_mod), "\\.module[0-9]{1,}$"),
        module = unname(base_mod),
        avail = NA
    )

    if(!check_module) {
        cat(crayon::make_style("orange")$bold("Here are modules used in this workflow:\n"))
        print(base_mod)
    }

    if(!check_module) return(invisible(base_mod))
    module_avail <- is.modules.avail()
    if(is.null(module_avail)) return({
        cat(crayon::make_style("orange")$bold("Modular system is not installed, skip\n"))
        invisible(base_mod)
    })

    all_mods <- moduleAvail()$available_modules %>% unlist(use.names = FALSE)
    base_mod$avail <-  base_mod$module %in% all_mods
    cat(crayon::blue$bold("Module availability:\n"))
    print(base_mod)
}


###########################################################################################
## Function to evaluate (eval=TRUE) or not evaluate (eval=FALSE) R code in the Rmarkdown ##
###########################################################################################
## infile: Name and path of the infile file, format Rmarkdown.
evalCode <- function(infile, eval = TRUE, output) {
    if (!file.exists(infile)) stop("Provide valid 'infile' file. Check the file PATH.")
    if (!"Rmd" %in% .getExt(infile)) stop("Provide Rmarkdown file. Check the file PATH.")
    file <- readLines(infile)
    Rchunk <- grep("^```[{}]", file)
    if (length(Rchunk) == 0) stop("The file does not have any R Chuck")
    for (i in Rchunk) {
        if (grepl("eval", file[i])) {
            file[i] <- sub("eval.*E", paste0("eval=", eval), file[i])
        } else {
            file[i] <- sub("[}]", paste0(", eval=", eval, "}"), file[i])
        }
    }
    writeLines(file, output)
    return(output)
}

## Usage:
# file <- system.file("extdata/workflows/rnaseq/", "systemPipeRNAseq.Rmd", package="systemPipeRdata")
# evalCode(infile=file, eval=FALSE, output="test.Rmd")

###################################
## Update CWL description files  ##
###################################
cwlFilesUpdate <- function(destdir, force = FALSE, verbose = TRUE) {
    tempDir <- tempdir()
    download.file(
        url = "https://raw.githubusercontent.com/systemPipeR/cwl_collection/master/cwl/repo_version.txt",
        file.path(tempDir, "repo_version_new.txt"), quiet = TRUE
    )
    ## option for old versions
    if (force) {
        download.file(
            url = "https://github.com/systemPipeR/cwl_collection/archive/refs/heads/master.zip",
            file.path(tempDir, "cwl_collection-master.zip")
        )
        unzip(file.path(tempDir, "cwl_collection-master.zip"), exdir = tempDir)
        file.copy(file.path(tempDir, "cwl_collection-master", "cwl"), to = file.path(destdir), overwrite = TRUE, recursive = TRUE)
        file.copy(file.path(tempDir, "cwl_collection-master", "docopt.R"), to = file.path(destdir), overwrite = TRUE, recursive = TRUE)
        if (verbose) {
            cat(crayon::magenta(file.path(destdir, "cwl"), "folder was updated successfully!"))
        }
    } else {
        ## Get version
        new <- readLines(file.path(tempDir, "repo_version_new.txt"))
        if (!file.exists(file.path(destdir, "cwl", "repo_version.txt"))) {
            if (verbose) {
                cat(crayon::magenta(
                    "We expect a file called:", file.path(destdir, "cwl", "repo_version.txt"),
                    "\n", "OR please use the argument `force = TRUE`."
                ))
            }
        } else {
            current <- readLines(file.path(destdir, "cwl", "repo_version.txt"))
            ## Download CWL repo
            if (as.numeric(sub(".*\\.", "", current)) < as.numeric(sub(".*\\.", "", new))) {
                download.file(
                    url = "https://github.com/systemPipeR/cwl_collection/archive/refs/heads/master.zip",
                    file.path(tempDir, "cwl_collection-master.zip"), quiet = TRUE
                )
                unzip(file.path(tempDir, "cwl_collection-master.zip"), exdir = tempDir)
                file.copy(file.path(tempDir, "cwl_collection-master", "cwl"),
                    to = file.path(destdir), overwrite = TRUE, recursive = TRUE
                )
                file.copy(file.path(tempDir, "cwl_collection-master", "docopt.R"),
                    to = file.path(destdir), overwrite = TRUE, recursive = TRUE
                )
                if (verbose) {
                    cat(crayon::magenta(
                        file.path(destdir, "cwl"), "folder was updated successfully!", "\n",
                        new
                    ))
                }
            } else {
                if (verbose) {
                    cat(crayon::magenta("Already up to date.", "\n", new))
                }
            }
        }
    }
}
## Usage
# destdir <- "param/"
# options(timeout = max(3000, getOption("timeout")))
# cwlFilesUpdate(destdir)

#################################
## Unexported helper functions ##
#################################

##################################
## Return the path of the file  ##
##################################
## [x] A character vector or an object containing file PATH.
.getPath <- function(x, normalizePath = TRUE, full_path = TRUE, warning = TRUE) {
    if (warning) {
        if (!any(file.exists(x))) warning("No such file or directory. Check the file PATH.")
    }
    if (normalizePath) {
        x <- normalizePath(x)
    }
    if (full_path) {
        for (i in seq_along(x)) {
            path_un <- unlist(strsplit(x[i], "/|\\\\"))
            path <- path_un[path_un != basename(x[i])]
            x[i] <- paste0(path, collapse = "/")
        }
    } else {
        for (i in seq_along(x)) {
            path_un <- unlist(strsplit(x[i], "/|\\\\"))
            path <- path_un[path_un != basename(x[i])]
            x[i] <- paste0(path[length(path)], collapse = "/")
        }
    }
    return(x)
}

## Usage:
# x <- system.file("extdata", "targets.txt", package = "systemPipeR")
# .getPath(x) ## internal fct: it will delete any suffixes up to the last slash ('/') character and return the 'path of the file'
# basename(x) ## BiocGenerics pkg: it will delete any prefix up to the last slash ('/') character and return the 'name of the file'

###############################
## Return the file extension ##
###############################
## Function to return the extension of the file. The argument 'x' is a character vector or an object containing the file PATH.
.getExt <- function(x) {
    ext <- Biostrings::strsplit(basename(x), split = "\\.")[[1]]
    ext <- ext[[length(ext)]]
    return(ext)
}

## Usage:
# x <- system.file("extdata", "targets.txt", package = "systemPipeR")
# .getExt(x) ## internal fct: it will delete any suffixes up to the last slash ('/') character and return the 'extension of the file'

##############################################
## Return the file name, without extension ##
#############################################
## [x] A character vector or an object containing file File name without extension, simmilar with 'basename'
.getFileName <- function(x) {
    #  if (!file.exists(x)) warning("No such file or directory. Check the file PATH.")
    filename <- Biostrings::strsplit(basename(x), split = ".([^.]*)$")[[1]]
    # filename <- filename[[-2]]
    return(filename)
}

## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# .getFileName(targetspath)

#################################################
## Return the logical, if the path is absolute ##
#################################################
is.fullPath <- function(x) {
    grepl("^(/|[A-Za-z]:|\\\\|~)", x)
}

## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# is.fullPath(targetspath)
# is.fullPath("./results")

##########################################################
## Internal function to detect nested of the param list ##
##########################################################
.nest <- function(x) ifelse(is.list(x), 1L + max(sapply(x, .nest)), 0L)

## Usage:
# param <- list(results_new=list(class="Directory", path=8))
# nesting <- .nest(param[1])

############################################################################
## Internal function to replace or add the list values at the input file ##
############################################################################
.replace <- function(input, param) {
    for (i in seq_along(param)) {
        for (j in seq_along(param[[i]])) {
            nesting <- .nest(param[i])
            if (nesting == 1) {
                if (is.numeric(param[[i]][j][[1]])) {
                    input[names(param)[i]] <- as.integer(param[[i]][j])
                } else {
                    input[names(param)[i]] <- param[[i]][j]
                }
            } else if (nesting > 1) {
                if (is.numeric(param[[i]][j][[1]])) {
                    input[[names(param[i])]][[names(param[[i]][j])]] <- as.integer(param[[i]][[j]])
                } else {
                    input[[names(param[i])]][[names(param[[i]][j])]] <- (param[[i]][[j]])
                    input[[names(param[i])]] <- as.list(input[[names(param[i])]])
                }
            }
        }
    }
    return(input)
}

## Usage:
# input_file="param/cwl/hisat2/hisat2-se/hisat2-mapping-se.yml"
# input <- yaml::read_yaml(file.path(input_file))
# param <- list(thread=14, test="test")
# .replace(input=input, param=param)

##########################
## .parse_step function ##
##########################
## Internal parse function used in the subsetRmd function
.parse_step <- function(t_lvl, input_steps) {
    . <- NULL
    t_lvl_name <- names(t_lvl)
    input_steps <- unlist(input_steps %>% stringr::str_remove_all(" ") %>% stringr::str_split(",") %>% list())
    # single steps
    nocolon_steps <- input_steps[stringr::str_which(input_steps, "^[^:]+$")]
    lapply(nocolon_steps, function(x) if (!any(t_lvl_name %in% x)) stop("Step ", x, " is not found"))
    # dash linked steps
    dash_list <- NULL
    for (i in stringr::str_which(input_steps, ":")) {
        dash_step <- unlist(stringr::str_split(input_steps[i], ":"))
        dash_parse <- unlist(lapply(dash_step, function(x) {
            which(t_lvl_name %in% x) %>% ifelse(length(.) > 0, ., stop("Step ", x, " is not found"))
        })) %>%
            {
                t_lvl_name[.[1]:.[2]]
            }
        dash_list <- append(dash_list, dash_parse)
    }
    # merge
    all_step_name <- unique(append(nocolon_steps, dash_list))
    # if upper level step is selected, all sub-level steps will be added
    unlist(lapply(all_step_name, function(x) stringr::str_which(t_lvl_name, paste0("^", x, "\\..*")))) %>%
        append(which(t_lvl_name %in% all_step_name)) %>%
        unique() %>%
        sort() %>%
        return()
}

#############################
## .tryCatch function ##
#############################
.tryCatch <- function(x, file = NULL) {
    if (is.null(file)) file <- tempfile()
    tryCatch(
        expr = {
            cat("## Output", append = TRUE, file = file, "\n")
            capture.output(out <- eval(parse(text = x), envir = globalenv()), file = file, append = TRUE)
            message("DONE")
            return(out)
        },
        error = function(e) {
            print(e)
            message("ERROR")
            return("Caught an error!")
        },
        warning = function(w) {
            print(w)
            message("WARNING")
            return("Caught an warning!")
        }
    )
}

## Usage:
# .tryCatch(x=codeList[[1]])

################################
## .checkSpecialChar function ##
################################
.checkSpecialChar <- function(x) {
    chunk_names_bad <- stringr::str_detect(x, "\\W")
    if (any(chunk_names_bad)) {
        stop(
            "Only letters, numbers, and '_' allowed for step_name. Invalid name:\n",
            paste0(x[chunk_names_bad], collapse = ", "),
            call. = FALSE
        )
    }
}

## Usage:
# .checkSpecialChar("name@")
# .checkSpecialChar("name test")

############################
## .renderMsg function ##
############################
.renderMsg <- function() {
    warn_flag <- getOption("spr_render_msg")
    if (isTRUE(warn_flag)) {
        return()
    }
    cat(
        crayon::green$bold("Done with workflow running, now consider rendering logs & reports\n"),
        crayon::blue("To render logs, run:    "), "sal <- renderLogs(sal)\n",
        crayon::blue("From command-line:      "), 'Rscript -e "sal = systemPipeR::SPRproject(resume = TRUE); sal = systemPipeR::renderLogs(sal)"\n',
        crayon::blue("To render reports, run: "), "sal <- renderReport(sal)\n",
        crayon::blue("From command-line:      "), 'Rscript -e "sal= s ystemPipeR::SPRproject(resume = TRUE); sal = systemPipeR::renderReport(sal)"\n',
        crayon::make_style("white")$bold("This message is displayed once per R session\n"),
        sep = ""
    )
    options(spr_render_msg = TRUE)
}

#################################
## .clusterRunResults function ##
################################
.clusterRunResults <- function(args.run, reg, nTargets) {
    logdir <- reg$file.dir
    file_log <- file.path(logdir, paste0(
        "sysargs2_log_",
        format(Sys.time(), "%b%d%Y_%H%Ms%S"),
        paste(sample(0:9, 4), collapse = "")
    ))
    id_save <- character()
    for (i in seq_along(1:nTargets)) {
        ## ind object created by the batchtools
        newsysargs <- batchtools::loadResult(reg = reg, id = i)
        id_sysargs <- names(newsysargs$cmdlist)
        id_save <- c(id_save, id_sysargs)
        ## update output slot
        args.run@output[id_sysargs] <- newsysargs$output[id_sysargs]
        ## Update status slot
        args.run@status$status.completed[id_sysargs, ] <- newsysargs$status$status.completed[id_sysargs, ]
        args.run@status$status.time[id_sysargs, ] <- newsysargs$status$status.time[id_sysargs, ]
        ## time
        args.run@status$status.time[id_sysargs, ]$time_start <- as.POSIXct(args.run@status$status.time[id_sysargs, ]$time_start, origin = "1970-01-01")
        args.run@status$status.time[id_sysargs, ]$time_end <- as.POSIXct(args.run@status$status.time[id_sysargs, ]$time_end, origin = "1970-01-01")
        ## Update files logs --> combining
        logs <- readLines(newsysargs$files$log)
        write(logs, file_log, append = TRUE, sep = "\n")
    }
    time_start <- sort(args.run$status$status.time[id_save, ]$time_start)[1]
    time_end <- tail(sort(args.run$status$status.time[id_save, ]$time_end), 1)
    args.run@status$total.time <- list(
        time_start = as.POSIXct(time_start, origin = "1970-01-01"),
        time_end = as.POSIXct(time_end, origin = "1970-01-01")
    )
    args.run@status$status.summary <- .statusSummary(args.run)
    args.run@files$log <- file_log
    return(args.run)
}


########################
## .tryRcode function ##
########################
.tryRcode <- function(command, envir) {
    warning <- error <- NULL
    value <- withCallingHandlers(
        tryCatch(
            eval(command, envir = envir),
            error = function(e) {
                error <<- conditionMessage(e)
                NULL
            }
        ),
        warning = function(w) {
            warning <<- append(warning, conditionMessage(w))
            invokeRestart("muffleWarning")
        }
    )
    list(stdout = value, warning = warning, error = error)
}

###############################
## .updateAfterRunC function ##
###############################
.updateAfterRunC <- function(args, step) {
    args2 <- args
    conList <- args2$targets_connection[lengths(args2$targets_connection) != 0]
    conList_step <- sapply(conList, "[[", 1)
    for (l in seq_along(conList_step)) {
        if (step %in% conList_step[[l]]) {
            requiredUP <- names(conList)[[l]]
            for (s in requiredUP) {
                WF <- args2[s]
                WFstep <- names(stepsWF(WF))
                new_targets <- WF$targetsWF[[1]]
                col_out <- lapply(outfiles(args2), function(x) colnames(x))
                col_out_l <- sapply(names(col_out), function(x) list(NULL))
                for (i in names(col_out)) {
                    col_out_l[[i]] <- col_out[[i]][col_out[[i]] %in% WF$targets_connection[[WFstep]]$new_targets_col[[1]]]
                }
                col_out_l <- col_out_l[lapply(col_out_l, length) > 0]
                if (all(sapply(col_out_l, function(x) length(x) == 1))) {
                    col_out_df <- lapply(names(col_out_l), function(x) getColumn(args2, step = x, position = "outfiles", column = col_out_l[[x]]))
                    names(col_out_df) <- col_out_l
                    new_targets[as.character(col_out_l)] <- col_out_df
                } else {
                    col_out_df <- data.frame(args2[step]$outfiles[[step]][, col_out_l[[1]]])
                    names(col_out_df) <- col_out_l[[1]]
                    new_targets[as.character(col_out_l[[1]])] <- col_out_df
                }
                WF2 <- stepsWF(WF)[[1]]
                WF2 <- updateWF(WF2, new_targets = targets.as.list(data.frame(new_targets)), inputvars = WF2$inputvars, write.yaml = FALSE)
                ## Preserve outfiles
                WF2[["output"]] <- WF$stepsWF[[s]]$output
                args2 <- sysargslist(args2)
                args2$stepsWF[[WFstep]] <- WF2
                args2$targetsWF[[WFstep]] <- as(WF2, "DataFrame")
                rownames(args2$targetsWF[[WFstep]]) <- rownames(args$targetsWF[[WFstep]])
                args2$outfiles[[WFstep]] <- output.as.df(WF2)
                rownames(args2$outfiles[[WFstep]]) <- rownames(args$outfiles[[WFstep]])
                args2$statusWF[[WFstep]] <- WF2$status
                rownames(args2$statusWF[[WFstep]]$status.completed) <- rownames(args$outfiles[[WFstep]])
                rownames(args2$statusWF[[WFstep]]$status.time) <- rownames(args$outfiles[[WFstep]])
                args2 <- as(args2, "SYSargsList")
            }
        } else {
            do <- "donothing"
        }
    }
    return(args2)
}

#############################
## .statusSummary function ##
#############################
.statusSummary <- function(args) {
    if (inherits(args, "SYSargs2")) {
        step.status.summary <- args$status$status.completed
    } else if (inherits(args, "data.frame")) {
        step.status.summary <- args[5:ncol(args)]
    } else {
        stop("Argument 'args' needs to be assigned an object of class 'SYSargs2' or 'data.frame'.")
    }
    if ("Error" %in% unlist(unique(step.status.summary))) {
        step.status <- "Error"
    } else if ("Warning" %in% unlist(unique(step.status.summary))) {
        step.status <- "Warning"
    } else if ("Success" %in% unlist(unique(step.status.summary))) {
        step.status <- "Success"
    } else if ("Pending" %in% unlist(unique(step.status.summary))) {
        step.status <- "Pending"
    } else if (is.null(step.status.summary)) {
        step.status <- "Pending"
    }
    return(step.status)
}

########################
## .prepareRmdPlot ##
########################
.prepareRmdPlot <- function(sysargs, dir_log) {
    out_path <- file.path(dir_log, "log_plot.html")
    plotWF(sysargs,
           out_format = "html", out_path = out_path, rmarkdown = TRUE,
           in_log = TRUE, rstudio = TRUE, plot_ctr = FALSE
    )
    # modify HTML content
    if (!file.exists(out_path)) stop("Cannot create the workflow plot for logs at\n", out_path)
    plot_content <- readLines(out_path)
    out_path
}

################################
## .dirProject function ##
################################
.dirProject <- function(projPath, data, param, results, silent) {
    project <- list(
        project = projPath,
        data = file.path(projPath, data),
        param = file.path(projPath, param),
        results = file.path(projPath, results)
    )
    path <- sapply(project, function(x) suppressMessages(tryPath(x)))
    create <- NULL
    for (i in seq_along(path)) {
        if (is.null(path[[i]])) create <- c(create, project[i])
    }
    ## Question
    if (!is.null(create)) {
        ## For an interactive() session
        if (interactive()) {
            dir_create <- readline(cat(
                "It is required to have the project structure in place. We can create the directories now, and you can find more information by reading the `?SPRProject` help file. ", "\n",
                "\n", "There is no directory called", "\n", paste(names(create), collapse = " OR ", sep = "\n"), "\n", "\n",
                "Would you like to create this directory now? Type a number: \n 1. Yes \n 2. No \n"
            ))
        } else {
            ## For an non-interactive session
            dir_create <- "1"
        }
        for (i in seq_along(create)) {
            if (dir_create == "1") {
                dir.create(create[[i]], recursive = TRUE)
                if (silent != TRUE) cat("Creating directory: ", create[[i]], "\n")
            } else if (dir_create == 2) {
                stop("Aborting project creation. Find more information by reading the `?SPRProject` help file.", call. = FALSE)
            }
        }
    }
    project <- list(
        project = projPath,
        data = file.path(data),
        param = file.path(param),
        results = file.path(results)
    )
    return(project)
}

#############################
## .statusPending function ##
#############################
.statusPending <- function(args) {
    status.pending <- check.output(args)
    ## function
    .statusSYSargs2 <- function(args, status.pending) {
        pending <- sapply(args$files$steps, function(x) list(x = "Pending"))
        pending <- data.frame(matrix(unlist(pending), ncol = length(pending), byrow = TRUE), stringsAsFactors = TRUE)
        colnames(pending) <- args$files$steps
        status.pending <- cbind(status.pending, pending)
        rownames(status.pending) <- status.pending$Targets
        status.pending[c(2:4)] <- sapply(status.pending[c(2:4)], as.numeric)
        status.pending[c(5:ncol(status.pending))] <- sapply(status.pending[c(5:ncol(status.pending))], as.character)
        # status.time <- data.frame(matrix(, nrow=nrow(status.pending),  ncol = length(pending)))
        status.time <- status.pending[, 1, drop = FALSE]
        # status.time <- cbind(status.time)
        status.time <- cbind(status.time, time_start = NA, time_end = NA)
        status.time$time_start <- .POSIXct(status.time$time_start)
        status.time$time_end <- .POSIXct(status.time$time_end)
        rownames(status.time) <- status.pending$Targets
        pendingList <- list(
            status.summary = .statusSummary(status.pending),
            status.completed = status.pending, status.time = status.time
        )
    }
    if (inherits(args, "SYSargsList")) {
        for (i in seq_along(status.pending)) {
            # print(i)
            if (inherits(args$stepsWF[[i]], "SYSargs2")) {
                status.pending[[i]] <- .statusSYSargs2(args$stepsWF[[i]], status.pending[[i]])
                # print(status.pending[[i]])
            }
        }
        pendingList <- status.pending
    } else if (inherits(args, "SYSargs2")) {
        pendingList <- .statusSYSargs2(args, status.pending)
    }
    return(pendingList)
}

##########################
## .outList2DF function ##
##########################
.outList2DF <- function(args) {
    if (inherits(args, "list")) {
        args <- as(args, "SYSargsList")
        out <- sapply(names(stepsWF(args)), function(x) list(NULL))
        for (i in seq_along(stepsWF(args))) {
            l_out <- output(stepsWF(args)[[i]])
            out[[i]] <- S4Vectors::DataFrame(matrix(unlist(l_out), nrow = length(l_out), byrow = TRUE))
            # out <- S4Vectors::DataFrame(as.data.frame(do.call(rbind, l_out)))
            colnames(out[[i]]) <- stepsWF(args)[[i]]$files$output_names
        }
    } else if (inherits(args, "SYSargs2")) {
        l_out <- output(args)
        # sapply(l_out, function(x) length(x))
        out <- S4Vectors::DataFrame(matrix(unlist(l_out), nrow = length(l_out), byrow = TRUE))
        # out <- S4Vectors::DataFrame(as.data.frame(do.call(rbind, l_out)))
        colnames(out) <- args$files$output_names
    }
    return(out)
}

#############################
## .outputTargets function ##
#############################
.outputTargets <- function(args, fromStep, index = 1, toStep, replace = c("FileName")) {
    if (!inherits(args, "SYSargsList")) stop("Argument 'args' needs to be assigned an object of class 'SYSargsList'")
    outputfiles <- outfiles(args[fromStep])[[1]]
    if (length(targetsWF(args)[[fromStep]]) > 0) {
        df <- targetsWF(args)[[fromStep]]
        df[replace] <- outputfiles
    }
    return(df)
}

#####################################
## Method Definitions for LineWise ##
#####################################
## Methods to return LineWise components
setMethod(f = "codeLine", signature = "LineWise", definition = function(x) {
    return(cat(as.character(x@codeLine), sep = "\n"))
})
setMethod(f = "rmdPath", signature = "LineWise", definition = function(x) {
    return(x@files$rmdPath)
})
setMethod(f = "codeChunkStart", signature = "LineWise", definition = function(x) {
    return(x@codeChunkStart)
})
setMethod(f = "stepName", signature = "LineWise", definition = function(x) {
    return(x@stepName)
})
setMethod(f = "dependency", signature = "LineWise", definition = function(x) {
    return(x@dependency)
})
setMethod(f = "status", signature = "LineWise", definition = function(x) {
    return(x@status)
})
setMethod(f = "files", signature = "LineWise", definition = function(x) {
    return(x@files)
})
setMethod(f = "runInfo", signature = "LineWise", definition = function(x) {
    return(x@runInfo)
})

#######################################
## Constructor Methods for LineWise ##
#######################################
## Constructor methods
## List to LineWise with: as(mylist, "LineWise")
setAs(
    from = "list", to = "LineWise",
    def = function(from) {
        new("LineWise",
            codeLine = from$codeLine,
            codeChunkStart = from$codeChunkStart,
            stepName = from$stepName,
            dependency = from$dependency,
            status = from$status,
            files = from$files,
            runInfo = from$runInfo
        )
    }
)

## Coerce back to list: as(LineWise, "list")
setMethod(f = "linewise", signature = "LineWise", definition = function(x) {
    linewise <- list(
        codeLine = x@codeLine, codeChunkStart = x@codeChunkStart,
        # rmdPath = x@rmdPath,
        stepName = x@stepName, dependency = x@dependency,
        status = x@status, files = x@files, runInfo = x@runInfo
    )
    return(linewise)
})

## LineWise to list with: as(LineWise, "list")
setAs(from = "LineWise", to = "list", def = function(from) {
    linewise(from)
})

## Define print behavior for LineWise
setMethod(
    f = "show", signature = "LineWise",
    definition = function(object) {
        cat(crayon::yellow$bold(paste0("Instance of '", class(object), "'")),
            paste0("    Code Chunk length: ", length(object)),
            sep = "\n"
        )
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "LineWise",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend length() method
setMethod(f = "length", signature = "LineWise", definition = function(x) {
    return(length(x@codeLine))
})


# Behavior of "[" operator for LineWise
setMethod(f = "[", signature = "LineWise", definition = function(x, i, ..., drop) {
    if (is.logical(i)) {
        i <- which(i)
    }
    x@codeLine <- x@codeLine[i]
    x@stepName <- x@stepName
    x@dependency <- x@dependency
    x@status <- x@status
    x@files <- x@files
    x@runInfo <- x@runInfo
    return(x)
})

## Behavior of "[[" operator for LineWise
setMethod(
    f = "[[", signature = c("LineWise", "ANY", "missing"),
    definition = function(x, i, ..., drop) {
        return(as(x, "list")[[i]])
    }
)

## Behavior of "$" operator for LineWise
setMethod("$",
    signature = "LineWise",
    definition = function(x, name) {
        slot(x, name)
    }
)

###########################################
## Replacement Definitions for LineWise ##
##########################################

## Replacement method for LineWise using "[" operator
setReplaceMethod(f = "[[", signature = "LineWise", definition = function(x, i, j, value) {
    if (i == 1) x@codeLine <- value
    if (i == 2) x@codeChunkStart <- value
    if (i == 4) x@stepName <- value
    if (i == 5) x@dependency <- value
    if (i == 6) x@status <- value
    if (i == 7) x@files <- value
    if (i == 8) x@runInfo <- value
    if (i == "codeLine") x@codeLine <- value
    if (i == "codeChunkStart") x@codeChunkStart <- value
    if (i == "stepName") x@stepName <- value
    if (i == "dependency") x@dependency <- value
    if (i == "status") x@status <- value
    if (i == "files") x@files <- value
    if (i == "runInfo") x@runInfo <- value
    return(x)
})

setReplaceMethod("replaceCodeLine", signature = c("LineWise"), function(x, line, ..., value) {
    if (!inherits(x, "LineWise")) stop("Provide 'LineWise' class object")
    y <- as(x, "list")
    y$codeLine <- as.character(y$codeLine)
    y$codeLine[line] <- value
    y$codeLine <- parse(text = y$codeLine)
    x <- as(y, "LineWise")
    x
})

setReplaceMethod("appendCodeLine", signature = c("LineWise"), function(x, after = length(x), value) {
    lengx <- length(x)
    x <- linewise(x)
    value <- parse(text = value)
    if (!after) {
        x$codeLine <- c(value, x$codeLine)
    } else if (after >= lengx) {
        x$codeLine <- c(x$codeLine, value)
    } else {
        x$codeLine <- c(x$codeLine[1L:after], value, x$codeLine[(after + 1L):lengx])
    }
    x <- as(x, "LineWise")
    x
})

#######################
## LineWise function ##
#######################
LineWise <- function(code, step_name = "default", codeChunkStart = integer(),
                     rmdPath = character(), dependency = NA,
                     run_step = "mandatory",
                     run_session = "management",
                     run_remote_resources = NULL) {
    ## used in `importWF`
    on.exit({
        options(linewise_importing = FALSE)
    })

    ## check options
    run_step <- match.arg(run_step, c("mandatory", "optional"))
    run_session <- match.arg(run_session, c("management", "compute"))
    if (!is.null(run_remote_resources)) {
        if (!inherits(run_remote_resources, "list")) {
            stop("Argument 'run_remote_resources' needs to be assigned an object of class 'list'")
        }
    }
    ## Step name
    if (step_name == "default") {
        step_name <- "Step_x"
    } else {
        .checkSpecialChar(step_name)
        step_name <- step_name
    }
    ## dependency
    dependency <- list(dependency)
    names(dependency) <- step_name
    ## RunInfo
    if (!is.null(run_remote_resources)) {
        if (run_session == "management") {
            message("Please note that the '", step_name, "' run_session option '", run_session, "' was replaced with 'compute' because run_remote_resources was available.")
            run_session <- "compute"
        }
    }
    runInfo <- list(runOption = list(list(
        directory = FALSE, run_step = run_step,
        run_session = run_session,
        run_remote_resources = run_remote_resources
    )))
    names(runInfo$runOption) <- step_name
    ## status
    step_status <- list(
        status.summary = "Pending",
        status.completed = data.frame(Step = step_name, status.summary = "Pending"),
        status.time = data.frame()
    )
    ## codeLine
    if (length(deparse(substitute(code))) == 1) {
        codeLine <- parse(text = sub("^\\{|\\}$", "", deparse(substitute(code))))
    } else {
        codeLine <- deparse(substitute(code))
        codeLine[1] <- sub("^\\{", "", codeLine[1])
        codeLine[length(codeLine)] <- sub("\\}$", "", codeLine[length(codeLine)])
        codeLine <- parse(text = codeLine)
    }
    line <- list(
        codeLine = codeLine,
        codeChunkStart = codeChunkStart,
        # rmdPath = rmdPath,
        stepName = step_name,
        dependency = dependency,
        status = step_status,
        files = list(rmdPath = rmdPath),
        runInfo = runInfo
    )
    return(as(line, "LineWise"))
}
## Usage:
# xx <- LineWise({
#   x <- 1+1;  y <- 100
# })
# plot <- LineWise({
#   plot(iris)
# })

########################
## importRmd function ##
########################
importWF <- function(
        sysargs,
        file_path,
        ignore_eval = TRUE,
        update = FALSE,
        confirm = FALSE,
        check_tool = !update,
        check_module = check_tool,
        verbose = TRUE
        ) {
    on.exit({
        options(linewise_importing = FALSE)
        options(spr_importing = FALSE)
    })
    orangeText <- crayon::make_style("orange")$bold
    stopifnot(is.character(file_path) && length(file_path) == 1)
    if (!stringr::str_detect(file_path, "\\.[Rr]md$")) stop("File must be .Rmd, or .rmd ending.")
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    stopifnot(is.logical(ignore_eval) && length(ignore_eval) == 1)
    stopifnot(is.logical(update) && length(update) == 1)
    stopifnot(is.logical(check_tool) && length(check_tool) == 1)
    stopifnot(is.logical(check_module) && length(check_module) == 1)
    keyword <- if(update) "Update" else "Import"
    if (!update && length(sysargs) > 0) {
        cat(orangeText("SYSargsList is not empty. Are you sure that you are combining two workflows?\n",
                       "If not use `update = TRUE` to re-import/update current workflow"), "\n")
    }
    ## start
    if (verbose) cat(crayon::blue$bold("Reading Rmd file\n"))
    df <- parseRmd(file_path, ignore_eval = ignore_eval, verbose = verbose)
    ## create a new env for sysargs to eval
    sysargs_env <- new.env()
    sal_imp <- sysargs
    sal_imp <- as(sal_imp, "list")
    if(update) {
        updated <- updateRmdTemplate(df = df, sal_imp = sal_imp, confirm = confirm, verbose = verbose)
        if(is.null(updated)) {
            df <- df[FALSE,]
        } else {
            sal_imp <- updated$sal_imp
            df <- updated$df
            if (verbose && nrow(df) > 0) cat(crayon::blue$bold("Now importing new steps\n"))
        }
        if(nrow(df[df$import, ]) > 0) {
            flag_import <- if(confirm) 1 else if(interactive()) menu(c("Yes", "No"), title = "Comparison done, do you want import new steps?") else 2
            df <- if(flag_import != 1) df[FALSE,] else df[df$import, ]
        } else df <- df[FALSE,]
    }
    ## adding steps
    for (i in seq_along(df$step_name)) {
        if (verbose) cat(crayon::blue$bold("Now importing step '", df$step_name[i], "' \n", sep = ""))
        options(spr_importing = TRUE)
        sal_imp <- as(sal_imp, "SYSargsList")
        salname <- sub("[\\)].*", "", sub(".*(appendStep\\()", "", df$code[i]))
        assign(salname, sal_imp, sysargs_env)
        args <- eval(parse(text = df$code[i]), envir = sysargs_env)
        if(!update) appendStep(sal_imp) <- args
        else {
            after <- length(sal_imp$stepsWF)
            if(!confirm && interactive()){
                if(df$index[i] == 1) {
                    after <- 0
                    previous_step <- ""
                } else {
                    step_names <- names(sal_imp$stepsWF)
                    previous_steps_in_df <- updated$df$step_name[seq(1, df$index[i] - 1)]
                    after_tmp <- integer(0)
                    for(s in rev(previous_steps_in_df)) {
                        after_tmp <- which(step_names == s)
                        if(length(after_tmp) != 0) {
                            after <- after_tmp
                            previous_step <- s
                            break
                        }
                    }
                }
                cat(
                    crayon::blue$bold("Step           order name\n"),
                    crayon::blue$bold("*************************\n"),
                    "Previous step: ", stringr::str_pad(after, 6, "right"), previous_step, "\n",
                    "New step:      ", stringr::str_pad(after + 1, 6, "right"), df$step_name[i], "\n",
                    sep = ""
                )
                flag_after <- menu(c("Yes", "No"), title = paste0(
                "Automatic detected the append order for ", df$step_name[i], " is after ", after, ".\n",
                "Is this the right order you want to append new step?", collapse = ""))
                after <- if(flag_after == 1) after else menu(step_names, title = "after which step you want to append this new step? 0 will before step 1. ")
            }
            appendStep(sal_imp, after = after) <- args
        }
        sal_imp <- as(sal_imp, "list")
        sal_imp$runInfo[["runOption"]][[df$step_name[i]]][["rmd_line"]] <- paste(df[i, 2:3], collapse = ":")
        sal_imp$runInfo[["runOption"]][[df$step_name[i]]][["prepro_lines"]] <- df$prepro_lines[i]
    }
    if (verbose) cat(crayon::blue$bold("Now back up current Rmd file as template for `renderReport`\n"))
    rmd_file <- file.path(sal_imp$projectInfo$project, sal_imp$projectInfo$logsDir, "workflow_template.Rmd")
    if(!file.copy(file_path, rmd_file, overwrite = TRUE)) stop("Cannot copy workflow template to workflow log directory, check path and permissions")
    # update sal
    sal_imp[["projectInfo"]]$rmd_file <- rmd_file
    # sal_imp[["projectInfo"]]$rmd_file_hash <- rlang::hash_file(rmd_file)

    if (verbose) cat(
        crayon::blue$bold("Template for renderReport is stored at"), "\n",
        rmd_file, "\n",
        crayon::make_style("orange")("Edit this file manually is not recommended"), "\n"
    )

    sal_imp <- as(sal_imp, "SYSargsList")
    sysargslist <- file.path(sal_imp$projectInfo$project, sal_imp$projectInfo$sysargslist)
    write_SYSargsList(sal_imp, sysargslist, silent = TRUE)

    if(check_tool) {
        cat(crayon::blue$bold("Now check if required tools are installed"), "\n")
        listCmdTools(sal_imp, check_path = TRUE, check_module = check_module)
    }


    if (verbose) cat(crayon::green$bold(keyword, " done\n"))
    return(sal_imp)
}

## Usage:
# file_path <- system.file("extdata", "spr_simple_wf.Rmd", package="systemPipeR")
# sal <- SPRproject(overwrite = TRUE)
# sal <- importWF(sal, file_path)

########################
## updateRmdTemplate function ##
########################


updateRmdTemplate <- function(df, sal_imp, confirm = FALSE, verbose = TRUE){
    orangeText <- crayon::make_style("orange")$bold
    if(verbose) cat(crayon::blue$bold("Update starts."),
        "Note for existing steps, update only fix the line number records. They are NOT imported again.",
        "If you have changed arguments in methods like `SYSargsList`, `Linewise`, `appendStep` in template for some steps,",
        "delete the original step from the workflow and rerun this function or manually to import it again,",
        "or use replacement methods to change arguments in current workflow, see ?`SYSargsList-class` help file.",
        "Otherwise, package would use what is in the current workflow to `renderReport` and `sal2rmd`.",
        "New arguments in the template will be ignored.",
        "\n")
    if(interactive() && !confirm && verbose)  cat(crayon::cyan$bold("Detected you have an interactive session, we may need your confirmation on some questions."), "\n")

    step_sal <- names(sal_imp$stepsWF)
    step_new <- df$step_name

    if(verbose)  cat(crayon::blue$bold("Comparing SPR steps"), "\n")
    step_new_in_sal <- step_new %in% step_sal
    df$import <- !step_new_in_sal
    df$index <- seq(1, nrow(df))
    if(!all(step_new_in_sal))
        message(crayon::blue$bold("Some new steps exist in new template but not in current SYSargsList.\n",
                              "They will be imported to workflow later. Update existing steps first."),
             "\nsteps: ", paste0(step_new[!step_new_in_sal], collapse = " ")
        )
    step_sal_in_new <- step_sal %in% step_new
    if(!all(step_sal_in_new))
        message(crayon::white$bold("Some new steps exist in SYSargsList but not in new template. Consider adding it to your template or delete from current workflow.\n"),
                "\nsteps: ", paste0(step_sal[!step_sal_in_new], collapse = " ")
        )

    if(verbose) cat(crayon::blue$bold("Comparing step orders"), "\n")
    df_order <- data.frame(
        step_name = step_new,
        order_new = seq_along(step_new),
        order_old = lapply(step_new, function(x) {match_order <- which(step_sal == x); ifelse(length(match_order) == 0, 0, match_order)}) %>%
            unlist()
    )
    diff_order <- df_order$order_new != df_order$order_old
    if(any(diff_order)) {
        if(verbose) cat("Note this function checks SPR step sequental orders, not the dependency graph.",
                        "Order change will not be immediately taken place in SYSargsList object.",
                        "New orders will be only used in `renderReport`. `sal2rmd` still uses the order in SYSargsList object.", "\n")
        cat(orangeText("Some steps in the new template have different order than SYSargsList."), "\n")
        cat(paste0(df_order$step_name[diff_order], ": ", df_order$order_old[diff_order], " -> ",   df_order$order_new[diff_order]), sep = "\n")
    }

    if(verbose) cat(crayon::blue$bold("Updating SPR steps line numbers"), "\n")

    rmd_lines_old <- lapply(sal_imp$runInfo$runOption, function(x) {lines <- x$rmd_line; if(is.null(lines)) "" else lines}) %>% unlist()
    rmd_lines_new <- paste0(df$start, ':', df$end)[step_new_in_sal]
    names(rmd_lines_new) <- step_new[step_new_in_sal]

    for(i in seq_along(rmd_lines_new)) {
        old_line_index <- which(names(rmd_lines_old) == names(rmd_lines_new[i]))
        # if(rmd_lines_old[old_line_index] == "") next
        if(rmd_lines_old[old_line_index] != rmd_lines_new[i]) {
            if(verbose) cat(crayon::blue$bold("Updating step lines of ", names(rmd_lines_old[old_line_index])),
                            rmd_lines_old[old_line_index], "->",  rmd_lines_new[i],"\n")
            sal_imp$runInfo$runOption[[names(rmd_lines_old[old_line_index])]]$rmd_line <- unname(rmd_lines_new[i])
        }
    }

    if(verbose) cat(crayon::blue$bold("Updating SPR steps preprocess code information"), "\n")
    prepro_lines_old <- lapply(sal_imp$runInfo$runOption, function(x) {lines <- x$prepro_lines; if(is.null(lines)) "" else lines}) %>% unlist()
    prepro_lines_new <- df$prepro_lines[step_new_in_sal]
    names(prepro_lines_new) <- df$step_name[step_new_in_sal]

    for(i in seq_along(prepro_lines_new)) {
        prepro_lines_index <- which(names(prepro_lines_old) == names(prepro_lines_new[i]))
        if(prepro_lines_old[prepro_lines_index] != prepro_lines_new[i]) {
            cat(crayon::blue$bold("For step"), names(prepro_lines_old[prepro_lines_index]), crayon::blue$bold("old preprocess code:"), "\n")
            cat(prepro_lines_old[prepro_lines_index], "\n")
            cat(crayon::blue$bold("New preprocess code:"), "\n")
            cat(prepro_lines_new[i], "\n")
            flag_prepro <- if(confirm) 1 else if(interactive()) menu(c("Yes", "No"), title = "Replace the preprocess code?") else 2
            if(flag_prepro == 1){
                sal_imp$runInfo$runOption[[names(prepro_lines_old[prepro_lines_index])]]$prepro_lines <- unname(prepro_lines_new[i])
            } else cat(orangeText("Skip current step's new preprocess code", "\n"))
        }
    }

    cat(crayon::blue$bold("Template update done."), "\n")
    list(sal_imp = sal_imp, df = df)
}


########################
## parseRmd function ##
########################
parseRmd <- function(file_path, ignore_eval = TRUE, verbose = FALSE) {
    # assertions
    stopifnot(is.character(file_path) && length(file_path) == 1)
    stopifnot(is.logical(ignore_eval) && length(ignore_eval) == 1)
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    # read file
    lines <- readLines(file_path)
    # get chunk numbers --------
    chunk_start <- lines %>% stringr::str_which("^```\\{.*\\}.*")
    chunk_end <- lines %>% stringr::str_which("^```[[:blank:]]{0,}$")
    if (length(chunk_start) != length(chunk_end)) {
        stop("unmatched number of code chunk starts and ends")
    }
    for (i in seq_along(chunk_start)[-length(chunk_end)]) {
        if (chunk_start[i + 1] <= chunk_end[i]) {
            stop(
                "A code chunk does not end, chunk line:\n",
                chunk_start[i + 1]
            )
        }
    }
    # create df
    df <- data.frame(
        # cols export
        step_name = "",
        start = chunk_start,
        end = chunk_end,
        dep = NA,
        code = NA,
        spr = NA,
        req = NA,
        session = NA,
        has_run = FALSE,
        success = FALSE,
        sample_pass = 0,
        sample_warn = 0,
        sample_error = 0,
        sample_total = 0,
        log_path = "",
        time_start = Sys.time(),
        time_end = Sys.time() + 1,
        # cols will be removed?
        opt_text = "",
        prepro_lines = ""
    )
    # get r chunks -----
    r_chunk <- lines[chunk_start] %>% stringr::str_detect("^```\\{r")
    # get chunk start and end
    if (verbose) message(crayon::blue("\n", "---- Actions ----"))
    if (verbose && length(chunk_start[!r_chunk])) message("Ignore none-R chunks at line: ", paste0(chunk_start[!r_chunk], collapse = ", "))
    df <- df[r_chunk, ]
    if (nrow(df) == 0) stop("No valid R code chunk left")
    # get chunk text
    chunk_text <- lines[df$start] %>%
        stringr::str_remove("^```\\{r[ ]?") %>%
        stringr::str_remove("\\}[[:blank:]]{0,}$")
    # get chunk names
    chunk_names <- stringr::str_match(chunk_text, "^([^,])+")[, 1]
    # chunks with no name, no option will be ""
    chunk_names[is.na(chunk_names)] <- ""
    # chunks with no name but only options
    opt_only_chunk <- stringr::str_which(chunk_names, "=")
    opt_only_chunk_text <- chunk_names[opt_only_chunk]
    # safe to clean chunk names of chunks with no name but only options
    chunk_names[opt_only_chunk] <- ""
    # get opt string
    opt_text <- stringr::str_match(chunk_text, ",(.*)")[, 2] %>% stringr::str_remove("^[ ]{0,}")
    # preappend  no name but only options chunks options to other options
    opt_text[opt_only_chunk] <- paste0(opt_only_chunk_text, ", ", opt_text[opt_only_chunk])
    # clean ", " end options
    opt_text <- stringr::str_remove(opt_text, ",[[:blank:]]{0,}$")
    # clean empty options
    opt_text[is.na(opt_text)] <- ""
    # update chunk name
    df$step_name <- chunk_names
    df$opt_text <- opt_text
    # check eval
    if (verbose) message("Checking chunk eval values")
    opt_eval <- stringr::str_match(df$opt_text, "eval[ ]{0,}=[ ]{0,}(['\"]{0,1}\\w+['\"]{0,1})")[, 2]
    # eval unspecified will be TRUE
    opt_eval[is.na(opt_eval)] <- TRUE
    if (any(stringr::str_detect(opt_eval, "['\"]"))) {
        stop(
            "Line ",
            paste(df$start[stringr::str_detect(opt_eval, "['\"]")], collapse = ", "),
            " has a character value for `eval` option, only TRUE, T, FALSE, F are valid"
        )
    }
    opt_eval <- stringr::str_detect(opt_eval, "^TRUE|T")
    # overwrite if ignore eval param is TRUE
    if (ignore_eval) opt_eval <- rep(TRUE, length(opt_eval))
    ## update df
    if (verbose && any(!opt_eval)) message("Ignore chunks with 'eval' are FALSE or invalid values: ", paste0(df$start[!opt_eval], collapse = ", "))
    df <- df[opt_eval, ]
    if (nrow(df) == 0) stop("No evaluated code chunk detected")
    # get spr option
    if (verbose) message("Checking chunk SPR option")
    opt_spr <- stringr::str_match(df$opt_text, "spr[ ]{0,}=[ ]{0,}(\\w+)")[, 2] %>% stringr::str_detect("^TRUE|T")
    if (all(is.na(opt_spr))) stop("No valid SPR code chunk detected, remember to add `spr=TRUE` in chunk options")
    ## update df
    if (verbose && any(is.na(opt_spr))) message("Ignore non-SPR chunks: ", paste0(df$start[is.na(opt_spr)], collapse = ", "))
    # eval unspecified will be TRUE
    opt_spr[is.na(opt_spr)] <- FALSE
    df <- df[opt_spr, ]
    df$spr <- TRUE
    if (nrow(df) == 0) stop("No SPR code chunk left")
    if (verbose) message("Parse chunk code")
    code <- lapply(seq_along(df$start), function(x) {
        paste0(lines[(df$start[x] + 1):(df$end[x] - 1)], collapse = "\n")
    }) %>% unlist()
    df$code <- code
    # check if any
    if (verbose) message("Checking preprocess code for each step")
    df <- .getPreprotext(df, verbose)
    df
}


## Usage:
# rmdpath <- system.file("extdata", "spr_simple_wf.Rmd", package="systemPipeR")
# df <- parseRmd(rmdpath)


########################
## .getPreprotext function ##
########################
# get the preprocssing R code for each workflow step
# Preprocessing code is defined after SPR chunks and
# before the `###pre-end` line.
.getPreprotext <- function(df, verbose) {
    prepro_steps <- stringr::str_split(df$code, "\n") %>%
        lapply(function(x) {
            pre_pro_line <- stringr::str_which(x, "^###pre-end[ ]{0,}")
            pre_pro_line[length(pre_pro_line) == 0] <- 0
            pre_pro_line
        })
    prepro_dup <- lapply(prepro_steps, length) %>% unlist()
    if(any(prepro_dup > 1))
        stop("More than 1 preprocess delimitor `###pre-end` detected in SPR code chunk starting:",
             paste(df$start[prepro_dup[prepro_dup > 1]], collapse = " "))
    prepro_steps <- unlist(prepro_steps)
    if (verbose && sum(prepro_steps) == 0) message("No preprocessing code for SPR steps found")
    for(i in which(prepro_steps > 0)) {
        df$prepro_lines[i] <- stringr::str_split(df$code[i], "\n") %>%
            {.[[1]][1:prepro_steps[i]]} %>%
            paste0(collapse = "\n")
    }
    df
}

#######################################
## Visualize SPR workflow and status ##
#######################################
plotWF <- function(sysargs,
                   width = NULL, height = NULL,
                   elementId = NULL,
                   responsive = TRUE,
                   branch_method = "auto",
                   branch_no = NULL,
                   layout = "compact",
                   no_plot = FALSE,
                   plot_method = "svg",
                   out_format = "plot",
                   out_path = NULL,
                   show_legend = TRUE,
                   mark_main_branch = FALSE,
                   rstudio = FALSE,
                   in_log = FALSE,
                   rmarkdown = "detect",
                   verbose = FALSE,
                   show_warns = FALSE,
                   plot_ctr = TRUE,
                   pan_zoom = FALSE,
                   exit_point = 0) {
    if (!is.null(width)) stopifnot(is.character(width) && length(width) == 1)
    if (!is.null(height)) stopifnot(is.character(height) && length(height) == 1)
    stopifnot(is.logical(responsive) && length(responsive) == 1)
    stopifnot(is.logical(rstudio) && length(rstudio) == 1)
    stopifnot(is.logical(show_warns) && length(show_warns) == 1)
    stopifnot(is.logical(plot_ctr) && length(plot_ctr) == 1)
    stopifnot(is.logical(pan_zoom) && length(pan_zoom) == 1)
    stopifnot(is.character(rmarkdown) || is.logical(rmarkdown) && length(rmarkdown) == 1)
    out_format <- match.arg(out_format, c("plot", "html", "dot", "dot_print"))
    if (!out_format %in% c("plot", "dot_print")) stopifnot(is.character(out_path) && length(out_path) == 1)
    plot_method <- match.arg(plot_method, c("svg", "png"))
    plot_method <- switch(plot_method,
        "svg" = "renderSVGElement",
        "png" = "renderImageElement"
    )
    msg <- "" # additional msg to display on plot
    if (verbose) message("Converting SYSargsList to df...")
    if (inherits(sysargs, "data.frame")) {
        df <- sysargs
        if (!all(col_names <- c(
            "step_name", "dep", "spr", "req", "session", "has_run", "success",
            "sample_pass", "sample_warn", "sample_error",
            "sample_total", "log_path", "time_start", "time_end"
        ) %in%
            names(df))) {
            stop("If sysargs is a dataframe, it must contain these columns:\n", paste(col_names, collapse = ", "))
        }
        if (nrow(df) < 1) stop("plotWF: empty dataframe")
    } else if (inherits(sysargs, "SYSargsList")) {
        df <- .buildDF(sysargs)
        if (nrow(df) == 1 && df$step_name[1] == "Empty_workflow") {
            show_legend <- FALSE
            branch_method <- "auto"
        }
    } else {
        stop("`sysargs` can only be a dataframe or a SYSargsList object")
    }
    if (verbose) message("Translating to DOT format...")
    dot_vector <- makeDot(
        df, branch_method, branch_no, layout, show_legend,
        mark_main_branch, in_log, verbose, exit_point, msg,
        show_warns
    )
    dot <- dot_vector[1]
    msg <- dot_vector[2]
    dot <- gsub(x = dot, "'", "\"")
    # if exit point
    if (exit_point > 0) {
        return(dot)
    }
    # if dot or dot_print
    if (out_format == "dot") {
        return(writeLines(dot, out_path))
    }
    if (out_format == "dot_print") {
        return(cat(dot))
    }
    # Decide if in Rmarkdown rendering
    if (is.character(rmarkdown) && rmarkdown != "detect") stop("rmarkdown can only be 'detect', TRUE or FALSE")
    if (rmarkdown == "detect") rmarkdown <- isTRUE(getOption("knitr.in.progress"))
    legend_uri <- if (rmarkdown && show_legend) .addDotLegendUri() else ""
    # forward options using x
    if (verbose) message("Making the plot...")
    if (pan_zoom && responsive) {
        warning("Pan-zoom and responsive cannot be used together. Pan-zoom has priority, now `responsive` has set to FALSE")
        responsive <- FALSE
    }
    x <- list(
        dot = dot,
        plotid = paste0("sprwf-", paste0(sample(8), collapse = "")),
        responsive = responsive,
        width = width,
        height = height,
        plot_method = plot_method,
        rmd = rmarkdown,
        msg = msg,
        plot_ctr = plot_ctr,
        pan_zoom = pan_zoom,
        legend_uri = legend_uri
    )
    # create widget
    grviz <- htmlwidgets::createWidget(
        name = "plotwf",
        x,
        width = width,
        height = height,
        package = "systemPipeR",
        elementId = elementId
    )
    # if html out
    if (out_format == "html") {
        return(htmlwidgets::saveWidget(widget = grviz, file = out_path, selfcontained = TRUE))
    }
    if (no_plot) {
        return(invisible(grviz))
    }
    # force to open browser tab instead of viewer in Rstudio
    if ((!rstudio || Sys.getenv("RSTUDIO") != "1") && !rmarkdown) {
        viewer <- getOption("viewer")
        on.exit(options(viewer = viewer), add = TRUE)
        options(viewer = NULL)
        return(print(grviz))
    } else {
        return(grviz)
    }
}

##################
## plotwfOutput ##
##################
plotwfOutput <- function(outputId, width = "100%", height = "400px") {
    htmlwidgets::shinyWidgetOutput(outputId, "plotwf", width, height, package = "systemPipeR")
}

# NOTE: To use `plotWF` in `renderPlotwf` in Shiny apps, always turn on the option `rstudio = TRUE`.

##################
## renderPlotwf ##
##################
renderPlotwf <- function(expr, env = parent.frame(), quoted = FALSE) {
    if (!quoted) {
        expr <- substitute(expr)
    } # force quoted
    htmlwidgets::shinyRenderWidget(expr, plotwfOutput, env, quoted = TRUE)
}

#############
## makeDot ##
#############
#' Translate a workflow structure and status into a dot language string----
makeDot <- function(df,
                    branch_method = "auto",
                    branch_no = NULL,
                    layout = "compact",
                    show_legend = TRUE,
                    mark_main_branch = TRUE,
                    in_log = FALSE,
                    verbose = FALSE,
                    exit_point = 0,
                    msg = "",
                    show_warns = TRUE) {
    # check
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    stopifnot(is.logical(show_legend) && length(show_legend) == 1)
    if (verbose) message("Workflow inputs pre-checking ...")
    stopifnot(is.character(df$step_name))
    stopifnot(is.logical(in_log) && length(in_log) == 1)
    # early exit for linear method
    layout <- match.arg(layout, c("compact", "vertical", "horizontal", "execution"))
    if (layout == "execution") {
        return(.WFlinear(df, show_legend, in_log))
    }
    stopifnot(is.list(df$dep))
    lapply(seq_along(df$dep), function(i) {
        if (!is.character(df$dep[[i]])) stop("No.", i, " item in dep is not a character vector")
    })
    branch_method <- match.arg(branch_method, c("auto", "choose"))
    stopifnot(is.numeric(exit_point) && length(exit_point) == 1)
    # find all possible branches
    if (verbose) message("Looking for possible branches ...")
    step_names <- df$step_name
    deps <- df$dep
    if (sum(starting_root <- df$dep == "") > 1) {
        if (show_warns) {
            message(
                "More than 1 step has no dependency. They all will be treated as starting point:\n",
                paste0(names(df$dep)[starting_root], collapse = ", ")
            )
        }
        step_names <- c("root_step0", step_names)
        deps <- df$dep
        deps[starting_root] <- "root_step0"
        deps <- append(deps, list(root_step0 = ""), after = 0)
    }
    tree <- .findBranch(step_names, deps)
    if (sum(starting_root) > 1) tree <- lapply(tree, function(x) x[!x == "root_step0"])
    # debug exit point
    if (exit_point == 1) {
        return(tree)
    }
    if (branch_method == "choose" && interactive() && is.null(branch_no) || verbose) {
        # list all branches
        invisible(lapply(seq_along(tree), function(i) {
            cat(crayon::blue$bold("Possible branch"), i, ":\n")
            cat(paste0(tree[[i]], collapse = " -> "), "\n")
        }))
    }
    # choose branch
    if (!is.null(branch_no)) {
        stopifnot(is.numeric(branch_no) && length(branch_no) == 1)
        if (branch_no > length(tree)) stop("Branch number is larger than possible branches:", length(tree))
    } else if (branch_method == "choose" && interactive()) {
        branch_no <- as.numeric(menu(paste("Branch", seq_along(tree)), title = "Choose a main branch to plot workflow"))
    } else {
        branch_no <- .recommendBranch(tree, df$step_name, verbose, show_warns)
        branch_msg <- names(branch_no)[1]
        if (stringr::str_starts(branch_msg, "Workflow's first step is") && show_warns) {
            msg <- branch_msg
            # df <- df[df$step_name %in% tree[[branch_no]], ]
        }
    }
    if (verbose) message("Build the workflow tree ...")
    nodes <- .buildTree(tree, branch_no)
    if (exit_point == 2) {
        return(nodes)
    }
    # organize all node attach point
    node_attach <- unique(unlist(lapply(nodes, `[[`, "attach_point")))
    # organize all side branch
    node_side <- unique(unlist(lapply(nodes, `[[`, "branch_side")))
    # connecting the main branch
    branch_trans <- paste(tree[[branch_no]], collapse = " -> ")
    # translation
    trans_func <- switch(layout,
        "compact" = .WFcompact,
        "vertical" = .WFvert,
        "horizontal" = .WFhori
    )
    if (verbose) message("Translate tree  to DOT language...")
    # build the skeleton
    p_main <- trans_func(branch_trans, node_attach, node_side, mark_main_branch)
    if (exit_point == 3) {
        return(paste0(p_main, "\n}\n"))
    }
    # add node decoration
    p_main <- paste0(p_main, .addNodeDecor(
        df$step_name, df$status_summary, df$has_run, df$success, df$spr, df$sample_pass,
        df$sample_warn, df$sample_error, df$sample_total, df$log_path,
        df$time_start, df$time_end, df$req, df$session, in_log
    ))
    # add legend
    if (show_legend) p_main <- paste0(p_main, .addDotLegend(mark_main_branch), collapse = "\n")
    # close the plot
    # return plot and additional msg
    c(paste0(p_main, "\n}\n"), msg)
}

##################
## .findBranch ##
#################
.findBranch <- function(steps, deps, step_n = 1,
                        dep_chain = list(
                            root = steps[1]
                        ),
                        branch_name = "root") {
    if (step_n > length(steps)) {
        return(dep_chain)
    }
    current_step <- steps[step_n]
    # find steps depend on this step
    new_step_n <- lapply(deps, function(x) {
        current_step %in% x
    }) %>%
        unlist() %>%
        which()
    # cat(current_step, new_step_n, "\n")
    # make a backup if new branch need to be created
    if (length(new_step_n) > 1) deps_backup <- dep_chain[[branch_name]]
    # loop through these new steps to append dep chain
    for (i in seq_along(new_step_n)) {
        # if more than 1 dependent step, create a new branch
        if (i != 1) {
            # cat("branch step is: ", new_step_n[i], "\n")
            branch_name <- paste0(step_n, "_", new_step_n[i])
            dep_chain[[branch_name]] <- deps_backup
            # dep_chain[[as.character(chain_num)]][["branch_point"]] <- current_step
            # cat("chain no is: ", branch_name, "\n")
        }
        # cat("chain num is", chain_num, "\n")
        dep_chain[[branch_name]] <- c(dep_chain[[branch_name]], steps[new_step_n[i]])
        dep_chain <- .findBranch(steps, deps, new_step_n[i], dep_chain, branch_name)
    }
    dep_chain
}

######################
## .recommendBranch ##
######################
.recommendBranch <- function(tree, steps, verbose, show_warns) {
    branch_complete <- lapply(tree, function(x) {
        all(c(steps[1], steps[length(steps)]) %in% x)
    }) %>%
        unlist() %>%
        which()
    if (length(branch_complete) == 0) {
        msg <- "Workflow's first step is not connected to the last step, something wrong? This may cause workflow plot display issues"
        warning(msg)
        return(structure(c(1), .Names = msg))
    } else {
        if (verbose) cat("**********\n")
        if (verbose) {
            cat(
                "Find", length(branch_complete), "branch(es) connecting first and last step:",
                paste0(branch_complete, collapse = ", "),
                ".\n"
            )
        }
        tree_complete <- tree[branch_complete]
    }
    branch_len <- unlist(lapply(tree, length))
    branch_long <- which(branch_len == max(branch_len))
    if (verbose) cat("Find branch(es)", paste0(branch_long, collapse = ", "), ": with the largest number of steps", max(branch_len), "\n")
    branch_recommand <- base::intersect(branch_long, branch_complete)
    branch_recommand <- tree[branch_recommand %in% tree]
    # use first complete branch if no intersection
    if (length(branch_recommand) == 0) {
        branch_recommand <- branch_complete[1]
        # if still empty, use longest branch
        if (length(branch_recommand) == 0) {
            branch_recommand <- branch_long[1]
        }
    }
    if (verbose) cat("**********\n")
    if (verbose) cat("Based on the detection, branch(es):", paste0(branch_recommand, collapse = ", "), "is (are) recommended\n")
    if (verbose) cat("Branch", crayon::yellow$bold(branch_recommand[1]), "will be used as the main branch\n")
    return(branch_recommand[1])
}

################
## .buildTree ##
################
.buildTree <- function(tree, branch_no) {
    branch <- tree[[branch_no]]
    # reconstruct side branches based on the selected main branch
    lapply(tree[-branch_no], function(x) {
        # see if other branches has node in common with main branch
        in_main <- x %in% branch
        # find where these node need to attach to mian branch
        current_state <- in_main[1]
        attach_point <- c()
        for (i in seq_along(in_main)) {
            if (current_state != in_main[i]) {
                attach_point <- c(attach_point, paste(x[i - 1], "->", x[i]))
                current_state <- in_main[i]
            }
        }
        # find the chain of new side branches
        in_branch <- which(!in_main)
        branch_side <- list(x[in_branch[1]])
        list_pos <- 1
        for (i in seq_along(in_branch)) {
            if (i == 1) next
            if (in_branch[i] - in_branch[i - 1] == 1) {
                branch_side[[list_pos]] <- c(branch_side[[list_pos]], x[in_branch[i]])
            } else {
                list_pos <- list_pos + 1
                branch_side[[list_pos]] <- x[in_branch[i]]
            }
        }
        branch_side <- lapply(branch_side, function(branches) {
            nodes <- c()
            for (n in seq_along(branches)) {
                if (n >= length(branches)) next
                nodes <- c(nodes, paste(branches[n], branches[n + 1], sep = " -> "))
            }
            nodes
        })
        list(attach_point = attach_point, branch_side = branch_side)
    })
}

################
## .WFcompact ##
################
.WFcompact <- function(branch_trans, node_attach, node_side, mark_main_branch) {
    paste0(
        "digraph {
    node[fontsize=20];
    subgraph {\n    ",
        if (mark_main_branch) '    node[color="dodgerblue"];\n        ' else "    ",
        paste0(branch_trans, if (mark_main_branch) '[color="dodgerblue"]' else "", collapse = ""),
        "\n   }\n    ",
        paste0(node_attach, collapse = "\n    "),
        "\n    ",
        paste0(node_side, collapse = "\n    "),
        "\n"
    )
}

#############
## .WFvert ##
#############
.WFvert <- function(branch_trans, node_attach, node_side, mark_main_branch) {
    paste0(
        'digraph {
    node[fontsize=20];
    subgraph {
        rankdir="TB";\n        ',
        if (mark_main_branch) '    node[color="dodgerblue"];\n        ' else "    ",
        paste0(branch_trans, if (mark_main_branch) '[color="dodgerblue"]' else "", collapse = ""),
        "\n   }\n    ",
        paste0(
            "subgraph {\n",
            '        rank="same";\n',
            "        ",
            node_attach,
            "\n    }\n"
        ) %>%
            paste0(collapse = "\n    "),
        "\n    ",
        paste0(node_side, collapse = "\n    "),
        "\n"
    )
}

#############
## .WFhori ##
#############
.WFhori <- function(branch_trans, node_attach, node_side, mark_main_branch) {
    paste0(
        'digraph {
    node[fontsize=20];
    subgraph {
        rank="same";\n                ',
        if (mark_main_branch) '    node[color="dodgerblue"];\n        ' else "    ",
        paste0(branch_trans, if (mark_main_branch) '[color="dodgerblue"]' else "", collapse = ""),
        "\n   }\n    ",
        paste0(
            "subgraph {\n",
            '        rankdir="TB";\n',
            "        ",
            node_attach,
            "\n    }\n"
        ) %>%
            paste0(collapse = "\n    "),
        "\n    ",
        paste0(node_side, collapse = "\n    "),
        "\n"
    )
}

###############
## .WFlinear ##
###############
.WFlinear <- function(df, show_legend, in_log) {
    steps_trans <- paste0(df$step_name, collapse = " -> ")
    paste0(
        'digraph {
    node[fontsize=20];
    subgraph {
        rank="TB";\n        ',
        steps_trans,
        "\n   }\n",
        .addNodeDecor(
            df$step_name, df$status_summary, df$has_run, df$success, df$spr, df$sample_pass,
            df$sample_warn, df$sample_error, df$sample_total, df$log_path,
            df$time_start, df$time_end, df$req, df$session, in_log
        ),
        if (show_legend) .addDotLegend(FALSE),
        "\n}\n"
    )
}

###################
## .addDotLegend ##
###################
.addDotLegend <- function(show_main = TRUE) {
    paste0(
        '        subgraph cluster_legend {
        rankdir=TB;
        color="#eeeeee";
        style=filled;
        ranksep =1;
        label="Legends";
        fontsize = 30;
        node [style=filled, fontsize=10];
        legend_img-> step_state[color="#eeeeee"];

        legend_img[shape=none, image="plotwf_legend-src.png", label = " ", height=1, width=3, style=""];

        step_state[style="filled", shape="box" color=white, label =<
            <table>
            <tr><td><b>Step Colors</b></td></tr>
            <tr><td><font color="black">Pending steps</font>; <font color="#5cb85c">Successful steps</font>; <font color="#d9534f">Failed steps</font></td></tr>
            <tr><td><b>Targets Files / Code Chunk </b></td></tr><tr><td><font color="#5cb85c">0 (pass) </font> | <font color="#f0ad4e">0 (warning) </font> | <font color="#d9534f">0 (error) </font> | <font color="blue">0 (total)</font>; Duration</td></tr></table>
            >];

    }\n'
    )
}

######################
## .addDotLegendUri ##
######################
.addDotLegendUri <- function() {
    # to update the URI, run
    # paste0("data:image/svg+xml;base64,", base64enc::base64encode("inst/htmlwidgets/plotwf_legend.svg"))
    "data:image/svg+xml;base64,[encoded data, 23764 characters]"
}

###################
## .addNodeDecor ##
###################
.addNodeDecor <- function(steps, status_summary, has_run, success, spr, sample_pass, sample_warn,
                          sample_error, sample_total, log_path, time_start, time_end,
                          req, session, in_log = FALSE) {
    node_text <- c()
    for (i in seq_along(steps)) {
        step_color <- switch(status_summary[i],
            "Success" = "#5cb85c",
            "Warning" = "#f0ad4e",
            "Error" = "#d9534f",
            "black"
        )
        duration <- .stepDuration(steps[i], time_start[i], time_end[i])
        node_text <- c(node_text, paste0(
            "    ", steps[i], "[",
            if (req[i] == "mandatory") 'fillcolor="#d3d6eb" ' else "",
            if (req[i] == "mandatory" && session[i] == "compute") {
                'style="filled, dashed, '
            } else if (req[i] == "mandatory" && session[i] != "compute") {
                'style="filled, '
            } else if (req[i] != "mandatory" && session[i] == "compute") {
                'style="dashed, '
            } else {
                'style="solid, '
            },
            if (spr[i] == "sysargs") 'rounded" ' else '"',
            "label=<<b>",
            '<font color="', step_color, '">', steps[i], "</font><br></br>",
            '<font color="#5cb85c">', sample_pass[i], "</font>/",
            '<font color="#f0ad4e">', sample_warn[i], "</font>/",
            '<font color="#d9534f">', sample_error[i], "</font>/",
            '<font color="blue">', sample_total[i], "</font></b>; ",
            '<font color="black">', duration$short, "</font>",
            "> ",
            if (spr[i] == "sysargs") ', shape="box" ' else "",
            if (in_log) paste0('href="', log_path[i], '" ') else " ",
            'tooltip="step ', steps[i], ": ",
            sample_pass[i], " samples passed; ",
            sample_warn[i], " samples have warnings; ",
            sample_error[i], " samples have errors; ",
            sample_total[i], " samples in total; ",
            "Start time: ", time_start[i], "; ",
            "End time: ", time_end[i], "; ",
            "Duration: ", duration$long,
            '"',
            "]\n"
        ))
    }
    paste0(node_text, collapse = "")
}

###################
## .stepDuration ##
###################
.stepDuration <- function(step, start, end) {
    duration <- round(as.numeric(difftime(end, start, units = "sec")), 1)
    if (duration < 0) {
        duration <- 0
        warning(
            "In step: ", step, "\n",
            "Starting time: ", start, "\n",
            "Ending time: ", end, "\n",
            "Ending time is before starting time, something wrong?\n",
            "Duration of this step is treated as 0 for now.",
            immediate. = TRUE,
            call. = FALSE
        )
    }
    secs <- duration %% 60
    mins_raw <- duration %/% 60
    mins <- mins_raw %% 60
    hrs <- mins_raw %/% 60
    return(list(
        long = paste(stringr::str_pad(hrs, 2, pad = "0"), stringr::str_pad(mins, 2, pad = "0"), stringr::str_pad(secs, 2, pad = "0"), sep = ":"),
        short = if (hrs > 0) paste0(hrs, "h") else if (mins > 0) paste0(mins, "m") else paste0(secs, "s")
    ))
}

###################
## .buildDF ##
###################
.buildDF <- function(sal) {
    sal_temp <- sal
    if (length(sal_temp) == 0) {
        warning("Workflow has no steps. Please make sure to add a step to the workflow before plotting.", call. = FALSE)
        return_df <- data.frame(
            step_name = "Empty_workflow",
            dep = NA,
            spr = "sysargs",
            req = "mandatory",
            session = "management",
            has_run = FALSE,
            success = FALSE,
            sample_pass = 0,
            sample_warn = 0,
            sample_error = 0,
            sample_total = 0,
            log_path = "",
            time_start = Sys.time(),
            time_end = Sys.time()
        )
        return_df$dep <- list("")
        return(return_df)
    }
    df <- data.frame(step_name = stepName(sal_temp))
    dep <- dependency(sal_temp)
    for (i in seq_along(dep)) {
        if (any(is.na(dep[i]))) {
            dep[[i]] <- ""
        }
    }
    df$dep <- dep
    df$spr <- ifelse(sapply(df$step_name, function(x) inherits(stepsWF(sal_temp)[[x]], "SYSargs2")), "sysargs", "r")
    df$req <- sapply(df$step_name, function(x) sal_temp$runInfo$runOption[[x]]$run_step)
    df$session <- sapply(df$step_name, function(x) sal_temp$runInfo$runOption[[x]]$run_session)
    df$status_summary <- sapply(df$step_name, function(x) sal_temp$statusWF[[x]]$status.summary)
    df$has_run <- ifelse(!sapply(df$step_name, function(x) sal_temp$statusWF[[x]]$status.summary) == "Pending", TRUE, FALSE)
    df$success <- ifelse(sapply(df$step_name, function(x) sal_temp$statusWF[[x]]$status.summary) == "Success", TRUE, FALSE)
    df <- cbind(df, data.frame(
        sample_pass = 0,
        sample_warn = 0,
        sample_error = 0,
        sample_total = 0,
        time_start = Sys.time(),
        time_end = Sys.time()
    ))
    for (i in seq_along(df$step_name)) {
        if (inherits(stepsWF(sal_temp)[[i]], "SYSargs2")) {
            sample_df <- as.list(colSums(sal_temp$statusWF[[i]][[2]][2:4]))
            df$sample_pass[i] <- sample_df$Existing_Files
            df$sample_total[i] <- sample_df$Total_Files
            if (all(sample_df$Missing_Files > 0 && sal_temp$statusWF[[i]]$status.summary == "Warning")) {
                df$sample_warn[i] <- sample_df$Missing_Files
            } else if (all(sample_df$Missing_Files > 0 && sal_temp$statusWF[[i]]$status.summary == "Error")) {
                df$sample_error[i] <- sample_df$Missing_Files
            }
            if (!is.null(sal_temp$statusWF[[i]]$total.time)) {
                df$time_start[i] <- sal_temp$statusWF[[i]]$total.time$time_start
                df$time_end[i] <- sal_temp$statusWF[[i]]$total.time$time_end
            }
        } else if (inherits(stepsWF(sal_temp)[[i]], "LineWise")) {
            df$sample_total[i] <- 1
            if (sal_temp$statusWF[[i]]$status.summary == "Success") {
                df$sample_pass[i] <- 1
            } else if (sal_temp$statusWF[[i]]$status.summary == "Warning") {
                df$sample_warn[i] <- 1
            } else if (sal_temp$statusWF[[i]]$status.summary == "Error") {
                df$sample_error[i] <- 1
            }
            if (length(sal_temp$statusWF[[i]]$status.time) > 0) {
                df$time_start[i] <- sal_temp$statusWF[[i]]$total.time$time_start
                df$time_end[i] <- sal_temp$statusWF[[i]]$total.time$time_end
            }
        }
    }
    df$log_path <- paste0("#", tolower(df$step_name))
    df <- rbind(df[which(df$dep == ""), ], df[which(!df$dep == ""), ])
    return(df)
}

############################
## ## Version 2 Functions  ##
############################

############# Exports ###########

# createParam2 # the same as createParam

printParam2 <- function(
        sysargs,
        base = FALSE, args = FALSE, inputs = FALSE,
        outputs = FALSE, stdout = FALSE, raw_cmd = FALSE, all = TRUE
    ) {
    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v1")) stop("input sysargs built on syntax version 1, please use `printParam")
    .catCmdAll2(
        obj, base = base, args = args, inputs = inputs,
        outputs = outputs, stdout = stdout, raw_cmd = raw_cmd, all = all
    )
}

appendParam2 <- function(
        sysargs, x,
        position = c("inputs", "args", "outputs"),
        after = NULL,
        verbose = FALSE
    ) {
    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v1")) stop("input sysargs built on syntax version 1, please use `appendParam`")
    .cmdAppend2(
        obj, x = x,
        position = position,
        after = after,
        verbose = verbose
    )
}

replaceParam2 <- function(
        sysargs, x, index=NULL,
        position = c("inputs", "baseCommand", "args", "outputs", "stdout"),
        verbose = FALSE
    ) {
    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v1")) stop("input sysargs built on syntax version 1, please use `replaceParam`")
    .cmdReplace2(
        obj, x = x,
        index=index,
        position = position,
        verbose = verbose
    )
}

removeParam2 <- function(
        sysargs, index=NULL,
        position = c("inputs", "args", "outputs", "stdout"),
        verbose = FALSE
    ) {
    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v1")) stop("input sysargs built on syntax version 1, please use `subsetParam`")

    .cmdRemove2(
        obj, index=index,
        position = position,
        verbose = verbose
    )
}


renameParam2 <- function(
        sysargs, index=NULL,
        new_names,
        position = c("inputs", "args", "outputs", "stdout"),
        verbose = FALSE
        ) {
    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v1")) stop("input sysargs built on syntax version 1, please use `renameParam`")
    .cmdRename2(
        obj, index=index,
        new_names = new_names,
        position = position,
        verbose = verbose
    )
}

############# Internal ###########
## actual cmd
# mycmd \
#     -s sample1.txt \
#     -s sample2.txt \
#     --c \
#     -o myout.txt \
#     a.fasta \
#     --n mouse \
#     > abc.txt

## format ##
# mycmd \                                   -> base command
# p: prefixx;     ;                       \ -> args
# p: prefixx; type; default_value         \ -> inpputs
# name      ; type; default_value         \ -> inpputs no prefix
# p: prefixx; type; out: default_value    \ -> inpputs, outputs
# name      ; type; default_value         \ -> inpputs
# name      ; type; stdout: default_value   -> stdout

# 1. Each line specifies one argument and its default value.
# 2. text before first `;` will be will used as prefix/names. If it starts with
#    keyword "p:", anything after "p:" and before the first `;` will be used as
#    prefix, and the name of this position will be the prefix but with leading
#    dash(s) '-', '--' removed. If there is any duplication, a number index will be
#    added to the end.
# 3. If there is no keyword "p:" before first `;`, all text before first `;` will
#    the name.
# 4. If there is  keyword "p:" before first `;` but nothing before and after the second `;`,
#    this position will be treated as CWL argument instead of input.
# 5. Text between first and second `;` is type. Must be one of  File, Directory, string,
#    int, double, float, long, boolean.
# 6. Text after second `;` and before `\` or end of the line is the default value. If it starts with
#    keywrod "out" or "stdout", this position will also be added to outputs or
#    standard output.
# 7. There is only 1 position with "stdout" allowed and usually it is the last position.
# 8. Ending with "\" is recommended but not required.
##### Test code
# cmd <- '
# mycmd \
#     p: -s; File; sample1.txt \
#     p: -s; File; sample2.txt \
#     p: --c; ; \
#     p: -o; File; out: myout.txt \
#     ref_genome; File; a.fasta \
#     p: --n; string; mouse \
#     mystdout; File; stdout: abc.txt
# '
# library(magrittr)
# cmd <- '
# mycmd \
#     p: -s; File; sample1.txt \
#     p: -s; File; sample2.txt \
#     p: --c; ; \
#     p: -o; File; out: myout.txt \
#     ref_genome; File; a.fasta \
#     p: --n; string; mouse \
#     mystdout; File; stdout: abc.txt
# '
# parsed <- .cmd2cwl2(cmd)
# .catCmdAll2(parsed)
#
# cmd <- ' p: -s; File; sample1.txt'

#' @param cmd_str length 1 commandline string.
#' @param verbose bool
#' @return `cmdParse` object
.cmd2cwl2 <- function(cmd_str, verbose = TRUE) {
    stopifnot(is.character(cmd_str) && length(cmd_str) == 1)
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    cmd_lines <- stringr::str_split(cmd_str, "\n", simplify = TRUE) %>% # split args by line
        stringr::str_remove_all("^[ ]+") %>% # remove all leading, ending spaces
        stringr::str_remove_all("[ ]+$")
    # remove empty lines
    cmd_lines <- cmd_lines[cmd_lines != ""]
    cmd_base <- cmd_lines[1]
    cmd_lines <- cmd_lines[-1]
    # split by ; and remove all leading/ending spaces
    cmd_split <- stringr::str_split(cmd_lines, ";") %>%
        lapply(stringr::str_remove_all, "^[ ]{0,}") %>%
        lapply(stringr::str_remove_all, "[ ]{0,}$")
    valid_types <- c("File", "Directory", "string", "int", "double", "float", "long", "boolean")
    cmd_types <- lapply(seq_along(cmd_split), function(x){
        if(length(cmd_split[[x]]) != 3) stop("Each param line needs to have exact 2 ';' to separate prefix/name with type and value. Error in:\n", cmd_lines[[x]])
        has_pre_name <- cmd_split[[x]][1] != ""
        has_type <-  cmd_split[[x]][2] != ""
        has_value <-  cmd_split[[x]][3] != ""
        is_out <- stringr::str_detect(cmd_split[[x]][3], "^out:")
        is_stdout <- stringr::str_detect(cmd_split[[x]][3], "^stdout:")
        if(has_pre_name && !has_type && !has_value) return("arg")
        if(!has_type && has_value) stop(cmd_lines[[x]], ": If default value is provided, type must be provided as well.")
        if(!cmd_split[[x]][2] %in% valid_types) stop("Input, output require a valid type, should be one of:\n", paste(valid_types, collapse = ", "))
        if(is_stdout) {
            if(stringr::str_detect( cmd_split[[x]][1], "^p:")) stop("standard out cannot have prefix")
            return("stdout")
        }
        if(is_out) return("out")
        return("input")
    }) %>% unlist()
    cmd_split <- mapply(x = cmd_split, i = seq_along(cmd_split), FUN = function(x, i) c(x, i), SIMPLIFY = FALSE)
    cmd_input <- cmd_split[cmd_types %in% c("input", "out")]
    cmd_arg <- cmd_split[cmd_types == "arg"]
    cmd_out <- cmd_split[cmd_types == "out"]
    cmd_stdout <- cmd_split[cmd_types == "stdout"]
    if(length(cmd_stdout) > 1) stop("You can only have one standard out")

    # arguments
    args <- lapply(cmd_arg, function(x){
        preF <- if(stringr::str_detect(x[1], "^p:")) stringr::str_remove(x[1], "^p:[ ]{0,}") %>% .removeSpaces2()
        else stop("command with no type and value will be arguments and must have prefix.")
        list(preF = preF, index = x[4])
    })
    if(length(args)) names(args) <- paste0("argument", seq(length(args)))
    # inputs
    inputs <<- lapply(cmd_input, function(x){
        preF <- if(stringr::str_detect(x[1], "^[ ]{0,}p:")) stringr::str_remove(x[1], "^[ ]{0,}p:") %>% .removeSpaces2() else ""
        list(
            preF = preF,
            arg_name =  if(preF != "") stringr::str_remove(preF, "^[-]{0,}") else x[1] %>% .removeSpaces2(),
            type = x[2] %>% .removeSpaces2(),
            value = stringr::str_remove(x[3], "^out:[ ]{0,}") %>% .removeSpaces2(),
            index = x[4]
        )
    })
    if(length(inputs)){
        input_names <- lapply(inputs, `[[`, 'arg_name') %>% unlist()
        inputs <- lapply(inputs, `[`, c('preF', 'type', 'value', 'index'))
        # fix dup names
        input_names <- ave(
            input_names, input_names,
            FUN=function(i) if (length(i) > 1) paste0(i[1], seq_along(i)) else i[1])
        names(inputs) <- input_names
    }
    # outputs
    outputs <- lapply(cmd_out, function(x) list(
        type = x[2] %>% .removeSpaces2(),
        value = stringr::str_remove(x[3], "^out:[ ]{0,}") %>% .removeSpaces2()
    ))
    if(length(outputs)) names(outputs) <- paste0("output", seq(length(outputs)))
    # stdout
    stdout <- if(length(cmd_stdout)) list(list(
        type = cmd_stdout[[1]][2] %>% .removeSpaces2(),
        value = stringr::str_remove(cmd_stdout[[1]][3], "^stdout:[ ]{0,}") %>% .removeSpaces2()
    )) else list()
    if(length(stdout)) names(stdout) <- cmd_stdout[[1]][1]
    commandline <- structure(list(baseCommand = cmd_base, args = args, inputs = inputs, outputs = outputs, stdout = stdout), class = c("list", "cwlParse", "v2"))
    if (verbose) .catCmdAll2(commandline)
    invisible(commandline)
}

## appending methods

##


#' @param cmd `cmdParse` object
#' @param x either a list of values of a param or a length 1 character string
#' which can be translated to the param structure.
#' @param position one of "inputs", "args", "outputs"
#' @param after numeric, where to append the new param, default is after all current params in
#' the `position` selected, `0` means before all current params.
#' @param verbose bool, verbose mode
#' @return `cmdParse` object
#' @details
#' different position has different requirements for the `x`
#' #### List format
#' inputs position require the list contains following items:
#' "name", "preF", "type", "value", "index".
#' args position require the list contains following items:
#' "name", "preF", "index".
#' outputs position require the list contains following items:
#' "name", "type", "value".
#'
#' #### String format
#' Please follow this format, append and replace methods
#' needs 3 semi-colons to separate 4 columns.
#'
#' p: prefixx;     ;                      ; index  -> args
#' p: prefixx; type; default_value        ; index  -> inputs
#' name      ; type; default_value        ; index  -> inputs
#' p: prefixx; type; out: default_value   ; index  -> outputs
#' name      ; type; out: default_value   ; index  -> outputs
.cmdAppend2 <- function(
        cmd, x,
        position = c("inputs", "args", "outputs"),
        after = NULL,
        verbose = FALSE
){
    position <- match.arg(position, c("inputs", "args", "outputs"))
    if (!inherits(cmd, "cwlParse"))  stop("Expecting a 'cwlParse' object")
    if(!is.null(after)) stopifnot(is.numeric(after) && length(after) == 1)
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    # find append index
    after <- if(is.null(after)) length(cmd[[position]]) else {
        if(length(after) > 1) stop("`after` can only be one number")
        as.integer(after)
    }
    # parse string or check list type, names
    if(is.character(x)) {
        x <- .parseInstr2(x, verbose) %>% .checkInstr2(position, cmd, check_dup = TRUE, verbose)
    } else if (is.list(x)) {
        x <- .checkInlist2(x, position, cmd, check_dup = TRUE, verbose)
    } else stop("x can only be a length 1 character string or a list")
    # build required list
    new_list <- .buildInlist2(x, position, verbose)
    # append the list
    if(verbose) message("Appnding to the ", after + 1, "th position in the list")
    cmd[[position]] <- append(cmd[[position]], new_list, after = after)
    if(verbose) .catCmdAll2(cmd)
    if(position == "outputs") message("Note: New output appended. However, outputs are often come in pairs with inputs. ",
                                      "Make sure the corresponding input is there, or append it.")
    invisible(cmd)
}

#' @param cmd `cmdParse` object
#' @param x either a list of values of a param or a length 1 character string
#' which can be translated to the param structure.
#' @param position one of "baseCommand","inputs", "args", "outputs", "stdout"
#' @param index numeric or character, where or the name to replace the new param
#' @param verbose bool, verbose mode
#' @return `cmdParse` object
#' @details
#' different position has different requirements for the `x`
#' #### List format
#' inputs position require the list contains following items:
#' "name", "preF", "type", "value", "index".
#' args position require the list contains following items:
#' "name", "preF", "index".
#' outputs position require the list contains following items:
#' "name", "type", "value".#
#' stdout position require the list contains following items:
#' "name", "type", "value".
#' baseCommand is **not supported** to use list
#'
#' #### String format
#' Please follow this format, append and replace methods
#' needs 3 semi-colons to separate 4 columns.
#' ""
#' p: prefixx;     ;                      ; index  -> args
#' p: prefixx; type; default_value        ; index  -> inputs
#' name      ; type; default_value        ; index  -> inputs
#' p: prefixx; type; out: default_value   ; index  -> outputs
#' name      ; type; out: default_value   ; index  -> outputs
#' name      ; type; stdout: default_value; index  -> stdout
.cmdReplace2 <- function(
        cmd, x, index=NULL,
        position = c("inputs", "baseCommand", "args", "outputs", "stdout"),
        verbose = FALSE
){
    # assertions
    position <- match.arg(position,  c("inputs", "baseCommand", "args", "outputs", "stdout"))
    if(position == "baseCommand") {
        stopifnot(is.character(x) && length(x) == 1)
        cmd$baseCommand <- x
        if(verbose) .catCmdAll2(cmd, base = TRUE, raw_cmd = TRUE, all = FALSE)
        return(cmd)
    }
    if (!inherits(cmd, "cwlParse"))  stop("Expecting a 'cwlParse' object")
    if(!(is.numeric(index) || is.character(index)) || length(index) != 1)
        stop("Index must be a single integer or a character name to indicate the name of param to replace.")
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    # find the position
    if(cmd[[position]][index] %>% names() %>% is.na()) {
        stop("Cannot find index '", index, "' at position ", position)
    }
    # parse string or check list type, names
    if(is.character(x)) {
        x <- .parseInstr2(x, verbose) %>% .checkInstr2(position, cmd, check_dup = TRUE, verbose)
    } else if (is.list(x)) {
        x <- .checkInlist2(x, position, cmd, check_dup = TRUE, verbose)
    } else stop("x can only be a length 1 character string or a list")
    # build required list
    new_list <- .buildInlist2(x, position, verbose)

    if(verbose) message("Replacing to the ", index, " at position ", position)
    pos_names <- names(cmd[[position]])
    after <- which(names(cmd[[position]][index]) %in% pos_names)
    cmd[[position]] <- append(cmd[[position]], new_list, after = after)
    cmd[[position]][index] <-  NULL
    if(verbose) .catCmdAll2(cmd)
    if(position == "outputs") message("Note: New output replaced. However, outputs are often come in pairs with inputs. ",
                                      "Make sure the corresponding input is also updated.")
    invisible(cmd)
}



#' @param cmd `cmdParse` object
#' @param index numeric or character vector, where or the name(s) of param(s) to remove
#' @param position one of "inputs", "args", "outputs", "stdout"
#' @param verbose bool, verbose mode
#' @return `cmdParse` object
.cmdRemove2 <- function(
        cmd, index=NULL,
        position = c("inputs", "args", "outputs", "stdout"),
        verbose = FALSE
){
    # assertions
    position <- match.arg(position,  c("inputs", "args", "outputs", "stdout"))
    if (!inherits(cmd, "cwlParse"))  stop("Expecting a 'cwlParse' object")
    if(!(is.numeric(index) || is.character(index)))
        stop("Index must be integer(s) or a character name(s) to indicate the name of param to remove.")
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    # find the position
    if(cmd[[position]][index] %>% names() %>% is.na() %>% any()) {
        stop("Cannot find at least one of the indices '", index, "' at position ", position)
    }
    # parse string or check list type, names
    if(verbose) message("Remove the ", index, " at position ", position)
    cmd[[position]][index] <-  NULL
    if(verbose) .catCmdAll2(cmd)
    invisible(cmd)
}

#' @param cmd `cmdParse` object
#' @param index numeric or character vector, where or the name(s) of param(s) to remove
#' @param new_names character vector, new names to rename, must be equal length with `index`
#' @param position one of "inputs", "args", "outputs", "stdout"
#' @param verbose bool, verbose mode
#' @return `cmdParse` object
.cmdRename2 <- function(
        cmd, index=NULL,
        new_names,
        position = c("inputs", "args", "outputs", "stdout"),
        verbose = FALSE
){
    # assertions
    position <- match.arg(position,  c("inputs", "args", "outputs", "stdout"))
    if (!inherits(cmd, "cwlParse"))  stop("Expecting a 'cwlParse' object")
    if(length(index) != length(new_names)) stop("new names must be equal length with `index`")
    if(!(is.numeric(index) || is.character(index)))
        stop("Index must be integer(s) or a character name(s) to indicate the name of param to remove.")
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    if(length(unique(new_names)) != length(new_names)) stop("All values in `new_names` must be unique")
    if(any(new_names %in% .getAllCmdNames2(cmd))) stop("At least one of the new names exists in current param names, try different names.")
    # find the position
    if(cmd[[position]][index] %>% names() %>% is.na() %>% any()) {
        stop("Cannot find at least one of the indices '", index, "' at position ", position)
    }
    # parse string or check list type, names
    if(verbose) message("Rename the ", index, " at position ", position)
    pos_names <- names(cmd[[position]])
    index_names <- names(cmd[[position]][index])
    for(i in seq_along(index_names)) {
        pos_names[pos_names == index_names[i]] <- new_names[i]
    }
    names(cmd[[position]]) <- pos_names
    if(verbose) .catCmdAll2(cmd)
    invisible(cmd)
}

## New param list format parser and checker
.buildInlist2 <- function(x, position, verbose = FALSE) {
    return(switch(position,
                  "args" = {
                      cmd_list <- list()
                      cmd_list[[x$name]] <- list(preF = x$preF, index = x$index)
                      cmd_list
                  },
                  "inputs" = {
                      cmd_list <- list()
                      cmd_list[[x$name]] <- list(preF = x$preF, type = x$type, value = x$value, index = x$index)
                      cmd_list
                  },
                  "outputs" = {
                      cmd_list <- list()
                      cmd_list[[x$name]] <- list(type = x$type, value = x$value)
                      cmd_list
                  },
                  "stdout" = {
                      cmd_list <- list()
                      cmd_list[[x$name]] <- list(type = x$type, value = x$value)
                      cmd_list
                  }
    ))
}
.checkInlist2 <- function(x, position, cmd, check_dup = FALSE, verbose = FALSE) {
    if (verbose) message("Detected the input to be a list, checking items in the list...")
    lapply(x[[1]], function(i) {
        if(length(i) != 1 || !is.character(i)) stop("Each item in new param list must be a length 1 character string.")
    })
    cmd_names <- names(x)
    switch(position,
           "args" = {
               if(!all(c("name", "preF", "index") %in% cmd_names))
                   stop('"name", "preF", "index" are required for argument position')
           },
           "inputs" = {
               if(!all(c("name", "preF", "type", "value", "index") %in% cmd_names))
                   stop('"name", "preF", "type", "value", "index" are required for input position')
           },
           "outputs" = {
               if(!all(c("name", "type", "value") %in% cmd_names))
                   stop('"name", "type", "value" are required for output position')
           },
           "stdout" = {
               if(!all(c("name", "type", "value") %in% cmd_names))
                   stop('"name", "type", "value" are required for standard out position')
           }
    )
    if(!check_dup) return()
    pos_names <- names(cmd[[position]])
    if(x$name %in% .getAllCmdNames2(cmd)) {
        new_name <- paste0(c(x$name, "_", sample(c(seq(9), letters), 3)), collapse = "")
        message("Param name ", x$name, " exists, it will be renamed to: ", new_name)
        x$name <- new_name
    }
    x
}

## New param string format parser and checkers
.parseInstr2 <- function(x, verbose=FALSE) {
    cmd_lines <- stringr::str_split(x, "\n", simplify = TRUE) %>% # split args by line
        stringr::str_remove_all("^[ ]+") %>% # remove all leading, ending spaces
        stringr::str_remove_all("[ ]+$")
    if(length(cmd_lines) > 1) stop("Only one new command can be modified or added a time")
    # split by ; and remove all leading/ending spaces
    cmd_split <- stringr::str_split(cmd_lines, ";") %>%
        lapply(stringr::str_remove_all, "^[ ]{0,}") %>%
        lapply(stringr::str_remove_all, "[ ]{0,}$")
    cmd_split <- cmd_split[[1]]

    valid_types <- c("File", "Directory", "string", "int", "double", "float", "long", "boolean")
    cmd_type <- (function(){
        if(length(cmd_split) != 4) stop("New param line needs to have exact 3 ';' to separate prefix/name, type, value, and index. Error in:\n", cmd_lines)
        has_pre_name <- cmd_split[1] != ""
        has_type <-  cmd_split[2] != ""
        has_value <-  cmd_split[3] != ""
        is_out <- stringr::str_detect(cmd_split[3], "^out:")
        is_stdout <- stringr::str_detect(cmd_split[3], "^stdout:")
        if(has_pre_name && !has_type && !has_value) return("arg")
        if(!has_type && has_value) stop(cmd_lines, ": If default value is provided, type must be provided as well.")
        if(!cmd_split[2] %in% valid_types) stop("Input, output require a valid type, should be one of:\n", paste(valid_types, collapse = ", "))
        if(is_stdout) {
            if(stringr::str_detect( cmd_split[1], "^p:")) stop("standard out cannot have prefix")
            return("stdout")
        }
        if(is_out) return("out")
        return("input")
    })()
    if(verbose) message("Detected type is: ", cmd_type)

    switch(cmd_type,
           'arg' = {
               preF <- if(stringr::str_detect(cmd_split[1], "^p:")) stringr::str_remove(cmd_split[1], "^p:[ ]{0,}") %>% .removeSpaces2()
               else stop("New string is detected to be commandline argument type, but it has noe prefix, not allowed")
               arg_name <- if(preF != "") stringr::str_remove(preF, "^[-]{0,}") %>% .removeSpaces2()
               else cmd_split[1] %>% .removeSpaces2()
               list(
                   pos = "arg", name = arg_name, preF = preF,
                   index = if(!is.na(cmd_split[4])) cmd_split[4] %>% .removeSpaces2()
                   else stop("Index required for argument param but not found in the string.")
               )
           },
           'input' = {
               preF <- if(stringr::str_detect(cmd_split[1], "^p:")) stringr::str_remove(cmd_split[1], "^p:[ ]{0,}") %>% .removeSpaces2() else ""
               arg_name <- if(preF != "") stringr::str_remove(preF, "^[-]{0,}") %>% .removeSpaces2()
               else cmd_split[1] %>% .removeSpaces2()
               list(
                   pos = "input", name = arg_name,
                   preF = preF, type = cmd_split[2] %>% .removeSpaces2(),
                   index = if(!is.na(cmd_split[4])) cmd_split[4] %>% .removeSpaces2()
                   else stop("Index required for input param but not found in the string."),
                   value = stringr::str_remove(cmd_split[3], "^out:[ ]{0,}") %>% .removeSpaces2()
               )
           },
           'out' = list(
               pos = "out", name = if(!is.na(cmd_split[1])) cmd_split[1] %>% .removeSpaces2() else "",
               type = cmd_split[2] %>% .removeSpaces2(),
               value = stringr::str_remove(cmd_split[3], "^out:[ ]{0,}") %>% .removeSpaces2()
           ),
           'stdout' = list(
               pos = "stdout", name = if(!is.na(cmd_split[1])) cmd_split[1] %>% .removeSpaces2() else "",
               type = cmd_split[2] %>% .removeSpaces2(),
               value = stringr::str_remove(cmd_split[3], "^stdout:[ ]{0,}") %>% .removeSpaces2()
           )
    )
}
.checkInstr2 <- function(x, position, cmd, check_dup = FALSE, verbose = FALSE) {
    cmd_pos <- x$pos
    position <- switch(position,
                       "inputs" = "input",
                       "args" = "arg",
                       "outputs" = "out",
                       "stdout" = "stdout",
                       position
    )
    if(cmd_pos != position) stop("The parsed param string is good for ",
                                 cmd_pos,
                                 " position, but the position you have provided is ",
                                 position)
    if(!check_dup) return()
    pos_names <- names(cmd[[position]])
    if(x$name %in% .getAllCmdNames2(cmd)) {
        new_name <- paste0(c(x$name, "_", sample(c(seq(9), letters), 3)), collapse = "")
        message("Param name ", x$name, " exists, it will be renamed to: ", new_name)
        x$name <- new_name
    }
    x
}

## printing methods----
#' @param cmd `cmdParse` object
#' @param base bool, base command
#' @param args bool, arguments
#' @param inputs bool, inputs
#' @param outputs bool, outputs
#' @param stdout bool, standard out
#' @param raw_cmd bool, raw parsed command
#' @param all bool, print all positions?
#'
#' @return invisible of `cmdParse` object
.catCmdAll2 <- function(cmd, base = FALSE, args = FALSE, inputs = FALSE,
                       outputs = FALSE, stdout = FALSE, raw_cmd = FALSE, all = TRUE) {
    if(all) base <- args <- inputs <- outputs <- stdout <- raw_cmd <- TRUE
    if(base) .catBase2(cmd$baseCommand)
    if(args) .catArgs2(cmd$args)
    if(inputs) .catInputs2(cmd$inputs)
    if(outputs) .catOutputs2(cmd$outputs)
    if(stdout) .catStdout2(cmd$stdout)
    if(raw_cmd) .catCmdRaw2(cmd)
    return(invisible(cmd))
}

.catBase2 <- function(baseCommand) {
    cat(crayon::bgBlue("*****BaseCommand*****\n"))
    cat(baseCommand, "\n")
}

.catArgs2 <- function(args) {
    cat(crayon::bgBlue("*****Arguments*****\n"))
    if(!length(args)) return(invisible())
    for (i in seq_along(args)) {
        cat(
            names(args)[i], ":\n",
            "    prefix: ", args[[i]][["preF"]], "\n",
            "    position: ", args[[i]][["index"]], "\n",
            sep = ""
        )
    }
}

.catInputs2 <- function(inputs) {
    cat(crayon::bgBlue("*****Inputs*****\n"))
    if(!length(inputs)) return(invisible())
    input_names <- names(inputs)
    for (i in seq_along(inputs)) {
        cat(
            input_names[i], ":\n",
            "    type: ", inputs[[i]][["type"]], "\n",
            "    prefix: ", inputs[[i]][["preF"]], "\n",
            "    default value: ", inputs[[i]][["value"]], "\n",
            "    position: ", inputs[[i]][["index"]], "\n",
            sep = ""
        )
    }
}

.catOutputs2 <- function(outputs) {
    cat(crayon::bgBlue("*****Outputs*****\n"))
    if(!length(outputs)) return(invisible())
    out_names <- names(outputs)
    for (i in seq_along(outputs)) {
        cat(
            out_names[i], ":\n",
            "    type: ", outputs[[i]][["type"]], "\n",
            "    default value: ", outputs[[i]][["value"]], "\n",
            sep = ""
        )
    }
}

.catStdout2 <- function(stdout) {
    cat(crayon::bgBlue("*****Standard Outputs*****\n"))
    if(!length(stdout)) return(invisible())
    cat(
        names(stdout)[1], ":\n",
        "    type: ", stdout[[1]][["type"]], "\n",
        "    default value: ", stdout[[1]][["value"]], "\n",
        sep = ""
    )
}

.catCmdRaw2 <- function(commandline) {
    arg_in_list <- append(commandline$inputs,  commandline$args)
    arg_in_index <- lapply(arg_in_list, `[[`, "index") %>% unlist() %>% sort()
    extract_order <- names(arg_in_index)
    arg_in_ordered <- arg_in_list[extract_order]
    cmd_string <- lapply(arg_in_ordered, `[`, c("preF", "value")) %>%
        unlist() %>%
        paste0(collapse = " ")
    stdout <- if(length(commandline$stdout)) paste(">", commandline$stdout[[1]]$value) else ""
    cat(crayon::bgBlue("*****Parsed raw command line*****\n"))
    cat(commandline$baseCommand, cmd_string, stdout, "\n")
}

.removeSpaces2 <- function(x){
    x %>% stringr::str_remove("^[ ]{0,}") %>% stringr::str_remove("[ ]{0,}$")
}

.getAllCmdNames2 <- function(cmd) {
    lapply(cmd, names) %>% unlist()
}

##############
## sal2rmd ##
##############
sal2rmd <- function(sal,
                    out_path = "spr_template.Rmd",
                    rmd_title = "SPR workflow template",
                    rmd_author = "my name",
                    rmd_date = "Last update: `r format(Sys.time(), '%d %B, %Y')`",
                    rmd_output = "html_document",
                    desc = "This is a workflow template.",
                    verbose = TRUE) {
    stopifnot(is.character(rmd_output) && length(rmd_output) == 1)
    if (verbose) message(crayon::blue$bold("sal2rmd starts, pre-checks..."))
    stopifnot(inherits(sal, "SYSargsList"))
    stopifnot(is.character(out_path) && length(out_path) == 1)
    if (!stringr::str_detect(out_path, "\\.[rR]md$")) stop("output file path must end with .Rmd or .rmd")
    stopifnot(is.character(rmd_title) && length(rmd_title) == 1)
    stopifnot(is.character(rmd_author) && length(rmd_author) == 1)
    stopifnot(is.character(rmd_date) && length(rmd_date) == 1)
    stopifnot(is.logical(verbose) && length(verbose) == 1)
    stopifnot(is.character(desc))
    if (verbose) message(crayon::blue$bold("Open", out_path, "to write"))
    on.exit(try(close(con), silent = TRUE))
    con <- file(out_path)
    open(con, "w")
    # header and desc
    if (verbose) message(crayon::blue$bold("Write Rmd header and description"))
    writeLines(c(
        "---",
        paste0('title: "', rmd_title, '"'),
        paste0('author: "', rmd_author, '"'),
        paste0('date: "', rmd_date, '"'),
        paste0("output: "),
        paste0("  ", rmd_output, ":"),
        "    number_sections: false",
        "    theme: flatly",
        "    toc: true",
        "    toc_float:",
        "      collapsed: true",
        "      smooth_scroll: false",
        "package: systemPipeR",
        "fontsize: 14pt",
        "---\n",
        "# About this Report \n",
        desc,
        "\n# Workflow Steps\n"
    ), con)
    # get some info from sal
    step_names <- names(sal$stepsWF)
    deps <- sal$dependency
    t_connects <- sal$targets_connection
    opts <- sal$runInfo$runOption
    for (i in seq_along(sal$stepsWF)) {
        if (verbose) message(crayon::blue$bold("Now writing step", i, step_names[i]))
        if (inherits(sal$stepsWF[[i]], "LineWise")) {
            .sal2rmd_rstep(
                sal = sal, con = con, i = i, step_name = step_names[i], dep = deps[[i]],
                req = opts[[i]]$run_step, session = opts[[i]]$run_session, prepro = opts[[i]]$prepro_lines)
        } else {
            .sal2rmd_sysstep(
                sal = sal, con = con, i = i, step_name = step_names[i], dep = deps[[i]],
                dir = opts[[i]]$directory, req = opts[[i]]$run_step, session = opts[[i]]$run_session,
                t_con = t_connects[[i]], prepro = opts[[i]]$prepro_lines)
        }
    }
    if (verbose) message(crayon::green$bold("Success! File created at", out_path))
}
## Usage:
# file_path <- system.file("extdata", "spr_simple_wf.Rmd", package="systemPipeR")
# sal <- SPRproject(overwrite = TRUE)
# sal <- importWF(sal, file_path)
# sal2rmd(sal)

##############
## sal2bash ##
##############
sal2bash <- function(sal, out_dir = ".", bash_path = "/bin/bash", stop_on_error = TRUE) {
    stopifnot(inherits(sal, "SYSargsList"))
    stopifnot(is.character(out_dir) && length(out_dir) == 1)
    stopifnot(is.character(bash_path) && length(bash_path) == 1)
    stopifnot(is.logical(stop_on_error) && length(stop_on_error) == 1)
    supp_dir <- file.path(out_dir, "spr_bash")
    if (!dir.exists(supp_dir)) dir.create(supp_dir, recursive = TRUE)
    if (!dir.exists(supp_dir)) stop("Can't create", supp_dir, "check permissions")
    out_path <- file.path(out_dir, "spr_wf.sh")
    on.exit(try(close(con), silent = TRUE))
    con <- file(out_path)
    open(con, "w")
    writeLines(con = con, paste0("#!", bash_path, collapse = ""))
    if (stop_on_error) writeLines(con = con, "set -e\n")
    step_list <- .collapseSteps(sal)
    for (chunk in step_list) {
        writeLines(con = con, paste("# Step", paste0(chunk$step, collapse = "_")))
        writeLines(con = con, paste0('echo "Running step ', paste0(chunk$step, collapse = "_"), '"'))
        if (chunk$type == "sys") {
            bash_code <- .bashSysStep(sal, chunk$step)
            writeLines(con = con, bash_code)
            writeLines(con = con, "\n")
        } else {
            r_code <- .bashRStep(sal, chunk$step)
            r_path <- paste0("rscript_step", paste0(chunk$step, collapse = "_"), ".R")
            .writeRscript(r_code, file.path(supp_dir, r_path), supp_dir)
            writeLines(con = con, paste0("Rscript ", file.path(supp_dir, r_path)))
            writeLines(con = con, "\n")
        }
    }
    .loaded_pkgs <- "base"
    save(list = c(as.character(match.call()$sal), ".loaded_pkgs"), file = file.path(supp_dir, "spr_wf.RData"), envir = environment())
    message(crayon::green$bold("Success: Make sure the script 'spr_wf.sh' and directory", supp_dir, "is there before executing."))
}
## Usage:
# file_path <- system.file("extdata", "spr_simple_wf.Rmd", package="systemPipeR")
# sal <- SPRproject(overwrite = TRUE)
# sal <- importWF(sal, file_path)
# sal2bash(sal)

#################################
## Unexported helper functions ##
#################################
#####################
## .sal2rmd_rstep ##
#####################
.sal2rmd_rstep <- function(sal, con, i, step_name, dep, req, session, prepro, return = "write") {
    header <- header <- paste0("```{r ", step_name, ", eval=FALSE, spr=TRUE}", collapse = "")
    dep_code <- if (!is.na(dep[1])) paste0("    dependency = c('", paste0(dep, collapse = ","), "'),") else paste0("    dependency = NA", ",")
    rep_code <- if (req == "optional") paste0("    run_step = c('optional'),") else paste0("    run_step = c('mandatory'),")
    ses_code <- if (session == "compute") paste0("    run_session = c('compute')") else paste0("    run_session = c('management')")
    rcode <- c(
        paste0("## Step", i, " ", step_name, collapse = ""),
        header,
        if(is.null(prepro) || prepro == "") NULL else prepro,
        "appendStep(sal) <- LineWise(\n    code={",
        paste0("        ", as.character(sal$stepsWF[[i]]$codeLine)) %>% stringr::str_replace_all("\n", "\n        "),
        "    },",
        paste0("    step_name = '", step_name, "',"),
        dep_code,
        rep_code,
        ses_code,
        ")\n```\n\n"
    )
    if (return == "write") {
        writeLines(
            con = con,
            rcode
        )
    } else if (return == "object") {
        obj <- c(rcode)
        return(obj)
    }
}

######################
## .sal2rmd_sysstep ##
######################
.sal2rmd_sysstep <- function(sal, con, i, step_name, dep, dir, req, session, t_con, prepro, return = "write") {
    header <- paste0("```{r ", step_name, ", eval=FALSE, spr=TRUE}", collapse = "")
    name_code <- paste0("    step_name = '", step_name, "',")
    dep_code <- if (!is.na(dep[1])) paste0("    dependency = c('", paste0(dep, collapse = ","), "'),") else paste0("    dependency = NA", ",")
    rep_code <- if (req == "optional") paste0("    run_step = c('optional'),") else paste0("    run_step = c('mandatory'),")
    ses_code <- if (session == "compute") paste0("    run_session = c('compute')") else paste0("    run_session = c('management')")
    targets_text <- if (!is.na(sal$stepsWF[[i]]$files$targets)) {
        paste0('    targets = "', sal$stepsWF[[i]]$files$targets, '",')
    } else if (!is.null(t_con)) {
        paste0('    targets = c("', paste0(t_con$targets_step[[1]], collapse = '", "'), '"),')
    } else {
        "    targets = NULL,"
    }
    in_var <- if (length(sal$stepsWF[[i]]$inputvars) == 0) {
        "    inputvars = NULL,"
    } else {
        in_var_names <- names(sal$stepsWF[[i]]$inputvars)
        tmp_string <- paste(in_var_names, paste0('"', unlist(sal$stepsWF[[i]]$inputvars), '"'), sep = "=", collapse = ", ")
        paste("    inputvars = c(", tmp_string, "),")
    }
    rm_col <- if (!is.null(t_con) && !is.null(t_con[["rm_targets_col"]][[1]])) {
        paste('    rm_targets_col = c("', paste(t_con[["rm_targets_col"]][[1]], collapse = '", "'), '"),')
    } else {
        paste("    rm_targets_col = NULL,")
    }
    dir_path <- if (is.na(sal$stepsWF[[i]]$files$dir_path[1])) {
        NULL
    } else {
        paste0('    dir_path="', sal$stepsWF[[i]]$files$dir_path[1], '",')
    }
    wf_file <- paste0('    wf_file="', sal$stepsWF[[i]]$files$cwl[1], '",')
    input_file <- paste0('    input_file="', sal$stepsWF[[i]]$files$yml[1], '",')
    final_obj <- c(
        paste0("## Step", i, " ", step_name, collapse = ""),
        header,
        if(is.null(prepro) || prepro == "") NULL else prepro,
        "appendStep(sal) <- SYSargsList(",
        targets_text,
        dir_path,
        wf_file,
        input_file,
        in_var,
        rm_col,
        name_code,
        dep_code,
        if (dir) "    dir=TRUE," else "    dir=FALSE,",
        rep_code,
        ses_code,
        ")\n```\n\n"
    )
    if (return == "write") {
        writeLines(
            con = con, final_obj
        )
    } else if (return == "object") {
        return(final_obj)
    }
}

####################
## .collapseSteps ##
####################
.collapseSteps <- function(sal) {
    steps <- unlist(lapply(seq_along(sal), function(x) {
        if (inherits(sal[["stepsWF"]][[x]], "LineWise")) x else NA
    }))
    names(steps) <- seq_along(steps)
    list_item <- 1
    current_step_no <- 1
    step_list <- list(
        "1" = list(
            type = if (is.na(steps[1])) "sys" else "r",
            step = 1
        )
    )
    for (i in as.numeric(names(steps[-1]))) {
        if (is.na(steps[i])) {
            list_item <- list_item + 1
            step_list[[as.character(list_item)]][["type"]] <- "sys"
            step_list[[as.character(list_item)]][["step"]] <- i
        } else {
            if (current_step_no + 1 != i || step_list[[as.character(list_item)]][["type"]] == "sys") {
                list_item <- list_item + 1
            }
            step_list[[as.character(list_item)]][["type"]] <- "r"
            step_list[[as.character(list_item)]][["step"]] <- c(step_list[[as.character(list_item)]][["step"]], i)
        }
        current_step_no <- current_step_no + 1
    }
    step_list
}
## Usage:
# .collapseSteps(sal)

####################
## .bashSysStep ##
####################
.bashSysStep <- function(sal, step_no) {
    unlist(cmdlist(sal[step_no]))
}
## Usage:
# .bashSysStep(sal, 2)

####################
## .bashRStep ##
####################
.bashRStep <- function(sal, step_no) {
    unlist(lapply(step_no, function(x) c(paste0("#step", x, collapse = " "), as.character(sal[[1]][[x]]$codeLine), "\n")))
}
## Usage:
# .bashRStep(sal, 1:2)

####################
## .writeRscript ##
####################
.writeRscript <- function(r_code, path, supp_dir) {
    r_code <- c(
        paste0('load("', file.path(supp_dir, "spr_wf.RData"), '")'),
        "lapply(.loaded_pkgs, require, character.only = TRUE)\n",
        r_code,
        ".loaded_pkgs <- .packages()",
        paste0('save.image("', file.path(supp_dir, "spr_wf.RData"), '")\n')
    )
    writeLines(text = c("#!/usr/bin/Rscript\n\n", r_code), con = path)
}

#######################################################################
## Merge BAM files based on factor and return updated SYSargs object ##
#######################################################################
## Useful prior to peak calling in ChIP-Seq or miRNA gene prediction experiments
## where pooling of replicates maximizes depth of read coverage.
## Note: default factor is "Factor"
mergeBamByFactor <- function(args, targetsDF = NULL, mergefactor = "Factor",
                             out_dir = file.path("results", "merge_bam"),
                             overwrite = FALSE, silent = FALSE, ...) {
    if (!inherits(args, c("SYSargs", "SYSargs2", "character"))) stop("Argument 'x' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2 OR named character vector")
    dir.create(out_dir, showWarnings = FALSE, recursive = TRUE)
    if(!dir.exists(out_dir)) stop("Cannot create out dircotory '", out_dir, "' for you, check permissions")
    ## SYSargs class
    if (inherits(args, "SYSargs")) {
        mergefactor <- targetsin(args)[[mergefactor]]
        targetsin <- targetsin(args)
        bampaths <- infile1(args)
        if (!"FileName" %in% colnames(targetsin)) stop("Name of one column in 'targetsin(arg)' is expected to be 'FileName'.")
        ## SYSargs2 class
    } else if (inherits(args, "SYSargs2")) {
        mergefactor <- targets.as.df(targets(args))[[mergefactor]]
        targetsin <- targets.as.df(targets(args))
        bampaths <- infile1(args)
        if (!"FileName" %in% colnames(targetsin)) stop("Name of one column in 'targetsin(arg)' is expected to be 'FileName'.")
    } else if (inherits(args, "character")) {
        if (is.null(names(args))) stop("Please provide a named character vector, where the names elements should be the sampleID")
        bampaths <- args
        if (is.null(targetsDF)) stop("'targets argument is required when a named character vector is provided for 'args' argument'.")
        if (!inherits(targetsDF, c("DFrame", "data.frame"))) stop("Argument 'targets' needs to be assigned an object of class 'DFrame' OR 'data.frame'")
        targetsDF <- as.data.frame(targetsDF)
        mergefactor <- targetsDF[[mergefactor]]
        targetsin <- targetsDF
    }
    ## Check validity of input
    allbam <- !grepl("\\.bam$|\\.BAM", bampaths)
    if (any(allbam)) stop("The following files lack the extension '.bam': ", paste(basename(bampaths[allbam]), collapse = ", "))
    ## Unique values in Factor column of targetsin(args)
    sample_index <- !duplicated(as.character(mergefactor))
    names(sample_index) <- names(bampaths)
    uniorder <- unique(mergefactor)
    unifreq <- table(mergefactor)[uniorder] # Important: in order of targetsin(args)!
    if (!any(unifreq >= 2)) warning("Values in Factor column are all unique. Thus, there are no BAM files to merge.")
    ## Store BAM file paths in a list that have >=2 identical values (replicates) in Factor column of targets file
    filelist <- tapply(bampaths, factor(mergefactor), as.character)
    filelist <- filelist[names(unifreq)] # Assures original order
    ## Create vector containing paths of output BAM files
    outname_vec <- file.path(out_dir, paste0(names(filelist), "_merged.bam"))
    names(outname_vec) <- names(filelist)

    filelist_merge <- names(unifreq[unifreq >= 2])# Merge only those with >= 2 files
    filelist_single <- names(unifreq[unifreq == 1])# single bams will be copied cover

    ## If any output BAM file exists and 'overwrite=FALSE' then stop
    file_exists <- file.exists(outname_vec)
    names(file_exists) <- names(outname_vec)
    if (any(file_exists) & overwrite == FALSE) stop("The following files exist: ", paste(names(file_exists)[file_exists], collapse = ", "), ". Delete/rename them or set 'overwrite=TRUE'")
    ## Generate collapsed BAM files
    for (i in seq(along = filelist)) {
        if(names(filelist)[i] %in% filelist_merge) mergeBam(filelist[[i]],  outname_vec[i], indexDestination = TRUE, overwrite = overwrite)
        else if (names(filelist)[i] %in% filelist_single) file.copy(filelist[[i]],  outname_vec[i], overwrite = overwrite)
        if (silent != TRUE) {
            cat("Merged BAM files:", basename(filelist[[i]]), "and saved to file", outname_vec[i], "\n\n")
        }
    }
    ## Generate updated SYSargs and SYSargs2 object
    filelist[names(outname_vec)] <- outname_vec # Assign new file names to proper slots
    outfile_names <- unlist(filelist)
    args_sub <- args[sample_index]
    ## SYSargs class
    if (inherits(args, "SYSargs")) {
        targets_out <- targetsout(args_sub)
        targets_out[, "FileName"] <- outfile_names
        rownames(targets_out) <- NULL
        syslist <- list(
            targetsin = targetsin(args_sub),
            targetsout = targets_out,
            targetsheader = targetsheader(args_sub),
            modules = modules(args_sub),
            software = "mergeBamByFactor",
            cores = cores(args_sub),
            other = other(args_sub),
            reference = reference(args_sub),
            results = results(args_sub),
            infile1 = infile1(args_sub),
            infile2 = infile2(args_sub),
            outfile1 = outfile_names,
            sysargs = sysargs(args_sub),
            outpaths = outfile_names
        )
        args_sub_out <- as(syslist, "SYSargs")
        ## SYSargs2 class
    } else if (inherits(args, "SYSargs2")) {
        out <- sapply(names(outfile_names), function(x) list(outfile_names[[x]]), simplify = F)
        for (i in seq_along(out)) {
            names(out[[i]]) <- files(args)$step
        }
        # out <- sapply(names(out), function(x) names(out[[x]]) <- files(args)$step, simplify = F)
        sys2list <- list(
            targets = targets(args_sub),
            targetsheader = targetsheader(args_sub),
            modules = as.list(modules(args_sub)),
            wf = wf(args_sub),
            clt = clt(args_sub),
            yamlinput = yamlinput(args_sub),
            cmdlist = cmdlist(args_sub),
            input = input(args_sub),
            output = out,
            files = files(args_sub),
            inputvars = inputvars(args_sub),
            cmdToCwl = list(),
            status = data.frame(),
            internal_outfiles = list()
        )
        args_sub_out <- as(sys2list, "SYSargs2")
    } else if (inherits(args, "character")) {
        targetsDF <- targetsDF[, -which(colnames(targetsDF) %in% c("FileName1", "FileName2", "FileName"))]
        targetsDF <- targetsDF[sample_index, ]
        # a <- file.path(.getPath(filelist_merge[[1]]), outfile_names)
        args_sub_out <- cbind(FileName = outname_vec, targetsDF)
    }
    return(args_sub_out)
}
## Usage:
# args <- systemArgs(sysma=NULL, mytargets="targets_bam.txt")
# args_merge <- mergeBamByFactor(args, overwrite=TRUE, silent=FALSE)
# writeTargetsout(x=args_merge, file="targets_mergeBamByFactor.txt", overwrite=TRUE)

############################################################################
## Creat targets file with refence sample, e.g. input sample for ChIP-Seq ##
############################################################################
writeTargetsRef <- function(infile, outfile, silent = FALSE, overwrite = FALSE, ...) {
    ## Import
    headerlines <- readLines(infile)
    targets <- read.delim(infile, comment.char = "#")
    ## Check for expected input
    if (!c("SampleReference") %in% colnames(targets)) stop("Targets file lacks SampleReference column")
    if (!c("FileName") %in% colnames(targets)) stop("Targets file lacks FileName column")
    if (all(c("FileName1", "FileName2") %in% colnames(targets))) stop("Targets file is expected to have only one FileName column")
    if (file.exists(outfile) & overwrite == FALSE) {
        stop(
            "I am not allowed to overwrite files; please delete existing file: ",
            outfile, " or set 'overwrite=TRUE'"
        )
    }
    testv <- as.character(targets$SampleReference)
    testv <- testv[!is.na(testv)]
    testv <- testv[testv != ""]
    myfiles <- as.character(targets$FileName)
    names(myfiles) <- as.character(targets$SampleName)
    if (!all(testv %in% names(myfiles))) {
        stop(
            "Value(s) ", paste(testv[!testv %in% names(myfiles)], collapse = ", "),
            " from SampleReference column have no matches in SampleName column!"
        )
    }
    ## Rearrange targets file
    targets <- data.frame(FileName1 = targets$FileName, FileName2 = NA, targets)
    targets[, "FileName2"] <- myfiles[as.character(targets$SampleReference)]
    targets <- targets[!is.na(as.character(targets$SampleReference)), , drop = FALSE]
    targets <- targets[targets$SampleReference != "", , drop = FALSE]
    targets <- targets[, !(names(targets) %in% "FileName")]
    ## Export targets file including header lines
    headerlines <- headerlines[grepl("^#", headerlines)]
    targetslines <- c(paste(colnames(targets), collapse = "\t"), apply(targets, 1, paste, collapse = "\t"))
    writeLines(c(headerlines, targetslines), outfile, ...)
    if (silent != TRUE) cat("\t", "Modified", infile, "file with sample-wise reference has been written to outfile", outfile, "\n")
}
## Usage:
# writeTargetsRef(infile="~/targets.txt", outfile="~/targets_refsample.txt", silent=FALSE, overwrite=FALSE)

########################################################
## Iterative read counting over different range files ##
########################################################
## Convenience function to perform read counting over several different
## range sets, e.g. peak ranges or feature types
countRangeset <- function(bfl, args, outfiles = NULL, format = "tabular", ...) {
    pkg <- c("GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    ## Input validity checks
    if (!inherits(bfl, "BamFileList")) stop("'bfl' needs to be of class 'BamFileList'.")
    if (!any(inherits(args, "SYSargs"), inherits(args, "SYSargs2"), inherits(args, "character"))) stop("Argument 'x' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2 OR named character vector")
    ## SYSargs or SYSargs2 class
    if (inherits(args, "SYSargs") | inherits(args, "SYSargs2")) {
        absent_peak_file <- infile1(args)[!file.exists(infile1(args))]
        if (length(absent_peak_file) != 0) stop("The following files assigned to 'infile1(args)' do not exist: ", paste(basename(absent_peak_file), collapse = ", "))
        if (inherits(args, "SYSargs")) {
            absent_peak_file <- infile1(args)
            countDFnames <- outpaths(args)
            ## SYSargs2 class
        } else if (inherits(args, "SYSargs2")) {
            absent_peak_file <- infile1(args)
            countDFnames <- subsetWF(args, slot = "output", subset = 1, index = 1)
        }
        ## named character vector class
    } else if (inherits(args, "character")) {
        if (is.null(names(args))) stop("Please provide a named character vector, where the names elements should be the sampleID")
        absent_peak_file <- args
        if (is.null(outfiles)) stop("Please provide a named character vector, where the names elements should be the sampleID and the outfiles names.")
        if (!all(names(outfiles) %in% names(absent_peak_file))) stop("names of 'outfiles' argument should be find at names of 'args' argument.")
        countDFnames <- outfiles
    }
    for (i in seq(along = absent_peak_file)) {
        if (format == "tabular") {
            df <- read.delim(absent_peak_file[i], comment.char = "#")
            peaks <- as(df, "GRanges")
        } else if (format == "bed") {
            peaks <- rtracklayer::import.bed(absent_peak_file[i])
        } else {
            stop("Input file format not supported.")
        }
        names(peaks) <- paste0(as.character(GenomeInfoDb::seqnames(peaks)), "_", start(peaks), "-", end(peaks))
        peaks <- split(peaks, names(peaks))
        countDF <- GenomicAlignments::summarizeOverlaps(peaks, bfl, ...)
        countDF <- SummarizedExperiment::assays(countDF)$counts
        write.table(countDF, countDFnames[i], col.names = NA, quote = FALSE, sep = "\t")
        cat("Wrote count result", i, "to", basename(countDFnames[i]), "\n")
    }
    if (inherits(args, "character")) {
        names(countDFnames) <- names(args)
        return(countDFnames)
    } else {
        return(countDFnames)
    }
}
## Usage:
# countDFnames <- countRangeset(bfl, args, mode="Union", ignore.strand=TRUE)

################################################################################
## Iterative edgeR/DESeq2 analysis over counts sets from different range sets ##
################################################################################
## Convenience function to iterate over several count sets generated by
## countRangeset() or similar utilities
runDiff <- function(args, outfiles = NULL, diffFct, targets, cmp, dbrfilter, ...) {
    if (!any(inherits(args, "SYSargs"), inherits(args, "SYSargs2"), inherits(args, "character"))) stop("Argument 'x' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2 OR named character vector")
    ## SYSargs class
    if (inherits(args, "SYSargs")) {
        countfiles <- infile1(args)
        dbrDFnames <- outpaths(args)
        ## SYSargs2 class
    } else if (inherits(args, "SYSargs2")) {
        countfiles <- infile1(args)
        dbrDFnames <- subsetWF(args, slot = "output", subset = 1, index = 1)
    } else if (inherits(args, "character")) {
        countfiles <- args
        dbrDFnames <- outfiles
    }
    ## Input validity checks
    absent_count_files <- countfiles[!file.exists(countfiles)]
    if (length(absent_count_files) != 0) stop("The following files assigned to 'countfiles' do not exist: ", paste(basename(absent_count_files), collapse = ", "))
    ## Perform differential analysis
    dbrlists <- list()
    for (i in seq(along = dbrDFnames)) {
        countDF <- read.delim(countfiles[i], row.names = 1)
        edgeDF <- diffFct(countDF = countDF, targets, cmp, ...)
        write.table(edgeDF, dbrDFnames[i], quote = FALSE, sep = "\t", col.names = NA)
        grDevices::pdf(paste0(dbrDFnames[i], ".pdf"))
        DBR_list <- filterDEGs(degDF = edgeDF, filter = dbrfilter)
        grDevices::dev.off()
        dbrlists <- c(dbrlists, list(DBR_list))
        names(dbrlists)[i] <- names(dbrDFnames[i])
        cat("Wrote count result", i, "to", basename(dbrDFnames[i]), "\n")
        cat("Saved plot", i, "to", basename(paste0(dbrDFnames[i], ".pdf")), "\n")
    }
    return(dbrlists)
}
## Usage:
# dbrlist <- runDiff(args, diffFct=run_edgeR, targets=targetsin(args_bam), cmp=cmp[[1]], independent=TRUE, dbrfilter=c(Fold=2, FDR=1))
# dbrlist <- runDiff(args, diffFct=run_edgeR, targets=ttargets.as.df(targets(args_bam)), cmp=cmp[[1]], independent=TRUE, dbrfilter=c(Fold=2, FDR=1))

###########################################################
## (A) olRanges Function for IRanges and GRanges Objects ##
###########################################################
##  Identify Range Overlaps
olRanges <- function(query, subject, output = "gr") {
    pkg <- c("IRanges", "GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    ## Input check
    if (!((class(query) == "GRanges" & class(subject) == "GRanges") | (class(query) == "IRanges" & class(subject) == "IRanges"))) {
        stop("Query and subject need to be of same class, either GRanges or IRanges!")
    }
    ## Find overlapping ranges
    if (class(query) == "GRanges") {
        GenomeInfoDb::seqlengths(query) <- rep(NA, length(GenomeInfoDb::seqlengths(query)))
        GenomeInfoDb::seqlengths(subject) <- rep(NA, length(GenomeInfoDb::seqlengths(subject)))
    }
    olindex <- as.matrix(GenomicRanges::findOverlaps(query, subject))
    query <- query[olindex[, 1]]
    subject <- subject[olindex[, 2]]
    olma <- cbind(Qstart = start(query), Qend = end(query), Sstart = start(subject), Send = end(subject))
    ## Pre-queries for overlaps
    startup <- olma[, "Sstart"] < olma[, "Qstart"]
    enddown <- olma[, "Send"] > olma[, "Qend"]
    startin <- olma[, "Sstart"] >= olma[, "Qstart"] & olma[, "Sstart"] <= olma[, "Qend"]
    endin <- olma[, "Send"] >= olma[, "Qstart"] & olma[, "Send"] <= olma[, "Qend"]
    ## Overlap types
    olup <- startup & endin
    oldown <- startin & enddown
    inside <- startin & endin
    contained <- startup & enddown
    ## Overlap types in one vector
    OLtype <- rep("", length(olma[, "Qstart"]))
    OLtype[olup] <- "olup"
    OLtype[oldown] <- "oldown"
    OLtype[inside] <- "inside"
    OLtype[contained] <- "contained"
    ## Overlap positions
    OLstart <- rep(0, length(olma[, "Qstart"]))
    OLend <- rep(0, length(olma[, "Qstart"]))
    OLstart[olup] <- olma[, "Qstart"][olup]
    OLend[olup] <- olma[, "Send"][olup]
    OLstart[oldown] <- olma[, "Sstart"][oldown]
    OLend[oldown] <- olma[, "Qend"][oldown]
    OLstart[inside] <- olma[, "Sstart"][inside]
    OLend[inside] <- olma[, "Send"][inside]
    OLstart[contained] <- olma[, "Qstart"][contained]
    OLend[contained] <- olma[, "Qend"][contained]
    ## Absolute and relative length of overlaps
    OLlength <- (OLend - OLstart) + 1
    OLpercQ <- OLlength / width(query) * 100
    OLpercS <- OLlength / width(subject) * 100
    ## Output type
    oldf <- data.frame(Qindex = olindex[, 1], Sindex = olindex[, 2], olma, OLstart, OLend, OLlength, OLpercQ, OLpercS, OLtype)
    if (class(query) == "GRanges") {
        oldf <- cbind(space = as.character(GenomeInfoDb::seqnames(query)), oldf)
    }
    if (output == "df") {
        return(oldf)
    }
    if (output == "gr") {
        if (class(query) == "GRanges") {
            S4Vectors::elementMetadata(query) <- cbind(as.data.frame(elementMetadata(query)), oldf)
        }
        if (class(query) == "IRanges") {
            query <- GRanges(seqnames = S4Vectors::Rle(rep("dummy", length(query))), ranges = IRanges::IRanges(start = oldf[, "Qstart"], end = oldf[, "Qend"]), strand = S4Vectors::Rle(BiocGenerics::strand(rep("+", length(query)))), oldf)
        }
        return(query)
    }
}

## Run olRanges function
## Sample Data Sets
# grq <- GRanges(seqnames = S4Vectors::Rle(c("chr1", "chr2", "chr1", "chr3"), c(1, 3, 2, 4)),
#                ranges = IRanges(seq(1, 100, by=10), end = seq(30, 120, by=10)),
#                strand = S4Vectors::Rle(BiocGenerics::strand(c("-", "+", "-")), c(1, 7, 2)))
# grs <- shift(grq[c(2,5,6)], 5)
# olRanges(query=grq, subject=grs, output="df")
# olRanges(query=grq, subject=grs, output="gr")

## ----style, echo = FALSE, results = 'asis'--------------------------------------------------------
BiocStyle::markdown()
options(width = 100, max.print = 1000)
knitr::opts_chunk$set(
    eval = as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache = as.logical(Sys.getenv("KNITR_CACHE", "TRUE")), 
    tidy.opts = list(width.cutoff = 100), tidy = FALSE)

## ----setting, eval=TRUE, echo=FALSE---------------------------------------------------------------
if (file.exists("spr_project")) unlink("spr_project", recursive = TRUE)
is_win <- Sys.info()[['sysname']] != "Windows"

## ----load_library, eval=TRUE, include=FALSE-------------------------------------------------------
suppressPackageStartupMessages({
    library(systemPipeR)
})

## ----utilities, eval=TRUE, warning= FALSE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Important functionalities of systemPipeR. (A) Illustration of workflow design concepts, and (B) examples of visualization functionalities for NGS data.", warning=FALSE----
knitr::include_graphics("images/utilities.png")

## ----sysargslistImage, warning= FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Workflow management class. Workflows are defined and managed by the `SYSargsList` (`SAL`) control class. Components of `SAL` include `SYSargs2` and/or `LineWise` for defining CL- and R-based workflow steps, respectively. The former are constructed from a `targets` and two CWL *param* files, and the latter comprises mainly R code.", warning=FALSE----

knitr::include_graphics("images/SYSargsList.png")

## ----sprandCWL, warning=FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Parameter files. Illustration how the different fields in cwl, yml and targets files are connected to assemble command-line calls, here for 'Hello World' example.", warning=FALSE----

knitr::include_graphics("images/SPR_CWL_hello.png")

## ----general, warning= FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Overview of `systemPipeR` workflows management instances. (A) A typical analysis workflow requires multiple software tools (red), metadata for describing the input (green) and output data, and analysis reports for interpreting the results (purple). B) The environment provides utilities for designing and building workflows containing R and/or command-line steps, for managing the workflow runs. C) Options are provided to execute single or multiple workflow steps. This includes a high level of scalability, functionalities for checkpointing, and generating of technical and scientific reports.", warning=FALSE----

knitr::include_graphics("images/general.png")

## ----install, eval=FALSE--------------------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE)) install.packages("BiocManager")
# BiocManager::install("systemPipeR")
# BiocManager::install("systemPipeRdata")

## ----eval=FALSE-----------------------------------------------------------------------------------
# systemPipeRdata::genWorkenvir(workflow = "rnaseq")
# setwd("rnaseq")

## ----eval=FALSE-----------------------------------------------------------------------------------
# library(systemPipeR)
# # Initialize workflow project
# sal <- SPRproject()
# ## Creating directory '/home/myuser/systemPipeR/rnaseq/.SPRproject'
# ## Creating file '/home/myuser/systemPipeR/rnaseq/.SPRproject/SYSargsList.yml'
# sal <- importWF(sal, file_path = "systemPipeRNAseq.Rmd") # import into sal the WF steps defined by chosen Rmd file
# 
# ## The following print statements, issued during the import, are shortened for brevity
# ## Import messages for first 3 of 20 steps total
# ## Parse chunk code
# ## Now importing step 'load_SPR'
# ## Now importing step 'preprocessing'
# ## Now importing step 'trimming'
# ## Now importing step '...'
# ## ...
# 
# ## Now check if required CL tools are installed
# ## Messages for 4 of 7 CL tools total
# ##        step_name         tool in_path
# ## 1       trimming  trimmomatic    TRUE
# ## 2   hisat2_index hisat2-build    TRUE
# ## 3 hisat2_mapping       hisat2    TRUE
# ## 4 hisat2_mapping     samtools    TRUE
# ## ...

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal
# ## Instance of 'SYSargsList':
# ##     WF Steps:
# ##        1. load_SPR --> Status: Pending
# ##        2. preprocessing --> Status: Pending
# ##            Total Files: 36 | Existing: 0 | Missing: 36
# ##          2.1. preprocessReads-pe
# ##              cmdlist: 18 | Pending: 18
# ##        3. trimming --> Status: Pending
# ##            Total Files: 72 | Existing: 0 | Missing: 72
# ##        4. - 20. not shown here for brevity

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal <- runWF(sal)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal

## ----wf-status-image, warning=FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Status check of workflow. The run status flags of each workflow step are given in its summary view.", warning=FALSE----

knitr::include_graphics("images/runwf.png")

## ----eval=FALSE-----------------------------------------------------------------------------------
# plotWF(sal)

## ----rnaseq-toplogy, eval=TRUE, warning= FALSE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Toplogy graph of RNA-Seq workflow.", warning=FALSE----
knitr::include_graphics("images/plotWF.png")

## ----eval=FALSE-----------------------------------------------------------------------------------
# # Scietific report
# sal <- renderReport(sal)
# rmarkdown::render("systemPipeRNAseq.Rmd", clean = TRUE, output_format = "BiocStyle::html_document")
# 
# # Technical (log) report
# sal <- renderLogs(sal)

## ----dir, eval=TRUE, echo=FALSE, warning= FALSE, out.width="100%", fig.align = "center", fig.cap= "Directory structure of workflows.", warning=FALSE----
knitr::include_graphics("images/spr_project.png")  

## ----targetsSE, eval=TRUE-------------------------------------------------------------------------
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR") 
showDF(read.delim(targetspath, comment.char = "#"))

## ----targetsPE, eval=TRUE-------------------------------------------------------------------------
targetspath <- system.file("extdata", "targetsPE.txt", package = "systemPipeR")
showDF(read.delim(targetspath, comment.char = "#"))

## ----comment_lines, echo=TRUE---------------------------------------------------------------------
readLines(targetspath)[1:4]

## ----targetscomp, eval=TRUE-----------------------------------------------------------------------
readComp(file = targetspath, format = "vector", delim = "-")

## ----targetsFig, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "_`systemPipeR`_ automatically creates the downstream `targets` files based on the previous steps outfiles. A) Usually, users provide the initial `targets` files, and this step will generate some outfiles, as demonstrated on B. Then, those files are used to build the new `targets` files as inputs in the next step. _`systemPipeR`_ (C) manages this connectivity among the steps automatically for the users.", warning=FALSE----
knitr::include_graphics("images/targets_con.png")  

## ----cleaning1, eval=TRUE, include=FALSE----------------------------------------------------------
if (file.exists(".SPRproject")) unlink(".SPRproject", recursive = TRUE)
## NOTE: Removes previous project created in the quick-start section

## ----SPRproject1a, eval=FALSE---------------------------------------------------------------------
# sal <- SPRproject()

## ----SPRproject1, eval=TRUE-----------------------------------------------------------------------
sal <- SPRproject(projPath = getwd(), overwrite = TRUE) 

## ----SPRproject_dir, eval=FALSE-------------------------------------------------------------------
# sal <- SPRproject(data = "data", param = "param", results = "results")

## ----SPRproject_logs, eval=FALSE------------------------------------------------------------------
# sal <- SPRproject(logs.dir= ".SPRproject", sys.file=".SPRproject/SYSargsList.yml")

## ----SPRproject_env, eval=FALSE-------------------------------------------------------------------
# sal <- SPRproject(envir = new.env())

## ----projectInfo, eval=TRUE-----------------------------------------------------------------------
sal
projectInfo(sal)

## ----length, eval=TRUE----------------------------------------------------------------------------
length(sal)

## ----sal_check, eval=TRUE-------------------------------------------------------------------------
sal

## ----firstStep_R, eval=TRUE-----------------------------------------------------------------------
appendStep(sal) <- LineWise(code = {
                              mapply(function(x, y) write.csv(x, y),
                                     split(iris, factor(iris$Species)),
                                     file.path("results", paste0(names(split(iris, factor(iris$Species))), ".csv"))
                                     ) 
                            },
                            step_name = "export_iris")

## ----show, eval=TRUE------------------------------------------------------------------------------
sal

## ----codeLine, eval=TRUE--------------------------------------------------------------------------
codeLine(sal)

## ----gzip_secondStep, eval=TRUE-------------------------------------------------------------------
targetspath <- system.file("extdata/cwl/gunzip", "targets_gunzip.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "gzip", 
                      targets = targetspath, dir = TRUE,
                      wf_file = "gunzip/workflow_gzip.cwl", input_file = "gunzip/gzip.yml",
                      dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                      inputvars = c(FileName = "_FILE_PATH_", SampleName = "_SampleName_"), 
                      dependency = "export_iris")

## -------------------------------------------------------------------------------------------------
sal

## -------------------------------------------------------------------------------------------------
cmdlist(sal, step = "gzip")
# cmdlist(sal, step = "gzip", targets=c("SE"))

## -------------------------------------------------------------------------------------------------
# outfiles(sal) # output files of all steps in sal
outfiles(sal)['gzip'] # output files of 'gzip' step
# colnames(outfiles(sal)$gzip) # returns column name passed on to `inputvars`

## ----gunzip, eval=TRUE----------------------------------------------------------------------------
appendStep(sal) <- SYSargsList(step_name = "gunzip", 
                      targets = "gzip", dir = TRUE,
                      wf_file = "gunzip/workflow_gunzip.cwl", input_file = "gunzip/gunzip.yml",
                      dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                      inputvars = c(gzip_file = "_FILE_PATH_", SampleName = "_SampleName_"), 
                      rm_targets_col = "FileName", 
                      dependency = "gzip")

## -------------------------------------------------------------------------------------------------
sal

## ----targetsWF_3, eval=TRUE-----------------------------------------------------------------------
targetsWF(sal['gunzip'])

## ----outfiles_2, eval=TRUE------------------------------------------------------------------------
outfiles(sal['gunzip'])

## ----eval=TRUE------------------------------------------------------------------------------------
cmdlist(sal["gunzip"], targets = 1)

## ----getColumn, eval=TRUE-------------------------------------------------------------------------
getColumn(sal, step = "gunzip", 'outfiles')

## ----iris_stats, eval=TRUE------------------------------------------------------------------------
appendStep(sal) <- LineWise(code = {
                    df <- lapply(getColumn(sal, step = "gunzip", 'outfiles'), function(x) read.delim(x, sep = ",")[-1])
                    df <- do.call(rbind, df)
                    stats <- data.frame(cbind(mean = apply(df[,1:4], 2, mean), sd = apply(df[,1:4], 2, sd)))
                    stats$size <- rownames(stats)
                    
                    plot <- ggplot2::ggplot(stats, ggplot2::aes(x = size, y = mean, fill = size)) + 
                      ggplot2::geom_bar(stat = "identity", color = "black", position = ggplot2::position_dodge()) +
                      ggplot2::geom_errorbar(ggplot2::aes(ymin = mean-sd, ymax = mean+sd), width = .2, position = ggplot2::position_dodge(.9)) 
                    },
                    step_name = "iris_stats", 
                    dependency = "gzip")

## -------------------------------------------------------------------------------------------------
sal

## ----importWF_rmd, eval=TRUE----------------------------------------------------------------------
sal_rmd <- SPRproject(logs.dir = ".SPRproject_rmd") 

sal_rmd <- importWF(sal_rmd, 
                file_path = system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR"))

## ----importWF_details, eval=FALSE-----------------------------------------------------------------
# sal_rmd
# stepsWF(sal_rmd)
# dependency(sal_rmd)
# cmdlist(sal_rmd)
# codeLine(sal_rmd)
# targetsWF(sal_rmd)
# statusWF(sal_rmd)

## ----fromFile_example_rules_cmd, eval=FALSE-------------------------------------------------------
# targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
# appendStep(sal) <- SYSargsList(step_name = "Example",
#                       targets = targetspath,
#                       wf_file = "example/example.cwl", input_file = "example/example.yml",
#                       dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                       inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))

## ----fromFile_example_rules_r, eval=FALSE---------------------------------------------------------
# appendStep(sal) <- LineWise(code = {
#                               library(systemPipeR)
#                             },
#                             step_name = "load_lib")

## ----runWF, eval=is_win---------------------------------------------------------------------------
sal <- runWF(sal)

## ----runWF_error, eval=FALSE----------------------------------------------------------------------
# sal <- runWF(sal, steps = c(1,3))

## ----runWF_force, eval=FALSE----------------------------------------------------------------------
# sal <- runWF(sal, force = TRUE, warning.stop = FALSE, error.stop = TRUE)

## ----runWF_env, eval=FALSE------------------------------------------------------------------------
# viewEnvir(sal)

## ----runWF_saveenv, eval=FALSE--------------------------------------------------------------------
# sal <- runWF(sal, saveEnv = TRUE)

## ----show_statusWF_details1, eval=TRUE------------------------------------------------------------
sal

## ----show_statusWF_details2, eval=FALSE-----------------------------------------------------------
# stepsWF(sal)
# dependency(sal)
# cmdlist(sal)
# codeLine(sal)
# targetsWF(sal)
# statusWF(sal)
# projectInfo(sal)

## ----save_sal, eval=FALSE-------------------------------------------------------------------------
# sal <- write_SYSargsList(sal)

## ----module_cmds, eval=FALSE----------------------------------------------------------------------
# module(action_type="load", module_name="hisat2")
# moduleload("hisat2") # alternative command
# moduleunload("hisat2")
# modulelist() # list software loaded into current session
# moduleAvail() # list all software available in module system

## ----list_module, eval=FALSE----------------------------------------------------------------------
# listCmdModules(sal)
# listCmdTools(sal)

## ----runWF_cluster, eval=FALSE--------------------------------------------------------------------
# resources <- list(conffile=".batchtools.conf.R",
#                   template="batchtools.slurm.tmpl",
#                   Njobs=18,
#                   walltime=120, ## in minutes
#                   ntasks=1,
#                   ncpus=4,
#                   memory=1024, ## in Mb
#                   partition = "short"
#                   )
# sal <- addResources(sal, step=c("hisat2_mapping"), resources = resources)
# sal <- runWF(sal)

## ----eval=TRUE------------------------------------------------------------------------------------
plotWF(sal, show_legend = TRUE, width = "80%", rstudio = TRUE)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal <- renderReport(sal)
# 
# rmarkdown::render("my.Rmd", clean = TRUE, output_format = "BiocStyle::html_document")

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal <- renderLogs(sal)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal2rmd(sal)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal2bash(sal)

## ----SPR_resume, eval=FALSE-----------------------------------------------------------------------
# sal <- SPRproject(resume = TRUE)

## ----resume_load, eval=FALSE----------------------------------------------------------------------
# sal <- SPRproject(resume = TRUE, load.envir = TRUE)

## ----envir, eval=FALSE----------------------------------------------------------------------------
# viewEnvir(sal)
# copyEnvir(sal, list="plot", new.env = globalenv())

## ----restart_load, eval=FALSE---------------------------------------------------------------------
# sal <- SPRproject(restart = TRUE)

## ----SPR_overwrite, eval=FALSE--------------------------------------------------------------------
# sal <- SPRproject(overwrite = TRUE)

## -------------------------------------------------------------------------------------------------
length(sal)

## -------------------------------------------------------------------------------------------------
stepName(sal)

## -------------------------------------------------------------------------------------------------
listCmdTools(sal)

## -------------------------------------------------------------------------------------------------
listCmdModules(sal)
modules(stepsWF(sal)$gzip)

## -------------------------------------------------------------------------------------------------
names(sal)

## -------------------------------------------------------------------------------------------------
stepsWF(sal)

## -------------------------------------------------------------------------------------------------
names(stepsWF(sal)$gzip)

## -------------------------------------------------------------------------------------------------
statusWF(sal)

## -------------------------------------------------------------------------------------------------
targetsWF(sal[2])

## ----eval=FALSE-----------------------------------------------------------------------------------
# targetsheader(sal, step = "Quality")

## -------------------------------------------------------------------------------------------------
outfiles(sal[2])

## -------------------------------------------------------------------------------------------------
dependency(sal)

## -------------------------------------------------------------------------------------------------
SampleName(sal, step = "gzip")

## -------------------------------------------------------------------------------------------------
getColumn(sal, "outfiles", step = "gzip", column = "gzip_file")
getColumn(sal, "targetsWF", step = "gzip", column = "FileName")

## -------------------------------------------------------------------------------------------------
yamlinput(sal, step = "gzip")

## -------------------------------------------------------------------------------------------------
cmdlist(sal, step = c(2,3), targets = 1)

## -------------------------------------------------------------------------------------------------
codeLine(sal, step = "export_iris")

## -------------------------------------------------------------------------------------------------
viewEnvir(sal)

## -------------------------------------------------------------------------------------------------
copyEnvir(sal, list = c("plot"), new.env = globalenv(), silent = FALSE)

## -------------------------------------------------------------------------------------------------
length(sal)
sal[1:2]

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal_sub <- subset(sal, subset_steps = c(2,3), input_targets = c("SE", "VE"), keep_steps = TRUE)
# stepsWF(sal_sub)
# targetsWF(sal_sub)
# outfiles(sal_sub)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal[1] + sal[2] + sal[3]

## ----eval=TRUE------------------------------------------------------------------------------------
## create a copy of sal for testing
sal_c <- sal
## view original value, here restricted to 'ext' slot
yamlinput(sal_c, step = "gzip")$ext
## Replace value under 'ext' 
yamlinput(sal_c, step = "gzip", paramName = "ext") <- "txt.gz"
## view modified value, here restricted to 'ext' slot
yamlinput(sal_c, step = "gzip")$ext
## Evaluate resulting CL call
cmdlist(sal_c, step = "gzip", targets = 1)

## ----sal_lw_rep, eval=TRUE------------------------------------------------------------------------
appendCodeLine(sal_c, step = "export_iris", after = 1) <- "log_cal_100 <- log(100)"
codeLine(sal_c, step = "export_iris")

## ----sal_lw_rep2, eval=TRUE-----------------------------------------------------------------------
replaceCodeLine(sal_c, step="export_iris", line = 2) <- LineWise(code={
                    log_cal_100 <- log(50)
                    })
codeLine(sal_c, step = "export_iris")

## -------------------------------------------------------------------------------------------------
renameStep(sal_c, c(1, 2)) <- c("newStep2", "newIndex")
sal_c
names(outfiles(sal_c))
names(targetsWF(sal_c))
dependency(sal_c)

## ----eval=FALSE-----------------------------------------------------------------------------------
# sal_test <- sal[c(1,2)]
# replaceStep(sal_test, step = 1, step_name = "gunzip" ) <- sal[3]
# sal_test

## -------------------------------------------------------------------------------------------------
sal_test <- sal[-2]
sal_test

## -------------------------------------------------------------------------------------------------
dir_path <- system.file("extdata/cwl", package = "systemPipeR")
cwl <- yaml::read_yaml(file.path(dir_path, "example/example.cwl"))

## -------------------------------------------------------------------------------------------------
cwl[1:2]

## -------------------------------------------------------------------------------------------------
cwl[3]

## -------------------------------------------------------------------------------------------------
cwl[4]

## -------------------------------------------------------------------------------------------------
cwl[5]

## -------------------------------------------------------------------------------------------------
cwl[6]

## -------------------------------------------------------------------------------------------------
cwl.wf <- yaml::read_yaml(file.path(dir_path, "example/workflow_example.cwl"))

## -------------------------------------------------------------------------------------------------
cwl.wf[1:2]

## -------------------------------------------------------------------------------------------------
cwl.wf[3]

## -------------------------------------------------------------------------------------------------
cwl.wf[4]

## -------------------------------------------------------------------------------------------------
cwl.wf[5]

## -------------------------------------------------------------------------------------------------
yaml::read_yaml(file.path(dir_path, "example/example_single.yml"))

## ----fromFile, eval=TRUE--------------------------------------------------------------------------
HW <- SYSargsList(wf_file = "example/workflow_example.cwl", 
                  input_file = "example/example_single.yml", 
                  dir_path = system.file("extdata/cwl", package = "systemPipeR"))
HW
cmdlist(HW)

## -------------------------------------------------------------------------------------------------
yml <- yaml::read_yaml(file.path(dir_path, "example/example.yml"))
yml

## -------------------------------------------------------------------------------------------------
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
read.delim(targetspath, comment.char = "#")

## ----fromFile_example, eval=TRUE------------------------------------------------------------------
HW_mul <- SYSargsList(step_name = "echo", 
                      targets=targetspath, 
                      wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                      dir_path = dir_path, 
                      inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
HW_mul

## ----fromFile_example2, eval=TRUE-----------------------------------------------------------------
cmdlist(HW_mul)

## ----cmd_orig, eval=FALSE-------------------------------------------------------------------------
# hisat2 -S ./results/M1A.sam -x ./data/tair10.fasta -k 1 -min-intronlen 30 -max-intronlen 3000 -threads 4 -U ./data/SRR446027_1.fastq.gz

## ----cmd, eval=TRUE-------------------------------------------------------------------------------
command <- "
    hisat2 \
    -S <F, out: ./results/M1A.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: ./data/SRR446027_1.fastq.gz>
"

## -------------------------------------------------------------------------------------------------
cmd <- createParam(command, writeParamFiles = TRUE, overwrite=TRUE, confirm=TRUE) 

## -------------------------------------------------------------------------------------------------
cmdlist(cmd)

## ----saving, eval=FALSE---------------------------------------------------------------------------
# writeParamFiles(cmd, overwrite = TRUE)

## ----sysargs2, eval=TRUE, results="hide"----------------------------------------------------------
command2 <- "
    hisat2 \
    -S <F, out: _SampleName_.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: _FASTQ_PATH1_>
"
WF <- createParam(command2, overwrite = TRUE, writeParamFiles = TRUE, confirm = TRUE) 
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
WF_test <- loadWorkflow(targets = targetspath, wf_file="hisat2.cwl",
                   input_file="hisat2.yml", dir_path = "param/cwl/hisat2/")
WF_test <- renderWF(WF_test, inputvars = c(FileName = "_FASTQ_PATH1_"))

## ----sysargs2b, eval=TRUE-------------------------------------------------------------------------
WF_test
cmdlist(WF_test)[1:2]

## ----eval=FALSE-----------------------------------------------------------------------------------
# printParam(cmd, position = "baseCommand") ## Return baseCommand
# printParam(cmd, position = "outputs") ## Return outputs
# printParam(cmd, position = "inputs", index = 1:2) ## Return components by index
# printParam(cmd, position = "inputs", index = -1:-2) ## Negative index subsetting

## ----eval=FALSE-----------------------------------------------------------------------------------
# cmd2 <- subsetParam(cmd, position = "inputs", index = 1:2, trim = TRUE)
# cmdlist(cmd2)
# 
# cmd2 <- subsetParam(cmd, position = "inputs", index = c("S", "x"), trim = TRUE)
# cmdlist(cmd2)

## ----eval=FALSE-----------------------------------------------------------------------------------
# cmd3 <- replaceParam(cmd, "base", index = 1, replace = list(baseCommand = "bwa"))
# cmdlist(cmd3) ## Replacement changed baseCommand

## ----eval=FALSE-----------------------------------------------------------------------------------
# new_inputs <- new_inputs <- list(
#     "new_input1" = list(type = "File", preF="-b", yml ="myfile"),
#     "new_input2" = "-L <int: 4>"
# )
# cmd4 <- replaceParam(cmd, "inputs", index = 1:2, replace = new_inputs)
# cmdlist(cmd4)

## ----eval=FALSE-----------------------------------------------------------------------------------
# newIn <- new_inputs <- list(
#     "new_input1" = list(type = "File", preF="-b1", yml ="myfile1"),
#     "new_input2" = list(type = "File", preF="-b2", yml ="myfile2"),
#     "new_input3" = "-b3 <F: myfile3>"
# )
# cmd5 <- appendParam(cmd, "inputs", index = 1:2, append = new_inputs)
# cmdlist(cmd5)
# 
# cmd6 <- appendParam(cmd, "inputs", index = 1:2, after=0, append = new_inputs)
# cmdlist(cmd6)

## ----eval=FALSE-----------------------------------------------------------------------------------
# new_outs <- list(
#     "sam_out" = "<F: $(inputs.results_path)/test.sam>"
# )
# cmd7 <- replaceParam(cmd, "outputs", index = 1, replace = new_outs)
# output(cmd7)

## ----SYSargs2_structure, eval=TRUE----------------------------------------------------------------
library(systemPipeR)
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
dir_path <- system.file("extdata/cwl", package = "systemPipeR")
WF <- loadWF(targets = targetspath, wf_file = "hisat2/hisat2-mapping-se.cwl",
                   input_file = "hisat2/hisat2-mapping-se.yml",
                   dir_path = dir_path)

WF <- renderWF(WF, inputvars = c(FileName = "_FASTQ_PATH1_", 
                                 SampleName = "_SampleName_"))

## ----cmdlist, eval=TRUE---------------------------------------------------------------------------
cmdlist(WF)[1]

## ----names_WF, eval=TRUE--------------------------------------------------------------------------
names(WF)

## ----output_WF, eval=TRUE-------------------------------------------------------------------------
output(WF)[1]

## ----targets_WF, eval=TRUE------------------------------------------------------------------------
targets(WF)[1]
as(WF, "DataFrame")

## ----module_WF, eval=TRUE-------------------------------------------------------------------------
modules(WF)

## ----other_WF, eval=FALSE-------------------------------------------------------------------------
# files(WF)
# inputvars(WF)

## ----lw, eval=TRUE--------------------------------------------------------------------------------
rmd <- system.file("extdata", "spr_simple_lw.Rmd", package = "systemPipeR")
sal_lw <- SPRproject(overwrite = TRUE)
sal_lw <- importWF(sal_lw, rmd, verbose = FALSE)
codeLine(sal_lw)

## ----lw_coerce, eval=TRUE-------------------------------------------------------------------------
lw <- stepsWF(sal_lw)[[2]]
## Coerce
ll <- as(lw, "list")
class(ll)
lw <- as(ll, "LineWise")
lw

## ----lw_access, eval=TRUE-------------------------------------------------------------------------
length(lw)
names(lw)
codeLine(lw)
codeChunkStart(lw)
rmdPath(lw)

## ----lw_sub, eval=TRUE----------------------------------------------------------------------------
l <- lw[2]
codeLine(l)
l_sub <- lw[-2]
codeLine(l_sub)

## ----lw_rep, eval=TRUE----------------------------------------------------------------------------
replaceCodeLine(lw, line = 2) <- "5+5"
codeLine(lw)
appendCodeLine(lw, after = 0) <- "6+7"
codeLine(lw)

## ----sal_rep_append, eval=FALSE-------------------------------------------------------------------
# replaceCodeLine(sal_lw, step = 2, line = 2) <- LineWise(code={
#                                                              "5+5"
#                                                                 })
# codeLine(sal_lw, step = 2)
# 
# appendCodeLine(sal_lw, step = 2) <- "66+55"
# codeLine(sal_lw, step = 2)
# 
# appendCodeLine(sal_lw, step = 1, after = 1) <- "66+55"
# codeLine(sal_lw, step = 1)

## ----table_tools, echo=FALSE, message=FALSE-------------------------------------------------------
library(magrittr)
SPR_software <- system.file("extdata", "SPR_software.csv", package = "systemPipeR")
software <- read.delim(SPR_software, sep = ",", comment.char = "#")
colors <- colorRampPalette((c("darkseagreen", "indianred1")))(length(unique(software$Category)))
id <- as.numeric(c((unique(software$Category))))
software %>%
  dplyr::mutate(Step = kableExtra::cell_spec(Step, color = "white", bold = TRUE,
   background = factor(Category, id, colors))) %>%
   dplyr::select(Tool, Step, Description) %>%
   dplyr::arrange(Tool) %>% 
  kableExtra::kable("html", escape = FALSE, col.names = c("Tool Name", "Description", "Step")) %>%
    kableExtra::kable_material(c("striped", "hover", "condensed")) %>%
    kableExtra::scroll_box(width = "80%", height = "500px")

## ----cleaning3, eval=TRUE, include=FALSE----------------------------------------------------------
if (file.exists(".SPRproject")) unlink(".SPRproject", recursive = TRUE)
## NOTE: Removing previous project create in the quick starts section

## ----SPRproject2, eval=FALSE----------------------------------------------------------------------
# sal <- SPRproject(projPath = getwd(), overwrite = TRUE)

## ----load_SPR, message=FALSE, eval=FALSE, spr=TRUE------------------------------------------------
# appendStep(sal) <- LineWise({
#                             library(systemPipeR)
#                             },
#                             step_name = "load_SPR")

## ----preprocessing, message=FALSE, eval=FALSE, spr=TRUE-------------------------------------------
# targetspath <- system.file("extdata", "targetsPE.txt", package = "systemPipeR")
# appendStep(sal) <- SYSargsList(
#     step_name = "preprocessing",
#     targets = targetspath, dir = TRUE,
#     wf_file = "preprocessReads/preprocessReads-pe.cwl",
#     input_file = "preprocessReads/preprocessReads-pe.yml",
#     dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#     inputvars = c(
#         FileName1 = "_FASTQ_PATH1_",
#         FileName2 = "_FASTQ_PATH2_",
#         SampleName = "_SampleName_"
#     ),
#     dependency = c("load_SPR"))

## ----custom_preprocessing_function, eval=FALSE----------------------------------------------------
# appendStep(sal) <- LineWise(
#     code = {
#         filterFct <- function(fq, cutoff = 20, Nexceptions = 0) {
#             qcount <- rowSums(as(quality(fq), "matrix") <= cutoff, na.rm = TRUE)
#             # Retains reads where Phred scores are >= cutoff with N exceptions
#             fq[qcount <= Nexceptions]
#         }
#         save(list = ls(), file = "param/customFCT.RData")
#     },
#     step_name = "custom_preprocessing_function",
#     dependency = "preprocessing"
# )

## ----editing_preprocessing, message=FALSE, eval=FALSE---------------------------------------------
# yamlinput(sal, "preprocessing")$Fct
# yamlinput(sal, "preprocessing", "Fct") <- "'filterFct(fq, cutoff=20, Nexceptions=0)'"
# yamlinput(sal, "preprocessing")$Fct ## check the new function
# cmdlist(sal, "preprocessing", targets = 1) ## check if the command line was updated with success

## ----trimGalore, eval=FALSE, spr=TRUE-------------------------------------------------------------
# targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
# appendStep(sal) <- SYSargsList(step_name = "trimGalore",
#                                targets = targetspath, dir = TRUE,
#                                wf_file = "trim_galore/trim_galore-se.cwl",
#                                input_file = "trim_galore/trim_galore-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = c(FileName = "_FASTQ_PATH1_", SampleName = "_SampleName_"),
#                                dependency = "load_SPR",
#                                run_step = "optional")

## ----trimmomatic, eval=FALSE, spr=TRUE------------------------------------------------------------
# targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
# appendStep(sal) <- SYSargsList(step_name = "trimmomatic",
#                                targets = targetspath, dir = TRUE,
#                                wf_file = "trimmomatic/trimmomatic-se.cwl",
#                                input_file = "trimmomatic/trimmomatic-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = c(FileName = "_FASTQ_PATH1_", SampleName = "_SampleName_"),
#                                dependency = "load_SPR",
#                                run_step = "optional")

## ----fastq_report, eval=FALSE, message=FALSE, spr=TRUE--------------------------------------------
# appendStep(sal) <- LineWise(code = {
#                 fastq <- getColumn(sal, step = "preprocessing", "targetsWF", column = 1)
#                 fqlist <- seeFastq(fastq = fastq, batchsize = 10000, klength = 8)
#                 pdf("./results/fastqReport.pdf", height = 18, width = 4*length(fqlist))
#                 seeFastqPlot(fqlist)
#                 dev.off()
#                 }, step_name = "fastq_report",
#                 dependency = "preprocessing")

## ----hisat_index, eval=FALSE, spr=TRUE------------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "hisat_index",
#                                targets = NULL, dir = FALSE,
#                                wf_file = "hisat2/hisat2-index.cwl",
#                                input_file = "hisat2/hisat2-index.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = NULL,
#                                dependency = "preprocessing")

## ----hisat_mapping_samtools, eval=FALSE, spr=TRUE-------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "hisat_mapping",
#                                targets = "preprocessing", dir = TRUE,
#                                wf_file = "workflow-hisat2/workflow_hisat2-se.cwl",
#                                input_file = "workflow-hisat2/workflow_hisat2-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars=c(FileName1="_FASTQ_PATH1_", SampleName="_SampleName_"),
#                                dependency = c("hisat_index"),
#                                run_session = "compute")

## ----bowtie_index, eval=FALSE, spr=TRUE-----------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "bowtie_index",
#                                targets = NULL, dir = FALSE,
#                                wf_file = "bowtie2/bowtie2-index.cwl",
#                                input_file = "bowtie2/bowtie2-index.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = NULL,
#                                dependency = "preprocessing",
#                                run_step = "optional")

## ----tophat2_mapping, eval=FALSE, spr=TRUE--------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "tophat2_mapping",
#                                targets = "preprocessing", dir = TRUE,
#                                wf_file = "tophat2/workflow_tophat2-mapping-se.cwl",
#                                input_file = "tophat2/tophat2-mapping-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"),
#                                dependency = c("bowtie_index"),
#                                run_session = "remote",
#                                run_step = "optional")

## ----bowtie2_mapping, eval=FALSE, spr=TRUE--------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "bowtie2_mapping",
#                                targets = "preprocessing", dir = TRUE,
#                                wf_file = "bowtie2/workflow_bowtie2-mapping-se.cwl",
#                                input_file = "bowtie2/bowtie2-mapping-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"),
#                                dependency = c("bowtie_index"),
#                                run_session = "remote",
#                                run_step = "optional")

## ----bwa_index, eval=FALSE, spr=TRUE--------------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "bwa_index",
#                                targets = NULL, dir = FALSE,
#                                wf_file = "bwa/bwa-index.cwl",
#                                input_file = "bwa/bwa-index.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = NULL,
#                                dependency = "preprocessing",
#                                run_step = "optional")

## ----bwa_mapping, eval=FALSE, spr=TRUE------------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "bwa_mapping",
#                                targets = "preprocessing", dir = TRUE,
#                                wf_file = "bwa/bwa-se.cwl",
#                                input_file = "bwa/bwa-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"),
#                                dependency = c("bwa_index"),
#                                run_session = "remote",
#                                run_step = "optional")

## ----rsubread_index, eval=FALSE, spr=TRUE---------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "rsubread_index",
#                                targets = NULL, dir = FALSE,
#                                wf_file = "rsubread/rsubread-index.cwl",
#                                input_file = "rsubread/rsubread-index.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = NULL,
#                                dependency = "preprocessing",
#                                run_step = "optional")

## ----rsubread_mapping, eval=FALSE, spr=TRUE-------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "rsubread",
#                                targets = "preprocessing", dir = TRUE,
#                                wf_file = "rsubread/rsubread-mapping-se.cwl",
#                                input_file = "rsubread/rsubread-mapping-se.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars=c(FileName1="_FASTQ_PATH1_", SampleName="_SampleName_"),
#                                dependency = c("rsubread_index"),
#                                run_session = "compute",
#                                run_step = "optional")

## ----gsnap_index, eval=FALSE, spr=TRUE------------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "gsnap_index",
#                                targets = NULL, dir = FALSE,
#                                wf_file = "gsnap/gsnap-index.cwl",
#                                input_file = "gsnap/gsnap-index.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                inputvars = NULL,
#                                dependency = "preprocessing",
#                                run_step = "optional")

## ----gsnap_mapping, eval=FALSE, spr=TRUE----------------------------------------------------------
# appendStep(sal) <- SYSargsList(step_name = "gsnap",
#                                targets = "targetsPE.txt", dir = TRUE,
#                                wf_file = "gsnap/gsnap-mapping-pe.cwl",
#                                input_file = "gsnap/gsnap-mapping-pe.yml",
#                                dir_path = system.file("extdata/cwl", package = "systemPipeR"),
#                                 inputvars = c(FileName1 = "_FASTQ_PATH1_",
#                                               FileName2 = "_FASTQ_PATH2_", SampleName = "_SampleName_"),
#                                dependency = c("gsnap_index"),
#                                run_session = "remote",
#                                run_step = "optional")

## ----bam_IGV, eval=FALSE, spr=TRUE----------------------------------------------------------------
# appendStep(sal) <- LineWise(
#     code = {
#         bampaths <- getColumn(sal, step = "hisat2_mapping", "outfiles",
#                   column = "samtools_sort_bam")
#         symLink2bam(
#             sysargs = bampaths, htmldir = c("~/.html/", "somedir/"),
#             urlbase = "https://cluster.hpcc.ucr.edu/<username>/",
#             urlfile = "./results/IGVurl.txt")
#     },
#     step_name = "bam_IGV",
#     dependency = "hisat_mapping",
#     run_step = "optional"
# )

## ----create_txdb, message=FALSE, eval=FALSE, spr=TRUE---------------------------------------------
# appendStep(sal) <- LineWise(code = {
#                             library(txdbmaker)
#                             txdb <- makeTxDbFromGFF(file="data/tair10.gff", format="gff",
#                                                     dataSource="TAIR", organism="Arabidopsis thaliana")
#                             saveDb(txdb, file="./data/tair10.sqlite")
#                             },
#                             step_name = "create_txdb",
#                             dependency = "hisat_mapping")

## ----read_counting, message=FALSE, eval=FALSE, spr=TRUE-------------------------------------------
# appendStep(sal) <- LineWise({
#                             library(BiocParallel)
#                             txdb <- loadDb("./data/tair10.sqlite")
#                             eByg <- exonsBy(txdb, by="gene")
#                             outpaths <- getColumn(sal, step = "hisat_mapping", 'outfiles', column = 2)
#                             bfl <- BamFileList(outpaths, yieldSize=50000, index=character())
#                             multicoreParam <- MulticoreParam(workers=4); register(multicoreParam); registered()
#                             counteByg <- bplapply(bfl, function(x) summarizeOverlaps(eByg, x, mode="Union",
#                                                                                      ignore.strand=TRUE,
#                                                                                      inter.feature=TRUE,
#                                                                                      singleEnd=TRUE))
#                             # Note: for strand-specific RNA-Seq set 'ignore.strand=FALSE' and for PE data set 'singleEnd=FALSE'
#                             countDFeByg <- sapply(seq(along=counteByg),
#                                                   function(x) assays(counteByg[[x]])$counts)
#                             rownames(countDFeByg) <- names(rowRanges(counteByg[[1]]))
#                             colnames(countDFeByg) <- names(bfl)
#                             rpkmDFeByg <- apply(countDFeByg, 2, function(x) returnRPKM(counts=x, ranges=eByg))
#                             write.table(countDFeByg, "results/countDFeByg.xls",
#                                         col.names=NA, quote=FALSE, sep="\t")
#                             write.table(rpkmDFeByg, "results/rpkmDFeByg.xls",
#                                         col.names=NA, quote=FALSE, sep="\t")
#                             },
#                             step_name = "read_counting",
#                             dependency = "create_txdb")

## ----align_stats, message=FALSE, eval=FALSE, spr=TRUE---------------------------------------------
# appendStep(sal) <- LineWise({
#                             read_statsDF <- alignStats(args)
#                             write.table(read_statsDF, "results/alignStats.xls",
#                                         row.names = FALSE, quote = FALSE, sep = "\t")
#                             },
#                             step_name = "align_stats",
#                             dependency = "hisat_mapping")

## ----align_stats2, eval=TRUE----------------------------------------------------------------------
read.table(system.file("extdata", "alignStats.xls", package = "systemPipeR"), header = TRUE)[1:4,]

## ----read_counting_mirna, message=FALSE, eval=FALSE, spr=TRUE-------------------------------------
# appendStep(sal) <- LineWise({
#                             system("wget https://www.mirbase.org/download/ath.gff3 -P ./data/")
#                             gff <- rtracklayer::import.gff("./data/ath.gff3")
#                             gff <- split(gff, elementMetadata(gff)$ID)
#                             bams <- getColumn(sal, step = "bowtie2_mapping", 'outfiles', column = 2)
#                             bfl <- BamFileList(bams, yieldSize=50000, index=character())
#                             countDFmiR <- summarizeOverlaps(gff, bfl, mode="Union",
#                                                             ignore.strand = FALSE, inter.feature = FALSE)
#                             countDFmiR <- assays(countDFmiR)$counts
#                             # Note: inter.feature=FALSE important since pre and mature miRNA ranges overlap
#                             rpkmDFmiR <- apply(countDFmiR, 2, function(x) returnRPKM(counts = x, ranges = gff))
#                             write.table(assays(countDFmiR)$counts, "results/countDFmiR.xls",
#                                         col.names=NA, quote=FALSE, sep="\t")
#                             write.table(rpkmDFmiR, "results/rpkmDFmiR.xls", col.names=NA, quote=FALSE, sep="\t")
#                             },
#                             step_name = "read_counting_mirna",
#                             dependency = "bowtie2_mapping")

## ----sample_tree_rlog, message=FALSE, eval=FALSE, spr=TRUE----------------------------------------
# appendStep(sal) <- LineWise({
#                             library(DESeq2, warn.conflicts=FALSE, quietly=TRUE)
#                             library(ape, warn.conflicts=FALSE)
#                             countDFpath <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
#                             countDF <- as.matrix(read.table(countDFpath))
#                             colData <- data.frame(row.names = targetsWF(sal)[[2]]$SampleName,
#                                                   condition=targetsWF(sal)[[2]]$Factor)
#                             dds <- DESeqDataSetFromMatrix(countData = countDF, colData = colData,
#                                                           design = ~ condition)
#                             d <- cor(assay(rlog(dds)), method = "spearman")
#                             hc <- hclust(dist(1-d))
#                             plot.phylo(as.phylo(hc), type = "p", edge.col = 4, edge.width = 3,
#                                        show.node.label = TRUE, no.margin = TRUE)
#                             },
#                             step_name = "sample_tree_rlog",
#                             dependency = "read_counting")

## ----edger, message=FALSE, eval=FALSE, spr=TRUE---------------------------------------------------
# appendStep(sal) <- LineWise({
#                             targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
#                             targets <- read.delim(targetspath, comment = "#")
#                             cmp <- readComp(file = targetspath, format = "matrix", delim = "-")
#                             countDFeBygpath <- system.file("extdata", "countDFeByg.xls", package = "systemPipeR")
#                             countDFeByg <- read.delim(countDFeBygpath, row.names = 1)
#                             edgeDF <- run_edgeR(countDF = countDFeByg, targets = targets, cmp = cmp[[1]],
#                                                 independent = FALSE, mdsplot = "")
#                             DEG_list <- filterDEGs(degDF = edgeDF, filter = c(Fold = 2, FDR = 10))
#                             },
#                             step_name = "edger",
#                             dependency = "read_counting")

## ----deseq2, message=FALSE, eval=FALSE, spr=TRUE--------------------------------------------------
# appendStep(sal) <- LineWise({
#                             degseqDF <- run_DESeq2(countDF=countDFeByg, targets=targets, cmp=cmp[[1]],
#                                                    independent=FALSE)
#                             DEG_list2 <- filterDEGs(degDF=degseqDF, filter=c(Fold=2, FDR=10))
#                             },
#                             step_name = "deseq2",
#                             dependency = "read_counting")

## ----vennplot, message=FALSE, eval=FALSE, spr=TRUE------------------------------------------------
# appendStep(sal) <- LineWise({
#                             vennsetup <- overLapper(DEG_list$Up[6:9], type="vennsets")
#                             vennsetdown <- overLapper(DEG_list$Down[6:9], type="vennsets")
#                             vennPlot(list(vennsetup, vennsetdown), mymain="", mysub="",
#                                      colmode=2, ccol=c("blue", "red"))
#                             },
#                             step_name = "vennplot",
#                             dependency = "edger")

## ----get_go_biomart, message=FALSE, eval=FALSE, spr=TRUE------------------------------------------
# appendStep(sal) <- LineWise({
#                             library("biomaRt")
#                             listMarts() # To choose BioMart database
#                             listMarts(host="plants.ensembl.org")
#                             m <- useMart("plants_mart", host="https://plants.ensembl.org")
#                             listDatasets(m)
#                             m <- useMart("plants_mart", dataset="athaliana_eg_gene", host="https://plants.ensembl.org")
#                             listAttributes(m) # Choose data types you want to download
#                             go <- getBM(attributes=c("go_id", "tair_locus", "namespace_1003"), mart=m)
#                             go <- go[go[,3]!="",]; go[,3] <- as.character(go[,3])
#                             go[go[,3]=="molecular_function", 3] <- "F"
#                             go[go[,3]=="biological_process", 3] <- "P"
#                             go[go[,3]=="cellular_component", 3] <- "C"
#                             go[1:4,]
#                             dir.create("./data/GO")
#                             write.table(go, "data/GO/GOannotationsBiomart_mod.txt",
#                                         quote=FALSE, row.names=FALSE, col.names=FALSE, sep="\t")
#                             catdb <- makeCATdb(myfile="data/GO/GOannotationsBiomart_mod.txt",
#                                                lib=NULL, org="", colno=c(1,2,3), idconv=NULL)
#                             save(catdb, file="data/GO/catdb.RData")
#                             },
#                             step_name = "get_go_biomart",
#                             dependency = "edger")

## ----go_enrichment, message=FALSE, eval=FALSE, spr=TRUE-------------------------------------------
# appendStep(sal) <- LineWise({
#                             load("data/GO/catdb.RData")
#                             DEG_list <- filterDEGs(degDF=edgeDF, filter=c(Fold=2, FDR=50), plot=FALSE)
#                             up_down <- DEG_list$UporDown; names(up_down) <- paste(names(up_down), "_up_down", sep="")
#                             up <- DEG_list$Up; names(up) <- paste(names(up), "_up", sep="")
#                             down <- DEG_list$Down; names(down) <- paste(names(down), "_down", sep="")
#                             DEGlist <- c(up_down, up, down)
#                             DEGlist <- DEGlist[sapply(DEGlist, length) > 0]
#                             BatchResult <- GOCluster_Report(catdb=catdb, setlist=DEGlist, method="all",
#                                                             id_type="gene", CLSZ=2, cutoff=0.9,
#                                                             gocats=c("MF", "BP", "CC"), recordSpecGO=NULL)
#                             library("biomaRt")
#                             m <- useMart("plants_mart", dataset="athaliana_eg_gene", host="https://plants.ensembl.org")
#                             goslimvec <- as.character(getBM(attributes=c("goslim_goa_accession"), mart=m)[,1])
#                             BatchResultslim <- GOCluster_Report(catdb=catdb, setlist=DEGlist, method="slim",
#                                                                 id_type="gene", myslimv=goslimvec, CLSZ=10,
#                                                                 cutoff=0.01, gocats=c("MF", "BP", "CC"),
#                                                                 recordSpecGO=NULL)
#                             gos <- BatchResultslim[grep("M6-V6_up_down", BatchResultslim$CLID), ]
#                             gos <- BatchResultslim
#                             pdf("GOslimbarplotMF.pdf", height=8, width=10); goBarplot(gos, gocat="MF"); dev.off()
#                             goBarplot(gos, gocat="BP")
#                             goBarplot(gos, gocat="CC")
#                             },
#                             step_name = "go_enrichment",
#                             dependency = "get_go_biomart")

## ----hierarchical_clustering, message=FALSE, eval=FALSE, spr=TRUE---------------------------------
# appendStep(sal) <- LineWise({
#                             library(pheatmap)
#                             geneids <- unique(as.character(unlist(DEG_list[[1]])))
#                             y <- assay(rlog(dds))[geneids, ]
#                             pdf("heatmap1.pdf")
#                             pheatmap(y, scale="row", clustering_distance_rows="correlation",
#                                      clustering_distance_cols="correlation")
#                             dev.off()
#                             },
#                             step_name = "hierarchical_clustering",
#                             dependency = c("sample_tree_rlog", "edger"))

## ----sessionInfo----------------------------------------------------------------------------------
sessionInfo()

#####################################
## Method Definitions for SYSargs2 ##
#####################################
## Methods to return SYSargs2 components
setMethod(f = "targets", signature = "SYSargs2", definition = function(x) {
    return(x@targets)
})
setMethod(f = "targetsheader", signature = "SYSargs2", definition = function(x) {
    return(x@targetsheader)
})
setMethod(f = "modules", signature = "SYSargs2", definition = function(x) {
    return(setNames(as.character(x@modules), names(x@modules)))
})
setMethod(f = "wf", signature = "SYSargs2", definition = function(x) {
    return(x@wf)
})
setMethod(f = "clt", signature = "SYSargs2", definition = function(x) {
    return(x@clt)
})
setMethod(f = "yamlinput", signature = "SYSargs2", definition = function(x) {
    return(x@yamlinput)
})
setMethod(f = "cmdlist", signature = "SYSargs2", definition = function(x) {
    return(x@cmdlist)
})
setMethod(f = "input", signature = "SYSargs2", definition = function(x) {
    return(x@input)
})
setMethod(f = "output", signature = "SYSargs2", definition = function(x) {
    return(x@output)
})
setMethod(f = "files", signature = "SYSargs2", definition = function(x) {
    return(x@files)
})
setMethod(f = "inputvars", signature = "SYSargs2", definition = function(x) {
    return(x@inputvars)
})
setMethod(f = "cmdToCwl", signature = "SYSargs2", definition = function(x) {
    return(x@cmdToCwl)
})
setMethod(f = "status", signature = "SYSargs2", definition = function(x) {
    return(x@status)
})

## Constructor methods
## List to SYSargs2 with: as(mylist, "SYSargs2")
setAs(
    from = "list", to = "SYSargs2",
    def = function(from) {
        new("SYSargs2",
            targets = from$targets,
            targetsheader = from$targetsheader,
            modules = from$modules,
            wf = from$wf,
            clt = from$clt,
            yamlinput = from$yamlinput,
            cmdlist = from$cmdlist,
            input = from$input,
            output = from$output,
            files = from$files,
            inputvars = from$inputvars,
            cmdToCwl = from$cmdToCwl,
            status = from$status,
            internal_outfiles = from$internal_outfiles
        )
    }
)

setMethod(f = "sysargs2", signature = "SYSargs2", definition = function(x) {
    sysargs2 <- list(
        targets = x@targets, targetsheader = x@targetsheader, modules = x@modules, wf = x@wf,
        clt = x@clt, yamlinput = x@yamlinput, cmdlist = x@cmdlist, input = x@input, output = x@output,
        files = x@files, inputvars = x@inputvars, cmdToCwl = x@cmdToCwl,
        status = x@status, internal_outfiles = x@internal_outfiles
    )
    return(sysargs2)
})

## SYSargs2 to list with: as(SYSargs2, "list")
setAs(from = "SYSargs2", to = "list", def = function(from) {
    sysargs2(from)
})

## Define print behavior for SYSargs2
setMethod(
    f = "show", signature = "SYSargs2",
    definition = function(object) {
        cat(crayon::green$bold(paste0("Instance of '", class(object), "':")),
            paste0("   Slot names/accessors: "),
            paste0(
                "      targets: ", length(object@targets),
                " (", head(names(object@targets), 1), "...",
                tail(names(object@targets), 1), ")",
                ", targetsheader: ", length(unlist(object@targetsheader)), " (lines)"
            ),
            paste0("      modules: ", length(object@modules)),
            paste0(
                "      wf: ", length(object@wf$steps),
                ", clt: ", length(object@clt),
                ", yamlinput: ", length(object@yamlinput), " (inputs)"
            ),
            paste0(
                "      input: ", length(object@input),
                ", output: ", length(object@output)
            ),
            paste0("      cmdlist: ", length(object@cmdlist)),
            "   Sub Steps:",
            paste0(
                "      ", seq_along(object@clt), ". ", object@files$steps,
                " (rendered: ", length(object@cmdlist[[1]]) != 0, ")"
            ),
            "\n",
            sep = "\n"
        )
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "SYSargs2",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend infile1() method
setMethod(f = "infile1", signature = "SYSargs2", definition = function(x, input = c("FileName", "FileName1")) {
    subset_input <- input(x)
    input_sub <- input[input %in% names(input(x)[[1]])]
    subset_sample <- sapply(names(subset_input), function(y) subset_input[[y]][[input_sub]])
    subset_sample <- sapply(names(subset_sample), function(y) ifelse(is.null(subset_sample[[y]]), "", subset_sample[y]))
    return(subset_sample)
})

## Extend infile2() method
setMethod(f = "infile2", signature = "SYSargs2", definition = function(x, input = "FileName2") {
    subset_input <- input(x)
    input_sub <- input[input %in% names(input(x)[[1]])]
    if (length(input_sub) == 0) input_sub <- ""
    subset_sample <- sapply(names(subset_input), function(y) subset_input[[y]][[input_sub]])
    subset_sample <- sapply(names(subset_sample), function(y) ifelse(is.null(subset_sample[[y]]), "", subset_sample[y]))
    return(subset_sample)
})

## Extend length() method
setMethod(
    f = "length", signature = "SYSargs2", definition = function(x) {
        return(length(x@cmdlist))
    }
)

# Behavior of "[" operator for SYSargs2
setMethod(f = "[", signature = "SYSargs2", definition = function(x, i, ..., drop) {
    if (is.logical(i)) {
        i <- which(i)
    }
    x@targets <- x@targets[i]
    x@input <- x@input[i]
    x@output <- x@output[i]
    x@internal_outfiles <- x@internal_outfiles[i]
    x@cmdlist <- x@cmdlist[i]
    return(x)
})

## Behavior of "[[" operator for SYSargs2
setMethod(
    f = "[[", signature = c("SYSargs2", "ANY", "missing"),
    definition = function(x, i, ..., drop) {
        return(as(x, "list")[[i]])
    }
)

## Behavior of "$" operator for SYSargs2
setMethod("$",
    signature = "SYSargs2",
    definition = function(x, name) {
        slot(x, name)
    }
)

## Convert targets data.frame to list
targets.as.list <- function(x, id = "SampleName") {
    targetslist <- yaml::yaml.load(yaml::as.yaml(x, column.major = FALSE))
    names(targetslist) <- x[[id]]
    return(targetslist)
}

## Usage:
# targets <- read.delim("targets.txt", comment.char = "#")
# targetslist <- targets.as.list(x=targets)

## Convert targets list to data.frame
targets.as.df <- function(x) {
    targetstmp <- sapply(x, as.character, simplify = FALSE)
    targetsDF <- as.data.frame(do.call("rbind", targetstmp))
    rownames(targetsDF) <- NULL
    colnames(targetsDF) <- names(x[[1]])
    return(targetsDF)
}

## Usage:
# targets.as.df(x=targetslist)

## targets slot from a SYSargs2 obj to df with: as(SYSargs2, "data.frame")
setAs(from = "SYSargs2", to = "DataFrame", def = function(from) {
    S4Vectors::DataFrame(targets.as.df(targets(from)))
})

setMethod("baseCommand", signature = "SYSargs2", definition = function(x) {
    return(x@clt[[1]]$baseCommand[[1]])
})

setMethod("SampleName", signature = "SYSargs2", definition = function(x) {
    targets_x <- targets(x)
    if (length(targets_x) > 0) {
        sample_name_x <- as(x, "DataFrame")
        id <- x[["files"]][["id"]]
        return(sample_name_x[[id]])
    } else if (length(targets_x) == 0) {
        message("This step doesn't contain multiple samples.")
    }
})

## Replacement method for SYSargs2 using "[" operator
setReplaceMethod(f = "[[", signature = "SYSargs2", definition = function(x, i, j, value) {
    if (i == 1) x@targets <- value
    if (i == 2) x@targetsheader <- value
    if (i == 3) x@modules <- value
    if (i == 4) x@wf <- value
    if (i == 5) x@clt <- value
    if (i == 6) x@yamlinput <- value
    if (i == 7) x@cmdlist <- value
    if (i == 8) x@input <- value
    if (i == 9) x@output <- value
    if (i == 10) x@files <- value
    if (i == 11) x@status <- value
    if (i == 12) x@internal_outfiles <- value
    if (i == "targets") x@targets <- value
    if (i == "targetsheader") x@targetsheader <- value
    if (i == "modules") x@modules <- value
    if (i == "wf") x@wf <- value
    if (i == "clt") x@clt <- value
    if (i == "yamlinput") x@yamlinput <- value
    if (i == "cmdlist") x@cmdlist <- value
    if (i == "input") x@input <- value
    if (i == "output") x@output <- value
    if (i == "files") x@files <- value
    if (i == "cmdToCwl") x@cmdToCwl <- value
    if (i == "status") x@status <- value
    if (i == "internal_outfiles") x@internal_outfiles <- value
    return(x)
})

## Replacement method
setReplaceMethod("yamlinput", c("SYSargs2"), function(x, paramName, value) {
    x <- as(x, "list")
    ## Check paramName
    if (!paramName %in% names(x$yamlinput)) {
        stop(
            "'paramName' argument must be one of the following: ", "\n",
            paste0(names(x$yamlinput), collapse = ", ")
        )
    }
    ## Check class of value
    if (!identical(class(x$yamlinput[[paramName]]), class(value))) {
        stop(
            "'value' argument must be the same class of the 'paramName': ", "\n",
            class(x$yamlinput[[paramName]])
        )
    }
    x$yamlinput[paramName] <- value
    x <- as(x, "SYSargs2")
    x <- updateWF(x)
    x
})

setReplaceMethod("cmdToCwl", c("SYSargs2"), function(x, ..., value) {
    x@cmdToCwl <- value
    x
})

#######################################
## Class Definitions for SYSargsList ##
#######################################
## Define SYSargsList class
setClass("SYSargsList", slots = c(
    stepsWF = "list",
    statusWF = "list",
    targetsWF = "list",
    outfiles = "list",
    SE = "list",
    dependency = "list",
    targets_connection = "list",
    projectInfo = "list",
    runInfo = "list"
))

####################################
## Class Definitions for LINEWISE ##
####################################
## Define LineWise class
setClass("LineWise", slots = c(
    codeLine = "expression",
    codeChunkStart = "integer",
    # rmdPath = "character",
    stepName = "character",
    dependency = "list",
    status = "list",
    files = "list",
    runInfo = "list"
))

####################################
## Class Definitions for SYSargs2 ##
####################################
## Define SYSargs2 class
setClass("SYSargs2", slots = c(
    targets = "list",
    targetsheader = "list",
    modules = "list",
    wf = "list",
    clt = "list",
    yamlinput = "list",
    cmdlist = "list",
    input = "list",
    output = "list",
    files = "list",
    inputvars = "list",
    cmdToCwl = "list",
    status = "list",
    internal_outfiles = "list"
))

####################################
## Class Definitions for SYSargs ##
###################################
## Define SYSargs class
setClass("SYSargs", representation(
    targetsin = "data.frame",
    targetsout = "data.frame",
    targetsheader = "character",
    modules = "character",
    software = "character",
    cores = "numeric",
    other = "character",
    reference = "character",
    results = "character",
    infile1 = "character",
    infile2 = "character",
    outfile1 = "character",
    sysargs = "character",
    outpaths = "character"
))

######################
## Filter VCF files ##
######################
filterVars <- function(files, filter, varcaller = "gatk", organism, out_dir = "results") {
    pkg <- c("VariantAnnotation")
    checkPkg(pkg, quietly = FALSE)
    if (class(files) %in% c("SYSargs", "SYSargs2")) {
        return(warning(
            'filterVars: New version of SPR no longer accept "SYSargs", "SYSargs2" objects as inputs.\n',
            "Use `getColumn` to get a vector of paths instead OR 
                   provide a named character vector."
        ))
    }
    stopifnot(is.character(files))
    stopifnot(is.character(filter) && length(filter) == 1)
    stopifnot(is.character(organism) && length(organism) == 1)
    stopifnot(is.character(out_dir) && length(out_dir) == 1)
    if (!dir.exists(out_dir)) dir.create(out_dir, recursive = TRUE, showWarnings = FALSE)
    if (!dir.exists(out_dir)) stop("Cannot create output directory", out_dir)
    if (!all(check_files <- file.exists(files))) stop("Some files are missing:\n", paste0(files[!check_files], collapse = ",\n"))
    if (!all(check_ext <- stringr::str_detect(files, "\\.vcf$"))) stop("filterVars: All files need to end with .vcf\n", paste0(files[!check_ext], collapse = ",\n"))
    outfiles <- file.path(out_dir, basename(gsub("\\.vcf", "_filter.vcf", files)))
    for (i in seq(along = files)) {
        vcf <- VariantAnnotation::readVcf(files[i], organism)
        vr <- as(vcf, "VRanges")
        if (varcaller == "gatk") {
            vrfilt <- vr[eval(parse(text = filter)), ]
        }
        if (varcaller == "bcftools") {
            vrsambcf <- vr
            vr <- unlist(values(vr)$DP4)
            vr <- matrix(vr, ncol = 4, byrow = TRUE)
            VariantAnnotation::totalDepth(vrsambcf) <- as.integer(values(vrsambcf)$DP)
            VariantAnnotation::refDepth(vrsambcf) <- rowSums(vr[, 1:2])
            VariantAnnotation::altDepth(vrsambcf) <- rowSums(vr[, 3:4])
            vrfilt <- vrsambcf[eval(parse(text = filter)), ]
        }
        vcffilt <- VariantAnnotation::asVCF(vrfilt)
        VariantAnnotation::writeVcf(vcffilt, outfiles[i], index = TRUE)
        print(paste("Generated file", i, gsub(".*/", "", paste0(outfiles[i], ".bgz"))))
    }
    out_paths <- paste0(outfiles, ".bgz")
    names(out_paths) <- names(files)
    out_paths
}
## Usage for GATK:
# filter <- "totalDepth(vr) >= 20 & (altDepth(vr) / totalDepth(vr) >= 0.8) & rowSums(softFilterMatrix(vr))==6"
# filterVars(args, filter, varcaller="gatk", organism="Pinfest")
## Usage for BCFtools:
# filter <- "rowSums(vr) >= 20 & (rowSums(vr[,3:4])/rowSums(vr[,1:4]) >= 0.8)"
# filterVars(args, filter, varcaller="bcftools", organism="Pinfest")

#################
## VAR Reports ##
#################
## Report for locatVariants() where data for each variant is collapsed to a single line.
.allAnnot <- function(x, vcf) {
    pkg <- c("GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    rd <- SummarizedExperiment::rowRanges(vcf)
    ## Make variant calls in rd unique by collapsing duplicated ones
    VARID <- VARID <- unique(names(rd))
    REF <- tapply(as.character(values(rd)$REF), factor(names(rd)), function(i) paste(unique(i), collapse = " "))
    # gatk > 4.2 chaged the way of detection. Now alternative allele can have more than one possiblities, simply `unlist` will not work.
    ALT <- tapply(
        unlist(lapply(values(rd)$ALT, function(x) paste0(x, collapse = ","))), factor(names(rd)),
        function(i) paste(unique(i), collapse = " ")
    )
    QUAL <- tapply(values(rd)$QUAL, factor(names(rd)), function(i) paste(unique(i), collapse = " "))
    ## fix names field in x if incomplete
    if (any(names(x) == "")) {
        index <- unique(names(rd))
        names(index) <- gsub("_.*", "", index)
        names(x) <- index[paste(as.character(GenomeInfoDb::seqnames(x)), ":", start(x), sep = "")]
    }
    ## Make annotated variant calls in x unique by collapsing duplicated ones
    LOCATION <- tapply(as.character(values(x)$LOCATION), as.factor(names(x)), function(i) paste(i, collapse = " "))
    GENEID <- tapply(values(x)$GENEID, factor(names(x)), function(i) paste(unique(i), collapse = " "))
    ## Assemble results in data.frame
    df <- data.frame(
        VARID = VARID,
        REF = REF[VARID],
        ALT = ALT[VARID],
        QUAL = QUAL[VARID],
        LOCATION = LOCATION[VARID],
        GENEID = GENEID[VARID]
    )
    df[, "LOCATION"] <- gsub("NA", "", df$LOCATION)
    df[, "GENEID"] <- gsub("NA", "", df$GENEID)
    return(df)
}
## Usage:
# allvar <- locateVariants(rd, txdb, AllVariants())
# varreport <- .allAnnot(allvar, vcf)

## Report for predictCoding() where data for each variant if collapsed to one line.
.codingReport <- function(x, txdb) {
    pkg <- c("GenomicFeatures")
    checkPkg(pkg, quietly = FALSE)
    txids <- values(GenomicFeatures::transcripts(txdb))$tx_name
    names(txids) <- values(GenomicFeatures::transcripts(txdb))$tx_id
    # myf <- as.factor(names(values(x)$CDSLOC))
    myf <- as.factor(names(x))
    if (length(myf) > 0) {
        df <- data.frame(
            VARID = tapply(as.character(myf), myf, unique),
            Strand = tapply(as.character(BiocGenerics::strand(x)), myf, unique),
            Consequence = tapply(as.character(values(x)$CONSEQUENCE), myf, function(i) paste(unique(i), collapse = " ")),
            Codon = tapply(paste(start(values(x)$CDSLOC), "_", as.character(values(x)$REFCODON), "/", as.character(values(x)$VARCODON), sep = ""), myf, paste, collapse = " "),
            AA = tapply(paste(sapply(values(x)$PROTEINLOC, paste, collapse = "_"), "_", as.character(values(x)$REFAA), "/", as.character(values(x)$VARAA), sep = ""), myf, paste, collapse = " "),
            TXIDs = tapply(txids[values(x)$TXID], myf, paste, collapse = " "),
            GENEIDcode = tapply(values(x)$GENEID, myf, function(i) paste(unique(i), collapse = " "))
        )
    } else {
        df <- data.frame(VARID = NA, Strand = NA, Consequence = NA, Codon = NA, AA = NA, TXIDs = NA, GENEIDcode = NA)[FALSE, , drop = FALSE]
    }
    return(df)
}
## Usage:
# codereport <- predictCoding(vcf, txdb, seqSource=fa)
# codereport <- .codingReport(coderport, txdb)

####################
## Variant Report ##
####################
variantReport <- function(files, txdb, fa, organism, out_dir = "results") {
    pkg <- c("VariantAnnotation", "GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    if (class(files) %in% c("SYSargs", "SYSargs2")) {
        return(warning(
            'filterVars: New version of SPR no longer accept "SYSargs", "SYSargs2" objects as inputs.\n',
            "Use `getColumn` to get a vector of paths instead OR 
                     provide a named character vector."
        ))
    }
    stopifnot(is.character(files))
    stopifnot(is.character(organism) && length(organism) == 1)
    stopifnot(is.character(out_dir) && length(out_dir) == 1)
    if (!dir.exists(out_dir)) dir.create(out_dir, recursive = TRUE, showWarnings = FALSE)
    if (!dir.exists(out_dir)) stop("Cannot create output directory", out_dir)

    if (!all(check_files <- file.exists(files))) stop("Some files are missing:\n", paste0(files[!check_files], collapse = ",\n"))
    if (!all(check_ext <- stringr::str_detect(files, "(\\.vcf|\\.bgz)$"))) stop("variantReport: All files need to end with .vcf or .bgz\n", paste0(files[!check_ext], collapse = ",\n"))
    outfiles <- file.path(out_dir, basename(gsub("(\\.vcf$|\\.vcf.bgz$|\\.bgz$)", "_anno.tsv", files)))

    for (i in seq(along = files)) {
        vcf <- VariantAnnotation::readVcf(files[i], organism)
        allvar <- VariantAnnotation::locateVariants(vcf, txdb, VariantAnnotation::AllVariants())
        varreport <- .allAnnot(allvar, vcf)
        coding <- VariantAnnotation::predictCoding(vcf, txdb, seqSource = fa)
        codereport <- .codingReport(coding, txdb)
        vr <- as(vcf, "VRanges")
        varid <- paste(as.character(GenomeInfoDb::seqnames(vr)), ":", start(vr),
            "_", VariantAnnotation::ref(vr), "/", VariantAnnotation::alt(vr),
            sep = ""
        )
        vrdf <- data.frame(row.names = varid, as.data.frame(vr))
        vrdf <- vrdf[, c("totalDepth", "refDepth", "altDepth")]
        fullreport <- cbind(varreport, codereport[rownames(varreport), -1])
        fullreport <- cbind(
            VARID = as.character(fullreport[, 1]),
            vrdf[as.character(rownames(fullreport)), ],
            fullreport[, -1]
        )
        fullreport <- data.frame(lapply(fullreport, as.character),
            stringsAsFactors = FALSE
        )
        write.table(fullreport,
            file = outfiles[i], row.names = FALSE,
            quote = FALSE, sep = "\t", na = ""
        )
        print(paste("Generated file", i, gsub(".*/", "", outfiles[i])))
    }
    names(outfiles) <- names(files)
    outfiles
}
## Usage:
# variantReport(args=args, txdb=txdb, fa=fa, organism="Pinfest")

#############################
## Combine Variant Reports ##
#############################
combineVarReports <- function(files, filtercol, ncol = 15) {
    if (class(files) %in% c("SYSargs", "SYSargs2")) {
        return(warning(
            'filterVars: New version of SPR no longer accept "SYSargs", "SYSargs2" objects as inputs.\n',
            "Use `getColumn` to get a vector of paths instead OR 
                   provide a named character vector."
        ))
    }
    stopifnot(is.character(files))
    if (!all(check_files <- file.exists(files))) stop("Some files are missing:\n", paste0(files[!check_files], collapse = ",\n"))
    if (!all(check_ext <- stringr::str_detect(files, "(\\.tsv)$"))) stop("combineVarReports: All files need to end with .tsv\n", paste0(files[!check_ext], collapse = ",\n"))
    samples <- names(files)
    for (i in seq(along = samples)) {
        if (i == 1) {
            varDF <- read.delim(files[i], colClasses = rep("character", ncol))
            varDF <- cbind(Sample = samples[i], varDF)
            if (filtercol[1] != "All") varDF <- varDF[varDF[, names(filtercol)] == filtercol, ]
        } else {
            tmpDF <- read.delim(files[i])
            tmpDF <- read.delim(files[i], colClasses = rep("character", ncol))
            tmpDF <- cbind(Sample = samples[i], tmpDF)
            if (filtercol[1] != "All") tmpDF <- tmpDF[tmpDF[, names(filtercol)] == filtercol, ]
            varDF <- rbind(as.data.frame(as.matrix(varDF)), as.data.frame(as.matrix(tmpDF)))
        }
        varDF <- varDF[order(varDF$VARID), ]
    }
    return(varDF)
}
## Usage:
# args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
# combineDF <- combineVarReports(args, filtercol=c(Consequence="nonsynonymous"))

###########################################
## Create summary statistics of variants ##
###########################################
varSummary <- function(files) {
    if (class(files) %in% c("SYSargs", "SYSargs2")) {
        return(warning(
            'filterVars: New version of SPR no longer accept "SYSargs", "SYSargs2" objects as inputs.\n',
            "Use `getColumn` to get a vector of paths instead OR 
                   provide a named character vector."
        ))
    }
    stopifnot(is.character(files))
    if (!all(check_files <- file.exists(files))) stop("Some files are missing:\n", paste0(files[!check_files], collapse = ",\n"))
    if (!all(check_ext <- stringr::str_detect(files, "(\\.tsv)$"))) stop("varSummary: All files need to end with .tsv\n", paste0(files[!check_ext], collapse = ",\n"))

    for (i in seq(along = files)) {
        annotDF <- read.delim(files[i])
        count <- c(
            all = length(annotDF[, 1]),
            table(unlist(strsplit(as.character(annotDF$LOCATION), " "))),
            table(unlist(strsplit(as.character(annotDF$Consequence), " ")))
        )
        if (i == 1) {
            countDF <- data.frame(count)
        } else {
            countDF <- cbind(countDF, count[rownames(countDF)])
        }
    }
    countDF[is.na(countDF)] <- 0
    colnames(countDF) <- names(files)
    return(countDF)
}
## Usage:
# args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
# varSummaryDF <- varSummary(args)

########################################
## Method Definitions for SYSargsList ##
########################################
## Methods to return SYSargsList components
setMethod(f = "stepsWF", signature = "SYSargsList", definition = function(x) {
    return(x@stepsWF)
})
setMethod(f = "statusWF", signature = "SYSargsList", definition = function(x) {
    return(lapply(
        lapply(x@statusWF, "[[", 2),
        function(y) S4Vectors::DataFrame(y, check.names = FALSE)
    ))
})
setMethod(f = "targetsWF", signature = "SYSargsList", definition = function(x) {
    return(x@targetsWF)
})
setMethod(f = "outfiles", signature = "SYSargsList", definition = function(x) {
    return(x@outfiles)
})
setMethod(f = "SE", signature = "SYSargsList", definition = function(x, step = NULL) {
    if (is.null(step)) {
        return(x@SE)
    } else {
        return(x@SE[[step]])
    }
})

setMethod(f = "dependency", signature = "SYSargsList", definition = function(x) {
    return(x@dependency)
})
setMethod(f = "projectInfo", signature = "SYSargsList", definition = function(x) {
    return(x@projectInfo)
})
setMethod(f = "runInfo", signature = "SYSargsList", definition = function(x) {
    return(x@runInfo)
})

#####################################
## Coerce Methods for SYSargsList ##
#####################################

## Coerce back to list: as(SYSargsList, "list")
setMethod(f = "sysargslist", signature = "SYSargsList", definition = function(x) {
    sysargslist <- list(
        stepsWF = x@stepsWF,
        statusWF = x@statusWF,
        targetsWF = x@targetsWF,
        outfiles = x@outfiles,
        SE = x@SE,
        dependency = x@dependency,
        targets_connection = x@targets_connection,
        projectInfo = x@projectInfo,
        runInfo = x@runInfo
    )
    return(sysargslist)
})

## Constructor methods
## List to SYSargsList
setAs(
    from = "list", to = "SYSargsList",
    def = function(from) {
        new("SYSargsList",
            stepsWF = from$stepsWF,
            statusWF = from$statusWF,
            targetsWF = from$targetsWF,
            outfiles = from$outfiles,
            SE = from$SE,
            dependency = from$dependency,
            targets_connection = from$targets_connection,
            projectInfo = from$projectInfo,
            runInfo = from$runInfo
        )
    }
)

## SYSargsList to list with: as("SYSargsList", list)
setAs(
    from = "SYSargsList", to = "list",
    def = function(from) {
        sysargslist(from)
    }
)

#####################################
## Generic Methods for SYSargsList ##
#####################################

## Define print behavior for SYSargsList
setMethod(
    f = "show", signature = "SYSargsList",
    definition = function(object) {
        if (length(object) > 0) {
            status_1 <- .showHelper(object)
            status <- append("   WF Steps:\n", status_1)
        } else {
            status <- "No workflow steps added"
        }
        cat(
            crayon::blue$bold(paste0("Instance of '", class(object), "':")), "\n",
            status, "\n"
        )
    }
)

## Internal function
.showHelper <- function(object) {
    status_1 <- as.character()
    for (i in seq_along(object@stepsWF)) {
        status_color <- switch(tolower(object@statusWF[[i]]$status.summary),
            "pending" = crayon::blue$bold,
            "warning" = crayon::make_style("orange")$bold,
            "error" = crayon::red$bold,
            "success" = crayon::green$bold
        )
        if (inherits(object@stepsWF[[i]], "SYSargs2")) {
            status_1 <- c(
                status_1,
                c(
                    paste0("      ", i, ". ", crayon::blue(names(object@stepsWF)[i], "--> Status: "), status_color(object@statusWF[[i]]$status.summary), sep = ""), "\n",
                    paste0(c("          Total Files: ", "Existing: ", "Missing: "), colSums(object@statusWF[[i]][[2]][2:4]), collapse = " | "), "\n",
                    paste0(
                        # "         Sub Steps:", "\n",
                        paste0("        ", i, ".", seq_along(object@stepsWF[[i]]@clt), ". ", crayon::green(object@stepsWF[[i]]$files$steps)), "\n",
                        paste0("             cmdlist: ", length(object@stepsWF[[i]]), " | "),
                        sapply(as.list(object@stepsWF[[i]]$files$steps), function(x) {
                            paste0(
                                paste0(names(table(unlist(object@statusWF[[i]][[2]][object@stepsWF[[i]]$files$steps][x]))), ": ",
                                    table(unlist(object@statusWF[[i]][[2]][object@stepsWF[[i]]$files$steps][x])),
                                    collapse = " | "
                                )
                            )
                        }),
                        "\n"
                    )
                )
            )
        } else if (inherits(object@stepsWF[[i]], "LineWise")) {
            status_1 <- c(
                status_1,
                paste0("      ", i, ". ", crayon::blue(names(object@stepsWF)[i], "--> Status: "), status_color(object@statusWF[[i]]$status.summary), "\n")
            )
        }
    }
    return(status_1)
}

## Extend names() method
setMethod(
    f = "names", signature = "SYSargsList",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend length() method
setMethod(
    f = "length", signature = "SYSargsList",
    definition = function(x) {
        return(length(x@stepsWF))
    }
)

# Behavior of "[" operator for SYSargsList
setMethod(f = "[", signature = "SYSargsList", definition = function(x, i, ..., drop) {
    if (missing(i)) {
        i <- 1:length(x)
    }
    if (inherits(i, "character")) {
        if (!all(i %in% stepName(x))) {
            stop(
                "\n",
                "Step name doesn't exist. Please subset accordingly with the 'stepName(x)'",
                "\n",
                paste0(stepName(x), collapse = ", ")
            )
        }
        i <- which(stepName(x) %in% i)
    }
    if (is.logical(i)) {
        i <- which(i)
    }
    for (s in seq_along(i)) {
        tryCatch(
            {
                if (i[s] < 0) {
                    ii <- i[s] * -1
                } else {
                    ii <- i[s]
                }
                x@stepsWF[[ii]]
            },
            error = function(e) {
                e$message <- paste0(
                    "\n",
                    "Step number is out of range. Please subset accordingly with the 'length(x)'",
                    "\n",
                    paste0(1:length(x), collapse = ", ")
                )
                stop(e)
            }
        )
    }
    x@stepsWF <- x@stepsWF[i]
    names_tc <- names(x@stepsWF)
    x@statusWF <- x@statusWF[i]
    x@targetsWF <- x@targetsWF[i]
    x@outfiles <- x@outfiles[i]
    x@SE <- x@SE[i]
    x@dependency <- x@dependency[i]
    x@targets_connection <- x@targets_connection[names(x@targets_connection) %in% names_tc]
    x@projectInfo <- x@projectInfo
    x@runInfo$env <- x@runInfo$env
    x@runInfo$runOption <- x@runInfo$runOption[i]
    # x <- .check_write_SYSargsList(x)
    return(x)
})

## Behavior of "[[" operator for SYSargsList
setMethod(f = "[[", signature = c("SYSargsList", "ANY", "missing"), definition = function(x, i, ..., drop) {
    return(as(x, "list")[[i]])
})

## Behavior of "$" operator for SYSargsList
setMethod("$",
    signature = "SYSargsList",
    definition = function(x, name) {
        slot(x, name)
    }
)

setMethod("SampleName", signature = "SYSargsList", definition = function(x, step) {
    ## Check steps
    if (inherits(step, "numeric")) {
        if (!step %in% 1:length(x)) stop("We can not find this step in the Workflow")
    } else if (inherits(step, "character")) {
        if (!step %in% stepName(x)) stop("We can not find this step in the Workflow")
    }
    id <- stepsWF(x)[[step]][["files"]][["id"]]
    if (is.null(id)) {
        # message("This is a LineWise step.")
        return(NULL)
    } else {
        names <- targetsWF(x)[[step]]
        if (length(names) > 1) {
            return(names[[id]])
        } else {
            message("This step doesn't contain multiple samples.")
        }
    }
})

setMethod("baseCommand", signature = "SYSargsList", definition = function(x, step) {
    if (missing(step)) {
        step <- 1:length(x)
    }
    step <- .StepClass(x, class = "SYSargs2", step)
    x <- x[step]
    cmd <- sapply(names(x$stepsWF), function(x) list(NULL))
    for (i in seq_along(x)) {
        cmd[[i]] <- baseCommand(x[step]$stepsWF[[i]])
    }
    return(cmd)
})

setMethod("stepName", signature = "SYSargsList", definition = function(x) {
    return(names(stepsWF(x)))
})

setMethod("targetsheader", signature = "SYSargsList", definition = function(x, step) {
    return(stepsWF(x)[[step]]$targetsheader)
})

## cmdlist method for SYSargslist
setMethod(f = "cmdlist", signature = "SYSargsList", definition = function(x, step, targets = NULL) {
    if (missing(step)) {
        step <- 1:length(x)
    }
    step <- .StepClass(x, class = "SYSargs2", step)
    if (length(step) == 0) stop("Provide a step with a 'SYSargs2' class instance.")
    x <- x[step]
    cmd <- sapply(names(x$stepsWF), function(x) list(NULL))
    for (i in seq_along(x)) {
        if (nchar(cmdlist(x$stepsWF[[i]])[[1]][[1]]) > 0) {
            cmd_list <- cmdlist(x$stepsWF[[i]])
            if (!is.null(targets)) {
                cmd_list <- cmd_list[targets]
            }
            cmd[[i]] <- cmd_list
        }
    }
    return(cmd)
})

setMethod(f = "yamlinput", signature = "SYSargsList", definition = function(x, step) {
    if (length(step) > 1) stop("Please provide one step at a time.", call. = FALSE)
    if (inherits(step, "character")) {
        if (!step %in% stepName(x)) stop("'step' cannot be found in the workflow", call. = FALSE)
    } else if (inherits(step, "numeric")) {
        if (!step %in% seq_along(x)) stop("'step' cannot be found in the workflow", call. = FALSE)
    }
    if (inherits(stepsWF(x)[[step]], "LineWise")) stop("Provide a step with a 'SYSargs2' class instance", call. = FALSE)
    stepsWF(x)[[step]]$yamlinput
})

## Behavior of "subset" method for SYSargsList
setMethod(f = "subset", signature = "SYSargsList", definition = function(x, subset_steps, input_targets, keep_steps = TRUE) {
    if (!hasArg(subset_steps)) stop("argument 'subset_steps' is missing")
    if (!hasArg(input_targets)) stop("argument 'input_targets' is missing")
    x_sub <- x[subset_steps]
    if (any(sapply(stepsWF(x_sub), function(y) class(y)) %in% "LineWise")) {
        stop("We cannot subset a 'LineWise' step. Please review the 'subset_steps' argument")
    }
    ## check subset_steps length
    if (length(unique(sapply(stepsWF(x_sub), function(x) length(x)))) > 1) stop("All 'subset_steps' should contain the same length.")
    if (missing(input_targets)) {
        input_targets <- 1:max(sapply(stepsWF(x_sub), function(x) length(x)))
    }
    # Check targets index, names
    if (inherits(input_targets, "numeric")) {
        if (!all(input_targets %in% sapply(stepsWF(x_sub), function(x) 1:length(x)))) {
            stop(
                "Please select the number of 'input_targets' accordingly, options are: ",
                paste0(1:length(x_sub@stepsWF[[1]]), collapse = ", ")
            )
        }
    } else if (inherits(input_targets, "character")) {
        if (!all(input_targets %in% sapply(stepsWF(x_sub), function(x) SampleName(x)))) {
            stop(
                "Please select the number of 'input_targets' accordingly, options are: ",
                paste0(SampleName(x_sub@stepsWF[[1]]), collapse = ", ")
            )
        }
        input_targets <- which(SampleName(x_sub$stepsWF[[1]]) %in% input_targets)
    }
    if (keep_steps == FALSE) {
        x <- x_sub
        subset_steps <- 1:length(x_sub)
    }
    for (s in subset_steps) {
        x@stepsWF[[s]] <- x@stepsWF[[s]][input_targets]
        x@statusWF[[s]]$status.completed <- x@statusWF[[s]]$status.completed[input_targets, ]
        x@statusWF[[s]]$status.time <- x@statusWF[[s]]$status.time[input_targets, ]
        x@targetsWF[[s]] <- x@targetsWF[[s]][input_targets, ]
        out <- S4Vectors::DataFrame(x@outfiles[[s]][input_targets, ])
        colnames(out) <- colnames(x@outfiles[[s]])
        x@outfiles[[s]] <- out
        x@SE[[s]] <- x@SE[[1]][, input_targets]
        x@dependency <- x@dependency
        x@targets_connection <- x@targets_connection
        x@projectInfo <- x@projectInfo
        x@runInfo$runOption <- x@runInfo$runOption
    }
    x <- .check_write_SYSargsList(x)
    x
})

setMethod("getColumn", signature = "SYSargsList", definition = function(x, step, position = c("outfiles", "targetsWF"), column = 1, names = SampleName(x, step)) {
    ## assertions
    stopifnot(inherits(x, "SYSargsList"))
    stopifnot(length(step) == 1)
    stopifnot(length(column) == 1)
    position <- match.arg(position, c("outfiles", "targetsWF"))
    ## Check steps
    if (inherits(step, "numeric")) {
        if (!step %in% 1:length(x)) stop("We can not find this step in the Workflow")
    } else if (inherits(step, "character")) {
        if (!step %in% stepName(x)) stop("We can not find this step in the Workflow")
    }
    ## Check column
    if (inherits(column, "numeric")) {
        if (!column %in% 1:ncol(x[[position]][[step]])) stop("We can not find this column in the Workflow")
    } else if (inherits(column, "character")) {
        if (!column %in% colnames(x[[position]][[step]])) stop("We can not find this column in the Workflow")
    }
    ## Check names
    if (inherits(x$stepsWF[[step]], "SYSargs2")) {
        if (!length(names) == length(x[[position]][[step]][[column]])) stop("'names' argument needs to have the same length of desired output")
    }
    ##
    if (!is.null(x[[position]][[step]][[column]])) {
        subset <- x[[position]][[step]][[column]]
        if (is.null(names)) {
            if (is.null(rownames(x[[position]][[step]]))) {
                names <- rep("", length(subset))
            } else {
                names <- rownames(x[[position]][[step]])
            }
        }
        names(subset) <- names
    } else {
        message("This step doesn't contain expected outfiles.")
    }
    return(subset)
})


setReplaceMethod("updateColumn", signature = "SYSargsList", definition = function(x, step, position = c("outfiles", "targetsWF"), value) {
    ## assertions
    stopifnot(inherits(x, "SYSargsList"))
    stopifnot(length(step) == 1)
    stopifnot(inherits(value, c("DFrame", "data.frame")))
    position <- match.arg(position, c("outfiles", "targetsWF"))
    ## Check steps
    if (inherits(step, "numeric")) {
        if (!step %in% 1:length(x)) stop("We can not find this step in the Workflow")
    } else if (inherits(step, "character")) {
        if (!step %in% stepName(x)) stop("We can not find this step in the Workflow")
    }
    ## get some info
    df_names <- names(value)
    df_rows <- nrow(value)
    sal_name <- as.character(match.call()$x)
    ## if empty original value
    if (nrow(x[[position]][[step]]) == 0) {
        x[[position]][[step]] <- as(value, "DataFrame")
        rownames(x[[position]][[step]]) <- rownames(value)
        return(x)
    }
    ## if not empty
    if (nrow(x[[position]][[step]]) != df_rows) stop("updateColumn: Original dataframe has different rows than the new dataframe.")
    x[[position]][[step]][, df_names] <- value
    x
})

## Print accessor for codeLine slot
setMethod(f = "codeLine", signature = "SYSargsList", definition = function(x, step) {
    if (missing(step)) {
        step <- 1:length(x)
    }
    step <- .StepClass(x, class = "LineWise", step)
    if (length(step) == 0) stop("No selected step is a 'LineWise' object.")
    x <- x[step]
    rcode <- sapply(names(x$stepsWF), function(x) list(NULL))
    for (i in seq_along(x)) {
        if (!inherits(stepsWF(x)[[i]], "LineWise")) stop("This step is 'SYSargs2'. Please provide an 'LineWise' class step")
        code_list <- x$stepsWF[[i]]$codeLine
        rcode[[i]] <- code_list
    }
    for (i in seq_along(rcode)) {
        cat(crayon::blue(names(rcode[i])), paste0("    ", as.character(rcode[[i]])), sep = "\n")
    }
})

## Internal function
.StepClass <- function(x, class = c("SYSargs2", "LineWise"), step) {
    x_class <- sapply(stepsWF(x), function(y) class(y))
    if (any(class(step) == c("numeric", "integer"))) {
        step <- stepName(x)[step]
    }
    select <- x_class[names(x_class) %in% step]
    if (all(select %in% class)) {
        return(names(select))
    } else if (!all(select %in% class)) {
        message(paste0(names(select[!select %in% class]), collapse = " AND "), " step have been dropped because it is not a ", class, " object.", "\n")
        return(names(select[select %in% class]))
    }
}

## viewEnvir() methods for SYSargsList
setMethod(f = "viewEnvir", signature = "SYSargsList", definition = function(x, silent = FALSE) {
    if (!silent) {
        print(x@runInfo$env)
        print(ls(x@runInfo$env, all.names = TRUE))
    } else {
        return(ls(x@runInfo$env, all.names = TRUE))
    }
})

## copyEnvir() methods for SYSargsList
setMethod(
    f = "copyEnvir", signature = "SYSargsList",
    definition = function(x, list = character(), new.env = globalenv(), silent = FALSE) {
        envir <- x@runInfo$env
        if (!silent) print(envir)
        if (length(list) == 0) {
            list <- ls(envir, all.names = TRUE)
        } else {
            list <- list
        }
        for (l in list) {
            assign(l, get(l, envir), new.env)
        }
        if (!silent) cat(paste0("Copying to 'new.env': ", "\n", paste0(list, collapse = ", ")))
    }
)

## addResources() methods for SYSargsList
setMethod(
    f = "addResources", signature = "SYSargsList",
    definition = function(x, step, resources) {
        # Validations
        if (!inherits(x, "SYSargsList")) {
            stop("Argument 'x' needs to be assigned an object of class 'SYSargsList'")
        }
        ## Check step
        if (inherits(step, "numeric")) {
            if (!all(step %in% seq_along(x))) {
                stop(
                    "Please select the 'step' number accordingly, options are: ", "\n",
                    "        ", paste0(seq_along(x), collapse = ", ")
                )
            }
        } else if (inherits(step, "character")) {
            if (!all(step %in% stepName(x))) {
                stop(
                    "Please select the 'step' name accordingly, options are: ", "\n",
                    "        ", paste0(stepName(x), collapse = ", ")
                )
            }
            step <- which(stepName(x) %in% step)
        }
        ## Check resources
        if (!inherits(resources, "list")) {
            stop("Argument 'resources' needs to be assigned an object of class 'named list', please check 'help(clusterRun)'")
        }
        if (!any(c("conffile", "template") %in% names(resources))) {
            stop("'resources' list should contain 'conffile' and 'template' file paths.")
        }
        if (!file.exists(resources$conffile)) stop("'", resources$conffile, "' doesn't exist. Please provid a valid PATH.")
        if (!file.exists(resources$template)) stop("'", resources$template, "' doesn't exist. Please provid a valid PATH.")
        ## for each step
        for (i in step) {
            x@runInfo$runOption[[i]]$"run_remote_resources" <- resources
            if (!x@runInfo$runOption[[i]]$run_session == "compute") {
                message("Please note that the '", stepName(x)[i], "' step option '", x@runInfo$runOption[[i]]$run_session, "' was replaced with 'compute'.")
                runInfo(x, step = i, param = "run_session") <- "compute"
            }
        }
        x <- .check_write_SYSargsList(x)
        return(x)
    }
)

#########################################
## Replacement Methods for SYSargsList ##
#########################################

## Replacement method for SYSargsList using "[[" operator
setReplaceMethod(f = "[[", signature = "SYSargsList", definition = function(x, i, j, value) {
    if (i == 1) x@stepsWF <- value
    if (i == 2) x@statusWF <- value
    if (i == 3) x@targetsWF <- value
    if (i == 4) x@outfiles <- value
    if (i == 5) x@SE <- value
    if (i == 6) x@dependency <- value
    if (i == 7) x@targets_connection <- value
    if (i == 8) x@projectInfo <- value
    if (i == 9) x@runInfo <- value
    if (i == "stepsWF") x@stepsWF <- value
    if (i == "statusWF") x@statusWF <- value
    if (i == "targetsWF") x@targetsWF <- value
    if (i == "outfiles") x@outfiles <- value
    if (i == "SE") x@SE <- value
    if (i == "dependency") x@dependency <- value
    if (i == "targets_connection") x@targets_connection <- value
    if (i == "projectInfo") x@projectInfo <- value
    if (i == "runInfo") x@runInfo <- value
    return(x)
})

## Replacement method
setReplaceMethod(
    f = "appendStep", signature = c("SYSargsList"),
    definition = function(x, after = length(x), ..., value) {
        on.exit({
            ## used in `importWF`
            options(spr_importing = FALSE)
            ## used in `+.SYSargsList`
            options(appendPlus = FALSE)
            options(linewise_importing = FALSE)
        })
        ## append position
        lengx <- length(x)
        after <- after
        if (any(stepName(value) %in% stepName(x))) stop("Steps Names need to be unique.")
        ## Dependency
        if (after > 0) {
            if (any(!value$dependency[[1]][!value$dependency[[1]] %in% NA] %in% stepName(x))) {
                stop(
                    "Dependency value needs to be present in the Workflow. ", "Options are: ", "\n",
                    paste0(paste0(stepName(x), collapse = ", "), ", OR NA")
                )
            }
        } else if (after == 0) {
            if (!is.na(dependency(value))) {
                stop("This is the first step, and there is no previous step in the Workflow. Please select NA.")
            }
        }
        if (all(dependency(value) %in% "")) value[["dependency"]][[1]] <- NA
        ## Append
        if (inherits(value, "SYSargsList")) {
            if (length(value) > 1) stop("One step can be appended in each operation.", call. = FALSE)
            value <- .validationStepConn(x, value)
            x <- sysargslist(x)
            if (names(value$stepsWF) == "Step_x") {
                step_name <- paste0("Step_", after + 1L)
                renameStep(value, 1) <- step_name
            }
            if (!after) {
                x$stepsWF <- c(value$stepsWF, x$stepsWF)
                x$targetsWF <- c(targetsWF(value), x$targetsWF)
                x$statusWF <- c(value$statusWF, x$statusWF)
                x$dependency <- c(dependency(value), x$dependency)
                x$outfiles <- c(outfiles(value), x$outfiles)
                x$SE <- c(value$SE, x$SE)
                x$targets_connection <- c(value$targets_connection, x$targets_connection)
                x$runInfo$runOption <- c(value$runInfo$runOption, x$runInfo$runOption)
            } else if (after >= lengx) {
                x$stepsWF <- c(x$stepsWF, value$stepsWF)
                x$targetsWF <- c(x$targetsWF, targetsWF(value))
                x$statusWF <- c(x$statusWF, value$statusWF)
                x$dependency <- c(x$dependency, dependency(value))
                x$outfiles <- c(x$outfiles, outfiles(value))
                x$SE <- c(x$SE, value$SE)
                x$targets_connection <- c(x$targets_connection, value$targets_connection)
                x$runInfo$runOption <- c(x$runInfo$runOption, value$runInfo$runOption)
            } else {
                after_tc <- names(x$stepsWF)[1L:after]
                before_tc <- names(x$stepsWF)[(after + 1L):lengx]
                x$targets_connection <- c(x$targets_connection[names(x$targets_connection) %in% after_tc], value$targets_connection, x$targets_connection[names(x$targets_connection) %in% before_tc])
                x$stepsWF <- c(x$stepsWF[1L:after], value$stepsWF, x$stepsWF[(after + 1L):lengx])
                x$targetsWF <- c(x$targetsWF[1L:after], targetsWF(value), x$targetsWF[(after + 1L):lengx])
                x$statusWF <- c(x$statusWF[1L:after], value$statusWF, x$statusWF[(after + 1L):lengx])
                x$dependency <- c(x$dependency[1L:after], dependency(value), x$dependency[(after + 1L):lengx])
                x$outfiles <- c(x$outfiles[1L:after], outfiles(value), x$outfiles[(after + 1L):lengx])
                x$SE <- c(x$SE[1L:after], value$SE, x$SE[(after + 1L):lengx])
                x$runInfo$runOption <- c(x$runInfo$runOption[1L:after], value$runInfo$runOption, x$runInfo$runOption[(after + 1L):lengx])
            }
            x <- as(x, "SYSargsList")
        } else if (inherits(value, "LineWise")) {
            if (value$stepName == "Step_x") {
                step_name <- paste0("Step_", after + 1L)
            } else {
                step_name <- value$stepName
            }
            x <- sysargslist(x)
            if (!after) {
                x$stepsWF <- c(value, x$stepsWF)
                x$targetsWF <- c(list(S4Vectors::DataFrame()), x$targetsWF)
                x$statusWF <- c(list(value$status), x$statusWF)
                x$dependency <- c(value$dependency, x$dependency)
                x$outfiles <- c(list(S4Vectors::DataFrame()), x$outfiles)
                x$SE <- c(list(NULL), x$SE)
                x$targets_connection <- c(list(NULL), x$targets_connection)
                x$runInfo$runOption <- c(value$runInfo$runOption, x$runInfo$runOption)
            } else if (after >= lengx) {
                x$stepsWF <- c(x$stepsWF, value)
                x$targetsWF <- c(x$targetsWF, list(S4Vectors::DataFrame()))
                x$statusWF <- c(x$statusWF, list(value$status))
                x$dependency <- c(x$dependency, value$dependency)
                x$outfiles <- c(x$outfiles, list(S4Vectors::DataFrame()))
                x$SE <- c(x$SE, list(NULL))
                x$targets_connection <- c(x$targets_connection, list(NULL))
                x$runInfo$runOption <- c(x$runInfo$runOption, value$runInfo$runOption)
            } else {
                after_tc <- names(x$stepsWF)[1L:after]
                before_tc <- names(x$stepsWF)[(after + 1L):lengx]
                x$targets_connection <- c(x$targets_connection[names(x$targets_connection) %in% after_tc], list(NULL), x$targets_connection[names(x$targets_connection) %in% before_tc])
                x$stepsWF <- c(x$stepsWF[1L:after], value, x$stepsWF[(after + 1L):lengx])
                x$targetsWF <- c(x$targetsWF[1L:after], list(S4Vectors::DataFrame()), x$targetsWF[(after + 1L):lengx])
                x$statusWF <- c(x$statusWF[1L:after], list(value$status), x$statusWF[(after + 1L):lengx])
                x$dependency <- c(x$dependency[1L:after], value$dependency, x$dependency[(after + 1L):lengx])
                x$outfiles <- c(x$outfiles[1L:after], list(S4Vectors::DataFrame()), x$outfiles[(after + 1L):lengx])
                x$SE <- c(x$SE[1L:after], list(NULL), x$SE[(after + 1L):lengx])
                x$runInfo$runOption <- c(x$runInfo$runOption[1L:after], value$runInfo$runOption, x$runInfo$runOption[(after + 1L):lengx])
            }
            names(x$stepsWF)[after + 1L] <- step_name
            names(x$statusWF)[after + 1L] <- step_name
            names(x$dependency)[after + 1L] <- step_name
            names(x$targetsWF)[after + 1L] <- step_name
            names(x$outfiles)[after + 1L] <- step_name
            names(x$SE)[after + 1L] <- step_name
            names(x$targets_connection)[after + 1L] <- step_name
            names(x$runInfo$runOption)[after + 1L] <- step_name
            x <- as(x, "SYSargsList")
        } else {
            stop("Argument 'value' needs to be assigned an object of class 'SYSargsList' OR 'LineWise'.")
        }
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Internal functions ##
.check_write_SYSargsList <- function(x, silent = TRUE) {
    if (!inherits(x, "SYSargsList")) stop("Argument 'x' needs to be assigned an object of class 'SYSargsList'.")
    sys.file <- projectInfo(x)$sysargslist
    if (is.null(sys.file)) {
        if (interactive()) {
            init <- readline(cat(
                cat(crayon::bgMagenta("** Object 'x' was NOT initialized with SPRproject function! **\n")),
                "Do you like to initialize the project now using the default values?", "Type a number: \n",
                "\n 1. Please create the project \n 2. I don't need the project information \n 3. Quit"
            ))
        } else {
            ## For an non-interactive session
            init <- "1"
        }
        if (init == "1") {
            init <- SPRproject()
            x[["projectInfo"]] <- init$projectInfo
            sys.file <- projectInfo(x)$sysargslist
            write_SYSargsList(x, sys.file, silent = TRUE)
            return(x)
        } else if (init == "2") {
            print("For more details, check help(SRRproject)")
            return(x)
        } else if (init == "3") {
            stop("Quiting...")
        }
    } else if (!is.null(sys.file)) {
        sys.file <- file.path(projectInfo(x)$project, projectInfo(x)$sysargslist)
        write_SYSargsList(x, sys.file, silent = silent)
        return(x)
    }
}

## Internal functions ##
.validationStepConn <- function(x, value) {
    ## used in `importWF`
    on.exit({
        options(spr_importing = FALSE)
        options(replace_step = FALSE)
    })
    targetsCon <- value$targets_connection[[1]]
    ## Check outfiles names
    value_out <- targetsCon[[1]][[1]]
    if (any(duplicated(unlist(lapply(value_out, function(y) names(outfiles(x)[[y]])))))) {
        stop("'outfiles' columns names need to be unique for the steps provide in the targets argument.", call. = FALSE)
    }
    ## Check value length
    ## only one step at the time
    if (length(value) > 1) stop("One step can be appended in each operation.", call. = FALSE)
    if (!is.null(targetsCon[[1]])) {
        step <- targetsCon[[1]][[1]]
        if (any(!step %in% names(stepsWF(x)))) {
            stop("'targets' argument needs to be assigned as valid targets file OR ", "\n",
                "the names of a previous step, for example: ", "\n",
                paste0(names(stepsWF(x)), collapse = " OR "),
                call. = FALSE
            )
        }
        ## check new_targets_col
        all_names <- unlist(append(
            lapply(outfiles(x), function(y) names(y)),
            unique(unlist(lapply(targetsWF(x)[step], function(y) names(y))))
        ))
        if (!all(targetsCon[[2]][[1]] %in% all_names)) stop("Invalid `inputVars`.", call. = FALSE)
        new_targets_col <- targetsCon[[2]][[1]][!targetsCon[[2]][[1]] %in% unlist(lapply(targetsWF(x)[step], function(y) names(y)))]
        new_targets <- .cbindTargetsOutfiles(x, step, new_targets_col, targetsCon[[3]][[1]])
        new_targetsheader <- sapply(step, function(y) targetsheader(x, y))
        if (!all(sapply(new_targetsheader, function(x) identical(x, new_targetsheader[[1]])))) {
            stop("Step(s) you selected have different targetsheader(x), cannot use these step(s) as targets connections", call. = FALSE)
        }
        new_targetsheader <- new_targetsheader[1]
        names(new_targetsheader) <- "targetsheader"
        WF <- value$stepsWF[[1]]
        WF2 <- updateWF(WF, new_targets = targets.as.list(data.frame(new_targets)), new_targetsheader = new_targetsheader, inputvars = WF$inputvars, write.yaml = FALSE)
        value <- sysargslist(value)
        value$stepsWF[[1]] <- WF2
        value$targetsWF[[1]] <- as(WF2, "DataFrame")
        ## SE object update
        rownames(value$targetsWF[[1]]) <- value$targetsWF[[1]][, value$stepsWF[[1]]$files$id]
        value$SE <- list(SummarizedExperiment::SummarizedExperiment(
            colData = value$targetsWF,
            metadata = value$stepsWF[[1]]$targetsheader
        ))
        names(value$SE) <- names(value$targetsWF)
        value$outfiles[[1]] <- output.as.df(WF2)
        value$statusWF[[1]] <- WF2$status
        rownames(value$outfiles[[1]]) <- value$targetsWF[[1]][, value$stepsWF[[1]]$files$id]
        rownames(value$statusWF[[1]]$status.completed) <- value$targetsWF[[1]][, value$stepsWF[[1]]$files$id]
        rownames(value$statusWF[[1]]$status.time) <- value$targetsWF[[1]][, value$stepsWF[[1]]$files$id]
        value <- as(value, "SYSargsList")
    }
    if (inherits(value, "SYSargs2")) {
        value[["statusWF"]][[1]]$status.completed <- cbind(check.output(value)[[1]], value$statusWF[[1]]$status.completed[5:ncol(value$statusWF[[1]]$status.completed)])
    }
    if (all(!is.na(dependency(value)) && !getOption("spr_importing", FALSE) && !getOption("replace_step", FALSE))) {
        dep <- dependency(value)[[1]]
        if (inherits(dep, "character")) {
            if (all(!dep %in% names(stepsWF(x)))) {
                stop(
                    "'dependency' argument needs to be assigned as valid previous Step Name, for example: ", "\n",
                    paste0(names(stepsWF(x)), collapse = " OR ")
                )
            }
        } else {
            if (inherits(dep, "numeric")) {
                if (all(!dep %in% 1:length(stepsWF(x)))) {
                    stop(
                        "'dependency' argument needs to be assigned as valid previous Step Index, for example: ", "\n",
                        paste0(1:length(stepsWF(x)), collapse = " OR ")
                    )
                }
            }
        }
    }
    return(value)
}

## Internal functions ##
.cbindTargetsOutfiles <- function(sal, targets_con, new_targets_col, rm_targets_con = NULL) {
    . <- print_targets <- NULL
    ## handle outfiles
    outfiles <- outfiles(sal)[targets_con] %>%
        lapply(as.data.frame) %>%
        {
            .[lapply(., function(x) nrow(x) > 0) %>% unlist()]
        }
    if (length(targets) > 1) {
        outfiles_length <- lapply(outfiles, nrow) %>% unlist()
        if (
            (length(unique(outfiles_length)) > 2) ||
                (outfiles_length[1] != mean(outfiles_length)) &&
                    (!1 %in% outfiles_length)
        ) {
            stop("Steps you selected have different Sample length in outfiles, cannot use these steps as targets connections")
        }
    }
    outfiles <- data.frame(lapply(outfiles, function(x) x[colnames(x) %in% new_targets_col]))
    colnames(outfiles) <- new_targets_col
    ## handle targets
    targets <- targetsWF(sal)[targets_con] %>%
        lapply(as.data.frame) %>%
        {
            .[lapply(., function(x) nrow(x) > 0) %>% unlist()]
        }
    ## cases of removal of columns
    if (!is.null(rm_targets_con)) targets <- lapply(targets, function(x) x[!colnames(x) %in% rm_targets_con])
    if (length(targets) > 1) {
        targets_length <- lapply(targets, nrow) %>% unlist()
        if (
            (length(unique(targets_length)) > 2) ||
                (targets_length[1] != mean(targets_length)) &&
                    (!1 %in% targets_length)
        ) {
            stop("Steps you selected have different Sample length in targets, cannot use these steps as targets connections")
        }
        targets <- lapply(seq_along(targets), function(x) {
            if (x == 1) {
                return(targets[[x]])
            }
            print_targets <- names(targets[x])
            names(targets[[x]]) <- paste0(names(targets[[x]]), "_", names(targets[x]))
            targets[[x]]
        })
        if (exists("print_targets")) message("columns in step ", print_targets, " has been renamed with `<columnName>_<StepName>`.")
    }
    names <- unlist(lapply(targets, function(y) names(y)))
    targets <- do.call(cbind, targets)
    colnames(targets) <- names
    ## merge both
    df <- if (length(outfiles) == 0 && length(targets) != 0) {
        targets
    } else if (length(outfiles) != 0 && length(targets) == 0) {
        outfiles
    } else if (length(outfiles) == 0 && length(targets) == 0) {
        stop("Selected steps don't have any targets or outfiles, try to choose other steps as targets connections")
    } else {
        if (nrow(targets) != nrow(outfiles) && nrow(outfiles) != 1) {
            stop("Step(s) you selected have different length in",
                "outfiles and targets dataframes or the outfiles",
                "length is not 1, this is not allowed",
                call. = FALSE
            )
        }
        df <- cbind(outfiles, targets)
    }
    return(df)
}

## Usage:
# appendStep(sal) <- SYSargsList(WF)
# appendStep(sal, after=0) <- SYSargsList(WF)
# appendStep(sal, after=0, step_index="test_11") <- SYSargsList(WF)

## Replacement method
setReplaceMethod(
    f = "yamlinput", signature = c("SYSargsList"),
    definition = function(x, step, paramName, value) {
        if (length(step) > 1) stop("Only ONE step can be selected at the time")
        x_sub <- x[step]
        args <- x_sub@stepsWF[[1]]
        if (!inherits(args, "SYSargs2")) stop("Please selected a 'SYSargs2' step")
        yamlinput(args, paramName) <- value
        x <- sysargslist(x)
        x$stepsWF[[step]] <- args
        x <- as(x, "SYSargsList")
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "replaceStep", signature = c("SYSargsList"),
    definition = function(x, step, step_name = "default", value) {
        on.exit({
            options(spr_importing = FALSE)
            options(replace_step = FALSE)
            options(appendPlus = FALSE)
        })
        if (any(!inherits(value, "SYSargsList") && !inherits(value, "LineWise"))) {
            stop("Argument 'value' needs to be assigned an object of class 'SYSargsList' or 'LineWise'.")
        }
        if (all(inherits(value, "SYSargsList") && length(value) > 1)) stop("Argument 'value' cannot have 'length(value) > 1")
        ## Check step name or index on x
        if (inherits(step, "numeric")) {
            if (step > length(x)) {
                stop("Argument 'step' cannot be greater than ", length(x))
            }
        } else if (inherits(step, "character")) {
            if (!step %in% stepName(x)) {
                stop(
                    "Argument 'step' needs to be assigned one of the following: ",
                    paste(stepName(x), collapse = " OR ")
                )
            }
            step <- grep(step, stepName(x))
        }
        ## Dependency
        if (step > 1) {
            if (all(dependency(value) %in% "")) value[["dependency"]][[1]] <- NA
            if (any(!value$dependency[[1]][!value$dependency[[1]] %in% NA] %in% stepName(x))) {
                stop(
                    "Dependency value needs to be present in the Workflow. ",
                    "Options are: ", "\n",
                    paste0(stepName(x)[1:step - 1], collapse = ", ")
                )
            }
        } else if (step == 1) {
            ## first step usually is ""
            if (!is.na(dependency(value))) {
                if (!value$dependency[[1]] %in% stepName(x)) {
                    warning("The dependency step specify is not in the Workflow. Please check the dependency tree.")
                }
            }
        }
        ## Update connections
        on.exit({
            options(replace_step = TRUE)
        })
        if (inherits(value, "SYSargsList")) value <- .validationStepConn(x[-c(step)], value)
        ## replace
        x <- sysargslist(x)
        if (inherits(value, "SYSargsList")) {
            x$stepsWF[step] <- value$stepsWF
            x$statusWF[step] <- value$statusWF
            x$targetsWF[step] <- value$targetsWF
            x$outfiles[step] <- value$outfiles
            x$SE[step] <- value$SE
            x$dependency[step] <- value$dependency
            x$targets_connection[step] <- value$targets_connection
            x$runInfo[["runOption"]][step] <- value$runInfo[["runOption"]]
        } else if (inherits(value, "LineWise")) {
            x$stepsWF[[step]] <- value
            x$statusWF[[step]] <- value$status
            x$targetsWF[[step]] <- S4Vectors::DataFrame()
            x$outfiles[[step]] <- S4Vectors::DataFrame()
            x$SE[step] <- list(NULL)
            x$dependency[[step]] <- value$dependency[[1]]
            x$targets_connection[[step]] <- list(NULL)
            x$runInfo[["runOption"]][step] <- value$runInfo[["runOption"]]
        }
        x <- as(x, "SYSargsList")
        ## rename
        if (step_name == "default") {
            name <- stepName(value)
            if (name %in% stepName(x)) {
                renameStep(x, step) <- paste0("Step_", step)
                cat(paste0("Index name of x", "[", step, "]", " was rename to ", paste0("Step_", step), " to avoid duplications."))
            } else {
                renameStep(x, step) <- stepName(value)
            }
        } else {
            renameStep(x, step) <- step_name
        }
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "updateStatus", signature = c("SYSargsList"),
    definition = function(x, step, value) {
        if (!inherits(value, "SYSargsList")) {
            stop("Argument 'value' needs to be assigned an object of class 'SYSargsList'.")
        }
        if (length(step) > 1) stop("Argument 'step' cannot have 'length(step) > 1")
        if (!all(stepName(value) %in% stepName(x))) stop("Argument 'value' are required to have the same stepName then x")
        ## Check step name or index on x
        if (inherits(step, "numeric")) {
            if (step > length(x)) stop("Argument 'step' cannot be greater than ", length(x))
            step <- stepName(x)[step]
        } else if (inherits(step, "character")) {
            if (!step %in% stepName(x)) {
                stop(
                    "Argument 'step' needs to be assigned one of the following: ",
                    paste(stepName(x), collapse = " OR ")
                )
            }
        }
        ## Dependency
        if (!all(dependency(x)[[step]] == dependency(value)[[step]])) {
            stop("'dependency' for 'x' and 'value' objects are required to have the same structure")
        }
        ## replace
        extra <- which(dependency(x) %in% stepName(x[step]))
        extra <- c(step, extra)
        x <- sysargslist(x)
        if (inherits(value, "SYSargsList")) {
            x$stepsWF[extra] <- value$stepsWF[extra]
            x$statusWF[extra] <- value$statusWF[extra]
            x$targetsWF[extra] <- value$targetsWF[extra]
            x$outfiles[extra] <- value$outfiles[extra]
            x$SE[extra] <- value$SE[extra]
            x$runInfo[["runOption"]][extra] <- value$runInfo[["runOption"]][extra]
            if (!is.null(value$projectInfo$logsFile)) {
                if (!is.null(x$projectInfo$logsFile)) {
                    cat(readLines(value$projectInfo$logsFile),
                        file = x$projectInfo$logsFile, sep = "\n",
                        append = TRUE
                    )
                }
            }
        }
        x <- as(x, "SYSargsList")
        if (length(ls(value$runInfo$env)) > 0) {
            copyEnvir(value, new.env = x$runInfo$env, silent = TRUE)
        }
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "renameStep", signature = c("SYSargsList"),
    definition = function(x, step, ..., value) {
        ## checking step and value length
        if (length(step) != length(value)) stop("value argument needs to be the same length of the step for rename")
        ## checking for special characters
        if (inherits(value, "character")) {
            .checkSpecialChar(value)
        } else {
            stop("Replace value needs to be assigned an 'character' name for the workflow step.")
        }
        ## if the replace has the same name
        if (any(value %in% stepName(x)[step])) {
            return(x)
        }
        ## step_name duplication
        if (any(value %in% stepName(x))) stop("Steps Names need to be unique.")
        ## Check step name or index on x
        if (inherits(step, "numeric")) {
            if (length(step) > length(x)) {
                stop("Argument 'step' cannot be greater than ", length(x))
            }
        } else if (inherits(step, "character")) {
            if (!all(step %in% stepName(x))) {
                stop(
                    "Argument 'step' needs to be assigned one of the following: ",
                    paste(stepName(x), collapse = " OR ")
                )
            }
            step <- sapply(as.list(step), function(y) grep(y, stepName(x)))
        }
        for (i in seq_along(step)) {
            original <- names(x@stepsWF)[step[i]]
            names(x@stepsWF)[step[i]] <- value[i]
            names(x@statusWF)[step[i]] <- value[i]
            names(x@dependency)[step[i]] <- value[i]
            names(x@targetsWF)[step[i]] <- value[i]
            names(x@outfiles)[step[i]] <- value[i]
            names(x@SE)[step[i]] <- value[i]
            names(x@targets_connection)[step[i]] <- value[i]
            if (!is.null(x$runInfo$runOption)) {
                names(x@runInfo$runOption)[step[i]] <- value[i]
            }
            ## check in dependency step
            x[["dependency"]] <- lapply(x$dependency, function(y) gsub(original, value[i], y))
            ## check in targets_connection step
            x[["targets_connection"]] <- lapply(x$targets_connection, function(y) {
                if (!is.null(y)) {
                    lapply(y, function(w) {
                        if (all(w == original)) {
                            sub(original, value[i], w)
                        } else {
                            w
                        }
                    })
                }
            })
        }
        ## Save
        if (!is.null(x$projectInfo$sysargslist)) {
            x <- .check_write_SYSargsList(x)
        }
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "dependency", signature = c("SYSargsList"),
    definition = function(x, step, ..., value) {
        ## checking step length
        if (length(step) > 1) stop("Dependency of one step at the time can be replaced...")
        ## Check step name or index on x
        if (inherits(step, "numeric")) {
            if (step > length(x)) {
                stop("Argument 'step' cannot be greater than ", length(x))
            }
            if (all(any(!value %in% stepName(x)[step:1]) && !is.na(value))) {
                stop("Dependency name cannot be found in the workflow.")
            }
        } else if (inherits(step, "character")) {
            if (!step %in% stepName(x)) {
                stop(
                    "Argument 'step' needs to be assigned one of the following: ",
                    paste(stepName(x), collapse = " OR ")
                )
            }
            step <- grep(step, stepName(x))
            if (all(any(!value %in% stepName(x)[step:1]) && !is.na(value))) {
                stop("Dependency name cannot be found in the workflow.")
            }
        }
        x@dependency[[step]] <- value
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "replaceCodeLine", signature = c("SYSargsList"),
    definition = function(x, step, line, value) {
        if (!inherits(value, "LineWise")) {
            stop("The value argument needs to be assigned a 'LineWise' object")
        }
        y <- x$stepsWF[step][[1]]
        if (!inherits(y, "LineWise")) {
            stop("The step argument needs to be assigned a 'LineWise' object")
        }
        y <- as(y, "list")
        y$codeLine <- as.character(y$codeLine)
        if (missing(line)) {
            y$codeLine <- as.character(value$codeLine)
        } else {
            y$codeLine[line] <- as.character(value$codeLine)
        }
        y$codeLine <- parse(text = y$codeLine)
        y <- as(y, "LineWise")
        x <- as(x, "list")
        x$stepsWF[step][[1]] <- y
        x <- as(x, "SYSargsList")
        sys.file <- projectInfo(x)$sysargslist
        write_SYSargsList(x, sys.file, silent = TRUE)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "appendCodeLine", signature = c("SYSargsList"),
    definition = function(x, step, after = NULL, value) {
        if (is.null(after)) after <- length(stepsWF(x[step])[[1]])
        y <- x$stepsWF[step][[1]]
        if (!inherits(y, "LineWise")) stop("Provide 'LineWise' class object")
        lengx <- length(y)
        y <- linewise(y)
        value <- parse(text = value)
        if (!after) {
            y$codeLine <- c(value, y$codeLine)
        } else if (after >= lengx) {
            y$codeLine <- c(y$codeLine, value)
        } else {
            y$codeLine <- c(y$codeLine[1L:after], value, y$codeLine[(after + 1L):lengx])
        }
        y <- as(y, "LineWise")
        x <- as(x, "list")
        x$stepsWF[step][[1]] <- y
        x <- as(x, "SYSargsList")
        sys.file <- projectInfo(x)$sysargslist
        write_SYSargsList(x, sys.file, silent = TRUE)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "stepsWF", signature = c("SYSargsList"),
    definition = function(x, step, ..., value) {
        x@stepsWF[[step]] <- value
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "statusWF", signature = c("SYSargsList"),
    definition = function(x, step, ..., value) {
        x@statusWF[[step]] <- value
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "runInfo", signature = c("SYSargsList"),
    definition = function(x, step, param, ..., value) {
        x@runInfo$runOption[[step]][[param]] <- value
        x <- .check_write_SYSargsList(x)
        x
    }
)

## Replacement method
setReplaceMethod(
    f = "SE", signature = c("SYSargsList"),
    definition = function(x, step, ..., value) {
        if (is.numeric(step)) {
            step <- stepName(x)[step]
        }
        if (!inherits(value, "SummarizedExperiment")) stop("Provide 'SummarizedExperiment' class object")
        x@SE[[step]] <- value
        x <- .check_write_SYSargsList(x)
        x
    }
)

###########################################################
## Additional utilities for SYSargs and SYSargs2 objects ##
###########################################################

######################################################
## Convenience write function for targetsout(args) ##
######################################################
writeTargetsout <- function(x, file = "default", silent = FALSE, overwrite = FALSE, step = NULL, new_col = NULL,
                            new_col_output_index = NULL, remove = FALSE, ...) {
    if (all(class(x) != "SYSargs" & class(x) != "SYSargs2")) stop("Argument 'x' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2")
    ## SYSargs class
    if (class(x) == "SYSargs") {
        targets <- targetsout(x)
        software <- software(x)
        if (file == "default") {
            file <- paste("targets_", software, ".txt", sep = "")
            file <- gsub(" {1,}", "_", file)
        } else {
            file <- file
        }
        headerlines <- targetsheader(x)
        ## SYSargs2 class
    } else if (class(x) == "SYSargs2") {
        if (is.null(step)) {
            stop(
                "Argument 'step' needs to be assigned one of the following values: ",
                paste(names(x$clt), collapse = ", "), " OR the corresponding position"
            )
        }
        if (all(!is.null(step) & is.character(step) & !any(names(x$clt) %in% step))) {
            stop(
                "Argument 'step' can only be assigned one of the following values: ",
                paste(names(x$clt), collapse = ", "), " OR the corresponding position"
            )
        }
        if (all(!is.null(step) & is.numeric(step) & !any(seq_along(names(x$clt)) %in% step))) {
            stop(
                "Argument 'step' can only be assigned one of the following position: ",
                paste(seq_along(names(x$clt)), collapse = ", "), " OR the corresponding names"
            )
        }
        targets <- targets.as.df(targets(x))
        if (remove == TRUE) {
            targets <- targets[, -c(which(grepl("FileName", colnames(targets))))]
        }
        ## Adding the columns
        if ((!is.null(new_col) & is.null(new_col_output_index)) |
            (is.null(new_col) & !is.null(new_col_output_index)) |
            (is.null(new_col) & is.null(new_col_output_index))) {
            cat("One of 'new_col' and 'new_col_output_index' is null. It is using default column naming and adding all the output files expected, and each one will be written in a different column. \n")
            for (i in seq_len(length(output(x)[[1]][[step]]))) {
                pout <- sapply(names(output(x)), function(y) output(x)[[y]][[step]][[i]], simplify = FALSE)
                targets[[paste0(files(x)$steps, "_", i)]] <- as.character(pout)
            }
        } else if (!is.null(new_col) & !is.null(new_col_output_index)) {
            if (any(length(output(x)[[1]][[step]]) < new_col_output_index) | any(new_col_output_index < 1)) {
                stop("'new_col_output_index' argument needs to be equal or bigger than 1 and smaller than ", length(output(x)[[1]][[1]]), ", the maximum number of outputs files.")
            }
            if (length(new_col) != length(new_col_output_index)) {
                stop("'new_col' should have the same length as 'new_col_output_index'")
            }
            for (i in seq_along(new_col)) {
                pout <- sapply(names(output(x)), function(y) output(x)[[y]][[step]][[new_col_output_index[i]]], simplify = FALSE)
                targets[[as.character(new_col[i])]] <- as.character(pout)
            }
        }
        ## Workflow and Step Name
        software <- strsplit(basename(files(x)$cwl), split = "\\.")[[1]][1]
        if (is.character(step)) {
            step <- strsplit(step, split = "\\.")[[1]][1]
        } else {
            step <- strsplit(names(x$clt)[step], split = "\\.")[[1]][1]
        }
        if (file == "default") {
            file <- paste("targets_", step, ".txt", sep = "")
            file <- gsub(" {1,}", "_", file)
        } else {
            file <- file
        }
        headerlines <- targetsheader(x)[[1]]
        names <- c(new_col, colnames(targets[, -c(which(grepl(paste(new_col, collapse = "|"), colnames(targets))))]))
        targets <- cbind(targets[, new_col], targets[, -c(which(grepl(paste(new_col, collapse = "|"), colnames(targets))))])
        colnames(targets) <- names
    }
    if (file.exists(file) & overwrite == FALSE) stop("I am not allowed to overwrite files; please delete existing file: ", file, " or set 'overwrite=TRUE'")
    targetslines <- c(paste(colnames(targets), collapse = "\t"), apply(targets, 1, paste, collapse = "\t"))
    writeLines(c(headerlines, targetslines), file, ...)
    if (silent != TRUE) cat("\t", "Written content of 'targetsout(x)' to file:", file, "\n")
}
## Usage:
# writeTargetsout(x=args, file="default") ## SYSargs class
# writeTargetsout(x=WF, file="default", step=1, new_col = "FileName1", new_col_output_index = 1) ## SYSargs2 class

##############################################################################
## Function to run NGS aligners including sorting and indexing of BAM files ##
##############################################################################
runCommandline <- function(args, runid = "01",
                           make_bam = FALSE, del_sam = TRUE,
                           dir = TRUE, dir.name = NULL,
                           force = FALSE, input_targets = NULL, ...) {
    ## Validation for 'args'
    if (any(!inherits(args, "SYSargs") & !inherits(args, "SYSargs2"))) stop("Argument 'args' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2'")
    ## Environment Modules section
    .moduleload(args)
    ## SYSargs class ##
    if (class(args) == "SYSargs") {
        .sysargsrunCommandline(args = args, runid = runid, make_bam = make_bam, del_sam = del_sam)
    } else if (class(args) == "SYSargs2") {
        ## SYSargs2 class ##
        ## Workflow Name (Workflow OR CommandLineTool class)
        if (length(wf(args)$steps) == 0) {
            cwl.wf <- gsub("[[:space:]]", "_", paste(baseCommand(args), collapse = "_"), perl = TRUE)
        } else {
            cwl.wf <- Biostrings::strsplit(basename(files(args)$cwl), split = "\\.")[[1]][1]
        }
        ## Check if "results" folders exists...
        if (!dir.exists(file.path(yamlinput(args)$results_path$path))) {
            stop("Please check our current directory ('getwd()').
           The PATH defined at `yamlinput(args)` was not found and it is required.")
        }
        logdir <- file.path(yamlinput(args)$results_path$path)
        if (is.null(dir.name)) {
            dir.name <- cwl.wf
        } else {
            dir.name <- dir.name
        }
        ## Check if expected files exists or not
        ## Important: this happen in the new location in the case of dir=TRUE
        return <- .checkOutArgs2(args,
            make_bam = make_bam, dir = dir, dir.name = dir.name,
            force = force, del_sam = del_sam
        )
        args.return <- return$args_complete
        completed <- return$completed
        args <- return$args
        ## Check if the command line is exported
        if (!baseCommand(args) == c("bash")) {
            cmd_test <- tryCMD(command = baseCommand(args), silent = TRUE)
            if (cmd_test == "error") {
                stop(
                    "\n", baseCommand(args), ": command not found. ",
                    "\n", "Please make sure to configure your PATH environment variable according to the software in use.",
                    call. = FALSE
                )
            }
        }
        ## Create log files
        file_log <- file.path(logdir, paste0(
            "submitargs", runid, "_",
            dir.name, "_log_",
            format(Sys.time(), "%b%d%Y_%H%Ms%S"),
            paste(sample(0:9, 4), collapse = "")
        ))
        ## Check input
        if (length(args$inputvars) >= 1) {
            inpVar <- args$inputvars
            check.inp <- colSums(sapply(inpVar, function(y) sapply(yamlinput(args), function(x) x["path"] %in% y)))
            df.targets <- targets.as.df(args$targets)[names(check.inp[check.inp > 0])]
            inp_targets2 <- FALSE
        } else {
            inp_targets2 <- TRUE
        }
        ## Targets input
        if (!is.null(input_targets)) {
            if (inherits(input_targets, c("numeric", "integer"))) {
                if (!all(input_targets %in% seq_along(cmdlist(args)))) {
                    stop("Please select the 'input_targets' number accordingly, options are: ", "\n",
                        "        ", paste0(seq_along(cmdlist(args)), collapse = ", "),
                        call. = FALSE
                    )
                }
            } else if (inherits(input_targets, "character")) {
                if (!all(input_targets %in% SampleName(args))) {
                    stop("Please select the 'input_targets' name accordingly, options are: ", "\n",
                        "        ", paste0(SampleName(args), collapse = ", "),
                        call. = FALSE
                    )
                }
                input_targets <- which(SampleName(args) %in% input_targets)
            }
            input_targets <- input_targets
        } else {
            input_targets <- seq_along(cmdlist(args))
        }
        ## Sample status and Time
        sample_status <- sapply(names(cmdlist(args)), function(x) {
            list(sapply(args$files$steps, function(x) list(NULL)))
        })
        sample_status <- sample_status[input_targets]
        time_status <- args$status$status.time
        ## Progress bar
        pb <- utils::txtProgressBar(min = 0, max = length(input_targets), style = 3)
        ## LOOP
        for (i in input_targets) {
            ii <- names(cmdlist(args)[i])
            utils::setTxtProgressBar(pb, i)
            cat("## ", names(cmdlist(args)[i]), "\n", file = file_log, fill = TRUE, append = TRUE)
            ## Time
            time_status[ii, ]$time_start <- as.POSIXct(Sys.time(), origin = "1970-01-01")
            for (j in seq_along(cmdlist(args)[[i]])) {
                ## Add_command file at log file
                cat(c(
                    paste0("Time: ", paste0(format(Sys.time(), "%b%d%Y_%H%Ms%S"))), "\n",
                    "### Code: ",
                    "```{r, eval=FALSE} ",
                    cmdlist(args)[[i]][[j]][[1]],
                    "```", "\n",
                    "### Stdout: ",
                    "```{r, eval=FALSE}"
                ), file = file_log, sep = "\n", append = TRUE)
                ## Run the commandline only for samples for which no output file is available OR force == TRUE
                if (all(force == FALSE && all(as.logical(completed[[i]][[j]])))) {
                    cat("The expected output file(s) already exist", "\n", file = file_log, fill = TRUE, append = TRUE)
                    ## close R chunk
                    cat("```", file = file_log, sep = "\n", append = TRUE)
                    sample_status[[ii]][[args$files$steps[j]]] <- "Success"
                    next()
                } else {
                    ## Create an object for executable
                    command <- gsub(" .*", "", as.character(cmdlist(args)[[i]][[j]]))
                    commandargs <- gsub("^.*? ", "", as.character(cmdlist(args)[[i]][[j]]))
                    ## Return an error if input file doesn't exist
                    if (all(inp_targets2) || all(inp_targets <- file.exists(as.character(df.targets[i, ])))) {
                        stdout <- .tryRunC(command, commandargs)
                    } else {
                        stdout <- list(
                            stdout = paste(paste0(as.character(df.targets[i, ])[!inp_targets], collapse = ", "), "\n are missing"),
                            warning = "", error = "We have an error because target(s) file doesn't exit"
                        )
                    }
                    cat(stdout$stdout, file = file_log, sep = "\n", append = TRUE)
                    ## report status
                    if (!is.null(stdout$error)) {
                        cat("## Error", file = file_log, sep = "\n", append = TRUE)
                        cat(stdout$error, file = file_log, sep = "\n", append = TRUE)
                        sample_status[[ii]][[args$files$steps[j]]] <- "Error"
                    } else if (!is.null(stdout$warning)) {
                        cat("## Warning", file = file_log, sep = "\n", append = TRUE)
                        cat(stdout$warning, file = file_log, sep = "\n", append = TRUE)
                        sample_status[[ii]][[args$files$steps[j]]] <- "Warning"
                    } else if (all(is.null(stdout$error) && is.null(stdout$warning))) {
                        sample_status[[ii]][[args$files$steps[j]]] <- "Success"
                    }
                    ## close R chunk
                    cat("```", file = file_log, sep = "\n", append = TRUE)
                }
                ## converting sam to bam using Rsamtools package
                .makeBam(output(args)[[i]][[j]], make_bam = make_bam, del_sam = del_sam)
            }
            time_status[ii, ]$time_end <- as.POSIXct(Sys.time(), origin = "1970-01-01")
        }
        args.return[["files"]][["log"]] <- file_log
        ## In the case of make_bam=TRUE
        if (make_bam == TRUE) {
            args <- .checkOutArgs2(args,
                make_bam = make_bam, dir = FALSE,
                force = force, dir.name = dir.name,
                del_sam = del_sam
            )$args_complete
        }
        ## Create recursive the subfolders
        if (dir == TRUE) {
            for (i in seq_along(names(cmdlist(args)))) {
                full_path <- file.path(logdir, dir.name)
                if (dir.exists(full_path) == FALSE) {
                    dir.create(full_path, recursive = TRUE)
                }
            }
            ## copy log files
            if (dir.exists(file.path(logdir, dir.name, "_logs")) == FALSE) {
                dir.create(file.path(logdir, dir.name, "_logs"), recursive = TRUE)
            }
            file.rename(from = file_log, to = file.path(logdir, dir.name, "_logs", basename(file_log)))
            args.return[["files"]][["log"]] <- file.path(logdir, dir.name, "_logs", basename(file_log))
            ## output FILES
            for (i in seq_along(output(args))) {
                if (length(output(args)[[i]]) > 1) {
                    for (j in seq_along(output(args)[[i]])) {
                        for (k in seq_along(output(args)[[i]][[j]])) {
                            if (file.exists(output(args)[[i]][[j]])) {
                                name <- Biostrings::strsplit(output(args)[[i]][[j]][[k]], split = "\\/")[[1]]
                                name <- name[length(name)]
                                file.rename(from = output(args)[[i]][[j]][[k]], to = file.path(logdir, dir.name, name))
                            } else if (!file.exists(output(args.return)[[i]][[j]][[k]])) {
                                dump <- "No such file or directory"
                            }
                        }
                    }
                } else if (length(output(args)[[i]]) == 1) {
                    for (j in seq_along(output(args)[[i]][[1]])) {
                        if (file.exists(output(args)[[i]][[1]][[j]])) {
                            name <- Biostrings::strsplit(output(args)[[i]][[1]][[j]], split = "\\/")[[1]]
                            name <- name[length(name)]
                            file.rename(from = output(args)[[i]][[1]][[j]], to = file.path(logdir, dir.name, name))
                        } else if (!file.exists(output(args)[[i]][[1]][[j]])) {
                            dump <- "No such file or directory"
                        }
                    }
                }
            }
        }
        ## Status and log.files
        sample_status <- lapply(sample_status, function(x) lapply(x, function(y) if (is.null(y)) y <- "Pending" else y))
        df.status <- data.frame(matrix(do.call("c", sample_status), nrow = length(sample_status), byrow = TRUE))
        colnames(df.status) <- files(args.return)$steps
        check <- check.output(args.return)[input_targets, ]
        df.status.f <- cbind(check, df.status)
        df.status.f[c(2:4)] <- sapply(df.status.f[c(2:4)], as.numeric)
        df.status.f[c(5:ncol(df.status.f))] <- sapply(df.status.f[c(5:ncol(df.status.f))], as.character)
        rownames(df.status.f) <- df.status.f$Targets
        ## updating object
        args.return[["status"]]$status.summary <- .statusSummary(df.status.f)
        args.return[["status"]]$status.completed[match(df.status.f$Targets, args.return[["status"]]$status.completed$Targets), ] <- df.status.f
        args.return[["status"]]$status.time <- time_status
        ## time
        args.return[["status"]]$status.time$time_start <- as.POSIXct(args.return[["status"]]$status.time$time_start, origin = "1970-01-01")
        args.return[["status"]]$status.time$time_end <- as.POSIXct(args.return[["status"]]$status.time$time_end, origin = "1970-01-01")
        # registering total time
        newTimeDF <- args.return[["status"]]$status.time[input_targets, ]
        args.return[["status"]]$total.time <- list(time_start = newTimeDF$time_start[1], time_end = newTimeDF$time_end[length(newTimeDF$time_end)])
        ## double check output file
        cat("\n")
        cat(crayon::blue("---- Summary ----"), "\n")
        print(df.status.f)
        close(pb)
        return(args.return)
    }
}

## Usage:
# WF <- runCommandline(WF, make_bam=TRUE) # creates the files in the ./results folder
# WF <- runCommandline(WF, dir=TRUE) # creates the files in the ./results/workflowName/Samplename folder
# WF <- runCommandline(WF, make_bam = FALSE, dir=TRUE) ## For hisat2-mapping.cwl template
# runid="01"; make_bam=FALSE; del_sam=FALSE; dir=TRUE; dir.name=NULL; force=FALSE
# runid="01"; make_bam=FALSE; del_sam=FALSE; dir=TRUE; dir.name=NULL; force=TRUE
# runid="01"; make_bam=FALSE; del_sam=FALSE; dir=TRUE; dir.name=NULL; force=TRUE

############################################################################################
## batchtools-based function to submit runCommandline jobs to queuing system of a cluster ##
############################################################################################
## The advantage of this function is that it should work with most queuing/scheduling systems such as SLURM, Troque, SGE, ...
clusterRun <- function(args,
                       FUN = runCommandline,
                       more.args = list(args = args, make_bam = TRUE),
                       conffile = ".batchtools.conf.R",
                       template = "batchtools.slurm.tmpl",
                       Njobs, runid = "01", resourceList) {
    checkPkg("batchtools", quietly = FALSE)
    ## Validity checks of inputs
    if (!any(inherits(args, c("SYSargs", "SYSargs2", "SYSargsList")))) {
        stop("Argument 'args' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2'")
    }
    if (!inherits(FUN, "function")) {
        stop("Value assigned to 'FUN' argument is not an object of class function.")
    }
    if (!file.exists(conffile)) {
        stop(
            "Need to point under 'conffile' argument to proper config file. ",
            "See more information here: https://mllg.github.io/batchtools/reference/makeRegistry.html. ",
            "Note: in this file *.tmpl needs to point to a valid template file."
        )
    }
    if (!file.exists(template)) {
        stop(
            "Need to point under 'template' argument to proper template file. ",
            "Sample template files for different schedulers are available here: https://github.com/mllg/batchtools/blob/master/inst/templates/"
        )
    }
    if (!class(more.args) == "list") {
        stop("'more.args' needs to be object of class 'list'.")
    }
    if (any(!names(more.args) %in% names(as.list(formals(FUN))))) {
        stop(
            "The list of arguments assigned to 'more.args' can only be the ",
            "following arguments defined in the function 'FUN':",
            paste(names(as.list(formals(FUN))), collapse = ", ")
        )
    }
    if (grepl("slurm", template)) {
        if (!grepl("slurm", Sys.getenv("PATH"))) {
            try(suppressWarnings(modulecmd_path <- system("which modulecmd", intern = TRUE, ignore.stderr = TRUE)), silent = TRUE)
            ## "Environment Modules" is not available
            if (length(modulecmd_path) == 0) {
                stop("Please export Slurm to your PATH")
                ## "Environment Modules" is available and proceed the module load
            } else if (length(modulecmd_path) > 0) {
                module_out <- moduleload("slurm") # loads specified software from module system
            }
        }
    }
    if (inherits(args, c("SYSargs", "SYSargs2"))) {
        if (!identical(FUN, runCommandline)) stop("For 'SYargs' OR 'SYSargs2' class, please use `FUN=runCommandline` function")
        ## SYSargs class
        if (inherits(args, "SYSargs")) {
            path <- normalizePath(results(args))
            args.f <- seq(along = args)
            ## SYSargs2 class
        } else if (inherits(args, "SYSargs2")) {
            path <- normalizePath(args$yamlinput$results_path$path)
            args.f <- seq(along = cmdlist(args))
        }
        ## batchtools routines
        fct <- function(i, args, ...) FUN(args = args[i], ...)
        logdir1 <- paste0(path, "/submitargs", runid, "_btdb_", paste(sample(0:9, 4), collapse = ""))
        reg <- batchtools::makeRegistry(file.dir = logdir1, conf.file = conffile, packages = "systemPipeR")
        ids <- batchtools::batchMap(fun = fct, args.f, more.args = more.args, reg = reg)
        chunk <- batchtools::chunk(ids$job.id, n.chunks = Njobs, shuffle = FALSE)
        ids$chunk <- chunk
        done <- batchtools::submitJobs(ids = ids, reg = reg, resources = resourceList)
        return(reg)
    } else if (inherits(args, c("SYSargsList"))) {
        if (!identical(FUN, runWF)) stop("For 'SYargsList' class, please use `FUN=runWF` function")
        sal <- args
        fct_sal <- function(i, sal, ...) {
            sal <- runWF(sysargs = sal, ...)
            return(sal)
        }
        path <- normalizePath(sal$projectInfo$results)
        for (j in seq_along(sal)) {
            logdir1 <- paste0(path, "/submitargs", 01, "_btdb_", paste(sample(0:9, 4), collapse = ""))
            reg <- batchtools::makeRegistry(file.dir = logdir1, conf.file = conffile, packages = "systemPipeR")
            ids <- batchtools::batchMap(fun = fct_sal, 1, more.args = list(sal = sal, steps = j), reg = reg)
            chunk <- batchtools::chunk(ids$job.id, n.chunks = 1, shuffle = FALSE)
            ids$chunk <- chunk
            done <- batchtools::submitJobs(ids = ids, reg = reg, resources = resourceList)
            batchtools::waitForJobs()
            sal <- batchtools::loadResult(reg = reg, id = ids)
        }
        return(sal)
    }
}

## Usage:
# targets <- system.file("extdata", "targets.txt", package="systemPipeR")
# dir_path <- system.file("extdata/cwl", package="systemPipeR")
# WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl",
#                    input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
# WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
# WF
# runCommandline(WF[1])
#
# resources <- list(walltime=120, ntasks=1, ncpus=4, memory=1024)
# reg <- clusterRun(WF[1], FUN = runCommandline,
#                   more.args = list(args = WF, make_bam = TRUE),
#                   conffile=".batchtools.conf.R",
#                   template="batchtools.slurm.tmpl",
#                   Njobs=9, runid="01", resourceList=resources)
# getStatus(reg=reg)
# waitForJobs(reg=reg)
#
# sal <- SPRproject(overwrite=TRUE)
# targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")
# appendStep(sal) <- SYSargsList(step_name = "echo", targets=targetspath, dir=TRUE, wf_file="example/workflow_example.cwl", input_file="example/example.yml", dir_path = system.file("extdata/cwl", package="systemPipeR"),inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
#
# appendStep(sal) <- LineWise(code = {
#   hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
# },
# step_name = "R_getCol",
# dependency = "echo")
#
# args <- sal
# sal <- clusterRun(sal, FUN = runWF,
#                   more.args = list(),
#                   conffile=".batchtools.conf.R",
#                   template="batchtools.slurm.tmpl",
#                   Njobs=1, runid="01", resourceList=resources)

########################
## Read preprocessing ##
########################
preprocessReads <- function(args = NULL,
                            FileName1 = NULL, FileName2 = NULL,
                            outfile1 = NULL, outfile2 = NULL,
                            Fct, batchsize = 100000, overwrite = TRUE, ...) {
    ## Checking input either args or individual files
    if (all(is.null(args) && is.null(FileName1) && is.null(outfile1))) {
        stop("At least one argument must be provided, either 'args' or 'FileName1' and 'outfile1'.")
    }
    ## Checking the function argument
    if (class(Fct) != "character") stop("Argument 'Fct' needs to be of class character")
    if (!is.null(args)) {
        if (all(!inherits(args, "SYSargs") & !inherits(args, "SYSargs2"))) stop("Argument 'args' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2")
        if (class(args) == "SYSargs") {
            colnames_args <- colnames(targetsout(args)) # SYSargs
            targets_in <- targetsin(args)
            if (!all(c("FileName1", "FileName2") %in% colnames_args)) {
                outpaths <- outpaths(args) # SYSargs
            } else {
                outpaths1 <- as.character(targetsout(args)$FileName1)
                outpaths2 <- as.character(targetsout(args)$FileName2)
            }
        } else if (class(args) == "SYSargs2") {
            colnames_args <- colnames(targets.as.df(args$targets)) # SYSargs2
            targets_in <- targets.as.df(args$targets)
            if (!all(c("FileName1", "FileName2") %in% colnames_args)) {
                outpaths <- subsetWF(args = args, slot = "output", subset = 1, index = 1)
            } else {
                outpaths1 <- subsetWF(args = args, slot = "output", subset = 1, index = 1)
                outpaths2 <- subsetWF(args = args, slot = "output", subset = 1, index = 2)
            }
        }
    } else if (!is.null(FileName1)) {
        if (!is.null(FileName2)) {
            colnames_args <- c("FileName1", "FileName2")
            targets_in <- data.frame(FileName1, FileName2)
            if (is.null(outfile1) | is.null(outfile2)) stop("'outfile1' and 'outfile2' are required.")
            outpaths1 <- outfile1
            outpaths2 <- outfile2
        } else {
            colnames_args <- c("FileName")
            targets_in <- data.frame(FileName1)
            if (is.null(outfile1)) stop("'outfile1' is required.")
            outpaths <- outfile1
        }
    }
    ## Run function in loop over all fastq files
    ## Single end fastq files
    if (!all(c("FileName1", "FileName2") %in% colnames_args)) {
        for (i in seq(along = outpaths)) {
            outfile <- outpaths[i]
            ## Delete existing fastq files with same names, since writeFastq will append to them
            if (overwrite == TRUE) {
                if (any(file.exists(outfile))) unlink(outfile)
            } else {
                if (any(file.exists(outfile))) stop("File ", outfile, " exists. Please delete file first or set overwrite=TRUE.")
            }
            ## Run preprocessor function with FastqStreamer
            counter <- 0
            f <- ShortRead::FastqStreamer(normalizePath(targets_in$FileName[i]), batchsize)
            while (length(fq <- ShortRead::yield(f))) {
                fqtrim <- eval(parse(text = Fct))
                ShortRead::writeFastq(fqtrim, outfile, mode = "a", ...)
                counter <- counter + length(fqtrim)
                cat(counter, "processed reads written to file:", outfile, "\n")
            }
            close(f)
        }
    }
    ## Paired end fastq files
    if (all(c("FileName1", "FileName2") %in% colnames_args)) {
        for (i in seq(along = outpaths1)) {
            p1 <- as.character(targets_in$FileName1[i])
            p2 <- as.character(targets_in$FileName2[i])
            p1out <- as.character(outpaths1[i])
            p2out <- as.character(outpaths2[i])
            ## Delete existing fastq files with same names, since writeFastq will append to them
            if (overwrite == TRUE) {
                if (any(file.exists(p1out))) unlink(p1out)
                if (any(file.exists(p2out))) unlink(p2out)
            } else {
                if (any(file.exists(p1out))) {
                    stop("File ", p1out, " exists. Please delete file first or set overwrite=TRUE.")
                }
                if (any(file.exists(p2out))) {
                    stop("File ", p2out, " exists. Please delete file first or set overwrite=TRUE.")
                }
            }
            ## Run preprocessor function with FastqStreamer
            counter1 <- 0
            counter2 <- 0
            f1 <- ShortRead::FastqStreamer(p1, batchsize)
            f2 <- ShortRead::FastqStreamer(p2, batchsize)
            while (length(fq1 <- ShortRead::yield(f1))) {
                fq2 <- ShortRead::yield(f2)
                if (length(fq1) != length(fq2)) {
                    stop("Paired end files cannot have different read numbers.")
                }
                ## Process p1
                fq <- fq1 # for simplicity in eval
                fq1trim <- eval(parse(text = Fct))
                ## Index for p1
                index1 <- as.character(ShortRead::id(fq1)) %in% as.character(ShortRead::id(fq1trim))
                names(index1) <- seq(along = index1)
                index1 <- names(index1[index1])
                ## Process p2
                fq <- fq2 # for simplicity in eval
                fq2trim <- eval(parse(text = Fct))
                ## Index for p1
                index2 <- as.character(ShortRead::id(fq2)) %in% as.character(ShortRead::id(fq2trim))
                names(index2) <- seq(along = index2)
                index2 <- names(index2[index2])
                ## Export to processed paired files
                indexpair1 <- index1 %in% index2
                ShortRead::writeFastq(fq1trim[indexpair1], p1out, mode = "a", ...)
                indexpair2 <- index2 %in% index1
                ShortRead::writeFastq(fq2trim[indexpair2], p2out, mode = "a", ...)
                counter1 <- counter1 + sum(indexpair1)
                cat(counter1, "processed reads written to file:", p1out, "\n")
                counter2 <- counter2 + sum(indexpair2)
                cat(counter2, "processed reads written to file:", p2out, "\n")
            }
            close(f1)
            close(f2)
        }
    }
}
## Usage:
# preprocessReads(args=args, Fct="trimLRPatterns(Rpattern='GCCCGGGTAA', subject=fq)", batchsize=100000, overwrite=TRUE, compress=TRUE)
# preprocessReads(FileName1 = "data/SRR446027_1.fastq.gz", FileName2 = NULL,
#                  outfile1 = "results/SRR446027_1.fastq_trim.gz", outfile2 = NULL,
#                  Fct="trimLRPatterns(Rpattern='GCCCGGGTAA', subject=fq)", batchsize=100000, overwrite=TRUE, compress=TRUE)
#
# preprocessReads(FileName1 = "data/SRR446027_1.fastq.gz", FileName2 = "data/SRR446027_2.fastq.gz",
#                  outfile1 = "results/SRR446027_1.fastq_trim.gz", outfile2 = "results/SRR446027_2.fastq_trim.gz",
#                  Fct="trimLRPatterns(Rpattern='GCCCGGGTAA', subject=fq)", batchsize=100000, overwrite=TRUE, compress=TRUE)

##################################################################
## Function to create sym links to bam files for viewing in IGV ##
##################################################################
symLink2bam <- function(sysargs, command = "ln -s", htmldir, ext = c(".bam", ".bai"), urlbase, urlfile) {
    if (!any(inherits(sysargs, "SYSargs"), inherits(sysargs, "SYSargs2"), inherits(sysargs, "character"))) stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2 OR 'named character vector'")
    ## SYSargs class
    if (inherits(sysargs, "SYSargs")) {
        bampaths <- outpaths(sysargs)
        symname <- SampleName(sysargs)
        ## SYSargs2 class ##
    } else if (inherits(sysargs, "SYSargs2")) {
        bampaths <- normalizePath(subsetWF(args = sysargs, slot = "output", subset = 1, index = 1))
        symname <- names(targets(sysargs))
    } else if (inherits(sysargs, "character")) {
        if (is.null(names(sysargs))) stop("Please provide a named character vector, where the names elements should be the sampleID")
        bampaths <- sysargs
        symname <- names(sysargs)
    }
    ## Create URL file
    urls <- paste(urlbase, htmldir[2], symname, ext[1], "\t", symname, sep = "")
    writeLines(urls, urlfile)
    ## Check directory and Create corresponding sym links
    if (!dir.exists(paste(htmldir, collapse = ""))) {
        dir.create(paste(htmldir, collapse = ""), recursive = TRUE)
        message(paste(htmldir, collapse = ""), "directory was created successfully!")
    }
    symname <- rep(symname, each = 2)
    symname <- paste(symname, c(ext[1], paste(ext, collapse = "")), sep = "")
    bampaths2 <- as.vector(t(cbind(bampaths, paste(bampaths, ext[2], sep = ""))))
    symcommands <- paste(command, " ", bampaths2, " ", paste(htmldir, collapse = ""), symname, sep = "")
    for (i in symcommands) system(i)
    message("Symbolic links were created successfully!")
}
## Usage:
# symLink2bam(sysargs=args, command="ln -s", htmldir=c("~/.html/", "somedir/"), ext=c(".bam", ".bai"), urlbase="http://cluster.hpcc.ucr.edu/~tgirke/", urlfile="IGVurl.txt")

#####################
## Alignment Stats ##
#####################
alignStats <- function(args, fqpaths, pairEnd = TRUE,
                       output_index = 1,
                       subset = "FileName1") {
    ## SYSargs class
    if (class(args) == "SYSargs") {
        fqpaths <- infile1(args)
        bampaths <- outpaths(args)
        if (!nchar(infile2(args))[1] > 0) pairEnd <- FALSE
        # SYSargs2 class
    } else if (class(args) == "SYSargs2") {
        fqpaths <- infile1(args)
        output.all <- subsetWF(args, slot = "output", subset = 1, index = output_index)
        bampaths <- as.character()
        for (i in seq_along(output.all)) {
            for (j in seq_along(output.all[[i]])) {
                if (grepl(".sam$", output.all[[i]][[j]]) == TRUE & grepl(".bam$", output.all[[i]][[j]]) == FALSE) {
                    stop("Please provide files in BAM format; it can be checked as 'output(args)'. Also, check 'output_update' function, if the BAM files were previously generated.")
                } else if (grepl(".bam$", output.all[[i]][[j]]) == TRUE & grepl("sorted.bam$", output.all[[i]][[j]]) == FALSE) {
                    bampaths <- c(bampaths, output.all[[i]][[j]])
                }
            }
        }
        names(bampaths) <- names(output.all)
        if (!nchar(infile2(args))[1] > 0) pairEnd <- FALSE
    } else if (class(args) == "character") {
        if (missing(fqpaths)) stop("Please provide fqpaths argument! It must be a named character vector, where the names elements should be the sampleID")
        bampaths <- args
        fqpaths <- fqpaths
    }
    bamexists <- file.exists(bampaths)
    fqpaths <- fqpaths[bamexists]
    bampaths <- bampaths[bamexists]
    ## Obtain total read number from FASTQ files
    Nreads <- ShortRead::countLines(fqpaths) / 4
    names(Nreads) <- names(fqpaths)
    ## If reads are PE multiply by 2 as a rough approximation
    if (pairEnd) Nreads <- Nreads * 2
    ## Obtain total number of alignments from BAM files
    bfl <- BamFileList(bampaths, yieldSize = 50000, index = character())
    param <- ScanBamParam(flag = scanBamFlag(isUnmappedQuery = FALSE))
    Nalign <- Rsamtools::countBam(bfl, param = param)
    ## Obtain number of primary alignments from BAM files
    param <- Rsamtools::ScanBamParam(flag = Rsamtools::scanBamFlag(isSecondaryAlignment = FALSE, isUnmappedQuery = FALSE))
    Nalignprim <- Rsamtools::countBam(bfl, param = param)
    statsDF <- data.frame(
        FileName = names(Nreads),
        Nreads = Nreads,
        Nalign = Nalign$records,
        Perc_Aligned = Nalign$records / Nreads * 100,
        Nalign_Primary = Nalignprim$records,
        Perc_Aligned_Primary = Nalignprim$records / Nreads * 100
    )
    if (pairEnd) colnames(statsDF)[which(colnames(statsDF) == "Nreads")] <- "Nreads2x"
    return(statsDF)
}
## Usage:
# read_statsDF <- alignStats(args=args)

########################
## RPKM Normalization ##
########################
returnRPKM <- function(counts, ranges) {
    geneLengthsInKB <- sum(width(reduce(ranges))) / 1000 # Length of exon union per gene in kbp
    millionsMapped <- sum(counts) / 1e+06 # Factor for converting to million of mapped reads.
    rpm <- counts / millionsMapped # RPK: reads per kilobase of exon model.
    rpkm <- rpm / geneLengthsInKB # RPKM: reads per kilobase of exon model per million mapped reads.
    return(rpkm)
}
## Usage:
# countDFrpkm <- apply(countDF, 2, function(x) returnRPKM(counts=x, ranges=eByg))

###############################################
## Read Sample Comparisons from Targets File ##
###############################################
## Parses sample comparisons from <CMP> line(s) in targets.txt file or SYSars object.
## All possible comparisons can be specified with 'CMPset: ALL'.
readComp <- function(file, format = "vector", delim = "-") {
    if (!format %in% c("vector", "matrix")) stop("Argument format can only be assigned: vector or matrix!")
    if (inherits(file, "SYSargs")) {
        if (length(targetsheader(file)) == 0) stop("Input has no targets header lines.")
        comp <- targetsheader(file)
        ## SYSargs2 class
    } else if (inherits(file, "SYSargs2")) {
        if (length(targetsheader(file))[[1]] == 0) stop("Input has no targets header lines.")
        comp <- targetsheader(file)[[1]]
    } else {
        comp <- readLines(file)
    }
    comp <- comp[grepl("<CMP>", comp)]
    comp <- gsub("#.*<CMP>| {1,}", "", comp)
    comp <- gsub("\t", "", comp)
    comp <- gsub("^\"|\"$", "", comp) # Often required if Excel is used for editing targets file
    comp <- strsplit(comp, ":|,")
    names(comp) <- lapply(seq(along = comp), function(x) comp[[x]][1])
    comp <- sapply(names(comp), function(x) comp[[x]][-1], simplify = FALSE)
    ## Check whether all samples are present in Factor column of targets file
    checkvalues <- unique(unlist(strsplit(unlist(comp), "-")))
    checkvalues <- checkvalues[checkvalues != "ALL"]
    if (inherits(file, "SYSargs")) {
        all <- unique(as.character(targetsin(file)$Factor))
    } else if (inherits(file, "SYSargs2")) {
        all <- unique(as.character(targets.as.df(targets(file))$Factor))
    } else {
        all <- unique(as.character(read.delim(file, comment.char = "#")$Factor))
    }
    if (any(!checkvalues %in% all)) stop("The following samples are not present in Factor column of targets file: ", paste(checkvalues[!checkvalues %in% all], collapse = ", "))
    ## Generate outputs
    allindex <- sapply(names(comp), function(x) any(grepl("ALL", comp[[x]])))
    if (any(allindex)) for (i in which(allindex)) comp[[i]] <- combn(all, m = 2, FUN = paste, collapse = delim)
    if (format == "vector" & delim != "-") comp <- sapply(names(comp), function(x) gsub("-", delim, comp[[x]]), simplify = FALSE)
    if (format == "vector") {
        return(comp)
    }
    if (format == "matrix") {
        return(sapply(names(comp), function(x) do.call("rbind", Biostrings::strsplit(comp[[x]], "-")), simplify = FALSE))
    }
}
## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# cmp <- readComp(targetspath, format="vector", delim="-")
# cmp <- readComp(WF, format="vector", delim="-")

#######################################################################
## Run edgeR GLM with entire count matrix or subsetted by comparison ##
#######################################################################
## If independent=TRUE then countDF will be subsetted for each comparison
run_edgeR <- function(countDF, targets, cmp, independent = TRUE, paired = NULL, mdsplot = "") {
    pkg <- c("edgeR", "limma", "grDevices")
    checkPkg(pkg, quietly = FALSE)
    ## if(class(cmp) != "matrix" & length(cmp)==2) cmp <- t(as.matrix(cmp)) # If cmp is vector of length 2, convert it to matrix.
    ## fix for _R_CHECK_LENGTH_1_LOGIC2_ error: " --- failure: the condition has length > 1 ---"
    if (all(class(cmp) != "matrix" & length(cmp) == 2)) cmp <- t(as.matrix(cmp))
    samples <- as.character(targets$Factor)
    names(samples) <- paste(as.character(targets$SampleName), "", sep = "")
    countDF <- countDF[, names(samples)]
    countDF[is.na(countDF)] <- 0
    edgeDF <- data.frame(row.names = rownames(countDF))
    group <- as.character(samples)
    if (independent == TRUE) {
        loopv <- seq(along = cmp[, 1])
    } else {
        loopv <- 1
    }
    for (j in loopv) {
        ## Filtering and normalization
        y <- edgeR::DGEList(counts = countDF, group = group) # Constructs DGEList object
        if (independent == TRUE) {
            subset <- samples[samples %in% cmp[j, ]]
            y <- y[, names(subset)]
            y$samples$group <- factor(as.character(y$samples$group))
        }
        keep <- rowSums(edgeR::cpm(y) > 1) >= 2
        y <- y[keep, ]
        y <- edgeR::calcNormFactors(y)
        ## Design matrix
        if (length(paired) == 0) {
            design <- model.matrix(~ 0 + y$samples$group, data = y$samples)
            colnames(design) <- levels(y$samples$group)
        } else {
            if (length(paired) > 0 & independent == FALSE) stop("When providing values under 'paired' also set independent=TRUE")
            Subject <- factor(paired[samples %in% cmp[j, ]]) # corrected Jun 2014 (won't change results)
            Treat <- y$samples$group
            design <- model.matrix(~ Subject + Treat)
            levels(design) <- levels(y$samples$group)
        }
        ## Estimate dispersion
        y <- edgeR::estimateGLMCommonDisp(y, design, verbose = TRUE) # Estimates common dispersions
        y <- edgeR::estimateGLMTrendedDisp(y, design) # Estimates trended dispersions
        y <- edgeR::estimateGLMTagwiseDisp(y, design) # Estimates tagwise dispersions
        fit <- edgeR::glmFit(y, design) # Fits the negative binomial GLM for each tag and produces an object of class DGEGLM with some new components.
        ## Contrast matrix is optional but makes anlysis more transparent
        if (independent == TRUE) {
            mycomp <- paste(cmp[j, 1], cmp[j, 2], sep = "-")
        } else {
            mycomp <- paste(cmp[, 1], cmp[, 2], sep = "-")
        }
        if (length(paired) == 0) contrasts <- limma::makeContrasts(contrasts = mycomp, levels = design)
        for (i in seq(along = mycomp)) {
            if (length(paired) == 0) {
                lrt <- edgeR::glmLRT(fit, contrast = contrasts[, i]) # Takes DGEGLM object and carries out the likelihood ratio test.
            } else {
                lrt <- edgeR::glmLRT(fit) # No contrast matrix with paired design
            }
            deg <- as.data.frame(edgeR::topTags(lrt, n = length(rownames(y))))
            colnames(deg) <- paste(paste(mycomp[i], collapse = "_"), colnames(deg), sep = "_")
            edgeDF <- cbind(edgeDF, deg[rownames(edgeDF), ])
        }
        if (nchar(mdsplot) > 0) {
            grDevices::pdf(paste("./results/sample_MDS_", paste(unique(subset), collapse = "-"), ".pdf", sep = ""))
            limma::plotMDS(y)
            grDevices::dev.off()
        }
    }
    return(edgeDF)
}
## Usage:
# cmp <- readComp(file=targetspath, format="matrix", delim="-")
# edgeDF <- run_edgeR(countDF=countDF, targets=targets, cmp=cmp[[1]], independent=TRUE, mdsplot="")

####################################################################
## Run DESeq2 with entire count matrix or subsetted by comparison ##
####################################################################
## If independent=TRUE then countDF will be subsetted for each comparison
run_DESeq2 <- function(countDF, targets, cmp, independent = FALSE, lfcShrink = FALSE, type = "normal") {
    pkg <- c("DESeq2")
    checkPkg(pkg, quietly = FALSE)
    ## if(class(cmp) != "matrix" & length(cmp)==2) cmp <- t(as.matrix(cmp)) # If cmp is vector of length 2, convert it to matrix.
    ## fix for _R_CHECK_LENGTH_1_LOGIC2_ error: " --- failure: the condition has length > 1 ---"
    if (all(class(cmp) != "matrix" & length(cmp) == 2)) cmp <- t(as.matrix(cmp))
    samples <- as.character(targets$Factor)
    names(samples) <- paste(as.character(targets$SampleName), "", sep = "")
    countDF <- countDF[, names(samples)]
    countDF[is.na(countDF)] <- 0
    deseqDF <- data.frame(row.names = rownames(countDF))
    if (independent == TRUE) {
        loopv <- seq(along = cmp[, 1])
    } else {
        loopv <- 1
    }
    for (j in loopv) {
        if (independent == TRUE) {
            ## Create subsetted DESeqDataSet object
            subset <- samples[samples %in% cmp[j, ]]
            countDFsub <- countDF[, names(subset)]
            dds <- DESeq2::DESeqDataSetFromMatrix(countData = as.matrix(countDFsub), colData = data.frame(condition = subset), design = ~condition)
            mycmp <- cmp[j, , drop = FALSE]
        } else {
            ## Create full DESeqDataSet object
            dds <- DESeq2::DESeqDataSetFromMatrix(countData = as.matrix(countDF), colData = data.frame(condition = samples), design = ~condition)
            mycmp <- cmp
        }
        ## Estimate of (i) size factors, (ii) dispersion, (iii) negative binomial GLM fitting and (iv) Wald statistics
        dds <- DESeq2::DESeq(dds, quiet = TRUE)
        for (i in seq(along = mycmp[, 1])) {
            ## Extracts DEG results for specific contrasts from DESeqDataSet object
            res <- DESeq2::results(dds, contrast = c("condition", mycmp[i, ]))
            ## lfcShrink
            if (lfcShrink == FALSE) {
                res <- DESeq2::results(dds, contrast = c("condition", mycmp[i, ]))
            } else if (lfcShrink == TRUE) {
                suppressMessages(
                    res <- DESeq2::lfcShrink(dds, contrast = c("condition", mycmp[i, ]), type = type)
                )
            }
            ## Set NAs to reasonable values to avoid errors in downstream filtering steps
            res[is.na(res[, "padj"]), "padj"] <- 1
            res[is.na(res[, "log2FoldChange"]), "log2FoldChange"] <- 0
            deg <- as.data.frame(res)
            colnames(deg)[colnames(deg) %in% c("log2FoldChange", "padj")] <- c("logFC", "FDR")
            colnames(deg) <- paste(paste(mycmp[i, ], collapse = "-"), colnames(deg), sep = "_")
            deseqDF <- cbind(deseqDF, deg[rownames(deseqDF), ])
        }
    }
    return(deseqDF)
}
## Usage:
# cmp <- readComp(file=targetspath, format="matrix", delim="-")
# degseqDF <- run_DESeq2(countDF=countDF, targets=targets, cmp=cmp[[1]], independent=FALSE)

###########################################
## Filter DEGs by p-value and fold change ##
############################################
filterDEGs <- function(degDF, filter, plot = TRUE) {
    ## global functions or variables
    Comparisons <- Counts <- Type <- NULL
    pval <- degDF[, grep("_FDR$", colnames(degDF)), drop = FALSE]
    log2FC <- degDF[, grep("_logFC$", colnames(degDF)), drop = FALSE]
    ## DEGs that are up or down regulated
    pf <- pval <= filter["FDR"] / 100 & (log2FC >= log2(filter["Fold"]) | log2FC <= -log2(filter["Fold"]))
    colnames(pf) <- gsub("_FDR", "", colnames(pf))
    pf[is.na(pf)] <- FALSE
    DEGlistUPorDOWN <- sapply(colnames(pf), function(x) rownames(pf[pf[, x, drop = FALSE], , drop = FALSE]), simplify = FALSE)
    ## DEGs that are up regulated
    pf <- pval <= filter["FDR"] / 100 & log2FC >= log2(filter["Fold"])
    colnames(pf) <- gsub("_FDR", "", colnames(pf))
    pf[is.na(pf)] <- FALSE
    DEGlistUP <- sapply(colnames(pf), function(x) rownames(pf[pf[, x, drop = FALSE], , drop = FALSE]), simplify = FALSE)
    ## DEGs that are down regulated
    pf <- pval <= filter["FDR"] / 100 & log2FC <= -log2(filter["Fold"])
    colnames(pf) <- gsub("_FDR", "", colnames(pf))
    pf[is.na(pf)] <- FALSE
    DEGlistDOWN <- sapply(colnames(pf), function(x) rownames(pf[pf[, x, drop = FALSE], , drop = FALSE]), simplify = FALSE)
    df <- data.frame(Comparisons = names(DEGlistUPorDOWN), Counts_Up_or_Down = sapply(DEGlistUPorDOWN, length), Counts_Up = sapply(DEGlistUP, length), Counts_Down = sapply(DEGlistDOWN, length))
    resultlist <- list(UporDown = DEGlistUPorDOWN, Up = DEGlistUP, Down = DEGlistDOWN, Summary = df)
    if (plot == TRUE) {
        mytitle <- paste("DEG Counts (", names(filter)[1], ": ", filter[1], " & ", names(filter)[2], ": ", filter[2], "%)", sep = "")
        df_plot <- data.frame(Comparisons = rep(as.character(df$Comparisons), 2), Counts = c(df$Counts_Up, df$Counts_Down), Type = rep(c("Up", "Down"), each = length(df[, 1])))
        p <- ggplot2::ggplot(df_plot, ggplot2::aes(Comparisons, Counts, fill = Type)) +
            ggplot2::geom_bar(position = "stack", stat = "identity") +
            ggplot2::coord_flip() +
            ggplot2::theme(axis.text.y = ggplot2::element_text(angle = 0, hjust = 1)) +
            ggplot2::ggtitle(mytitle)
        print(p)
    }
    return(resultlist)
}
## Usage:
# DEG_list <- filterDEGs(degDF=edgeDF, filter=c(Fold=2, FDR=1))

#############
## showDF ##
#############
showDF <- function(data, ...) {
    checkPkg("DT", quietly = FALSE)
    DT::datatable(
        data,
        extensions = c("FixedColumns", "Scroller"),
        options = list(
            scrollX = TRUE,
            fixedColumns = TRUE,
            deferRender = TRUE,
            scrollY = 200,
            scroller = TRUE
        )
    )
}
## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# targets <- read.delim(targetspath, comment.char = "#")
# showDF(targets)

###############
## checkPkg ##
###############
# param pkg character vector of the names of packages
checkPkg <- function(pkg, quietly = TRUE) {
    if (!inherits(pkg, "character")) stop("Argument 'pkg' needs to be assigned an object of class 'character'")
    for (i in pkg) {
        if (!requireNamespace(i, quietly = quietly)) {
            stop("Package '", i, "' should be installed.", "\n", call. = FALSE)
        }
    }
}
# pkg <- c("AnnotationDbi", "GO.db")
# pkg <- c("annotate")
# checkPkg(pkg, quietly = FALSE)

#########################
## Internal Functions ##
########################

###############
## .tryRunC ##
###############
.tryRunC <- function(command, commandargs) {
    warning <- error <- NULL
    value <- withCallingHandlers(
        tryCatch(
            if (command %in% "bwa") {
                bwa_err <- tempfile()
                system2(command, args = commandargs, stdout = T, stderr = bwa_err)
                readLines(bwa_err)
            } else if (command %in% c("bash")) {
                system(paste(command, commandargs))
            } else if (isTRUE(grep("\\$", command) == 1)) {
                system(paste(command, commandargs))
            } else {
                system2(command, args = commandargs, stdout = TRUE, stderr = TRUE)
            },
            error = function(e) {
                error <<- conditionMessage(e)
                NULL
            }
        ),
        warning = function(w) {
            warning <<- append(warning, conditionMessage(w))
            invokeRestart("muffleWarning")
        }
    )
    list(stdout = value, warning = warning, error = error)
}

## Usage:
# .tryRunC("ls", "la")
# .tryRunC("ls", "-la")

###########################################################################
## .moduleload function: internal function to module load <modules> ##
###########################################################################
.moduleload <- function(args) {
    ## Environment Modules section
    if (any(nchar(gsub(" {1,}", "", modules(args))) > 0)) {
        ## Check if "Environment Modules" is in the PATH
        # try(suppressWarnings(modulecmd_path <- system("which modulecmd", intern = TRUE, ignore.stderr = TRUE)),
        #     silent = TRUE
        # )
        modulecmd_path <- suppressMessages(is.modules.avail())
        ## "Environment Modules" is not available
        if (length(modulecmd_path) == 0) {
            dump <- "do nothing"
            ## "Environment Modules" is available and proceed the module load
        } else if (length(modulecmd_path) > 0) {
            for (j in modules(args)) moduleload(j) # loads specified software from module system
        }
    }
}

###########################################################################
## .makeBam function: internal function to convert *.sam to *.bam file ##
###########################################################################
.makeBam <- function(output_args, make_bam = TRUE, del_sam = TRUE) {
    if (all(!is.logical(c(make_bam, del_sam)))) stop("Arguments needs to be assigned 'TRUE' and 'FALSE'")
    if (make_bam == TRUE) {
        sam_files <- grepl(".sam$", output_args)
        others_files <- grepl("vcf$|bcf$|xls$|bed$", output_args)
        completed.bam <- grepl(".bam$", output_args)
        if (any(sam_files)) {
            for (k in which(sam_files)) {
                if (file.exists(output_args[k])) {
                    Rsamtools::asBam(file = output_args[k], destination = gsub("\\.sam$", "", output_args[k]), overwrite = TRUE, indexDestination = TRUE)
                    if (del_sam == TRUE) {
                        unlink(output_args[k])
                    } else if (del_sam == FALSE) {
                        dump <- "do nothing"
                    }
                } else {
                    next()
                }
            }
        } else if (any(others_files)) {
            dump <- "do nothing"
        }
        if (any(completed.bam)) { # If output is unindexed *.bam file (e.g. Tophat2)
            for (k in which(completed.bam)) {
                Rsamtools::sortBam(file = output_args[k], destination = gsub("\\.bam$", "", output_args[k]))
                Rsamtools::indexBam(output_args[k])
            }
        }
    } else if (make_bam == FALSE) {
        dump <- "do nothing"
    }
}
## Usage:
# .makeBam(output(args)[[1]][[1]], make_bam=TRUE, del_sam=FALSE)

########################################################
## .checkOutArgs2 function: internal function to check
## if the expected output has been created  ##
########################################################
.checkOutArgs2 <- function(args, make_bam, dir = dir, dir.name, force, del_sam = TRUE) {
    args_complete <- args
    if (make_bam == TRUE) {
        ## Validation for Hisat2
        if (any(grepl("samtools", names(clt(args_complete))))) {
            stop("argument 'make_bam' should be 'FALSE' when using the workflow with 'SAMtools'", call. = FALSE)
        }
        if (any(grepl(".sam", args_complete$output[[1]][[1]]))) {
            args_complete <- output_update(args_complete, dir = dir, dir.name = dir.name, replace = TRUE, extension = c(".sam", ".bam"), make_bam = make_bam, del_sam = del_sam)
        }
    }
    if (dir == TRUE) {
        args_complete <- output_update(args_complete, dir = dir, dir.name = dir.name)
    }
    completed <- output(args_complete)
    for (i in seq_along(output(args_complete))) {
        for (j in seq_along(output(args_complete)[[i]])) {
            completed[[i]][[j]] <- file.exists(output(args_complete)[[i]][[j]])
            names(completed[[i]][[j]]) <- output(args_complete)[[i]][[j]]
        }
    }
    check <- check.output(args_complete, "list")
    if (force) check <- replace(check, check == TRUE, FALSE)
    for (i in seq_along(check)) {
        if (check[i] == FALSE) {
            args[["output"]][[i]] <- args$internal_outfiles[[i]]
        }
    }
    return <- list(args = args, args_complete = args_complete, completed = completed)
    return(return)
}
## Usage:
# return <- .checkOutArgs2(args, make_bam=TRUE)
# args <- return$args
# completed <- return$completed

##########################################################################################
## .sysargsrunCommandline function: Old version of runCommandline accepts SYSargs class ##
##########################################################################################
.sysargsrunCommandline <- function(args, runid = "01", make_bam = TRUE, del_sam = TRUE, ...) {
    message("This method is using the previus version of SYSargs workflow control modules.
          Please check the new version 'SYSargs2'.")
    commands <- sysargs(args)
    completed <- file.exists(outpaths(args))
    names(completed) <- outpaths(args)
    logdir <- results(args)
    for (i in seq(along = commands)) {
        ## Run alignmets only for samples for which no BAM file is available.
        if (as.logical(completed)[i]) {
            next()
        } else {
            ## Create soubmitargsID_command file
            cat(commands[i], file = paste(logdir, "submitargs", runid, sep = ""), sep = "\n", append = TRUE)
            ## Run executable
            command <- gsub(" .*", "", as.character(commands[i]))
            commandargs <- gsub("^.*? ", "", as.character(commands[i]))
            ## Execute system command; note: BWA needs special treatment in stderr handling since it writes
            ## some stderr messages to sam file if used with system2()
            if (software(args) %in% c("bwa aln", "bwa mem")) {
                stdout <- system2(command, args = commandargs, stdout = TRUE, stderr = FALSE)
            } else if (software(args) %in% c("bash_commands")) {
                stdout <- system(paste(command, commandargs))
            } else {
                stdout <- system2(command, args = commandargs, stdout = TRUE, stderr = TRUE)
            }
            ## Create submitargsID_stdout file
            cat(commands[i], file = paste(logdir, "submitargs", runid, "_log", sep = ""), sep = "\n", append = TRUE)
            cat(unlist(stdout), file = paste(logdir, "submitargs", runid, "_log", sep = ""), sep = "\n", append = TRUE)
            ## Conditional postprocessing of results
            if (make_bam == TRUE) {
                if (grepl(".sam$", outfile1(args)[i])) { # If output is *.sam file (e.g. Bowtie2)
                    Rsamtools::asBam(file = outfile1(args)[i], destination = gsub("\\.sam$", "", outfile1(args)[i]), overwrite = TRUE, indexDestination = TRUE)
                    if (del_sam == TRUE) {
                        unlink(outfile1(args)[i])
                    } else if (del_sam == FALSE) {
                        dump <- "do nothing"
                    }
                } else if (grepl("vcf$|bcf$|xls$|bed$", outpaths(args)[i])) {
                    dump <- "do nothing"
                } else { # If output is unindexed *.bam file (e.g. Tophat2)
                    Rsamtools::sortBam(file = names(completed[i]), destination = gsub("\\.bam$", "", names(completed[i])))
                    Rsamtools::indexBam(names(completed[i]))
                }
            }
        }
    }
    bamcompleted <- gsub("sam$", "bam$", file.exists(outpaths(args)))
    names(bamcompleted) <- SampleName(args)
    cat("Missing alignment results (bam files):", sum(!as.logical(bamcompleted)), "\n")
    cat("Existing alignment results (bam files):", sum(as.logical(bamcompleted)), "\n")
    return(bamcompleted)
}
## Usage:
# args <- systemArgs(sysma="param/hisat2.param", mytargets="targets.txt")
# sysargs(args)[1] # Command-line parameters for first FASTQ file
# system("hisat2-build ./data/tair10.fasta ./data/tair10.fasta")
# .sysargsrunCommandline(args=args)

##############################################
## Set Intersect and Venn Diagram Functions ##
##############################################
## Author: Thomas Girke
## Last update: Jan 5, 2015

##############################################
## Class and Method Definitions for VENNset ##
##############################################
## Define VENNset class
setClass("VENNset", representation(setlist = "list", intersectmatrix = "matrix", complexitylevels = "integer", vennlist = "list"))

## Methods to return VENNset components
setGeneric(name = "setlist", def = function(x) standardGeneric("setlist"))
setMethod(f = "setlist", signature = "VENNset", definition = function(x) {
    return(x@setlist)
})
setGeneric(name = "intersectmatrix", def = function(x) standardGeneric("intersectmatrix"))
setMethod(f = "intersectmatrix", signature = "VENNset", definition = function(x) {
    return(x@intersectmatrix)
})
setGeneric(name = "complexitylevels", def = function(x) standardGeneric("complexitylevels"))
setMethod(f = "complexitylevels", signature = "VENNset", definition = function(x) {
    return(x@complexitylevels)
})
setGeneric(name = "vennlist", def = function(x) standardGeneric("vennlist"))
setMethod(f = "vennlist", signature = "VENNset", definition = function(x) {
    return(x@vennlist)
})
setGeneric(name = "as.list", def = function(x) standardGeneric("as.list"))
setMethod(f = "as.list", signature = "VENNset", definition = function(x) {
    mylist <- list(
        setlist = x@setlist,
        intersectmatrix = x@intersectmatrix,
        complexitylevels = x@complexitylevels,
        vennlist = x@vennlist
    )
    return(mylist)
})

## Constructor methods
## List to VENNset with: as(mylist, "VENNset")
setAs(
    from = "list", to = "VENNset",
    def = function(from) {
        new("VENNset",
            setlist = from$setlist,
            intersectmatrix = from$intersectmatrix,
            complexitylevels = from$complexitylevels,
            vennlist = from$vennlist
        )
    }
)

## Define print behavior for VENNset
setMethod(
    f = "show", signature = "VENNset",
    definition = function(object) {
        cat("An instance of '", class(object), "' with ", length(object@setlist), " label sets ", "\n", sep = "")
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "VENNset",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend length() method
setMethod(
    f = "length", signature = "VENNset",
    definition = function(x) {
        return(length(x@setlist))
    }
)

###################################################
## Class and Method Definitions for INTERSECTset ##
###################################################
## Define INTERSECTset class
setClass("INTERSECTset", representation(setlist = "list", intersectmatrix = "matrix", complexitylevels = "integer", intersectlist = "list"))

## Methods to return INTERSECTset components
setMethod(f = "setlist", signature = "INTERSECTset", definition = function(x) {
    return(x@setlist)
})
setMethod(f = "intersectmatrix", signature = "INTERSECTset", definition = function(x) {
    return(x@intersectmatrix)
})
setMethod(f = "complexitylevels", signature = "INTERSECTset", definition = function(x) {
    return(x@complexitylevels)
})
setGeneric(name = "intersectlist", def = function(x) standardGeneric("intersectlist"))
setMethod(f = "intersectlist", signature = "INTERSECTset", definition = function(x) {
    return(x@intersectlist)
})
setMethod(f = "as.list", signature = "INTERSECTset", definition = function(x) {
    mylist <- list(
        setlist = x@setlist,
        intersectmatrix = x@intersectmatrix,
        complexitylevels = x@complexitylevels,
        intersectlist = x@intersectlist
    )
    return(mylist)
})

## Constructor methods
## List to INTERSECTset with: as(mylist, "INTERSECTset")
setAs(
    from = "list", to = "INTERSECTset",
    def = function(from) {
        new("INTERSECTset",
            setlist = from$setlist,
            intersectmatrix = from$intersectmatrix,
            complexitylevels = from$complexitylevels,
            intersectlist = from$intersectlist
        )
    }
)

## Define print behavior for INTERSECTset
setMethod(
    f = "show", signature = "INTERSECTset",
    definition = function(object) {
        cat("An instance of '", class(object), "' with ", length(object@setlist), " label sets and 'complexity = ", paste0(unique(object@complexitylevels), collapse = ", "), "'", "\n", sep = "")
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "INTERSECTset",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend length() method
setMethod(
    f = "length", signature = "INTERSECTset",
    definition = function(x) {
        return(length(x@setlist))
    }
)

################################
## Generic Intersect Function ##
################################
## Computation of (1) Venn Intersects and (2) Pairwise Intersects
overLapper <- function(setlist, complexity = "default", sep = "_", cleanup = FALSE, keepdups = FALSE, type) {
    ## Default complexity levels
    if (complexity[1] == "default") complexity <- 1:length(setlist)
    ## Check validity of inputs
    if (class(setlist) != "list" | length(names(setlist)) == 0) stop("Unexpected input.
             The input 'setlist' needs to be of class 'list' where each list component stores a
             label set as 'vector' and the name of each label set is provided under the
             name slot of each list component.")
    if (!all(sapply(setlist, is.vector) | sapply(setlist, is.null)) | length(setlist) < 2) stop("Unexpected input. 
	     The input 'setlist' needs to be a list with at least 2 components each 
             containig a vector of set labels.")
    if (length(type) != 1 & all(c("vennsets", "intersects") %in% type)) stop("Argument 'type' needs to be assigned 'vennsets' or 'intersects'.")
    if (type == "vennsets" & !identical(complexity, 1:length(setlist))) stop("When assigning 'vennsets' to 'type', then 'complexity' needs to be assigned 'default' or '1:length(setlist)'.")
    ## Clean up of sample sets to minimize formatting issues
    if (cleanup == TRUE) {
        ## Set all characters to upper case
        setlist <- sapply(setlist, function(x) gsub("([A-Z])", "\\U\\1", x, perl = TRUE, ignore.case = TRUE))
        ## Remove leading and trailing spaces
        setlist <- sapply(setlist, function(x) gsub("^ {1,}| {1,}$", "", x, perl = TRUE, ignore.case = TRUE))
    }
    ## Append object counter to retain duplicates
    if (keepdups == TRUE) {
        dupCount <- function(setlist = setlist) {
            count <- table(setlist)
            paste(rep(names(count), count), unlist(sapply(count, function(x) seq(1, x))), sep = ".")
        }
        mynames <- names(setlist)
        setlist <- lapply(setlist, function(x) dupCount(x)) # lapply necessary for numeric data!
        names(setlist) <- mynames
    }
    ## Create intersect matrix (removes duplicates!)
    setunion <- sort(unique(unlist(setlist)))
    setmatrix <- sapply(names(setlist), function(x) setunion %in% unique(setlist[[x]]))
    rownames(setmatrix) <- setunion
    storage.mode(setmatrix) <- "numeric"
    ## Create all possible sample combinations within requested complexity levels
    labels <- names(setlist)
    allcombl <- lapply(complexity, function(x) combn(labels, m = x, simplify = FALSE))
    allcombl <- unlist(allcombl, recursive = FALSE)
    complevels <- sapply(allcombl, length)
    ## Return intersect list for generated sample combinations
    if (type == "intersects") {
        OLlist <- sapply(seq(along = allcombl), function(x) setunion[rowSums(setmatrix[, rep(allcombl[[x]], 2)]) == 2 * length(allcombl[[x]])], simplify = FALSE)
        names(OLlist) <- sapply(allcombl, paste, collapse = sep)
        OLlist <- list(setlist = setlist, intersectmatrix = setmatrix, complexitylevels = complevels, intersectlist = OLlist)
        intersectset <- as(OLlist, "INTERSECTset")
        return(intersectset)
    }
    ## Return Venn intersect list for generated sample combinations
    if (type == "vennsets") {
        vennSets <- function(setmatrix = setmatrix, allcombl = allcombl, index = 1) {
            mycol1 <- which(colnames(setmatrix) %in% allcombl[[index]])
            mycol2 <- which(!colnames(setmatrix) %in% allcombl[[index]])
            cond1 <- rowSums(setmatrix[, rep(mycol1, 2)]) == 2 * length(mycol1)
            cond2 <- rowSums(setmatrix[, rep(mycol2, 2)]) == 0
            return(setunion[cond1 & cond2])
        }
        vennOLlist <- sapply(seq(along = allcombl), function(x) vennSets(setmatrix = setmatrix, allcombl = allcombl, index = x), simplify = FALSE)
        names(vennOLlist) <- sapply(allcombl, paste, collapse = sep)
        OLlist <- list(setlist = setlist, intersectmatrix = setmatrix, complexitylevels = complevels, vennlist = vennOLlist)
        vennset <- as(OLlist, "VENNset")
        return(vennset)
    }
}

####################################
## Venn Diagram Plotting Function ##
####################################
vennPlot <- function(x, mymain = "Venn Diagram", mysub = "default", setlabels = "default", yoffset = seq(0, 10, by = 0.34),
                     ccol = rep(1, 31), colmode = 1, lcol = c("#FF0000", "#008B00", "#0000FF", "#FF00FF", "#CD8500"),
                     lines = c("#FF0000", "#008B00", "#0000FF", "#FF00FF", "#CD8500"), mylwd = 3, diacol = 1, type = "ellipse",
                     ccex = 1.0, lcex = 1.0, sepsplit = "_", ...) {
    ## Check validity of inputs and
    if (!any(c(class(x) == "VENNset", class(x) == "list", is.numeric(x)))) {
        stop("x needs to be one of: VENNset, list of VENNsets, named numeric vector, or list of named numeric vectors.")
    }
    if (class(x) == "list") {
        if (length(unique(sapply(x, length))) != 1) stop("List components need to have identical length.")
    }
    ## Compute count set(s)
    # If x is VENNset
    if (class(x) == "VENNset") {
        counts <- list(sapply(vennlist(x), length))
        myclass <- "VENNset"
        # If x is list of VENNsets
    } else if (class(x) == "list" & all(sapply(x, class) == "VENNset")) {
        counts <- lapply(x, function(y) sapply(vennlist(y), length))
        myclass <- "VENNset"
        ## If x is count set (named numeric vector)
    } else if (is.numeric(x) & is.list(x) == FALSE) {
        counts <- list(x)
        myclass <- "numeric"
        ## If x is list of count sets
    } else if (class(x) == "list" & all(sapply(x, is.numeric))) {
        counts <- x
        myclass <- "numeric"
    } else {
        stop("x needs to be one of: VENNset, list of VENNsets, named numeric vector, or list of named numeric vectors.")
    }
    ## Check for supported number of Venn counts: 3, 7, 15 and 31
    if (!length(counts[[1]]) %in% c(3, 7, 15, 31)) stop("Only 2-5 way venn comparisons are supported.")
    ## Function to return for a set label the index of matches in the name field of a counts object
    grepLabel <- function(label, x = names(counts[[1]])) {
        x <- strsplit(x, sepsplit)
        as.numeric(which(sapply(x, function(y) any(y == label))))
    }
    ## 2-way Venn diagram
    if (length(counts[[1]]) == 3) {
        ## Define subtitle
        if (mysub == "default") {
            if (myclass == "numeric") {
                n <- names(counts[[1]])[1:2]
                if (!all(rowSums(sapply(n, function(x) sapply(n, function(y) grepl(y, x)))) == 1)) { # Checks if one or more set labels are substrings of one another
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                    if (sum(grepl(sepsplit, n)) > 0 | !all(grepl(sepsplit, names(counts[[1]][-c(1:length(n))])))) {
                        sample_counts <- rep("?", length(n))
                        warning("Set labels are substrings of one another. To fix this, the set labels need to be separated by the character provided under \"sepsplit\", but the individual names cannot contain this character themselves.")
                    }
                } else {
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grep(x, names(counts[[1]]))]))
                }
                mysub <- paste(paste("Unique objects: All =", sum(counts[[1]])), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), sep = "")
            } else if (myclass == "VENNset") {
                if (class(x) == "list") x <- x[[1]]
                sample_counts <- sapply(setlist(x), function(y) unique(length(y)))
                mysub <- paste(paste("Unique objects: All =", length(unique(unlist(setlist(x))))), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), sep = "")
            } else {
                mysub <- mysub
            }
        }
        ## Plot venn shapes
        graphics::symbols(x = c(4, 6), y = c(6, 6), circles = c(2, 2), xlim = c(0, 10), ylim = c(0, 10), inches = FALSE, main = mymain, sub = mysub, lwd = mylwd, xlab = "", ylab = "", xaxt = "n", yaxt = "n", bty = "n", fg = lines, ...)
        ## Add counts
        for (i in seq(along = counts)) {
            olDF <- data.frame(
                x = c(3.1, 7.0, 5.0),
                y = c(6.0, 6.0, 6.0),
                counts = counts[[i]]
            )
            if (colmode == 1) {
                graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol, cex = ccex, ...)
            }
            if (colmode == 2) {
                graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol[[i]], cex = ccex[i], ...)
            } # For coloring several numbers per intersect differently. ccol can needs to be list to color each field differently..
        }
        ## Add sample labels
        if (length(setlabels) == 1 & setlabels[1] == "default") {
            setlabels <- names(counts[[1]][1:2])
        } else {
            setlabels <- setlabels
        }
        graphics::text(c(2.0, 8.0), c(8.8, 8.8), labels = setlabels, col = lcol, cex = lcex, ...)
    }
    ## 3-way Venn diagram
    if (length(counts[[1]]) == 7) {
        ## Define subtitle
        if (mysub == "default") {
            if (myclass == "numeric") {
                n <- names(counts[[1]])[1:3]
                if (!all(rowSums(sapply(n, function(x) sapply(n, function(y) grepl(y, x)))) == 1)) { # Checks if one or more set labels are substrings of one another
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                    if (sum(grepl(sepsplit, n)) > 0 | !all(grepl(sepsplit, names(counts[[1]][-c(1:length(n))])))) {
                        sample_counts <- rep("?", length(n))
                        warning("Set labels are substrings of one another. To fix this, the set labels need to be separated by the character provided under \"sepsplit\", but the individual names cannot contain this character themselves.")
                    }
                } else {
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                }
                mysub <- paste(paste("Unique objects: All =", sum(counts[[1]])), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), sep = "")
            } else if (myclass == "VENNset") {
                if (class(x) == "list") x <- x[[1]]
                sample_counts <- sapply(setlist(x), function(y) unique(length(y)))
                mysub <- paste(paste("Unique objects: All =", length(unique(unlist(setlist(x))))), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), sep = "")
            } else {
                mysub <- mysub
            }
        }
        ## Plot venn shapes
        graphics::symbols(x = c(4, 6, 5), y = c(6, 6, 4), circles = c(2, 2, 2), xlim = c(0, 10), ylim = c(0, 10), inches = FALSE, main = mymain, sub = mysub, lwd = mylwd, xlab = "", ylab = "", xaxt = "n", yaxt = "n", bty = "n", fg = lines, ...)
        ## Add counts
        for (i in seq(along = counts)) {
            olDF <- data.frame(
                x = c(3.0, 7.0, 5.0, 5.0, 3.8, 6.3, 5.0),
                y = c(6.5, 6.5, 3.0, 7.0, 4.6, 4.6, 5.3),
                counts = counts[[i]]
            )
            if (colmode == 1) {
                graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol, cex = ccex, ...)
            }
            if (colmode == 2) {
                graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol[[i]], cex = ccex[i], ...)
            }
        }
        ## Add sample labels
        if (length(setlabels) == 1 & setlabels[1] == "default") {
            setlabels <- names(counts[[1]][1:3])
        } else {
            setlabels <- setlabels
        }
        graphics::text(c(2.0, 8.0, 6.0), c(8.8, 8.8, 1.1), labels = setlabels, col = lcol, cex = lcex, ...)
    }
    ## 4-way Venn diagram with ellipses
    if (length(counts[[1]]) == 15 & type == "ellipse") {
        ## Define subtitle
        if (mysub == "default") {
            if (myclass == "numeric") {
                n <- names(counts[[1]])[1:4]
                if (!all(rowSums(sapply(n, function(x) sapply(n, function(y) grepl(y, x)))) == 1)) { # Checks if one or more set labels are substrings of one another
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                    if (sum(grepl(sepsplit, n)) > 0 | !all(grepl(sepsplit, names(counts[[1]][-c(1:length(n))])))) {
                        sample_counts <- rep("?", length(n))
                        warning("Set labels are substrings of one another. To fix this, the set labels need to be separated by the character provided under \"sepsplit\", but the individual names cannot contain this character themselves.")
                    }
                } else {
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                }
                mysub <- paste(paste("Unique objects: All =", sum(counts[[1]])), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), sep = "")
            } else if (myclass == "VENNset") {
                if (class(x) == "list") x <- x[[1]]
                sample_counts <- sapply(setlist(x), function(y) unique(length(y)))
                mysub <- paste(paste("Unique objects: All =", length(unique(unlist(setlist(x))))), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), sep = "")
            } else {
                mysub <- mysub
            }
        }
        ## Plot ellipse
        plotellipse <- function(center = c(1, 1), radius = c(1, 2), rotate = 1, segments = 360, xlab = "", ylab = "", ...) {
            angles <- (0:segments) * 2 * pi / segments
            rotate <- rotate * pi / 180
            ellipse <- cbind(radius[1] * cos(angles), radius[2] * sin(angles))
            ellipse <- cbind(ellipse[, 1] * cos(rotate) + ellipse[, 2] * sin(rotate), ellipse[, 2] * cos(rotate) - ellipse[, 1] * sin(rotate))
            ellipse <- cbind(center[1] + ellipse[, 1], center[2] + ellipse[, 2])
            plot(ellipse, type = "l", xlim = c(0, 10), ylim = c(0, 10), xlab = "", ylab = "", ...)
        }
        ## Plot ellipse as 4-way venn diagram
        ellipseVenn <- function(...) {
            graphics::split.screen(c(1, 1))
            plotellipse(center = c(3.5, 3.6), radius = c(2, 4), rotate = -35, segments = 360, xlab = "", ylab = "", col = lines[1], axes = FALSE, main = mymain, sub = mysub, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(4.7, 4.4), radius = c(2, 4), rotate = -35, segments = 360, xlab = "", ylab = "", col = lines[2], axes = FALSE, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(5.3, 4.4), radius = c(2, 4), rotate = 35, segments = 360, xlab = "", ylab = "", col = lines[3], axes = FALSE, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(6.5, 3.6), radius = c(2, 4), rotate = 35, segments = 360, xlab = "", ylab = "", col = lines[4], axes = FALSE, lwd = mylwd, ...)
            ## Add counts
            for (i in seq(along = counts)) {
                olDF <- data.frame(
                    x = c(1.5, 3.5, 6.5, 8.5, 2.9, 3.1, 5.0, 5.0, 6.9, 7.1, 3.6, 5.8, 4.2, 6.4, 5.0),
                    y = c(4.8, 7.2, 7.2, 4.8, 5.9, 2.2, 0.7, 6.0, 2.2, 5.9, 4.0, 1.4, 1.4, 4.0, 2.8),
                    counts = counts[[i]]
                )
                if (colmode == 1) {
                    graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol, cex = ccex, ...)
                }
                if (colmode == 2) {
                    graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol[[i]], cex = ccex[i], ...)
                }
            }
            ## Add sample labels
            if (length(setlabels) == 1 & setlabels[1] == "default") {
                setlabels <- names(counts[[1]][1:4])
            } else {
                setlabels <- setlabels
            }
            graphics::text(c(0.4, 2.8, 7.5, 9.4), c(7.3, 8.3, 8.3, 7.3), labels = setlabels, col = lcol, cex = lcex, ...)
            graphics::close.screen(all.screens = TRUE)
        }
        ellipseVenn(...)
    }
    ## 4-way Venn diagram with circles (pseudo-venn diagram that misses two overlap sectors)
    if (length(counts[[1]]) == 15 & type == "circle") {
        ## Define subtitle
        if (mysub == "default") {
            if (myclass == "numeric") {
                n <- names(counts[[1]])[1:4]
                if (!all(rowSums(sapply(n, function(x) sapply(n, function(y) grepl(y, x)))) == 1)) { # Checks if one or more set labels are substrings of one another
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                    if (sum(grepl(sepsplit, n)) > 0 | !all(grepl(sepsplit, names(counts[[1]][-c(1:length(n))])))) {
                        sample_counts <- rep("?", length(n))
                        warning("Set labels are substrings of one another. To fix this, the set labels need to be separated by the character provided under \"sepsplit\", but the individual names cannot contain this character themselves.")
                    }
                } else {
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                }
                mysub <- paste(paste("Unique objects: All =", sum(counts[[1]])), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), sep = "")
            } else if (myclass == "VENNset") {
                if (class(x) == "list") x <- x[[1]]
                sample_counts <- sapply(setlist(x), function(y) unique(length(y)))
                mysub <- paste(paste("Unique objects: All =", length(unique(unlist(setlist(x))))), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), sep = "")
            } else {
                mysub <- mysub
            }
        }
        ## Plot venn shapes
        graphics::symbols(x = c(4, 5.5, 4, 5.5), y = c(6, 6, 4.5, 4.5), circles = c(2, 2, 2, 2), xlim = c(0, 10), ylim = c(0, 10), inches = FALSE, main = mymain, sub = mysub, lwd = mylwd, xlab = "", ylab = "", xaxt = "n", yaxt = "n", bty = "n", fg = lines, ...)
        ## Add counts
        for (i in seq(along = counts)) {
            olDF <- data.frame(
                x = c(3.0, 6.5, 3.0, 6.5, 4.8, 3.0, 4.8, 4.8, 6.5, 4.8, 3.9, 5.7, 3.9, 5.7, 4.8),
                y = c(7.2, 7.2, 3.2, 3.2, 7.2, 5.2, 0.4, 0.4, 5.2, 3.2, 6.3, 6.3, 4.2, 4.2, 5.2),
                counts = counts[[i]]
            )
            if (colmode == 1) {
                graphics::text(olDF$x[-c(7, 8)], olDF$y[-c(7, 8)] + yoffset[i], olDF$counts[-c(7, 8)], col = ccol, cex = ccex, ...)
            } # rows 14-15 of olDF are printed in next step
            if (colmode == 2) {
                graphics::text(olDF$x[-c(7, 8)], olDF$y[-c(7, 8)] + yoffset[i], olDF$counts[-c(7, 8)], col = ccol[[i]], cex = ccex[i], ...)
            }
            graphics::text(c(4.8), c(0.8) + yoffset[i], paste("Only in ", names(counts[[1]][1]), " & ", names(counts[[1]][4]), ": ", olDF$counts[7], "; Only in ", names(counts[[1]][2]), " & ", names(counts[[1]][3]), ": ", olDF$counts[8], sep = ""), col = diacol, cex = ccex, ...)
        }
        ## Add sample labels
        if (length(setlabels) == 1 & setlabels[1] == "default") {
            setlabels <- names(counts[[1]][1:4])
        } else {
            setlabels <- setlabels
        }
        graphics::text(c(2.0, 7.5, 2.0, 7.5), c(8.3, 8.3, 2.0, 2.0), labels = setlabels, col = lcol, cex = lcex, ...)
    }
    ## 5-way Venn diagram
    if (length(counts[[1]]) == 31) {
        ## Define subtitle
        if (mysub == "default") {
            if (myclass == "numeric") {
                n <- names(counts[[1]])[1:5]
                if (!all(rowSums(sapply(n, function(x) sapply(n, function(y) grepl(y, x)))) == 1)) { # Checks if one or more set labels are substrings of one another
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                    if (sum(grepl(sepsplit, n)) > 0 | !all(grepl(sepsplit, names(counts[[1]][-c(1:length(n))])))) {
                        sample_counts <- rep("?", length(n))
                        warning("Set labels are substrings of one another. To fix this, the set labels need to be separated by the character provided under \"sepsplit\", but the individual names cannot contain this character themselves.")
                    }
                } else {
                    sample_counts <- sapply(n, function(x) sum(counts[[1]][grepLabel(x, names(counts[[1]]))]))
                }
                mysub <- paste(paste("Unique objects: All =", sum(counts[[1]])), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), paste("; S5 =", sample_counts[5]), sep = "")
            } else if (myclass == "VENNset") {
                if (class(x) == "list") x <- x[[1]]
                sample_counts <- sapply(setlist(x), function(y) unique(length(y)))
                mysub <- paste(paste("Unique objects: All =", length(unique(unlist(setlist(x))))), paste("; S1 =", sample_counts[1]), paste("; S2 =", sample_counts[2]), paste("; S3 =", sample_counts[3]), paste("; S4 =", sample_counts[4]), paste("; S5 =", sample_counts[5]), sep = "")
            } else {
                mysub <- mysub
            }
        }
        ## Plot ellipse
        plotellipse <- function(center = c(1, 1), radius = c(1, 2), rotate = 1, segments = 360, xlab = "", ylab = "", ...) {
            angles <- (0:segments) * 2 * pi / segments
            rotate <- rotate * pi / 180
            ellipse <- cbind(radius[1] * cos(angles), radius[2] * sin(angles))
            ellipse <- cbind(ellipse[, 1] * cos(rotate) + ellipse[, 2] * sin(rotate), ellipse[, 2] * cos(rotate) - ellipse[, 1] * sin(rotate))
            ellipse <- cbind(center[1] + ellipse[, 1], center[2] + ellipse[, 2])
            plot(ellipse, type = "l", xlim = c(0, 10), ylim = c(0, 10), xlab = "", ylab = "", ...)
        }
        ## Plot ellipse as 5-way venn diagram
        ellipseVenn <- function(...) {
            graphics::split.screen(c(1, 1))
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(4.83, 6.2), radius = c(1.43, 4.11), rotate = 0, segments = 360, xlab = "", ylab = "", col = lines[1], axes = FALSE, main = mymain, sub = mysub, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(6.25, 5.4), radius = c(1.7, 3.6), rotate = 66, segments = 360, xlab = "", ylab = "", col = lines[2], axes = FALSE, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(6.1, 3.5), radius = c(1.55, 3.9), rotate = 150, segments = 360, xlab = "", ylab = "", col = lines[3], axes = FALSE, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(4.48, 3.15), radius = c(1.55, 3.92), rotate = 210, segments = 360, xlab = "", ylab = "", col = lines[4], axes = FALSE, lwd = mylwd, ...)
            graphics::screen(1, new = FALSE)
            plotellipse(center = c(3.7, 4.8), radius = c(1.7, 3.6), rotate = 293.5, segments = 360, xlab = "", ylab = "", col = lines[5], axes = FALSE, lwd = mylwd, ...)
            ## Add counts
            for (i in seq(along = counts)) {
                olDF <- data.frame(
                    x = c(4.85, 8.0, 7.1, 3.5, 2.0, 5.90, 4.4, 4.60, 3.60, 7.1, 6.5, 3.2, 5.4, 6.65, 3.40, 5.00, 6.02, 3.60, 5.20, 4.03, 4.20, 6.45, 6.8, 3.39, 6.03, 5.74, 4.15, 3.95, 5.2, 6.40, 5.1),
                    y = c(8.30, 6.2, 1.9, 1.6, 5.4, 6.85, 6.6, 2.45, 6.40, 4.3, 6.0, 4.6, 2.1, 3.40, 3.25, 6.43, 6.38, 5.10, 2.49, 6.25, 3.08, 5.30, 4.0, 3.80, 3.20, 5.95, 5.75, 3.75, 3.0, 4.50, 4.6),
                    counts = counts[[i]]
                )
                if (colmode == 1) {
                    graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol, cex = ccex, ...)
                }
                if (colmode == 2) {
                    graphics::text(olDF$x, olDF$y + yoffset[i], olDF$counts, col = ccol[[i]], cex = ccex[i], ...)
                }
            }
            ## Add sample labels
            if (length(setlabels) == 1 & setlabels[1] == "default") {
                setlabels <- names(counts[[1]][1:5])
            } else {
                setlabels <- setlabels
            }
            graphics::text(c(5.7, 7.9, 8.5, 4.2, 0.8), c(9.9, 7.9, 1.9, 0.0, 7.3), adj = c(0, 0.5), labels = setlabels, col = lcol, cex = lcex, ...)
            graphics::close.screen(all.screens = TRUE)
        }
        ellipseVenn(...)
    }
}

##########################################
## Bar Plot Function for Intersect Sets ##
##########################################
## Plots the counts of VENNset/INTERSECTset generated by overLapper function
olBarplot <- function(x, mincount = 0, complexity = "default", myxlabel = "default", myylabel = "Counts", mytitle = "default", ...) {
    ## Check validity of inputs
    if (!any(c("VENNset", "INTERSECTset") %in% class(x))) stop("x needs to be of class VENNset or INTERSECTset")
    ## global functions or variables
    Intersect_Sets <- Counts <- Level <- NULL
    ## Generate counts
    if (class(x) == "VENNset") counts <- sapply(vennlist(x), length)
    if (class(x) == "INTERSECTset") counts <- sapply(intersectlist(x), length)
    ## Complexity filter
    if (complexity[1] != "default") {
        complfilter <- complexitylevels(x) %in% complexity
    } else {
        complfilter <- complexitylevels(x) %in% complexitylevels(x)
    }
    ## Min count filter
    mincountfilter <- counts >= mincount
    ## Apply filters
    myfilter <- complfilter & mincountfilter
    counts <- counts[myfilter]
    ## Color bars by default by complexity levels
    mycol <- complexitylevels(x)
    mycol <- mycol[myfilter]
    ## Define x-axis label
    if (myxlabel == "default") {
        myxlabel <- paste("Intersect Sets (min count cutoff = ", mincount, ")", sep = "")
    } else {
        myxlabel <- myxlabel
    }
    ## Define main title
    if (mytitle == "default") {
        mytitle <- paste("Intersect Plot of", class(x), "Object")
    } else {
        mytitle < mytitle
    }
    ## Generate bar plot with ggplot2
    df_plot <- data.frame(Intersect_Sets = names(counts), Counts = counts, Level = as.character(mycol))
    df_plot[, 1] <- factor(df_plot[, 1], levels = unique(df_plot[, 1]), ordered = TRUE) # Defines plotting order of bars!!!
    ggplot2::ggplot(df_plot, ggplot2::aes(Intersect_Sets, Counts, fill = Level)) +
        ggplot2::geom_bar(position = "stack", stat = "identity", ...) +
        ggplot2::coord_flip() +
        ggplot2::theme(legend.position = "none") +
        ggplot2::theme(axis.text.y = ggplot2::element_text(angle = 0, hjust = 1)) +
        ggplot2::labs(x = myxlabel, y = myylabel) +
        ggplot2::ggtitle(mytitle)
}

##########################################
## Helper Functions not Exposed to User ##
##########################################

####################################################################
## Subset Reads by Mapping Regions to Create Mini FASTQ/BAM Files ##
####################################################################

## (A) Download FASTQ files of study SRP010938 from SRA at NCBI
.getSRAfastq <- function(sraid, maxreads) {
    system(paste("fastq-dump --defline-seq '@$sn[_$rn]/$ri' --gzip --split-files --maxSpotId", maxreads, sraid))
}
## Usage:
# library(systemPipeR)
# moduleload("sratoolkit/2.9.2")
# sraidv <- paste("SRR4460", 27:44, sep="")
# bplapply(sraidv, .getSRAfastq, maxreads="1000000000", BPPARAM = MulticoreParam(workers=18))
## Non-parallized download
# for(i in sraidv) .getSRAfastq(sraid=i, maxreads = "1000000000")

## (B) Align reads with systemPipeR/tophat against truncated TAIR10 reference (each chr truncated to 100kbp)
## (C) Extract 100,000 reads from each fastq file mapping to the truncated regions in reference
## Step (C) is performed with the following function
.subsetReadsByMappingRegion <- function(args, mydir = getwd(),
                                        outdir = "./data/SRP010938_sub",
                                        chromosomelength = 100000) {
    pkg <- c("GenomicAlignments", "GenomeInfoDb", "IRanges")
    checkPkg(pkg, quietly = FALSE)
    if (!dir.exists(outdir)) dir.create(outdir, recursive = TRUE)
    setwd(outdir) # outdir
    for (i in seq(along = outpaths(args))) {
        fl <- outpaths(args)[i]
        si <- GenomeInfoDb::seqinfo(BamFile(fl))
        gr <- GenomicRanges::GRanges(GenomeInfoDb::seqnames(si), IRanges::IRanges(100, GenomeInfoDb::seqlengths(si) - 100))
        aligns <- GenomicAlignments::readGAlignments(fl, param = Rsamtools::ScanBamParam(which = gr), use.names = TRUE)
        keepids <- names(aligns[start(aligns) < chromosomelength]) # Return read ids mapping in first 100000 nucleotides of chromosomes
        myN <- sample(90000:100000, 1) # Keep number of random sampled reads between 90-100K
        keepids <- sample(unique(keepids), myN, replace = TRUE) # random sample x reads
        keepids1 <- paste(keepids, "/1", sep = "")
        reads1 <- ShortRead::readFastq(infile1(args)[i]) # Reads in a FASTQ file from the current folder
        index <- gsub(" .*", "", as.vector(id(reads1))) %in% keepids1
        length(index[index == TRUE])
        reads1 <- reads1[index] # subset by keepids
        ShortRead::writeFastq(reads1, gsub("^.*/", "", infile1(args)[i]), full = TRUE) # writes ShortReadQ object to output file
        rm(reads1)
        gc() # Clean up memory
        reads2 <- ShortRead::readFastq(infile2(args)[i])
        keepids2 <- paste(keepids, "/2", sep = "")
        index <- gsub(" .*", "", as.vector(ShortRead::id(reads2))) %in% keepids2
        length(index[index == TRUE])
        reads2 <- reads2[index]
        ShortRead::writeFastq(reads2, gsub("^.*/", "", infile2(args)[i]), full = TRUE)
        rm(reads2)
        gc() # Clean up memory
        print(i)
    }
    setwd(mydir)
}
## Usage:
# getwd()
# targets <- system.file("extdata", "targetsPE.txt", package="systemPipeR")
# dir_path <- system.file("extdata/cwl", package="systemPipeR")
# args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-pe.cwl",
#                    input_file="hisat2/hisat2-mapping-pe.yml", dir_path=dir_path)
# args <- renderWF(args, inputvars = c(FileName1 = "_FASTQ_PATH1_", FileName2 = "_FASTQ_PATH2_",
#                                  SampleName = "_SampleName_"))
# args
#
# cmdlist(args)[1]
#
# resources <- list(walltime = 1200, ntasks = 1, ncpus = 14, memory = 20480)
# reg <- clusterRun(args, FUN = runCommandline, more.args = list(dir =FALSE, make_bam = TRUE),
#    conffile = ".batchtools.conf.R", template = "batchtools.slurm.tmpl",
#    Njobs = 18, runid = "01", resourceList = resources)
# batchtools::getStatus(reg = reg)
#
# args <- output_update(args, replace=".bam", dir=FALSE)
# .subsetReadsByMappingRegion(args = args)

#################################################
## Class and Method Definitions for EnvModules ##
#################################################
## Define EnvModules class
setClass("EnvModules", slots = c(
    available_modules = "list",
    loaded_modules = "list",
    default_modules = "list",
    modulecmd = "character"
))

## Methods to return module components
setGeneric(name = "available_modules", def = function(x) standardGeneric("available_modules"))
setMethod(f = "available_modules", signature = "EnvModules", definition = function(x) {
    return(x@available_modules)
})
setGeneric(name = "loaded_modules", def = function(x) standardGeneric("loaded_modules"))
setMethod(f = "loaded_modules", signature = "EnvModules", definition = function(x) {
    return(x@loaded_modules)
})
setGeneric(name = "default_modules", def = function(x) standardGeneric("default_modules"))
setMethod(f = "default_modules", signature = "EnvModules", definition = function(x) {
    return(x@default_modules)
})
setGeneric(name = "modulecmd", def = function(x) standardGeneric("modulecmd"))
setMethod(f = "modulecmd", signature = "EnvModules", definition = function(x) {
    return(x@modulecmd)
})

## Constructor methods
## List to EnvModules with: as(mylist, "EnvModules")
setAs(
    from = "list", to = "EnvModules",
    def = function(from) {
        new("EnvModules",
            available_modules = from$available_modules,
            loaded_modules = from$loaded_modules,
            default_modules = from$default_modules,
            modulecmd = from$modulecmd
        )
    }
)

## Coerce back to list: as(EnvModules, "list")
setGeneric(name = "EnvModules", def = function(x) standardGeneric("EnvModules"))
setMethod(f = "EnvModules", signature = "EnvModules", definition = function(x) {
    modules <- list(
        available_modules = x@available_modules, loaded_modules = x@loaded_modules, default_modules = x@default_modules,
        modulecmd = x@modulecmd
    )
    return(modules)
})

## EnvModules to list with: as("EnvModules", list)
setAs(
    from = "EnvModules", to = "list",
    def = function(from) {
        EnvModules(from)
    }
)

## Define print behavior for EnvModules
setMethod(
    f = "show", signature = "EnvModules",
    definition = function(object) {
        if (length(object@loaded_modules) == 0) {
            name_load <- 0
        } else {
            name <- names(object@loaded_modules)
            name_load <- length(object@loaded_modules[[name]])
        }
        if (length(object@available_modules$avail) == 0) {
            s_avail <- "Run: 'moduleAvail()'"
        } else {
            s_avail <- length(object@available_modules$avail)
        }
        cat(paste0("Instance of '", class(object), "':"),
            paste0("   Slot names/accessors: "),
            paste0("      modules available: ", s_avail),
            paste0("      modules loaded: ", name_load),
            paste0("      default modules: ", length(object@default_modules$default_modules)),
            paste0("      modulecmd: '", object@modulecmd, "'"),
            "\n",
            sep = "\n"
        )
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "EnvModules",
    definition = function(x) {
        return(slotNames(x))
    }
)

# Behavior of "[" operator for EnvModules
setMethod(f = "[", signature = "EnvModules", definition = function(x, i, ..., drop) {
    if (is.logical(i)) {
        i <- which(i)
    }
    x@available_modules <- x@available_modules[i]
    x@loaded_modules <- x@loaded_modules[i]
    x@default_modules <- x@default_modules[i]
    x@modulecmd <- x@modulecmd[i]
    return(x)
})

## Behavior of "[[" operator for EnvModules
setMethod(
    f = "[[", signature = c("EnvModules", "ANY", "missing"),
    definition = function(x, i, ..., drop) {
        return(as(x, "list")[[i]])
    }
)

## Behavior of "$" operator for EnvModules
setMethod("$",
    signature = "EnvModules",
    definition = function(x, name) {
        slot(x, name)
    }
)

## Replacement method for EnvModules using "[" operator
setReplaceMethod(f = "[[", signature = "EnvModules", definition = function(x, i, j, value) {
    if (i == 1) x@default_modules <- value
    if (i == 2) x@modulecmd <- value
    if (i == "default_modules") x@default_modules <- value
    if (i == "modulecmd") x@modulecmd <- value
    return(x)
})

#################################
## Module function Constructor ##
#################################
module <- function(action_type, module_name = NULL) {
    # Find path for module command
    modulecmd_path <- is.modules.avail()
    # Only initialize module system if it has not yet been initialized and the module command exists
    if (Sys.getenv("MODULEPATH") == "" && length(modulecmd_path) > 0) {
        list <- module.Clear.Init("init", modulecmd_path)
    } else if (Sys.getenv("MODULEPATH") == "" && length(modulecmd_path) == 0) {
        stop("Cound not find the path of Environment Modules command \"modulecmd\" nor LMOD_CMD")
    }
    mymodules <- list(
        available_modules = list(),
        loaded_modules = module.List.Avail("list", is.modules.avail()),
        default_modules = default_modules <- myEnvModules(),
        modulecmd = modulecmd_path <- is.modules.avail()
    )
    ## Action
    switch(action_type,
           "load"   = mymodules$loaded_modules <- module.Load.Unload(action_type, module_name, mymodules$modulecmd),
           "unload" = mymodules$loaded_modules <- module.Load.Unload(action_type, module_name, mymodules$modulecmd),
           "list"   = mymodules$loaded_modules <- print(module.List.Avail(action_type, mymodules$modulecmd)),
           "avail"  = mymodules$available_modules <- module.List.Avail(action_type, mymodules$modulecmd),
           "clear"  = mymodules$loaded_modules <- module.Clear.Init(action_type, mymodules$modulecmd),
           "init"   = mymodules$loaded_modules <- module.Clear.Init(action_type, mymodules$modulecmd),
           stop("That action is not supported.")
    )
    invisible(as(mymodules, "EnvModules"))
}
## Usage::
# mod <- module("init")
# mod <- module("list")
# mod <- module("avail")
# mod <- module("load","samtools")
# mod <- module("unload", "samtools")
# mod <- module("clear")

##############
## Wrappers ##
##############

################
## moduleInit ##
################
# Function to load default modules files
moduleInit <- function() {
    return(module("init"))
}
## Usage:
# mod <- moduleInit()

################
## modulelist ##
################
## List software available in module system
modulelist <- function() {
    return(module("list"))
}
## Usage:
# mod <- modulelist()

################
## moduleAvail ##
################
# Function to check module avail
moduleAvail <- function() {
    return(module("avail"))
}
## Usage:
# mod <- moduleAvail()

################
## moduleload ##
################
## Load software from module system
moduleload <- function(module_name) {
    return(module("load", module_name))
}
## Usage:
# mod <- moduleload("samtools")
# mod <- moduleload(c("samtools", "hisat2"))

##################
## moduleUnload ##
##################
# Unload module file
moduleUnload <- function(module_name) {
    return(module("unload", module_name))
}
## Usage:
# mod <- moduleUnload("samtools")
# mod <- moduleUnload(c("samtools", "hisat2"))

#################
## moduleClear ##
#################
# Unload all currently loaded modules
moduleClear <- function() {
    return(module("clear"))
}

## Usage:
# mod <- moduleClear()

##################################
## module accessories functions ##
#################################

######################
## is.modules.avail ##
######################
# Check if the Environment Modules is available in the system and returns module
# function PATH.
is.modules.avail <- function() {
    ## Find path for module command
    modulecmd_path <- Sys.getenv("LMOD_CMD")
    if (Sys.info()[["sysname"]] == "Windows") {
        modulecmd_path <- NULL
    } else {
        if (modulecmd_path == "") {
            try(suppressWarnings(modulecmd_path <- system("which modulecmd", intern = TRUE, ignore.stderr = TRUE)),
                silent = TRUE
            )
        }
    }
    ## "Environment Modules" is not available
    if (length(modulecmd_path) == 0) {
        message(
            "'Environment Modules is not available. Please make sure to configure
            your PATH environment variable according to the software in use.'", "\n",
            "Find more detail help('module')"
        )
        ## "Environment Modules" is available and proceed the module action_type
    } else if (length(modulecmd_path) > 0) {
        return(modulecmd_path)
    }
}

## Usage:
# is.modules.avail()

##################
## myEnvModules ##
##################
# It returns a list with all default modules files.
myEnvModules <- function() {
    # Module function assumes are using a bash SHELL
    if (!system("echo $0", intern = TRUE) %in% c("bash", "sh")) warning("'module' function assumes you are using a bash SHELL and may not work as expected in other SHELL types.")
    # Get base environment from login profile
    base_env <- strsplit(system('bash -l -c "env"', intern = TRUE, ignore.stderr = TRUE), "\n")
    base_env <- strsplit(as.character(base_env), "=")
    # Iterate through base environment
    for (x in seq_along(base_env)) {
        # Set environment based on login profile
        if (base_env[[x]][1] == "LOADEDMODULES" || base_env[[x]][1] == "MODULESHOME" || base_env[[x]][1] == "MODULEPATH" || base_env[[x]][1] == "MODULES_DIR" || base_env[[x]][1] == "HPCC_MODULES") {
            if (base_env[[x]][1] == "LOADEDMODULES") {
                default_modules <- strsplit(base_env[[x]][2], ":")
                names(default_modules) <- "default_modules"
            } else {
                l <- list(base_env[[x]][2])
                names(l) <- base_env[[x]][1]
                do.call(Sys.setenv, l)
            }
        }
    }
    return(default_modules)
}
## Usage:
# myEnvModules()

########################
## module.Load.Unload ##
########################
# Internal function to module load <module_name> and module unload <module_name>
module.Load.Unload <- function(action_type, module_name = "", modulecmd_path) {
    module_name <- paste(module_name, collapse = " ")
    # modulecmd_path <- is.modules.avail()
    # Use the low level C binary for generating module environment variables
    try(module_vars <- system(paste(modulecmd_path, "bash", action_type, module_name), intern = TRUE))
    if (length(module_vars) > 0) {
        for (y in seq(1, length(module_vars))) {
            # Separate environment variables
            module_var <- strsplit(module_vars, ";")
            # Iterate through all environment variables
            for (x in seq(1, length(module_var[[y]]))) {
                # Isolate key, value pair
                evar <- module_var[[y]][x]
                # Filter export commands
                if (length(grep("^ *export", evar)) == 0 && length(evar) > 0) {
                    # Seprate key and value
                    evar <- strsplit(as.character(evar), "=")
                    # Stip spaces at the end of the value
                    evar_val <- gsub("\\\\", "", gsub("[[:space:]]", "", evar[[1]][2]))
                    # Remove extra backslashes
                    l <- list(gsub("\\$", "", evar_val))
                    # Load dependant modules
                    if (length(grep("^ *module", evar[[1]][1])) > 0) {
                        inner_module <- strsplit(evar[[1]][1], " ")
                    }
                    # Source environment
                    else if (length(grep("^ *source", evar[[1]][1])) > 0) {
                        warning("Module uses a bash script to initialize, some software may not function as expected:\n\t", evar[[1]][1])
                    }
                    # Unset variables that need to be unset
                    else if (length(grep("^ *unset ", evar[[1]][1])) > 0) {
                        evar <- gsub("^unset (.*)$", "\\1", evar[[1]][1])
                        Sys.unsetenv(evar)
                    } else {
                        # Assign names to each value in list
                        names(l) <- evar[[1]][1]
                        # Set environment variable in current environment
                        do.call(Sys.setenv, l)
                    }
                }
            }
        }
    }
    module_loaded <- module.List.Avail("list", modulecmd_path)
    return(module_loaded)
}

## Usage:
# module.Load.Unload("load", "samtools")
# module.Load.Unload("unload", "samtools")

########################
## module.List.Avail ##
########################
# Internal function to module list and module avail
module.List.Avail <- function(action_type, modulecmd_path) {
    try(module_vars <- system2(modulecmd_path, paste("bash", action_type, "-t"), stdout = TRUE, stderr = TRUE))
    ## Return only the module names
    module_l <- module_vars[-grep(":$", module_vars)]
    for (i in seq_along(module_l)) {
        if (grepl("\033\\[0m", module_l[i])) {
            module_l[i] <- gsub("*\033\\[0m", "", module_l[i])
            module_l[i] <- gsub("\033\\[4m", "", module_l[i])
            module_l[i] <- gsub("\033\\[4;90;47", "", module_l[i])
            module_l[i] <- gsub("\033\\[90;47", "", module_l[i])
        }
    }
    module_l <- list(module_l)
    names(module_l) <- action_type
    return(module_l)
}

## Usage:
# module.List.Avail("list")
# module.List.Avail("avail")

########################
## module.Clear.Init ##
########################
# Internal function to module clear and module init
module.Clear.Init <- function(action_type, modulecmd_path) {
    if (action_type == "init") {
        default_modules <- myEnvModules()
        ## Make sure to process default modules after the environment is set with the above loop
        for (x in seq_along(default_modules[[1]])) {
            print(paste("Loading module", default_modules[[1]][x]))
            try(module.Load.Unload("load", default_modules[[1]][x], modulecmd_path))
        }
        return(default_modules)
    } else if (action_type == "clear") {
        loaded_modules <- strsplit(Sys.getenv("LOADEDMODULES"), ":")
        if (length(loaded_modules[[1]]) > 0) {
            for (x in seq(1, length(loaded_modules[[1]]))) {
                module_name <- loaded_modules[[1]][x]
                print(paste("Unloading module", module_name))
                try(module.Load.Unload("unload", module_name, modulecmd_path))
            }
        }
        return(list())
    }
}

## Usage:
# module.Clear.Init("init", modulecmd_path)
# module.Clear.Init("clear")

#########################################
## .callModNew function Constructor ##
#########################################
## This was developed for the r shell in Module system.
# .callModNew <- function(action_type, module_name, modulecmd_path) {
#     if (action_type %in% c("list", "clear", "init") && !is.null(module_name)) {
#         warning("Any value of `module_name` for action type 'list', 'clear', and 'init' is ignored", immediate. = TRUE)
#     }
#     if (action_type %in% c("load", "unload") && is.null(module_name)) {
#         stop("`module_name` cannot be empty for load and unload actions")
#     }
#     
#     cmdpipe <- pipe(paste0(modulecmd_path, " r autoinit"))
#     on.exit(try(close(cmdpipe), silent = TRUE), add = TRUE)
#     myenv <- new.env()
#     eval(parse(cmdpipe), envir = myenv)
#     
#     module_name <- paste(module_name, collapse = " ")
#     if (action_type %in% c("init")) {
#         default_modules <- myEnvModules()[[1]]
#         module_name <- paste(default_modules, collapse = " ")
#     }
#     call_cmd <- switch(action_type,
#                        "load"   = paste("load", module_name),
#                        "unload" = paste("unload", module_name),
#                        "init"   = paste("load", module_name),
#                        "list"   = "list",
#                        "avail"  = paste("avail", module_name),
#                        "clear"  = "clear -f",
#                        stop("That action is not supported.")
#     )
#     call_cmd <- stringr::str_remove(call_cmd, "[ ]{0,}$")
#     eval(parse(text = paste0("myenv$module(", deparse(call_cmd), ")")))
# }

######################################################
## Generate various feature types from TxDb objects ##
######################################################
genFeatures <- function(txdb, featuretype = "all", reduce_ranges, upstream = 1000, downstream = 0, verbose = TRUE) {
    pkg <- c("GenomeInfoDb", "GenomicFeatures")
    checkPkg(pkg, quietly = FALSE)
    ## Check validity of inputs
    supported_features <- c("tx_type", "promoter", "intron", "exon", "cds", "fiveUTR", "threeUTR", "intergenic")
    if (tolower(featuretype[1]) == "all") featuretype <- supported_features
    if (class(txdb) != "TxDb") stop("Argument 'txdb' needs to be assigned object of class TxDb!")
    if (any(!featuretype %in% supported_features)) stop("featuretype supports any of the following values: ", paste(supported_features, collapse = ", "))
    ## Empty GRangesList to store results
    featuresGRl <- GRangesList()
    GenomeInfoDb::seqinfo(featuresGRl) <- GenomeInfoDb::seqinfo(txdb)
    ## Empty GRanges object for feature types that don't exist
    gr_empty <- GRanges()
    mcols(gr_empty) <- S4Vectors::DataFrame(feature_by = character(), featuretype_id = character(), featuretype = character())
    GenomeInfoDb::seqinfo(gr_empty) <- GenomeInfoDb::seqinfo(txdb)
    ## Gene/transcript id mappings (required for some features)
    ids <- mcols(GenomicFeatures::transcripts(txdb, columns = c("tx_id", "tx_name", "gene_id")))
    ge_id <- unstrsplit(ids$gene_id)
    names(ge_id) <- ids$tx_id
    ## Transcript ranges: each 'tx_type' as separate GRanges object (reduced by gene)
    if ("tx_type" %in% featuretype) {
        tx <- GenomicFeatures::transcripts(txdb, columns = c("tx_name", "gene_id", "tx_type"))
        if (length(tx) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("transcript" = gr_empty))
        } else {
            mcols(tx)$tx_type <- ifelse(is.na(mcols(tx)$tx_type), "transcript", mcols(tx)$tx_type)
            tx_type <- unique(mcols(tx)$tx_type)
            for (i in seq_along(tx_type)) {
                tmp <- tx[mcols(tx)$tx_type == tx_type[i]]
                if (reduce_ranges == TRUE) {
                    tmp <- reduce(split(tmp, as.character(mcols(tmp)$gene_id)))
                    tmp <- unlist(tmp)
                    feature_id <- paste(names(tmp), ":", tx_type[i], "_red", sep = "")
                    mcols(tmp) <- S4Vectors::DataFrame(feature_by = names(tmp), featuretype_id = feature_id, featuretype = paste0(tx_type[i], "_red"))
                    names(tmp) <- seq_along(tmp)
                    featuresGRl <- c(featuresGRl, GRangesList(tmp = tmp))
                    names(featuresGRl)[length(featuresGRl)] <- paste0(tx_type[i], "_red")
                } else {
                    mcols(tmp) <- S4Vectors::DataFrame(feature_by = mcols(tmp)$gene_id, featuretype_id = mcols(tmp)$tx_name, featuretype = tx_type[i])
                    featuresGRl <- c(tmp = featuresGRl, GRangesList(tmp = tmp))
                    names(tmp) <- seq_along(tmp)
                    names(featuresGRl)[length(featuresGRl)] <- tx_type[i]
                }
            }
            if (verbose == TRUE) cat("Created feature ranges:", paste(tx_type, collapse = ", "), "\n")
        }
    }
    ## Create promoter ranges reduced by gene
    if ("promoter" %in% featuretype) {
        mycheck <- suppressWarnings(promoters(GenomicFeatures::transcriptsBy(txdb, "gene"), upstream, downstream))
        if (length(mycheck) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("promoter" = gr_empty))
        } else {
            if (reduce_ranges == TRUE) {
                mypromoters <- suppressWarnings(unlist(reduce(promoters(GenomicFeatures::transcriptsBy(txdb, "gene"), upstream, downstream))))
                mypromoters <- trim(mypromoters)
                feature_id <- paste0(names(mypromoters), ":P_red")
                mcols(mypromoters) <- S4Vectors::DataFrame(feature_by = names(mypromoters), featuretype_id = feature_id, featuretype = "promoter_red")
                names(mypromoters) <- seq_along(mypromoters)
                featuresGRl <- c(featuresGRl, GRangesList("promoter_red" = mypromoters))
            } else {
                mypromoters <- suppressWarnings(promoters(txdb, upstream, downstream, columns = c("tx_name", "gene_id", "tx_type")))
                mypromoters <- trim(mypromoters)
                mcols(mypromoters) <- S4Vectors::DataFrame(feature_by = as(mcols(mypromoters)$gene_id, "CharacterList"), featuretype_id = mcols(mypromoters)$tx_name, featuretype = "promoter")
                featuresGRl <- c(featuresGRl, GRangesList("promoter" = mypromoters))
            }
            if (verbose == TRUE) cat("Created feature ranges: promoter", "\n")
        }
    }
    ## Create intron ranges reduced by gene
    if ("intron" %in% featuretype) {
        ## Introns by transcript
        myintrons <- GenomicFeatures::intronsByTranscript(txdb)
        if (length(myintrons) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("intron" = gr_empty))
        } else {
            ## Convert to introns by genes
            intron_count <- sapply(width(myintrons), length)
            names(intron_count) <- ge_id[names(intron_count)]
            intron_count <- intron_count[intron_count != 0]
            ge_id_intron <- rep(names(intron_count), intron_count)
            myintrons <- unlist(myintrons)
            myintrons <- split(myintrons, ge_id_intron) # Introns by gene
            if (reduce_ranges == TRUE) {
                ## Reduce introns by gene, use gene ID for naming and append counter
                myintrons <- reduce(myintrons)
                intron_red_count <- sapply(width(myintrons), length)
                ge_id_red_intron <- rep(names(intron_red_count), intron_red_count)
                feature_id <- paste(ge_id_red_intron, sprintf("I%03d_red", unlist(sapply(as.integer(intron_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myintrons <- unlist(myintrons)
                mcols(myintrons) <- S4Vectors::DataFrame(feature_by = ge_id_red_intron, featuretype_id = feature_id, featuretype = "intron_red")
                names(myintrons) <- seq_along(myintrons)
                featuresGRl <- c(featuresGRl, GRangesList("intron_red" = myintrons))
            } else {
                intron_red_count <- sapply(width(myintrons), length)
                ge_id_red_intron <- rep(names(intron_red_count), intron_red_count)
                feature_id <- paste(ge_id_red_intron, sprintf("I%03d", unlist(sapply(as.integer(intron_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myintrons <- unlist(myintrons)
                mcols(myintrons) <- S4Vectors::DataFrame(feature_by = as(ge_id_red_intron, "CharacterList"), featuretype_id = feature_id, featuretype = "intron")
                names(myintrons) <- seq_along(myintrons)
                featuresGRl <- c(featuresGRl, GRangesList("intron" = myintrons))
            }
            if (verbose == TRUE) cat("Created feature ranges: intron", "\n")
        }
    }
    ## Create exon ranges reduced by gene
    if ("exon" %in% featuretype) {
        ## exons by gene
        myexons <- GenomicFeatures::exonsBy(txdb, "gene")
        if (length(myexons) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("exon" = gr_empty))
        } else {
            if (reduce_ranges == TRUE) {
                myexons <- reduce(myexons)
                exon_red_count <- sapply(width(myexons), length)
                ge_id_red_exon <- rep(names(exon_red_count), exon_red_count)
                feature_id <- paste(ge_id_red_exon, sprintf("E%03d_red", unlist(sapply(as.integer(exon_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myexons <- unlist(myexons)
                mcols(myexons) <- S4Vectors::DataFrame(feature_by = ge_id_red_exon, featuretype_id = feature_id, featuretype = "exon_red")
                names(myexons) <- seq_along(myexons)
                featuresGRl <- c(featuresGRl, GRangesList("exon_red" = myexons))
            } else {
                exon_red_count <- sapply(width(myexons), length)
                ge_id_red_exon <- rep(names(exon_red_count), exon_red_count)
                feature_id <- paste(ge_id_red_exon, sprintf("E%03d", unlist(sapply(as.integer(exon_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myexons <- unlist(myexons)
                mcols(myexons) <- S4Vectors::DataFrame(feature_by = as(ge_id_red_exon, "CharacterList"), featuretype_id = feature_id, featuretype = "exon")
                names(myexons) <- seq_along(myexons)
                featuresGRl <- c(featuresGRl, GRangesList("exon" = myexons))
            }
            if (verbose == TRUE) cat("Created feature ranges: exon", "\n")
        }
    }
    ## Create CDS ranges reduced by gene
    if ("cds" %in% featuretype) {
        ## CDS by gene
        mycds <- GenomicFeatures::cdsBy(txdb, "gene")
        if (length(mycds) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("cds" = gr_empty))
        } else {
            if (reduce_ranges == TRUE) {
                mycds <- reduce(mycds)
                cds_red_count <- sapply(width(mycds), length)
                ge_id_red_cds <- rep(names(cds_red_count), cds_red_count)
                feature_id <- paste(ge_id_red_cds, sprintf("CDS%03d_red", unlist(sapply(as.integer(cds_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                mycds <- unlist(mycds)
                mcols(mycds) <- S4Vectors::DataFrame(feature_by = ge_id_red_cds, featuretype_id = feature_id, featuretype = "cds_red")
                names(mycds) <- seq_along(mycds)
                featuresGRl <- c(featuresGRl, GRangesList("cds_red" = mycds))
            } else {
                cds_red_count <- sapply(width(mycds), length)
                ge_id_red_cds <- rep(names(cds_red_count), cds_red_count)
                feature_id <- paste(ge_id_red_cds, sprintf("CDS%03d", unlist(sapply(as.integer(cds_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                mycds <- unlist(mycds)
                mcols(mycds) <- S4Vectors::DataFrame(feature_by = as(ge_id_red_cds, "CharacterList"), featuretype_id = feature_id, featuretype = "cds")
                names(mycds) <- seq_along(mycds)
                featuresGRl <- c(featuresGRl, GRangesList("cds" = mycds))
            }
            if (verbose == TRUE) cat("Created feature ranges: cds", "\n")
        }
    }
    ## Create 5'UTR ranges reduced by gene
    if ("fiveUTR" %in% featuretype) {
        ## 5'UTRs by transcript
        myfiveutr <- GenomicFeatures::fiveUTRsByTranscript(txdb)
        if (length(myfiveutr) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("fiveUTR" = gr_empty))
        } else {
            ## Convert to 5'UTRs by genes
            utr_count <- sapply(width(myfiveutr), length)
            names(utr_count) <- ge_id[names(utr_count)]
            utr_count <- utr_count[utr_count != 0]
            ge_id_utr <- rep(names(utr_count), utr_count)
            myfiveutr <- unlist(myfiveutr)
            myfiveutr <- split(myfiveutr, ge_id_utr) # UTRs by gene
            if (reduce_ranges == TRUE) {
                ## Reduce introns by gene, use gene ID for naming and append counter
                myfiveutr <- reduce(myfiveutr)
                utr_red_count <- sapply(width(myfiveutr), length)
                ge_id_red_utr <- rep(names(utr_red_count), utr_red_count)
                feature_id <- paste(ge_id_red_utr, sprintf("fiveUTR%03d_red", unlist(sapply(as.integer(utr_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myfiveutr <- unlist(myfiveutr)
                mcols(myfiveutr) <- S4Vectors::DataFrame(feature_by = ge_id_red_utr, featuretype_id = feature_id, featuretype = "fiveUTR_red")
                names(myfiveutr) <- seq_along(myfiveutr)
                featuresGRl <- c(featuresGRl, GRangesList("fiveUTR_red" = myfiveutr))
            } else {
                utr_red_count <- sapply(width(myfiveutr), length)
                ge_id_red_utr <- rep(names(utr_red_count), utr_red_count)
                feature_id <- paste(ge_id_red_utr, sprintf("fiveUTR%03d", unlist(sapply(as.integer(utr_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                myfiveutr <- unlist(myfiveutr)
                mcols(myfiveutr) <- S4Vectors::DataFrame(feature_by = as(ge_id_red_utr, "CharacterList"), featuretype_id = feature_id, featuretype = "fiveUTR")
                names(myfiveutr) <- seq_along(myfiveutr)
                featuresGRl <- c(featuresGRl, GRangesList("fiveUTR" = myfiveutr))
            }
            if (verbose == TRUE) cat("Created feature ranges: fiveUTR", "\n")
        }
    }
    ## Create 3'UTR ranges reduced by gene
    if ("threeUTR" %in% featuretype) {
        ## 3'UTRs by transcript
        mythreeutr <- GenomicFeatures::threeUTRsByTranscript(txdb)
        if (length(mythreeutr) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("threeUTR" = gr_empty))
        } else {
            ## Convert to 3'UTRs by genes
            utr_count <- sapply(width(mythreeutr), length)
            names(utr_count) <- ge_id[names(utr_count)]
            utr_count <- utr_count[utr_count != 0]
            ge_id_utr <- rep(names(utr_count), utr_count)
            mythreeutr <- unlist(mythreeutr)
            mythreeutr <- split(mythreeutr, ge_id_utr) # UTRs by gene
            if (reduce_ranges == TRUE) {
                ## Reduce introns by gene, use gene ID for naming and append counter
                mythreeutr <- reduce(mythreeutr)
                utr_red_count <- sapply(width(mythreeutr), length)
                ge_id_red_utr <- rep(names(utr_red_count), utr_red_count)
                feature_id <- paste(ge_id_red_utr, sprintf("threeUTR%03d_red", unlist(sapply(as.integer(utr_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                mythreeutr <- unlist(mythreeutr)
                mcols(mythreeutr) <- S4Vectors::DataFrame(feature_by = ge_id_red_utr, featuretype_id = feature_id, featuretype = "threeUTR_red")
                names(mythreeutr) <- seq_along(mythreeutr)
                featuresGRl <- c(featuresGRl, GRangesList("threeUTR_red" = mythreeutr))
            } else {
                utr_red_count <- sapply(width(mythreeutr), length)
                ge_id_red_utr <- rep(names(utr_red_count), utr_red_count)
                feature_id <- paste(ge_id_red_utr, sprintf("threeUTR%03d", unlist(sapply(as.integer(utr_red_count), function(x) seq(from = 1, to = x)))), sep = ":")
                mythreeutr <- unlist(mythreeutr)
                mcols(mythreeutr) <- S4Vectors::DataFrame(feature_by = as(ge_id_red_utr, "CharacterList"), featuretype_id = feature_id, featuretype = "threeUTR")
                names(mythreeutr) <- seq_along(mythreeutr)
                featuresGRl <- c(featuresGRl, GRangesList("threeUTR" = mythreeutr))
            }
            if (verbose == TRUE) cat("Created feature ranges: threeUTR", "\n")
        }
    }
    ## Create intergenic ranges
    if ("intergenic" %in% featuretype) {
        # if(verbose==TRUE & any(is.na(seqlengths(txdb)))) warning("seqlengths missing for: ", paste(head(names(seqlengths(txdb))[is.na(seqlengths(txdb))]), collapse=", "), ". Thus, corresponding chromosome end ranges will be missing in intergenic results.")
        ge <- GenomicFeatures::genes(txdb)
        if (length(ge) == 0) { # If range set is empty, append 'gr_empty'.
            featuresGRl <- c(featuresGRl, GRangesList("intergenic" = gr_empty))
        } else {
            myseqinfo <- GenomeInfoDb::seqinfo(ge)
            GenomeInfoDb::seqlengths(ge) <- NA # Note: the following ignores chromosome end ranges on the right end
            mynames <- names(ge)
            BiocGenerics::strand(ge) <- "*"
            ge <- reduce(ge, with.revmap = TRUE)
            myids <- character(length = length(ge))
            revmaplist <- as.list(mcols(ge)$revmap)
            for (i in seq(along = ge)) myids[i] <- paste(mynames[revmaplist[[i]]], collapse = "_")
            myintergenics <- gaps(ge)
            myintergenics <- myintergenics[BiocGenerics::strand(myintergenics) == "*"] # Removes chromosome ranges created by gaps when seqlengths available
            # index <- GenomicRanges::findOverlaps(ge, myintergenics, minoverlap=0L)
            index <- GenomicRanges::findOverlaps(ge, myintergenics, maxgap = 0L, minoverlap = 0L) # change necessary since default in IRanges changed from maxgap=0L to maxgap=-1L
            myids <- tapply(myids[as.matrix(index)[, 1]], as.matrix(index)[, 2], paste, collapse = "__")
            if (reduce_ranges == TRUE) {
                mcols(myintergenics) <- S4Vectors::DataFrame(feature_by = sprintf("INTER%08d", seq_along(myids)), featuretype_id = as.character(myids), featuretype = "intergenic")
            } else {
                mcols(myintergenics) <- S4Vectors::DataFrame(feature_by = as(sprintf("INTER%08d", seq_along(myids)), "CharacterList"), featuretype_id = as.character(myids), featuretype = "intergenic")
            }
            names(myintergenics) <- seq_along(myintergenics)
            GenomeInfoDb::seqinfo(myintergenics) <- myseqinfo
            featuresGRl <- c(featuresGRl, GRangesList("intergenic" = myintergenics))
            if (verbose == TRUE) cat("Created feature ranges: intergenic", "\n")
        }
    }
    ## Return results
    return(featuresGRl)
}
## Usage:
# file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
# txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")
# feat <- genFeatures(txdb, featuretype="all", reduce_ranges=TRUE, upstream=1000, downstream=0, verbose=TRUE)

#############################################################
## Compute and Plot Read Distribution Across Feature Types ##
#############################################################
## Compute distribution of reads across feature types
featuretypeCounts <- function(bfl, grl, singleEnd = TRUE, readlength = NULL, type = "data.frame") {
    pkg <- c("GenomicAlignments", "IRanges")
    checkPkg(pkg, quietly = FALSE)
    ## Check for valid inputs
    if (!(is.null(readlength[1]) | is.integer(readlength))) stop("readlength needs to be assigned NULL or integer vector")
    if (length(type) != 1) stop("Argument needs to be character vector of length 1.")
    if (!any(c("list", "data.frame") %in% type)) stop("Argument 'type' needs to be assigned one of 'list' or 'data.frame'")
    ## List container for storing results
    resultlist <- sapply(names(bfl), function(x) list(NULL))
    ## Vector to store counts of total aligned reads
    totalcounts <- numeric(length(bfl))
    names(totalcounts) <- names(bfl)
    ## Total length (in bps) of each reduced feature type
    feattypelength <- sapply(names(grl), function(x) sum(width(reduce(grl[[x]]))))
    ## Read count for every feature given in gr (coming from gff)
    for (i in names(grl)) BiocGenerics::strand(grl[[i]][BiocGenerics::strand(grl[[i]]) == "*"]) <- "+" # Sets "*" to "+" to avoid double-counting of reads in this strand-specific method
    feature <- names(grl)
    featurewithtotal <- c(names(grl), "N_total_aligned")
    for (j in seq(along = bfl)) {
        if (is.null(readlength[1])) {
            myMA <- matrix(rep(0, length(featurewithtotal) * 1), nrow = length(featurewithtotal), ncol = 1, dimnames = list(featurewithtotal, "anyreadlength"))
        } else {
            myMA <- matrix(rep(0, length(featurewithtotal) * length(readlength)), nrow = length(featurewithtotal), ncol = length(readlength), dimnames = list(featurewithtotal, readlength))
        }
        myMAsense <- myMA
        bf <- open(bfl[[j]])
        while (isIncomplete(bf)) {
            if (singleEnd == TRUE) {
                aligns <- GenomicAlignments::readGAlignments(bf, use.names = FALSE)
            } else if (singleEnd == FALSE) {
                aligns <- GenomicAlignments::readGAlignmentPairs(bf, use.names = FALSE)
            } else {
                stop("singleEnd needs to be TRUE or FALSE")
            }
            for (i in feature) {
                gr <- grl[[i]]
                counter <- which(feature == i)
                ## Non-strand-specific counts
                alignssub <- IRanges::subsetByOverlaps(aligns, gr, ignore.strand = TRUE)
                if (singleEnd == TRUE) {
                    if (is.null(readlength[1])) {
                        counts <- length(alignssub)
                        if (counter == 1) totalcounts <- length(aligns)
                    } else {
                        counts <- table(GenomicAlignments::qwidth(alignssub))[colnames(myMA)]
                        if (counter == 1) totalcounts <- table(GenomicAlignments::qwidth(aligns))[colnames(myMA)]
                    }
                } else { # The following reports for PE reads the mean read length for each pair
                    if (is.null(readlength[1])) {
                        counts <- length(alignssub)
                        if (counter == 1) totalcounts <- length(aligns)
                    } else {
                        mywidth <- round((GenomicAlignments::qwidth(GenomicAlignments::last(alignssub)) + GenomicAlignments::qwidth(S4Vectors::first(alignssub))) / 2)
                        counts <- table(mywidth)[colnames(myMA)]
                        if (counter == 1) {
                            totalmywidth <- round((GenomicAlignments::qwidth(GenomicAlignments::last(aligns)) + GenomicAlignments::qwidth(S4Vectors::first(aligns))) / 2)
                            totalcounts <- table(totalmywidth)[colnames(myMA)]
                        }
                    }
                }
                counts[is.na(counts)] <- 0
                myMA[i, ] <- myMA[i, ] + counts
                if (counter == 1) {
                    totalcounts[is.na(totalcounts)] <- 0
                    myMA["N_total_aligned", ] <- myMA["N_total_aligned", ] + totalcounts
                }
                ## Strand-specific counts
                alignssub <- IRanges::subsetByOverlaps(aligns, gr, ignore.strand = FALSE)
                if (singleEnd == TRUE) {
                    if (is.null(readlength[1])) {
                        sensecounts <- length(alignssub)
                        if (counter == 1) totalsensecounts <- length(aligns[BiocGenerics::strand(aligns) == "+"])
                    } else {
                        sensecounts <- table(GenomicAlignments::qwidth(alignssub))[colnames(myMAsense)]
                        if (counter == 1) totalsensecounts <- table(GenomicAlignments::qwidth(aligns[BiocGenerics::strand(aligns) == "+"]))[colnames(myMAsense)]
                    }
                } else { # The following reports for PE reads the mean read length for each pair
                    if (is.null(readlength[1])) {
                        sensecounts <- length(alignssub)
                        if (counter == 1) totalsensecounts <- length(aligns[BiocGenerics::strand(aligns) == "+"])
                    } else {
                        mywidth <- round((GenomicAlignments::qwidth(GenomicAlignments::last(alignssub)) + GenomicAlignments::qwidth(S4Vectors::first(alignssub))) / 2)
                        sensecounts <- table(mywidth)[colnames(myMA)]
                        if (counter == 1) {
                            totalmywidth <- round((GenomicAlignments::qwidth(GenomicAlignments::last(aligns)) + GenomicAlignments::qwidth(S4Vectors::first(aligns))) / 2)
                            totalsensecounts <- table(totalmywidth)[colnames(myMA)]
                        }
                    }
                }
                sensecounts[is.na(sensecounts)] <- 0
                myMAsense[i, ] <- myMAsense[i, ] + sensecounts
                if (counter == 1) {
                    totalsensecounts[is.na(totalsensecounts)] <- 0
                    myMAsense["N_total_aligned", ] <- myMAsense["N_total_aligned", ] + totalsensecounts
                }
            }
        }
        close(bf)
        myMAantisense <- myMA - myMAsense
        myMAantisense[myMAantisense < 0] <- 0
        myMAsense[myMAsense <- 0] <- 0
        myMAsense <- data.frame(SampleName = names(bfl)[j], Strand = "Sense", Featuretype = row.names(myMAsense), Featuretypelength = as.numeric(feattypelength[row.names(myMAsense)]), myMAsense, check.names = FALSE)
        myMAantisense <- data.frame(SampleName = names(bfl)[j], Strand = "Antisense", Featuretype = row.names(myMAantisense), Featuretypelength = as.numeric(feattypelength[row.names(myMAantisense)]), myMAantisense, check.names = FALSE)
        resultlist[[j]] <- list(Sense = myMAsense, Antisense = myMAantisense)
        cat(paste0("Processed sample ", j, ": ", names(bfl)[j]), "\n")
    }
    ## Object types to return
    if (type == "list") {
        return(resultlist)
    } else if (type == "data.frame") {
        resultdf <- do.call("rbind", unlist(resultlist, recursive = FALSE))
        row.names(resultdf) <- NULL
        return(resultdf)
    } else {
        stop("Argument 'type' needs to be assigned one of 'list' or 'data.frame'")
    }
}

## Usage:
# outpaths <- subsetWF(args , slot="output", subset=1, index=1)
# file.exists(outpaths)
# featureCounts <- featuretypeCounts(bfl=BamFileList(outpaths, yieldSize=50000), grl=feat, singleEnd=TRUE, readlength=c(74:76,99:102), type="data.frame")
# write.table(featureCounts, "results/featureCounts.xls", quote=FALSE, row.names=FALSE, sep="\t")
# featureCounts2 <- featuretypeCounts(bfl=BamFileList(outpaths), grl=feat, singleEnd=TRUE, readlength=NULL, type="data.frame")
# write.table(featureCounts2, "results/featureCounts2.xls", quote=FALSE, row.names=FALSE, sep="\t")

######################################################
## Plot distribution of reads across feature types ##
######################################################
plotfeaturetypeCounts <- function(x, graphicsfile, graphicsformat = "pdf", scales = "fixed", anyreadlength = FALSE, drop_N_total_aligned = TRUE, scale_count_val = 10^6, scale_length_val = NULL) {
    checkPkg("grid", quietly = FALSE)
    ## Input validity checks
    if (class(x) != "data.frame") stop("x needs to be object of class 'data.frame'")
    if (any(colnames(x)[1:3] != c("SampleName", "Strand", "Featuretype"))) stop("First three column names need to be: 'SampleName', 'Strand', 'Featuretype'")
    if (!is.numeric(as.matrix(x[, -c(1:3)]))) stop("Following columns (after 3rd one) need to be numeric.")
    ## global functions or variables
    Strand <- Feature <- Counts <- Length <- NULL
    ## Store Featuretypelength and remove it from x
    featuretypelength <- tapply(x$Featuretypelength, x$Featuretype, unique)
    featuretypelength <- featuretypelength[!is.na(featuretypelength)]
    x <- x[, !colnames(x) %in% "Featuretypelength"]
    ## Get numbers of total aligned reads per sample
    N_total_aligned_DF <- x[x$Featuretype == "N_total_aligned", ]
    if (colnames(N_total_aligned_DF)[4] != "anyreadlength") N_total_aligned_DF <- data.frame(N_total_aligned_DF[, 1:3], anyreadlength = rowSums(N_total_aligned_DF[, -c(1:3)]))
    N_total_aligned <- tapply(as.numeric(as.vector(N_total_aligned_DF[, 4])), N_total_aligned_DF$SampleName, sum)
    ## Eliminate total read counts to not show them in plots
    if (drop_N_total_aligned == TRUE) x <- x[x$Featuretype != "N_total_aligned", ]
    ## Sum up read length counts if 'anyreadlength=TRUE'
    if (colnames(x)[4] != "anyreadlength" & anyreadlength == TRUE) x <- data.frame(x[, 1:3], anyreadlength = rowSums(x[, -c(1:3)]))
    ## Scale per x reads (e.g. per million reads)
    if (is.numeric(scale_count_val[1])) {
        if (is.numeric(scale_length_val[1])) {
            correctv <- scale_length_val / featuretypelength[as.character(x$Featuretype)]
            for (i in seq_along(colnames(x))[-c(1:3)]) x[, i] <- as.numeric(as.vector(x[, i])) * (scale_count_val / N_total_aligned[x$SampleName]) * correctv
        } else if (length(scale_length_val) == 0) {
            for (i in seq_along(colnames(x))[-c(1:3)]) x[, i] <- as.numeric(as.vector(x[, i])) * (scale_count_val / N_total_aligned[x$SampleName])
        } else {
            stop("'scale_length_val' needs to be assinged NULL or numeric value.")
        }
    } else if (is.null(scale_count_val[1])) {
        if (is.numeric(scale_length_val[1])) {
            correctv <- scale_length_val / featuretypelength[as.character(x$Featuretype)]
            for (i in seq_along(colnames(x))[-c(1:3)]) x[, i] <- as.numeric(as.vector(x[, i])) * correctv
        } else if (length(scale_length_val) == 0) {
            x <- x
        } else {
            stop("'scale_length_val' needs to be assinged NULL or numeric value.")
        }
    } else {
        stop("'scale_count_val' needs to be assinged NULL or numeric value.")
    }
    ## Define plotting order of samples
    x[, 1] <- factor(x[, 1], levels = unique(x[, 1]), ordered = TRUE)
    ## Label for count axis
    if (length(scale_count_val) == 0 & length(scale_length_val) == 0) axis_label <- "Raw counts"
    if (length(scale_count_val) > 0 & length(scale_length_val) > 0) axis_label <- paste("Counts normalized per", scale_count_val, "reads", "and", scale_length_val, "bp feature length")
    if (length(scale_count_val) > 0 & length(scale_length_val) == 0) axis_label <- paste("Counts normalized per", scale_count_val, "reads")
    if (length(scale_count_val) == 0 & length(scale_length_val) > 0) axis_label <- paste("Counts normalized per", scale_length_val, "bp feature length")
    ## Plot without read length resolution
    if (colnames(x)[4] == "anyreadlength") {
        x[, 3] <- factor(x[, 3], levels = sort(as.character(unique(x[, 3])), decreasing = TRUE), ordered = TRUE) # Defines plotting order of bars!!!
        colnames(x)[3:4] <- c("Feature", "Counts") # Assign nicer names for plot
        myplot <- ggplot2::ggplot(x, ggplot2::aes(x = Feature, y = Counts)) +
            ggplot2::geom_bar(ggplot2::aes(fill = Strand), position = "stack", stat = "identity") +
            ggplot2::facet_wrap(~SampleName) +
            ggplot2::scale_y_continuous(axis_label) +
            ggplot2::theme(axis.text.x = ggplot2::element_text(angle = -90, hjust = 0, vjust = 0.4)) +
            ggplot2::coord_flip() +
            ggplot2::scale_x_discrete(limits = unique(x$Feature))
        get(graphicsformat)(graphicsfile)
        print(myplot)
        grDevices::dev.off()
        cat("Generated graphics file", graphicsfile, "\n")
        return(myplot)
        ## Plot with read length resolution
    } else {
        ## Split data on samples (SampleName column) and convert to format expected by ggplot2
        .convert2DFlist <- function(x) {
            featureCountslist <- split(x, x$SampleName, drop = TRUE)
            featureCountslist <- featureCountslist[unique(as.character(x$SampleName))]
            for (j in seq_along(featureCountslist)) {
                df <- featureCountslist[[j]]
                tmpDF <- data.frame()
                for (i in seq_along(df[, 4:length(df[1, ])])) {
                    tmpDF <- rbind(tmpDF, data.frame(df[, 1:3], Counts = df[, i + 3], Length = colnames(df[, i + 3, drop = FALSE])))
                }
                featureCountslist[[j]] <- tmpDF
            }
            return(featureCountslist)
        }
        featureCountslist <- .convert2DFlist(x)

        ## Get maximum read counts in data set after summing up strand spec counts
        tmp <- data.frame(paste(x[, 1], x[, 3], sep = "_"), x[, -c(1:3)])
        mymax <- max(t(sapply(unique(tmp[, 1]), function(x) colSums(tmp[tmp[, 1] == x, -1]))))
        ## Generate plotting instructions
        myplotlist <- sapply(names(featureCountslist), function(x) NULL, simplify = FALSE)
        for (i in seq(along = featureCountslist)) {
            myplot <- ggplot2::ggplot(featureCountslist[[i]], ggplot2::aes(x = Length, y = Counts)) +
                ggplot2::geom_bar(ggplot2::aes(fill = Strand), position = "stack", stat = "identity") +
                ggplot2::facet_wrap(~Featuretype, ncol = 1, scales = scales) +
                ggplot2::theme(legend.position = "bottom") +
                ggplot2::theme(axis.text.x = ggplot2::element_text(angle = -90, hjust = 0, vjust = 0.4)) +
                ggplot2::ggtitle(featureCountslist[[i]][1, 1]) +
                ggplot2::scale_x_discrete(limits = unique(featureCountslist[[i]]$Length))
            ## Assure same scale for all panels if scales="fixed"
            if (scales == "fixed") {
                myplot <- myplot + ggplot2::scale_y_continuous(axis_label, limits = c(0, mymax))
            } else {
                myplot <- myplot + ggplot2::scale_y_continuous(axis_label)
            }
            myplotlist[[i]] <- myplot
        }
        ## Generate graphics and write to file in pdf, png or jpeg format.
        if (tolower(graphicsformat) == "pdf") mydim <- c(height = 20, width = 6 * length(myplotlist))
        if (tolower(graphicsformat) %in% c("png", "jpeg")) mydim <- c(height = 20 * 96, width = 6 * length(myplotlist) * 96)
        get(graphicsformat)(graphicsfile, width = mydim["width"], height = mydim["height"])
        grid::grid.newpage() # Open a new page on grid device
        grid::pushViewport(grid::viewport(layout = grid::grid.layout(1, length(myplotlist)))) # Assign to device viewport with 1 by 2 grid layout
        for (i in seq(along = myplotlist)) print(myplotlist[[i]], vp = grid::viewport(layout.pos.row = 1, layout.pos.col = i))
        grDevices::dev.off()
        cat("Generated graphics file", graphicsfile, "\n")
        return(myplotlist)
    }
}

## Usage:
# library(ggplot2); library(grid)
# featureCounts <- read.delim("results/featureCounts.xls", check.names=FALSE)
# myplots <- plotfeaturetypeCounts(x=featureCounts, graphicsfile="results/featureCounts.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=FALSE, drop_N_total_aligned=TRUE, scale_count_val=10^6, scale_length_val=10^3)
# featureCounts2 <- read.delim("results/featureCounts2.xls", check.names=FALSE)
# myplots <- plotfeaturetypeCounts(x=featureCounts2, graphicsfile="results/featureCounts2.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=TRUE, drop_N_total_aligned=TRUE, scale_count_val=10^6, scale_length_val=10^3)

##############################################
## Compute and plot coverage along features ##
##############################################
## Computes coverage along single and multi component features, such as exons/cds by transcripts.
featureCoverage <- function(bfl, grl, resizereads = NULL, readlengthrange = NULL, Nbins = 20, method = mean, fixedmatrix, resizefeatures, upstream, downstream, outfile, overwrite = FALSE) {
    pkg <- c("GenomicAlignments", "IRanges", "GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    ## Input validity checks
    if (!is.null(outfile)) {
        if (file.exists(outfile) & overwrite == FALSE) stop("File ", outfile, " exists. Delete it or set 'overwrite=TRUE'")
        if (file.exists(outfile) & overwrite == TRUE) unlink(outfile)
    }
    if (class(bfl) != "BamFileList") stop("'bfl' needs to be of class 'BamFileList'")
    if (!inherits(grl, "GRangesList")) stop("'grl' needs to be a GRangesList object.")
    if (!is.null(readlengthrange)) {
        if (is.numeric(readlengthrange) & length(readlengthrange) != 2) stop("'readlengthrange' needs to be assigned NULL or numeric vector of length 2")
        if (!is.numeric(readlengthrange)) stop("'readlengthrange' needs to be assigned NULL or numeric vector of length 2")
        if ((is.numeric(readlengthrange) & length(readlengthrange) == 2) & readlengthrange[1] > readlengthrange[2]) stop("Second value in read length range needs to be equal or larger then first one.")
    }
    if (fixedmatrix == TRUE & resizefeatures == FALSE) stop("If 'fixedmatrix=TRUE' then 'resizefeatures' needs to be set to 'TRUE' too.")
    ## If Nbins is not NULL, then remove ranges with width < Nbins
    if (!is.null(Nbins)) grl <- grl[sum(width(reduce(grl))) >= Nbins]
    ## Resize features by upstream and downstream value
    if (resizefeatures == TRUE) {
        grl <- .resizeFeature(grl = grl, upstream = upstream, downstream = upstream, component_resort = TRUE)
    }
    ## Following codes operates mostly on GRanges object
    gr <- unlist(grl)
    ## Define empty buckets for collcecting results generated in master loop
    binDFresult <- data.frame()
    fixedMAresult <- data.frame()
    fixedbinMAresult <- data.frame()
    rle_result <- list()
    for (mysample in seq_along(bfl)) {
        ## Compute coverage for ranges in stored in gr from BAM file. Note, coverage() works
        ## directly on BAM files but for resizing read lengths and strand specific analysis
        ## one needs to import the corresponding alignment sections first.
        ## Import alignment chunk
        aligns <- GenomicAlignments::readGAlignments(bfl[[mysample]], param = ScanBamParam(what = Rsamtools::scanBamWhat(), which = gr))
        ## Remove duplicated mappings generated by readGAlignment for nearby/overlapping ranges; reduce() doesn't fix that
        aligns <- aligns[!duplicated(paste(as.character(GenomeInfoDb::seqnames(aligns)), start(aligns), end(aligns), as.character(BiocGenerics::strand(aligns)), mcols(aligns)$qname, sep = "_"))]
        ## Subset to specific read length range specified under readlengthrange
        if (is.numeric(readlengthrange)) {
            aligns <- aligns[GenomicAlignments::qwidth(aligns) >= readlengthrange[1] & GenomicAlignments::qwidth(aligns) <= readlengthrange[2]]
        }
        ## Compute coverage
        if (is.numeric(resizereads[1])) {
            cov <- coverage(resize(granges(aligns), resizereads[1]))
            cov_pos <- coverage(resize(granges(IRanges::subsetByOverlaps(aligns, gr, ignore.strand = FALSE)), resizereads[1]))
        } else if (is.null(resizereads)) {
            cov <- coverage(aligns)
            cov_pos <- coverage(IRanges::subsetByOverlaps(aligns, gr, ignore.strand = FALSE))
        } else {
            stop("'resizereads' needs to be assigned NULL or positive integer of length 1.")
        }
        cov_neg <- cov - cov_pos
        ## Extract coverage for gr components.
        ## Sense coverage
        # cov_posreg <- suppressWarnings(Biostrings::Views(cov_pos, as(gr, "IntegerRangesList"))) # delete
        cov_posreg <- suppressWarnings(Biostrings::Views(cov_pos[names(as(gr, "IntegerRangesList"))], as(gr, "IntegerRangesList"))) # Update 22-Nov-15: cov_pos needs to be subsetted by seqnames in IntegerRangesList. This is relevant if txdb/grl was created from gff with scaffolds not containing any genes
        cov_posreg <- cov_posreg[sapply(cov_posreg, length) > 0] # Removes empty components (chr)
        ## Antisense coverage
        # cov_negreg <- suppressWarnings(Biostrings::Views(cov_neg, as(gr, "IntegerRangesList"))) # delete
        cov_negreg <- suppressWarnings(Biostrings::Views(cov_neg[names(as(gr, "IntegerRangesList"))], as(gr, "IntegerRangesList"))) # Update 22-Nov-15: cov_neg needs to be subsetted by seqnames in IntegerRangesList. This is relevant if txdb/grl was created from gff with scaffolds not containing any genes
        cov_negreg <- cov_negreg[sapply(cov_negreg, length) > 0] # Removes empty components (chr)
        ## Collapse (splice) multicomponent coverage ranges, e.g. cds exons to full cds
        ## Sense coverage
        mystrand <- BiocGenerics::strand(grl)
        mystrand <- sapply(names(mystrand), function(x) as.character(mystrand[[x]])[1])
        cov_posList <- as.list(mystrand)
        ## Features on "+" strand
        for (i in seq_along(cov_posreg)) {
            for (j in names(mystrand[mystrand == "+"])) {
                myview <- cov_posreg[[i]][names(cov_posreg[[i]]) %in% j]
                if (length(myview) != 0) {
                    cov_posList[[j]] <- S4Vectors::Rle(as.numeric(na.omit(as.vector(t(as.matrix(myview))))))
                }
            }
        }
        ## Features on "-" strand: note coverage of component features needs to be reversed here prior to collapsing to single feature!
        for (i in seq_along(cov_posreg)) {
            for (j in names(mystrand[mystrand == "-"])) {
                myview <- cov_posreg[[i]][names(cov_posreg[[i]]) %in% j]
                if (length(myview) != 0) {
                    cov_posList[[j]] <- S4Vectors::Rle(as.numeric(na.omit(as.vector(t(as.matrix(reverse(myview)))))))
                }
            }
        }
        ## Antisense coverage
        cov_negList <- as.list(mystrand)
        ## Features on "+" strand
        for (i in seq_along(cov_negreg)) {
            for (j in names(mystrand[mystrand == "+"])) {
                myview <- cov_negreg[[i]][names(cov_negreg[[i]]) %in% j]
                if (length(myview) != 0) {
                    cov_negList[[j]] <- S4Vectors::Rle(as.numeric(na.omit(as.vector(t(as.matrix(myview))))))
                }
            }
        }
        ## Features on "-" strand: note coverage of component features needs to be reversed here prior to collapsing to single feature!
        for (i in seq_along(cov_negreg)) {
            for (j in names(mystrand[mystrand == "-"])) {
                myview <- cov_negreg[[i]][names(cov_negreg[[i]]) %in% j]
                if (length(myview) != 0) {
                    cov_negList[[j]] <- S4Vectors::Rle(as.numeric(na.omit(as.vector(t(as.matrix(reverse(myview)))))))
                }
            }
        }
        ## Get total number of aligned reads from BAM file and add to output for normalization
        param <- ScanBamParam(flag = scanBamFlag(isSecondaryAlignment = FALSE, isUnmappedQuery = FALSE))
        aligned_reads <- Rsamtools::countBam(bfl[mysample], param = param)
        ## If Nbins is integer, compute relative bin coverage for fixed number of bins (intervals) of each feature
        if (!is.null(Nbins)) {
            ## Function to bin coverage
            .interComp <- function(x, slice, method) {
                interval <- cut(1:length(x), slice, labels = FALSE)
                resultvec <- tapply(x, as.factor(interval), method)
                return(resultvec)
            }
            ## Sense coverage
            myMApos <- t(sapply(cov_posList, function(y) .interComp(x = y, slice = Nbins, method = method)))
            ## Antisense coverage
            myMAneg <- t(sapply(cov_negList, function(y) .interComp(x = y, slice = Nbins, method = method)))
            ## Combine results
            myMAneg <- myMAneg[rownames(myMApos), , drop = FALSE] # Assure proper sorting
            myDFpos <- data.frame(SampleName = names(bfl[mysample]), N_total_aligned = aligned_reads$records, IDs = rownames(myMApos), Strand = "Sense", myMApos, check.names = FALSE)
            myDFneg <- data.frame(SampleName = names(bfl[mysample]), N_total_aligned = aligned_reads$records, IDs = rownames(myMAneg), Strand = "Antisense", myMAneg, check.names = FALSE)
            myDFbins <- rbind(myDFpos, myDFneg, make.row.names = FALSE)
            row.names(myDFbins) <- NULL
            binDFresult <- rbind(binDFresult, myDFbins)
            exportDF <- myDFbins
        }
        ## Generate fixed matrix output
        if (fixedmatrix == TRUE) {
            mycolnames <- c(-upstream:-1, 0, 1:downstream)
            fixedMAstartpos <- t(sapply(names(cov_posList), function(x) as.numeric(cov_posList[[x]])[1:(upstream + downstream + 1)]))
            colnames(fixedMAstartpos) <- mycolnames
            fixedMAendpos <- t(sapply(names(cov_posList), function(x) as.numeric(cov_posList[[x]])[(length(as.numeric(cov_posList[[x]])) - (upstream + downstream)):length(as.numeric(cov_posList[[x]]))]))
            colnames(fixedMAendpos) <- mycolnames
            fixedMAstartneg <- t(sapply(names(cov_negList), function(x) as.numeric(cov_negList[[x]])[1:(upstream + downstream + 1)]))
            colnames(fixedMAstartneg) <- mycolnames
            fixedMAendneg <- t(sapply(names(cov_negList), function(x) as.numeric(cov_negList[[x]])[(length(as.numeric(cov_negList[[x]])) - (upstream + downstream)):length(as.numeric(cov_negList[[x]]))]))
            colnames(fixedMAendneg) <- mycolnames
            fixedMA <- rbind(
                data.frame(SampleName = names(bfl[mysample]), N_total_aligned = aligned_reads$records, IDs = rownames(fixedMAstartpos), Strand = "Sense", fixedMAstartpos, check.names = FALSE),
                data.frame(SampleName = names(bfl[mysample]), N_total_aligned = aligned_reads$records, IDs = rownames(fixedMAstartneg), Strand = "Antisense", fixedMAstartneg, check.names = FALSE)
            )
            tmpMA <- rbind(
                data.frame(fixedMAendpos[rownames(fixedMAstartpos), , drop = FALSE], check.names = FALSE),
                data.frame(fixedMAendneg[row.names(fixedMAstartneg), , drop = FALSE], check.names = FALSE)
            )
            fixedMAout <- cbind(fixedMA, "<S|E>" = "|", tmpMA)
            row.names(fixedMAout) <- NULL
            fixedMAresult <- rbind(fixedMAresult, fixedMAout)
            exportDF <- fixedMAout
        }
        ## Combine fixed and binned coverage matrix
        if (!is.null(Nbins) & fixedmatrix == TRUE) {
            fixedbinMAout <- data.frame(fixedMA, "<S|B>" = "|", myDFbins[, -c(1:4), drop = FALSE], "<B|E>" = "|", tmpMA, check.names = FALSE)
            row.names(fixedbinMAout) <- NULL
            fixedbinMAresult <- rbind(fixedbinMAresult, fixedbinMAout)
            exportDF <- fixedbinMAout
        }
        ## Organize rle results in list
        if (fixedmatrix == FALSE & is.null(Nbins)) {
            rle_out <- list(list(N_total_aligned = aligned_reads$records, sense = as(cov_posList, "RleList"), antisense = as(cov_negList, "RleList")))
            names(rle_out) <- names(bfl[mysample])
            rle_result <- c(rle_result, rle_out)
        }
        ## Write tabular data to file in append mode
        if (!is.null(outfile) & (fixedmatrix == TRUE | !is.null(Nbins))) {
            if (!file.exists(outfile)) {
                write.table(exportDF, outfile, append = FALSE, quote = FALSE, row.names = FALSE, col.names = TRUE, sep = "\t")
                cat("Processed sample:", names(bfl[mysample]), "and wrote results to file", outfile, "\n")
            } else {
                write.table(exportDF, outfile, append = TRUE, quote = FALSE, row.names = FALSE, col.names = FALSE, sep = "\t")
                cat("Processed sample:", names(bfl[mysample]), "and appended results to file", outfile, "\n")
            }
        } else {
            cat("Processed sample:", names(bfl[mysample]), "\n")
        }
    }
    ## Return proper final result
    if (!is.null(Nbins) & fixedmatrix == FALSE) {
        return(binDFresult)
    } else if (is.null(Nbins) & fixedmatrix == TRUE) {
        return(fixedMAresult)
    } else if (!is.null(Nbins) & fixedmatrix == TRUE) {
        return(fixedbinMAresult)
    } else {
        return(rle_result)
    }
}
## Usage:
# grl <- GenomicFeatures::cdsBy(txdb, "tx", use.names=TRUE)
# fcov <- featureCoverage(bfl=BamFileList(outpaths[1]), grl=grl[1:4], resizereads=NULL, readlengthrange=NULL, Nbins=NULL, method=mean, fixedmatrix=TRUE, resizefeatures=TRUE, upstream=20, downstream=20, outfile="results/zzz.xls", overwrite=TRUE)

## Helper function to extend single and multi component ranges
## Extends featureBy GRangeList objects containing component features
## such as exons in CDSs or transcripts so that only the first and last components
## get extended. Single component features will be extended the same way.
.resizeFeature <- function(grl, upstream, downstream, component_resort = TRUE) {
    checkPkg("GenomeInfoDb", quietly = FALSE)
    if (!inherits(grl, "GRangesList")) stop("'grl' needs to be a GRangesList object.")
    gr <- unlist(grl)
    if (!all(names(grl) %in% unique(names(gr)))) stop("None or not all components in grl are named.")
    ## Add sort_index
    mcols(gr) <- S4Vectors::DataFrame(mcols(gr), sort_index = seq_along(gr))
    ## Ranges on + strand
    gr_pos <- gr[BiocGenerics::strand(gr) == "+" | BiocGenerics::strand(gr) == "*"] # Note: treats unstranded * the same as pos +
    if (component_resort == TRUE) {
        gr_pos <- gr_pos[order(as.character(GenomeInfoDb::seqnames(gr_pos)), names(gr_pos), start(gr_pos))] # Assures proper sorting
    }
    index_pos_first <- !duplicated(names(gr_pos), fromLast = FALSE)
    suppressWarnings(start(gr_pos[index_pos_first]) <- start(gr_pos[index_pos_first]) - upstream)
    gr_pos <- trim(gr_pos)
    index_pos_last <- !duplicated(names(gr_pos), fromLast = TRUE)
    suppressWarnings(end(gr_pos[index_pos_last]) <- end(gr_pos[index_pos_last]) + downstream)
    gr_pos <- trim(gr_pos)
    ## Ranges on - strand
    gr_neg <- gr[BiocGenerics::strand(gr) == "-"]
    if (component_resort == TRUE) {
        gr_neg <- gr_neg[order(as.character(GenomeInfoDb::seqnames(gr_neg)), names(gr_neg), -start(gr_neg))]
    }
    index_neg_first <- !duplicated(names(gr_neg), fromLast = FALSE)
    suppressWarnings(end(gr_neg[index_neg_first]) <- end(gr_neg[index_neg_first]) + upstream)
    gr_neg <- trim(gr_neg)
    index_neg_last <- !duplicated(names(gr_neg), fromLast = TRUE)
    suppressWarnings(start(gr_neg[index_neg_last]) <- start(gr_neg[index_neg_last]) - downstream)
    gr_neg <- trim(gr_neg)
    ## Return output in same format as input
    gr_mod <- c(gr_pos, gr_neg)
    gr_mod <- gr_mod[order(mcols(gr_mod)$sort_index)]
    gr_mod <- gr_mod[, seq_along(colnames(mcols(grl[[1]])))]
    myfactor <- names(gr_mod)
    if (is.null(names(grl[[1]]))) names(gr_mod) <- NULL
    grl_mod <- split(gr_mod, myfactor)
    grl_mod <- grl_mod[names(grl)]
    return(grl_mod)
}
## Usage:
# grl_mod <- .resizeFeature(grl=grl, upstream=20, downstream=20, component_resort=TRUE)

###########################
## Plot feature coverage ##
###########################
## Plots tabular coverage data generated by featureCoverage()
plotfeatureCoverage <- function(covMA, method = mean, scales = "fixed", extendylim = 2, scale_count_val = 10^6) {
    checkPkg("grid", quietly = FALSE)
    ## Some input validity checks
    if (class(covMA) != "data.frame") stop("'covMA' needs to be assigned an object of class 'data.frame'.")
    expectedcol <- c("SampleName", "N_total_aligned", "IDs", "Strand")
    if (any(!colnames(covMA)[1:4] %in% expectedcol)) stop("The first 4 columns in 'covMA' need to be named: ", paste(expectedcol, collapse = ", "))
    ## global functions or variables
    Coverage <- Strand <- NULL
    ## Determine split type required for provided input
    splitloc <- which(grepl("(<S\\|B>)|(<B\\|E>)|(<S\\|E>)", colnames(covMA)))
    ## Get numbers of total aligned reads per sample
    N_total_aligned <- covMA$N_total_aligned
    names(N_total_aligned) <- covMA$SampleName
    N_total_aligned <- N_total_aligned[!duplicated(names(N_total_aligned))]
    ## Define function to convert tabular input into ggplot2 friendly format
    .convertDFlist <- function(malist) {
        for (j in seq_along(malist)[-1]) {
            df <- malist[[j]]
            tmpDF <- data.frame()
            for (i in seq_along(colnames(df))[-c(1, 2)]) {
                tmpDF <- rbind(tmpDF, data.frame(df[, 1:2], Position = colnames(df)[i], Coverage = df[, i]))
            }
            malist[[j]] <- tmpDF
        }
        return(malist)
    }
    ## Construct informative title: print ID if only one or their count if more than 1
    ti <- as.character(unique(covMA[, "IDs"]))
    if (length(ti) > 1) ti <- paste(length(ti), "features")

    ## Split and compute summary stats in format expected by ggplot2
    ## For binned matrix
    if (length(splitloc) == 0) {
        malist <- sapply(c("title", "bin"), function(x) NULL)
        malist[["title"]] <- c(titlebin = paste("CDS of", ti), x = "Bins", y = "Coverage")
        bin <- covMA
        malist[["bin"]] <- aggregate(bin[, -c(1:4)], by = list(SampleName = bin$SampleName, Strand = bin$Strand), FUN = method)
        malist <- .convertDFlist(malist)
    }
    ## For fixed matrix around start and stop codons
    if (length(splitloc) == 1) {
        malist <- sapply(c("title", "start", "stop"), function(x) NULL)
        malist[["title"]] <- c(titlestart = paste("Start of", ti), titlestop = paste("Stop of", ti), x = "Bins", y = "Coverage")
        start <- covMA[, 1:(splitloc[1] - 1)]
        malist[["start"]] <- aggregate(start[, -c(1:4)], by = list(SampleName = start$SampleName, Strand = start$Strand), FUN = method)
        stop <- covMA[, c(1:4, (splitloc[1] + 1):length(colnames(covMA)))]
        malist[["stop"]] <- aggregate(stop[, -c(1:4)], by = list(SampleName = stop$SampleName, Strand = stop$Strand), FUN = method)
        malist <- .convertDFlist(malist)
    }
    ## For fixed matrix and binned matrix
    if (length(splitloc) == 2) {
        malist <- sapply(c("title", "start", "bin", "stop"), function(x) NULL)
        malist[["title"]] <- c(titlestart = paste("Start of", ti), titlebin = paste("CDS of", ti), titlestop = paste("Stop of", ti), x = "Bins", y = "Coverage")
        start <- covMA[, 1:(splitloc[1] - 1)]
        malist[["start"]] <- aggregate(start[, -c(1:4)], by = list(SampleName = start$SampleName, Strand = start$Strand), FUN = method)
        bin <- covMA[, c(1:4, (splitloc[1] + 1):(splitloc[2] - 1))]
        malist[["bin"]] <- aggregate(bin[, -c(1:4)], by = list(SampleName = bin$SampleName, Strand = bin$Strand), FUN = method)
        stop <- covMA[, c(1:4, (splitloc[2] + 1):length(colnames(covMA)))]
        malist[["stop"]] <- aggregate(stop[, -c(1:4)], by = list(SampleName = stop$SampleName, Strand = stop$Strand), FUN = method)
        malist <- .convertDFlist(malist)
    }
    ## Scale per x reads (e.g. per million reads)
    if (is.numeric(scale_count_val[1])) {
        for (i in seq_along(malist)[-1]) malist[[i]][, "Coverage"] <- malist[[i]][, "Coverage"] * (scale_count_val / N_total_aligned[malist[[i]][, "SampleName"]])
    } else if (length(scale_count_val) == 0) {
        malist <- malist
    } else {
        stop("'scale_count_val' needs to be assinged NULL or numeric value.")
    }
    ## Label for coverage axis
    if (length(scale_count_val) == 0) axis_label <- "Raw Coverage"
    if (length(scale_count_val) > 0) axis_label <- paste("Coverage normalized per", scale_count_val, "reads")
    ## Get maximum coverage in data sets after summing up strand spec counts
    mymax <- numeric()
    for (i in seq_along(malist)[-1]) {
        myfactor <- paste(malist[[i]][, 1], malist[[i]][, 2], malist[[i]][, 3], sep = "_")
        mymax <- max(c(mymax, max(tapply(malist[[i]][, "Coverage"], myfactor, sum))))
    }
    mymax <- mymax * extendylim
    ## Generate plotting instructions
    myplotlist <- sapply(names(malist[-1]), function(x) NULL, simplify = FALSE)
    for (i in seq_along(myplotlist)) {
        myplot <- ggplot2::ggplot(malist[[names(myplotlist)[i]]], ggplot2::aes(x = Position, y = Coverage)) +
            ggplot2::geom_bar(ggplot2::aes(fill = Strand), position = "stack", stat = "identity") +
            ggplot2::facet_wrap(~SampleName, ncol = 1, scales = scales) +
            ggplot2::theme(legend.position = "bottom") +
            ggplot2::ggtitle(malist[["title"]][i]) +
            ggplot2::scale_x_discrete(limits = unique(malist[[names(myplotlist)[i]]]$Position))
        ## Assure same scale for all panels if scales="fixed"
        if (scales == "fixed") {
            myplot <- myplot + ggplot2::scale_y_continuous(axis_label, limits = c(0, mymax))
        } else {
            myplot <- myplot + ggplot2::scale_y_continuous(axis_label)
        }
        myplotlist[[i]] <- myplot
    }
    ## Generate graphics
    grid::grid.newpage() # Open a new page on grid device
    grid::pushViewport(grid::viewport(layout = grid::grid.layout(1, length(myplotlist)))) # Assign to device viewport with 1 by 2 grid layout
    for (i in seq(along = myplotlist)) print(myplotlist[[i]], vp = grid::viewport(layout.pos.row = 1, layout.pos.col = i))
}

## Usage:
# grl <- GenomicFeatures::cdsBy(txdb, "tx", use.names=TRUE)
# fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, readlengthrange=NULL, Nbins=20, method=mean, fixedmatrix=TRUE, resizefeatures=TRUE, upstream=20, downstream=20, outfile="results/zzz.xls", overwrite=TRUE)
# plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", extendylim=2, scale_count_val=10^6)

##################
## Predict ORFs ##
##################
## Function to predict ORFs in DNA sequences provided as DNAString/DNAStringSet objects
predORF <- function(x, n = 1, type = "grl", mode = "orf", strand = "sense", longest_disjoint = FALSE, startcodon = "ATG", stopcodon = c("TAA", "TAG", "TGA")) {
    pkg <- c("IRanges", "GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    ## Check input validity
    if (any(nchar(c(startcodon, stopcodon)) != 3)) stop("startcodon and stopcodons can only contain 3-letter strings.")
    if (!toupper(mode) %in% c("ORF", "CDS")) stop("'mode' can only be assigned one of: 'orf' or 'cds'")
    if (length(names(x)) == 0 | any(duplicated(names(x)))) stop("Sequence name slot of x need be populated with unique names.")
    ## Remove sequence with less than 6 nucleotides in length
    x <- x[width(x) >= 6]
    ## Function for predicting ORFs/CDSs on single sequence
    .predORF <- function(x, n, mode, strand, ...) {
        ## start/stop codon assignment
        if (tolower(strand) == "sense") {
            mystrand <- 1 # for +
            startcodon <- startcodon
            stopcodon <- stopcodon
        } else if (tolower(strand) == "antisense") {
            ## Reverse and complement start/stop plus swap their assignment
            mystrand <- 2 # for -
            stopcodon_temp <- as.character(Biostrings::reverseComplement(Biostrings::DNAStringSet(stopcodon)))
            startcodon_temp <- as.character(Biostrings::reverseComplement(Biostrings::DNAStringSet(startcodon)))
            stopcodon <- startcodon_temp
            startcodon <- stopcodon_temp
        } else {
            stop("strand can only be assigned 'sense', 'antisense' or 'both'")
        }
        ## Sequences containing N are not processed
        if (Biostrings::alphabetFrequency(x)["N"] > 0) {
            orfRanges <- cbind(subject_id = numeric(), start = numeric(), end = numeric(), width = numeric(), strand = numeric(), inframe2end = numeric())
            warning("Skipped sequence containing Ns.")
            return(orfRanges)
        }
        ## Tripletize x for each frame
        c1 <- as.character(suppressWarnings(Biostrings::codons(x)))
        c2 <- as.character(suppressWarnings(Biostrings::codons(x[2:length(x)])))
        c3 <- as.character(suppressWarnings(Biostrings::codons(x[3:length(x)])))
        ## Identify position of start/stop in tripletized x
        startpos1 <- which(c1 %in% startcodon)
        stoppos1 <- which(c1 %in% stopcodon)
        startpos2 <- which(c2 %in% startcodon)
        stoppos2 <- which(c2 %in% stopcodon)
        startpos3 <- which(c3 %in% startcodon)
        stoppos3 <- which(c3 %in% stopcodon)
        ## Make sure subsequent code also finds coding sequence frames (CDS) rather than just strict open reading frames (ORFs)
        if (mode == "cds") {
            stoppos1 <- unique(c(0, stoppos1, length(c1) + 1))
            stoppos2 <- unique(c(0, stoppos2, length(c2) + 1))
            stoppos3 <- unique(c(0, stoppos3, length(c3) + 1))
            startpos1 <- stoppos1
            startpos2 <- stoppos2
            startpos3 <- stoppos3
        }
        ## Map tripletized matches back to sequence of x
        if (tolower(strand) == "sense") {
            orfpos1 <- t(sapply(seq(along = startpos1), function(x) c((startpos1[x] * 3) - 2, stoppos1[stoppos1 > startpos1[x]][1] * 3)))
            if (length(orfpos1) == 0) orfpos1 <- matrix(nrow = 0, ncol = 2)
            orfpos2 <- t(sapply(seq(along = startpos2), function(x) c((startpos2[x] * 3) - 1, (stoppos2[stoppos2 > startpos2[x]][1] * 3) + 1)))
            if (length(orfpos2) == 0) orfpos2 <- matrix(nrow = 0, ncol = 2)
            orfpos3 <- t(sapply(seq(along = startpos3), function(x) c((startpos3[x] * 3) - 0, (stoppos3[stoppos3 > startpos3[x]][1] * 3) + 2)))
            if (length(orfpos3) == 0) orfpos3 <- matrix(nrow = 0, ncol = 2)
        }
        if (tolower(strand) == "antisense") { # Note - for antisense predictions startpos contain stop codons and stoppos contain start codons
            startpos1 <- sort(startpos1, decreasing = TRUE)
            startpos2 <- sort(startpos2, decreasing = TRUE)
            startpos3 <- sort(startpos3, decreasing = TRUE)
            stoppos1 <- sort(stoppos1, decreasing = TRUE)
            stoppos2 <- sort(stoppos2, decreasing = TRUE)
            stoppos3 <- sort(stoppos3, decreasing = TRUE)
            orfpos1 <- t(sapply(seq(along = stoppos1), function(x) c((startpos1[startpos1 < stoppos1[x]][1] * 3) - 2, stoppos1[x] * 3)))
            if (length(orfpos1) == 0) orfpos1 <- matrix(nrow = 0, ncol = 2)
            orfpos2 <- t(sapply(seq(along = stoppos2), function(x) c((startpos2[startpos2 < stoppos2[x]][1] * 3) - 1, (stoppos2[x] * 3) + 1)))
            if (length(orfpos2) == 0) orfpos2 <- matrix(nrow = 0, ncol = 2)
            orfpos3 <- t(sapply(seq(along = stoppos3), function(x) c((startpos3[startpos3 < stoppos3[x]][1] * 3) - 0, (stoppos3[x] * 3) + 2)))
            if (length(orfpos3) == 0) orfpos3 <- matrix(nrow = 0, ncol = 2)
        }
        orfRanges <- rbind(orfpos1, orfpos2, orfpos3)
        orfRanges <- na.omit(orfRanges)
        if (mode == "cds") { # Modifications required for mode=="cds"
            orfRanges[, 1] <- orfRanges[, 1] + 3
            orfRanges[orfRanges[, 2] > length(x), 2] <- length(x)
        }
        orfRanges <- IRanges::IRanges(start = orfRanges[, 1], end = orfRanges[, 2])
        orfRanges <- orfRanges[rev(order(width(orfRanges)))]
        ## Organize results in data.frame and also add info about frame of predicted ORF to downstream ORF e.g. prediction is uORF of 5'-UTR
        orfRanges <- as.data.frame(orfRanges)
        inframe <- (length(x) - orfRanges$end) / 3
        inframe2 <- inframe
        inframe2[abs((inframe - as.integer(inframe))) == 0] <- 1
        inframe2[abs(round((inframe - as.integer(inframe)), 2)) == round(1 / 3, 2)] <- 2
        inframe2[abs(round((inframe - as.integer(inframe)), 2)) == round(2 / 3, 2)] <- 3
        if (nrow(orfRanges) > 0) {
            orfRanges <- cbind(subject_id = 1:length(orfRanges[, 1]), orfRanges, strand = mystrand, inframe2end = inframe2)
        } else {
            orfRanges <- cbind(subject_id = numeric(), start = numeric(), end = numeric(), width = numeric(), strand = numeric(), inframe2end = numeric())
        }
        ## Return all ORFs
        if (n == "all") {
            ## Subset to non-overlapping ORF set containing longest ORF
            if (nrow(orfRanges) > 0 & longest_disjoint == TRUE) {
                tmpgr <- GRanges(seqnames = "dummy", IRanges::IRanges(orfRanges[, 2], orfRanges[, 3]), strand = "+")
                orfRanges <- orfRanges[disjointBins(tmpgr) == 1, , drop = FALSE]
                orfRanges[, 1] <- 1:nrow(orfRanges)
            }
            return(orfRanges)
            ## Return only as many ORFs as specified under n sorted decreasingly by length
        } else if (is.numeric(n)) {
            ## Make sure subsetting does not exceed number of records in orfRanges
            if (nrow(orfRanges) < n & nrow(orfRanges) != 0) {
                upperlimit <- length(orfRanges[, 1])
            } else if (nrow(orfRanges) > 0) {
                upperlimit <- n
            } else {
                upperlimit <- NULL
            }
            if (is.null(upperlimit)) {
                return(orfRanges[upperlimit, , drop = FALSE])
            } else {
                return(orfRanges[1:upperlimit, , drop = FALSE])
            }
        } else {
            stop("n needs to be assigned positive integer or 'all'")
        }
    }
    ## Run .predORF
    if (class(x) == "DNAString") {
        if (tolower(strand) == "sense" | tolower(strand) == "antisense") {
            tmp <- .predORF(x, n, mode, strand, longest_disjoint, startcodon, stopcodon)
            tmp[, "strand"] <- ifelse(as.numeric(tmp[, "strand"]) == 1, "+", "-")
        } else if (tolower(strand) == "both") {
            tmp_pos <- .predORF(x, n, mode, strand = "sense", longest_disjoint, startcodon, stopcodon)
            tmp_neg <- .predORF(x, n, mode, strand = "antisense", longest_disjoint, startcodon, stopcodon)
            tmp <- rbind(tmp_pos, tmp_neg)
            tmp[, "strand"] <- ifelse(as.numeric(tmp[, "strand"]) == 1, "+", "-")
        } else {
            stop("strand can only be assigned 'sense', 'antisense' or 'both'")
        }
        if (type == "df") {
            return(tmp)
        }
        if (type == "gr") {
            return(makeGRangesFromDataFrame(data.frame(seqnames = "unknown", tmp), keep.extra.columns = TRUE))
        }
    }
    if (class(x) == "DNAStringSet") {
        if (tolower(strand) == "sense" | tolower(strand) == "antisense") {
            tmp <- lapply(x, function(y) .predORF(y, n = n, mode = mode, strand, longest_disjoint, startcodon, stopcodon))
            names(tmp) <- names(x)
            tmpdf <- do.call("rbind", tmp)
            rownames(tmpdf) <- NULL
            tmpdf <- data.frame(seqnames = rep(names(tmp), sapply(tmp, nrow)), tmpdf)
            tmpdf[, "strand"] <- ifelse(as.numeric(tmpdf[, "strand"]) == 1, "+", "-")
        } else if (tolower(strand) == "both") {
            ## for sense strand
            tmp_pos <- lapply(x, function(y) .predORF(y, n = n, mode = mode, strand = "sense", longest_disjoint, startcodon, stopcodon))
            names(tmp_pos) <- names(x)
            tmpdf_pos <- do.call("rbind", tmp_pos)
            rownames(tmpdf_pos) <- NULL
            ## for antisense strand
            tmpdf_pos <- data.frame(seqnames = rep(names(tmp_pos), sapply(tmp_pos, nrow)), tmpdf_pos)
            tmp_neg <- lapply(x, function(y) .predORF(y, n = n, mode = mode, strand = "antisense", longest_disjoint, startcodon, stopcodon))
            names(tmp_neg) <- names(x)
            tmpdf_neg <- do.call("rbind", tmp_neg)
            rownames(tmpdf_neg) <- NULL
            tmpdf_neg <- data.frame(seqnames = rep(names(tmp_neg), sapply(tmp_neg, nrow)), tmpdf_neg)
            ## combine and sort results
            tmpdf <- rbind(tmpdf_pos, tmpdf_neg)
            tmpdf[, "strand"] <- ifelse(as.numeric(tmpdf[, "strand"]) == 1, "+", "-")
            tmpdf <- tmpdf[order(tmpdf$seqnames, tmpdf$subject_id), ]
        } else {
            stop("strand can only be assigned 'sense', 'antisense' or 'both'")
        }
        ## Return results in format defined by type
        if (tolower(type) == "df") {
            rownames(tmpdf) <- NULL
            return(tmpdf)
        } else if (tolower(type) == "gr") {
            tmpdf <- makeGRangesFromDataFrame(tmpdf, keep.extra.columns = TRUE)
            return(tmpdf)
        } else if (tolower(type) == "grl") {
            tmpdf <- makeGRangesFromDataFrame(tmpdf, keep.extra.columns = TRUE)
            tmpdf <- split(tmpdf, as.character(GenomeInfoDb::seqnames(tmpdf)))
            return(tmpdf)
        } else {
            stop("type can only be assigned 'df' of 'gr'")
        }
    }
}
# library(Biostrings)
# file <- system.file("extdata", "someORF.fa", package="Biostrings")
# dna <- readDNAStringSet(file)
# orf <- predORF(dna[1:4], n=1, type="df", mode="orf", strand="antisense", startcodon="ATG", stopcodon=c("TAA", "TAG", "TGA"))

######################################################
## Scale feature level mappings to genome positions ##
######################################################
## Function to scale ranges within genomic features (query)
## to corresponding genome positions (subject). The function
## also accounts for intron insertions of compound features
## (e.g. between exons of transcribed regions) that are absent in
## the query ranges, but present in the corresponding subject ranges.
scaleRanges <- function(subject, query, type = "custom", verbose = TRUE) {
    pkg <- c("IRanges", "GenomeInfoDb")
    checkPkg(pkg, quietly = FALSE)
    ## Both input objects need to be of class GRangesList
    if (!inherits(subject, "GRangesList") | !inherits(query, "GRangesList")) stop("Both subject and query need to be GRangesList objects.")
    ## All names(query) need to be present in names(subject)
    if (any(!names(query) %in% names(subject))) stop("All 'names(query)' need to be present in 'names(subject)'.")
    ## Perform scaling on single subject/query pair each containing on entry
    .scaleRanges <- function(subject, query, returntype = "df") {
        ## Check for validity of query
        if (length(query) > 1) warning("Only the first range in 'query' will be used.")
        query <- query[1]
        if (sum(width(subject)) < width(query)) stop("Sum of width of subject ranges cannot be smaller than width of query range.")
        ## Check for validity of subject
        subjectstrand <- unique(as.character(BiocGenerics::strand(subject)))
        if (length(subjectstrand) != 1) stop("More than one orientation detected. There can only be one.")
        querystrand <- unique(as.character(BiocGenerics::strand(query)))
        ## Check for validity of seqnames
        myseqname <- unique(as.character(GenomeInfoDb::seqnames(subject)))
        if (length(myseqname) != 1) stop("More than one seqname detected. There can only be one.")
        ## Scale query range to range of subject ranges (of genomic feature) using interval trees from IRanges
        subject <- subject[order(start(subject))]
        rangev <- paste("c(", paste(paste(start(subject), end(subject), sep = ":"), collapse = ", "), ")", sep = "")
        rangev <- eval(parse(text = rangev))
        names(rangev) <- seq_along(rangev)
        if (subjectstrand == "+") rangev <- rangev[start(query):end(query)]
        if (subjectstrand == "-") rangev <- rev(rangev)[start(query):end(query)]
        ir <- reduce(IRanges::IRanges(rangev, rangev))
        ## Set orientation properly
        if (querystrand == "-" & subjectstrand == "-") mystrand <- "+"
        if (querystrand == "+" & subjectstrand == "+") mystrand <- "+"
        if (querystrand == "+" & subjectstrand == "-") mystrand <- "-"
        if (querystrand == "-" & subjectstrand == "+") mystrand <- "-"
        ## Organize result as GRanges
        if (mystrand == "+") { # Proper exon ranking for exons on +/- strand
            gr <- GRanges(myseqname, ir[order(start(ir), decreasing = FALSE)], mystrand)
        } else {
            gr <- GRanges(myseqname, ir[order(start(ir), decreasing = TRUE)], mystrand)
        }
        mcols(gr) <- data.frame(type = type)
        ## Return results as data.frame or GRanges
        if (returntype == "gr") {
            return(gr)
        }
        if (returntype == "df") {
            return(as.data.frame(gr))
        }
    }
    ## Run .scaleRanges on two GRangesLists as input
    subject <- subject[names(query)] # Subset subject to entries in query
    mygrl <- unlist(query)
    myids1 <- rep(names(query), sapply(start(query), length))
    myids2 <- paste(myids1, ":", start(mygrl), "_", end(mygrl), sep = "")
    mcols(mygrl) <- data.frame(type = type)
    mygrl <- split(mygrl, seq_along(mygrl))
    names(mygrl) <- myids2
    mylist <- as.list(character(length = length(mygrl)))
    names(mylist) <- names(mygrl)
    for (i in seq_along(mygrl)) {
        myentryid <- myids1[i]
        suppressWarnings(mylist[[i]] <- .scaleRanges(subject[[myentryid]], mygrl[[i]]))
        if (verbose == TRUE) {
            cat(paste0("Scaled range ", i, " of ", length(mygrl), " ranges: ", names(mygrl[i])), "\n")
        }
    }
    ## If loop gets interrupted, output only completed results!
    mylist <- mylist[1:i]
    gr <- GenomicRanges::makeGRangesFromDataFrame(do.call("rbind", mylist), keep.extra.columns = FALSE)
    mcols(gr) <- S4Vectors::DataFrame(feature_by = as(rep(names(mylist), sapply(mylist, nrow)), "CharacterList"), featuretype_id = names(gr), featuretype = type)
    names(gr) <- NULL
    grl <- split(gr, as.character(mcols(gr)$feature_by))
    return(grl)
}
## Usage for simple example
# subject <- GRanges(seqnames="Chr1", IRanges(c(5,15,30),c(10,25,40)), strand="+")
# query <- GRanges(seqnames="myseq", IRanges(1, 9), strand="+")
# scaleRanges(GRangesList(myid1=subject), GRangesList(myid1=query), type="test")

## Usage for more complex example
# library(txdbmaker)
# gff <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
# txdb <- makeTxDbFromGFF(file=gff, format="gff3", organism="Arabidopsis")
# futr <- fiveUTRsByTranscript(txdb, use.names=TRUE)
# genome <- system.file("extdata/annotation", "tair10.fasta", package="systemPipeRdata")
# dna <- extractTranscriptSeqs(FaFile(genome), futr)
# uorf <- predORF(dna, n="all", mode="orf", longest_disjoint=TRUE, strand="sense")
# grl_scaled <- scaleRanges(subject=futr, query=uorf, type="uORF", verbose=TRUE)
# rtracklayer::export.gff3(unlist(grl_scaled), "uorf.gff")

#######################################
## Translational Efficiency Analysis ##
#######################################
## Currently, this step is covered entire by the code given in the Ribo-Seq
## workflow vignette using DESeq2 out of the box. The approach ended up being
## very similar to some of time course analysis steps given in the DESeq2
## vignette as well as some community discussions:
##      https://support.bioconductor.org/p/61509/ also here
##      https://support.bioconductor.org/p/67455/
## To-dos: add convenience function similar to run_DESeq2 (or extend it)
## to handle this analysis step for many experiment sets in a more convenient manner.

######################
## Adaptor Trimming ##
######################
## Trims adaptors hierarchically from longest to shortest match from right end of read.
## If 'internalmatch=TRUE' then internal matches will trigger the same behavior. The
## argument minpatternlength defines shortest adaptor match to consider for reads
## containing only partial adaptors at the right end.
trimbatch <- function(fq, pattern, internalmatch = FALSE, minpatternlength = 8,
                      Nnumber = 1, polyhomo = 100, minreadlength = 18, maxreadlength) {
    mylength <- max(width(fq))
    if (internalmatch == TRUE) {
        regpart <- ".*"
    } else {
        regpart <- "$"
    }
    processedreads <- ShortRead::ShortReadQ()
    ## Iterative trimming based on regular expression
    for (j in seq(along = minpatternlength:(nchar(pattern))) - 1) {
        mypattern <- paste(substring(pattern, 1, nchar(pattern) - j), regpart, sep = "")
        d <- Biostrings::DNAStringSet(gsub(mypattern, "", sread(fq)))
        q <- Biostrings::BStringSet(Biostrings::quality(Biostrings::quality(fq)), 1, width(d))
        fq <- ShortRead::ShortReadQ(sread = d, quality = q, id = id(fq))
        processedreads <- BiocGenerics::append(processedreads, fq[width(fq) < mylength])
        fq <- fq[width(fq) >= mylength]
    }
    processedreads <- BiocGenerics::append(processedreads, fq)
    processedreads <- processedreads[width(processedreads) >= minreadlength & width(processedreads) <= maxreadlength] # Read length filter
    filter1 <- ShortRead::nFilter(threshold = Nnumber) # keep only reads with <= x Ns
    filter2 <- ShortRead::polynFilter(threshold = polyhomo, nuc = c("A", "C", "T", "G")) # remove reads with x or more of the same nucleotide
    filter <- ShortRead::compose(filter1, filter2) # Combine filters into one
    processedreads[filter(processedreads)]
}
## Usage:
# iterTrim <- trimbatch(fq, pattern="ACACGTCT", minpatternlength=6, Nnumber=1, polyhomo=20, minreadlength=16, maxreadlength = 101)
# preprocessReads(args=args, Fct=iterTrim, batchsize=100000, overwrite=TRUE, compress=TRUE)

####################################
## Method Definitions for SYSargs ##
####################################
## Methods to return SYSargs components
setMethod(f = "targetsin", signature = "SYSargs", definition = function(x) {
    return(x@targetsin)
})
setMethod(f = "targetsout", signature = "SYSargs", definition = function(x) {
    return(x@targetsout)
})
setMethod(f = "targetsheader", signature = "SYSargs", definition = function(x) {
    return(x@targetsheader)
})
setMethod(f = "modules", signature = "SYSargs", definition = function(x) {
    return(as.character(x@modules))
})
setMethod(f = "software", signature = "SYSargs", definition = function(x) {
    return(as.character(x@software))
})
setMethod(f = "cores", signature = "SYSargs", definition = function(x) {
    return(x@cores)
})
setMethod(f = "other", signature = "SYSargs", definition = function(x) {
    return(x@other)
})
setMethod(f = "reference", signature = "SYSargs", definition = function(x) {
    return(x@reference)
})
setMethod(f = "results", signature = "SYSargs", definition = function(x) {
    return(as.character(x@results))
})
setMethod(f = "infile1", signature = "SYSargs", definition = function(x) {
    return(x@infile1)
})
setMethod(f = "infile2", signature = "SYSargs", definition = function(x) {
    return(x@infile2)
})
setMethod(f = "outfile1", signature = "SYSargs", definition = function(x) {
    return(x@outfile1)
})
setMethod(f = "SampleName", signature = "SYSargs", definition = function(x) {
    return(names(x@sysargs))
})
setMethod(f = "sysargs", signature = "SYSargs", definition = function(x) {
    return(x@sysargs)
})
setMethod(f = "outpaths", signature = "SYSargs", definition = function(x) {
    return(x@outpaths)
})

## Constructor methods
## List to SYSargs with: as(mylist, "SYSargs")
setAs(
    from = "list", to = "SYSargs",
    def = function(from) {
        new("SYSargs",
            targetsin = from$targetsin,
            targetsout = from$targetsout,
            targetsheader = from$targetsheader,
            modules = from$modules,
            software = from$software,
            cores = from$cores,
            other = from$other,
            reference = from$reference,
            results = from$results,
            infile1 = from$infile1,
            infile2 = from$infile2,
            outfile1 = from$outfile1,
            sysargs = from$sysargs,
            outpaths = from$outpaths
        )
    }
)

## Define print behavior for SYSargs
setMethod(
    f = "show", signature = "SYSargs",
    definition = function(object) {
        cat("An instance of '", class(object), "' for running '", object@software, "' on ", length(object@sysargs), " samples ", "\n", sep = "")
    }
)

## Extend names() method
setMethod(
    f = "names", signature = "SYSargs",
    definition = function(x) {
        return(slotNames(x))
    }
)

## Extend length() method
setMethod(
    f = "length", signature = "SYSargs",
    definition = function(x) {
        return(length(x@infile1))
    }
)

## Behavior of "[" operator for SYSargs
setMethod(f = "[", signature = "SYSargs", definition = function(x, i, ..., drop) {
    if (is.logical(i)) {
        i <- which(i)
    }
    x@targetsin <- x@targetsin[i, ]
    x@targetsout <- x@targetsout[i, ]
    x@infile1 <- x@infile1[i]
    x@infile2 <- x@infile2[i]
    x@outfile1 <- x@outfile1[i]
    x@sysargs <- x@sysargs[i]
    x@outpaths <- x@outpaths[i]
    return(x)
})

## Construct SYSargs object from param and targets files
systemArgs <- function(sysma, mytargets, type = "SYSargs") {
    ## Read sysma and convert to arglist; if NULL is assigned to sysma then a dummy version is generated
    sysmapath <- sysma
    if (length(sysmapath) != 0) {
        sysma <- as.matrix(read.delim(sysma, comment.char = "#"))
        sysma[is.na(sysma)] <- ""
    } else {
        sysma <- cbind(
            PairSet = c("software", "cores", "other", "outfile1", "reference", "infile1", "infile1", "infile2", "infile2"),
            Name = c("", "", "", "", "", "", "path", "", "path"),
            Value = c("", "1", "", "<FileName1>", "", "<FileName1>", "", "<FileName2>", "")
        )
    }
    if (any(sysma[, 1] %in% "type")) { # Detects software type: commandline or R
        iscommandline <- sysma[sysma[, 1] %in% "type", , drop = FALSE]
        iscommandline <- as.logical(iscommandline[1, "Value"])
        sysma <- sysma[!sysma[, 1] %in% "type", ] # removes type row(s)
    } else {
        iscommandline <- TRUE # If type line not present then 'commandline' will be assumed
    }
    arglist <- sapply(as.character(unique(sysma[, "PairSet"])), function(x) as.vector(t(as.matrix(sysma[sysma[, "PairSet"] == x, 2:3]))), simplify = FALSE)
    for (i in seq(along = arglist)) names(arglist[[i]]) <- paste(rep(c("n", "v"), length(arglist[[i]]) / 2), rep(1:(length(arglist[[i]]) / 2), 2), sep = "")
    if (type == "json") {
        checkPkg("rjson", quietly = FALSE)
        return(rjson::toJSON(arglist))
    }
    ## Read comment/header lines from targets file
    targetsheader <- readLines(mytargets)
    targetsheader <- targetsheader[grepl("^#", targetsheader)]
    ## Validity checks
    mytargets <- read.delim(mytargets, comment.char = "#")
    mytargetsorig <- mytargets
    if (any(duplicated(mytargets$SampleName))) stop("SampleName column of mytargets cannot contain duplicated entries!")
    ## Preprocessing of targets input
    colnames(mytargets)[1] <- "FileName1" # To support FileName column for SE data
    ## Insert empty FileName2 column if not present
    if (length(mytargets$FileName2) == 0) mytargets <- data.frame(FileName1 = mytargets$FileName1, FileName2 = "", mytargets[, !colnames(mytargets) %in% "FileName1"])
    ## Check name:value violations in arglist
    check <- sapply(names(arglist), function(x) sum(grepl("^n", names(arglist[[x]]))) == sum(grepl("^n", names(arglist[[x]]))))
    if (any(!check)) stop("Name:Value violation in arglist component(s): ", 
                          paste(names(check[check]), collapse = ", "))
    ## Modify arglist object as specified in arglist and mytargets
    ## Remove module component and store values in separate container
    modules <- as.character(arglist$modules[grepl("v", names(arglist$modules))])
    arglist <- arglist[!names(arglist) %in% "modules"]
    ## Extract single value components
    software <- as.character(arglist$software[grepl("v", names(arglist$software))])
    other <- as.character(arglist$other[grepl("v", names(arglist$other))])
    if (!(is.na(arglist[["reference"]][["v1"]]) | nchar(arglist[["reference"]][["v1"]]) == 0)) {
        reference <- as.character(arglist$reference[grepl("v", names(arglist$reference))])
        if (!grepl("^/", reference)) reference <- paste0(getwd(), gsub("^\\.", "", reference)) # Turn relative into absolute path.
        arglist[["reference"]]["v1"] <- reference
    } else {
        reference <- ""
    }
    cores <- as.numeric(arglist$cores[grepl("v", names(arglist$cores))])
    ## Populate arglist$infile1
    if (any(grepl("^<.*>$", arglist$infile1))) {
        infile1 <- gsub("<|>", "", arglist$infile1[grepl("^<.*>$", arglist$infile1)][[1]])
        infile1 <- as.character(mytargets[, infile1])
        infile1 <- normalizePath(infile1)
        argname <- arglist$infile1[grep("<.*>", arglist$infile1)[1] - 1]
        path <- arglist$infile1[grep("path", arglist$infile1)[1] + 1]
        infile1back <- paste(path, infile1, sep = "")
        names(infile1back) <- as.character(mytargets$SampleName)
        infile1 <- paste(argname, " ", path, infile1, sep = "")
        arglist[["infile1"]] <- gsub("(^ {1,})|( ${1,})", "", infile1)
    } else {
        infile1back <- rep("", length(mytargets[, 1]))
        infile1 <- infile1back
        names(infile1back) <- as.character(mytargets$SampleName)
        arglist[["infile1"]] <- infile1back
    }
    ## Populate arglist$infile2
    if (any(grepl("^<.*>$", arglist$infile2))) {
        infile2 <- gsub("<|>", "", arglist$infile2[grepl("^<.*>$", arglist$infile2)][[1]])
        infile2 <- as.character(mytargets[, infile2])
        if (nchar(infile2[1]) > 0) infile2 <- normalizePath(infile2)
        argname <- arglist$infile2[grep("<.*>", arglist$infile2)[1] - 1]
        path <- arglist$infile2[grep("path", arglist$infile2)[1] + 1]
        infile2back <- paste(path, infile2, sep = "")
        names(infile2back) <- as.character(mytargets$SampleName)
        infile2 <- paste(argname, " ", path, infile2, sep = "")
        arglist[["infile2"]] <- gsub("(^ {1,})|( ${1,})", "", infile2)
    } else {
        infile2back <- rep("", length(mytargets[, 1]))
        infile2 <- infile2back
        names(infile2back) <- as.character(mytargets$SampleName)
        arglist[["infile2"]] <- infile2back
    }
    ## Populate arglist$outfile1
    outfile1 <- gsub("<|>", "", arglist$outfile1[grepl("^<.*>$", arglist$outfile1)][[1]])
    outfile1 <- as.character(mytargets[, outfile1])
    outfile1 <- gsub("^.*/", "", outfile1)
    remove <- arglist$outfile1[grep("remove", arglist$outfile1)[1] + 1]
    outfile1 <- gsub(as.character(remove), "", outfile1)
    outfile1back <- outfile1
    outpaths <- outfile1
    outextension <- as.character(arglist$outfile1[grep("outextension", arglist$outfile1) + 1])
    append <- arglist$outfile1[grep("append", arglist$outfile1)[1] + 1]
    outfile1 <- paste(outfile1, append, sep = "")
    argname <- arglist$outfile1[grep("<.*>", arglist$outfile1)[1] - 1]
    path <- arglist$outfile1[grep("path", arglist$outfile1)[1] + 1]
    path <- gsub("^\\./|^/|/$", "", path)
    resultpath <- paste(getwd(), "/", path, "/", sep = "")
    outfile1back <- paste(getwd(), "/", path, "/", outfile1, sep = "")
    names(outfile1back) <- as.character(mytargets$SampleName)
    outfile1 <- paste(argname, " ", getwd(), "/", path, "/", outfile1, sep = "")
    arglist[["outfile1"]] <- gsub("(^ {1,})|( ${1,})", "", outfile1)
    ## Populate arglist$outfile2 if it exists (usually only required for PE trimming)
    if ("outfile2" %in% names(arglist)) {
        outfile2 <- gsub("<|>", "", arglist$outfile2[grepl("^<.*>$", arglist$outfile2)][[1]])
        outfile2 <- as.character(mytargets[, outfile2])
        outfile2 <- gsub("^.*/", "", outfile2)
        remove2 <- arglist$outfile2[grep("remove", arglist$outfile2)[1] + 1]
        outfile2 <- gsub(as.character(remove2), "", outfile2)
        outfile2back <- outfile2
        outpaths2 <- outfile2
        outextension2 <- as.character(arglist$outfile2[grep("outextension", arglist$outfile2) + 1])
        append2 <- arglist$outfile2[grep("append", arglist$outfile2)[1] + 1]
        outfile2 <- paste(outfile2, append2, sep = "")
        argname2 <- arglist$outfile2[grep("<.*>", arglist$outfile2)[1] - 1]
        path2 <- arglist$outfile2[grep("path", arglist$outfile2)[1] + 1]
        path2 <- gsub("^\\./|^/|/$", "", path2)
        resultpath2 <- paste(getwd(), "/", path2, "/", sep = "")
        outfile2back <- paste(getwd(), "/", path2, "/", outfile2, sep = "")
        names(outfile2back) <- as.character(mytargets$SampleName)
        outfile2 <- paste(argname2, " ", getwd(), "/", path2, "/", outfile2, sep = "")
        arglist[["outfile2"]] <- gsub("(^ {1,})|( ${1,})", "", outfile2)
    }
    ## Generate arglist$outpaths
    outpaths <- paste(getwd(), "/", path, "/", outpaths, outextension, sep = "")
    names(outpaths) <- as.character(mytargets$SampleName)
    ## Generate targetsout
    targetsout <- mytargetsorig
    targetsout[, 1] <- outpaths[as.character(targetsout$SampleName)]
    if ("outfile2" %in% names(arglist)) {
        outpaths2 <- paste(getwd(), "/", path2, "/", outpaths2, outextension2, sep = "")
        names(outpaths2) <- as.character(mytargets$SampleName)
        targetsout[, 2] <- outpaths2[as.character(targetsout$SampleName)]
        arglist <- arglist[!names(arglist) %in% "outfile2"]
    } else {
        colnames(targetsout)[1] <- "FileName"
        targetsout <- targetsout[, !colnames(targetsout) %in% "FileName2"]
    }
    ## Collapse remaining components to single string vectors
    remaining <- names(arglist)[!names(arglist) %in% c("outfile1", "infile1", "infile2", "outpaths")]
    for (i in remaining) arglist[[i]] <- rep(gsub("(^ {1,})|( ${1,})", "", paste(arglist[[i]], collapse = " ")), length(arglist$infile1))
    args <- do.call("cbind", arglist)
    rownames(args) <- as.character(mytargets$SampleName)
    args <- apply(args, 1, paste, collapse = " ")
    if (software == "bash_commands") { # If command-line is series of bash commands
        args <- gsub("' {1,}| {1,}'", "'", args)
        args <- gsub("bash_commands {1,}", "", args)
    }
    ## When software is R-based then system commands make no sense and NA is used instead
    if (iscommandline == FALSE) args[] <- ""
    ## If sysma=NULL then make adjustments that are most reasonable
    if (length(sysmapath) == 0) {
        targetsout <- mytargetsorig
        modules <- ""
        software <- "R functions"
        other <- ""
        reference <- ""
        resultpath <- ""
        outfile1back <- infile1back
        args[] <- ""
        outpaths[] <- infile1back
    }
    ## Construct SYSargs object from components
    syslist <- list(
        targetsin = mytargetsorig,
        targetsout = targetsout,
        targetsheader = targetsheader,
        modules = modules,
        software = software,
        cores = cores,
        other = other,
        reference = reference,
        results = resultpath,
        infile1 = infile1back,
        infile2 = infile2back,
        outfile1 = outfile1back,
        sysargs = args,
        outpaths = outpaths
    )
    sysargs <- as(syslist, "SYSargs")
    if (type == "SYSargs") {
        return(sysargs)
    }
}

## Usage:
# args <- systemArgs(sysma="../inst/extdata/tophat.param", mytargets="../inst/extdata/targets.txt")
# names(args); modules(args); cores(args); outpaths(args); sysargs(args)

#########################
## FASTQ Quality Plots ##
#########################
## Author: Thomas Girke
## Last update: 05-Dec-13
## Old version of this file is available under the name fastqQuality_old.R
## Utility:
##      Plots quality report for set of FASTQ files including
##              (A) Per cycle box plot of quality
##              (B) Per cycle base proportion
##              (C) Per cycle mean base quality
##              (D) Relative k-mer diversity: unique_k-mers / all_possible_k-mers
##              (E) Number of reads where all Phred scores are above a minimum cutoff
##              (F) Distribution of mean quality of reads
##              (G) Read length distribution
#               (H) Read occurrence distribution

## (A) Compute quality stats and store them in list
seeFastq <- function(fastq, batchsize, klength = 8) {
    ## Processing of single fastq file
    seeFastqSingle <- function(fastq, batchsize, klength) {
        ## Random sample N reads from fastq file (N=batchsize)
        f <- ShortRead::FastqSampler(fastq, batchsize)
        fq <- ShortRead::yield(f)
        nReads <- f$status()[["total"]] # Total number of reads in fastq file
        close(f)
        ## If reads are not of constant width then inject them into a matrix pre-populated with
        ## N/NA values and of dimensions N_rows = number_of_reads and N_columns = length_of_longest_read.
        if (length(unique(width(fq))) == 1) {
            q <- as.matrix(Biostrings::PhredQuality(Biostrings::quality(fq)))
            s <- as.matrix(ShortRead::sread(fq))
        } else {
            mymin <- min(width(fq))
            mymax <- max(width(fq))
            s <- matrix("N", length(fq), mymax)
            q <- matrix(NA, length(fq), mymax)
            for (i in mymin:mymax) {
                index <- width(fq) == i
                if (any(index)) {
                    s[index, 1:i] <- as.matrix(Biostrings::DNAStringSet(ShortRead::sread(fq)[index], start = 1, end = i))
                    q[index, 1:i] <- as.matrix(Biostrings::PhredQuality(Biostrings::quality(fq))[index])
                }
            }
        }
        s[s == "N"] <- NA
        row.names(q) <- paste("s", 1:length(q[, 1]), sep = "")
        colnames(q) <- 1:length(q[1, ])
        ## (A) Per cycle quality box plot
        ## Generate box plot from precomputed stats
        bpl <- graphics::boxplot(q, plot = FALSE)
        astats <- data.frame(bpl$names, t(matrix(bpl$stats, dim(bpl$stats))))
        colnames(astats) <- c("Cycle", "min", "low", "mid", "top", "max")
        astats[, 1] <- factor(astats[, 1], levels = unique(astats[, 1]), ordered = TRUE)
        ## (B) Per cycle base proportion
        bstats <- apply(s, 2, function(x) table(factor(x, levels = c("A", "C", "G", "T"))))
        colnames(bstats) <- 1:length(bstats[1, ])
        bstats <- t(apply(bstats, 1, function(x) x / colSums(bstats)))
        bstats <- data.frame(Nuc = rownames(bstats), bstats)
        convertDF <- function(df = df, mycolnames) {
            myfactor <- rep(colnames(df)[-1], each = length(df[, 1]))
            mydata <- as.vector(as.matrix(df[, -1]))
            df <- data.frame(df[, 1], mydata, myfactor)
            colnames(df) <- mycolnames
            return(df)
        }
        bstats <- convertDF(bstats, mycolnames = c("Base", "Frequency", "Cycle"))
        bstats[, 3] <- as.numeric(gsub("X", "", bstats[, 3]))
        bstats[, 3] <- factor(bstats[, 3], levels = unique(bstats[, 3]), ordered = TRUE)
        ## (C) Per cycle average quality of each base type
        A <- q
        A[s %in% c("T", "G", "C")] <- NA
        A <- colMeans(A, na.rm = TRUE)
        T <- q
        T[s %in% c("A", "G", "C")] <- NA
        T <- colMeans(T, na.rm = TRUE)
        G <- q
        G[s %in% c("T", "A", "C")] <- NA
        G <- colMeans(G, na.rm = TRUE)
        C <- q
        C[s %in% c("T", "G", "A")] <- NA
        C <- colMeans(C, na.rm = TRUE)
        cstats <- data.frame(Quality = c(A, C, G, T), Base = rep(c("A", "C", "G", "T"), each = length(A)), Cycle = c(names(A), names(C), names(G), names(T)))
        cstats[, 3] <- factor(cstats[, 3], levels = unique(cstats[, 3]), ordered = TRUE)
        ## (D) Relative K-mer Diversity
        dna <- ShortRead::sread(fq)
        loopv <- 1:(min(width(dna)) - (klength - 1))
        kcount <- sapply(loopv, function(x) length(unique(Biostrings::DNAStringSet(start = x, end = x + klength - 1, dna))))
        reldiv <- kcount / (5^klength) # 5 instead of 4 because of Ns
        reldiv <- c(rep(NA, klength - 1), reldiv) # Adds dummy NAs to align with sequencing cycles
        names(reldiv) <- 1:length(reldiv)
        dstats <- data.frame(RelDiv = reldiv, Method = rep(c(1), each = length(reldiv)), Cycle = names(reldiv))
        dstats[, 3] <- factor(dstats[, 3], levels = unique(dstats[, 3]), ordered = TRUE)
        ## (E) Number of reads where all Phred scores are above a minimum cutoff
        ev <- c("0" = 0, "1" = 10, "2" = 20, "3" = 30, "4" = 40)
        edf <- sapply(ev, function(x) sapply(as.numeric(names(ev)), function(y) sum(rowSums(q >= x, na.rm = TRUE) >= (rowSums(!is.na(q)) - y))))
        rownames(edf) <- names(ev)
        colnames(edf) <- ev
        edf <- edf / max(edf) * 100
        edf <- data.frame(Percent = paste(">", colnames(edf), sep = ""), t(edf), check.names = FALSE)
        estats <- convertDF(edf, mycolnames = c("minQuality", "Percent", "Outliers"))
        estats[, 1] <- factor(estats[, 1], levels = unique(estats[, 1]), ordered = TRUE)
        estats[, 3] <- factor(estats[, 3], levels = unique(estats[, 3]), ordered = TRUE)
        ## (F) Distribution of mean quality of reads
        qv <- table(round(rowMeans(q)))[as.character(0:max(q, na.rm = TRUE))]
        qv[is.na(qv)] <- 0
        names(qv) <- 0:max(q, na.rm = TRUE)
        fstats <- data.frame(Quality = names(qv), Percent = as.numeric(qv))
        fstats[, 2] <- as.numeric(as.vector(fstats[, 2])) / length(q[, 1]) * 100
        fstats[, 1] <- factor(fstats[, 1], levels = unique(fstats[, 1]), ordered = TRUE)
        ## (G) Read length distribution
        l <- rep(0, max(width(fq)))
        names(l) <- 1:length(l)
        lv <- table(width(fq))
        l[names(lv)] <- lv
        gstats <- data.frame(Cycle = names(l), Percent = l)
        gstats[, 2] <- gstats[, 2] / sum(gstats[, 2]) * 100
        gstats[, 1] <- factor(gstats[, 1], levels = unique(gstats[, 1]), ordered = TRUE)
        ## (H) Read occurrence distribution
        qa1 <- ShortRead::qa(fq, basename(fastq))
        hstats <- qa1[["sequenceDistribution"]][, 1:2]
        hstats <- data.frame(nOccurrences = hstats[, 1], Percent = hstats[, 1] * hstats[, 2] / batchsize * 100)
        hstats[, 1] <- factor(hstats[, 1], levels = unique(hstats[, 1]), ordered = TRUE)
        ## Assemble results in list
        return(list(fqstats = c(batchsize = batchsize, nReads = nReads, klength = klength), astats = astats, bstats = bstats, cstats = cstats, dstats = dstats, estats = estats, fstats = fstats, gstats = gstats, hstats = hstats))
    }
    ## Loop to run seeFastqSingle on one or many fastq files
    fqlist <- lapply(names(fastq), function(x) seeFastqSingle(fastq = fastq[x], batchsize = batchsize, klength = klength))
    names(fqlist) <- names(fastq)
    return(fqlist)
}
## Alias
# fastqQuality <- seeFastq

## (B) Plot seeFastq results
seeFastqPlot <- function(fqlist, arrange = c(1, 2, 3, 4, 5, 8, 6, 7), ...) {
    ## Create plotting instances from fqlist
    fastqPlot <- function(x = fqlist) {
        Cycle <- low <- mid <- top <- Frequency <- Base <- Quality <- RelDiv <- Method <- minQuality <- Percent <- Outliers <- NULL
        ## (A) Per cycle quality box plot
        astats <- x[[1]][["astats"]]
        a <- ggplot2::ggplot(astats, ggplot2::aes(x = Cycle, ymin = min, lower = low, middle = mid, upper = top, ymax = max)) +
            ggplot2::geom_boxplot(stat = "identity", color = "#606060", fill = "#56B4E9") +
            ggplot2::scale_x_discrete(breaks = c(1, seq(0, length(astats[, 1]), by = 10)[-1])) +
            ggplot2::ylab("Quality") +
            ggplot2::theme(legend.position = "none", plot.title = ggplot2::element_text(size = 12)) +
            ggplot2::ggtitle(names(x))
        ## (B) Per cycle base proportion
        bstats <- x[[1]][["bstats"]]
        b <- ggplot2::ggplot(bstats, ggplot2::aes(x = Cycle, y = Frequency, fill = Base), color = "black") +
            ggplot2::scale_x_discrete(breaks = c(1, seq(0, length(unique(bstats$Cycle)), by = 10)[-1])) +
            ggplot2::geom_bar(stat = "identity") +
            ggplot2::theme(legend.position = "top", legend.key.size = ggplot2::unit(0.2, "cm")) +
            ggplot2::ylab("Proportion")
        ## (C) Per cycle average quality of each base type
        cstats <- x[[1]][["cstats"]]
        c <- ggplot2::ggplot(cstats, ggplot2::aes(x = Cycle, y = Quality, group = Base, color = Base)) +
            ggplot2::geom_line() +
            ggplot2::scale_x_discrete(breaks = c(1, seq(0, length(unique(bstats$Cycle)), by = 10)[-1])) +
            ggplot2::theme(legend.position = "none")
        ## (D) Relative K-mer Diversity
        dstats <- x[[1]][["dstats"]]
        d <- ggplot2::ggplot(dstats, ggplot2::aes(x = Cycle, y = RelDiv, group = Method, color = Method)) +
            ggplot2::geom_line() +
            ggplot2::scale_x_discrete(breaks = c(1, seq(0, length(unique(bstats$Cycle)), by = 10)[-1])) +
            ggplot2::ylab(paste("k", x[[1]][["fqstats"]][["klength"]], "-mer Div", sep = "")) +
            ggplot2::theme(legend.position = "none")
        ## (E) Number of reads where all Phred scores are above a minimum cutoff
        estats <- x[[1]][["estats"]]
        e <- ggplot2::ggplot(estats, ggplot2::aes(x = minQuality, y = Percent, fill = Outliers)) +
            ggplot2::geom_bar(position = "dodge", stat = "identity") +
            ggplot2::theme(legend.position = "top", legend.key.size = ggplot2::unit(0.2, "cm")) +
            ggplot2::xlab("All Bases Above Min Quality") +
            ggplot2::ylab("% Reads")
        ## (F) Distribution of mean quality of reads
        fstats <- x[[1]][["fstats"]]
        f <- ggplot2::ggplot(fstats, ggplot2::aes(x = Quality, y = Percent)) +
            ggplot2::geom_bar(fill = "#0072B2", stat = "identity") +
            ggplot2::theme(legend.position = "none", plot.title = ggplot2::element_text(size = 9)) +
            ggplot2::ggtitle(paste(formatC(x[[1]][["fqstats"]][["batchsize"]], big.mark = ",", format = "f", digits = 0), "of", formatC(x[[1]][["fqstats"]][["nReads"]], big.mark = ",", format = "f", digits = 0), "Reads")) +
            ggplot2::scale_x_discrete(breaks = c(0, seq(0, length(unique(fstats$Quality)), by = 5)[-1])) +
            ggplot2::xlab("Mean Quality") +
            ggplot2::ylab("% Reads")
        ## (G) Read length distribution
        gstats <- x[[1]][["gstats"]]
        g <- ggplot2::ggplot(gstats, ggplot2::aes(x = Cycle, y = Percent)) +
            ggplot2::geom_bar(fill = "#0072B2", stat = "identity") +
            ggplot2::theme(legend.position = "none") +
            ggplot2::scale_x_discrete(breaks = c(1, seq(0, length(unique(gstats$Cycle)), by = 10)[-1])) +
            ggplot2::xlab("Read Length") +
            ggplot2::ylab("% Reads")
        ## (H) Read occurrence distribution
        hstats <- x[[1]][["hstats"]]
        myintervals <- data.frame(labels = c("1", "2-10", "11-100", "101-1k", "1k-10k", ">10k"), lower = c(1, 2, 11, 101, 1001, 10001), upper = c(2, 11, 101, 1001, 10001, Inf))
        iv <- sapply(seq(along = myintervals[, 1]), function(x) sum(hstats[as.numeric(as.vector(hstats$nOccurrences)) >= myintervals[x, 2] & as.numeric(as.vector(hstats$nOccurrences)) < myintervals[x, 3], "Percent"]))
        hstats <- data.frame(labels = myintervals[, 1], Percent = iv)
        hstats[, 1] <- factor(hstats[, 1], levels = unique(hstats[, 1]), ordered = TRUE)
        h <- ggplot2::ggplot(hstats, ggplot2::aes(x = labels, y = Percent)) +
            ggplot2::geom_bar(fill = "#0072B2", stat = "identity") +
            ggplot2::theme(legend.position = "none") +
            ggplot2::xlab("Read Occurrence") +
            ggplot2::ylab("% Reads")
        ## Assemble results in list
        return(list(a = a, b = b, c = c, d = d, g = g, e = e, f = f, h = h))
    }
    ## Loop to run fastqPlot and store instances in list
    fqplot <- lapply(names(fqlist), function(z) fastqPlot(x = fqlist[z]))
    names(fqplot) <- names(fqlist)
    ## Final plot
    grid::grid.newpage() # Open a new page on grid device
    grid::pushViewport(grid::viewport(layout = grid::grid.layout(length(arrange), length(fqplot))))
    for (i in seq(along = fqplot)) {
        for (j in seq(along = arrange)) {
            suppressWarnings(print(fqplot[[i]][[arrange[j]]], vp = grid::viewport(layout.pos.row = j, layout.pos.col = i)))
        }
    }
}
## Alias
# plotFQ <- seeFastqPlot

## Usage:
## Download some sample fastq files
# system("wget http://biocluster.ucr.edu/~tgirke/HTML_Presentations/Manuals/Rngsapps/chipseqBioc2012/data.zip")
# system("unzip data.zip")

## Generate FASTQ quality plots
# source("http://faculty.ucr.edu/~tgirke/Documents/R_BioCond/My_R_Scripts/fastqQuality.R")
# fastq <- list.files("data", "*.fastq$"); fastq <- paste("data/", fastq, sep="")
# names(fastq) <- paste("flowcell_6_lane", 1:4, sep="_")
# fqlist <- seeFastq(fastq=fastq, batchsize=100000, klength=8)
# pdf("fastqQuality.pdf", height=16, width=4*length(fastq))
# seeFastqPlot(fqlist, arrange=seq(along=fqlist))
# dev.off()

#######################
## createParamFiles ##
#######################
createParamFiles <- function(commandline, cwlVersion = "v1.1", class = "CommandLineTool",
                             results_path = "./results", module_load = "baseCommand",
                             file = "default", syntaxVersion = "v1", writeParamFiles = TRUE, confirm = FALSE,
                             overwrite = FALSE, silent = FALSE) {

    syntaxVersion <- match.arg(syntaxVersion, c("v1", "v2"))
    parse_func <- if(syntaxVersion == "v1") .modifyCwlParse else .cmd2cwl2
    if(syntaxVersion == "v1" && stringr::str_detect(commandline, ";")) on.exit(message(crayon::yellow$bold(
        "';' symbol detected but you are using v1 syntax, are you sure this is right?"
    )), add = TRUE)
    commandline <- parse_func(commandline)
    if (all(interactive() && confirm == FALSE)) {
        correct <- readline(cat(
            cat(crayon::bgMagenta("*****Checking Output*****\n")),
            "Is it all correct? ", "\n",
            "Would you like to proceed now? Type a number: \n 1. Yes \n 2. No \n"
        ))
        if (all(is.na(pmatch(c(1, 2), correct)))) stop("Unrecognized response ", dQuote(correct))
    } else {
        ## For an non-interactive session
        correct <- "1"
    }
    if (correct == "1") {
        WF <- createWF(
            targets = NULL, commandline, results_path = results_path,
            module_load = module_load, overwrite = TRUE, cwlVersion = cwlVersion, class = class
        )
        WF <- renderWF(WF)
        if (writeParamFiles) {
            ## Action to save files
            writeParamFiles(sysargs = WF, file = file, overwrite = overwrite, silent = silent, syntaxVersion = syntaxVersion)
        }
        ## Return
        return(WF)
    } else if (correct == "2") {
        message("Please try to adjust the raw command line and try again!")
    }
}

createParam <- createParamFiles

## Usage:
# command <- "
# hisat2 \
#     -S <F, out: ./results/M1A.sam> \
#     -x <F: ./data/tair10.fasta> \
#     -k <int: 1> \
#     -min-intronlen <int: 30> \
#     -max-intronlen <int: 3000> \
#     -threads <int: 4> \
#     -U <F: ./data/SRR446027_1.fastq.gz> \
#     --verbose
# "
# cmd <- createParamFiles(command)
# cmdlist(cmd)

#######################
## writeParamFiles ##
#######################
writeParamFiles <- function(sysargs, file = "default", overwrite = TRUE, silent = FALSE, syntaxVersion = "v1") {

    syntaxVersion <- match.arg(syntaxVersion, c("v1", "v2"))

    if (any(length(cmdlist(sysargs)[[1]]) == 0)) stop("Argument 'sysargs' needs to be assigned an object of class 'SYSargs2' fully rendered.")
    baseCommand <- clt(sysargs)[[1]]$baseCommand
    if ("default" %in% file) {
        if (dir.exists(file.path("param", "cwl", baseCommand)) == FALSE) dir.create(path = file.path("param", "cwl", baseCommand), recursive = TRUE)
        file.cwl <- file.path("param", "cwl", baseCommand, paste0(baseCommand, ".cwl"))
        file.yml <- file.path("param", "cwl", baseCommand, paste0(baseCommand, ".yml"))
    } else {
        for (i in seq_along(file)) {
            extension <- sub(".*\\.", "", file[[i]])
            if (!c("cwl") %in% extension & !c("yml") %in% extension) stop("Argument 'file' needs to be assigned as a character vector with the names of the two param file. For example, 'test.cwl' and 'test.yml'.")
            if (c("yml") %in% extension) {
                file.yml <- file[[i]]
            } else if (c("cwl") %in% extension) {
                file.cwl <- file[[i]]
            }
        }
    }
    if (file.exists(file.cwl) & overwrite == FALSE) {
        stop(
            "I am not allowed to overwrite files; please delete existing file: ",
            file.cwl, " or set 'overwrite=TRUE', or provide a different name in the 'file' argument"
        )
    }
    if (file.exists(file.yml) & overwrite == FALSE) {
        stop(
            "I am not allowed to overwrite files; please delete existing file: ",
            file.yml, " or set 'overwrite=TRUE', or provide a different name in the 'file' argument"
        )
    }
    args <- sysargs2(sysargs)
    if(!inherits(args$cmdToCwl, syntaxVersion))
        stop("input sysargs building syntax version is different than `syntaxVersion` value. Please change it.")
    cwlVersion <- args$clt[[1]]$cwlVersion
    class <- args$clt[[1]]$class
    module_load <- args$yamlinput$ModulesToLoad[[1]]
    results_path <- args$yamlinput$results_path$path
    clt <- write.clt(args$cmdToCwl, cwlVersion = cwlVersion, class = class, file.cwl = file.cwl,
                     writeout = TRUE, silent = silent,  syntaxVersion = syntaxVersion)
    yamlinput <- write.yml(args$cmdToCwl, file.yml = file.yml, results_path = results_path,
                           module_load = module_load, writeout = TRUE, silent = silent, syntaxVersion = syntaxVersion)
}

## Usage:
# cmd <- createParamFiles(command)
# writeParamFiles(cmd)

################
## printParam ##
################
printParam <- function(sysargs, position, index = NULL) {

    obj <- if(inherits(sysargs, "SYSargs2")) cmdToCwl(sysargs) else if(inherits(sysargs, "cwlParse")) sysargs else {
        stop("sysargs must be `SYSargs2` or `cwlParse` object")
    }
    if(inherits(obj, "v2")) stop("input sysargs built on syntax version 2, please use `printParam2`")
    .modifyCwlParse(commandline = obj, position = position, index = index)

}

## Usage
# printParam(cmd, position = "baseCommand")
# printParam(cmd, position = "inputs")
# printParam(cmd, position = "outputs")
# printParam(cmd, position = "inputs", index = 1:2)
# # or use character to index
# printParam(cmd, position = "inputs", index = c("S", "U"))
# printParam(cmd, position = "inputs", index = -1:-2)

##################
## subsetParam  ##
##################
subsetParam <- function(sysargs, position, index = NULL, trim = TRUE, mute = FALSE) {
    if(!inherits(sysargs, c("SYSargs2", "cwlParse"))) stop("sysargs must be `SYSargs2` or `cwlParse` object")
    if (inherits(sysargs, "SYSargs2")) {
        param <- cmdToCwl(sysargs)
        if(inherits(param, "v2")) stop("input sysargs built on syntax version 2, please use `removeParam2`")
        newParam <- .modifyCwlParse(
            commandline = param, position = position,
            index = index, trim = trim, mute = mute
        )
        cmdToCwl(sysargs) <- newParam
        sysargs <- updateWF(sysargs)
        return(invisible(sysargs))
    } else {
        if (inherits(sysargs, "cwlParse")) {
            if(inherits(sysargs, "v2")) stop("input sysargs built on syntax version 2, please use `removeParam2`")
            sysargs <- .modifyCwlParse(
                commandline = sysargs, position = position,
                index = index, trim = trim, mute = mute
            )
            return(invisible(sysargs))
        }
    }
}

## Usage:
# cmd2 <- subsetParam(cmd, position = "inputs", index = 1:2, trim = TRUE)
# cmdlist(cmd2)
# cmd3 <- subsetParam(cmd, position = "inputs", index = -1, trim = TRUE)
# cmdlist(cmd3)

###################
## replaceParam  ##
###################
replaceParam <- function(sysargs, position, index = NULL, replace, mute = FALSE) {
    if(!inherits(sysargs, c("SYSargs2", "cwlParse"))) stop("sysargs must be `SYSargs2` or `cwlParse` object")
    if (inherits(sysargs, "SYSargs2")) {
        param <- cmdToCwl(sysargs)
        if(inherits(param, "v2")) stop("input sysargs built on syntax version 2, please use `replaceParam2`")
        newParam <- .modifyCwlParse(
            commandline = param, position = position,
            index = index, replacing = replace, mute = mute
        )
        cmdToCwl(sysargs) <- newParam
        sysargs <- updateWF(sysargs)
        return(invisible(sysargs))
    } else {
        if (inherits(sysargs, "cwlParse")) {
            if(inherits(sysargs, "v2")) stop("input sysargs built on syntax version 2, please use `replaceParam2`")
            sysargs <- .modifyCwlParse(
                commandline = sysargs, position = position,
                index = index, replacing = replace, mute = mute
            )
            return(invisible(sysargs))
        }
    }
}

## Usage:
# cmd4 <- replaceParam(cmd, "base", index = 1, replace = list(baseCommand = "bwa"))
# cmdlist(cmd4)
#
# newIn <- new_inputs <- list(
#     "new_input1" = list(type = "File", preF="-b", yml ="myfile"),
#     "new_input2" = "-L <int: 4>"
# )
# cmd5 <- replaceParam(cmd, "inputs", index = 1:2, replace = new_inputs)
# cmdlist(cmd5)
#
# # string format
# new_outs <- list(
#     "sam_out" = "<F: $(inputs.results_path)/test.sam>"
# )
# cmd6 <- replaceParam(cmd, "outputs", index = 1, replace = new_outs)
# output(cmd6)
#
# # list format
# new_outs <- list(
#     "sam_out" = list(type = "File", value = "$(inputs.results_path)/test2.sam")
# )
# cmd7 <- replaceParam(cmd, "outputs", index = 1, replace = new_outs)
# output(cmd7)

###################
## renameParam  ##
###################
renameParam <- function(sysargs, position, index = FALSE, rename, mute = FALSE) {
    if(!inherits(sysargs, c("SYSargs2", "cwlParse"))) stop("sysargs must be `SYSargs2` or `cwlParse` object")
    if (inherits(sysargs, "SYSargs2")) {
        param <- cmdToCwl(sysargs)
        if(inherits(param, "v2")) stop("input sysargs built on syntax version 2, please use `renameParam2`")
        newParam <- .modifyCwlParse(
            commandline = param, position = position,
            index = index, rename = rename, mute = mute
        )
        cmdToCwl(sysargs) <- newParam
        sysargs <- updateWF(sysargs)
        return(invisible(sysargs))
    } else {
        if (inherits(sysargs, "cwlParse")) {
            if(inherits(sysargs, "v2")) stop("input sysargs built on syntax version 2, please use `renameParam2`")
            sysargs <- .modifyCwlParse(
                commandline = sysargs, position = position,
                index = index, rename = rename, mute = mute
            )
            return(invisible(sysargs))
        }
    }
}

# ## Usage:
# cmd8 <- renameParam(cmd, "inputs", index = c("S"), rename = c("Sample"))

###################
## appendParam  ##
###################
appendParam <- function(sysargs, position, index = NULL, append, after = NULL, mute = FALSE) {
    if(!inherits(sysargs, c("SYSargs2", "cwlParse"))) stop("sysargs must be `SYSargs2` or `cwlParse` object")
    if (inherits(sysargs, "SYSargs2")) {
        param <- cmdToCwl(sysargs)
        if(inherits(param, "v2")) stop("input sysargs built on syntax version 2, please use `appendParam2`")
        newParam <- .modifyCwlParse(
            commandline = param, position = position,
            index = index, appending = append, after = after, mute = mute
        )
        cmdToCwl(sysargs) <- newParam
        sysargs <- updateWF(sysargs)
        return(invisible(sysargs))
    } else {
        if (inherits(sysargs, "cwlParse")) {
            if(inherits(sysargs, "v2")) stop("input sysargs built on syntax version 2, please use `appendParam2`")
            sysargs <- .modifyCwlParse(
                commandline = sysargs, position = position,
                index = index, appending = append, after = after, mute = mute
            )
            return(invisible(sysargs))
        }
    }
}

# newIn <- new_inputs <- list(
#     "new_input1" = list(type = "File", preF="-b1", yml ="myfile1"),
#     "new_input2" = list(type = "File", preF="-b2", yml ="myfile2"),
#     "new_input3" = "-b3 <F: myfile3>"
# )
# cmd9 <- appendParam(cmd, "inputs", append = new_inputs)
# cmdlist(cmd9)
#
# cmd10 <- appendParam(cmd, "inputs", append = new_inputs, after=0)
# cmdlist(cmd10)

############################
## ## Internal Functions  ##
############################
.cmdToCwl <- function(cmd, mute = FALSE) {
    slash_line <- NULL
    stopifnot(is.character(cmd) && length(cmd) == 1)
    cmd_split <- stringr::str_split(cmd, "\n", simplify = TRUE) %>% # split args by line
        stringr::str_remove_all("^[ ]+") %>% # remove all leading, ending spaces
        stringr::str_remove_all("[ ]+$")
    # remove empty lines
    cmd_split <- cmd_split[cmd_split != ""]
    if (any(start_check <- stringr::str_detect(cmd_split[-1], "^[^<-]"))) {
        stop("Args must start with '-' or '<' for no prefix arg: ", cmd_split[-1][start_check])
    }
    if (any(slash_check <- stringr::str_detect(cmd_split, "\\\\$"))) {
        stop("Invalid line ends with '\\\\': ", stringr::str_replace(cmd_split[slash_line], "\\\\", "\\\\\\\\"))
    }
    # base command
    cmd_base <- cmd_split[1]
    cmd_list <- cmd_split[-1] %>%
        stringr::str_replace("^<", "no_prefix <") # find no prefix args
    # find no default args and replace with keyword no_default
    no_defaults <- cmd_list[stringr::str_detect(cmd_list, "<.*>", negate = TRUE)] %>%
        stringr::str_replace("$", " <no_default: no_default>")
    # replace them
    cmd_list[stringr::str_detect(cmd_list, "<.*>", negate = TRUE)] <- no_defaults
    # grep groups
    cmd_list <- stringr::str_match(cmd_list, "(^[-]{0,2}[A-Za-z0-9-_]+) (<.*>$)")

    # get prefix
    cmd_arg_prefix <- cmd_list[, 2]
    # give unique names of no prefix args
    # use prefix without - as name
    cmd_names <- cmd_arg_prefix %>% stringr::str_remove("^[-]{0,2}")
    # give unique names of no prefix args
    cmd_names[cmd_names == "no_prefix"] <- paste0("no_prefix", seq(sum(cmd_names == "no_prefix")))
    # now safe to replace no_prefix to ""
    cmd_arg_prefix[cmd_arg_prefix == "no_prefix"] <- ""

    # get arg content
    cmd_args <- cmd_list[, 3] %>%
        stringr::str_remove("^<") %>%
        stringr::str_remove(">$") %>%
        stringr::str_split(": ")
    # get defaults
    cmd_arg_defaults <- unlist(lapply(cmd_args, `[[`, 2)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^no_default$", "")
    # get input type
    cmd_arg_info <- unlist(lapply(cmd_args, `[[`, 1)) %>% stringr::str_split(",")
    cmd_arg_type <- unlist(lapply(cmd_arg_info, `[[`, 1)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^F$", "File") %>%
        # change F to File
        stringr::str_replace("^no_default$", "") # change no_defaults to empty
    # get to know if any input will be used for output
    cmd_out_steps <- unlist(lapply(cmd_arg_info, `[`, 2)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_which("out")
    # assemble inputs
    inputs <- mapply(
        function(type, prefix, default) {
            list(type = type, preF = prefix, yml = default)
        },
        type = cmd_arg_type, prefix = cmd_arg_prefix, default = cmd_arg_defaults,
        SIMPLIFY = FALSE
    )
    names(inputs) <- cmd_names
    # assemble outputs
    outputs <- mapply(
        function(type, default) {
            list(type = type, value = default)
        },
        type = cmd_arg_type[cmd_out_steps],
        default = cmd_arg_defaults[cmd_out_steps],
        SIMPLIFY = FALSE
    )
    names(outputs) <- paste0("output", seq(length(cmd_out_steps)))
    # assemble all
    commandline <- structure(list(baseCommand = cmd_base, inputs = inputs, outputs = outputs), class = c("list", "cwlParse", "v1"))
    if (!mute) .catCmdRaw(commandline)
    invisible(commandline)
}

########## .modifyCwlParse ##########
.modifyCwlParse <- function(commandline,
                            position = NULL,
                            index = NULL,
                            trim = FALSE,
                            replacing = NULL,
                            appending = NULL,
                            after = NULL,
                            rename = NULL,
                            mute = FALSE) {
    # assertions
    if (inherits(commandline, "character")) {
        commandline <- .cmdToCwl(commandline, mute = TRUE)
    } else if (inherits(commandline, "cwlParse")) {
        commandline <- commandline
    } else {
        stop("Expecting a 'character' or 'cwlParse' object")
    }
    # If position is NULL print it and return
    if (is.null(position)) {
        .catBase(commandline$baseCommand)
        .catInputs(commandline$inputs)
        .catOutputs(commandline$outputs)
        .catCmdRaw(commandline)
        return(invisible(commandline)) # always return itself
    }

    position <- match.arg(position, c("baseCommand", "inputs", "outputs"))
    if (position == "baseCommand" && !is.null(rename)) stop("'rename' does not work on 'baseCommand' position")
    stopifnot(is.character(index) || is.numeric(index) || is.null(index))
    stopifnot(is.logical(trim) && length(trim) == 1)
    stopifnot(is.logical(mute) && length(mute) == 1)

    # selected printing and/or trimming
    if (is.null(replacing) && is.null(rename) && is.null(appending) || trim) {
        commandline <- .cwlIndexTrim(commandline, position, index, trim, mute)
        return(invisible(commandline))
    }
    # replace and rename
    if (!is.null(replacing)) commandline <- .cwlReplace(commandline, position, index, replacing, mute)
    if (!is.null(rename)) commandline <- .cwlRename(commandline, position, index, rename, mute)
    if (!is.null(appending)) commandline <- .cwlAppend(commandline, position, appending, after, mute)

    return(invisible(commandline))
}

############# helper funcs ###########
## printing methods----
.catBase <- function(baseCommand) {
    cat(crayon::bgBlue("*****BaseCommand*****\n"))
    cat(baseCommand, "\n")
}

.catInputs <- function(inputs) {
    input_names <- names(inputs)
    cat(crayon::bgBlue("*****Inputs*****\n"))
    for (i in seq_along(inputs)) {
        cat(
            input_names[i], ":\n",
            "    type: ", inputs[[i]][["type"]], "\n",
            "    preF: ", inputs[[i]][["preF"]], "\n",
            "    yml: ", inputs[[i]][["yml"]], "\n",
            sep = ""
        )
    }
}

.catOutputs <- function(outputs) {
    out_names <- names(outputs)
    cat(crayon::bgBlue("*****Outputs*****\n"))
    for (i in seq_along(outputs)) {
        cat(
            out_names[i], ":\n",
            "    type: ", outputs[[i]][["type"]], "\n",
            "    value: ", outputs[[i]][["value"]], "\n",
            sep = ""
        )
    }
}

.catCmdRaw <- function(commandline) {
    cmd_string <- lapply(commandline$inputs, `[`, c("preF", "yml")) %>%
        unlist() %>%
        paste0(collapse = " ")
    cat(crayon::bgBlue("*****Parsed raw command line*****\n"))
    cat(commandline$baseCommand, cmd_string, "\n")
}

## print certain position or trimming----
.cwlIndexTrim <- function(commandline, position, index, trim, mute) {
    switch(position,
        "baseCommand" = {
            .catBase(commandline$baseCommand)
        },
        "inputs" = {
            inputs <- commandline$inputs
            if (!is.null(index)) {
                if (is.character(index)) {
                    index <- index[index %in% names(inputs)]
                } else if (is.numeric(index)) {
                    if (sum(index > 0) > 0 && sum(index < 0) > 0) {
                        stop("Cannot mix negative and positive indexing")
                    } else if (length(index) == 1 && index == 0) {
                        stop("Cannot use a single 0 to index")
                    }
                    index <- index[index <= length(inputs)]
                } else {
                    stop("Incorrect class of index")
                }
                inputs <- commandline$inputs[index]
            } else {
                inputs <- commandline$inputs
            }

            if (trim) {
                commandline$inputs <- inputs
                if (!mute) {
                    .catInputs(inputs)
                    .catCmdRaw(commandline)
                }
            } else {
                .catInputs(inputs)
            }
        },
        "outputs" = {
            outputs <- commandline$outputs
            if (!is.null(index)) {
                if (is.character(index)) {
                    index <- index[index %in% names(outputs)]
                } else if (is.numeric(index)) {
                    if (sum(index > 0) > 0 && sum(index < 0) > 0) {
                        stop("Cannot mix negative and positive indexing")
                    } else if (length(index) == 1 && index == 0) {
                        stop("Cannot use a single 0 to index")
                    }
                    index <- index[index <= length(outputs)]
                } else {
                    stop("Incorrect class of index")
                }
                outputs <- commandline$outputs[index]
            } else {
                outputs <- commandline$outputs
            }
            if (trim) {
                commandline$outputs <- outputs
                if (!mute) {
                    .catOutputs(outputs)
                    .catCmdRaw(commandline)
                }
            } else {
                .catOutputs(outputs)
            }
        }
    )
    commandline
}

## replacing method ----------
.cwlReplace <- function(commandline, position, index, replacing, mute) {
    # many assertions
    stopifnot(is.list(replacing))
    ## assert names
    re_names <- names(replacing)
    if ("" %in% re_names) stop("All items in 'replacing' must be named")
    if (length(unique(re_names)) != length(re_names)) stop("All items in 'replacing' must be unique")

    if (!is.null(replacing) && is.null(index)) stop("'replace' specified but 'index' is empty")
    if (length(replacing) != length(index)) stop("'replace' and 'index' must have the same length")
    if (length(unique(index)) != length(replacing)) stop("You have duplicated index")
    if (length(unique(names(replacing))) != length(replacing)) stop("All replacing items must be uniquely named")
    ## start to replace
    switch(position,
        "baseCommand" = {
            if (length(replacing) != 1) stop("The list to replace baseCommand needs to be length of 1")
            if (names(replacing[1]) != "baseCommand") stop("Replace list for baseCommand must have an item named 'baseCommand'")
            commandline$baseCommand <- replacing[["baseCommand"]][[1]]
            if (!mute) {
                cat("Replacing baseCommand\n")
                .catBase(commandline$baseCommand)
                .catCmdRaw(commandline)
            }
            return(invisible(commandline))
        },
        "inputs" = {
            replacing <- .parseNewIn(replacing)
            ### verify index
            if (is.character(index)) {
                # change char to numeric
                index <- which(names(commandline$inputs) %in% index)
            } else if (is.numeric(index)) {
                if (sum(index < 0) > 0) {
                    stop("Cannot use negative indexing for replacing")
                } else if (length(index) == 1 && index == 0) {
                    stop("Cannot use a single 0 to index")
                }
                index <- index[index <= length(commandline$inputs)]
            }
            if (length(index) < 1) stop("No valid index left")
            # after some invalid index removed, validate index and replacing again
            if (length(index) != length(replacing)) {
                stop(
                    "length of index is ", length(index),
                    " but length of replacing is ", length(replacing),
                    " after removing invalid indices"
                )
            }
            ## start to replace
            commandline$inputs[index] <- replacing
            ## overwrite names
            names(commandline$inputs)[index] <- names(replacing)
            if (!mute) {
                cat("Replacing inputs\n")
                .catInputs(commandline$inputs)
                .catCmdRaw(commandline)
            }
        },
        "outputs" = {
            ## assert input type
            replacing <- .parseNewOut(replacing)
            ### verify index
            if (is.character(index)) {
                # change char to numeric
                index <- which(names(commandline$outputs) %in% index)
            } else if (is.numeric(index)) {
                if (sum(index < 0) > 0) {
                    stop("Cannot use negative indexing for replacing")
                } else if (length(index) == 1 && index == 0) {
                    stop("Cannot use a single 0 to index")
                }
                index <- index[index <= length(commandline$outputs)]
            }
            if (length(index) < 1) stop("No valid index left")
            # after some invalid index removed, validate index and replacing again
            if (length(index) != length(replacing)) {
                stop(
                    "length of index is ", length(index),
                    " but length of replacing is ", length(replacing),
                    " after removing invalid indices"
                )
            }
            ## start to replace
            commandline$outputs[index] <- replacing
            ## overwrite names
            names(commandline$outputs)[index] <- names(replacing)
            if (!mute) {
                cat("Replacing outputs\n")
                .catOutputs(commandline$outputs)
                .catCmdRaw(commandline)
            }
        }
    )
    commandline
}
## rename --------
.cwlRename <- function(commandline, position, index, rename, mute) {
    if (is.null(index)) stop("'rename' specified but 'index' is empty")
    if (length(rename) != length(index)) stop("'rename' and 'index' must have the same length")
    stopifnot(is.character(rename))
    if (length(unique(rename)) != length(rename)) stop("Duplicated reanme items detected")
    if (position == "baseCommand") stop("Cannot rename baseCommand position")

    switch(position,
        "inputs" = {
            if (is.character(index)) {
                # change char to numeric
                index <- which(names(commandline$inputs) %in% index)
            } else if (is.numeric(index)) {
                if (sum(index < 0) > 0) {
                    stop("Cannot use negative indexing for rename")
                } else if (length(index) == 1 && index == 0) {
                    stop("Cannot use a single 0 to index")
                }
                index <- index[index <= length(commandline$inputs)]
            }
            if (length(index) < 1) stop("No valid index left")
            if (length(index) != length(rename)) {
                stop(
                    "length of index is ", length(index),
                    " but length of rename is ", length(rename),
                    " after removing invalid indices"
                )
            }
            ## overwrite names
            names(commandline$inputs)[index] <- rename
            if (!mute) {
                cat("Renaming inputs\n")
                .catInputs(commandline$inputs)
                .catCmdRaw(commandline)
            }
        },
        "outputs" = {
            if (is.character(index)) {
                # change char to numeric
                index <- which(names(commandline$outputs) %in% index)
            } else if (is.numeric(index)) {
                if (sum(index < 0) > 0) {
                    stop("Cannot use negative indexing for rename")
                } else if (length(index) == 1 && index == 0) {
                    stop("Cannot use a single 0 to index")
                }
                index <- index[index <= length(commandline$outputs)]
            }
            if (length(index) < 1) stop("No valid index left")
            if (length(index) != length(rename)) {
                stop(
                    "length of index is ", length(index),
                    " but length of rename is ", length(rename),
                    " after removing invalid indices"
                )
            }
            names(commandline$outputs)[index] <- rename
            if (!mute) {
                cat("Renaming outputs\n")
                .catOutputs(commandline$outputs)
                .catCmdRaw(commandline)
            }
        }
    )
    commandline
}

## appending method ----
.cwlAppend <- function(commandline, position, appending, after, mute) {
    # many assertions
    if (position == "baseCommand") stop("Cannot appending to baseCommand")
    stopifnot(is.list(appending))
    ## assert names
    ap_names <- names(appending)
    if ("" %in% ap_names) stop("All items in 'appending' must be named")
    if (length(unique(ap_names)) != length(ap_names)) stop("All items in 'replacing' must be unique")
    after <- if (is.null(after)) {
        length(commandline[[position]])
    } else {
        stopifnot(is.numeric(after) && length(after) == 1)
        as.integer(after)
    }
    ## start to replace
    switch(position,
        "inputs" = {
            ## assert input type
            appending <- .parseNewIn(appending, print_word = "appending")
            ## start to append
            commandline$inputs <- append(commandline$inputs, appending, after = after)
            if (!mute) {
                cat("Replacing inputs\n")
                .catInputs(commandline$inputs)
                .catCmdRaw(commandline)
            }
        },
        "outputs" = {
            ## assert input type
            appending <- .parseNewOut(appending, print_word = "appending")
            ## start to append
            commandline$outputs <- append(commandline$outputs, appending, after = after)
            if (!mute) {
                cat("Replacing outputs\n")
                .catOutputs(commandline$outputs)
                .catCmdRaw(commandline)
            }
        }
    )
    commandline
}

## in/out parsing methods
.parseNewIn <- function(newIn, print_word = "replacing") {
    in_names <- names(newIn)
    newIn <- lapply(seq_along(newIn), function(x) {
        if (is.list(newIn[[x]])) {
            ## assert items
            if (length(newIn[[x]]) != 3 || !all(names(newIn[[x]]) %in% c("type", "preF", "yml"))) {
                cat("You are ", print_word, " inputs:\n")
                stop(names(newIn[x]), ' item in "', print_word, '" must be length 3 and have "type", "preF" and "yml"')
            }
            ## assert item type
            lapply(newIn[[x]], function(i) {
                if (length(i) != 1 || !is.character(i)) {
                    cat("You are ", print_word, " inputs:\n")
                    stop('In "', names(newIn[x]), '": "type", "preF", "yml" in each item must all be length 1 character string')
                }
            })
            newIn[[x]]
        } else if (is.character(newIn[[x]]) && length(newIn[[x]]) == 1) {
            .parseInStr(newIn[[x]])
        } else {
            cat("You are ", print_word, " inputs:\n")
            stop("Item ", names(newIn[x]), " in ", print_word, " must be a list with 3 sub-item or a chracter string")
        }
    })
    names(newIn) <- in_names
    return(newIn)
}

.parseInStr <- function(inStr) {
    cmd_list <- stringr::str_replace(inStr, "^<", "no_prefix <") # find no prefix args
    no_defaults <- cmd_list[stringr::str_detect(cmd_list, "<.*>", negate = TRUE)] %>%
        stringr::str_replace("$", " <no_default: no_default>")
    cmd_list[stringr::str_detect(cmd_list, "<.*>", negate = TRUE)] <- no_defaults

    cmd_list <- stringr::str_match(cmd_list, "(^[-]{0,2}[A-Za-z0-9-_]+) (<.*>$)")
    if (is.na(cmd_list[1, 1])) stop("Invalid string: ", inStr)
    cmd_arg_prefix <- cmd_list[, 2]
    cmd_arg_prefix[cmd_arg_prefix == "no_prefix"] <- ""

    cmd_args <- cmd_list[, 3] %>%
        stringr::str_remove("^<") %>%
        stringr::str_remove(">$") %>%
        stringr::str_split(": ")

    cmd_arg_defaults <- unlist(lapply(cmd_args, `[[`, 2)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^no_default$", "")

    cmd_arg_info <- unlist(lapply(cmd_args, `[[`, 1)) %>% stringr::str_split(",")
    cmd_arg_type <- unlist(lapply(cmd_arg_info, `[[`, 1)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^F$", "File") %>%
        # change F to File
        stringr::str_replace("^no_default$", "")
    list(type = cmd_arg_type, preF = cmd_arg_prefix, yml = cmd_arg_defaults)
}


.parseNewOut <- function(newOut, print_word = "replacing") {
    out_names <- names(newOut)
    newOut <- lapply(seq_along(newOut), function(x) {
        if (is.list(newOut[[x]])) {
            ## assert items
            if (length(newOut[[x]]) != 2 || !all(names(newOut[[x]]) %in% c("type", "value"))) {
                cat("You are ", print_word, " outputs:\n")
                stop(names(newOut[x]), ' item in "', print_word, '" must be length 2 and have "type", "value"')
            }
            ## assert item type
            lapply(newOut[[x]], function(i) {
                if (length(i) != 1 || !is.character(i)) {
                    cat("You are ", print_word, " outputs:\n")
                    stop('In "', names(newOut[x]), '": "type", "value" in each item must all be length 1 character string')
                }
            })
            newOut[[x]]
        } else if (is.character(newOut[[x]]) && length(newOut[[x]]) == 1) {
            .parseOutStr(newOut[[x]])
        } else {
            cat("You are ", print_word, " outputs:\n")
            stop("Item ", names(newOut[x]), " in ", print_word, " must be a list with 3 sub-item or a chracter string")
        }
    })
    names(newOut) <- out_names
    return(newOut)
}

.parseOutStr <- function(outStr) {
    cmd_list <- outStr
    if (!stringr::str_detect(cmd_list, "^<.*>$")) stop("Invalid string: '", outStr, " ', needs to be inside '<...>'")
    if (length(stringr::str_extract_all(cmd_list, ":", simplify = TRUE)) != 1) {
        stop("Invalid string: '", outStr, " ', needs to have exact 1 ':'")
    }

    cmd_args <- cmd_list %>%
        stringr::str_remove("^<") %>%
        stringr::str_remove(">$") %>%
        stringr::str_split(": ")
    if (stringr::str_detect(cmd_args[[1]][1], "\\W")) {
        stop("Invalid string: '", outStr, " ', no special character for output type")
    }

    cmd_arg_defaults <- unlist(lapply(cmd_args, `[[`, 2)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^no_default$", "")

    cmd_arg_info <- unlist(lapply(cmd_args, `[[`, 1)) %>% stringr::str_split(",")
    cmd_arg_type <- unlist(lapply(cmd_arg_info, `[[`, 1)) %>%
        stringr::str_remove("^[ ]+") %>%
        stringr::str_remove("[ ]+$") %>%
        stringr::str_replace("^F$", "File") %>%
        # change F to File
        stringr::str_replace("^no_default$", "")
    list(type = cmd_arg_type, value = cmd_arg_defaults)
}

#######################
## Gene Set Analysis ##
#######################

############################################
## Class and Method Definitions for catDB ##
############################################
## Define catDB class
setClass("catDB", representation(catmap = "list", catlist = "list", idconv = "ANY"))
## Methods to return catDB components as lists
setGeneric(name = "catmap", def = function(x) standardGeneric("catmap"))
setMethod(f = "catmap", signature = "catDB", definition = function(x) {
    return(x@catmap)
})
setGeneric(name = "catlist", def = function(x) standardGeneric("catlist"))
setMethod(f = "catlist", signature = "catDB", definition = function(x) {
    return(x@catlist)
})
setGeneric(name = "idconv", def = function(x) standardGeneric("idconv"))
setMethod(f = "idconv", signature = "catDB", definition = function(x) {
    return(x@idconv)
})
## Constructor methods
## List to catDB with: as(mylist, "catDB")
setAs(
    from = "list", to = "catDB",
    def = function(from) {
        new("catDB",
            catmap = from$catmap,
            catlist = from$catlist,
            idconv = from$idconv
        )
    }
)
## Define print behavior for catDB
setMethod(
    f = "show", signature = "catDB",
    definition = function(object) {
        cat("An instance of '", class(object), "' containing:", "\n\t",
            "catmap: ", length(object@catmap), " mapping data frames (", paste(names(object@catmap), collapse = ", "), ") ", "\n\t",
            "catlist: ", length(object@catlist), " category lists (", paste(names(object@catlist), collapse = ", "), ")", "\n\t",
            "idconv: ", length(object@idconv), " id conversion data frames (", paste(names(object@idconv), collapse = ", "), ")",
            "\n",
            sep = ""
        )
    }
)
## Extend names() method
setMethod(
    f = "names", signature = "catDB",
    definition = function(x) {
        return(slotNames(x))
    }
)

############################
## Construct catDB object ##
############################
## (A.1) Generate sample data frames with assigned gene-to-GO mappings,
## one for MF, one for BP and one for CC mappings
## custom mappings can be used here, but need to have the same format as GO_XX_DFs in the following examples
## (A.1.1) Obtain mappings from geneontology.org
.readGOorg <- function(myfile, colno, org) {
    pkg <- c("AnnotationDbi", "GO.db")
    checkPkg(pkg, quietly = FALSE)
    go_org <- read.delim(myfile, na.strings = "", header = FALSE, comment.char = "!", sep = "\t")
    go_org <- go_org[, colno]
    names(go_org) <- c("GOID", "GeneID", "GOCAT")
    if (org == "Arabidopsis") {
        go_org[, "GeneID"] <- gsub(".*(AT.G\\d\\d\\d\\d\\d).*", "\\1", as.character(go_org[, 2]), perl = TRUE)
        go_org <- go_org[grep("^AT.G\\d\\d\\d\\d\\d", as.character(go_org$GeneID), perl = TRUE), ]
        go_org <- go_org[!duplicated(paste(go_org[, "GOID"], gsub("\\.\\d{1,}", "", as.character(go_org[, "GeneID"]), perl = TRUE), sep = "_")), ]
    }
    go_org <- na.omit(go_org)
    ## Make GO cat labels consistent, e.g. from BioMart
    gocat <- as.character(go_org$GOCAT)
    gocat[gocat == "molecular_function"] <- "F"
    gocat[gocat == "biological_process"] <- "P"
    gocat[gocat == "cellular_component"] <- "C"
    go_org[, "GOCAT"] <- gocat
    ## Split data frame by category
    GO_MF_DF <- go_org[go_org[, 3] == "F", ]
    GO_BP_DF <- go_org[go_org[, 3] == "P", ]
    GO_CC_DF <- go_org[go_org[, 3] == "C", ]
    ## Generates data frame (go_df) containing the commonly used components for all GO nodes: GOID, GO Term and Ontology Type. This step is only required if "go_df" hasn't been imported with the above load() function.
    go_df <- data.frame(GOID = names(AnnotationDbi::Term(GO.db::GOTERM)), Term = AnnotationDbi::Term(GO.db::GOTERM), Ont = AnnotationDbi::Ontology(GO.db::GOTERM))
    go_df <- na.omit(go_df)
    ## Return results
    dflist <- list(D_BP = GO_BP_DF, D_CC = GO_CC_DF, D_MF = GO_MF_DF, GO_DF = go_df)
    return(dflist)
}
## Usage:
# catdf <- .readGOorg(myfile = "data/GO/GOannotationsBiomart_mod.txt", org="", colno = c(1,2,3))

## (A.1.2) Obtain mappings from BioC
.sampleDFgene2GO <- function(lib) {
    pkg <- c("GO.db", "annotate", "AnnotationDbi")
    # checkPkg(pkg, quietly = FALSE)
    require(lib, character.only = TRUE)
    mylibbase <- gsub(".db", "", lib)
    GOMF <- eapply(get(paste(mylibbase, "GO", sep = "")), annotate::getOntology, "MF") # generates list with GeneID components containing MFGOs
    GO_MF_DF <- data.frame(GOID = unlist(GOMF), GeneID = rep(names(GOMF), as.vector(sapply(GOMF, length))), Count = rep(as.vector(sapply(GOMF, length)), as.vector(sapply(GOMF, length))))
    GOBP <- eapply(get(paste(mylibbase, "GO", sep = "")), annotate::getOntology, "BP") # generates list with GeneID components containing BPGOs
    GO_BP_DF <- data.frame(GOID = unlist(GOBP), GeneID = rep(names(GOBP), as.vector(sapply(GOBP, length))), Count = rep(as.vector(sapply(GOBP, length)), as.vector(sapply(GOBP, length))))
    GOCC <- eapply(get(paste(mylibbase, "GO", sep = "")), annotate::getOntology, "CC") # generates list with GeneID components containing CCGOs
    GO_CC_DF <- data.frame(GOID = unlist(GOCC), GeneID = rep(names(GOCC), as.vector(sapply(GOCC, length))), Count = rep(as.vector(sapply(GOCC, length)), as.vector(sapply(GOCC, length))))
    ## Generates data frame (go_df) containing the commonly used components for all GO nodes: GOID, GO Term and Ontology Type. This step is only required if "go_df" hasn't been imported with the above load() function.
    go_df <- data.frame(GOID = names(AnnotationDbi::Term(GO.db::GOTERM)), Term = AnnotationDbi::Term(GO.db::GOTERM), Ont = AnnotationDbi::Ontology(GO.db::GOTERM))
    go_df <- na.omit(go_df)
    ## Return results
    dflist <- list(D_BP = GO_BP_DF, D_CC = GO_CC_DF, D_MF = GO_MF_DF, GO_DF = go_df)
    return(dflist)
}
## Usage:
# catdf <- .sampleDFgene2GO(lib="ath1121501.db")

## (A.2) Generate list containing gene-to-GO-OFFSPRING associations including assiged nodes
## This is slow (3 minutes), but needs to be done only once!
.gene2GOlist <- function(catdf, rootUK = FALSE) { # If the argument 'rootUK' is set to TRUE then the root nodes are treated as terminal nodes to account for the new unknown terms
    ## Import required data frames
    GO_MF_DF <- catdf$D_MF
    GO_BP_DF <- catdf$D_BP
    GO_CC_DF <- catdf$D_CC
    ## Populate each GO node with associated gene ids
    for (i in c("MF", "BP", "CC")) {
        if (i == "MF") {
            go_offspr_list <- as.list(GO.db::GOMFOFFSPRING)
        }
        if (i == "BP") {
            go_offspr_list <- as.list(GO.db::GOBPOFFSPRING)
        }
        if (i == "CC") {
            go_offspr_list <- as.list(GO.db::GOCCOFFSPRING)
        }
        go_offspr_list <- lapply(go_offspr_list, unlist)
        go_offspr_list <- lapply(go_offspr_list, as.vector) # clean-up step for the list
        go_offspr_list_temp <- lapply(names(go_offspr_list), function(x) c(x, go_offspr_list[[x]])) # include list component (GOID) names in corresponding (GOID) vectors
        names(go_offspr_list_temp) <- names(go_offspr_list) # names list components after go_offspr_list
        go_offspr_list <- go_offspr_list_temp
        go_offspr_list <- lapply(go_offspr_list, function(x) x[!is.na(x)]) # remove NAs in vectors
        ## Treat root nodes as terminal nodes to account for the new unknown terms. This step removes the offspring information from the root nodes.
        if (rootUK == TRUE) {
            if (i == "MF") {
                go_offspr_list[["GO:0003674"]] <- c("GO:0003674")
            }
            if (i == "BP") {
                go_offspr_list[["GO:0008150"]] <- c("GO:0008150")
            }
            if (i == "CC") {
                go_offspr_list[["GO:0005575"]] <- c("GO:0005575")
            }
        }
        ## Retrieve gene (affy) IDs for GOID vectors
        if (i == "MF") {
            MF_node_gene_list <- lapply(go_offspr_list, function(x) unique(as.vector(GO_MF_DF[GO_MF_DF$GOID %in% x, 2])))
        }
        if (i == "BP") {
            BP_node_gene_list <- lapply(go_offspr_list, function(x) unique(as.vector(GO_BP_DF[GO_BP_DF$GOID %in% x, 2])))
        }
        if (i == "CC") {
            CC_node_gene_list <- lapply(go_offspr_list, function(x) unique(as.vector(GO_CC_DF[GO_CC_DF$GOID %in% x, 2])))
        }
        cat("\n", paste("'", i, "_node_gene_list'", sep = ""), "with gene-to-GO-OFFSPRING associations created.", "\n")
    }
    node_gene_list <- list(L_BP = BP_node_gene_list, L_CC = CC_node_gene_list, L_MF = MF_node_gene_list)
    return(node_gene_list)
}
## Usage:
# catlist <- .gene2GOlist(catdf=catdf, rootUK=FALSE)

## (A.3) Generate AffyID-to-GeneID mappings when working with chip feature IDs
## This function creates a AffyID-to-GeneID mapping data frame using by default the TAIR mappings for the Arabidopsis ATH1 chip.
## Once the decoding data frame 'affy2locusDF' is created, the function returns for a query set of AffyIDs the corresponding GeneIDs.
## To use the function for the mappings of other chips, one needs to create the corresponding decoding data frame 'affy2locusDF'.
.AffyID2GeneID <- function(map = "ftp://ftp.arabidopsis.org/home/tair/Microarrays/Affymetrix/affy_ATH1_array_elements-2008-5-29.txt", download = FALSE, catdb = NULL, affyIDs, probe2gene = 1) {
    if (download == TRUE) {
        cat("\n", "Downloading AffyID-to-GeneID mappings", "\n")
        affy2locus <- read.delim(map, na.strings = "", fill = TRUE, header = TRUE, sep = "\t")[, -c(2:4, 7:9)]
        names(affy2locus) <- c("AffyID", "AGI", "Desc")
        row.names(affy2locus) <- as.vector(affy2locus[, 1])
        my_list <- apply(affy2locus[, -c(3)], 1, list)
        my_list <- lapply(my_list, unlist)
        my_list <- lapply(my_list, function(x) as.vector(x[-1]))
        my_list <- lapply(my_list, strsplit, ";")
        my_list <- lapply(my_list, unlist)
        affy2locusDF <- data.frame(unlist(my_list))
        affy2locusDF <- data.frame(rep(names(unlist(lapply(my_list, length))), as.vector(unlist(lapply(my_list, length)))), affy2locusDF)
        names(affy2locusDF) <- c("AffyID", "GeneID")
        return(affy2locusDF)
    }
    if (!missing(affyIDs)) {
        affy2locusDF <- idconv(catdb)[[1]]
        if (probe2gene == 1) { # For probe sets that match several loci, only the first locus ID will be used
            affy2locusDF <- affy2locusDF[!duplicated(affy2locusDF$AffyID), ]
        }
        GeneIDs <- unique(as.vector(affy2locusDF[affy2locusDF[, 1] %in% affyIDs, 2]))
        return(GeneIDs)
    }
}
## Usage:
# affy2locusDF <- systemPipeR:::.AffyID2GeneID(map = "ftp://ftp.arabidopsis.org/home/tair/Microarrays/Affymetrix/affy_ATH1_array_elements-2010-12-20.txt", download=TRUE)
# catdb_conv <- makeCATdb(myfile="data/GO/GOannotationsBiomart_mod.txt", lib=NULL, org="", colno=c(1,2,3), idconv=list(affy=affy2locusDF))
# systemPipeR:::.AffyID2GeneID(catdb=catdb_conv, affyIDs=c("244901_at", "244902_at"))

## Constructor function to generate catDB object
makeCATdb <- function(myfile, lib = NULL, org = "", colno = c(1, 2, 3), idconv = NULL, rootUK = FALSE) {
    if (!is.null(lib) & !is.null(myfile)) stop("Arguments myfile and lib are exclusive. One of them needs to be assigned NULL.")
    if (!is.null(lib)) {
        catdf <- .sampleDFgene2GO(lib = lib)
    }
    if (!is.null(myfile)) {
        catdf <- .readGOorg(myfile = myfile, org = org, colno = colno)
    }
    catlist <- .gene2GOlist(catdf = catdf, rootUK = rootUK)
    catdblist <- c(catmap = list(catdf), catlist = list(catlist), idconv = list(idconv))
    catdb <- as(catdblist, "catDB")
    return(catdb)
}
## Usage:
# catdb <- makeCATdb(myfile="data/GO/GOannotationsBiomart_mod.txt", lib=NULL, org="", colno=c(1,2,3), idconv=NULL)
# catdb <- makeCATdb(myfile=NULL, lib="ath1121501.db", org="", colno=c(1,2,3), idconv=NULL)
# save(catdb, file="data/GO/catdb.RData")
# load("data/GO/catdb.RData")

######################################################################################################
### GOHyperGAll: Global Hypergeometric Test Using Custom Gene-to-GO Mappings Plus GO Slim Analysis ###
######################################################################################################
## Utility: To test a sample population of genes for over-representation of GO terms, the
## function 'GOHyperGAll' computes for all GO nodes a hypergeometric distribution test and
## returns the corresponding raw and Bonferroni corrected p-values. A subsequent filter function
## performs a GO Slim analysis using default or custom GO Slim categories.
## The associated publication is available in Plant Physiol (2008) 147, 41-57.
## Note: GOHyperGAll provides similar utilities as the GOHyperG function in the GOstats package
## from BioConductor. The main difference is that GOHyperGAll simplifies the usage of custom
## chip-to-gene and gene-to-GO mappings.
##
## How it works:
## (A) Generate the required data objects (slow, but needs to be done only once)
## (B) Define GOhyperG_All function
## (C) Subsetting and plotting of results by assigned nodes or goSlim categories

############################
## (B) GOhyperG_All function
############################
## (B.1) Define GOhyperG_All function
GOHyperGAll <- function(catdb, gocat = "MF", sample, Nannot = 2) {
    ## go_df containing the commonly used components for all GO nodes: GOID, GO Term and Ontology Type. This step is only required if "go_df" hasn't been imported with the above load() function.
    go_df <- catmap(catdb)$GO_DF
    ## (m): Obtain for every node in GO tree their number of associated genes or chip features
    if (gocat == "MF") {
        node_list <- catlist(catdb)$L_MF
    }
    if (gocat == "BP") {
        node_list <- catlist(catdb)$L_BP
    }
    if (gocat == "CC") {
        node_list <- catlist(catdb)$L_CC
    }
    node_stats_df <- data.frame(NodeSize = sapply(node_list, length))
    node_stats_df <- data.frame(GOID = row.names(node_stats_df), node_stats_df)
    row.names(node_stats_df) <- 1:length(node_stats_df[, 1])
    m <- as.vector(node_stats_df$NodeSize)
    ## (x): Obtain for every node in GO tree the number of matching genes in sample set
    node_sample_stats <- sapply(node_list, function(x) {
        sum(unlist(x) %in% sample)
    })
    node_sample_stats <- as.vector(node_sample_stats)
    x <- node_sample_stats
    ## (n): Obtain the number of unique genes at GO nodes with direct annotations
    if (gocat == "MF") {
        GO_DF <- catmap(catdb)$D_MF
    }
    if (gocat == "BP") {
        GO_DF <- catmap(catdb)$D_BP
    }
    if (gocat == "CC") {
        GO_DF <- catmap(catdb)$D_CC
    }
    n <- length(unique(GO_DF[, 2]))

    ## (k): Obtain number of unique genes in test sample that have GO mappings
    k <- length(unique(GO_DF[GO_DF[, 2] %in% sample, 2]))

    ## Obtain gene/chip keys matching at GO nodes
    match_key <- sapply(node_list, function(x) {
        x[unlist(x) %in% sample]
    })
    match_key <- sapply(match_key, function(x) {
        paste(x, collapse = " ")
    })
    match_key <- as.vector(match_key)
    key <- match_key
    key[key == ""] <- "NA"
    ## Apply phyper function
    phyp_v <- phyper(x - 1, m, n - m, k, lower.tail = FALSE)
    ## P-value correction according to Bioinformatics, 20, 3710-3715
    Ncorrect <- table(GO_DF[GO_DF$GeneID %in% sample, 1]) # Obtain the GO nodes with direct annotations from sample set
    Ncorrect <- sum(Ncorrect >= Nannot) # Count only those that have 2 or more annotations from sample set
    if (Ncorrect <= 1) {
        adj_phyp_v <- phyp_v # no adjustment necessary if Ncorrect <= 1
    } else {
        adj_phyp_v <- phyp_v * Ncorrect # Calculates simple Bonferroni correction.
        adj_phyp_v[adj_phyp_v >= 1] <- 1
        # adj_phyp_v <- sapply(phyp_v, p.adjust, method=Padj, n = Ncorrect) # Runs p.adjust(). This is disabled because most adjustment methods require that the length of the p-value vector is >= n.
    }
    ## Generate output data format
    result_df <- data.frame(node_stats_df, SampleMatch = x, Phyper = phyp_v, Padj = adj_phyp_v, SampleKeys = key)
    result_df <- merge(result_df, go_df, x.by = "GOID", y.by = "GOID", all.x = TRUE)
    result_df <- result_df[order(result_df$Phyper), ]
    result_df <- result_df[, c(1:5, 7:8, 6)]
    return(result_df)
}
# test_sample <- unique(as.character(catmap(catdb)$D_MF[1:100,"GeneID"]))
# GOHyperGAll(catdb=catdb, gocat="MF", sample=test_sample, Nannot=2)[1:20,]

####################################################################################
## (C) Subsetting of results from GOHyperGAll by assigned nodes or goSlim categories
####################################################################################
## (C.1) Define subsetting function
GOHyperGAll_Subset <- function(catdb, GOHyperGAll_result, sample = test_sample, type = "goSlim", myslimv) { # type: "goSlim" or "assigned"; optional argument "myslimv" to privde custom goSlim vector
    ## global functions or variables
    test_sample <- NULL
    if (type == "goSlim") {
        if (missing(myslimv)) {
            slimv <- c("GO:0003674", "GO:0008150", "GO:0005575", "GO:0030246", "GO:0008289", "GO:0003676", "GO:0000166", "GO:0019825", "GO:0005515", "GO:0003824", "GO:0030234", "GO:0003774", "GO:0004871", "GO:0005198", "GO:0030528", "GO:0045182", "GO:0005215", "GO:0006519", "GO:0007154", "GO:0016043", "GO:0006412", "GO:0006464", "GO:0006810", "GO:0007275", "GO:0007049", "GO:0005975", "GO:0006629", "GO:0006139", "GO:0019748", "GO:0015979", "GO:0005618", "GO:0005829", "GO:0005783", "GO:0005768", "GO:0005794", "GO:0005739", "GO:0005777", "GO:0009536", "GO:0005840", "GO:0005773", "GO:0005764", "GO:0005856", "GO:0005634", "GO:0005886", "GO:0005576") # contains new unknown terms: "GO:0003674", "GO:0008150", "GO:0005575"
            # slimv <- c("GO:0005554", "GO:0000004", "GO:0008372", "GO:0030246","GO:0008289","GO:0003676","GO:0000166","GO:0019825","GO:0005515","GO:0003824","GO:0030234","GO:0003774","GO:0004871","GO:0005198","GO:0030528","GO:0045182","GO:0005215","GO:0006519","GO:0007154","GO:0016043","GO:0006412","GO:0006464","GO:0006810","GO:0007275","GO:0007049","GO:0005975","GO:0006629","GO:0006139","GO:0019748","GO:0015979","GO:0005618","GO:0005829","GO:0005783","GO:0005768","GO:0005794","GO:0005739","GO:0005777","GO:0009536","GO:0005840","GO:0005773","GO:0005764","GO:0005856","GO:0005634","GO:0005886","GO:0005576") # contains old unknown terms: "GO:0005554", "GO:0000004", "GO:0008372"
        } else {
            slimv <- myslimv
        }
        GOHyperGAll_subset <- GOHyperGAll_result[GOHyperGAll_result[, 1] %in% slimv, ]
    }
    if (type == "assigned") {
        ## Import required data frames
        GO_MF_DF <- catmap(catdb)$D_MF
        GO_BP_DF <- catmap(catdb)$D_BP
        GO_CC_DF <- catmap(catdb)$D_CC
        termGO <- c(
            as.vector(GO_MF_DF[GO_MF_DF$GeneID %in% sample, 1]),
            as.vector(GO_BP_DF[GO_BP_DF$GeneID %in% sample, 1]),
            as.vector(GO_CC_DF[GO_CC_DF$GeneID %in% sample, 1])
        )
        subset_v <- unique(termGO)
        GOHyperGAll_subset <- GOHyperGAll_result[GOHyperGAll_result[, 1] %in% subset_v, ]
    }
    GOHyperGAll_subset
}
## Usage:
# GOHyperGAll_result <- GOHyperGAll(catdb=catdb, gocat="MF", sample=test_sample, Nannot=2)
# GOHyperGAll_Subset(catdb, GOHyperGAll_result, sample=test_sample, type="goSlim")

#########################################################
## (D) Reduce GO Term Redundancy in 'GOHyperGAll_results'
#########################################################
## (D.1) The function 'GOHyperGAll_Simplify' subsets the data frame 'GOHyperGAll_result' by a user
## specified adjusted p-value cutoff and removes from it all GO nodes with overlapping children sets
## (OFFSPRING). Only the best scoring nodes remain in the data frame.
## The argument 'correct' is experimental. It aims to favor the selection of distal (information rich)
## GO terms that have at the same time a large number of sample matches. The following calculation is used
## for this adjustment: phyper x Number_of_children / SampleMatch
## Define GOHyperGAll_Simplify()
GOHyperGAll_Simplify <- function(GOHyperGAll_result, gocat = "MF", cutoff = 0.001, correct = TRUE) { # gocat: "MF", "BP" or "CC"; cutoff: p-value cutoff; correct: TRUE or FALSE
    if (gocat != as.vector(GOHyperGAll_result$Ont[!is.na(GOHyperGAll_result$Ont)])[1]) {
        stop("The GO categories in GOHyperGAll_Simplify() and GOHyperGAll_result need to match")
    }
    checkPkg("GO.db", quietly = FALSE)
    testDF <- GOHyperGAll_result[GOHyperGAll_result$Padj <= cutoff, ]
    testDF <- data.frame(testDF, test = rep(0, times = length(testDF[, 1])))
    testDF <- testDF[!is.na(testDF$Ont), ]
    GO_OL_Matchv <- GOIDv <- NULL
    while (sum(testDF$test == 0) > 0) {
        clusterv <- NULL
        test <- as.vector(testDF[, 1])
        for (j in 1:length(test)) {
            if (gocat == "MF") {
                mymatch <- sum(unique(na.omit(c(test[j], as.list(GO.db::GOMFOFFSPRING)[[test[j]]])) %in% na.omit(c(test[1], as.list(GO.db::GOMFOFFSPRING)[[test[1]]]))))
                if (mymatch == 1) {
                    mymatch <- length(as.list(GO.db::GOMFOFFSPRING)[[test[j]]])
                }
            }
            if (gocat == "BP") {
                mymatch <- sum(unique(na.omit(c(test[j], as.list(GO.db::GOBPOFFSPRING)[[test[j]]])) %in% na.omit(c(test[1], as.list(GO.db::GOBPOFFSPRING)[[test[1]]]))))
                if (mymatch == 1) {
                    mymatch <- length(as.list(GO.db::GOBPOFFSPRING)[[test[j]]])
                }
            }
            if (gocat == "CC") {
                mymatch <- sum(unique(na.omit(c(test[j], as.list(GO.db::GOCCOFFSPRING)[[test[j]]])) %in% na.omit(c(test[1], as.list(GO.db::GOCCOFFSPRING)[[test[1]]]))))
                if (mymatch == 1) {
                    mymatch <- length(as.list(GO.db::GOCCOFFSPRING)[[test[j]]])
                }
            }
            clusterv <- c(clusterv, mymatch)
        }
        clusterv[clusterv == 0] <- NA
        testDF <- data.frame(testDF[, -9], test = clusterv)
        if (correct == TRUE) {
            testDF <- data.frame(testDF, decide = testDF$Padj * (testDF$test / testDF$SampleMatch))
        } else {
            testDF <- data.frame(testDF, decide = testDF$Padj)
        }
        GOIDv <- c(GOIDv, as.vector(testDF[order(testDF[, 10]), ][1, 1]))
        GO_OL_Matchv <- c(GO_OL_Matchv, length(unique(unlist(strsplit(as.vector(testDF[!is.na(testDF$test), 8]), " ")))))
        testDF <- testDF[is.na(testDF$test), ]
        testDF <- testDF[order(testDF[, 5]), -c(9, 10)]
        testDF <- data.frame(testDF, test = rep(0, times = length(testDF[, 1])))
        cat(GOIDv, "\n")
    }
    simplifyDF <- data.frame(GOID = GOIDv, GO_OL_Match = GO_OL_Matchv)
    simplifyDF
}

## Apply GOHyperGAll_Simplify
## simplifyDF <- GOHyperGAll_Simplify(GOHyperGAll_result, gocat="MF", cutoff=0.001, correct=TRUE)
## data.frame(GOHyperGAll_result[GOHyperGAll_result[,1] %in% simplifyDF[,1], -8], GO_OL_Match=simplifyDF[,2])

########################################
## (D.2) Batch Analysis of Gene Clusters
########################################
## The function 'GOCluster_Report' performs the three GO analyses in batch mode: 'GOHyperGAll',
## 'GOHyperGAll_Subset' or 'GOHyperGAll_Simplify'. It processes many groups of genes (e.g.
## gene expression clusters) and organizes the results in a single data frame.

GOCluster_Report <- function(catdb, setlist, id_type = "affy", method = "all", CLSZ = 10, cutoff = 0.001, gocats = c("MF", "BP", "CC"), myslimv = "default", correct = TRUE, recordSpecGO = NULL, ...) { # CLSZ: minimum cluster size; method: "all", "slim" or "simplify"; gocat: "MF", "BP" or "CC"; cutoff: adjusted p-value cutoff; recordSpecGO: argument to include one specific GOID in each of the 3 ontologies, e.g: recordSpecGO=c("GO:0003674", "GO:0008150", "GO:0005575")
    CL_DF <- data.frame(geneID = unlist(setlist), CLID = rep(names(setlist), sapply(setlist, length)), ClusterSize = rep(sapply(setlist, length), sapply(setlist, length)))
    cluster_loop <- unique(as.vector(CL_DF[CL_DF[, 3] >= CLSZ, 2]))
    # Next step included for historical reasons
    if (all(gsub("(^CL).*", "\\1", cluster_loop) == "CL") & all(!is.na(suppressWarnings(as.numeric(gsub("^CL", "", cluster_loop)))))) {
        cluster_loop <- paste("CL", sort(as.numeric(gsub("CL", "", as.character(cluster_loop)))), sep = "")
    }
    if (method == "all") {
        containerDF <- data.frame(CLID = NULL, CLSZ = NULL, GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL)
        for (i in cluster_loop) {
            cat("\n", "Processing cluster no", i, "with method: \"all\" (GOHyperGAll) \n")
            if (id_type == "affy") {
                affy_sample <- CL_DF[CL_DF[, 2] == i, 1]
                test_sample <- .AffyID2GeneID(catdb = catdb, affyIDs = affy_sample, probe2gene = 1)
            }
            if (id_type == "gene") {
                test_sample <- as.vector(CL_DF[CL_DF[, 2] == i, 1])
            }
            containerDF2 <- data.frame(GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL)
            count <- 0
            for (j in gocats) {
                count <- count + 1
                GOHyperGAll_result <- GOHyperGAll(catdb = catdb, gocat = j, sample = test_sample, ...)
                tempDF <- GOHyperGAll_result[GOHyperGAll_result$Padj <= cutoff, ]
                if (length(tempDF[, 1]) == 0) { # If filter returns empty data frame, then include at least the first two best scoring GO entries
                    tempDF <- GOHyperGAll_result[1:2, ]
                }
                containerDF2 <- rbind(containerDF2, tempDF)
                if (length(recordSpecGO) > 0) {
                    containerDF2 <- rbind(containerDF2, GOHyperGAll_result[GOHyperGAll_result[, 1] == recordSpecGO[count], ])
                }
                no_annot <- test_sample[!test_sample %in% eval(parse(text = paste("catmap(catdb)$D_", j, sep = "")))[, 2]]
                no_annot <- no_annot[no_annot != "no_match"]
                containerDF2 <- rbind(containerDF2, data.frame(GOID = paste("no_annot_", j, sep = ""), NodeSize = NA, SampleMatch = length(no_annot), Phyper = NA, Padj = NA, Term = NA, Ont = j, SampleKeys = paste(no_annot, collapse = ", ")))
            }
            tempDF2 <- data.frame(CLID = rep(i, times = length(containerDF2[, 1])), CLSZ = rep(unique(as.vector(CL_DF[CL_DF[, 2] == i, 3])), times = length(containerDF2[, 1])), containerDF2)
            containerDF <- rbind(containerDF, tempDF2)
        }
        return(containerDF)
    }
    if (method == "slim") {
        containerDF <- data.frame(CLID = NULL, CLSZ = NULL, GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL)
        for (i in cluster_loop) {
            cat("\n", "Processing cluster no", i, "with method: \"slim\" (GOHyperGAll_Subset) \n")
            if (id_type == "affy") {
                affy_sample <- CL_DF[CL_DF[, 2] == i, 1]
                test_sample <- .AffyID2GeneID(catdb = catdb, affyIDs = affy_sample, probe2gene = 1)
            }
            if (id_type == "gene") {
                test_sample <- as.vector(CL_DF[CL_DF[, 2] == i, 1])
            }
            containerDF2 <- data.frame(GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL)
            count <- 0
            for (j in gocats) {
                count <- count + 1
                GOHyperGAll_result <- GOHyperGAll(catdb, gocat = j, sample = test_sample, ...)
                if (any(myslimv == "default")) {
                    slimv <- c("GO:0003674", "GO:0008150", "GO:0005575", "GO:0030246", "GO:0008289", "GO:0003676", "GO:0000166", "GO:0019825", "GO:0005515", "GO:0003824", "GO:0030234", "GO:0003774", "GO:0004871", "GO:0005198", "GO:0030528", "GO:0045182", "GO:0005215", "GO:0006519", "GO:0007154", "GO:0016043", "GO:0006412", "GO:0006464", "GO:0006810", "GO:0007275", "GO:0007049", "GO:0005975", "GO:0006629", "GO:0006139", "GO:0019748", "GO:0015979", "GO:0005618", "GO:0005829", "GO:0005783", "GO:0005768", "GO:0005794", "GO:0005739", "GO:0005777", "GO:0009536", "GO:0005840", "GO:0005773", "GO:0005764", "GO:0005856", "GO:0005634", "GO:0005886", "GO:0005576") # contains new unknown terms: "GO:0003674", "GO:0008150", "GO:0005575"
                } else {
                    slimv <- myslimv
                }
                tempDF <- GOHyperGAll_Subset(catdb, GOHyperGAll_result, sample = test_sample, type = "goSlim", myslimv = slimv)
                containerDF2 <- rbind(containerDF2, tempDF)
                if (length(recordSpecGO) > 0) {
                    containerDF2 <- rbind(containerDF2, GOHyperGAll_result[GOHyperGAll_result[, 1] == recordSpecGO[count], ])
                }
                no_annot <- test_sample[!test_sample %in% eval(parse(text = paste("catmap(catdb)$D_", j, sep = "")))[, 2]]
                no_annot <- no_annot[no_annot != "no_match"]
                containerDF2 <- rbind(containerDF2, data.frame(GOID = paste("no_annot_", j, sep = ""), NodeSize = NA, SampleMatch = length(no_annot), Phyper = NA, Padj = NA, Term = NA, Ont = j, SampleKeys = paste(no_annot, collapse = ", ")))
            }
            tempDF2 <- data.frame(CLID = rep(i, times = length(containerDF2[, 1])), CLSZ = rep(unique(as.vector(CL_DF[CL_DF[, 2] == i, 3])), times = length(containerDF2[, 1])), containerDF2)
            containerDF <- rbind(containerDF, tempDF2)
        }
        return(containerDF)
    }
    if (method == "simplify") {
        containerDF <- data.frame(CLID = NULL, CLSZ = NULL, GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL, GO_OL_Match = NULL)
        for (i in cluster_loop) {
            cat("\n", "Processing cluster no", i, "with method: \"simplify\" (GOHyperGAll_Simplify) \n")
            if (id_type == "affy") {
                affy_sample <- CL_DF[CL_DF[, 2] == i, 1]
                test_sample <- .AffyID2GeneID(catdb = catdb, affyIDs = affy_sample, probe2gene = 1)
            }
            if (id_type == "gene") {
                test_sample <- as.vector(CL_DF[CL_DF[, 2] == i, 1])
            }
            containerDF2 <- data.frame(GOID = NULL, NodeSize = NULL, SampleMatch = NULL, Phyper = NULL, Padj = NULL, Term = NULL, Ont = NULL, SampleKeys = NULL, GO_OL_Match = NULL)
            count <- 0
            for (j in gocats) {
                count <- count + 1
                GOHyperGAll_result <- GOHyperGAll(catdb, gocat = j, sample = test_sample, ...)
                simplifyDF <- GOHyperGAll_Simplify(GOHyperGAll_result, gocat = j, cutoff = cutoff, correct = correct)
                if (length(simplifyDF) == 0) { # If simplifyDF() returns empty data frame, then include at least the first two best scoring GO entries
                    simplifyDF <- GOHyperGAll_Simplify(GOHyperGAll_result[1:2, ], gocat = j, cutoff = 1, correct = TRUE)
                }
                tempDF <- data.frame(GOHyperGAll_result[GOHyperGAll_result[, 1] %in% simplifyDF[, 1], ], GO_OL_Match = simplifyDF[, 2])
                containerDF2 <- rbind(containerDF2, tempDF)
                if (length(recordSpecGO) > 0) {
                    containerDF2 <- rbind(containerDF2, data.frame(GOHyperGAll_result[GOHyperGAll_result[, 1] == recordSpecGO[count], ], GO_OL_Match = GOHyperGAll_result[GOHyperGAll_result[, 1] == recordSpecGO[count], 3]))
                }
                no_annot <- test_sample[!test_sample %in% eval(parse(text = paste("catmap(catdb)$D_", j, sep = "")))[, 2]]
                no_annot <- no_annot[no_annot != "no_match"]
                containerDF2 <- rbind(containerDF2, data.frame(GOID = paste("no_annot_", j, sep = ""), NodeSize = NA, SampleMatch = length(no_annot), Phyper = NA, Padj = NA, Term = NA, Ont = j, SampleKeys = paste(no_annot, collapse = ", "), GO_OL_Match = length(no_annot)))
            }
            tempDF2 <- data.frame(CLID = rep(i, times = length(containerDF2[, 1])), CLSZ = rep(unique(as.vector(CL_DF[CL_DF[, 2] == i, 3])), times = length(containerDF2[, 1])), containerDF2)
            containerDF <- rbind(containerDF, tempDF2)
        }
        containerDF <- containerDF[, c(1:9, 11, 10)]
        return(containerDF)
    }
}

## Apply GOCluster_Report
# testlist <- list(Set1=test_sample)
# GOBatchResult <- GOCluster_Report(catdb=catdb, setlist=testlist, method="all", id_type="gene", CLSZ=10, cutoff=0.001, gocats=c("MF", "BP", "CC"), recordSpecGO=c("GO:0003674", "GO:0008150", "GO:0005575"))

######################
## (D.3) GO Barplot ##
######################
goBarplot <- function(GOBatchResult, gocat) {
    ## global functions or variables
    SampleMatch <- Sample <- Term <- NULL
    x <- GOBatchResult
    x <- x[, c("SampleMatch", "Term", "CLID", "Ont")]
    x <- x[x$Ont == gocat, 1:3]
    colnames(x)[grep("CLID", colnames(x))] <- "Sample"
    term <- as.character(x$Term)
    term[is.na(term)] <- "no GO assignment"
    x[, "Term"] <- term
    ontnames <- c(CC = "Cellular Component", BP = "Biological Process", MF = "Molecular Function")
    x[, 2] <- factor(x[, 2], levels = unique(x[, 2]), ordered = TRUE) # Defines plotting order of bars!!!
    p <- ggplot2::ggplot(x, ggplot2::aes(Term, SampleMatch, fill = Sample)) +
        ggplot2::geom_bar(position = "dodge", stat = "identity") +
        ggplot2::coord_flip() +
        ggplot2::theme(axis.text.y = ggplot2::element_text(angle = 0, hjust = 1)) +
        ggplot2::xlab("GO Term") +
        ggplot2::ylab("Gene Count") +
        ggplot2::ylim(0, max(x$SampleMatch)) +
        ggplot2::ggtitle(ontnames[gocat])
    print(p)
}
## Usage:
# goBarplot(GOBatchResult, gocat="MF")

#####################################
## Generic Definitions for SYSargs ##
#####################################
## Methods to return SYSargs components
setGeneric(name = "targetsin", def = function(x) standardGeneric("targetsin"))
setGeneric(name = "targetsout", def = function(x) standardGeneric("targetsout"))
setGeneric(name = "targetsheader", def = function(x, ...) standardGeneric("targetsheader"))
setGeneric(name = "modules", def = function(x) standardGeneric("modules"))
setGeneric(name = "software", def = function(x) standardGeneric("software"))
setGeneric(name = "cores", def = function(x) standardGeneric("cores"))
setGeneric(name = "other", def = function(x) standardGeneric("other"))
setGeneric(name = "reference", def = function(x) standardGeneric("reference"))
setGeneric(name = "results", def = function(x) standardGeneric("results"))
setGeneric(name = "infile1", def = function(x, ...) standardGeneric("infile1"))
setGeneric(name = "infile2", def = function(x, ...) standardGeneric("infile2"))
setGeneric(name = "outfile1", def = function(x) standardGeneric("outfile1"))
setGeneric(name = "SampleName", def = function(x, ...) standardGeneric("SampleName"))
setGeneric(name = "sysargs", def = function(x) standardGeneric("sysargs"))
setGeneric(name = "outpaths", def = function(x) standardGeneric("outpaths"))

######################################
## Generic Definitions for SYSargs2 ##
######################################
## Methods to return SYSargs2 components
setGeneric(name = "targets", def = function(x) standardGeneric("targets"))
setGeneric(name = "wf", def = function(x) standardGeneric("wf"))
setGeneric(name = "clt", def = function(x) standardGeneric("clt"))
setGeneric(name = "yamlinput", def = function(x, ...) standardGeneric("yamlinput"))
setGeneric(name = "cmdlist", def = function(x, ...) standardGeneric("cmdlist"))
setGeneric(name = "input", def = function(x) standardGeneric("input"))
setGeneric(name = "output", def = function(x) standardGeneric("output"))
setGeneric(name = "files", def = function(x) standardGeneric("files"))
setGeneric(name = "inputvars", def = function(x) standardGeneric("inputvars"))
setGeneric(name = "cmdToCwl", def = function(x) standardGeneric("cmdToCwl"))
setGeneric(name = "status", def = function(x) standardGeneric("status"))
## Coerce
setGeneric(name = "sysargs2", def = function(x) standardGeneric("sysargs2"))
## Accessors
setGeneric(name = "baseCommand", def = function(x, ...) standardGeneric("baseCommand"))
## Replacement methods
setGeneric(name = "yamlinput<-", def = function(x, paramName, ..., value) standardGeneric("yamlinput<-"))
setGeneric(name = "cmdToCwl<-", def = function(x, ..., value) standardGeneric("cmdToCwl<-"))

#########################################
## Generic Definitions for SYSargsList ##
#########################################
## Methods to return SYSargsList components
setGeneric(name = "stepsWF", def = function(x) standardGeneric("stepsWF"))
setGeneric(name = "statusWF", def = function(x) standardGeneric("statusWF"))
setGeneric(name = "targetsWF", def = function(x) standardGeneric("targetsWF"))
setGeneric(name = "outfiles", def = function(x) standardGeneric("outfiles"))
setGeneric(name = "SE", def = function(x, ...) standardGeneric("SE"))
setGeneric(name = "dependency", def = function(x) standardGeneric("dependency"))
setGeneric(name = "projectInfo", def = function(x) standardGeneric("projectInfo"))
setGeneric(name = "runInfo", def = function(x) standardGeneric("runInfo"))
## Accessors
setGeneric(name = "stepName", def = function(x) standardGeneric("stepName"))
setGeneric(name = "getColumn", def = function(x, step, position = c("outfiles", "targetsWF"), column = 1, names = SampleName(x, step)) standardGeneric("getColumn"))
setGeneric(name = "addResources", def = function(x, step, resources) standardGeneric("addResources"))
setGeneric(name = "viewEnvir", def = function(x, silent = FALSE) standardGeneric("viewEnvir"))
setGeneric(name = "copyEnvir", def = function(x, list = character(), new.env = globalenv(), silent = FALSE) standardGeneric("copyEnvir"))
## Coerce back to list: as(SYSargsList, "list")
setGeneric(name = "sysargslist", def = function(x) standardGeneric("sysargslist"))
## Replacement methods
setGeneric(name = "updateColumn<-", def = function(x, step, position = c("outfiles", "targetsWF"), value) standardGeneric("updateColumn<-"))
setGeneric(name = "appendStep<-", def = function(x, after = length(x), ..., value) standardGeneric("appendStep<-"))
setGeneric(name = "replaceStep<-", def = function(x, step, step_name = "default", value) standardGeneric("replaceStep<-"))
setGeneric(name = "stepsWF<-", def = function(x, step, ..., value) standardGeneric("stepsWF<-"))
setGeneric(name = "renameStep<-", def = function(x, step, ..., value) standardGeneric("renameStep<-"))
setGeneric(name = "statusWF<-", def = function(x, step, ..., value) standardGeneric("statusWF<-"))
setGeneric(name = "dependency<-", def = function(x, step, ..., value) standardGeneric("dependency<-"))
setGeneric(name = "updateStatus<-", def = function(x, step, ..., value) standardGeneric("updateStatus<-"))
setGeneric(name = "runInfo<-", def = function(x, step, param, ..., value) standardGeneric("runInfo<-"))
setGeneric(name = "SE<-", def = function(x, step, ..., value) standardGeneric("SE<-"))

######################################
## Generic Definitions for LineWise ##
######################################
## Methods to return LineWise components
setGeneric(name = "codeLine", def = function(x, ...) standardGeneric("codeLine"))
setGeneric(name = "rmdPath", def = function(x) standardGeneric("rmdPath"))
setGeneric(name = "codeChunkStart", def = function(x) standardGeneric("codeChunkStart"))
## Coerce back to list: as(LineWise, "list")
setGeneric(name = "linewise", def = function(x) standardGeneric("linewise"))
## Replacement methods
setGeneric(name = "replaceCodeLine<-", def = function(x, line, ..., value) standardGeneric("replaceCodeLine<-"))
setGeneric(name = "appendCodeLine<-", def = function(x, after = length(x), ..., value) standardGeneric("appendCodeLine<-"))

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()
options(width=80, max.print=1000)
knitr::opts_chunk$set(
    eval=as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache=as.logical(Sys.getenv("KNITR_CACHE", "TRUE")), 
    tidy.opts=list(width.cutoff=80), tidy=TRUE)

## ----setup, echo=FALSE, messages=FALSE, warnings=FALSE------------------------
suppressPackageStartupMessages({
    library(systemPipeR)
})

#################################################################
## Functions to construct SYSargs2 objects and other utilities ##
################################################################

###################
## Load Workflow ##
###################
loadWorkflow <- function(targets = NULL, wf_file, input_file, dir_path = "param/cwl", id = "SampleName") {
    if (is.null(dir_path)) {
        dir_path <- ""
        cwlfiles <- list(
            cwl = wf_file,
            yml = input_file,
            dir_path = NA
        )
    } else if (!is.null(dir_path)) {
        cwlfiles <- list(
            cwl = wf_file,
            yml = input_file,
            dir_path = normalizePath(dir_path)
        )
    } else {
        stopifnot(is.character(dir_path))
    }
    if (any(inherits(wf_file, "list"))) {
        wf <- wf_file
    } else {
        if (!file.exists(file.path(dir_path, wf_file)) == TRUE) stop("Provide valid '.cwl' file. Check the file PATH.")
        wf <- yaml::read_yaml(file.path(dir_path, wf_file))
    }
    if (any(inherits(input_file, "list"))) {
        input <- input_file
    } else {
        if (!file.exists(file.path(dir_path, input_file)) == TRUE) stop("Provide valid 'files.'.yml' file. Check the file PATH.")
        input <- yaml::read_yaml(file.path(dir_path, input_file))
    }
    modules <- input$ModulesToLoad
    if (is.null(modules)) modules <- list()
    inputvars <- list()
    if (tolower(wf$class) == "workflow") {
        steps <- names(wf$steps)
        cwlfiles$steps <- steps
        cltpaths <- sapply(seq_along(steps), function(x) file.path(dir_path, wf$steps[[steps[x]]]$run))
        names(cltpaths) <- strsplit(basename(cltpaths), ".cwl")
        cwlfiles$cltpaths <- cltpaths
        cltlist <- sapply(cltpaths, function(x) yaml::read_yaml(file.path(x)), simplify = FALSE)
        names(cltlist) <- sapply(seq_along(steps), function(x) wf$steps[[steps[x]]]$run)
        cmdlist <- sapply(names(cltlist), function(x) list(NULL))
        myinput <- sapply(names(cltlist), function(x) list(NULL))
        myoutput <- sapply(names(cltlist), function(x) list(NULL))
        cwlfiles$output_names <- sapply(names(cltlist), function(x) names(cltlist[[x]]$outputs))
        WF <- list(
            modules = modules, wf = wf, clt = cltlist, yamlinput = input, cmdlist = cmdlist,
            input = myinput, output = myoutput, files = cwlfiles, inputvars = inputvars,
            cmdToCwl = list(), status = list(), internal_outfiles = list()
        )
    } else if (tolower(wf$class) == "commandlinetool") {
        cltlist <- list(wf)
        names(cltlist) <- basename(wf_file)
        cmdlist <- sapply(names(cltlist), function(x) list(NULL))
        myinput <- sapply(names(cltlist), function(x) list(NULL))
        myoutput <- sapply(names(cltlist), function(x) list(NULL))
        cwlfiles$steps <- strsplit(basename(wf_file), ".cwl")[[1]]
        cwlfiles$output_names <- names(cltlist[[1]]$outputs)
        WF <- list(
            modules = modules, wf = list(), clt = cltlist, yamlinput = input, cmdlist = cmdlist,
            input = myinput, output = myoutput, files = cwlfiles, inputvars = inputvars,
            cmdToCwl = list(), status = list(), internal_outfiles = list()
        )
    } else {
        stop("Class slot in '<wf_file>.cwl' needs to be 'Workflow' or 'CommandLineTool'.")
    }
    if (!is.null(targets)) {
        if (inherits(targets, "SummarizedExperiment")) {
            mytargets <- as.data.frame(SummarizedExperiment::colData(targets))
            mytargets <- targets.as.list(mytargets, id)
            targetsheader <- S4Vectors::metadata(targets)
            WF$files["id"] <- id
            WF <- c(list(targets = mytargets, targetsheader = targetsheader), WF)
        } else {
            if (!file.exists(file.path(targets)) == TRUE) stop("Provide valid 'targets' file. Check the file PATH.")
            ext <- strsplit(basename(targets), split = "\\.")[[1]]
            ext <- ext[[-1]]
            if ("txt" %in% ext) {
                mytargets <- read.delim(normalizePath(file.path(targets)), comment.char = "#")
                mytargets <- targets.as.list(mytargets, id)
            } else if (any(c("yml", "yaml") %in% ext)) {
                mytargets <- yaml::read_yaml(targets)
            }
            targetsheader <- readLines(normalizePath(file.path(targets)))
            targetsheader <- targetsheader[grepl("^#", targetsheader)]
            WF$files["targets"] <- file.path(targets)
            WF$files["id"] <- id
            WF <- c(list(targets = mytargets, targetsheader = list(targetsheader = targetsheader)), WF)
        }
    } else {
        WF$files["targets"] <- NA
        WF$files["id"] <- id
        WF <- c(list(targets = data.frame(), targetsheader = list()), WF)
    }
    return(as(WF, "SYSargs2"))
}

## Wrapper for loadWorkflow: Short and consistent name for the function
loadWF <- loadWorkflow

## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# dir_path <- system.file("extdata/cwl/hisat2", package="systemPipeR")
# WF <- loadWF(targets=targetspath, wf_file="hisat2-se/hisat2-mapping-se.cwl",
#              input_file="hisat2-se/hisat2-mapping-se.yml", dir_path=dir_path)

###############################################
## Render WF for all samples in targets slot ##
###############################################
renderWF <- function(WF, inputvars = NULL) {
    if (!is.null(inputvars)) {
        .checkInputVars(WF, inputvars)
    }
    if (any(length(cmdlist(WF)[[1]]) != 0)) stop("Argument 'WF' needs to be assigned an object of class 'SYSargs2' and an object created by the 'loadWorkflow' function")
    ids <- names(targets(WF))
    if (length(ids) == 0) ids <- "defaultid"
    bucket <- sapply(ids, function(x) "", simplify = FALSE)
    bucketlist <- list(cmd = bucket, input = bucket, output = bucket)
    for (i in ids) {
        tmplist <- .renderWFsingle(WF = WF, id = i, inputvars = inputvars)
        bucketlist[["cmd"]][[i]] <- tmplist[["cmd"]]
        bucketlist[["input"]][[i]] <- tmplist[["input"]]
        bucketlist[["output"]][[i]] <- tmplist[["output"]]
    }
    WF <- as(WF, "list")
    WF$cmdlist <- bucketlist$cmd
    WF$input <- bucketlist$input
    WF$output <- bucketlist$output
    WF$internal_outfiles <- bucketlist$output
    WF$inputvars <- tmplist$inputvars
    WF <- as(WF, "SYSargs2")
    WF[["status"]] <- .statusPending(WF)
    return(WF)
}

## Usage:
# WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))

###############################################################
## Update  WF container for all samples in targets slot  ##
###############################################################
updateWF <- function(WF, write.yaml = FALSE, name.yaml = "default", new_targets = NULL,
                     new_targetsheader = NULL, inputvars = NULL, silent = FALSE) {
    if (!inherits(WF, "SYSargs2")) stop("WF needs to be object of class 'SYSargs2'.")
    WF <- sysargs2(WF)
    if (is.null(inputvars)) {
        WF$inputvars <- inputvars <- WF$inputvars
    } else {
        WF$inputvars <- inputvars
    }
    if (length(WF$cmdToCwl) > 1) {
        cwlVersion <- WF$clt[[1]]$cwlVersion
        class <- WF$clt[[1]]$class
        module_load <- WF$yamlinput$ModulesToLoad[[1]]
        results_path <- WF$yamlinput$results_path$path
        WF$clt <- write.clt(WF$cmdToCwl, cwlVersion = cwlVersion, class = class, writeout = FALSE, silent = silent)
        WF$yamlinput <- write.yml(WF$cmdToCwl, results_path = results_path, module_load = module_load, writeout = FALSE, silent = silent)
    } else if (length(WF$cmdToCwl) == 0) {
        ## targets
        if (!is.null(new_targets)) {
            WF$targets <- new_targets
        } else {
            WF$targets <- WF$targets
        }
        ## targetsheader
        if (!is.null(new_targetsheader)) {
            WF$targetsheader <- new_targetsheader
        } else {
            WF$targetsheader <- WF$targetsheader
        }

        WF$yamlinput <- WF$yamlinput
        WF$clt <- WF$clt
        results_path <- WF$yamlinput$results_path$path
    }
    WF$input <- WF$output <- WF$cmdlist <- sapply(names(WF$clt), function(x) list(NULL))
    ## write the new yaml
    if (write.yaml == TRUE) {
        if (name.yaml == "default") {
            path <- .getPath(WF$files$yml)
            name <- paste0(
                .getFileName(WF$files$yml),
                format(Sys.time(), "%b%d%Y_%H%M"), ".yml"
            )
            name.yaml <- file.path(path, name)
        } else {
            name.yaml <- name.yaml
        }
        yaml::write_yaml(WF$yamlinput, name.yaml)
        if (silent != TRUE) {
            cat(
                "\t", "Written content of 'yamlinput(x)' to file:", "\n",
                name.yaml, "\n"
            )
        }
        WF$files$yml <- name.yaml
    }
    WF <- as(WF, "SYSargs2")
    WF <- renderWF(WF, inputvars = inputvars)
    ## Update status slot
    WF[["status"]] <- .statusPending(WF)
    return(WF)
}

## Usage:
# yamlinput(WF, "thread")  <- 6L
# WF <- updateWF(WF, write.yaml = TRUE)
# cmdlist(WF)[1]
# yamlinput(WF)$thread

##################################################
## check outfiles: if the expected files exist ##
##################################################
check.output <- function(sysargs, type = "data.frame") {
    ## Check the class and slot
    if (inherits(sysargs, c("SYSargs2"))) {
        return(.check.output.sysargs2(sysargs, type = type))
    } else if (inherits(sysargs, c("SYSargsList"))) {
        steps <- sapply(names(stepsWF(sysargs)), function(x) list(NULL))
        sysargs_names <- unlist(lapply(stepsWF(sysargs), function(x) which(inherits(x, c("SYSargs2")))))
        sysargs <- sysargs[names(sysargs_names)]
        for (i in names(sysargs_names)) {
            step.dir <- sysargs$runInfo$runOption[[i]]$directory
            steps[[i]] <- .check.output.sysargs2(stepsWF(sysargs)[[i]],
                type = type,
                step.name = i, step.dir = step.dir
            )
        }
        return(steps)
    } else {
        stop("sysargs needs to be object of class 'SYSargs2' or 'SYSargsList'.")
    }
}

## Usage:
# check.output(WF)

## check.outfiles alias
check.outfiles <- check.output

##################################
## Unexported helper functions ##
##################################

######################
## .checkInputVars ##
######################
.checkInputVars <- function(WF, inputvars) {
    inputvars <- unlist(inputvars)
    if (length(WF$targets) != 0) {
        targets <- colnames(targets.as.df(WF$targets))
        if (!all(names(inputvars) %in% targets)) {
            stop("names of the inputvars are not matching with targets colnames.", "\n",
                "Names available are:", "\n",
                paste(targets, collapse = " | "),
                call. = FALSE
            )
        }
    }
    if (any(duplicated(names(inputvars)))) warning("names of the inputvars are duplicated. Please continue with attention! This object can not be resumed in a later occasion.")
    input <- unlist(WF$yamlinput)
    if (!all(inputvars %in% input)) {
        stop(
            "inputvars elements are not matching with input variables. ", "\n",
            "To check variable names, please see:", "\n",
            file.path(WF$files$dir_path, WF$files$yml),
            call. = FALSE
        )
    }
}
## Usage:
# targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
# dir_path <- system.file("extdata/cwl/hisat2", package="systemPipeR")
# WF <- loadWF(targets=targetspath, wf_file="hisat2-se/hisat2-mapping-se.cwl",
#              input_file="hisat2-se/hisat2-mapping-se.yml", dir_path=dir_path)
# WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName2_")) # will return error

##############################################
## Resolve CWL variable-based path instance ##
##############################################
pathInstance <- function(pathvar, input, altinput) {
    pathvar <- unlist(strsplit(pathvar[[1]], "/"))
    extension <- gsub("^.*\\)", "", pathvar)
    if (grepl(".\\$\\(", pathvar[length(pathvar)])) {
        ext <- sub("\\)", "", sub(".*[$\\(]", "", pathvar[length(pathvar)]))
        ext <- strsplit(ext, "\\.")[[1]]
        ext <- ext[length(ext)]
        ext <- input[[ext]]
        extension <- c("", paste0(".", ext))
        pathvar <- sub(".\\$\\(.*", "", pathvar)
    }
    pathvar <- gsub("(^.*\\)).*", "\\1", pathvar)
    pathvar <- gsub("\\$|\\(|\\)", "", pathvar)
    pathvarlist <- strsplit(pathvar, "\\.")
    filenametype <- lapply(seq_along(pathvarlist), function(x) pathvarlist[[x]][pathvarlist[[x]] %in% c("basename", "nameroot", "path")])
    filenametype <- unlist(lapply(filenametype, function(x) ifelse(length(x) == 0, NA, x)))
    filenametype <- ifelse(is.na(filenametype), "NA", filenametype)
    myvalue_list <- sapply((pathvarlist), function(x) list(NULL), simplify = FALSE)
    for (i in seq_along(pathvarlist)) {
        myvalue <- NULL
        for (j in seq_along(pathvarlist[[i]])) {
            myvalue_input <- input[[pathvarlist[[i]][[j]]]]
            if ("class" %in% names(myvalue_input)) myvalue_input$class <- NULL
            if (!is.null(myvalue_input)) {
                myvalue <- c(myvalue, list(myvalue_input))
            }
        }
        myvalue_list[i] <- myvalue
    }
    ## Use altinput if no values were assigned by input
    if (all(sapply(myvalue_list, length) == 0)) {
        myvalue_list <- sapply(seq_along(pathvarlist), function(x) altinput[[pathvarlist[[x]][[2]]]]$default, simplify = FALSE)
    }
    enforce_list <- length(myvalue_list) == 1
    if (any(enforce_list)) for (i in which(enforce_list)) myvalue_list[[i]] <- list(class = NULL, path = myvalue_list[[i]])
    mypathvec <- list()
    for (i in seq_along(myvalue_list)) {
        for (j in seq_along(myvalue_list[[i]])) {
            vec_input <- myvalue_list[[i]][[j]]
            if (any(names(myvalue_list[[i]][[j]]) %in% c("path"))) {
                vec_input <- myvalue_list[[i]][[j]]$path
            }
            if (!is.null(vec_input)) {
                # # vec <- sapply(seq_along(filenametype), function(x) pathUtils(vec_input[x], type = filenametype[x]))
                vec <- sapply(seq_along(vec_input), function(x) pathUtils(vec_input[x], type = filenametype[i]))
                mypathvec <- c(mypathvec, list(vec))
            }
        }
        mypathvec <- lapply(mypathvec, function(x) x[!is.na(x)])
    }
    ## Assign '.' to 'runtime.outdir'
    pwdindex <- any(pathvar %in% c("runtime.outdir"))
    nullindex <- any(sapply(mypathvec, length) == 0)
    if (any(pwdindex & nullindex)) {
        mypathvec[pwdindex & nullindex] <- "."
    }
    mypathvec <- sapply(seq_along(mypathvec), function(x) {
        if (is.null(mypathvec[[x]])) {
            mypathvec[[x]] <- ""
        } else {
            mypathvec[[x]] <- mypathvec[[x]]
        }
    })
    ## Generate output
    if (length(mypathvec) == 1) {
        extension <- extension[!is.na(extension)]
        if (all("" %in% extension & length(extension) == 1)) {
            mypath <- paste(mypathvec)
        } else {
            extension <- extension[extension != ""]
            mypath <- paste(mypathvec, extension, sep = "/")
        }
    } else if (any(is.na(extension))) {
        mypath <- sapply(seq_along(mypathvec), function(x) paste0(mypathvec[x]))
    } else {
        mypath <- sapply(seq_along(mypathvec), function(x) paste0(mypathvec[x], extension[x]))
        if (length(mypathvec) < length(extension)) {
            extension <- extension[extension != ""]
            mypath <- c(mypath, extension)
        }
    }
    returnpath <- file.path(paste(mypath, collapse = "/"))
    return(returnpath)
}

# pathvar <- c("$(inputs.results_path.basename)","$(inputs.SampleName).$(inputs.ext)")
# pathvar <- c("$(inputs.results_path.basename)","$(inputs.SampleName).sam")
#################################################################
## Helper function to construct/manipulate path and file names ##
#################################################################
pathUtils <- function(x, type, dropdir = TRUE) {
    if (type == "dirname") {
        mypath <- dirname(x)
    } else if (type == "basename") {
        mypath <- basename(x)
    } else if (type == "nameroot") {
        mypath <- gsub("(^.*)\\..*$", "\\1", basename(x))
    } else if (type == "path") {
        mypath <- x
    } else if (type == "NA") {
        mypath <- x
    } else {
        mypath <- x # Return unchanged input if 'type' is not one the above three values
    }
    ## Construct output
    if (dropdir == TRUE) {
        return(mypath)
    } else if (dropdir == FALSE & type != "dirname") {
        return(file.path(dirname(x), mypath))
    } else {
        stop("Invalid path request, e.g. drop and appenrequest, e.g. drop and append dir.")
    }
}

#############################################
## Assemble Commandline Components in List ##
#############################################
assembleCommandlineList <- function(clt = WF$clt[[1]]) {
    ## global functions or variables
    WF <- NULL
    ## Base command and arguments
    basecommand <- clt$baseCommand
    arguments <- clt$arguments
    ## Special case for Rscript --  get the absolute path to the Rscript command
    if ("Rscript" %in% basecommand) {
        basecommand <- file.path(R.home("bin"), "Rscript")
    }
    if (!is.null(arguments)) {
        for (i in seq_along(arguments)) arguments[[i]][["position"]] <- ""
    }
    ## Inputs
    inputargs <- renderInputs(x = clt$inputs, returntags = list(inputBinding = c("prefix"), type = "any"))
    ## Outputs
    outputargs <- renderOutputs(x = clt$outputs, stdout = clt$stdout, returntags = list(outputBinding = c("prefix", "glob"), type = "any"))
    ## Assemble command-line
    arglist <- list(baseCommand = basecommand, arguments = arguments, inputs = inputargs, outputs = outputargs)
    return(arglist)
}

########################################
## Populate Variables in Command-line ##
########################################
populateCommandline <- function(WF, cltid, exclude = exclude, mmp) {
    ## Populate inputs
    cmdlist <- assembleCommandlineList(nameUnnamed(WF$clt[[cltid]]))
    yamlinput <- list(inputs = nameUnnamed(WF$yamlinput))
    cmdnames <- nestedNames(cmdlist)
    yamlnames <- nestedNames(yamlinput)
    ## Create yamlnames list without 'unnamed' tags if present
    yamlnamestmp <- sapply(names(yamlnames), function(x) yamlnames[[x]][!grepl("_\\d{1,}_", yamlnames[[x]])], simplify = FALSE)
    matchmap <- findBestMatch(x = cmdnames, y = yamlnamestmp, mmp, minmatch = 2)
    excludepos <- sapply(names(cmdnames), function(x) tail(cmdnames[[x]], 1) %in% exclude)
    removetype <- sapply(cmdnames, function(x) tail(x %in% "type", 1))
    for (i in seq_along(cmdnames)) {
        inputslice <- yamlnames[[matchmap[[i]]]]
        ## Inject yamlinput in corresponding cmdlist components
        if ((length(inputslice) > 0) & (excludepos[[i]]) != TRUE) {
            cmdlist <- injectListbyName(cmdlist, cmdnames[[i]], value = subsetListbyName(yamlinput, inputslice))
        }
        ## Eliminate type values (e.g. boolean/string) that are not associated with yamlinput
        if ((length(inputslice) == 0) & (excludepos[[i]] != TRUE & removetype[[i]] == TRUE)) {
            cmdlist <- injectListbyName(cmdlist, cmdnames[[i]], value = "")
        }
    }
    ## Populate variable path instances
    pos <- sapply(names(cmdnames), function(x) grepl("^\\$\\(", subsetListbyName(cmdlist, cmdnames[[x]])))
    if (any(pos)) {
        for (i in which(pos)) {
            mypath <- pathInstance(pathvar = subsetListbyName(cmdlist, cmdnames[[i]]), input = WF$yamlinput, altinput = nameUnnamed(WF$clt[[cltid]])$inputs)
            cmdlist <- injectListbyName(cmdlist, cmdnames[[i]], value = mypath)
        }
    }
    return(cmdlist)
}

####################################################################################
## Inject command-line lists from populateCommandline into cmdlist slot WF object ##
####################################################################################
injectCommandlinelist <- function(WF) {
    if (class(WF) == "SYSargs2") {
        WF <- as(WF, "list")
    } else {
        stop("WF needs to be object of class 'SYSargs2'.")
    }
    cmdsteps <- names(WF$cmdlist)
    mmp <- list(class = c("class", "type"), path = c("path", "type"))
    exclude <- c("baseCommand", "prefix")
    for (i in seq_along(cmdsteps)) {
        WF$cmdlist[[i]] <- populateCommandline(WF, cltid = cmdsteps[i], exclude = exclude, mmp)
    }
    ## Update inputs that depend on output of one of the previous steps
    .connectInout <- function(WF) {
        steps <- WF$wf$steps
        stepnames <- sapply(names(steps), function(x) steps[[x]]$run)
        connectedlist <- sapply(seq_along(steps), function(x) which(grepl("/", steps[[x]]$`in`)))
        names(connectedlist) <- names(steps)
        connectedlist <- connectedlist[sapply(connectedlist, length) > 0]
        if (length(connectedlist) > 0) {
            for (j in seq_along(connectedlist)) {
                connected <- connectedlist[j]
                ## Inner loop to support multiple connections
                for (i in seq_along(connected[[1]])) {
                    ## Generate output string from corresponding upstream step
                    connectednames <- strsplit(unlist(steps[[names(connected)]])[connected[[1]][i]], "/")
                    connectedstep <- stepnames[[connectednames[[1]][1]]]
                    connectedoutput <- WF$cmdlist[[connectedstep]]$outputs
                    connectedoutput <- unlist(connectedoutput[connectednames[[1]][[2]]])
                    ## Inject output string into input of corresponding downstream step
                    termname <- as.character(sapply(nestedNames(steps[[names(connected)]]), tail, 1)[connected[[1]][i]])
                    namepath <- c("cmdlist", stepnames[[names(connected)]], "inputs", termname)
                    WF <- injectListbyName(l = WF, namepath, value = as.character(connectedoutput), type = "value")
                }
            }
        }
        names(WF$cmdlist) <- WF$files$steps
        names(WF$clt) <- WF$files$steps
        return(WF)
    }
    WF <- .connectInout(WF)
    return(as(WF, "SYSargs2"))
}

################################
## Render Commandline Strings ##
################################
renderCommandline <- function(x, dropoutput = TRUE, redirect = ">") {
    if (class(x) == "SYSargs2") {
        x <- as(x, "list")
    } else {
        stop("x needs to be object of class 'SYSargs2'.")
    }
    ## Fct to render single command-line string
    .renderCommandline <- function(x = x, redirect = redirect) {
        cmdnames <- nestedNames(x)
        ## Check for stdout instance, if present prepend value of redirect
        stdoutpos <- sapply(cmdnames, function(y) {
            tmp <- y %in% c("outputs", "stdout")
            tmp[1] == TRUE & tail(tmp, 1) == TRUE
        })
        if (any(stdoutpos)) {
            cmd <- x
            cmdnamessub <- cmdnames[stdoutpos]
            for (i in seq_along(cmdnamessub)) {
                stdoutstr <- unlist(subsetListbyName(l = cmd, cmdnamessub[[i]]))
                stdoutstr <- paste(redirect, stdoutstr, sep = " ")
                cmd <- injectListbyName(l = cmd, cmdnamessub[[i]], value = stdoutstr, type = "value")
            }
        } else {
            if (dropoutput == TRUE) x <- x[names(x) != "outputs"]
            cmd <- x
        }
        ## Collapse list to single string
        cmd <- paste(unlist(cmd), collapse = " ")
        return(cmd)
    }
    ## Check here for WF class instead of names once implemented
    if (all(names(x) == c("targets", "targetsheader", "modules", "wf", "clt", "yamlinput", "cmdlist", "input", "output", "files", "inputvars", "cmdToCwl", "status", "internal_outfiles"))) {
        cmdstring <- sapply(names(x$cmdlist),
            function(i) .renderCommandline(x = x$cmdlist[[i]], redirect = redirect),
            simplify = FALSE
        )
    } else {
        cmdstring <- .renderCommandline(x = x, redirect = redirect)
    }
    return(cmdstring)
}

###########################################################
## Helper Function to render inputs of single clt object ##
###########################################################
renderInputs <- function(x = WF$clt[[1]]$inputs, returntags = list(inputBinding = c("prefix"), type = "any")) {
    ## global functions or variables
    WF <- NULL
    inputnames <- names(x)
    ## Remove entries where inputBinding is missing since those parameters do not appear on the command-line
    inputnames <- inputnames[!sapply(inputnames, function(i) is.null(x[[i]]$inputBinding))]
    x <- x[inputnames]
    inputlist <- sapply(inputnames, function(i) {
        tmp <- c(
            x[[i]][[names(returntags["inputBinding"])]][returntags$inputBinding],
            x[[i]][names(returntags["type"])]
        )
        tmp <- tmp[!sapply(tmp, length) < 1]
        tmp
    }, simplify = FALSE)
    inputposition <- sapply(inputnames, function(i) x[[i]]$inputBinding$position)
    if (class(inputposition) == "list") inputposition <- seq_along(inputposition)
    inputlist <- inputlist[order(inputposition)]
    return(inputlist)
}

############################################################
## Helper Function to render outputs of single clt object ##
############################################################
renderOutputs <- function(x = WF$clt[[1]]$outputs, stdout = WF$clt[[1]]$stdout, returntags = list(outputBinding = c("prefix", "glob"), type = "any")) {
    ## global functions or variables
    WF <- NULL
    outputnames <- names(x)
    outputlist <- sapply(outputnames, function(i) {
        tmp <- c(x[[i]][[names(returntags["outputBinding"])]][returntags$outputBinding[1]],
            x[[i]][[names(returntags["outputBinding"])]][returntags$outputBinding[2]],
            type = x[[i]][[names(returntags["type"])]]
        )
        tmp <- tmp[!sapply(tmp, length) < 1]
        tmp
    }, simplify = FALSE)
    ## Remove entries 'type: Directory' since they are only relevant for CWL internals
    types <- sapply(seq_along(outputlist), function(i) outputlist[[i]][["type"]])
    outputlist <- outputlist[tolower(types) != "directory"]
    for (i in seq_along(outputlist)) {
        check <- outputlist[[i]][["type"]]
        if (is.null(check)) check <- "absent"
        if (check == "stdout") {
            outputlist[[i]] <- list(stdout = stdout)
        }
    }
    return(outputlist)
}

##################
## Name unnamed ##
##################
## Yaml format may have unnamed components; not having names creates
## problems in some cases with name-based subsetting of lists; thus the
## following function assigns names to unnamed components. A tagging syntax
## can be used to ignore them in subsetting routines if necessary.
nameUnnamed <- function(l) {
    for (a in seq_along(l)) {
        for (b in seq_along(l[[a]])) {
            for (c in seq_along(l[[a]][[b]])) {
                for (d in seq_along(l[[a]][[b]][[c]])) {
                    if (is.null(names(l[[a]][[b]][[c]][[d]])) & class(l[[a]][[b]][[c]][[d]]) == "list") names(l[[a]][[b]][[c]][[d]]) <- paste0("_", seq_along(l[[a]][[b]][[c]][[d]]), "_")
                    if (is.null(names(l[[a]][[b]][[c]])) & class(l[[a]][[b]][[c]]) == "list") names(l[[a]][[b]][[c]]) <- paste0("_", seq_along(l[[a]][[b]][[c]]), "_")
                    if (is.null(names(l[[a]][[b]])) & class(l[[a]][[b]]) == "list") names(l[[a]][[b]]) <- paste0("_", seq_along(l[[a]][[b]]), "_")
                    if (is.null(names(l[[a]])) & class(l[[a]]) == "list") names(l[[a]]) <- paste0("_", seq_along(l[[a]]), "_")
                }
            }
        }
    }
    return(l)
}

###########################################################################
## Return names of nested lists (with up to 5 nesting levels) as vectors ##
###########################################################################
nestedNames <- function(l, sep = "_") {
    nestednames <- lapply(seq_along(l), function(a) {
        lapply(seq_along(l[[a]]), function(b) {
            lapply(seq_along(l[[a]][[b]]), function(c) {
                lapply(seq_along(l[[a]][[b]][[c]]), function(d) {
                    lapply(seq_along(l[[a]][[b]][[c]][[d]]), function(e) {
                        c(
                            names(l[a]),
                            names(l[[a]][b]),
                            names(l[[a]][[b]][c]),
                            names(l[[a]][[b]][[c]][d]),
                            names(l[[a]][[b]][[c]][[d]][e])
                        )
                    })
                })
            })
        })
    })
    while (any(sapply(nestednames, is.list))) nestednames <- unlist(nestednames, recursive = FALSE)
    names(nestednames) <- sapply(nestednames, paste, collapse = sep)
    return(nestednames)
}

########################################################
## Find best matches among name vectors for two lists ##
########################################################
findBestMatch <- function(x, y, mmp, minmatch = 2) {
    matchindex <- setNames(rep(NA, length(x)), names(x))
    ## Perfect matches
    matchpos <- sapply(names(y), function(j) {
        sapply(names(x), function(i) {
            ident <- all(y[[j]] %in% x[[i]])
            lengthcheck <- length(y[[j]]) == length(x[[i]])
            ident & lengthcheck
        })
    })
    ## Note, if there are several input matches to one command-line slot then only the last one is used (see tail)
    matchpos <- sapply(rownames(matchpos), function(i) tail(which(matchpos[i, ]), 1), simplify = FALSE)
    for (i in seq_along(matchindex)) {
        if (is.na(matchindex[i]) == TRUE) matchindex[i] <- matchpos[[i]][1]
    }
    ## Matches with tag specific terminal mismatches
    matchpos <- sapply(names(y), function(j) {
        sapply(names(x), function(i) {
            all(termMMatch(x = x[[i]], y = y[[j]], mmp = mmp, minmatch = minmatch, returntype = "logical"))
        })
    })
    ## Note, if there are several input matches to one command-line slot then only the last one is used (see tail)
    matchpos <- sapply(rownames(matchpos), function(i) tail(which(matchpos[i, ]), 1), simplify = FALSE)
    for (i in seq_along(matchpos)) {
        if (is.na(matchindex[i]) == TRUE) matchindex[i] <- matchpos[[i]][1]
    }
    ## Matches with terminal (max 1) length differences
    matchpos <- sapply(names(y), function(j) {
        sapply(names(x), function(i) {
            ident <- all(y[[j]] %in% x[[i]][1:length(y[[j]])])
            lengthcheck <- length(y[[j]]) >= minmatch
            ident & lengthcheck
        })
    })
    ## Note, if there are several input matches to one command-line slot then only the last one is used (see tail)
    matchpos <- sapply(rownames(matchpos), function(i) tail(which(matchpos[i, ]), 1), simplify = FALSE)
    for (i in seq_along(matchpos)) {
        if (is.na(matchindex[i]) == TRUE) matchindex[i] <- matchpos[[i]][1]
    }
    return(matchindex)
}

###############################################
## Inject into List Subsetted by Name Vector ##
###############################################
injectListbyName <- function(l, name_index, value, type = "value") {
    ## Input validity check for l and name_index
    if (all(!c("name", "value") %in% type[1])) stop("Argument type can only be assigned one of: 'name' or 'value'.")
    checknames <- nestedNames(l)
    checknames <- checknames[!sapply(checknames, length) < length(name_index)]
    checknames <- sapply(checknames, function(x) which(name_index == x[seq_along(name_index)]), simplify = FALSE)
    checknames <- checknames[sapply(checknames, length) == length(name_index)]
    checkindex <- sapply(seq_along(checknames), function(x) all(checknames[[x]] == seq_along(checknames[[x]])))
    if (length(checkindex) == 0) checkindex <- FALSE
    if (any(checkindex == FALSE)) stop("Invalid 'name_index' lacking consecutive name matches in any list component.")
    if (length(name_index) == 1) {
        if (type == "name") names(l)[which(names(l) %in% name_index[1])] <- value
        if (type == "value") l[[name_index[1]]] <- value
    } else if (length(name_index) == 2) {
        if (type == "name") names(l[[name_index[1]]])[1] <- value
        if (type == "value") l[[name_index[1]]][[name_index[2]]] <- value
    } else if (length(name_index) == 3) {
        if (type == "name") names(l[[name_index[1]]][[name_index[2]]]) <- value
        if (type == "value") l[[name_index[1]]][[name_index[2]]][[name_index[3]]] <- value
    } else if (length(name_index) == 4) {
        if (type == "name") names(l[[name_index[1]]][[name_index[2]]][[name_index[3]]]) <- value
        if (type == "value") l[[name_index[1]]][[name_index[2]]][[name_index[3]]][[name_index[4]]] <- value
    } else if (length(name_index) == 5) {
        if (type == "name") names(l[[name_index[1]]][[name_index[2]]][[name_index[3]]][[name_index[4]]]) <- value
        if (type == "value") l[[name_index[1]]][[name_index[2]]][[name_index[3]]][[name_index[4]]][[name_index[5]]] <- value
    } else {
        stop("Nesting level (length of name_index) cannot exceed 5.")
    }
    return(l)
}

################################
## Subset List by Name vector ##
################################
subsetListbyName <- function(l, name_index) {
    ## Input validity check for l and name_index
    checknames <- nestedNames(l)
    checknames <- checknames[!sapply(checknames, length) < length(name_index)]
    checknames <- sapply(checknames, function(x) which(name_index == x[seq_along(name_index)]), simplify = FALSE)
    checknames <- checknames[sapply(checknames, length) == length(name_index)]
    checkindex <- sapply(seq_along(checknames), function(x) all(checknames[[x]] == seq_along(checknames[[x]])))
    if (length(checkindex) == 0) checkindex <- FALSE
    if (any(checkindex == FALSE)) stop("Invalid 'name_index' lacking consecutive name matches in any list component.")
    if (length(name_index) == 1) {
        lsub <- l[name_index[1]]
    } else if (length(name_index) == 2) {
        lsub <- l[[name_index[1]]][name_index[2]]
    } else if (length(name_index) == 3) {
        lsub <- l[[name_index[1]]][[name_index[2]]][name_index[3]]
    } else if (length(name_index) == 4) {
        lsub <- l[[name_index[1]]][[name_index[2]]][[name_index[3]]][name_index[4]]
    } else if (length(name_index) == 5) {
        lsub <- l[[name_index[1]]][[name_index[2]]][[name_index[3]]][[name_index[4]]][name_index[5]]
    } else {
        stop("Nesting level (length of name_index) cannot exceed 5.")
    }
    return(lsub)
}

############################################################
## Matching vectors with tag specific terminal mismatches ##
############################################################
termMMatch <- function(x, y, mmp, minmatch = 2, returntype = "values") {
    ## Input validity checks
    if (!all(sapply(mmp, length) == 2)) stop("List components of 'mmp' need to be vectors of length = 2.")
    if (!all(sapply(names(mmp), function(x) x %in% mmp[[x]]))) stop("Names of 'mmp' list components need to match one of the entries in the corresponding list.")
    ## Check for candidate matches
    lengthcheck <- length(x) == length(y)
    term <- unique(c(tail(x, 1), tail(y, 1)))
    l <- length(term) == 2
    minmatchcheck <- sum(x[-length(x)] == y[-length(y)]) >= minmatch
    index <- which(sapply(names(mmp), function(x) all(term %in% mmp[[x]])))
    p <- length(index) > 0
    if (lengthcheck & l & p & minmatchcheck) {
        for (i in index) {
            x[length(x)] <- names(mmp)[i]
            y[length(y)] <- names(mmp)[i]
        }
        if (returntype == "values") {
            return(list(x = x, y = y))
        } else if (returntype == "logical") {
            return(rep(TRUE, length(x)))
        } else {
            stop("Argument 'returntype' can only be assigned one of: 'values' or 'logical'.")
        }
        ## Return input if there are not matches
    } else {
        if (returntype == "values") {
            return(list(x = x, y = y))
        } else if (returntype == "logical") {
            x <- x == y[1:length(x)]
            x[is.na(x)] <- FALSE
            return(x)
        } else {
            stop("Argument 'returntype' can only be assigned one of: 'values' or 'logical'.")
        }
    }
}

#########################
##   .renderWFsingle   ##
#########################
.renderWFsingle <- function(WF, id, inputvars) {
    inputvarslist <- sapply(names(inputvars), function(x) "", simplify = FALSE)
    if (!length(names(targets(WF))) == 0) (if (any(!names(inputvars) %in% colnames(targets.as.df(WF$targets)))) stop("Please note that the 'inputvars' variables need to be defined in the 'input_file'; as well it needs to match the column names defined in the 'targets' file."))
    input <- yamlinput(WF)
    for (i in seq_along(inputvars)) {
        subvalue <- targets(WF)[[id]][[names(inputvars)[i]]]
        if (length(subvalue) != 0) {
            input <- rapply(input, function(x) gsub(inputvars[[i]], subvalue, x), how = "replace")
            inputvarslist[[i]] <- subvalue
        }
    }
    WF <- as(WF, "list")
    WF$yamlinput <- input
    WF <- as(WF, "SYSargs2")
    WF <- injectCommandlinelist(WF)
    ## Fix for cases like IDX/tophat/STAR, more than one output file per cmdlist
    outfilelist <- sapply(names(cmdlist(WF)), function(x) list(NULL))
    for (i in seq_along(outfilelist)) {
        for (j in seq_along(cmdlist(WF)[[names(outfilelist[i])]]$output)) {
            if ("stdout" %in% names(cmdlist(WF)[[names(outfilelist[i])]]$output[[j]])) {
                outfilelist[[i]][j] <- cmdlist(WF)[[names(outfilelist[i])]]$output[[j]]$stdout
            } else {
                outfilelist[[i]][j] <- cmdlist(WF)[[names(outfilelist[i])]]$output[[j]]$glob
            }
        }
    }
    cmdlist <- renderCommandline(WF, redirect = ">")
    inputvars <- as.list(inputvars)
    return(list(cmd = cmdlist, input = inputvarslist, output = outfilelist, inputvars = inputvars))
}

############################
## .check.output.sysargs2 ##
############################
.check.output.sysargs2 <- function(sysargs, type, step.name, step.dir = FALSE) {
    if (type == "data.frame") {
        checkfile <- sapply(names(output(sysargs)), function(x) list(NULL))
        for (i in seq_along(output(sysargs))) {
            checkfile[[i]][["Total"]] <- length(unlist(output(sysargs)[[i]]))
            if (step.dir == TRUE) {
                newfile <- sum(file.exists(file.path(.getPath(unlist(output(sysargs)[[i]]), full_path = FALSE, warning = FALSE), step.name, basename(unlist(output(sysargs)[[i]])))))
                checkfile[[i]][["Existing"]] <- sum(file.exists(unlist(output(sysargs)[[i]])), newfile)
            } else if (step.dir == FALSE) {
                checkfile[[i]][["Existing"]] <- sum(file.exists(unlist(output(sysargs)[[i]])))
            }
            checkfile[[i]][["Missing"]] <- length(unlist(output(sysargs)[[i]])) - checkfile[[i]][["Existing"]]
        }
        checkfile <- data.frame(matrix(unlist(checkfile), nrow = length(checkfile), byrow = TRUE))
        checkfile <- data.frame(cbind(
            Targets = names(output(sysargs)), Total_Files = as.numeric(checkfile$X1),
            Existing_Files = checkfile$X2, Missing_Files = checkfile$X3
        ), stringsAsFactors = FALSE)
        checkfile[, 2:4] <- sapply(checkfile[, 2:4], as.numeric)
        return(checkfile)
    } else if (type == "list") {
        checkfile <- sapply(names(output(sysargs)), function(x) list(NULL))
        for (i in seq_along(output(sysargs))) {
            checkfile[[i]] <- all(file.exists(unlist(output(sysargs)[[i]])))
        }
        return(unlist(checkfile))
    }
}

###############################################################
## Subsetting the input and output slots by name or position ##
###############################################################
subsetWF <- function(args, slot, subset = NULL, index = NULL, delete = FALSE) {
    ## Check the class and slot
    if (!class(args) == "SYSargs2") stop("args needs to be object of class 'SYSargs2'.")
    if (all(!c("input", "output", "step") %in% slot)) stop("Argument slot can only be assigned one of: 'input' or 'output' or 'step'.")

    ## slot input
    if (slot %in% "input") {
        ## Check the subset
        if (all(!is.null(subset) & is.character(subset) & !any(names(inputvars(args)) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following values in the subset argument: ",
                paste(names(inputvars(args)), collapse = ", "),
                " OR the corresponding position OR NULL"
            )
        }
        if (all(!is.null(subset) & is.numeric(subset) & !any(seq_along(names(inputvars(args))) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following position in the subset argument: ",
                paste(seq_along(names(inputvars(args))), collapse = ", "), " OR the names OR NULL"
            )
        }
        subset_input <- input(args)
        subset_sample <- sapply(names(subset_input), function(x) list(NULL))
        if (!is.null(subset)) {
            for (i in seq_along(names(subset_input))) {
                subset_sample[[i]] <- subset_input[[i]][[subset]]
            }
        } else {
            subset_sample <- subset_input
        }
    }
    ## slot output
    if (slot %in% "output") {
        ## Check the subset
        if (all(!is.null(subset) & is.character(subset) & !any(names(args$clt) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following values in the subset argument:",
                paste(names(args$clt), collapse = ", "),
                " OR the corresponding position OR NULL"
            )
        }
        if (all(!is.null(subset) & is.numeric(subset) & !any(seq_along(names(args$clt)) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following position in the subset argument: ",
                paste(seq_along(names(args$clt)), collapse = ", "),
                " OR the names OR NULL"
            )
        }
        if (!is.null(subset)) {
            if (!any(seq_along(output(args)[[1]][[subset]]) %in% index)) {
                stop(
                    "For the 'index' argument, can only be assigned one of the following position: ",
                    paste(seq_along(output(args)[[1]][[subset]]), collapse = ", ")
                )
            }
        }
        subset_output <- output(args)
        subset_sample <- as.character()
        if (all(!is.null(subset) & !is.null(index))) {
            for (i in seq_along(names(subset_output))) {
                # subset_sample[[i]] <- subset_output[[i]][[subset]]
                subset_sample <- c(subset_sample, subset_output[[i]][[subset]][index])
            }
        } else {
            subset_sample <- subset_output
        }
        names(subset_sample) <- rep(names(subset_output), each = length(subset_sample[1]))
    }
    ## slot step
    if (slot %in% "step") {
        ## Check the subset
        if (all(!is.null(subset) & is.character(subset) & !any(names(args$clt) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following values in the subset argument: ",
                paste(names(args$clt), collapse = ", "),
                " OR the corresponding position OR NULL"
            )
        }
        if (all(!is.null(subset) & is.numeric(subset) & !any(seq_along(names(args$clt)) %in% subset))) {
            stop(
                "For the ", slot, " slot, can only be assigned one of the following position in the subset argument: ",
                paste(seq_along(names(args$clt)), collapse = ", "),
                " OR the names OR NULL"
            )
        }
        subset_step <- cmdlist(args)
        subset_sample <- sapply(names(subset_step), function(x) list(NULL))
        if (!is.null(subset)) {
            for (i in seq_along(names(subset_sample))) {
                subset_sample[[i]] <- subset_step[[i]][[subset]]
            }
        } else {
            subset_sample <- subset_step
        }
    }
    ## IF subset=NULL returns a list
    if (!is.null(subset)) {
        names <- names(subset_sample)
        subset_sample <- as.character(subset_sample)
        names(subset_sample) <- names
    }
    ## delete == TRUE
    if (delete == TRUE) {
        ## delete option only works if the subset is define
        if (!is.character(subset_sample)) {
            stop("Please define the 'subset' to be deleted in the subset argument")
        }
        if (all(file.exists(subset_sample))) {
            del <- file.remove(subset_sample)
            cat("The following files has been deleted:", paste(subset_sample, collapse = ", "), "\n")
        } else if (all(!file.exists(subset_sample))) {
            cat("The subset cannot be deleted: no such file ", "\n")
        }
    }
    return(subset_sample)
}

## Usage:
# subsetWF(WF, slot="input", subset='FileName')
# subsetWF(WF, slot="step", subset=1)
# subsetWF(WF, slot="output", subset=1, index=1)
# subsetWF(WF, slot="output", subset=1, index=1, delete=TRUE) ## in order to delete the subset files list

#########################################################
## Update the output location after run runCommandline ##
#########################################################
output_update <- function(args, dir = FALSE, dir.name = NULL, replace = FALSE, extension = NULL, make_bam = FALSE, del_sam = TRUE) {
    ## Validation for 'args'
    if (any(!inherits(args, "SYSargs") & !inherits(args, "SYSargs2"))) stop("Argument 'args' needs to be assigned an object of class 'SYSargs' OR 'SYSargs2'")
    ## If the argument 'replace' is TRUE, it is required to specify the 'extension' argument
    if (replace != FALSE) {
        if (is.null(extension)) {
            stop("argument 'extension' missing. The argument can only be assigned 'NULL' when no replacement is required. The argument should be assigned as a character vector with the current extension and the new one.")
        }
    }
    if (replace == TRUE) {
        args <- as(args, "list")
        for (i in seq_along(args$output)) {
            for (j in seq_along(args$output[[i]])) {
                for (k in seq_along(args$output[[i]][[j]])) {
                    name <- basename(args$output[[i]][[j]][k])
                    dirRep <- sub("/([^/]*)$", "", args$output[[i]][[j]][k])
                    if (grepl(extension[1], name)) {
                        sam <- .getExt(name)
                        args$output[[i]][[j]][k] <- file.path(dirRep, paste0(.getFileName(name), extension[2]))
                    } else {
                        # message if the extension are not matching, return the same object
                        args$output[[i]][[j]][k] <- args$output[[i]][[j]][k]
                    }
                    if (make_bam == TRUE) {
                        if (grepl("bam", args$output[[i]][[j]][k])) {
                            args$output[[i]][[j]][length(args$output[[i]][[j]]) + 1] <- paste0(gsub("\\.bam$", "", args$output[[i]][[j]][k]), ".bam.bai")
                        }
                        if (del_sam == FALSE) {
                            args$output[[i]][[j]] <- append(args$output[[i]][[j]], args$internal_outfiles[[i]][[j]][k], after = 0)
                        }
                    }
                }
            }
        }
        # }
        args <- as(args, "SYSargs2")
    }
    if (dir == TRUE) {
        args <- as(args, "list")
        ## Results path
        logdir <- file.path(args$yamlinput$results_path$path)
        ## Workflow Name: Detail: if the folder was not created during 'runCommandline,' it will return a warning message pointing 'no such directory'
        if (is.null(dir.name)) {
            cwl.wf <- file.path(logdir, .getFileName(args$files$cwl))
        } else if (!is.null(dir.name)) {
            cwl.wf <- file.path(logdir, dir.name)
        }
        ## New path
        for (i in seq_along(args$output)) {
            for (j in seq_along(args$output[[i]])) {
                for (k in seq_along(args$output[[i]][[j]])) {
                    name <- basename(args$output[[i]][[j]][k])
                    args$output[[i]][[j]][k] <- file.path(cwl.wf, name)
                }
            }
        }
        args <- as(args, "SYSargs2")
    }
    return(args)
}
## Usage:
# WF <- output_update(WF, dir=FALSE, replace=TRUE, extension=c(".sam", ".bam"))
# WF <- output_update(WF, dir=TRUE, replace=TRUE, extension=c(".sam", ".bam"))

###################################################
##   Create CommandLineTools from Command-line   ##
###################################################
createWF <- function(targets = NULL, commandLine, results_path = "./results", module_load = "baseCommand", file = "default",
                     overwrite = FALSE, cwlVersion = "v1.0", class = "CommandLineTool", writeout = FALSE, silent = FALSE) {
    if (all(!inherits(commandLine, "list"))) stop("'commandLine' needs to be object of class 'list'.")
    if (any(!c("baseCommand", "inputs", "outputs") %in% names(commandLine))) stop("Argument 'commandLine' needs to be assigned at least to: 'baseCommand', 'input' or 'output'.")
    if (all(!c("Workflow", "CommandLineTool") %in% class)) stop("Class slot in '<wf_file>.cwl' needs to be 'Workflow' or 'CommandLineTool'.")
    if (dir.exists(results_path) == FALSE) dir.create(path = results_path)
    if (module_load == "baseCommand") {
        module_load <- commandLine$baseCommand[[1]]
    } else {
        module_load <- module_load
    }
    if ("default" %in% file) {
        if (dir.exists(paste("param/cwl/", commandLine$baseCommand, sep = "")) == FALSE) dir.create(path = paste("param/cwl/", commandLine$baseCommand, sep = ""), recursive = TRUE)
        file.cwl <- paste("param/cwl/", commandLine$baseCommand, "/", commandLine$baseCommand, ".cwl", sep = "")
        file.yml <- paste("param/cwl/", commandLine$baseCommand, "/", commandLine$baseCommand, ".yml", sep = "")
    } else {
        for (i in seq_along(file)) {
            extension <- sub(".*\\.", "", file[[i]])
            if (!c("cwl") %in% extension & !c("yml") %in% extension) {
                stop("Argument 'file' needs to be assigned as a character vector with the names of the two param file. For example, 'test.cwl' and 'test.yml'.")
            }
            if (c("yml") %in% extension) {
                file.yml <- file[[i]]
            } else if (c("cwl") %in% extension) {
                file.cwl <- file[[i]]
            }
        }
    }
    if (file.exists(file.cwl) & overwrite == FALSE) {
        stop(
            "I am not allowed to overwrite files; please delete existing file: ",
            file, " or set 'overwrite=TRUE', or provide a different name in the 'file' argument"
        )
    }
    if (file.exists(file.yml) & overwrite == FALSE) {
        stop(
            "I am not allowed to overwrite files; please delete existing file: ",
            file, "or set 'overwrite=TRUE', or provide a different name in the 'file' argument"
        )
    }
    ## class("CommandLineTool", "Workflow")
    # WF.temp <- SYScreate("SYSargs2")
    syntaxVersion <- if(inherits(commandLine, "v2")) "v2" else "v1"
    WF.temp <- as(SYScreate("SYSargs2"), "list")
    WF.temp$wf <- list()
    WF.temp$clt <- write.clt(commandLine, cwlVersion, class, file.cwl, writeout = writeout, silent = silent, syntaxVersion = syntaxVersion)
    WF.temp$yamlinput <- write.yml(commandLine, file.yml, results_path, module_load, writeout = writeout, silent = silent, syntaxVersion = syntaxVersion)
    WF.temp$modules <- WF.temp$yamlinput$ModulesToLoad
    WF.temp$cmdlist <- sapply(names(WF.temp$clt), function(x) list(NULL))
    WF.temp$input <- sapply(names(WF.temp$clt), function(x) list(NULL))
    WF.temp$output <- sapply(names(WF.temp$clt), function(x) list(NULL))
    WF.temp$internal_outfiles <- sapply(names(WF.temp$clt), function(x) list(NULL))
    WF.temp$files <- list(
        cwl = file.path(file.cwl),
        yml = file.path(file.yml),
        steps = names(WF.temp$clt)
    )
    WF.temp$cmdToCwl <- commandLine
    ## targets
    if (!is.null(targets)) {
        mytargets <- read.delim(normalizePath(file.path(targets)), comment.char = "#")
        mytargets <- targets.as.list(mytargets)
        targetsheader <- readLines(normalizePath(file.path(targets)))
        targetsheader <- targetsheader[grepl("^#", targetsheader)]
        WF.temp$files["targets"] <- normalizePath(file.path(targets))
        WF.temp <- c(list(targets = mytargets, targetsheader = list(targetsheader = targetsheader)), WF.temp)
    } else {
        WF.temp$files["targets"] <- NA
        WF.temp <- c(list(targets = data.frame(), targetsheader = list()), WF.temp)
    }
    WF.temp <- as(WF.temp, "SYSargs2")
    # WF.temp[["status"]] <- .statusPending(WF.temp)
    return(WF.temp)
}

## Usage:
## Example commandLine
# "hisat2 -S ./results/_SampleName_.sam  -x ./data/tair10.fasta  -k 1  --min-intronlen 30  --max-intronlen 3000 --threads 4 -U _FASTQ_PATH1_"
## Provide a list
# baseCommand <- list(baseCommand="hisat2")
# inputs <- list(
#   "S"=list(type="File", preF="-S", yml="./results/_SampleName_.sam"),
#   "x"=list(type="File", preF="-x", yml="./data/tair10.fasta"),
#   "k"= list(type="int", preF="-k", yml= 1L),
#   "threads"= list(type="int", preF="-threads", yml=4L),
#   "min-intronlen"= list(type="int", preF="--min-intronlen", yml= 30L),
#   "max-intronlen"= list(type="int", preF="--max-intronlen", yml=3000L),
#   "U"=list(type="File", preF="-U", yml="./data/_FASTQ_PATH1_") )
# outputs <- list("hisat2_sam"=list(type="File", "./results/_SampleName_.sam"))
# commandLine <- list(baseCommand=baseCommand, inputs=inputs, outputs=outputs)
#
## Creates a SYSargs2 object, populate all the command-line, and creates *.cwl and *.yml files
# targets <- system.file("extdata", "targets.txt", package="systemPipeR")
# WF <- createWF(targets=targets, commandLine, results_path="./results", module_load="baseCommand",
#                file = "default", overwrite = FALSE, cwlVersion = "v1.0",
#                class = "CommandLineTool")
# WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))

###################
##   write.cwl   ##
###################
write.clt <- function(commandLine, cwlVersion, class, file.cwl, writeout = TRUE, silent = FALSE, syntaxVersion = "v1") {
    cwlVersion <- cwlVersion
    class <- class
    baseCommand <- commandLine$baseCommand[[1]]
    ## File
    clt <- list(cwlVersion = cwlVersion, class = class)
    ## requirements
    if (is.null(commandLine$requeriments)) {
        dump <- "do nothing"
    } else if (!is.null(commandLine$requeriments)) {
        requeriments <- list()
        clt <- c(clt, list(requeriments = requeriments))
    }
    ## ARGUMENTS
    arguments <- sapply(names(commandLine$args), function(x) list())
    if (!is.null(commandLine$args)) {
        for (i in seq_along(commandLine$args)) {
            arguments[[i]]["prefix"] <- commandLine$args[[i]]$preF
            arguments[[i]]["valueFrom"] <- ""
            arguments[[i]]["position"] <- as.integer(commandLine$args[[i]]$index)
        }
    }
    ## INPUTS
    if (any(names(commandLine$inputs) == "")) stop("Each element of the list 'commandLine' needs to be assigned a name")
    if (is.null(names(commandLine$inputs))) stop("Each element of the list 'commandLine' needs to be assigned a name")
    inputs <- sapply(names(commandLine$inputs), function(x) list())
    for (i in seq_along(commandLine$inputs)) {
        if ("type" %in% names(commandLine$inputs[[i]])) {
            if (!c("type") %in% names(commandLine$inputs[[i]])) stop("Each element of the sublist 'inputs' in 'commandLine' needs to be defined the type of the argument, for example: type='Directory' or type='File' or type='int' or type='string'")
            inputs[[i]]["type"] <- commandLine$inputs[[i]]$type
        }
        if ("preF" %in% names(commandLine$inputs[[i]])) {
            if (commandLine$inputs[[i]]$preF == "") {
                inputs[[i]]["inputBinding"] <- list(list(prefix = ""))
            } else {
                inputs[[i]]["inputBinding"] <- list(list(prefix = commandLine$inputs[[i]]$preF))
            }
        }
        if(syntaxVersion == "v2") inputs[[i]]["inputBinding"]$inputBinding$position <- as.integer(commandLine$inputs[[i]]$index)
        if (any(c("label", "secondaryFiles", "doc", "default", "format", "streamable") %in% names(commandLine$inputs[[i]]))) {
            for (j in which(c("label", "secondaryFiles", "doc", "default", "format", "streamable") %in% names(commandLine$inputs[[i]]))) {
                inputs[[i]][names(commandLine$inputs[[i]][j])] <- commandLine$inputs[[i]][names(commandLine$inputs[[i]])][[j]]
            }
        }
    }
    ## OUTPUTS
    outputs <- sapply(names(commandLine$outputs), function(x) list())
    if (!c("type") %in% names(commandLine$inputs[[i]])) stop("Each element of the sublist 'outputs' in 'commandLine' needs to be defined the type of the argument, for example: type='Directory' or type='File'.")
    if (all(!c("File", "Directory") %in% commandLine$outputs[[1]]$type)) stop("Each element of the sublist 'outputs' in 'commandLine' needs to be defined the type = 'Directory', 'File'.")
    for (i in seq_along(commandLine$outputs)) {
        outputs[[i]]["type"] <- commandLine$outputs[[i]]$type
        outputs[[i]]["outputBinding"] <- list(list(glob = commandLine$outputs[[i]][[2]]))
    }
    ## standard out
    if(length(commandLine$stdout) > 0) {
        stdout_name <- names(commandLine$stdout)
        if(is.null(stdout_name) || stdout_name == "") stdout_name <- "new_stdout"
        outputs[[stdout_name]]$type <- "stdout"
    }
    ## FILE
    positions <- list(baseCommand = baseCommand, arguments = arguments, inputs = inputs, outputs = outputs)
    if(length(commandLine$stdout) > 0) positions$stdout <- commandLine$stdout[[1]]$value
    clt <- c(clt, positions)
    ## writing file
    if (writeout == TRUE) {
        yaml::write_yaml(x = clt, file = file.cwl)
        ## print message
        if (silent != TRUE) cat("\t", "Written content of 'commandLine' to file:", "\n", file.cwl, "\n")
    }
    clt <- list(clt)
    names(clt) <- baseCommand
    return(clt)
}

## Usage:
# clt_cwl <- write.clt(commandLine, cwlVersion, class, file.cwl)

###################
##   write.yml   ##
###################
## Write the yaml file
write.yml <- function(commandLine, file.yml, results_path, module_load, writeout = TRUE, silent = FALSE, syntaxVersion = "v1") {
    inputs <- commandLine$inputs
    if(length(inputs) == 0) {
        return(
            message(crayon::yellow$bold("No inputs given, no yml file is written"),
                    "\nAre you sure this is correct? Double-check the command string")
        )
    }
    if (any(names(inputs) == "")) stop("Each element of the list 'commandLine' needs to be assigned a name")
    if (is.null(names(inputs))) stop("Each element of the list 'commandLine' needs to be assigned a name")
    ## yamlinput_yml
    yamlinput_yml <- sapply(names(inputs), function(x) list())
    for (i in seq_along(inputs)) {
        if (!c("type") %in% names(inputs[[i]])) stop("Each element of the sublist 'inputs' in 'commandLine' needs to be defined the type of the argument, for example: type='Directory' or type='File' or type='int' or type='string'")
        if(syntaxVersion == "v1") {
            if (any(c("File", "Directory") %in% inputs[[i]])) {
                yamlinput_yml[[i]]["class"] <- inputs[[i]]$type
                yamlinput_yml[[i]]["path"] <- inputs[[i]]$yml
            } else if (any(c("int", "string") %in% inputs[[i]])) {
                yamlinput_yml[[i]] <- inputs[[i]]$yml
            }
        } else {
            # enforce types
            if (any(c("File", "Directory") %in% inputs[[i]])) {
                yamlinput_yml[[i]]["class"] <- inputs[[i]]$type
                yamlinput_yml[[i]]["path"] <- inputs[[i]]$value
            } else if ("string" %in% inputs[[i]]) {
                yamlinput_yml[[i]] <- as.character(inputs[[i]]$value)
            } else if (any(c("double", "float") %in% inputs[[i]])) {
                yamlinput_yml[[i]] <- as.numeric(inputs[[i]]$value)
            } else if (any(c("int", "long") %in% inputs[[i]])) {
                yamlinput_yml[[i]] <- as.integer(inputs[[i]]$value)
            } else if ("boolean" %in% inputs[[i]]) {
                yamlinput_yml[[i]] <- as.logical(inputs[[i]]$value)
            }  else {
                stop("Argument ", names(inputs[i])[1], " has a currently unsupported type ", inputs[[i]]$type)
            }
        }
    }
    ## results_path
    yamlinput_yml[["results_path"]]["class"] <- list("Directory")
    yamlinput_yml[["results_path"]]["path"] <- list(results_path)
    ## moduleload
    for (i in seq_along(module_load)) {
        yamlinput_yml[["ModulesToLoad"]][paste0("module", i)] <- list(module_load[[i]])
    }
    ## write out the '.yml' file
    if (writeout == TRUE) {
        yaml::write_yaml(x = yamlinput_yml, file = file.yml)
        ## print message
        if (silent != TRUE) cat("\t", "Written content of 'commandLine' to file:", "\n", file.yml, "\n")
    }
    return(yamlinput_yml)
}

## Usage:
# yamlinput_yml <- write.yml(commandLine, file.yml, results_path, module_load)

###################
##  cmdTool2wf   ##
###################
## CommandlineTool --> Workflow class
cmdTool2wf <- function(cmdTool_path, file.cwl, writeout = TRUE, silent = FALSE) {
    cmdTools <- yaml::read_yaml(file.path(cmdTool_path))
    cwlVersion <- cmdTools$cwlVersion
    class <- "Workflow"
    ## Input
    inputs_names <- names(cmdTools$inputs)
    inputs <- sapply(inputs_names, function(x) list(cmdTools$inputs[[x]]$type))
    ## output
    outputs <- sapply(names(cmdTools$outputs), function(x) list(NULL))
    for (i in seq_along(outputs)) {
        outputs[[i]][["outputSource"]] <- paste0(cmdTools$baseCommand, "/", names(outputs)[i])
        outputs[[i]][["type"]] <- cmdTools$outputs[[i]]$type
    }
    ## Steps
    step.in <- sapply(names(inputs), function(x) list(x))
    step.out <- paste0("[", paste0(names(outputs), collapse = ", "), "]")
    steps <- list(list(`in` = step.in, `out` = step.out, run = cmdTool_path))
    if (length(cmdTools$baseCommand) > 1) {
        cmdTools$baseCommand <- paste0(cmdTools$baseCommand, collapse = "_")
    } else if (is.null(cmdTools$baseCommand)) {
        cmdTools$baseCommand <- .getFileName(cmdTool_path)
    }
    names(steps) <- cmdTools$baseCommand
    ## Combine
    wf2 <- list(
        class = class, cwlVersion = cwlVersion, inputs = inputs,
        outputs = outputs, steps = steps
    )
    ## write out the '.cwl' file
    if (writeout == TRUE) {
        yaml::write_yaml(x = wf2, file = file.cwl)
        ## print message
        if (silent != TRUE) cat("\t", "Written content of 'Workflow' to file:", "\n", file.cwl, "\n")
    }
    ## Return
    return(wf2)
}

# cmdTools_path <- "param/cwl/hisat2/hisat2-pe/hisat2-mapping-pe.cwl"
# cmdTools_path <- "param/cwl/hisat2/hisat2-idx/hisat2-index.cwl"
#
# ## Usage:
# wf <- cmdTool2wf(cmdTools_path, file.cwl = "test.cwl")

---
title: "systemPipeR: Workflow Environment for Data Analysis and Report Generation" 
author: "Author: Le Zhang, Daniela Cassol, and Thomas Girke"
date: "Last update: `r format(Sys.time(), '%d %B, %Y')`" 
output:
  BiocStyle::html_document:
    toc_float: true
    code_folding: show
    toc_depth: 4
package: systemPipeR
vignette: |
  %\VignetteEncoding{UTF-8}
  %\VignetteIndexEntry{Overview}
  %\VignetteEngine{knitr::rmarkdown}
fontsize: 14pt
bibliography: bibtex.bib
editor_options: 
  markdown: 
    wrap: 80
  chunk_output_type: console
---

<!--
- Compile from command-line
Rscript -e "rmarkdown::render('systemPipeR.Rmd', c('BiocStyle::html_document'), clean=F); knitr::knit('systemPipeR.Rmd', tangle=FALSE)"
-->

```{css, echo=FALSE}
pre code {
white-space: pre !important;
overflow-x: scroll !important;
word-break: keep-all !important;
word-wrap: initial !important;
}
```

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
options(width = 100, max.print = 1000)
knitr::opts_chunk$set(
    eval = as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache = as.logical(Sys.getenv("KNITR_CACHE", "TRUE")), 
    tidy.opts = list(width.cutoff = 100), tidy = FALSE)
```

```{r setting, eval=TRUE, echo=FALSE}
if (file.exists("spr_project")) unlink("spr_project", recursive = TRUE)
is_win <- Sys.info()[['sysname']] != "Windows"
```

```{r load_library, eval=TRUE, include=FALSE}
suppressPackageStartupMessages({
    library(systemPipeR)
})
```

# Introduction

[_`systemPipeR`_](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html) is a versatile workflow environment for data analysis that integrates R with command-line (CL) software [@H_Backman2016-bt]. This platform allows scientists to analyze diverse data types on personal or distributed computer systems. It ensures a high level of reproducibility, scalability, and portability (Figure \@ref(fig:utilities)). Central to `systemPipeR` is a CL interface (CLI) that adopts the Common Workflow Language [CWL, @Crusoe2021-iq]. Using this CLI, users can select the optimal R or CL software for each analysis step. The platform supports end-to-end and partial execution of workflows, with built-in restart capabilities. A workflow control container class manages analysis tasks of varying complexity. Standardized processing routines for metadata facilitate the handling of large numbers of input samples and complex experimental designs. As a multipurpose workflow management toolkit, `systemPipeR` enables users to run existing workflows, customize them, or create entirely new ones while leveraging widely adopted data structures within the Bioconductor ecosystem. Another key aspect of `systemPipeR` is its ability to generate reproducible scientific analysis and technical reports. For result interpretation, it offers a range of graphics functionalities. Additionally, an associated Shiny App provides various interactive features for result exploration, and enhancing the user experience.


```{r utilities, eval=TRUE, warning= FALSE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Important functionalities of systemPipeR. (A) Illustration of workflow design concepts, and (B) examples of visualization functionalities for NGS data.", warning=FALSE}
knitr::include_graphics("images/utilities.png")
```

## Workflow control class

A central component of `systemPipeR` is `SYSargsList` or short `SAL`, a
container for workflow management. This S4 class stores all relevant
information for running and monitoring each analysis step in workflows. It 
captures the connectivity between workflow steps, the paths to their input and 
output data, and pertinent parameter values used in each step 
(see Figure \@ref(fig:sysargslistImage)). Typically, `SAL` instances are constructed 
from an intial metadata targets table, R code and CWL parameter files for each 
R- and CL-based analysis step in workflows (details provided below). 
For preconfigured workflows, users only need to provide their input data (such as FASTQ 
files) and the corresponding metadata in a targets file. The latter describes the 
experimental design, defines sample labels, replicate information, and other 
relevant information. 

```{r sysargslistImage, warning= FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Workflow management class. Workflows are defined and managed by the `SYSargsList` (`SAL`) control class. Components of `SAL` include `SYSargs2` and/or `LineWise` for defining CL- and R-based workflow steps, respectively. The former are constructed from a `targets` and two CWL *param* files, and the latter comprises mainly R code.", warning=FALSE}

knitr::include_graphics("images/SYSargsList.png")
```
## CL interface (CLI) {#cl-interface}

_`systemPipeR`_ adopts the [Common Workflow Language
(CWL)](https://www.commonwl.org/index.html), which is a widely used community
standard for describing CL tools and workflows in a declarative, generic, and
reproducible manner [@Amstutz2016-ka]. CWL specifications are human-readable
[YAML](https://www.commonwl.org/user_guide/topics/yaml-guide.html) files that
are straightforward to create and to modify. Integrating CWL in `systemPipeR`
enhances the sharability, standardization, extensibility and portability of
data analysis workflows.

Following the CWL Specifications, the basic description for executing a CL
software are defined by two files: a cwl step definition file and a yml
configuration file. Figure \@ref(fig:sprandCWL) illustrates the utilitity of
the two files using “Hello World” as an example. The cwl file (A) defines the
parameters of CL tool or workflow (C), and the yml file (B) assigns the input
variables to the corresponding parameters. For convenience, in `systemPipeR` parameter
values can be provided by a targets file (D, see above), and automatically
passed on to the corresponding parameters in the yml file. The usage of a
targets file greatly simplifies the operation of the system for users, because
a tabular metadata file is intuitive to maintain, and it eliminates the need of
modifying the more complex cwl and yml files directly. The structure of
`targets` files is explained in the corresponding section
[below](#targets-files). A detailed overview of the CWL syntax is provided in
the [CWL syntax](#cwl) section below, and the details for connecting the input
information in `targets` with CWL parameters are described
[here](#cwl_targets). 

```{r sprandCWL, warning=FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Parameter files. Illustration how the different fields in cwl, yml and targets files are connected to assemble command-line calls, here for 'Hello World' example.", warning=FALSE}

knitr::include_graphics("images/SPR_CWL_hello.png")
```

## Workflow templates 
`systemPipeRdata`, a companion package to `systemPipeR`, offers a collection of
workflow templates that are ready to use. With a single command, users can
easily load these templates onto their systems. Once loaded, users have the
flexibility to utilize the templates as they are or modify them as needed. More
in-depth information can be found in the main vignette of systemPipeRdata,
which can be accessed
[here](https://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRdata.html).


## Other functionalities
<!-- _`systemPipeR's`_ CWL interface provides two
options to run command-line tools and workflows based on CWL. First, one can
run CWL in its native way via an R-based wrapper utility for *cwl-runner* or
*cwl-tools* (CWL-based approach). Second, one can run workflows using CWL's
command-line and workflow instructions from within R (R-based approach). In the
latter case the same CWL workflow definition files are used but rendered and
executed entirely with R functions defined by _`systemPipeR`_, and thus use CWL
mainly as a command-line and workflow definition format rather than execution
software to run workflows. --> 
The package also provides several convenience
functions that are useful for designing and testing workflows, such as a
[CL rendering function](#cmd-step) that assembles from the parameter files (cwl, yml and 
targets) the exact CL strings for each step prior to running a CL tool. 
[Auto-generation of CWL](#cwl-auto-generation) parameter files is also supported. Here, users can simply 
provide the CL strings for a CL software of interest to a rendering function that generates 
the corresponding `*.cwl` and `*.yml` files for them. Auto-conversion of workflows to 
executable [Bash scripts](#bash-script) is also supported.


<!--
```{r general, warning= FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Overview of `systemPipeR` workflows management instances. (A) A typical analysis workflow requires multiple software tools (red), metadata for describing the input (green) and output data, and analysis reports for interpreting the results (purple). B) The environment provides utilities for designing and building workflows containing R and/or command-line steps, for managing the workflow runs. C) Options are provided to execute single or multiple workflow steps. This includes a high level of scalability, functionalities for checkpointing, and generating of technical and scientific reports.", warning=FALSE}

knitr::include_graphics("images/general.png")
```
-->

# Quick start

## Installation

The [_`systemPipeR`_](http://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html) 
package can be installed from the R console using the [_`BiocManager::install`_](https://cran.r-project.org/web/packages/BiocManager/index.html) 
command. The associated [_`systemPipeRdata`_](http://www.bioconductor.org/packages/devel/data/experiment/html/systemPipeRdata.html) package can be installed the same way. The latter is a data package for generating _`systemPipeR`_ 
workflow test instances with a single command. These instances contain all parameter files and 
sample data required to quickly test and run workflows. 

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE)) install.packages("BiocManager")
BiocManager::install("systemPipeR")
BiocManager::install("systemPipeRdata")
```

For a workflow to run successfully, all CL tools used by a workflow need to be installed and executable on a user's system, where the analysis will be performed (details provided [below](#third-party-software-tools)). 

## Five minute tutorial {#five-min}

The following demonstrates how to initialize, run and monitor workflows, and subsequently create analysis reports. 


__1. Create workflow environment.__ The chosen example uses the `genWorenvir` function from
the `systemPipeRdata` package to create an RNA-Seq workflow environment that is fully populated with a small test data set, including FASTQ files, reference genome and annotation data. After this, the user's R session needs to be directed 
into the resulting `rnaseq` directory (here with `setwd`). A list of available workflow templates 
is available in the vignette of the `systemPipeRdata` package [here](https://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRdata.html#wf-bioc-collection).

```{r eval=FALSE}
systemPipeRdata::genWorkenvir(workflow = "rnaseq")
setwd("rnaseq")
```

__2. Initialize project and import workflow from `Rmd` template.__ New workflow
instances are created with the `SPRproject` function. When calling this
function, a project directory with the default name `.SPRproject` is created
within the workflow directory. Progress information and log files of a workflow
run will be stored in this directory. After this, workflow steps can be loaded
into `sal` one-by-one, or all at once with the `importWF` function. The latter
reads all steps from a workflow Rmd file (here `systemPipeRNAseq.Rmd`)
defining the analysis steps. 

```{r eval=FALSE}
library(systemPipeR) 
# Initialize workflow project
sal <- SPRproject()
## Creating directory '/home/myuser/systemPipeR/rnaseq/.SPRproject'
## Creating file '/home/myuser/systemPipeR/rnaseq/.SPRproject/SYSargsList.yml'
sal <- importWF(sal, file_path = "systemPipeRNAseq.Rmd") # import into sal the WF steps defined by chosen Rmd file

## The following print statements, issued during the import, are shortened for brevity
## Import messages for first 3 of 20 steps total 
## Parse chunk code
## Now importing step 'load_SPR'
## Now importing step 'preprocessing' 
## Now importing step 'trimming'
## Now importing step '...' 
## ...

## Now check if required CL tools are installed 
## Messages for 4 of 7 CL tools total
##        step_name         tool in_path
## 1       trimming  trimmomatic    TRUE
## 2   hisat2_index hisat2-build    TRUE
## 3 hisat2_mapping       hisat2    TRUE
## 4 hisat2_mapping     samtools    TRUE
## ...
```

The `importWF` function also checks the availability of the R packages and CL 
software tools used by a workflow. All dependency CL software needs to be installed and exported to a user's
`PATH`. In the given example, the CL tools `trimmomatic`, `hisat2-build`, `hisat2`, 
and `samtools` are listed. If the `in_path` column shows `FALSE` for 
any of them, then the missing CL software needs to be installed and made available in a user's
`PATH` prior to running the workflow. Note, the shown availability table of CL tools can 
also be returned with `listCmdTools(sal, check_path=TRUE)`, and the availability of individual CL
tools can be checked with `tryCL`, _e.g._ for `hisat2` use: `tryCL(command = "hisat2")`.  

__3. Status summary.__ An overview of the workflow steps and their status
information can be returned by typing `sal`. For space reasons, the following
shows only the first 3 of a total of 20 steps of the RNA-Seq workflow. At this 
stage all workflow steps are listed as pending since none of them have been executed yet. 

```{r eval=FALSE}
sal
## Instance of 'SYSargsList': 
##     WF Steps:
##        1. load_SPR --> Status: Pending
##        2. preprocessing --> Status: Pending 
##            Total Files: 36 | Existing: 0 | Missing: 36 
##          2.1. preprocessReads-pe
##              cmdlist: 18 | Pending: 18
##        3. trimming --> Status: Pending 
##            Total Files: 72 | Existing: 0 | Missing: 72 
##        4. - 20. not shown here for brevity
```

__4. Run workflow.__ Next, one can execute the entire workflow from start to
finish. The `steps` argument of `runWF` can be used to run only selected steps.
For details, consult the help file with `?runWF`. During the run, detailed status
information will be provided for each workflow step.

```{r eval=FALSE}
sal <- runWF(sal)  
```

After completing all or only some steps, the status of workflow steps can
always be checked with the summary print function. If a workflow step was
completed, its status will change from `Pending` to `Success` or `Failed`.

```{r eval=FALSE}
sal
```

```{r wf-status-image, warning=FALSE, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Status check of workflow. The run status flags of each workflow step are given in its summary view.", warning=FALSE}

knitr::include_graphics("images/runwf.png")
```

__5. Workflow topology graph.__ Workflows can be displayed as topology graphs
using the `plotWF` function. The run status information for each step and various 
other details are embedded in these graphs. Additional details are provided in the [visualize workflow
section](#visualize-workflow) below.

```{r eval=FALSE}
plotWF(sal)
```

```{r rnaseq-toplogy, eval=TRUE, warning= FALSE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "Toplogy graph of RNA-Seq workflow.", warning=FALSE}
knitr::include_graphics("images/plotWF.png")
```

__6. Report generation.__ The `renderReport` and `renderLogs` function can be used
for generating scientific and technical reports, respectively. Alternatively, scientific
reports can be generated with the `render` function of the `rmarkdown` package.

```{r eval=FALSE}
# Scietific report
sal <- renderReport(sal)
rmarkdown::render("systemPipeRNAseq.Rmd", clean = TRUE, output_format = "BiocStyle::html_document") 

# Technical (log) report
sal <- renderLogs(sal)
```

# Directory structure {#wf-directories}

The root directory of `systemPipeR` workflows contains by default three user 
facing sub-directories: `data`, `results` and `param`. A fourth sub-directory is 
a hidden log directory with the default name `.SPRproject` that is created when initializing 
a workflow run with the `SPRproject` function (see above). Users can change
the recommended directory structure, but will need to adjust in some cases the code in
their workflows. Just adding directories to the default structure is possible without requiring changes 
to the workflows. The following directory tree summarizes the expected content in 
each default directory (names given in <span style="color:green">***green***</span>).

* <span style="color:green">_**workflow/**_</span> 
    + This is the root directory of a workflow. It can have any name and includes the following files: 
        + Workflow *Rmd* and metadata targets file(s) 
        + Optionally, configuration files for computer clusters, such as `.batchtools.conf.R` and `tmpl` files for `batchtools` and `BiocParallel`. 
        + Additional files can be added as needed.
  + Default sub-directories: 
    + <span style="color:green">_**param/**_</span> 
        + CWL parameter files are organized by CL tools (under <span style="color:green">_**cwl/**_</span>), each with its own sub-directory that contains the corresponding `cwl` and `yml` files. Previous versions of parameter files are stored in a separate sub-directory. 
    + <span style="color:green">_**data/**_ </span>
        + Raw input and/or assay data (*e.g.* FASTQ files)
        + Reference data, including genome sequences, annotation files, databases, etc.
        + Any number of sub-directories can be added to organize the data under this directory.
        + Other input data
    + <span style="color:green">_**results/**_</span>
        + Analysis results are written to this directory. Examples include tables, plots, or NGS results such as alignment (BAM), variant (VCF), peak (BED) files.
        + Any number of sub-directories can be created to organize the analysis results under this directory.
    + <span style="color:green">_**.SPRproject/**_</span>
        + Hidden log directory created by `SPRproject` function at the beginning of a workflow run. It is a hidden directory because its name starts with a dot. 
        + Run status information and log files of a workflow run are stored here. The content in this directory is auto-generated and not expected to be modified by users.

<!--
```{r dir, eval=TRUE, echo=FALSE, warning= FALSE, out.width="100%", fig.align = "center", fig.cap= "Directory structure of workflows.", warning=FALSE}
knitr::include_graphics("images/spr_project.png")  
```
-->

# The _`targets`_ file {#targets-files}

A `targets` file defines the input files (_e.g._ FASTQ, BAM, BCF) and
sample comparisons used in a data analysis workflow. It can also store any number of 
additional descriptive information for each sample. How the input 
information is passed on from a `targets` file to the CWL parameter files is 
introduced [above](#cl-interface), and additional details are given [below](#cwl). The following
shows the format of two _`targets`_ file examples included in the package. They 
can also be viewed and downloaded from _`systemPipeR`'s_ GitHub repository
[here](https://github.com/tgirke/systemPipeR/blob/master/inst/extdata/targets.txt).
As an alternative to using targets files, `YAML` files can be used instead. Since 
organizing experimental variables in tabular files is straightforward, the following 
sections of this vignette focus on the usage of targets files. Their usage also 
integrates well with the widely used `SummarizedExperiment` object class.

Descendant targets files can be extracted for each step with input/output
operations where the output of the previous step(s) serves as input to the
current step, and the output of the current step becomes the input of the next 
step. This connectivity among input/output operations is automatically tracked
throughout workflows. This way it is straightforward to start workflows at
different processing stages. For instance, one can intialize an RNA-Seq workflow 
at the stage of raw sequence files (FASTQ), alignment files (BAM) or a precomputed 
read count table.

### Single-end (SE) data

In a `targets` file with a single type of input files, here FASTQ files of 
single-end (SE) reads, the first three columns are mandatory including their 
column names, while it is four mandatory columns for FASTQ files of PE reads. 
All subsequent columns are optional and any number of additional columns 
can be added as needed. The columns in `targets` files are
expected to be tab separated (TSV format). The `SampleName` column contains
usually short labels for referencing samples (here FASTQ files) across many
workflow steps (_e.g._ plots and column titles). Importantly, the labels used in
the `SampleName` column need to be unique, while technical or biological
replicates are indicated by the same values under the `Factor` column. For
readability and transparency, it is useful to use here a short, consistent and
informative syntax for naming samples and replicates. This is important
since the values provided under the `SampleName` and `Factor` columns are intended to
be used as labels for naming the columns or plotting features in downstream
analysis steps.

```{r targetsSE, eval=TRUE}
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR") 
showDF(read.delim(targetspath, comment.char = "#"))
```

To work with custom data, users need to generate a `targets` file containing 
the paths to their own FASTQ files and then provide under `targetspath` the
path to the corresponding `targets` file. 

### Paired-end (PE) data

For paired-end (PE) samples, the structure of the targets file is similar. The main
difference is that `targets` files for PE data have two FASTQ path columns (here `FileName1` and `FileName2`) 
each containing the paths to the corresponding PE FASTQ files. 

```{r targetsPE, eval=TRUE}
targetspath <- system.file("extdata", "targetsPE.txt", package = "systemPipeR")
showDF(read.delim(targetspath, comment.char = "#"))
```

### Sample comparisons

If needed, sample comparisons of comparative experiments, such as differentially expressed genes (DEGs), can be 
specified in the header lines of a `targets` file that start with a `# <CMP>` tag. 
Their usage is optional, but useful for controlling comparative analyses according 
to certain biological expectations, such as identifying DEGs in RNA-Seq experiments based on 
simple pair-wise comparisons.

```{r comment_lines, echo=TRUE}
readLines(targetspath)[1:4]
```

The function `readComp` imports the comparison information and stores it in a 
`list`. Alternatively, `readComp` can obtain the comparison information from 
a `SYSargsList` instance containing the `targets` file information (see below). 


```{r targetscomp, eval=TRUE}
readComp(file = targetspath, format = "vector", delim = "-")
```
<!--
## Downstream targets files description

After the step which required the initial targets file information, the downstream 
targets files are created automatically (see Figure \@ref(fig:targetsFig)).
Each step that uses the previous step outfiles as an input, the new targets input 
will be managed internally by the workflow instances, establishing connectivity 
among the steps in the workflow. _`systemPipeR`_ provides features to automatically and systematically build this 
connection, providing security that all the samples will be managed efficiently 
and reproducibly.

```{r targetsFig, eval=TRUE, echo=FALSE, out.width="100%", fig.align = "center", fig.cap= "_`systemPipeR`_ automatically creates the downstream `targets` files based on the previous steps outfiles. A) Usually, users provide the initial `targets` files, and this step will generate some outfiles, as demonstrated on B. Then, those files are used to build the new `targets` files as inputs in the next step. _`systemPipeR`_ (C) manages this connectivity among the steps automatically for the users.", warning=FALSE}
knitr::include_graphics("images/targets_con.png")  
```
-->



<!--
## Structure of the new parameters files

The parameters and configuration required for running command-line software are 
provided by the widely used community standard [Common Workflow Language](https://www.commonwl.org/) (CWL) 
[@Amstutz2016-ka], which describes parameters analysis workflows in a generic 
and reproducible manner. For R-based workflow steps, param files are not required. 
For a complete overview of the CWL syntax, please see the [section](#cwl) below. 
Also, we have a dedicated section explain how to _`systemPipeR`_ establish the 
connection between the CWL parameters files and the targets files. Please see [here](#cwl_targets). 
-->

```{r cleaning1, eval=TRUE, include=FALSE}
if (file.exists(".SPRproject")) unlink(".SPRproject", recursive = TRUE)
## NOTE: Removes previous project created in the quick-start section
```

<!-- # Quick Start -->

<!-- This section will demonstrate how to build a basic workflow. The main features  -->
<!-- will be briefly illustrated here. The following section will discuss all the  -->
<!-- alternatives to design and build the workflow and the support features available  -->
<!-- in _`systemPipeR`_. -->

<!-- - Load sample data and directory structure -->

<!-- [*systemPipeRdata*](http://bioconductor.org/packages/release/data/experiment/html/systemPipeRdata.html) package is a helper package to generate a fully populated [*systemPipeR*](http://bioconductor.org/packages/release/bioc/html/systemPipeR.html) -->
<!-- workflow environment in the current working directory with a single command.  -->
<!-- All the instruction for generating the workflow are provide in the *systemPipeRdata* vignette [here](http://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRdata.html#1_Introduction).  -->

<!-- ```{r genNew_wf, eval=TRUE} -->
<!-- systemPipeRdata::genWorkenvir(workflow = "new", mydirname = "spr_project") -->
<!-- ``` -->

<!-- ```{r, eval=FALSE, warning=FALSE} -->
<!-- setwd("spr_project") -->
<!-- ``` -->

<!-- Typically, the user wants to record here the sources and versions of the -->
<!-- reference genome sequence along with the corresponding annotations. In -->
<!-- the provided sample data set all data inputs are stored in a `data` -->
<!-- subdirectory and all results will be written to a separate `results` directory, -->
<!-- while the `Rmarkdown` workflow file and the `targets` file are expected to be  -->
<!-- located in the parent directory.  -->

<!-- ```{r setting_dir, include=FALSE, warning=FALSE} -->
<!-- knitr::opts_knit$set(root.dir = 'spr_project') -->
<!-- ``` -->

<!-- - Create a project -->

<!-- _`systemPipeR`_ workflows can be designed and built from start to finish with a  -->
<!-- single command, importing from an R Markdown file or stepwise in interactive  -->
<!-- mode from the R console.  -->

<!-- To create a Workflow within _`systemPipeR`_, we can start by defining an empty -->
<!-- container and checking the directory structure: -->

<!-- ```{r SPRproject_ex, eval=TRUE} -->
<!-- sal <- SPRproject()  -->
<!-- ``` -->

<!-- - Build workflow from RMarkdown file -->

<!-- The workflow can be created by adding all the analysis steps interact or importing  -->
<!-- the steps from an R Markdown file. -->
<!-- After initializing the project with `SPRproject` function, `importWF` function -->
<!-- will scan and import all the R chunks from the R Markdown file and build all -->
<!-- the workflow instances. Then, each R chuck in the file will be converted in a workflow step.  -->

<!-- ```{r importwf_example, eval=TRUE} -->
<!-- sal <- importWF(sal,  -->
<!--                 file_path = system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR"), -->
<!--                 verbose = FALSE) -->
<!-- ``` -->

<!-- This workflow contains five steps. First, it loads _`systemPipeR`_  library, then  -->
<!-- exports `iris` data set, separating each species' data in a specific file.  -->
<!-- In the third step, each one of those files will be compressed using `gzip`  -->
<!-- command line, and later these files will be decompressed. Even though each step  -->
<!-- is a straightforward process, it is a simple demonstration of the connectivity  -->
<!-- between command-line and R-based analysis steps. Finally, the last step will -->
<!-- calculate a mean for sepal length and width and petal length and width, respectively, -->
<!-- and plot these statistics. -->

<!-- - Running workflow -->

<!-- Interactive job submissions in a single machine -->

<!-- For running the workflow, `runWF` function will execute all the steps store in  -->
<!-- the workflow container. The execution will be on a single machine without  -->
<!-- submitting to a queuing system of a computer cluster.  -->

<!-- ```{r run_echo, eval=is_win} -->
<!-- sal <- runWF(sal) -->
<!-- ``` -->

<!-- - Visualize workflow -->

<!-- _`systemPipeR`_ workflows instances can be visualized with the `plotWF` function. -->

<!-- ```{r plot_echo, eval=TRUE} -->
<!-- plotWF(sal, width = "80%", rstudio = TRUE) -->
<!-- ``` -->

<!-- - Checking workflow status -->

<!-- To check the summary of the workflow, we can use: -->

<!-- ```{r status_echo, eval=TRUE} -->
<!-- statusWF(sal) -->
<!-- ``` -->

<!-- - Accessing logs report -->

<!-- _`systemPipeR`_ compiles all the workflow execution logs in one central location, -->
<!-- making it easier to check any standard output (`stdout`) or standard error -->
<!-- (`stderr`) for any command-line tools used on the workflow or the R code stdout. -->

<!-- ```{r logs_echo, eval=FALSE} -->
<!-- sal <- renderLogs(sal) -->
<!-- ``` -->

<!-- ```{r cleaning2, eval=TRUE, include=FALSE} -->
<!-- if (file.exists(".SPRproject")) unlink(".SPRproject", recursive = TRUE) -->
<!-- ## NOTE: Removing previous project create in the quick starts section -->
<!-- ``` -->

# Detailed tutorial

## Initialization

A `systemPipeR` workflow instance is initialized with the `SPRproject` function. This function
call creates an empty `SAL` container instance and at the same time a linked project 
log directory that acts as a flat-file database of a workflow. A YAML file is automatically 
included in the project directory that specifies the basic location of the workflow project. 
Every time the `SAL` container is updated in R with a new workflow step or a modification 
to an existing step, the changes are automatically recorded in the flat-file database. This
is important for tracking the run status of workflows and providing restart functionality for 
workflows. 

```{r SPRproject1a, eval=FALSE}
sal <- SPRproject() 
```

If `overwrite` is set to `TRUE`, a new project log directory will be created and any existing 
one deleted. This option should be used with caution. It is mainly useful when developing 
and testing workflows, but should be avoided in production runs of workflows.

```{r SPRproject1, eval=TRUE}
sal <- SPRproject(projPath = getwd(), overwrite = TRUE) 
```

The function checks whether the expected workflow directories (see [here](#wf-directories)) exist,
and will create them if any of them is missing. If needed users can change the default names of 
these directories as shown.

```{r SPRproject_dir, eval=FALSE}
sal <- SPRproject(data = "data", param = "param", results = "results") 
```

Similarly, the default names of the log directory and `YAML` file can be changed.

```{r SPRproject_logs, eval=FALSE}
sal <- SPRproject(logs.dir= ".SPRproject", sys.file=".SPRproject/SYSargsList.yml") 
```

It is also possible to use for all workflow steps a dedicated R environment
that is separate from the current environment. This way R objects generated by
workflow steps will not overwrite objects with the same names in the current environment.

```{r SPRproject_env, eval=FALSE}
sal <- SPRproject(envir = new.env()) 
```

At this stage, `sal` is an empty `SAL` (`SYSargsList`) container that only contains
the basic information about the project's directory structure that can be accessed with 
`projectInfo`.

```{r projectInfo, eval=TRUE}
sal
projectInfo(sal)
```

The number of workflow steps stored in a `SAL` object can be returned with the `length` function. At this stage
it returns zero since no workflow steps have been loaded into `sal` yet. 

```{r length, eval=TRUE}
length(sal)
```

## Constructing workflows

In systemPipeR, workflows can be incrementally constructed in [interactive mode](#appendstep)
by sequentially evaluating code for individual workflow steps in the R console.
Alternatively, all steps of a workflow can be imported simultaneously from an R
script or an R Markdown workflow file using a [single import command](#importWF).
To explain constructing and connecting different types of workflow steps, this
tutorial section introduces the interactive approach first. After that, the
automated import of entire workflows with many steps is explained, where the
individual steps are defined the same way.
In all cases, workflow steps are loaded into a `SAL` workflow container with the
proper connectivity information using `systemPipeR's` `appendStep` method. This
method allows steps to be comprised of R code or CL calls.

### Stepwise construction  {#appendstep}

The following demonstrates how to design, load and run workflows using a simple
data processing routine as an example. This mini workflow will export a test
dataset to multiple files, compress/decompress the exported files, import them back 
into R, and then perform a simple statistical analysis and plot the results. The file 
compression steps demonstrate the usage of the CL interface.

The `sal` object of the new workflow project (directory named`.SPRproject`) was
intialized in the previous section. At this point this `sal` instance contains
no data analysis steps since none have been loaded so far.

```{r sal_check, eval=TRUE}
sal
```

Next, workflow steps will be added to `sal`.

#### Step 1: R step 

The first step in the chosen example workflow comprises R code that will be
stored in a `LineWise` object. It is constructed with the `LineWise` function,
and then appended to `sal` with the  `appendStep<-` method. The R code of an
analysis step is assigned to the `code` argument of the `LineWise` function. In this
assignment the R code has to be enclosed by braces (`{...}`) and separted from
them by new lines. Additionally, the workflow step should be given a descriptive name
under the `step_name` argument. Step names are required to be unique throughout
workflows. During the construction of workflow steps, the included R code will
not be executed. The execution of workflow steps is explained in a separate
section [below](#wf-execution).

In the given code example, the `iris` dataset is split by the species
names under the `Species` column, and then the resulting `data.frames` are
exported to three tabular files. 


```{r, firstStep_R, eval=TRUE}
appendStep(sal) <- LineWise(code = {
                              mapply(function(x, y) write.csv(x, y),
                                     split(iris, factor(iris$Species)),
                                     file.path("results", paste0(names(split(iris, factor(iris$Species))), ".csv"))
                                     ) 
                            },
                            step_name = "export_iris")
```

After adding the R code, `sal` contains now one workflow step.

```{r show, eval=TRUE}
sal
```

To extract the code of an R step stored in a `SAL` object, the `codeLine` method can be used.

```{r codeLine, eval=TRUE}
codeLine(sal)
```

#### Step 2: CL step {#cmd-step}

CL steps are stored as `SYSargs2` objects that are constructed with the
`SYSargsList` function, and then appended to `sal` with the `appendStep<-`
method. As outlined in the introduction (see [here](#cl-interface)), CL steps
are defined by two CWL parameter files (`yml` configuration and `cwl` step
definition files) and an optional `targets` file. How parameter values in the
`targets` file are passed on to the corresponding entries in the `yml` file, is
defined by a `named vector` that is assigned to the `inputvars` argument of the
`SYSargsList` function. A parameter connection is established if a name assigned to
`inputvars` has matching column and element names in the `targets` and `yml` files, 
respectively (Fig \@ref(fig:sprandCWL)). More details about parameter passing and CWL 
syntax are provied below (see [here](#cwl_targets) and [here](#cwl)). 

The most important other arguments of the `SYSargsList` function are listed below. For more 
information, users want to consult the function's help with `?SYSargsList`.

  - `step_name`: a unique *name* for the step. If no name is provided, a default 
    `step_x` name will be assigned, where `x` is the step index.
  - `dir`: if `TRUE` (default) all output files generated by a workflow step will be written to a 
    subdirectory with the same name as `step_name`. This is useful for organizing result files. 
  - `dependency`: assign here the name of the step the current step depends on. This is mandatory 
    for all steps in a workflow, except the first one. The dependency tree of a workflow is 
    based on the dependency connections among steps.

In the specific example code given below, a CL step is added to the workflow where the
[`gzip`](https://www.gnu.org/software/gzip/) software is used to compress the
files that were generated in the previous step. 

```{r gzip_secondStep, eval=TRUE}
targetspath <- system.file("extdata/cwl/gunzip", "targets_gunzip.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "gzip", 
                      targets = targetspath, dir = TRUE,
                      wf_file = "gunzip/workflow_gzip.cwl", input_file = "gunzip/gzip.yml",
                      dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                      inputvars = c(FileName = "_FILE_PATH_", SampleName = "_SampleName_"), 
                      dependency = "export_iris")
```

After adding the above CL step, `sal` contains now two steps. 

```{r}
sal
```

The individual CL calls, that will be executed by the `gzip` step, can be rendered and viewed 
with the `cmdlist` function. Under the `targets` argument one can subset the CL calls to 
specific samples by assigning the corresponding names or index numbers.

```{r}
cmdlist(sal, step = "gzip")
# cmdlist(sal, step = "gzip", targets=c("SE"))
```

#### Step 3: CL with input from previous step

In many use cases the output files, generated by an upstream workflow step, serve as input 
to a downstream step. To establish these input/output connections, the names (paths) of the 
output files generated by each step needs to be accessible. This information
can be extracted from `SAL` objects with the `outfiles` accessor method as shown below. 

```{r}
# outfiles(sal) # output files of all steps in sal
outfiles(sal)['gzip'] # output files of 'gzip' step
# colnames(outfiles(sal)$gzip) # returns column name passed on to `inputvars`
```

Note, the names of this and other important accessor methods for 'SAL' objects
can be looked up conveniently with `names(sal)` (for more details see [here](#accessor-methods)). 

In the chosen workflow example, the output files (here compressed `gz` files), that
were generated by the previous `gzip` step, will be uncompressed in the current step with the
`gunzip` software. The corresponding input files for the `gunzip` step are listed under the 
`gzip_file` column above. For defining the `gunzip` step, the values 'gzip' and 'gzip_file' 
will be used under the `targets` and `inputvars` arguments of the `SYSargsList` function, 
respectively. The argument `rm_targets_col` allows to drop columns in the `targets` 
instance of the new step. The remaining parameters settings are similar to those in the 
previous step. 


```{r gunzip, eval=TRUE}
appendStep(sal) <- SYSargsList(step_name = "gunzip", 
                      targets = "gzip", dir = TRUE,
                      wf_file = "gunzip/workflow_gunzip.cwl", input_file = "gunzip/gunzip.yml",
                      dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                      inputvars = c(gzip_file = "_FILE_PATH_", SampleName = "_SampleName_"), 
                      rm_targets_col = "FileName", 
                      dependency = "gzip")
```

After adding the above new step, `sal` contains now a third step. 

```{r}
sal
```

The `targets` instance of the new step can be returned with the `targetsWF` method
where the output files from the previous step are listed under the first column (input).

```{r targetsWF_3, eval=TRUE}
targetsWF(sal['gunzip'])
```

As before, the output files of the new step can be returned with `outfiles`. 

```{r outfiles_2, eval=TRUE}
outfiles(sal['gunzip'])
```

Finally, the corresponding CL calls of the new step can be returned with the `cmdlist` 
function (here for first entry).

```{r, eval=TRUE}
cmdlist(sal["gunzip"], targets = 1)
```

#### Step 4: R with input from previous step 

The final step in this sample workflow is an R step that uses the files from a previous
step as input. In this case the `getColumn` method is used to obtain the paths to the files
generated in a previous step, which is in the given example the 'gunzip' step.. 

```{r getColumn, eval=TRUE}
getColumn(sal, step = "gunzip", 'outfiles')
```

In this R step, the tabular files generated in the previous `gunzip` CL step
are imported into R and row appended to a single `data.frame`. Next the
column-wise mean values are calculated for the first four columns.
Subsequently, the results are plotted as a bar diagram with error bars. 

```{r, iris_stats, eval=TRUE}
appendStep(sal) <- LineWise(code = {
                    df <- lapply(getColumn(sal, step = "gunzip", 'outfiles'), function(x) read.delim(x, sep = ",")[-1])
                    df <- do.call(rbind, df)
                    stats <- data.frame(cbind(mean = apply(df[,1:4], 2, mean), sd = apply(df[,1:4], 2, sd)))
                    stats$size <- rownames(stats)
                    
                    plot <- ggplot2::ggplot(stats, ggplot2::aes(x = size, y = mean, fill = size)) + 
                      ggplot2::geom_bar(stat = "identity", color = "black", position = ggplot2::position_dodge()) +
                      ggplot2::geom_errorbar(ggplot2::aes(ymin = mean-sd, ymax = mean+sd), width = .2, position = ggplot2::position_dodge(.9)) 
                    },
                    step_name = "iris_stats", 
                    dependency = "gzip")
```

This is the final step of this demonstration resulting in a `sal` workflow container with
a total of four steps. 

```{r}
sal
```

### Load workflow from R or Rmd scripts{#importWF}

The above process of loading workflow steps one-by-one into a `SAL` workflow
container can be easily automated by storing the step definitions in an R or
Rmd script, and then importing them from there into an R session. 

__1. Loading workflows from an R script.__ For importing workflow steps from an
R script, the code of the workflow steps needs to be stored in an R script
from where it can be imported with R's `source` command. Applied to
the above workflow example (see [here](appendstep)), this means nothing else 
than saving the code of the four workflow steps to an R script where each step is declared 
with the standard CL or R step syntax: `appendStep(sal) <- SYSargsList/LineWise(...)`. 
At the beginning of the R script one has to load the `systemPipeR` library, and 
initialize a new workflow project and associated `SAL` container with `SPRproject()`. 
After sourcing the R script from R, the fully populated `SAL` container will be 
loaded into that session, and the workflow is ready to be executed (see below).

__2. Loading workflows from an R Markdown file.__ As an alternative to plain R
scripts, R Markdown (Rmd) scripts provide a more adaptable solution for
defining workflows. An Rmd file can be converted into various publication-ready
formats, such as HTML or PDF. These formats can incorporate not only the
analysis code but also the results the code generates, including tables and figures.
This approach enables the creation of reproducible analysis reports for
workflows. This reporting feature is crucial for reproducibility,
documentation, and visual interpretation of the analysis results. The following illustrates this
approach for the same four workflow steps used in the previous section [here](#appendstep), 
that is included in an Rmd file of the `systemPipeR` package. Note, the path to this Rmd file
is retrieved with R's `system.file` function. 

Prior to importing the workflow from an Rmd file, it is required to initialize for it a new 
workflow project with the `SPRproject` function. Next, the `importWF` function is used to scan 
the Rmd file for code chunks that define workflow steps, and subsequently import them in to the 
`SAL` workflow container of the project. 

```{r importWF_rmd, eval=TRUE}
sal_rmd <- SPRproject(logs.dir = ".SPRproject_rmd") 

sal_rmd <- importWF(sal_rmd, 
                file_path = system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR"))
```

After the import, the new `sal_rmd` workflow container, that is fully populated with all four workflow 
steps from [before](#appendstep), can be inspected with several accessor functions (not 
evaluated here). Additional details about accessor functions are provided [here](#accessor-methods).

```{r importWF_details, eval=FALSE}
sal_rmd
stepsWF(sal_rmd)
dependency(sal_rmd)
cmdlist(sal_rmd)
codeLine(sal_rmd)
targetsWF(sal_rmd)
statusWF(sal_rmd)
```

#### Define workflow steps in R Markdowns {#linewise_rmd}

In standard R Markdown (Rmd) files, code chunks are enclosed by new lines
starting with three backticks. The backtick line at the start of a code chunk
is followed by braces that can contain arguments controlling the code chunk's
behavior. To formally declare a workflow step in an R Markdown file's argument
line, `systemPipeR` introduces a special argument named `spr`. When
using `importWF` to scan an R Markdown file, only code chunks with `spr=TRUE` in
their argument line will be recognized as workflow steps and loaded into the
provided `SAL` workflow container. This design allows for the inclusion of
standard code chunks not part of a workflow and renders them as usual. Here are
two examples of argument settings that will both result in the inclusion of the
corresponding code chunk as a workflow step since `spr` is set to `TRUE` in both
cases. Notably, in one case, the standard R Markdown argument `eval` is assigned
`FALSE`, preventing the `rmarkdown::render` function from evaluating the
corresponding code chunk.

Examples: workflow code chunks are declared by `spr` flag in their argument line:

+ *```{r step_1, eval=TRUE, spr=TRUE}*
+ *```{r step_2, eval=FALSE, spr=TRUE}*


In addition to including `spr = TRUE`, the actual code of workflow steps has additional 
requirements. First, the last assignment in a code chunk of a workflow step needs to be an 
`appendStep` of `SAL` using `SYSargsList` or `LineWise` for CL or R code, respectively. This 
requirement is met if there are no other assignments outside of `appnedStep`. Second,
R workflow steps need to be largely self contained by generating and/or loading the dependencies 
required to execute the code. Third, in most cases the name of a `SAL` container should remain 
the same throughout a workflow. This avoids errors such as: _'Error: <objectName> object not found'_.

Example of last assignment in a CL step.

```{r fromFile_example_rules_cmd, eval=FALSE}
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "Example", 
                      targets = targetspath, 
                      wf_file = "example/example.cwl", input_file = "example/example.yml", 
                      dir_path = system.file("extdata/cwl", package = "systemPipeR"), 
                      inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
```

Example of last assignment in an R step.

```{r fromFile_example_rules_r, eval=FALSE}
appendStep(sal) <- LineWise(code = {
                              library(systemPipeR)
                            },
                            step_name = "load_lib")
```

# Running workflows {#wf-execution}

## Overview

In `systemPipeR`, the `runWF` function serves as the primary tool for executing
workflows. It is responsible for running the code specified in the steps of a
populated `SAL` workflow container. The following `runWF` command  will run the 
test workflow from above from start to finish. This test workflow was first assembled step-by-step, 
allowing for a thorough examination of its behavior. Subsequently, the same workflow 
was imported from an Rmd file to demonstrate how to auto-load all steps of a workflow 
at once into a `SAL` container. Please refer to the provided link [here](#appendstep) 
for more information about this process.

```{r runWF, eval=is_win}
sal <- runWF(sal)
```

The `runWF` function allows to choose one or multiple steps to be executed via
its `steps` argument. When using partial workflow executions, it is important
to pay attention to the requirements of the dependency graph of a workflow. If
a selected step depends on one or more previous steps, that have not been
executed yet, then the execution of the chosen step(s) will not be possible
until the previous steps have been completed. 

```{r runWF_error, eval=FALSE}
sal <- runWF(sal, steps = c(1,3))
```

Importantly, by default, already completed workflow steps with a status of '`Success`' (for
example, all output files exist) will not be repeated unnecessarily unless one explicitly sets
the force parameter to TRUE. Skipping such steps can save time, particularly
when optimizing workflows or adding new samples to previously completed runs.
Additionally, one may find it useful in certain situations to ignore warnings or 
errors without terminating workflow runs. This behavior can be enabled by setting
`warning.stop=TRUE` and/or `error.stop=TRUE`.


```{r runWF_force, eval=FALSE}
sal <- runWF(sal, force = TRUE, warning.stop = FALSE, error.stop = TRUE)
```

When starting a new workflow project with the `SPRproject` function, a new R environment
will be initialized that stores the objects generated by the workflow steps. The content
of this R environment can be inspected with the `viewEnvir` function.

```{r runWF_env, eval=FALSE}
viewEnvir(sal)
```

The `runWF` function saves the new R environment to an `rds` file under `.SPRproject` when `saveEnv=TRUE`, which 
is done by default. For additional details, users want to consult the corresponding help document 
with `?runWF`. 

```{r runWF_saveenv, eval=FALSE}
sal <- runWF(sal, saveEnv = TRUE)
```

A status summary of the executed workflows can be returned by typing `sal`.  

```{r show_statusWF_details1, eval=TRUE}
sal
```

Several accessor functions can be used to retrieve additional information about
workflows and their run status. The code box below lists these functions,
omitting their output for brevity. Although some of these functions have been
introduced above already, they are included here again for easy reference. Additional, 
details on these functions can be found [here](#sysargslist).

```{r show_statusWF_details2, eval=FALSE}
stepsWF(sal)
dependency(sal)
cmdlist(sal)
codeLine(sal)
targetsWF(sal)
statusWF(sal)
projectInfo(sal)
```

While `SAL` objects are autosaved when working with workflows, it
can be sometimes safer to explicity save the object before closing R.

```{r save_sal, eval=FALSE}
sal <- write_SYSargsList(sal)
```

## Module system {#module-system}

Some computing systems, such as HPC clusters, allow users to load software via
an [Environment Modules](https://modules.sourceforge.net/) system into their
`PATH`. If a module system is available, the function `module` allows to
interact with it from within R. Specific actions are controlled by values
passed on to the `action_type` argument of the `module` function, such as
loading and unloading software with `load` and `unload`, respectively.
Additionally, dedicated functions are provided for certain actions. The
following code examples are not evaluated since they will only work on systems where
an Environment Modules software is installed. A full list of actions and
additional functions for Environment Modules can be accessed with `?module`.

```{r module_cmds, eval=FALSE}
module(action_type="load", module_name="hisat2")
moduleload("hisat2") # alternative command
moduleunload("hisat2")
modulelist() # list software loaded into current session
moduleAvail() # list all software available in module system
```

Note, the module load/unload actions can be defined in the R/Rmd workflow
scripts or in the CWL parameter files. The `listCmdModules` function can be
used, to list the names and versions of all software tools that are loaded via
Environment Modules in each step of a `SAL` workflow container. Independent of
the usage of an Environment Modules system, all CL software used by each step
in a workflow can be listed with `listCmdTools`. The output of both fumction
calls is not shown below for the same reason as in the previous code chunk.

```{r list_module, eval=FALSE}
listCmdModules(sal)
listCmdTools(sal)
```

## Parallel evaluation

The processing time of computationally expensive steps can be greatly accelerated by
processing many input files in parallel using several CPUs and/or computer nodes 
of an HPC or cloud system, where a scheduling system is used for load balancing. 
To simplify for users the configuration and execution of workflow steps in serial or parallel mode, 
`systemPipeR` uses for both the same `runWF` function. Parallelization simply 
requires appending of the parallelization parameters to the settings of the corresponding workflow
steps each requesting the computing resources specified by the user, such as
the number of CPU cores, RAM and run time. These resource settings are
stored in the corresponding workflow step of the `SAL` workflow container.
After adding the parallelization parameters, `runWF` will execute the chosen steps 
in parallel mode as instructed. 

The following example applies to an alignment step of an RNA-Seq workflow. The
above demonstration workflow is not used here since it is too simple to benefit
from parallel processing. In the chosen alignment example, the parallelization
parameters are added to the alignment step (here `hisat2_mapping`) of `SAL` via
a `resources` list. The given parameter settings will run 18 processes (`Njobs`) in
parallel using for each 4 CPU cores (`ncpus`), thus utilizing a total of 72 CPU
cores. The `runWF` function can be used with most queueing systems as it is based on
utilities defined by the `batchtools` package, which supports the use of
template files (_`*.tmpl`_) for defining the run parameters of different
schedulers. In the given example below, a `conffile` (see
_`.batchtools.conf.R`_ samples [here](https://mllg.github.io/batchtools/)) and
a `template` file (see _`*.tmpl`_ samples
[here](https://github.com/mllg/batchtools/tree/master/inst/templates)) need to be present
on the highest level of a user's workflow project. The following example uses the sample
`conffile` and `template` files for the Slurm scheduler that are both provided by this
package. 

The `resources` list can be added to analysis steps when a workflow is loaded into `SAL`. 
Alternatively, one can add the resource settings with the `addResources` function 
to any step of a pre-populated `SAL` container afterwards. For workflow steps with the same resource 
requirements, one can add them to several steps at once with a single call to `addResources` by 
specifying multiple step names under the `step` argument.

```{r runWF_cluster, eval=FALSE}
resources <- list(conffile=".batchtools.conf.R",
                  template="batchtools.slurm.tmpl", 
                  Njobs=18, 
                  walltime=120, ## in minutes
                  ntasks=1,
                  ncpus=4, 
                  memory=1024, ## in Mb
                  partition = "short"  
                  )
sal <- addResources(sal, step=c("hisat2_mapping"), resources = resources)
sal <- runWF(sal)
```

The above example will submit via `runWF(sal)` the *hisat2_mapping* step
to a partition (queue) called `short` on an HPC cluster. Users need to adjust this and
other parameters, that are defined in the `resources` list, to their cluster environment .

# Visualize workflows {#visualize-wf}

Workflows instances can be visualized as topology graphs with the `plotWF` function.
The resulting plot includes the following information.

+ Workflow topology graph rendered based on dependencies among steps
+ Workflow step status, e.g. Success, Error, Pending, Warnings
+ Sample status and statistics
+ Run time of individual steps

If no layout parameters are provided, then `plotWF` will automatically detect reasonable settings
for a user's system, including width, height, layout, plot method, branch styles and others.

```{r, eval=TRUE}
plotWF(sal, show_legend = TRUE, width = "80%", rstudio = TRUE)
```

For more details about the `plotWF` function, please visit its help with `?plotWF`.

# Report generation

`systemPipeR` produces two report types: Scientific and Technical. The
Scientific Report resembles a scientific publication detailing data analysis,
results, interpretation information, and user-provided text. The Technical
Report provides logging information useful for assessing workflow steps and
troubleshooting problems.

## Scientific reports

After a workflow run, `systemPipeR's` `renderReport` or `rmarkdown's` `render`
function can be used to generate  Scientific Reports in HTML, PDF or other
formats. The former uses the final `SAL` instance as input, and the latter the
underlying Rmd source file. The resulting reports mimic research papers by combining
user-generated text with analysis results, creating reproducible analysis
reports. This reporting infrastructure offers support for citations,
auto-generated bibliographies, code chunks with syntax highlighting, and inline
evaluation of variables to update text content. Tables and figures in a report
can be automatically updated when the document is rebuilt or workflows are
rerun, ensuring data components are always current. This automation increases
reproducibility and saves time creating Scientific Reports. Furthermore, the
workflow topology maps described earlier can be incorporated into Scientific
Reports, enabling integration between Scientific and Technical Reports. 

```{r, eval=FALSE}
sal <- renderReport(sal)

rmarkdown::render("my.Rmd", clean = TRUE, output_format = "BiocStyle::html_document") 
```
Note, `my.Rmd` in the last code line needs to be replaced with the name (path) of 
the source `Rmd` file used for generating the `SAL` workflow container. 

## Technical report

The package collects technical information about workflow runs in a project’s
log directory (default name: `.SPRproject`). After partial or full completion
of a workflow, the logging information of a run is used by the `renderLog`
function to generate a Technical Report in HTML or other formats. The report
includes software execution commands, warnings and errors messages of each
workflow step. Easy visual navigation of Technical Reports is provided by
including an interactive instance of the corresponding workflow topology graph.
The technical details in these reports help assess the success of each workflow
step and facilitate troubleshooting.

```{r, eval=FALSE}
sal <- renderLogs(sal)
```

# Converting workflows to Bash and Rmd

The SAL workflow containers of `systemPipeR` provide versatile conversion and
export options to both Rmd and executable Bash scripts. This feature not only
enhances the portability and reusability of workflows across different systems
but also promotes transparency, enabling efficient testing and
troubleshooting.

## R Markdown script

A populated `SAL` workflow container can be converted to an Rmd file using the
`sal2rmd` function. If needed, this `Rmd` file can be used to construct a `SAL`
workflow container with the `importWF` function as introduced above. This
functionality is useful for building templates of workflow Rmds and sharing
them with other systems. 

```{r, eval=FALSE}
sal2rmd(sal)
```

## Bash script {#bash-script}

The `sal2bash` function converts and exports workflows stored in SAL containers
into executable Bash scripts. This enables users to run their workflows as Bash
scripts from the command line. The function takes a SAL container as input and
generates a `spr_wf.sh` file in the project's root directory as output.
Additionally, it creates a `spr_bash` directory that stores all R-based workflow
steps as separate R scripts. To minimize the number of R scripts needed, the 
function combines adjacent R steps into a single file. 

```{r, eval=FALSE}
sal2bash(sal)
```

# Restarting and resetting workflows

The ability to restart existing workflows projects is important for continuing analyses that could not 
be completed, or to make changes without repeating already completed steps. Two main options are provided
to restart workflows. Another option is provided that resets workflows to the very beginning, which effectively
deletes the previous environment.

__1. The `resume=TRUE` option__ will initialize the latest instance of a `SAL` object stored in the `logs.dir`
   including its log files. When this option is used, a workflow can be continued where it was left off, 
   for example after closing and restarting R from the same directory on the same system. If the project was created
   with custom directory and/or file names, then those names need to be specified under the `log.dir` and `sys.file` 
   arguments of the `SPRproject` function, respectively, otherwise the default names will be used. 

```{r SPR_resume, eval=FALSE}
sal <- SPRproject(resume = TRUE) 
```

If the R environment was saved, one can recover with `load.envir=TRUE` all
objects that were created during the previous workflow run. The same is possible with 
the `restart` option. For more details, please consult the help for the `runWF` function. 

```{r resume_load, eval=FALSE}
sal <- SPRproject(resume = TRUE, load.envir = TRUE) 
```

After resuming the workflow with `load.envir` enabled, one can inspect the objects 
created in the old environment, and decide if it is necessary to copy them to the
current environment.

```{r envir, eval=FALSE}
viewEnvir(sal)
copyEnvir(sal, list="plot", new.env = globalenv())
```

__2. The `restart=TRUE` option__ will also use the latest instance of the `SAL` object stored in 
   the `logs.dir`, but the previous log files will be deleted.


```{r restart_load, eval=FALSE}
sal <- SPRproject(restart = TRUE) 
```

__3. The `overwrite=TRUE` option__ will reset the workflow project to the very beginning by deleting the 
   `log.dir` directory (`.SPRproject`) that stores the previous `SAL` instance and all its log files. At the same time 
   a new and empty ‘SAL’ workflow container will be created. This option should be used with caution
   since it will effectively delete the workflow environment. Output files written by the
   workflow steps to the `results` directory will not be deleted when this option is used. 

```{r SPR_overwrite, eval=FALSE}
sal <- SPRproject(overwrite = TRUE) 
```


# Additional utilities {#sysargslist}

This section describes methods for accessing, subsetting and modifying `SAL`
workflow objects.

## Accessor methods {#accessor-methods}

Workflows and their run status can be explored further using a range of
accessor functions for `SAL` objects. 

### General information

The number of steps in a workflow can be determined with the `length` function.

```{r}
length(sal)
```

The corresponding names of workflow steps can be returned with `stepName`.

```{r}
stepName(sal)
```

CL software used by each step in a workflow can be listed with `listCmdTools`.

```{r}
listCmdTools(sal)
```

Some computing systems (often HPC clusters) allow users to load CL software via 
an [Environment Modules](http://modules.sourceforge.net/) system into their PATH. 
If this is the case, then the exact verions of the software tools loaded via the 
module system can be listed for `SAL` and `SYSargs2` objects with `listCmdModules`
and `modules`, respectively. The example workflow used here 
does not make use of Environment Modules, and thus there are no software tools 
to list here. 

```{r}
listCmdModules(sal)
modules(stepsWF(sal)$gzip)
```

For more information on how to work with Environment Modules in `systemPipeR`, please
visit the help with `?module`, `?modules` and `?listCmdModules`.

### Slot data

Several accessor functions are named after the corresponding slot names in
`SAL` objects. This makes it easy to look them up with `names()`, and then
apply them to `sal` as the only argument, such as `runInfo(sal)`. 

```{r}
names(sal)
```

The individual workflow steps in a `SAL` container are stored as `SYSargs2` and `LineWise` 
components. They can be returned with the `stepsWF` function. 

```{r}
stepsWF(sal)
```

The accessor function of `SYSargs2` and `LineWise` objects can be returned similarly 
(here for `gzip` step). 

```{r}
names(stepsWF(sal)$gzip)
```

The `statusWF` function returns a status summary for each step in a `SAL` workflow instance. 

```{r}
statusWF(sal)
```

The `targets` instances for each step in a workflow can be returned with `targetsWF`. The 
below applies it to the second step.

```{r}
targetsWF(sal[2])
```

If a workflow contains sample comparisons, that have been specified in the header 
lines of a targets file starting with a `# <CMP> tag`, then they can be returned 
with the `targetsheader` functions. This does not apply to the current demo `sal` 
instance, and thus the function returns `NULL`. For more details, consult the `targets` 
file section [here](#targets-files).

```{r, eval=FALSE}
targetsheader(sal, step = "Quality")
```

The `outfiles` component of a `SAL` object stores the paths to the expected outfiles files 
for each step in a workflow. Some of them are the input for downstream workflow steps.

```{r}
outfiles(sal[2])
```

The `dependency` step(s) in a workflow can be obtained with the
`dependency` function. This information is used to construct the toplogy
graph of a workflow (see [here](#visualize-wf)). 

```{r}
dependency(sal)
```

The sample names (IDs) stored in the corresponding column of a targets file 
can be returned with the `SampleName` function. 

```{r}
SampleName(sal, step = "gzip")
```

The `getColumn` method can be used to obtain the paths to the files generated in a
specified step.

```{r}
getColumn(sal, "outfiles", step = "gzip", column = "gzip_file")
getColumn(sal, "targetsWF", step = "gzip", column = "FileName")
```

The `yamlinput` function returns the parameters of a workflow step defined in the 
corresponding yml file.

```{r}
yamlinput(sal, step = "gzip")
```

### CL and R code {#cl-and-r}

The exact syntax for running CL software on each input data set in a workflow can 
be returned with the `cmdlist` function. The CL calls are assembled from the corresponding
`yml` and `cwl`, and an optional `targets` file as described in the above CLI section
[here](#cl-interface). The example below shows the CL syntax for running `gzip`
and `gunzip` on the first input sample. Evaluating the output of `cmdlist` can
be very helpful for designing and debugging CWL parameter files to support new CL
software or changing their settings.

```{r}
cmdlist(sal, step = c(2,3), targets = 1)
```

Similarly, the `codeLine` function returns the R code of a `LineWise` workflow step.

```{r}
codeLine(sal, step = "export_iris")
```

### R environment

The objects generated in a workflow's run environment can be accessed with `viewEnvir`.

```{r}
viewEnvir(sal)
```

If needed one or multiple objects can be copied from the run environment of a workflow 
to the current environment of an R session.

```{r}
copyEnvir(sal, list = c("plot"), new.env = globalenv(), silent = FALSE)
```

## Subsetting workflows

The bracket operator can be used to subset workflow by steps. For instance, the current
instance of `sal` has four steps, and `sal[1:2]` will subset the workflow to the first two 
steps. 

```{r}
length(sal)
sal[1:2]
```

In addition to subsetting by steps, one can subset workflows by input samples. The following
illustrates this for the first two input samples, but omits the function output for brevity.

```{r, eval=FALSE}
sal_sub <- subset(sal, subset_steps = c(2,3), input_targets = c("SE", "VE"), keep_steps = TRUE)
stepsWF(sal_sub)
targetsWF(sal_sub)
outfiles(sal_sub)
```

For appending workflow steps, one can use the `+` operator.

```{r, eval=FALSE}
sal[1] + sal[2] + sal[3]
```

## Replacement methods

Replacement methods are implemented to make adjustments to certain paramer settings and
R code in workflow steps.  

### Changing parameters

```{r, eval=TRUE}
## create a copy of sal for testing
sal_c <- sal
## view original value, here restricted to 'ext' slot
yamlinput(sal_c, step = "gzip")$ext
## Replace value under 'ext' 
yamlinput(sal_c, step = "gzip", paramName = "ext") <- "txt.gz"
## view modified value, here restricted to 'ext' slot
yamlinput(sal_c, step = "gzip")$ext
## Evaluate resulting CL call
cmdlist(sal_c, step = "gzip", targets = 1)
```

### Changes to R steps {#change-r-step} 

Code lines can be added with `appendCodeLine` to R steps (`LineWise`) as shown in the 
following example. 

```{r, sal_lw_rep, eval=TRUE}
appendCodeLine(sal_c, step = "export_iris", after = 1) <- "log_cal_100 <- log(100)"
codeLine(sal_c, step = "export_iris")
```

In addition, code lines can be replaced with the `replaceCodeLine` function.
For additional details about the `LineWise` class, please see the example
[above](#appendstep) and the detailed description of the `LineWise` class
[here](#linewise).

```{r, sal_lw_rep2, eval=TRUE}
replaceCodeLine(sal_c, step="export_iris", line = 2) <- LineWise(code={
                    log_cal_100 <- log(50)
                    })
codeLine(sal_c, step = "export_iris")
```

Renaming of workflow steps is possible with the `renameStep` function.

```{r}
renameStep(sal_c, c(1, 2)) <- c("newStep2", "newIndex")
sal_c
names(outfiles(sal_c))
names(targetsWF(sal_c))
dependency(sal_c)
```

### Replacing workflow steps

The `replaceStep` function can be used to replace entire workflow steps. When
replacing workflow steps, it is important to maintain a valid dependency graph
among the affected steps. 

```{r, eval=FALSE}
sal_test <- sal[c(1,2)]
replaceStep(sal_test, step = 1, step_name = "gunzip" ) <- sal[3]
sal_test
```

If needed, workflow steps can be removed as follows. 

```{r}
sal_test <- sal[-2]
sal_test
```


# CWL specifications {#cwl}

This section provides a concise overview of [CWL](https://www.commonwl.org/user_guide/topics/) 
and its utilization within `systemPipeR`. It covers fundamental CWL concepts, including 
the `CommandLineTool` and `Workflow` classes for describing individual CL processes and 
workflows. For further details, readers want to refer to CWL's comprehensive
[CommandLineTool](https://www.commonwl.org/user_guide/topics/command-line-tool.html) and 
[Workflow](https://www.commonwl.org/user_guide/topics/workflows.html) documentation, as well 
as the examples provided in CWL's [Beginner Tutorial](https://carpentries-incubator.github.io/cwl-novice-tutorial/) 
and [User Guide](https://www.commonwl.org/user_guide/). Additionally, familiarizing oneself 
with [CWL's YAML](https://www.commonwl.org/user_guide/topics/yaml-guide.html) format 
specifications can be beneficial.

As illustrated in the introduction ([Fig 2](#cl-interface)), CWL files with the '`.cwl`' 
extension define the parameters of a specific CL step or workflow, while files
with the '`.yml`' extension define their input values.

## CWL `CommandLineTool` {#cwl-clt}

A Command Line Tool (`CommandLineTool` class) specifies a standalone process
that can be run by itself (without including interactions with other
programs), and has inputs and outputs.

The following inspects the basic structure of a '`.cwl`' sample file for a `CommandLineTool` 
that is provided by this package. 

```{r}
dir_path <- system.file("extdata/cwl", package = "systemPipeR")
cwl <- yaml::read_yaml(file.path(dir_path, "example/example.cwl"))
```
Important components include:

__1.__ `cwlVersion`: version of CWL specification used by file.

__2.__ `class`: declares description of a `CommandLineTool`. 

```{r}
cwl[1:2]
```

__3.__ `baseCommand`: name of CL tool.

```{r}
cwl[3]
```

__4.__ `inputs`: defines input information to run the tool. This includes:

- `id`: each input has an `id` including name.
- `type`: type of input value; one of `string`, `int`, `long`, `float`, `double`, 
    `File`, `Directory` or `Any`.
- `inputBinding`: indicates if the input parameter should appear in CL call. If 
      missing input will not appear in the CL call.

```{r}
cwl[4]
```

__5.__. `outputs`: list of expected outputs after running the CL tool. Important components are:

- `id`: each input has an `id` including name.
- `type`: type of output value; one of `string`, `int`, `long`, `float`, `double`, 
    `File`, `Directory`, `Any` or `stdout`);
- `outputBinding`: defines how to set outputs values; `glob` specifies output value's name. 

```{r}
cwl[5]
```

__6.__ `stdout`: specifies `filename` for standard output. Note, by default `systemPipeR` 
       constructs the output `filename` from `results_path` and `SampleName` (see above).

```{r}
cwl[6]
```

## CWL `Workflow` {#cwl-wf}

CWL's `Workflow` class describes one or more workflow steps, declares
their interdependencies, and defines how `CommandLineTools` are executed. 
Its CWL file includes inputs, outputs, and steps. 

The following illustrates the basic structure of a '`.cwl`' sample file for a `Workflow` 
that is provided by this package. 

```{r}
cwl.wf <- yaml::read_yaml(file.path(dir_path, "example/workflow_example.cwl"))
```

__1.__ `cwlVersion`: version of CWL specification used by file.

__2.__ `class`: declares description of a `Workflow` that describes one or 
       more `CommandLineTools` and their combined usage. 

```{r}
cwl.wf[1:2]
```

__3.__ `inputs`: defines the inputs of the workflow. 

```{r}
cwl.wf[3]
```

__4.__ `outputs`: defines the outputs of the workflow.

```{r}
cwl.wf[4]
```

__5.__ `steps`: describes the steps of the workflow. The example below shows one step.

```{r}
cwl.wf[5]
```

## CWL input values

The `.yml` file provides the input values for the parameters described above.
The following example includes input values for three parameters (`message`,
`SampleName` and `results_path`).

```{r}
yaml::read_yaml(file.path(dir_path, "example/example_single.yml"))
```

Note, the `.yml` file needs to provide input values for each input parameter 
specified in the corresponding `.cwl` file (compare `cwl[4]` above).

# Mappings among `cwl`, `yml` and `targets` {#cwl_targets}

This section illustrates how the parameters in CWL files (`cwl` and `yml`) are 
interconnected to construct CL calls of steps, and subsequently assembled 
to workflows. 

A `SAL` container (long name `SYSargsList`) stores all information and instructions 
needed for processing a set of inputs (incl. files) with a single or many CL steps within a workflow 
The `SAL` object is created and fully populated with the `SYSargsList` constructor
function. More detailed documentation of `SAL` workflow instances is available
[here](#appendstep) and [here](#sysargslist).

The following imports the `.cwl` and `.yml` files for running the `echo Hello World!`
example.

```{r fromFile, eval=TRUE}
HW <- SYSargsList(wf_file = "example/workflow_example.cwl", 
                  input_file = "example/example_single.yml", 
                  dir_path = system.file("extdata/cwl", package = "systemPipeR"))
HW
cmdlist(HW)
```

The example provided is restricted to creating a CL call for a single input
(sample). To process multiple inputs, a straightforward approach is to assign
variables to the corresponding parameters instead of using fixed (hard-coded)
values. These variables can then be assigned the desired input values
iteratively, resulting in multiple CL calls, one for each input value. The 
following illustrates this with an example, where the `message` and `SampleName` 
parameters are assigned variables that are labeled with tags of the form
`_XXX_`. These variables will be assigned values stored in a `targets` file. 


```{r}
yml <- yaml::read_yaml(file.path(dir_path, "example/example.yml"))
yml
```

The content of the `targets` file used for this example is shown below. The 
general structure of `targets` files is explained [above](#targets-files).

```{r}
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
read.delim(targetspath, comment.char = "#")
```

In the simple example given above the values stored under the `Message` and
`SampleName` columns of the targets file will be passed on to the corresponding
parameters with matching names in the `yml` file, and from there to
the `echo` command defined in the `cwl` file (see [here](#cwl-wf)). 
As mentioned previously, the usage of `targets` files is optional in
`systemPipeR`. Since `targets` files provide an easy and efficient solution for
organizing experimental variables, their usage is highly encouraged and well
supported in `systemPipeR`.

### Assembly of CL calls from three files

The `SYSargsList` function constructs `SAL` instances from the three parameter
files, that were introduced above (see [Fig 3](#cl-interface)). The path to each file is assigned to its own
argument: `wf_file` is assigned the path of a `cwl` workflow file, `input_file`
the path of a `yml` input file, and `targets` the path of a `targets` file. Additionally, a named
vector is provided under the `inputvars` argument that defines which column
values in the `targets` file are assigned to specific parameters in the `yml`
file. A parameter connection is established where a name in `inputvars` has
matching column and parameter names in the `targets` and `yml` files,
respectively (Fig 3). A tagging syntax with the pattern `_XXX_` is used to
indicate which parameters contain variables that will be assigned values from
the `targets` file. The usage of this pattern is only recommended for
consistency and easy identification, but not enforced.

The `SYSargslist` function call constructs the `echo` commands (CL calls) based on the 
parameters provided by the above described parameter file instances (`cwl`, `yml` and `targets`) 
as well as the variable mappings specified under the `inputvars` argument. 

```{r fromFile_example, eval=TRUE}
HW_mul <- SYSargsList(step_name = "echo", 
                      targets=targetspath, 
                      wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                      dir_path = dir_path, 
                      inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
HW_mul
```

The final CL calls (here `echo` command) can be returned with the `cmdlist` for
each string given under the `Message` column of the `targets` file. The values under
the `SampleName` column are used to name the corresponding output files, each with a
`txt` extension. 

```{r fromFile_example2, eval=TRUE}
cmdlist(HW_mul)
```

# Auto-creation of CWL files {#cwl-auto} 

To streamline the process of generating CWL parameter files (both `cwl` and
`yml`), users can simply provide the CL syntax for executing new software. This
action will automatically create the corresponding CWL parameter files, which
alleviates the need for manual creation of CWL files, reducing the
burden on users. This functionality is implemented in systemPipeR’s
`createParam` function group. 

## Expected CL syntax 

To use this functionality, CL calls need to be provided in a pseudo-bash script format
and stored as a `character vector`. 

The following uses as example a CL call for the HISAT2 software.

```{r cmd_orig, eval=FALSE}
hisat2 -S ./results/M1A.sam -x ./data/tair10.fasta -k 1 -min-intronlen 30 -max-intronlen 3000 -threads 4 -U ./data/SRR446027_1.fastq.gz
```

For the CL call above, the corresponding pseudo-bash syntax is given below.
Here, the CL string needs to be stored in a single slot of a `character vector`, 
here named `command`. The formatting requirements for the CL string will be explained
next.

```{r cmd, eval=TRUE}
command <- "
    hisat2 \
    -S <F, out: ./results/M1A.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: ./data/SRR446027_1.fastq.gz>
"
```

__Format specifications for pseudo-bash syntax (Version 1)__

- The syntax organizes each part of a CL string on a separate line. Each part is terminated by a backslash `\` at the end of a line.
- The first line contains the base command (`baseCommand`). It can include a subcommand, such as in `git commit` where `commit` is a subcommand. 
- Arguments are listed in the subsequent lines, one argument per line.
- Short- and long-form arguments are expected to start on a new line with one
  or two dashes, respectively, and are terminated by the first space on the
  same line, such as `-S` and `--min`. Values that should be assigned to
  arguments are placed inside `<...>`, also on the same line. Arguments and flags without 
  values lack this assignment. 
- The type of the input for arguments with assigned values is defined by a pattern of the form `<TYPE:`, where `TYPE` can be 
  `F` for "File", "int", "string", etc. 
- Optional: to indicate that an argument specifies CWL output, the flag `out` can be added after `TYPE` separated by a comma.
- Lines without a prefix will be treated as positional arguments. The line
  number defines the position of the argument in the CL.
- A colon `:` is used to separate keywords and default values. Any non-space value after the `:` will be treated as a default value. 

Note, the above specifications are Version 1 (`v1`) of the pseudo-bash syntax
used by the `createParam` function below. There also is a Version 2 (`v2`)
specification that supports additional features, but comes with more syntax
restrictions. Details on this are available in the help of the `createParam`
function. 

## `createParam` Function

The `createParam` function accepts as input a CL string that is formatted in the above 
pseudo-bash syntax. As output it creates the corresponding CWL files (`cwl` and `yml`) 
that will be written to the default directory: `./param/cwl/`. This path can be changed 
under the `file` argument. In addition, it constructs for the given CL string the corresponding
`SYSargs2` object (here assigned to `cmd`). The information printed as console output
contains the original CL string that is included for checking purposes. This CL string is 
not included to the resulting CWL files. 


```{r}
cmd <- createParam(command, writeParamFiles = TRUE, overwrite=TRUE, confirm=TRUE) 
```

Next, the `cmdlist` can be used to check the correctness of the CL call defined
by the CWL parameter files generated by the `createParam` command above. 

```{r}
cmdlist(cmd)
```

If the `createParam` function is executed without creating the CWL parameter files right 
away (argument setting `writeParamFiles=FALSE`) then these files can be generated in a 
separate step with `writeParamFiles`. 

```{r saving, eval=FALSE}
writeParamFiles(cmd, overwrite = TRUE)
```

## Example with `targets` file

The following gives a more complete example where the CWL files are first created for a CL string, 
and then loaded together with a `targets` file into a `SYSargs2` object. Next, the final CL calls 
are assembled for each input sample with the `renderWF` function. The final CL calls can then be 
inspected with the `cmdlist` function, where the below shows only the first 2 of a total of
18 CL calls for brevity.

```{r sysargs2, eval=TRUE, results="hide"}
command2 <- "
    hisat2 \
    -S <F, out: _SampleName_.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: _FASTQ_PATH1_>
"
WF <- createParam(command2, overwrite = TRUE, writeParamFiles = TRUE, confirm = TRUE) 
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
WF_test <- loadWorkflow(targets = targetspath, wf_file="hisat2.cwl",
                   input_file="hisat2.yml", dir_path = "param/cwl/hisat2/")
WF_test <- renderWF(WF_test, inputvars = c(FileName = "_FASTQ_PATH1_"))
```

```{r sysargs2b, eval=TRUE}
WF_test
cmdlist(WF_test)[1:2]
```

## Utilities for CWL files

The following introduces several accessor and replacement functions that are useful for
creating and revising CWL parameter files. 

### Printing components

```{r, eval=FALSE}
printParam(cmd, position = "baseCommand") ## Return baseCommand
printParam(cmd, position = "outputs") ## Return outputs
printParam(cmd, position = "inputs", index = 1:2) ## Return components by index
printParam(cmd, position = "inputs", index = -1:-2) ## Negative index subsetting
```

### Subsetting the CL strings

```{r, eval=FALSE}
cmd2 <- subsetParam(cmd, position = "inputs", index = 1:2, trim = TRUE)
cmdlist(cmd2)

cmd2 <- subsetParam(cmd, position = "inputs", index = c("S", "x"), trim = TRUE)
cmdlist(cmd2)
```

### Replacing existing arguments

```{r, eval=FALSE}
cmd3 <- replaceParam(cmd, "base", index = 1, replace = list(baseCommand = "bwa"))
cmdlist(cmd3) ## Replacement changed baseCommand
```

```{r, eval=FALSE}
new_inputs <- new_inputs <- list(
    "new_input1" = list(type = "File", preF="-b", yml ="myfile"),
    "new_input2" = "-L <int: 4>"
)
cmd4 <- replaceParam(cmd, "inputs", index = 1:2, replace = new_inputs)
cmdlist(cmd4)
```

### Adding new arguments

```{r, eval=FALSE}
newIn <- new_inputs <- list(
    "new_input1" = list(type = "File", preF="-b1", yml ="myfile1"),
    "new_input2" = list(type = "File", preF="-b2", yml ="myfile2"),
    "new_input3" = "-b3 <F: myfile3>"
)
cmd5 <- appendParam(cmd, "inputs", index = 1:2, append = new_inputs)
cmdlist(cmd5)

cmd6 <- appendParam(cmd, "inputs", index = 1:2, after=0, append = new_inputs)
cmdlist(cmd6)
```

### Editing `output` parameters

```{r, eval=FALSE}
new_outs <- list(
    "sam_out" = "<F: $(inputs.results_path)/test.sam>"
) 
cmd7 <- replaceParam(cmd, "outputs", index = 1, replace = new_outs)
output(cmd7) 
```

# Workflow step classes

The workflow steps of `SAL` (synonym `SYSargsList`) containers are composed of `SYSargs2` 
and/or `LineWise` objects. These two classes are introduced here in more detail.

## `SYSargs2` class {#sysargs2}

The `SYSargs2` class stores workflow steps that run CL software. An instance of
`SYSargs2` stores all the input/output paths and parameter components necessary
for executing a specific CL data analysis step. `SYSargs2` instances are
created using two constructor functions: `loadWF` and `renderWF`. These
functions make use of a `targets` (or `yml`) and the two CWL parameter files
`cwl` and `yml`. The structure and content for the CWL files are described
[above](#cwl). The following creates a `SYSargs2` instance using the `cwl` and
`yml` files for running the RNA-Seq read aligner HISAT2 [@Kim2015-ve]. Note,
when using the `SYSargsList` method for constructing workflow steps 
(see [here](#cmd-step)), then the user will not need to run the `loadWF` 
and `renderWF` directly. 


```{r SYSargs2_structure, eval=TRUE}
library(systemPipeR)
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
dir_path <- system.file("extdata/cwl", package = "systemPipeR")
WF <- loadWF(targets = targetspath, wf_file = "hisat2/hisat2-mapping-se.cwl",
                   input_file = "hisat2/hisat2-mapping-se.yml",
                   dir_path = dir_path)

WF <- renderWF(WF, inputvars = c(FileName = "_FASTQ_PATH1_", 
                                 SampleName = "_SampleName_"))
```

In addition to `SAL` objects (see [here](#cl-and-r)), the `cmdlist` function accepts 
`SYSargs2` to constructs CL calls based on the parameter inputs imported from the
corresponding `targets`, `yml` and `cwl` files. 

```{r cmdlist, eval=TRUE}
cmdlist(WF)[1]
```

Several accessor methods are available that are named after the slot names of
`SYSargs2` objects.

```{r names_WF, eval=TRUE}
names(WF)
```

The output components of `SYSargs2` define the expected output files for each
step in the workflow; some of which are the input for the next workflow step,
 _e.g._ a downstream `SYSargs2` instance.

```{r output_WF, eval=TRUE}
output(WF)[1]
```

The `targets` method allows access to the `targets` component of a `SYSargs2`
object. Refer to the information provided [above](#targets-files) for an
explanation of the `targets` file structure.

```{r, targets_WF, eval=TRUE}
targets(WF)[1]
as(WF, "DataFrame")
```

If CL software is loaded via an [Environment Modules](http://modules.sourceforge.net/) system
into a user's `PATH`, then this information can be accessed in `SYSargs2` objects as shown
below. For more details on working with Environment Modules, see [here](#module-system).

```{r, module_WF, eval=TRUE}
modules(WF)
```

Additional accessible information includes the location of the parameters files, 
`inputvars` (see [here](#cmd-step)) and more.

```{r, other_WF, eval=FALSE}
files(WF)
inputvars(WF)
```

## LineWise Class {#linewise}

To define R code as workflow steps, the `LineWise` class is used. The syntax
for declaring lines of R code as workflow steps in R or Rmd files is introduced
in the [workflow design](#linewise_rmd) section. The following showcases
additional utilities for `LineWise` objects.

```{r lw, eval=TRUE}
rmd <- system.file("extdata", "spr_simple_lw.Rmd", package = "systemPipeR")
sal_lw <- SPRproject(overwrite = TRUE)
sal_lw <- importWF(sal_lw, rmd, verbose = FALSE)
codeLine(sal_lw)
```

Coerce a `LineWise` object to a `list` object and vice versa.

```{r, lw_coerce, eval=TRUE}
lw <- stepsWF(sal_lw)[[2]]
## Coerce
ll <- as(lw, "list")
class(ll)
lw <- as(ll, "LineWise")
lw
```

Accessing basic information of `LineWise` objects. 

```{r, lw_access, eval=TRUE}
length(lw)
names(lw)
codeLine(lw)
codeChunkStart(lw)
rmdPath(lw)
```

Subsetting `LineWise` objects.

```{r, lw_sub, eval=TRUE}
l <- lw[2]
codeLine(l)
l_sub <- lw[-2]
codeLine(l_sub)
```

Replacement methods for changing R code in `LineWise` objects.

```{r, lw_rep, eval=TRUE}
replaceCodeLine(lw, line = 2) <- "5+5"
codeLine(lw)
appendCodeLine(lw, after = 0) <- "6+7"
codeLine(lw)
```

For comparison, similar replacement methods are available for `SAL` objects. They have been
covered [above](#change-r-step). 

```{r, sal_rep_append, eval=FALSE}
replaceCodeLine(sal_lw, step = 2, line = 2) <- LineWise(code={
                                                             "5+5"
                                                                })
codeLine(sal_lw, step = 2)

appendCodeLine(sal_lw, step = 2) <- "66+55"
codeLine(sal_lw, step = 2)

appendCodeLine(sal_lw, step = 1, after = 1) <- "66+55"
codeLine(sal_lw, step = 1)
```

# Supplemental Material

## Examples of CL software {#third-party-software-tools}

Here is a partial list of CL software for which `systemPipeR` includes CWL
parameter file templates. Notably, with the newly added auto-creation feature
for CWL files (see [here](#cwl-auto)), generating CWL parameter files for most CL 
tools has become straightforward. Thus, maintaining and extending this list will
not be necessary anymore.

```{r table_tools, echo=FALSE, message=FALSE}
library(magrittr)
SPR_software <- system.file("extdata", "SPR_software.csv", package = "systemPipeR")
software <- read.delim(SPR_software, sep = ",", comment.char = "#")
colors <- colorRampPalette((c("darkseagreen", "indianred1")))(length(unique(software$Category)))
id <- as.numeric(c((unique(software$Category))))
software %>%
  dplyr::mutate(Step = kableExtra::cell_spec(Step, color = "white", bold = TRUE,
   background = factor(Category, id, colors))) %>%
   dplyr::select(Tool, Step, Description) %>%
   dplyr::arrange(Tool) %>% 
  kableExtra::kable("html", escape = FALSE, col.names = c("Tool Name", "Description", "Step")) %>%
    kableExtra::kable_material(c("striped", "hover", "condensed")) %>%
    kableExtra::scroll_box(width = "80%", height = "500px")
```

To run any of the tools mentioned, users must ensure that the necessary
software is installed on their system and added to the `PATH`. There are
several methods to verify if the required tools/modules are installed. The
easiest method is automatically executed for users when they call the `importWF`
function, or just `tryCL(<base_command>)`. In the print message of `importWF`, all 
necessary tools and modules are automatically listed and checked for users. 
For additional tool validation methods, please refer to these instructions: 
[Five Minute Tutorial](#five-min), [Environment Modules](#module-system), and
[Managing Workflows](https://systempipe.org/sp/spr/sp_run/step_run/#before-running). 

```{r cleaning3, eval=TRUE, include=FALSE}
if (file.exists(".SPRproject")) unlink(".SPRproject", recursive = TRUE)
## NOTE: Removing previous project create in the quick starts section
```

## Data analysis functionalities

This section presents various data analysis functionalities that are valuable
for many workflows. Some of these functionalities are R functions, while others
are CWL interfaces to widely used CL software. A few of them are included for
historical reasons.

## Project initialization

To work with the following examples a new workflow project needs to be created.
The below includes the `overwrite=TRUE` setting to remove any already 
project directory.

```{r SPRproject2, eval=FALSE}
sal <- SPRproject(projPath = getwd(), overwrite = TRUE) 
```

The first step in the new workflow project is to load the `systemPipeR` package.

```{r load_SPR, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            library(systemPipeR)
                            }, 
                            step_name = "load_SPR")
```

Importantly, in order to use the individual `appendStep` operations below, one has 
to pay attention to the step dependencies.

### Read Preprocessing

#### Preprocessing with `preprocessReads` function

The function `preprocessReads` allows to apply predefined or custom
read preprocessing functions to the FASTQ files referenced in a
`SYSargsList` container, such as quality filtering or adapter trimming
routines. Internally, `preprocessReads` uses the `FastqStreamer` function from
the `ShortRead` package to stream through large FASTQ files in a
memory-efficient manner. The following example performs adapter trimming with
the `trimLRPatterns` function from the `Biostrings` package.

In this step, the preprocessing parameters defined in the corresponding
`*.pe.cwl` and `*.pe.yml` files are added to a previously created `SAL` object.
This preprocessing step is crucial for preparing the reads for further
analysis.

```{r preprocessing, message=FALSE, eval=FALSE, spr=TRUE}
targetspath <- system.file("extdata", "targetsPE.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(
    step_name = "preprocessing",
    targets = targetspath, dir = TRUE,
    wf_file = "preprocessReads/preprocessReads-pe.cwl",
    input_file = "preprocessReads/preprocessReads-pe.yml",
    dir_path = system.file("extdata/cwl", package = "systemPipeR"),
    inputvars = c(
        FileName1 = "_FASTQ_PATH1_",
        FileName2 = "_FASTQ_PATH2_",
        SampleName = "_SampleName_"
    ),
    dependency = c("load_SPR"))
```

After the preprocessing step, the `outfiles` files can be used to generate the new 
targets files containing the paths to the trimmed FASTQ files. The new targets 
information can be used for the next workflow step instance, _e.g._ running the 
NGS alignments with the trimmed FASTQ files. The `appendStep` function is
automatically handling this connectivity between steps. Please check the next 
step for more details.

The following example shows how one can design a custom `preprocessReads`
function. Here, it is possible to replace the function used on the
`preprocessing` step and modify the corresponding `sal` object. Because it is a
custom function, it is necessary to save this part in the R object, and
internally the `preprocessReads.doc.R` script, that is stored in the `param` directory 
of the workflow templates, is loading the custom function. If the R
object is saved with a different name (here `"param/customFCT.RData"`), one has
to adjust the corresponding path in the `preprocessReads.doc.R` script.

First, the custom function is defined.

```{r custom_preprocessing_function, eval=FALSE}
appendStep(sal) <- LineWise(
    code = {
        filterFct <- function(fq, cutoff = 20, Nexceptions = 0) {
            qcount <- rowSums(as(quality(fq), "matrix") <= cutoff, na.rm = TRUE)
            # Retains reads where Phred scores are >= cutoff with N exceptions
            fq[qcount <= Nexceptions]
        }
        save(list = ls(), file = "param/customFCT.RData")
    },
    step_name = "custom_preprocessing_function",
    dependency = "preprocessing"
)
```

After this the input parameters can be edited as shown here.

```{r editing_preprocessing, message=FALSE, eval=FALSE}
yamlinput(sal, "preprocessing")$Fct
yamlinput(sal, "preprocessing", "Fct") <- "'filterFct(fq, cutoff=20, Nexceptions=0)'"
yamlinput(sal, "preprocessing")$Fct ## check the new function
cmdlist(sal, "preprocessing", targets = 1) ## check if the command line was updated with success
```

#### Preprocessing with TrimGalore!

[TrimGalore!](http://www.bioinformatics.babraham.ac.uk/projects/trim_galore/) is 
a wrapper tool for Cutadapt and FastQC to consistently apply quality and adapter 
trimming to fastq files.

```{r trimGalore, eval=FALSE, spr=TRUE}
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "trimGalore", 
                               targets = targetspath, dir = TRUE,
                               wf_file = "trim_galore/trim_galore-se.cwl", 
                               input_file = "trim_galore/trim_galore-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = c(FileName = "_FASTQ_PATH1_", SampleName = "_SampleName_"), 
                               dependency = "load_SPR", 
                               run_step = "optional")
```


#### Preprocessing with Trimmomatic

[Trimmomatic](http://www.usadellab.org/cms/?page=trimmomatic) software [@Bolger2014-yr] 
performs a variety of useful trimming tasks for Illumina paired-end and single
ended reads. The following is an example of how to perform this task.

```{r trimmomatic, eval=FALSE, spr=TRUE}
targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "trimmomatic", 
                               targets = targetspath, dir = TRUE,
                               wf_file = "trimmomatic/trimmomatic-se.cwl", 
                               input_file = "trimmomatic/trimmomatic-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = c(FileName = "_FASTQ_PATH1_", SampleName = "_SampleName_"), 
                               dependency = "load_SPR", 
                               run_step = "optional")
```

### FASTQ quality report

The following `seeFastq` and `seeFastqPlot` functions generate and plot a series of useful 
quality statistics for a set of FASTQ files, including per cycle quality box
plots, base proportions, base-level quality trends, relative k-mer
diversity, length, and occurrence distribution of reads, number of reads
above quality cutoffs and mean quality distribution. The results are
written to a PDF file named `fastqReport.pdf`.

```{r fastq_report, eval=FALSE, message=FALSE, spr=TRUE}
appendStep(sal) <- LineWise(code = {
                fastq <- getColumn(sal, step = "preprocessing", "targetsWF", column = 1)
                fqlist <- seeFastq(fastq = fastq, batchsize = 10000, klength = 8)
                pdf("./results/fastqReport.pdf", height = 18, width = 4*length(fqlist))
                seeFastqPlot(fqlist)
                dev.off()
                }, step_name = "fastq_report", 
                dependency = "preprocessing")
``` 

<center><img src="images/fastqReport.png"></center>
<div align="center">**Figure 6:** FASTQ quality report </div></br>

### NGS Alignment software

After quality control, the sequence reads can be aligned to a reference genome or 
transcriptome. The following gives examples for running several NGS read aligners. 

#### `HISAT2`

The following steps demonstrate how to run the `HISAT2` short read aligner
[@Kim2015-ve] from `systemPipeR`.

To use an NGS aligner, one has to first index the reference genome. This is done
below with `hisat2-build`.

```{r hisat_index, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "hisat_index", 
                               targets = NULL, dir = FALSE,
                               wf_file = "hisat2/hisat2-index.cwl", 
                               input_file = "hisat2/hisat2-index.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = NULL, 
                               dependency = "preprocessing")
```

The parameter settings of the aligner are defined in the `workflow_hisat2-se.cwl` 
and `workflow_hisat2-se.yml` files. The following shows how to append the alignment 
step to the `sal` workflow container. In this step several post-processing steps 
with `Samtools` are included to convert the SAM files, that were generated by `HISAT2`, 
to indexed and sorted BAM files. Those sub-steps are defined by the corresponding CWL workflow file 
(see workflow_hisat2-se.cwl). 

```{r hisat_mapping_samtools, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "hisat_mapping", 
                               targets = "preprocessing", dir = TRUE,
                               wf_file = "workflow-hisat2/workflow_hisat2-se.cwl", 
                               input_file = "workflow-hisat2/workflow_hisat2-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars=c(FileName1="_FASTQ_PATH1_", SampleName="_SampleName_"), 
                               dependency = c("hisat_index"), 
                               run_session = "compute")
```

#### `Tophat2`

The `Bowtie2/Tophat2` suite is the predecessor of `Hisat2` [@Kim2013-vg; @Langmead2012-bs]. 
How to run it via CWL is shown below. 

First, the reference genome has to be indexed for `Bowtie2`. 

```{r bowtie_index, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "bowtie_index", 
                               targets = NULL, dir = FALSE,
                               wf_file = "bowtie2/bowtie2-index.cwl", 
                               input_file = "bowtie2/bowtie2-index.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = NULL, 
                               dependency = "preprocessing", 
                               run_step = "optional")
```

Next, the alignment step is constructed with the parameter files `workflow_tophat2-mapping.cwl` 
and `tophat2-mapping-pe.yml`. 

```{r tophat2_mapping, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "tophat2_mapping", 
                               targets = "preprocessing", dir = TRUE,
                               wf_file = "tophat2/workflow_tophat2-mapping-se.cwl", 
                               input_file = "tophat2/tophat2-mapping-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"), 
                               dependency = c("bowtie_index"), 
                               run_session = "remote", 
                               run_step = "optional")
```

#### `Bowtie2`

The following example runs `Bowtie2` by itself (without `Tophat2` or `Hisat2`). 

```{r bowtie2_mapping, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "bowtie2_mapping", 
                               targets = "preprocessing", dir = TRUE,
                               wf_file = "bowtie2/workflow_bowtie2-mapping-se.cwl", 
                               input_file = "bowtie2/bowtie2-mapping-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"), 
                               dependency = c("bowtie_index"), 
                               run_session = "remote", 
                               run_step = "optional")
```

#### `BWA-MEM`

The following example runs BWA-MEM, an aligner that is widely used for VAR-Seq experiments. 

First, the reference genome has to be indexed for `BWA-MEM`. 

```{r bwa_index, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "bwa_index", 
                               targets = NULL, dir = FALSE,
                               wf_file = "bwa/bwa-index.cwl", 
                               input_file = "bwa/bwa-index.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = NULL, 
                               dependency = "preprocessing", 
                               run_step = "optional")
```

Next, the reads can be aligned with `BWA-MEM`. 

```{r bwa_mapping, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "bwa_mapping", 
                               targets = "preprocessing", dir = TRUE,
                               wf_file = "bwa/bwa-se.cwl", 
                               input_file = "bwa/bwa-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars=c(preprocessReads_se="_FASTQ_PATH1_", SampleName="_SampleName_"), 
                               dependency = c("bwa_index"), 
                               run_session = "remote", 
                               run_step = "optional")
```

#### `Rsubread`

`Rsubread` is an R package for processing short and long reads. It is well known for its
fast and accurate mapping performance of RNA-Seq reads. 

First, the reference genome has to be indexed for `Rsubread`. 

```{r rsubread_index, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "rsubread_index", 
                               targets = NULL, dir = FALSE,
                               wf_file = "rsubread/rsubread-index.cwl", 
                               input_file = "rsubread/rsubread-index.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = NULL, 
                               dependency = "preprocessing", 
                               run_step = "optional")
```

Next, the RNA-Seq reads can be aligned with `Rsubread`. 

```{r rsubread_mapping, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "rsubread", 
                               targets = "preprocessing", dir = TRUE,
                               wf_file = "rsubread/rsubread-mapping-se.cwl", 
                               input_file = "rsubread/rsubread-mapping-se.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars=c(FileName1="_FASTQ_PATH1_", SampleName="_SampleName_"), 
                               dependency = c("rsubread_index"), 
                               run_session = "compute", 
                               run_step = "optional")
```

#### `gsnap`

The `gmapR` package provides an interface to work with the `GSNAP` and `GMAP`
aligners from R [@Wu2010-iq]. 

First, the reference genome has to be indexed for `GSNAP`. 

```{r gsnap_index, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "gsnap_index", 
                               targets = NULL, dir = FALSE,
                               wf_file = "gsnap/gsnap-index.cwl", 
                               input_file = "gsnap/gsnap-index.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                               inputvars = NULL, 
                               dependency = "preprocessing", 
                               run_step = "optional")
```

Next, the RNA-Seq reads are aligned with `GSNAP`. 

```{r gsnap_mapping, eval=FALSE, spr=TRUE}
appendStep(sal) <- SYSargsList(step_name = "gsnap", 
                               targets = "targetsPE.txt", dir = TRUE,
                               wf_file = "gsnap/gsnap-mapping-pe.cwl", 
                               input_file = "gsnap/gsnap-mapping-pe.yml", 
                               dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                                inputvars = c(FileName1 = "_FASTQ_PATH1_", 
                                              FileName2 = "_FASTQ_PATH2_", SampleName = "_SampleName_"), 
                               dependency = c("gsnap_index"), 
                               run_session = "remote", 
                               run_step = "optional")
```


### BAM file viewing in IGV

The genome browser IGV supports reading of indexed/sorted BAM files via web
URLs. This way it can be avoided to create unnecessary copies of these large
files. To enable this approach, an HTML directory with https access needs to be
available in the user account (_e.g._ `home/.html`) of a system. If this
is not the case then the BAM files need to be moved or copied to the system
where IGV runs. In the following, `htmldir` defines the path to the HTML
directory with https access where the symbolic links to the BAM files will be
stored. The corresponding URLs will be written to a text file specified under
the `urlfile` argument. To make the following code work, users need to change
the directory name (here `somedir/`) and the username (here `<username>`) to the
corresponding names on their system.

```{r bam_IGV, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise(
    code = {
        bampaths <- getColumn(sal, step = "hisat2_mapping", "outfiles", 
                  column = "samtools_sort_bam")
        symLink2bam(
            sysargs = bampaths, htmldir = c("~/.html/", "somedir/"),
            urlbase = "https://cluster.hpcc.ucr.edu/<username>/",
            urlfile = "./results/IGVurl.txt")
    },
    step_name = "bam_IGV",
    dependency = "hisat_mapping",
    run_step = "optional"
)
```

### Read counting for mRNA profiling experiments

Reads overlapping with annotation ranges of interest are counted for each
sample using the `summarizeOverlaps` function [@Lawrence2013-kt]. 

First, the gene annotation ranges from a GFF file are stored in a `TxDb` container for
efficient work with genomic features. 

```{r create_txdb, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise(code = {
                            library(txdbmaker)
                            txdb <- makeTxDbFromGFF(file="data/tair10.gff", format="gff", 
                                                    dataSource="TAIR", organism="Arabidopsis thaliana")
                            saveDb(txdb, file="./data/tair10.sqlite")
                            }, 
                            step_name = "create_txdb", 
                            dependency = "hisat_mapping")
```

Next, The read counting is preformed for exonic gene regions in a
non-strand-specific manner while ignoring overlaps among different genes. 

```{r read_counting, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            library(BiocParallel)
                            txdb <- loadDb("./data/tair10.sqlite")
                            eByg <- exonsBy(txdb, by="gene")
                            outpaths <- getColumn(sal, step = "hisat_mapping", 'outfiles', column = 2)
                            bfl <- BamFileList(outpaths, yieldSize=50000, index=character())
                            multicoreParam <- MulticoreParam(workers=4); register(multicoreParam); registered()
                            counteByg <- bplapply(bfl, function(x) summarizeOverlaps(eByg, x, mode="Union",
                                                                                     ignore.strand=TRUE,
                                                                                     inter.feature=TRUE,
                                                                                     singleEnd=TRUE))
                            # Note: for strand-specific RNA-Seq set 'ignore.strand=FALSE' and for PE data set 'singleEnd=FALSE'
                            countDFeByg <- sapply(seq(along=counteByg), 
                                                  function(x) assays(counteByg[[x]])$counts)
                            rownames(countDFeByg) <- names(rowRanges(counteByg[[1]]))
                            colnames(countDFeByg) <- names(bfl)
                            rpkmDFeByg <- apply(countDFeByg, 2, function(x) returnRPKM(counts=x, ranges=eByg))
                            write.table(countDFeByg, "results/countDFeByg.xls", 
                                        col.names=NA, quote=FALSE, sep="\t")
                            write.table(rpkmDFeByg, "results/rpkmDFeByg.xls", 
                                        col.names=NA, quote=FALSE, sep="\t")
                            }, 
                            step_name = "read_counting", 
                            dependency = "create_txdb")
```

Please note, in addition to read counts this step generates RPKM normalized
expression values. For most statistical differential expression or abundance
analysis methods, such as `edgeR` or `DESeq2`, the raw count values should
be used as input. The usage of RPKM values should be restricted to specialty
applications required by some users, _e.g._ manually comparing the expression
levels of different genes or features. 

##### Read and alignment stats

The following provides an overview of the number of reads in each sample and
how many of them aligned to the reference. 

```{r align_stats, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            read_statsDF <- alignStats(args)
                            write.table(read_statsDF, "results/alignStats.xls", 
                                        row.names = FALSE, quote = FALSE, sep = "\t")
                            }, 
                            step_name = "align_stats", 
                            dependency = "hisat_mapping")
```

The following shows the first four lines of the sample alignment stats file 
provided by the `systemPipeR` package. For simplicity the number of PE reads 
is multiplied here by 2 to approximate proper alignment frequencies where each 
read in a pair is counted. 

```{r align_stats2, eval=TRUE}
read.table(system.file("extdata", "alignStats.xls", package = "systemPipeR"), header = TRUE)[1:4,]
```

### Read counting for miRNA profiling experiments

Example of downloading a GFF file for miRNA ranges from an organism of interest (here _A. thaliana_), and then 
use them for read counting, here RNA-Seq reads from the above steps. 

```{r read_counting_mirna, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            system("wget https://www.mirbase.org/download/ath.gff3 -P ./data/")
                            gff <- rtracklayer::import.gff("./data/ath.gff3")
                            gff <- split(gff, elementMetadata(gff)$ID)
                            bams <- getColumn(sal, step = "bowtie2_mapping", 'outfiles', column = 2)
                            bfl <- BamFileList(bams, yieldSize=50000, index=character())
                            countDFmiR <- summarizeOverlaps(gff, bfl, mode="Union",
                                                            ignore.strand = FALSE, inter.feature = FALSE) 
                            countDFmiR <- assays(countDFmiR)$counts
                            # Note: inter.feature=FALSE important since pre and mature miRNA ranges overlap
                            rpkmDFmiR <- apply(countDFmiR, 2, function(x) returnRPKM(counts = x, ranges = gff))
                            write.table(assays(countDFmiR)$counts, "results/countDFmiR.xls", 
                                        col.names=NA, quote=FALSE, sep="\t")
                            write.table(rpkmDFmiR, "results/rpkmDFmiR.xls", col.names=NA, quote=FALSE, sep="\t")
                            }, 
                            step_name = "read_counting_mirna", 
                            dependency = "bowtie2_mapping")
```


### Correlation analysis of samples

The following computes the sample-wise Spearman correlation coefficients from
the `rlog` (regularized-logarithm) transformed expression values generated
with the `DESeq2` package. After transformation to a distance matrix,
hierarchical clustering is performed with the `hclust` function and the
result is plotted as a dendrogram. 

```{r sample_tree_rlog, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            library(DESeq2, warn.conflicts=FALSE, quietly=TRUE)
                            library(ape, warn.conflicts=FALSE)
                            countDFpath <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
                            countDF <- as.matrix(read.table(countDFpath))
                            colData <- data.frame(row.names = targetsWF(sal)[[2]]$SampleName,  
                                                  condition=targetsWF(sal)[[2]]$Factor)
                            dds <- DESeqDataSetFromMatrix(countData = countDF, colData = colData, 
                                                          design = ~ condition)
                            d <- cor(assay(rlog(dds)), method = "spearman")
                            hc <- hclust(dist(1-d))
                            plot.phylo(as.phylo(hc), type = "p", edge.col = 4, edge.width = 3,
                                       show.node.label = TRUE, no.margin = TRUE)
                            }, 
                            step_name = "sample_tree_rlog", 
                            dependency = "read_counting")
```

<center><img src="images/sample_tree.png"></center>

<div align="center">**Figure 7:** Correlation dendrogram of samples for _`rlog`_ values. </div></br>

### DEG analysis with `edgeR`

The following _`run_edgeR`_ function is a convenience wrapper for
identifying differentially expressed genes (DEGs) in batch mode with
_`edgeR`_'s GML method [@Robinson2010-uk] for any number of
pairwise sample comparisons specified under the _`cmp`_ argument. Users
are strongly encouraged to consult the 
[_`edgeR`_](\href{http://www.bioconductor.org/packages/devel/bioc/vignettes/edgeR/inst/doc/edgeRUsersGuide.pdf) vignette 
for more detailed information on this topic and how to properly run _`edgeR`_ 
on data sets with more complex experimental designs. 

```{r edger, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            targetspath <- system.file("extdata", "targets.txt", package = "systemPipeR")
                            targets <- read.delim(targetspath, comment = "#")
                            cmp <- readComp(file = targetspath, format = "matrix", delim = "-")
                            countDFeBygpath <- system.file("extdata", "countDFeByg.xls", package = "systemPipeR")
                            countDFeByg <- read.delim(countDFeBygpath, row.names = 1)
                            edgeDF <- run_edgeR(countDF = countDFeByg, targets = targets, cmp = cmp[[1]],
                                                independent = FALSE, mdsplot = "")
                            DEG_list <- filterDEGs(degDF = edgeDF, filter = c(Fold = 2, FDR = 10))
                            }, 
                            step_name = "edger", 
                            dependency = "read_counting")
```

Filter and plot DEG results for up and down-regulated genes. Because of the
small size of the toy data set used by this vignette, the _FDR_ cutoff value has been
set to a relatively high threshold (here 10%). More commonly used _FDR_ cutoffs
are 1% or 5%. The definition of '_up_' and '_down_' is given in the
corresponding help file. To open it, type `?filterDEGs` in the R console. 

<center><img src="images/DEGcounts.png"></center>

<div align="center">**Figure 8:** Up and down regulated DEGs identified by `edgeR`. </div></br>

### DEG analysis with `DESeq2` 

The following `run_DESeq2` function is a convenience wrapper for
identifying DEGs in batch mode with `DESeq2` [@Love2014-sh] for any number of
pairwise sample comparisons specified under the `cmp` argument. Users
are strongly encouraged to consult the 
[_`DESeq2`_](http://www.bioconductor.org/packages/devel/bioc/vignettes/DESeq2/inst/doc/DESeq2.pdf) vignette
for more detailed information on this topic and how to properly run `DESeq2`
on data sets with more complex experimental designs. 

```{r deseq2, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            degseqDF <- run_DESeq2(countDF=countDFeByg, targets=targets, cmp=cmp[[1]],
                                                   independent=FALSE)
                            DEG_list2 <- filterDEGs(degDF=degseqDF, filter=c(Fold=2, FDR=10))
                            }, 
                            step_name = "deseq2", 
                            dependency = "read_counting")
```

### Venn Diagrams

The function `overLapper` can compute Venn intersects for large numbers of
sample sets (up to 20 or more) and `vennPlot` can plot 2-5 way Venn diagrams.
A useful feature is the possibility to combine the counts from several Venn
comparisons with the same number of sample sets in a single Venn diagram (here
for 4 up and down DEG sets).

```{r vennplot, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            vennsetup <- overLapper(DEG_list$Up[6:9], type="vennsets")
                            vennsetdown <- overLapper(DEG_list$Down[6:9], type="vennsets")
                            vennPlot(list(vennsetup, vennsetdown), mymain="", mysub="", 
                                     colmode=2, ccol=c("blue", "red"))
                            }, 
                            step_name = "vennplot", 
                            dependency = "edger")
```

<center><img src="images/vennplot.png"></center>
<div align="center">**Figure 9:** Venn Diagram for 4 Up and Down DEG Sets. </div></br>

### GO term enrichment analysis of DEGs

#### Obtain gene-to-GO mappings

The following shows how to obtain gene-to-GO mappings from `biomaRt` (here
for _A. thaliana_) and how to organize them for the downstream GO term
enrichment analysis. Alternatively, the gene-to-GO mappings can be obtained for
many organisms from Bioconductor's  `*.db` genome annotation packages or GO
annotation files provided by various genome databases. For each annotation,
this relatively slow preprocessing step needs to be performed only once.
Subsequently, the preprocessed data can be loaded with the `load` function as
shown in the next step. 

```{r get_go_biomart, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            library("biomaRt")
                            listMarts() # To choose BioMart database
                            listMarts(host="plants.ensembl.org")
                            m <- useMart("plants_mart", host="https://plants.ensembl.org")
                            listDatasets(m)
                            m <- useMart("plants_mart", dataset="athaliana_eg_gene", host="https://plants.ensembl.org")
                            listAttributes(m) # Choose data types you want to download
                            go <- getBM(attributes=c("go_id", "tair_locus", "namespace_1003"), mart=m)
                            go <- go[go[,3]!="",]; go[,3] <- as.character(go[,3])
                            go[go[,3]=="molecular_function", 3] <- "F"
                            go[go[,3]=="biological_process", 3] <- "P"
                            go[go[,3]=="cellular_component", 3] <- "C"
                            go[1:4,]
                            dir.create("./data/GO")
                            write.table(go, "data/GO/GOannotationsBiomart_mod.txt", 
                                        quote=FALSE, row.names=FALSE, col.names=FALSE, sep="\t")
                            catdb <- makeCATdb(myfile="data/GO/GOannotationsBiomart_mod.txt",
                                               lib=NULL, org="", colno=c(1,2,3), idconv=NULL)
                            save(catdb, file="data/GO/catdb.RData")
                            }, 
                            step_name = "get_go_biomart", 
                            dependency = "edger")
```

#### Batch GO term enrichment analysis

Apply the enrichment analysis to the DEG sets obtained in the above
differential expression analysis. Note, in the following example the _FDR_
filter is set here to an unreasonably high value, simply because of the small
size of the toy data set used in this vignette. Batch enrichment analysis of
many gene sets is performed with the `GOCluster_Report` function. When
`method="all"`, it returns all GO terms passing the p-value cutoff specified
under the `cutoff` arguments. When `method="slim"`, it returns only the GO
terms specified under the `myslimv` argument. The given example shows how one
can obtain such a GO slim vector from BioMart for a specific organism. 

```{r go_enrichment, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({ 
                            load("data/GO/catdb.RData")
                            DEG_list <- filterDEGs(degDF=edgeDF, filter=c(Fold=2, FDR=50), plot=FALSE)
                            up_down <- DEG_list$UporDown; names(up_down) <- paste(names(up_down), "_up_down", sep="")
                            up <- DEG_list$Up; names(up) <- paste(names(up), "_up", sep="")
                            down <- DEG_list$Down; names(down) <- paste(names(down), "_down", sep="")
                            DEGlist <- c(up_down, up, down)
                            DEGlist <- DEGlist[sapply(DEGlist, length) > 0]
                            BatchResult <- GOCluster_Report(catdb=catdb, setlist=DEGlist, method="all",
                                                            id_type="gene", CLSZ=2, cutoff=0.9,
                                                            gocats=c("MF", "BP", "CC"), recordSpecGO=NULL)
                            library("biomaRt")
                            m <- useMart("plants_mart", dataset="athaliana_eg_gene", host="https://plants.ensembl.org")
                            goslimvec <- as.character(getBM(attributes=c("goslim_goa_accession"), mart=m)[,1])
                            BatchResultslim <- GOCluster_Report(catdb=catdb, setlist=DEGlist, method="slim",
                                                                id_type="gene", myslimv=goslimvec, CLSZ=10,
                                                                cutoff=0.01, gocats=c("MF", "BP", "CC"),
                                                                recordSpecGO=NULL)
                            gos <- BatchResultslim[grep("M6-V6_up_down", BatchResultslim$CLID), ]
                            gos <- BatchResultslim
                            pdf("GOslimbarplotMF.pdf", height=8, width=10); goBarplot(gos, gocat="MF"); dev.off()
                            goBarplot(gos, gocat="BP")
                            goBarplot(gos, gocat="CC")
                            }, 
                            step_name = "go_enrichment", 
                            dependency = "get_go_biomart")
```

#### Plot batch GO term results

The `data.frame` generated by `GOCluster_Report` can be plotted with the
`goBarplot` function. Because of the variable size of the sample sets, it may
not always be desirable to show the results from different DEG sets in the same
bar plot. 

<center><img src="images/GOslimbarplotMF.png"></center>
<div align="center">**Figure 10:** GO Slim Barplot for MF Ontology.</div></br>


### Clustering and heat maps

The following example performs hierarchical clustering on the `rlog`
transformed expression matrix subsetted by the DEGs identified in the above
differential expression analysis. It uses a Pearson correlation-based distance
measure and complete linkage for cluster joining.

```{r hierarchical_clustering, message=FALSE, eval=FALSE, spr=TRUE}
appendStep(sal) <- LineWise({
                            library(pheatmap)
                            geneids <- unique(as.character(unlist(DEG_list[[1]])))
                            y <- assay(rlog(dds))[geneids, ]
                            pdf("heatmap1.pdf")
                            pheatmap(y, scale="row", clustering_distance_rows="correlation",
                                     clustering_distance_cols="correlation")
                            dev.off()
                            }, 
                            step_name = "hierarchical_clustering", 
                            dependency = c("sample_tree_rlog", "edger"))
```


<center><img src="images/heatmap1.png"></center>
<div align="center">**Figure 11:** Heat map with hierarchical clustering dendrograms of DEGs.</div></br>


# Version information

```{r sessionInfo}
sessionInfo()
```

# Funding

This project is funded by awards from the National Science Foundation ([ABI-1661152](https://www.nsf.gov/awardsearch/showAward?AWD_ID=1661152)], 
and the National Institute on Aging of the National Institutes of Health ([U19AG023122](https://reporter.nih.gov/project-details/9632486)). 

# References

---
title: "systemPipeR: Workflow Templates" 
author: "Author: Le Zhang, Daniela Cassol, and Thomas Girke"
date: "Last update: `r format(Sys.time(), '%d %B, %Y')`" 
output:
  BiocStyle::html_document:
    toc_float: true
    code_folding: show
  BiocStyle::pdf_document: default
package: systemPipeR
vignette: |
  %\VignetteEncoding{UTF-8}
  %\VignetteIndexEntry{systemPipeR: Workflow Templates}
  %\VignetteEngine{knitr::rmarkdown}
fontsize: 14pt
bibliography: bibtex.bib
---

<!--
- Compile from command-line
Rscript -e "rmarkdown::render('systemPipeR_workflows.Rmd', c('BiocStyle::html_document'), clean=F); knitr::knit('systemPipeR_workflows.Rmd', tangle=FALSE)"
-->

```{css, echo=FALSE}
pre code {
white-space: pre !important;
overflow-x: scroll !important;
word-break: keep-all !important;
word-wrap: initial !important;
}
```

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
options(width=80, max.print=1000)
knitr::opts_chunk$set(
    eval=as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache=as.logical(Sys.getenv("KNITR_CACHE", "TRUE")), 
    tidy.opts=list(width.cutoff=80), tidy=TRUE)
```

```{r setup, echo=FALSE, messages=FALSE, warnings=FALSE}
suppressPackageStartupMessages({
    library(systemPipeR)
})
```

# Redirect notification

The
[systemPipeRdata](https://www.bioconductor.org/packages/devel/data/experiment/html/systemPipeRdata.html)
package provides a collection of pre-built workflow templates that are ready to
use from
[systemPipeR](https://www.bioconductor.org/packages/devel/bioc/html/systemPipeR.html).
These templates are described in detail in the associated `systemPipeRdata`
overview vignette
[here](https://www.bioconductor.org/packages/devel/data/experiment/vignettes/systemPipeRdata/inst/doc/systemPipeRdata.html),
which includes instructions on how to use them.


# Funding

This project is funded by awards from the National Science Foundation ([ABI-1661152](https://www.nsf.gov/awardsearch/showAward?AWD_ID=1661152)], 
and the National Institute on Aging of the National Institutes of Health ([U19AG023122](https://reporter.nih.gov/project-details/9632486)). 

\name{run_edgeR}
\alias{run_edgeR}
\title{
Runs edgeR 
}
\description{
Convenience wrapper function to identify differentially expressed genes
(DEGs) in batch mode with the \code{edgeR} GML method for any number of pairwise
sample comparisons specified under the \code{cmp} argument.  Users are strongly
encouraged to consult the \code{edgeR} vignette for more detailed information
on this topic and how to properly run \code{edgeR} on data sets with more
complex experimental designs.
}
\usage{
run_edgeR(countDF, targets, cmp, independent = TRUE, paired = NULL, mdsplot = "")
}
\arguments{
  \item{countDF}{
\code{date.frame} containing raw read counts
}
  \item{targets}{
	targets \code{data.frame}
}
  \item{cmp}{
	\code{character matrix} where comparisons are defined in two columns. This matrix should be generated with \code{readComp()} from the targets file. Values used for comparisons need to match those in the \code{Factor} column of the targets file.
}
  \item{independent}{
	If \code{independent=TRUE} then the \code{countDF} will be subsetted for each comparison. This behavior can be useful when working with samples from unrelated studies. For samples from the same or comparable studies, the setting \code{independent=FALSE} is usually preferred.
}
  \item{paired}{
	Defines pairs (\code{character vector}) for paired analysis. Default is unpaired (\code{paired=NULL}).
}
  \item{mdsplot}{
	Directory where \code{plotMDS} should be written to. Default setting \code{mdsplot=""} will omit the plotting step.
}
}
\value{
\code{data.frame} containing \code{edgeR} results from all comparisons. Comparison labels are appended to column titles for tracking.
}
\references{
Please properly cite the \code{edgeR} papers when using this function:
http://www.bioconductor.org/packages/devel/bioc/html/edgeR.html
}
\author{
Thomas Girke
}
\seealso{
\code{run_DESeq2}, \code{readComp} and \code{edgeR} vignette
}
\examples{
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
targets <- read.delim(targetspath, comment.char = "#")
cmp <- readComp(file=targetspath, format="matrix", delim="-")
countfile <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
countDF <- read.delim(countfile, row.names=1)
edgeDF <- run_edgeR(countDF=countDF, targets=targets, cmp=cmp[[1]], independent=FALSE, mdsplot="")
pval <- edgeDF[, grep("_FDR$", colnames(edgeDF)), drop=FALSE]
fold <- edgeDF[, grep("_logFC$", colnames(edgeDF)), drop=FALSE]
DEG_list <- filterDEGs(degDF=edgeDF, filter=c(Fold=2, FDR=10))
names(DEG_list)
DEG_list$Summary
}
\keyword{ utilities }

\name{seeFastq}
\alias{seeFastq}
\alias{seeFastqPlot}
\title{
Quality reports for FASTQ files
}
\description{
The following \code{seeFastq} and \code{seeFastqPlot} functions generate and plot a series of
useful quality statistics for a set of FASTQ files including per cycle quality
box plots, base proportions, base-level quality trends, relative k-mer
diversity, length and occurrence distribution of reads, number of reads above
quality cutoffs and mean quality distribution. The functions allow processing
of reads with variable length, but most plots are only meaningful if the read
positions in the FASTQ file are aligned with the sequencing cycles. For
instance, constant length clipping of the reads on either end or variable
length clipping on the 3' end maintains this relationship, while variable
length clipping on the 5' end without reversing the reads erases it.

The function \code{seeFastq} computes the summary stats and stores them in a relatively 
small list object that can be saved to disk with \code{save()} and reloaded with 
\code{load()} for later plotting. The argument 'klength' specifies the k-mer length and 'batchsize' the
number of reads to random sample from each fastq file.  }
\usage{
seeFastq(fastq, batchsize, klength = 8)

seeFastqPlot(fqlist, arrange = c(1, 2, 3, 4, 5, 8, 6, 7), ...)
}
\arguments{
  \item{fastq}{
	Named character vector containing paths to FASTQ file in the data fields and sample labels in the name slots.
}
  \item{batchsize}{
	Number of reads to random sample from each FASTQ file that will be considered in the QC analysis. Smaller numbers reduce the memory footprint and compute time.
}
  \item{klength}{
	Specifies the k-mer length in the plot for the relative k-mer diversity.
}
  \item{fqlist}{
	\code{list} object returned by \code{seeFastq()}.
}
  \item{arrange}{
	Integer vector from 1 to 7 specifying the row order of the QC plot. Dropping numbers eliminates the corresponding plots.  
}
  \item{\dots}{
	Additional plotting arguments to pass on to \code{seeFastqPlot()}.
}
}
\value{
	The function \code{seeFastq} returns the summary stats in a \code{list} containing all information required for the quality plots. 
	The function \code{seeFastqPlot} plots the information generated by \code{seeFastq} using \code{ggplot2}.
}
\author{
Thomas Girke
}
\examples{
\dontrun{
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
fqlist <- seeFastq(fastq=infile1(args), batchsize=10000, klength=8)
pdf("fastqReport.pdf", height=18, width=4*length(fastq))
seeFastqPlot(fqlist)
dev.off()

}
}
\keyword{ utilities }

\name{evalCode}
\alias{evalCode}
\title{
Toggles option \code{eval} on the RMarkdown files 
}
\description{
Function to evaluate (\code{eval=TRUE}) or not evaluate (\code{eval=FALSE}) R chunk codes in the Rmarkdown file. This function does not run the code, just toggles between \code{TRUE} or \code{FALSE} the option \code{eval} and writes out a new file with the chosen option.
}
\usage{
evalCode(infile, eval = TRUE, output)
}
\arguments{
  \item{infile}{
name and path of the infile file, format \code{Rmd}.
}
  \item{eval}{
whether to evaluate the code and include its results. The default is \code{TRUE}. 
}
  \item{output}{
name and path of the output file. File format \code{Rmd}.
}
}
\value{
Writes Rmarkdown file containing the exact copy of the \code{infile} file with the option choose on the \code{eval} argument. 
It will be easy to toggle between run all the R chunk codes or not. 
}
\author{
Daniela Cassol
}
\examples{
library(systemPipeRdata)
file <- system.file("extdata/workflows/rnaseq", "systemPipeRNAseq.Rmd", package="systemPipeRdata")
evalCode(infile=file, eval=FALSE, output=file.path(tempdir(), "test.Rmd"))
}
\keyword{ utilities }

\name{SYSargsList}
% Constructor
\alias{SYSargsList}

\title{SYSargsList Constructor}
\description{
\code{SYSargsList} instances are constructed by the \code{SYSargsList} function.
}
\usage{
SYSargsList(sysargs = NULL, step_name = "default", 
            targets = NULL, wf_file = NULL, input_file = NULL, dir_path = ".", 
            id = "SampleName",
            inputvars = NULL, rm_targets_col = NULL, 
            dir = TRUE, dependency = NA, 
            run_step = "mandatory",
            run_session = "management",
            run_remote_resources = NULL,
            silent = FALSE, 
            projPath = getOption("projPath", getwd()))
}

\arguments{
  \item{sysargs}{
  \code{SYSargs2} object. If the object already exists, it can be used to 
  construct the \code{SYSargsList} object. 
}
  \item{step_name}{
  character with the step index name.
}
  \item{targets}{
  the path to \code{targets} file. The \code{targets} file can be either a simple 
  tabular or yml file. Also, it is possible to assign \code{NULL} to run the 
  pipeline without the 'targets' file. This can be useful for running specific 
  workflows that do not require input files.
}
  \item{wf_file}{
  name and path to \code{CWL parameters} file.
}
  \item{input_file}{
  name and path to \code{input parameters} file.
}
  \item{dir_path}{
  full path to the directory with the \code{CWL parameters} and \code{input} 
  files.
}
  \item{id}{
  A column from \code{targets} file, which will be used as an id for each one
  of the samples. It is required to be unique.
}
  \item{inputvars}{
  Each vector element is required to be defined in the \code{input} file, and the 
  names of the elements are needed to match the column names defined in the 
  \code{targets} file.
}
  \item{rm_targets_col}{
  targets file colunms to be removed.
}
  \item{dir}{
  This option allows creating an exclusive results folder for each step in the 
  workflow. All the outfiles and log files for the particular step will be 
  created in the respective folders. Default is \code{dir=TRUE}.
}
  \item{dependency}{
  character. Dependency tree, required when appending this step to 
  the workflow. Character name of a previous step in the workflow. 
  Default is \code{NA}.
}
  \item{run_step}{
  character. If the step has "mandatory" or "optional" flag for the execution.
}
  \item{run_session}{
  character. If the step has "management" or "compute" flag for the execution.
} 
  \item{run_remote_resources}{
  \code{List} for reserving for each cluster job sufficient computing resources
  including memory (Megabyte), number of nodes (Int), CPU cores, walltime (Minutes),
  etc. It is necessary two additional files: \code{conffile} and \code{template}. 
  \code{conffile} is the path to configuration file (default location 
  \code{./.batchtools.conf.R}). This file contains in its simplest form just one 
  command, such as this line for the scheduler: 
  \code{cluster.functions <- makeClusterFunctionsSlurm(template="batchtools.slurm.tmpl")}. 
  For more detailed information visit this page: https://mllg.github.io/batchtools/index.html
  \code{template} The template files for a specific queueing/scheduling systems 
  can be downloaded from here: 
  https://github.com/mllg/batchtools/tree/master/inst/templates. Slurm, 
  PBS/Torque, and Sun Grid Engine (SGE) templates are provided within the package
  demo data.
}
  \item{silent}{
  If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{projPath}{
  a character vector of a full project path name. Default is the current path. 
}
}
\author{
Daniela Cassol
}
\seealso{
\code{SYSargs2}, \code{LineWise}, and \code{SPRproject}
}
\examples{
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", 
                            package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", 
                               input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", 
                               package="systemPipeR"),
                               inputvars = c(Message = "_STRING_",
                               SampleName = "_SAMPLE_"))
                               
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")
                            
sal
}
\keyword{ utilities }

\name{genFeatures}
\alias{genFeatures}
\title{
Generate feature ranges from TxDb
}
\description{
Function to generate a variety of feature types from \code{TxDb} objects using 
utilities provided by the \code{GenomicFeatures} package. The feature types are 
organized per gene and can be returned on that level in their non-reduced or 
reduced form.

Currently, supported features include \code{intergenic}, \code{promoter},
\code{intron}, \code{exon}, \code{cds}, \code{5'/3'UTR} and different
\code{transcript} types. The latter contains as many transcript types as
available in the \code{tx_type} column when extracting transcripts from
\code{TxDb} objects as follows: 
\code{transcripts(txdb, c("tx_name", "gene_id", "tx_type"))}
}
\usage{
genFeatures(txdb, featuretype = "all", reduce_ranges, upstream = 1000, downstream = 0, verbose = TRUE)
}
\arguments{
  \item{txdb}{
\code{TxDb} object
}
  \item{featuretype}{
Feature types can be specified by assigning a \code{character} vector containing 
any of the following: c("tx_type", "promoter", "intron", "exon", "cds", "fiveUTR", "threeUTR", "intergenic").
The default \code{all} is a shorthand to select all supported features.
}
  \item{reduce_ranges}{
If set to \code{TRUE} the feature ranges will be reduced on the gene level. As a result 
overlapping feature components of the same type and from the same gene will be
merged to a single range, e.g. two overlapping exons from the same gene are merged 
to one. Intergenic ranges are not affected by this setting. Note, all reduced feature
types are labeled with the suffix '_red'.
}
  \item{upstream}{
Defines for promoter features the number of bases upstream from the transcription
start site. 
}
  \item{downstream}{
Defines for promoter features the number of bases downstream from the transcription
start site.
}
  \item{verbose}{
\code{verbose=FALSE} turns off all print messages.
}
}
\value{
The results are returned as a \code{GRangesList} where each component is a
\code{GRanges} object containing the range set of each feature type. Intergenic
ranges are assigned unique identifiers and recorded in the \code{featuretype_id} 
column of the metadata block. For this the ids of their adjacent genes are concatenated with two 
underscores as separator. If the adjacent genes overlap with other genes then 
their identifiers are included in the id string as well and separated by a single
underscore.  
}
\author{
Thomas Girke
}
\seealso{
\code{transcripts} and associated \code{TxDb} accessor functions from 
the \code{GenomicFeatures} package.
}
\examples{
## Sample from txdbmaker package
library(txdbmaker)
gffFile <- system.file("extdata", "GFF3_files", "a.gff3", package="txdbmaker")
txdb <- makeTxDbFromGFF(file=gffFile, format="gff3", organism="Solanum lycopersicum")
feat <- genFeatures(txdb, featuretype="all", reduce_ranges=FALSE, upstream=1000, downstream=0)

## List extracted feature types
names(feat)

## Obtain feature lists by genes, here for promoter
split(feat$promoter, unlist(mcols(feat$promoter)$feature_by))

## Return all features in single GRanges object
unlist(feat)

\dontrun{
## Sample from systemPipeRdata package
file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")
feat <- genFeatures(txdb, featuretype="all", reduce_ranges=TRUE, upstream=1000, downstream=0)
}
}
\keyword{ utilities }

\name{printParam2}
\alias{printParam2}
\alias{removeParam2}
\alias{replaceParam2}
\alias{renameParam2}
\alias{appendParam2}

\title{
Accessories function to modify the Command-line Version 2
}
\description{
Accessories function to modify the Command-line Version 2
}
\usage{
printParam2(sysargs, base = FALSE, args = FALSE, inputs = FALSE,
        outputs = FALSE, stdout = FALSE, raw_cmd = FALSE, all = TRUE)
appendParam2(sysargs, x, position = c("inputs", "args", "outputs"),
        after = NULL, verbose = FALSE)
replaceParam2(sysargs, x, index=NULL,
              position = c("inputs", "baseCommand", "args", "outputs", "stdout"),
              verbose = FALSE)
removeParam2(sysargs, index=NULL, position = c("inputs", "args", "outputs", "stdout"),
             verbose = FALSE)
renameParam2(sysargs, index=NULL, new_names,
             position = c("inputs", "args", "outputs", "stdout"), verbose = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sysargs}{
  Object of class \code{SYSargs2}. Output from the \code{createParamFiles} function.
}
  \item{base}{
  logical, print out base command information?
}
  \item{args}{
  logical, print out arguments information?
}
  \item{inputs}{
  logical, print out inputs information?
}
  \item{outputs}{
  logical, print out outputs information?
}
  \item{stdout}{
  logical, print out stdout information?
}
  \item{raw_cmd}{
  logical, print out parsed raw command information?
}
  \item{all}{
  logical, print out all base command, arguments, inputs,
  outputs, and raw command information?
  Turn this to \code{TRUE} will overwrite all above to \code{TRUE}.
  If you need to print out selected positions, turn this to \code{FALSE} and turn
  other positions to \code{TRUE}.
}
  \item{position}{
  string, one of the positions to apply a modification.
  For \code{appendParam2}: "inputs", "args", "outputs",
  for \code{replaceParam2}: "inputs", "baseCommand", "args", "outputs", "stdout",
  for \code{removeParam2}, \code{renameParam2}: "inputs", "args", "outputs", "stdout".
}
  \item{index}{
  numeric or character vector, index of items to remove or rename item(s)
  inside the position you choose, in \code{removeParam2},  \code{renameParam2},
  \code{replaceParam2}.
}
  \item{after}{
  integer, in \code{appendParam2}, after which current item you want to append
  the new items in the position you have selected? For example, if you want
  the new item to be the first, then use \code{0}, if last, then use
  \code{999} to make sure it goes to the last one.
}
  \item{x}{
  named list or string, new items to replace or append in different positions. Replace list length
  must be the same as \code{index}. Different positions will have different requirements.
  See details of the \code{x} format requirements.
}
  \item{new_names}{
  character vector, new names that you wish to replace the old names. \code{new_names} vector length
  must be the same as \code{index} in \code{renameParam2}.
}
  \item{verbose}{
  logical, show addtional information during/after operation? for example, print the new changes.
}
}

\details{
- \code{printParam2}: prints its arguments defined by \code{position} and \code{index}.

- \code{removeParam2}: removes items in certain positions you select.

- \code{replaceParam2}: replaces the values in command-line with indices given in list by those given in values

- \code{renameParam2}: rename the names of items in certain position.

- \code{appendParam2}: Add arguments to the original command line. Adding new basecommand or
  standard out is not allowed.

  \subsection{x format}{
    - If \code{x} is a character, it requires exact 3 semi-colons \code{;} to separate the string
    in to 4 columns. Values before the third column is the same as \code{createParam} inputs,
    first column: prefix/argument name, second column: type, third column: default value.
    The fourth column (new): numeric, index of the new item, this will be translated into
    \code{position} entries in CWL.

    - If \code{x} is a list, it must be named. Following items must be included in list:
     \code{preF}, \code{type}, \code{value}, \code{index}. They refer to prefix, param type,
     default value, and position index correspondingly.
  }
}
\value{
\code{SYSargs2} object
}
\references{
For more details on \code{CWL}, please consult the following page: https://www.commonwl.org/
}
\author{
Le Zhang and Daniela Cassol
}
\seealso{
\code{writeParamFiles}
\code{createParamFiles}
\code{loadWorkflow}
\code{renderWF}
\code{showClass("SYSargs2")}
}

\examples{
command2 <- '
mycmd2 \
    p: -s; File; sample1.txt \
    p: -s; File; sample2.txt \
    p: --c; ; \
    p: -o; File; out: myout.txt \
    ref_genome; File; a.fasta \
    p: --nn; int; 12 \
    mystdout; File; stdout: abc.txt
'
cmd2 <- createParam(command2, syntaxVersion = "v2", writeParamFiles=FALSE)
# string format
new_cmd <- 'p: -abc; string; abc; 7'
cmd2 <- appendParam2(cmd2, x = new_cmd, position = "inputs")
printParam2(cmd2, all = FALSE, inputs = TRUE, raw_cmd = TRUE)
# list format
new_cmd <- list(name = "new_arg", preF = "--foo", index = "8")
cmd2 <- appendParam2(cmd2, x = new_cmd, position = "args")
printParam2(cmd2, all = FALSE, args = TRUE, raw_cmd = TRUE)
# rename
cmd2 <- renameParam2(cmd2, "new_name_arg", index = "new_arg", position = "args")
printParam2(cmd2, all = FALSE, args = TRUE, raw_cmd = TRUE)
# remove
cmd2 <- removeParam2(cmd2, index = "new_name_arg", position = "args")
printParam2(cmd2, all = FALSE, args = TRUE, raw_cmd = TRUE)
}

\keyword{ utilities }

\name{cwlFilesUpdate}
\alias{cwlFilesUpdate}
\title{Update CWL description files}
\description{
Function to sync and download the most updated CWL description files from
the systemPipeR package.
}
\usage{
cwlFilesUpdate(destdir, force = FALSE, verbose = TRUE)
}
\arguments{
\item{destdir}{a character string with the directory path where the param are
stored.}

\item{force}{logical. Force the download of the CWL files.}

\item{verbose}{logical. The setting \code{FALSE} suppresses all print messages.}
}
\author{
Daniela Cassol
}

\examples{
\dontrun{
destdir <- "param/"
cwlFilesUpdate(destdir)
}
}
\keyword{ utilities }

\name{returnRPKM}
\alias{returnRPKM}
\title{
RPKM Normalization
}
\description{
Converts read counts to RPKM normalized values.
}
\usage{
returnRPKM(counts, ranges)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{counts}{
	Count data frame, e.g. from an RNA-Seq experiment.
}
  \item{ranges}{
	\code{GRangesList} object, e.g. generated by \code{exonsBy(txdb, by="gene")}.
}
}
\value{
	\code{data.frame}
}
\author{
Thomas Girke
}
\examples{
\dontrun{
countDFrpkm <- apply(countDF, 2, function(x) returnRPKM(counts=x, gffsub=eByg))
}
}
\keyword{ utilities }

\name{INTERSECTset-class}
\Rdversion{1.1}
\docType{class}
\alias{INTERSECTset-class}
\alias{as.list,INTERSECTset-method}
\alias{coerce,list,INTERSECTset-method}
\alias{complexitylevels,INTERSECTset-method}
\alias{intersectlist,INTERSECTset-method}
\alias{intersectmatrix,INTERSECTset-method}
\alias{length,INTERSECTset-method}
\alias{names,INTERSECTset-method}
\alias{setlist,INTERSECTset-method}
\alias{show,INTERSECTset-method}

\title{Class \code{"INTERSECTset"}}
\description{
Container for storing standard intersect results created by the \code{overLapper} function.
The \code{setlist} slot stores the original label sets as \code{vectors} in a \code{list};
\code{intersectmatrix} organizes the label sets in a present-absent matrix; \code{complexitylevels}
represents the number of comparisons considered for each comparison set as vector of integers;
and \code{intersectlist} contains the standard intersect vectors. 
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("INTERSECTset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{setlist}:}{Object of class \code{"list"}: \code{list} of \code{vectors} }
    \item{\code{intersectmatrix}:}{Object of class \code{"matrix"}: binary \code{matrix} }
    \item{\code{complexitylevels}:}{Object of class \code{"integer"}: \code{vector} of \code{integers} }
    \item{\code{intersectlist}:}{Object of class \code{"list"}: \code{list} of \code{vectors} }
  }
}
\section{Methods}{
  \describe{
    \item{as.list}{\code{signature(x = "INTERSECTset")}: coerces \code{INTERSECTset} to \code{list} }
    \item{coerce}{\code{signature(from = "list", to = "INTERSECTset")}: \code{as(list, "INTERSECTset")} }
    \item{complexitylevels}{\code{signature(x = "INTERSECTset")}: extracts data from \code{complexitylevels} slot }
    \item{intersectlist}{\code{signature(x = "INTERSECTset")}: extracts data from \code{intersectlist} slot }
    \item{intersectmatrix}{\code{signature(x = "INTERSECTset")}: extracts data from \code{intersectmatrix} slot }
    \item{length}{\code{signature(x = "INTERSECTset")}: returns number of original label sets }
    \item{names}{\code{signature(x = "INTERSECTset")}: extracts slot names }
    \item{setlist}{\code{signature(x = "INTERSECTset")}: extracts data from \code{setlist} slot }
    \item{show}{\code{signature(object = "INTERSECTset")}: summary view of \code{INTERSECTset} objects }
	 }
}
\author{
Thomas Girke
}
\seealso{
\code{overLapper}, \code{vennPlot}, \code{olBarplot}, \code{VENNset-class}
}
\examples{
showClass("INTERSECTset")

## Sample data
setlist <- list(A=sample(letters, 18), B=sample(letters, 16),
                C=sample(letters, 20), D=sample(letters, 22),
                E=sample(letters, 18), F=sample(letters, 22))

## Create VENNset
interset <- overLapper(setlist[1:5], type="intersects")
class(interset)

## Accessor methods for VENNset/INTERSECTset objects
names(interset)
setlist(interset)
intersectmatrix(interset)
complexitylevels(interset)
intersectlist(interset)

## Coerce VENNset/INTERSECTset object to list
as.list(interset)
}
\keyword{classes}

\name{runCommandline}
\alias{runCommandline}
\title{
Execute SYSargs and SYSargs2
}
\description{
Function to execute system parameters specified in \code{SYSargs} 
and \code{SYSargs2} object.
}
\usage{
runCommandline(args, runid = "01", make_bam = FALSE, del_sam=TRUE, dir = TRUE, 
                dir.name = NULL, force=FALSE, input_targets = NULL, ...)
}
\arguments{
  \item{args}{
    object of class \code{SYSargs} or \code{SYSargs2}.
}
  \item{runid}{
    Run identifier used for log file to track system call commands. 
    Default is \code{"01"}.
}
  \item{make_bam}{
    Auto-detects SAM file outputs and converts them to sorted and indexed BAM 
    files. Default is \code{make_bam=FALSE}.
}
  \item{del_sam}{
    This option allows deleting the SAM files created when the \code{make_BAM} 
    converts the SAM files to sorted and indexed BAM files. 
    Default is \code{del_sam=TRUE}.
}
  \item{dir}{
    This option allows creating an exclusive results folder for each step in the 
    workflow and a sub-folder for each sample defined in the \code{targets} file. 
    All the outputs and log files for the particular step will be created in the 
    respective folders. Default is \code{dir=TRUE}. Option available only for an 
    object of class \code{SYSargs2}.
}
  \item{dir.name}{
    Name of the workflow directory. Default is \code{dir.name=FALSE}. Note: This 
    argument is required when the \code{dir=TRUE}.
}
  \item{force}{
    Internally, the function checks if the expected \code{output} files exist, 
    and it skips the command lines when the respective files exist. If the 
    argument \code{force} is set to \code{TRUE}, the command line will be 
    executed and the files overwrite. Default is \code{force=FALSE}. 
}
  \item{input_targets}{
    This option allows selecting which targets file and, by consequence which
    command line will be executed. Default is \code{NULL}, in which all command 
    lines will be executed.
}
  \item{\dots}{
    Additional arguments to pass on to \code{runCommandline()}.
}
}
\value{
    Output files, their paths can be obtained with \code{outpaths()} from 
    \code{SYSargs} container or \code{output()} from \code{SYSargs2}. 
    In addition, a \code{character vector} is returned containing the same
    paths.
}
\author{
Daniela Cassol and Thomas Girke
}
\examples{
##########################################
## Examples with \code{SYSargs2} object ##
##########################################
## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF
names(WF); modules(WF); targets(WF)[1]; cmdlist(WF)[1:2]; output(WF)

\dontrun{
## Execute SYSargs2 on single machine
WF <- runCommandline(args=WF)

## Execute SYSargs on multiple machines of a compute cluster. 
file.copy(system.file("extdata", ".batchtools.conf.R", 
            package="systemPipeR"), ".")
file.copy(system.file("extdata", "batchtools.slurm.tmpl", 
            package="systemPipeR"), ".")
resources <- list(walltime=120, ntasks=1, ncpus=4, memory=1024) 
reg <- clusterRun(WF, FUN = runCommandline, 
        more.args = list(args = WF, make_bam = TRUE), 
        conffile=".batchtools.conf.R", template="batchtools.slurm.tmpl",
        Njobs=18, runid="01", resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)

## Updates the path in the object \code{output(WF)}
WF <- output_update(WF, dir=FALSE, replace=TRUE, extension=c(".sam", ".bam"))

## Alignment stats
read_statsDF <- alignStats(WF) 
read_statsDF <- cbind(read_statsDF[targets$FileName,], targets)
write.table(read_statsDF, "results/alignStats.xls",
            row.names=FALSE, quote=FALSE, sep="\t")
}

#########################################
## Examples with \code{SYSargs} object ##
#########################################
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "hisat2.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); modules(args); cores(args); outpaths(args); sysargs(args)

\dontrun{
## Execute SYSargs on single machine
runCommandline(args=args)

## Execute SYSargs on multiple machines of a compute cluster. 
file.copy(system.file("extdata", ".batchtools.conf.R", package="systemPipeR"), ".")
file.copy(system.file("extdata", "batchtools.slurm.tmpl", package="systemPipeR"), ".")
resources <- list(walltime=120, ntasks=1, ncpus=cores(args), memory=1024) 
reg <- clusterRun(args, FUN = runCommandline, conffile=".batchtools.conf.R", 
                    template="batchtools.slurm.tmpl", Njobs=18, 
                    runid="01", resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)
file.exists(outpaths(args))

## Alignment stats
read_statsDF <- alignStats(args) 
read_statsDF <- cbind(read_statsDF[targets$FileName,], targets)
write.table(read_statsDF, "results/alignStats.xls", row.names=FALSE, 
            quote=FALSE, sep="\t")
}
}
\keyword{ utilities }

\name{countRangeset}
\alias{countRangeset}
\title{
Read counting for several range sets
}
\description{
Convenience function to perform read counting iteratively for serveral 
range sets, e.g. peak range sets or feature types. Internally, 
the read counting is performed with the \code{summarizeOverlaps}
function from the \code{GenomicAlignments} package. The resulting count 
tables are directly saved to files.
}
\usage{
countRangeset(bfl, args, outfiles=NULL, format="tabular", ...)
}
\arguments{
  \item{bfl}{
    \code{BamFileList} object containing paths to one or more BAM files.
}
  \item{args}{
    An instance of \code{SYSargs} or \code{SYSargs2} constructed from a
    \code{targets} file where the first column (\code{targetsin(args)} or 
    \code{targets.as.df(targets(args))}) contains the paths to the tabular range 
    data files (e.g. peak ranges) used for counting. Another possibily is 
    \code{named character vector} with the paths to the tabular range data files 
    and the elements names should be the sampleID.
}
  \item{outfiles}{
    Default is \code{NULL}. When \code{args} is an object of \code{named 
    character vector} class, \code{outfile} argument is required. 
    \code{Named character vector} with the paths to the resulting count tables
    and the elements names should be the sampleID.
}
  \item{format}{
    Format of input range files. Currently, supported are \code{tabular} or 
    \code{bed}. If \code{tabular} is selected then the input range files need 
    to contain the proper column titles to coerce with \code{as(..., "GRanges")} 
    to \code{GRanges}  objects after importing them with \code{read.delim}. The 
    latter is the case for the peak files (\code{*peaks.xls}) generated by the 
    MACS2 software.
}
  \item{\dots}{
    Arguments to be passed on to internally used \code{summarizeOverlaps}
    function.
}
}
\value{
Named character vector containing the paths from \code{outpaths(args)} to the 
resulting count table files. 
}
\author{
Thomas Girke
}
\seealso{
\code{summarizeOverlaps}
}
\examples{
## Paths to BAM files
param <- system.file("extdata", "bowtieSE.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args_bam <- systemArgs(sysma=param, mytargets=targets)
bfl <- BamFileList(outpaths(args_bam), yieldSize=50000, index=character())

\dontrun{
##########################################
## Examples with \code{SYSargs2} object ##
##########################################
## Construct SYSargs2 object 
## SYSargs2 with paths to range data and count files
dir_path <- system.file("extdata/cwl/count_rangesets", package="systemPipeR")
args <- loadWF(targets = "targets_macs.txt", wf_file = "count_rangesets.cwl", 
    input_file = "count_rangesets.yml", dir_path = dir_path)
args <- renderWF(args, inputvars = c(FileName = "_FASTQ_PATH1_", SampleName = "_SampleName_"))

## Iterative read counting
countDFnames <- countRangeset(bfl, args, mode="Union", ignore.strand=TRUE)

##########################################
## Examples with \code{SYSargs} object ##
##########################################
## Construct SYSargs object 
## SYSargs with paths to range data and count files
args <- systemArgs(sysma="param/count_rangesets.param", mytargets="targets_macs.txt")

## Iterative read counting
countDFnames <- countRangeset(bfl, args, mode="Union", ignore.strand=TRUE)
writeTargetsout(x=args, file="targets_countDF.txt", overwrite=TRUE)
}
}
\keyword{ utilities }

\name{alignStats}
\alias{alignStats}
\title{
Alignment statistics 
}
\description{
Generate data frame containing important read alignment statistics such as the
total number of reads in the FASTQ files, the number of total alignments, as
well as the number of primary alignments in the corresponding BAM files. 
}
\usage{
alignStats(args, fqpaths, pairEnd = TRUE, output_index = 1, subset="FileName1")
}
\arguments{
  \item{args}{
    Object of class \code{SYSargs} or \code{SYSargs2} or \code{named character vector} 
    with BAM files PATH and the elements names should be the sampleID. 
}
  \item{fqpaths}{
    \code{named character vector} with raw FASTQ files PATH and the names should be the sampleID. 
    Required when \code{class(args)} is "character".
}
  \item{pairEnd}{
    logical. For pair-end libraries, select \code{TRUE}.
}
  \item{output_index}{
    A numeric index positions of the file in \code{SYSargs2} object, slot \code{output}. Default is \code{output_index=1}.
}
  \item{subset}{
    \code{subset} are the variables defined in the \code{param.yml} file, for example "FileName1".
}
}
\value{
    \code{data.frame} with alignment statistics.
}
\seealso{
\code{clusterRun} and \code{runCommandline} and \code{output_update}
}
\author{
Thomas Girke
}
\examples{
##########################################
## Examples with \code{SYSargs2} object ##
##########################################
## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targetspath, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF

names(WF); modules(WF); targets(WF)[1]; cmdlist(WF)[1:2]; output(WF)

\dontrun{
## Execute SYSargs2 on single machine
WF <- runCommandline(args=WF, make_bam=TRUE)

## Alignment stats
read_statsDF <- alignStats(WF, subset="FileName") 
write.table(read_statsDF, "results/alignStats.xls", row.names=FALSE, quote=FALSE, sep="\t")
}

#########################################
## Examples with \code{SYSargs} object ##
#########################################
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "hisat2.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); modules(args); cores(args); outpaths(args); sysargs(args)

\dontrun{
## Execute SYSargs on single machine
runCommandline(args=args)

## Alignment stats
read_statsDF <- alignStats(args) 
write.table(read_statsDF, "results/alignStats.xls", row.names=FALSE, quote=FALSE, sep="\t")
}
}
\keyword{ utilities }

\name{preprocessReads}
\alias{preprocessReads}
\title{
Run custom read preprocessing functions
}
\description{
Applies custom read preprocessing functions to single-end or paired-end FASTQ 
files. The function uses the \code{FastqStreamer} function from the \code{ShortRead} 
package to stream through large files in a memory-efficient manner. 
}
\usage{
preprocessReads(args = NULL,
                FileName1 = NULL, FileName2 = NULL, 
                outfile1 = NULL, outfile2 = NULL, 
                Fct, batchsize = 100000, overwrite = TRUE, ...)
}
\arguments{
  \item{args}{
Object of class \code{SYSargs} or \code{SYSargs2}.
}
  \item{FileName1}{
Path to input forward fastq file. Defaul is \code{NULL}.
}
  \item{FileName2}{
Path to input reverse fastq file. Defaul is \code{NULL}
}
  \item{outfile1}{
Path to output forward fastq file. Defaul is \code{NULL}
}
  \item{outfile2}{
Path to output reverse fastq file. Defaul is \code{NULL}
}
  \item{Fct}{
\code{character} string of custom read preprocessing function call where both the 
input and output needs to be an object of class \code{ShortReadQ}. The name of the 
input \code{ShortReadQ} object needs to be \code{fq}.
}
  \item{batchsize}{
Number of reads to process in each iteration by the internally used \code{FastqStreamer}
function.
}
  \item{overwrite}{
If \code{TRUE} existing file will be overwritten.
}
  \item{\dots}{
To pass on additional arguments to the internally used \code{writeFastq} function.
}
}
\value{
Writes to files in FASTQ format. Their names are specified by \code{outpaths(args)}.
}
\author{
Thomas Girke
}
\seealso{
FastqStreamer 
}
\examples{
## Preprocessing of single-end reads
dir_path <- system.file("extdata/cwl/preprocessReads/trim-se", package="systemPipeR")
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
trim <- loadWorkflow(targets=targetspath, wf_file="trim-se.cwl", input_file="trim-se.yml", dir_path=dir_path)
trim <- renderWF(trim, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
\dontrun{
preprocessReads(args=trim[1], Fct="trimLRPatterns(Rpattern='GCCCGGGTAA', subject=fq)", batchsize=100000, overwrite=TRUE, compress=TRUE)
}

## Preprocessing of paired-end reads
dir_path <- system.file("extdata/cwl/preprocessReads/trim-pe", package="systemPipeR")
targetspath <- system.file("extdata", "targetsPE.txt", package="systemPipeR")
trim <- loadWorkflow(targets=targetspath, wf_file="trim-pe.cwl", input_file="trim-pe.yml", dir_path=dir_path)
trim <- renderWF(trim, inputvars=c(FileName1="_FASTQ_PATH1_", FileName2="_FASTQ_PATH2_", SampleName="_SampleName_"))
trim
\dontrun{
preprocessReads(args=trim[1], Fct="trimLRPatterns(Rpattern='GCCCGGGTAA', subject=fq)", batchsize=100000, overwrite=TRUE, compress=TRUE)
}
}
\keyword{ utilities }

\name{filterVars}
\alias{filterVars}
\title{
Filter VCF files
}
\description{
Convenience function for filtering VCF files based on user definable quality 
parameters. The function imports each VCF file into R, applies the filtering on 
an internally generated \code{VRanges} object and then writes the results to a 
new VCF file.
}
\usage{
filterVars(files, filter, varcaller="gatk", organism,
            out_dir="results")
}
\arguments{
  \item{files}{
	\code{named character vector} with paths of the input VCF files.
}
  \item{filter}{
	Character vector of length one specifying the filter syntax that will be 
	applied to the internally created \code{VRanges} object.
}
  \item{varcaller}{
	Character vector of length one specifying the variant caller used for 
	generating the input VCFs. Currently, this argument can be assigned 'gatk', 
	'bcftools' or 'vartools'.
}
  \item{organism}{
	Character vector specifying the organism name of the reference genome.
}
  \item{out_dir}{
	Character vector of a \code{results} directory name. 
	Default is \code{results}. 
}
}
\value{
	Output files in VCF format. Their paths can be obtained with 
	\code{outpaths(args)} or \code{output(args)}. 
}
\author{
Thomas Girke
}
\seealso{
\code{variantReport} \code{combineVarReports}, \code{varSummar}
}
\examples{
## Alignment with BWA (sequentially on single machine)
param <- system.file("extdata", "bwa.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
sysargs(args)[1]

\dontrun{
library(VariantAnnotation)
system("bwa index -a bwtsw ./data/tair10.fasta")
bampaths <- runCommandline(args=args)

## Alignment with BWA (parallelized on compute cluster)
resources <- list(walltime="20:00:00", nodes=paste0("1:ppn=", cores(args)), memory="10gb")
reg <- clusterRun(args, conffile=".BatchJobs.R", template="torque.tmpl", Njobs=18, runid="01",
                  resourceList=resources)

## Variant calling with GATK
## The following creates in the inital step a new targets file
## (targets_bam.txt). The first column of this file gives the paths to
## the BAM files created in the alignment step. The new targets file and the
## parameter file gatk.param are used to create a new SYSargs
## instance for running GATK. Since GATK involves many processing steps, it is
## executed by a bash script gatk_run.sh where the user can specify the
## detailed run parameters. All three files are expected to be located in the
## current working directory. Samples files for gatk.param and
## gatk_run.sh are available in the subdirectory ./inst/extdata/ of the 
## source file of the systemPipeR package. 
writeTargetsout(x=args, file="targets_bam.txt")
system("java -jar CreateSequenceDictionary.jar R=./data/tair10.fasta O=./data/tair10.dict")
# system("java -jar /opt/picard/1.81/CreateSequenceDictionary.jar R=./data/tair10.fasta O=./data/tair10.dict")
args <- systemArgs(sysma="gatk.param", mytargets="targets_bam.txt")
resources <- list(walltime="20:00:00", nodes=paste0("1:ppn=", 1), memory="10gb")
reg <- clusterRun(args, conffile=".BatchJobs.R", template="torque.tmpl", Njobs=18, runid="01",
                  resourceList=resources)
writeTargetsout(x=args, file="targets_gatk.txt")

## Variant calling with BCFtools
## The following runs the variant calling with BCFtools. This step requires in
## the current working directory the parameter file sambcf.param and the 
## bash script sambcf_run.sh.
args <- systemArgs(sysma="sambcf.param", mytargets="targets_bam.txt")
resources <- list(walltime="20:00:00", nodes=paste0("1:ppn=", 1), memory="10gb")
reg <- clusterRun(args, conffile=".BatchJobs.R", template="torque.tmpl", Njobs=18, runid="01",
                  resourceList=resources)
writeTargetsout(x=args, file="targets_sambcf.txt")

## Filtering of VCF files generated by GATK
args <- systemArgs(sysma="filter_gatk.param", mytargets="targets_gatk.txt")
filter <- "totalDepth(vr) >= 2 & (altDepth(vr) / totalDepth(vr) >= 0.8) & rowSums(softFilterMatrix(vr))==4"
# filter <- "totalDepth(vr) >= 20 & (altDepth(vr) / totalDepth(vr) >= 0.8) & rowSums(softFilterMatrix(vr))==6"
filterVars(args, filter, varcaller="gatk", organism="A. thaliana")
writeTargetsout(x=args, file="targets_gatk_filtered.txt")

## Filtering of VCF files generated by BCFtools
args <- systemArgs(sysma="filter_sambcf.param", mytargets="targets_sambcf.txt")
filter <- "rowSums(vr) >= 2 & (rowSums(vr[,3:4])/rowSums(vr[,1:4]) >= 0.8)"
# filter <- "rowSums(vr) >= 20 & (rowSums(vr[,3:4])/rowSums(vr[,1:4]) >= 0.8)"
filterVars(args, filter, varcaller="bcftools", organism="A. thaliana")
writeTargetsout(x=args, file="targets_sambcf_filtered.txt")

## Annotate filtered variants from GATK
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
txdb <- loadDb("./data/tair10.sqlite")
fa <- FaFile(systemPipeR::reference(args))
variantReport(args=args, txdb=txdb, fa=fa, organism="A. thaliana")

## Annotate filtered variants from BCFtools
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_sambcf_filtered.txt")
txdb <- loadDb("./data/tair10.sqlite")
fa <- FaFile(systemPipeR::reference(args))
variantReport(args=args, txdb=txdb, fa=fa, organism="A. thaliana")

## Combine results from GATK
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
combineDF <- combineVarReports(args, filtercol=c(Consequence="nonsynonymous"))
write.table(combineDF, "./results/combineDF_nonsyn_gatk.xls", quote=FALSE, row.names=FALSE, sep="\t")

## Combine results from BCFtools
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_sambcf_filtered.txt")
combineDF <- combineVarReports(args, filtercol=c(Consequence="nonsynonymous"))
write.table(combineDF, "./results/combineDF_nonsyn_sambcf.xls", quote=FALSE, row.names=FALSE, sep="\t")

## Summary for GATK
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
write.table(varSummary(args), "./results/variantStats_gatk.xls", quote=FALSE, col.names = NA, sep="\t")

## Summary for BCFtools
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_sambcf_filtered.txt")
write.table(varSummary(args), "./results/variantStats_sambcf.xls", quote=FALSE, col.names = NA, sep="\t")

## Venn diagram of variants
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_gatk_filtered.txt")
varlist <- sapply(names(outpaths(args))[1:4], function(x) as.character(read.delim(outpaths(args)[x])$VARID))
vennset_gatk <- overLapper(varlist, type="vennsets")
args <- systemArgs(sysma="annotate_vars.param", mytargets="targets_sambcf_filtered.txt")
varlist <- sapply(names(outpaths(args))[1:4], function(x) as.character(read.delim(outpaths(args)[x])$VARID))
vennset_bcf <- overLapper(varlist, type="vennsets")
vennPlot(list(vennset_gatk, vennset_bcf), mymain="", mysub="GATK: red; BCFtools: blue", colmode=2, ccol=c("blue", "red"))
}
}
\keyword{ utilities }

\name{createParam}
\alias{createParamFiles}
\alias{writeParamFiles}
\alias{createParam}

\title{
createParam
}
\description{
The constructor function creates an \code{SYSargs2} S4 class object from
command-line string. Also, the function creates and saves the CWL param files.
The latest storages all the parameters required for running command-line software,
following the standard and specification defined on Common Workflow Language (CWL).
}
\usage{
createParamFiles(commandline, cwlVersion = "v1.1", class = "CommandLineTool",
                  results_path = "./results", module_load = "baseCommand",
                  file = "default", syntaxVersion = "v1",
                  writeParamFiles = TRUE, confirm = FALSE,
                  overwrite = FALSE, silent = FALSE)

writeParamFiles(sysargs, file = "default", overwrite = TRUE, silent = FALSE,
                syntaxVersion = "v1")
}

\arguments{
  \item{commandline}{
  string. Original command-line to create the CWL files from. Please see
  \code{Details} for more information.
}
  \item{cwlVersion}{
  string. The version of the Common Workflow Language. More information
  here: https://www.commonwl.org/.
}
  \item{class}{
  character. Name of Common Workflow Language Description class. The following
  is accepted: \code{CommandLineTool}.
}
  \item{results_path}{
  Path to the results folder. Default is \code{results}.
}
  \item{module_load}{
  string, Name of software to load by Environment Modules system. Default is
  "baseCommand", which creates a subfolder and two files: *.cwl and *.yml
  at \code{./param/cwl/}.
}
  \item{file}{
  character. Name and path of output files. If set to "default" then the name of
  the output files will have the pattern \code{<software>.cwl} and
  \code{<software>.yml}, where <software> will be what \code{baseCommand(x)}
  returns, when \code{x} is an object of class \code{SYSargs2}.
  Also, it creates a subfolder at \code{./param/cwl/} with name <software>.
}
  \item{syntaxVersion}{
  character. One of \code{"v1"} or \code{"v2"}, what CWL parsing syntax version to use.
  Default is to use the old version. The V2 version comes with more feature support,
  but has more syntax restrictions. See details.
}
  \item{writeParamFiles}{
  logical. If set to TRUE, it will write to file the content of the CWL
  files:\code{*.cwl} and \code{*.yml}. Default is \code{TRUE}.
}
  \item{confirm}{
  If set to \code{FALSE} and in an interactive section, it will prompt a question to
  proceed or not.
}
  \item{overwrite}{
   logical. If set to TRUE, existing files of the same name will be overwritten.
   Default is \code{FALSE}.
}
  \item{silent}{
  logical. If set to TRUE, all messages returned by the function will be
  suppressed. Default is \code{FALSE}.
}
  \item{sysargs}{
  Object of class \code{SYSargs2}. Output from the \code{createParamFiles}
  function.
}
}
\details{

    \subsection{Version 1 syntax}{

    - First line of the command-line object will be treated as the
    \code{baseCommand};

    - For argument lines (starting from the second line), any word before the first
      space with leading `-` or `--` in each will be treated as a prefix, like
      \code{-S} or \code{--min}. Any line without this first word will be treated
      as no prefix;

    - All defaults are placed inside \code{<...>};

    - First argument is the input argument type. \code{F} for "File", \code{int}
      for integer, \code{string} for string;

    - Optional: use the keyword \code{out} followed the type with a \code{,} comma
      separation to indicate if this argument is also a CWL output;

    - Then, use \code{:} to separate keywords and default values, any non-space
      value after the \code{:} will be treated as the default value;

    - If any argument has no default value, just a flag, like \code{--verbose},
      there no need to add any \code{<...>}.

    - The \code{\\} is not required, however for consistency it is recommended to add.

    }

    \subsection{Version 2 syntax}{

    - First line of the command-line object will be treated as the
    \code{baseCommand};

    - Each line specifies one argument and its default value.

    - Each line is composed with exact 2 \code{;} to seprate 3 columns.

    - Text before first \code{;} will be will used as prefix/names.
    If it starts with keyword "\code{p:}", anything after "\code{p:}"
    and before the first \code{;} will be used as prefix, and the name
    of this position will be the prefix but with leading dash(s) "\code{-}",
    "\code{-}" removed. If there is any duplication, a number index will be
    added to the end. If there is no keyword "\code{p:}" before first \code{;},
    all text before first \code{;} will be the name.

    - If there is keyword "\code{p:}" before first \code{;} but nothing before
    and after the second \code{;}, this position will be treated as CWL argument
    instead of input.

    - Text between first and second \code{;} is type. Must be one of File, Directory,
    string, int, double, float, long, boolean.

    - Text after second \code{;} and before \code{\\} or end of the line is the
    default value. If it starts with keyword "\code{out}" or "\code{stdout}", this
    position will also be added to outputs or standard output.

    - There is only 1 position with "\code{stdout}" allowed and usually it is the
    last position arguement.

    - Ending with "\code{\\}" is recommended but not required.

    }
}
\value{
\code{SYSargs2} object
}
\references{
For more details on \code{CWL}, please consult the following
page: https://www.commonwl.org/
}
\author{
Le Zhang and Daniela Cassol
}
\seealso{
\code{writeParamFiles}
\code{printParam}
\code{subsetParam}
\code{replaceParam}
\code{renameParam}
\code{appendParam}
\code{loadWorkflow}
\code{renderWF}
\code{showClass("SYSargs2")}
}

\examples{
## syntax version 1  example
command <- "
hisat2 \
    -S <F, out: ./results/M1A.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: ./data/SRR446027_1.fastq.gz> \
    --verbose
"
cmd <- createParam(command, writeParamFiles=FALSE)
cmdlist(cmd)

## syntax version 2  example
command2 <- '
mycmd2 \
    p: -s; File; sample1.txt \
    p: -s; File; sample2.txt \
    p: --c; ; \
    p: -o; File; out: myout.txt \
    ref_genome; File; a.fasta \
    p: --nn; int; 12 \
    mystdout; File; stdout: abc.txt
'
cmd2 <- createParam(command2, syntaxVersion = "v2", writeParamFiles=FALSE)
cmdlist(cmd2)

}

\keyword{ utilities }

\name{catmap}
\alias{catmap}
\alias{catmap-methods}
\alias{catlist}
\alias{catlist-methods}
\alias{idconv}
\alias{idconv-methods}
\docType{data}
\title{ catDB accessor methods}

\description{
	Methods to access information from \code{catDB} object.
}
\usage{
	catmap(x)
}
\arguments{
  \item{x}{
	object of class \code{catDB}
}
}
\value{
	various outputs
}
\author{
Thomas Girke
}
\examples{
\dontrun{
## Obtain annotations from BioMart
m <- useMart("ENSEMBL_MART_PLANT"); listDatasets(m) 
m <- useMart("ENSEMBL_MART_PLANT", dataset="athaliana_eg_gene")
listAttributes(m) # Choose data types you want to download
go <- getBM(attributes=c("go_accession", "tair_locus", 
                            "go_namespace_1003"), mart=m)
go <- go[go[,3]!="",]; go[,3] <- as.character(go[,3])
write.table(go, "GOannotationsBiomart_mod.txt", quote=FALSE, 
            row.names=FALSE, col.names=FALSE, sep="\t")

## Create catDB instance (takes a while but needs to be done only once)
catdb <- makeCATdb(myfile="GOannotationsBiomart_mod.txt", lib=NULL, 
                    org="", colno=c(1,2,3), idconv=NULL)
catdb

## Access methods for catDB
catmap(catdb)$D_MF[1:4,]
catlist(catdb)$L_MF[1:4]
idconv(catdb)

}
}
\keyword{ utilities }

\name{renderLogs}
\alias{renderLogs}
\title{
Render RMarkdown Logs Report
}
\description{
Render the logs report file to the specified output format using pandoc.
}
\usage{
renderLogs(sysargs, type = c("html_document", "pdf_document"), 
            fileName = "default", quiet = FALSE, 
            open_file = TRUE)
}
\arguments{
  \item{sysargs}{
  object of class \code{SYSargsList}.
}
  \item{type}{
  The R Markdown output format to convert to. The option 
  can be the name of a format (e.g. \code{"pdf_document"} or \code{"html_document"}).
}
  \item{fileName}{
  character string naming a file output. Default is \code{"logs_<date>.Rmd"}.
}
  \item{quiet}{
  If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{open_file}{
  Default is \code{TRUE}. 
}
}
\value{
It will return an \code{SYSargsList} updated.
}
\author{
Daniela Cassol
}
\seealso{
See also as \code{SYSargsList-class}.
}
\examples{
## Construct SYSargsList object from Rmd file
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", package="systemPipeR"),
                               inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")
sal <- runWF(sal)
sal <- renderLogs(sal, open_file = FALSE)
}
\keyword{ utilities }

\name{configWF}
\alias{configWF}
\title{
Workflow Steps Selection
}
\description{
This function allows the user to control of which step of the workflow will be 
run and the generation of the new RMarkdown.
}
\usage{
configWF(x, input_steps = "ALL", exclude_steps = NULL, silent = FALSE, ...)
}
\arguments{
  \item{x}{
  object of class \code{SYSargsList}.
}
  \item{input_steps}{
  a character vector of all steps desires to preserve on the output file. 
Default is \code{ALL}. It can be used the symbol ":" to select many steps in 
sequence, for example, input_steps=1:5.2, from step 1 to step 5.2.
The symbol "." represents the substeps and symbol "," is used to separate selections.
Jump from a major step to sub-step is supported, but if a major step is selected/excluded, 
all sub-steps of this major step will be selected/excluded. Repeatedly selected 
steps will only result in a unique step.It is recommended to put major steps in 
\code{input_steps}, like \code{1:4, 6:8, 10}; and unwanted sub-steps in 
\code{exclude_step}, like \code{1.1, 3.1.1-3.1.3, 6.5}. Reverse selecting is 
supported e.g. \code{10:1}. 
}
  \item{exclude_steps}{
  a character vector of all steps desires to remove on the output file.
}
  \item{silent}{
  if set to TRUE, all messages returned by the function will be suppressed.
}
  \item{\dots}{
  Additional arguments to pass on to \code{configWF()}.
}
}
\author{
Daniela Cassol
}
\examples{
\dontrun{
library(systemPipeRdata)
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
script <- system.file("extdata/workflows/rnaseq", "systemPipeRNAseq.Rmd", package="systemPipeRdata")
SYSconfig <- initProject(projPath="./", targets=targets, script=script, overwrite=TRUE, silent=TRUE)

sysargslist <- configWF(x=sysargslist)
 }
}
\keyword{ utilities }

\name{filterDEGs}
\alias{filterDEGs}
\title{
Filter and plot DEG results
}
\description{
Filters and plots DEG results for a given set of sample comparisons. The gene idenifiers of all (i) Up_or_Down, (ii) Up and (iii) Down regulated genes are stored as separate list components, while the corresponding summary statistics, stored in a fourth list component, is plotted in form of a stacked bar plot.
}
\usage{
filterDEGs(degDF, filter, plot = TRUE)
}
\arguments{
  \item{degDF}{
	\code{data.frame} generated by \code{run_edgeR}
}
  \item{filter}{
	Named vector with filter cutoffs of format \code{c(Fold=2, FDR=1)} where \code{Fold} refers to the fold change cutoff (unlogged) and \code{FDR} to the p-value cutoff.
}
  \item{plot}{
	Allows to turn plotting behavior on and off with default set to \code{TRUE}. 
}
}
\details{
Currently, there is no community standard available how to calculate fold
changes (here logFC) of genomic ranges, such as gene or feature ranges, to
unambiguously refer to them as features with increased or decreased read
abundandce; or in case of gene expression experiments to up or down regulated
genes, respectively. To be consistent within \code{systemPipeR}, the
corresponding functions, such as \code{filterDEGs}, use here the following
definition. Genomic ranges with positive logFC values are classified as
\code{up} and those with negative logFC values as \code{down}.  This means if a
comparison among two samples \code{a} and \code{b} is specified in the
corresponding targets file as \code{a-b} then the feature with a positive logFC
has a higher _normalized_ read count value in sample \code{a} than in sample
\code{b}, and vice versa. To inverse this assignment, users want to change the
specification of their chosen sample comparison(s) in the targets file
accordingly, e.g. change \code{a-b} to \code{b-a}. Alternatively, one can swap
the column order of the matrix assigned to the \code{cmp} argument of the
\code{run_edgeR} or \code{run_DESeq2} functions. Users should also be aware
that for logFC values close to zero (noise range), the direction of the fold
change (sign of logFC) can be very sensitive to minor differences in the
normalization method, while this assignment is much more robust for more
pronounced changes or higher absolute logFC values. 
}
\value{
Returns \code{list} with four components
  \item{UporDown}{List of up or down regulated gene/transcript indentifiers meeting the chosen filter settings for all comparisons defined in data frames \code{pval} and \code{log2FC}.}
  \item{Up}{Same as above but only for up regulated genes/transcript.}
  \item{Down}{Same as above but only for down regulated genes/transcript.}
}
\author{
Thomas Girke
}
\seealso{
\code{run_edgeR}
}
\examples{
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
targets <- read.delim(targetspath, comment.char = "#")
cmp <- readComp(file=targetspath, format="matrix", delim="-")
countfile <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
countDF <- read.delim(countfile, row.names=1)
edgeDF <- run_edgeR(countDF=countDF, targets=targets, cmp=cmp[[1]], independent=FALSE, mdsplot="")
pval <- edgeDF[, grep("_FDR$", colnames(edgeDF)), drop=FALSE]
fold <- edgeDF[, grep("_logFC$", colnames(edgeDF)), drop=FALSE]
DEG_list <- filterDEGs(degDF=edgeDF, filter=c(Fold=2, FDR=10))
names(DEG_list)
DEG_list$Summary
}
\keyword{utilities}

\name{featuretypeCounts}
\alias{featuretypeCounts}
\title{
Plot read distribution across genomic features
}
\description{
Counts how many reads in short read alignment files (BAM format) overlap with
entire annotation categories. This utility is useful for analyzing the
distribution of the read mappings across feature types, e.g. coding versus non-coding
genes. By default the read counts are reported for the sense and antisense
strand of each feature type separately. To minimize memory consumption, the
BAM files are processed in a stream using utilities from the \code{Rsamtools}
and \code{GenomicAlignment} packages.  The counts can be reported for each
read length separately or as a single value for reads of any length.
Subsequently, the counting results can be plotted with the associated
\code{plotfeaturetypeCounts} function.
}
\usage{
featuretypeCounts(bfl, grl, singleEnd = TRUE, readlength = NULL, type = "data.frame")
}
\arguments{
  \item{bfl}{
\code{BamFileList} object containing the paths to the target BAM files stored
on disk. Note, memory-efficient processing is achieved by streaming through
BAM files rather than reading entire files into memory at once. The maximum
number of alignments to process in each iteration is determined by the
\code{yieldSize} value passed on to the \code{BamFileList} function. For
details see \code{?BamFileList}. 
}
  \item{grl}{
\code{GRangesList} object containing in each list component the range set of
a feature type. Typically, this object is generated with the \code{genFeatures}
function. For details see the example section below and \code{?genFeatures}. 
}
  \item{singleEnd}{
Specifies whether the targets BAM files contain alignments for single-end (SE) or paired-end
read data. \code{TRUE} is for SE and \code{FALSE} for PE data. 
}
  \item{readlength}{
Integer vector specifying the read length values for which to report counts
separately. If \code{readlength=NULL} the length of the reads will be ignored
resulting in a single value for each feature type and strand. Note, for PE data
the two reads in a pair may differ in length. In those cases the length of the
two reads is averaged and then assigned to the corresponding length category
after rounding the mean length to the closest integer. This is not an ideal
solution but a reasonable compromise for the purpose of the summary statistics
generated by \code{featuretypeCounts}. 
}
  \item{type}{
Determines whether the results are returned as \code{data.frame} (\code{type="data.frame"}) 
or as \code{list} (\code{type="list"}). Each list component contains the counting
results for one BAM file and is named after the corresponding sample. The 
\code{data.frame} result contains this sample assignment information in a separate 
column.  
}
}
\value{
The results are returned as \code{data.frame} or \code{list} of \code{data.frames}.
For details see above under \code{types} argument. The result \code{data.frames} contain
the following columns in the given order:
\item{SampleName}{Sample names obtained from \code{BamFileList} object.}
\item{Strand}{Sense or antisense strand of read mappings.}  
\item{Featuretype}{Name of feature type provided by \code{GRangesList} object. Note, the total number
of aligned reads is reported under the special feature type 'N_total_aligned'. This value 
is useful for scaling/normalization purposes in plots, e.g. counts per million reads.}
\item{Featuretypelength}{Total genomic length of each reduced feature type in bases. This value is 
useful to normalize the read counts by genomic length units, e.g. in plots.}
\item{Subsequent columns}{Counts for reads of any length or for individual read lengths.}
}
\author{
Thomas Girke
}
\seealso{
\code{plotfeaturetypeCounts}, \code{genFeatures}
}
\examples{
## Construct SYSargs2 object from param and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args

\dontrun{
## Run alignments
args <- runCommandline(args, dir = FALSE, make_bam = TRUE)
outpaths <- subsetWF(args, slot = "output", subset = 1, index = 1)

## Features from sample data of systemPipeRdata package
library(txdbmaker)
file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")
feat <- genFeatures(txdb, featuretype="all", reduce_ranges=TRUE, upstream=1000, downstream=0, verbose=TRUE)

## Generate and plot feature counts for specific read lengths
fc <- featuretypeCounts(bfl=BamFileList(outpaths, yieldSize=50000), grl=feat, singleEnd=TRUE, readlength=c(74:76,99:102), type="data.frame")
p <- plotfeaturetypeCounts(x=fc, graphicsfile="featureCounts.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=FALSE)

## Generate and plot feature counts for any read length  
fc2 <- featuretypeCounts(bfl=BamFileList(outpaths, yieldSize=50000), grl=feat, singleEnd=TRUE, readlength=NULL, type="data.frame")
p2 <- plotfeaturetypeCounts(x=fc2, graphicsfile="featureCounts2.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=TRUE)
}
}
\keyword{ utilities }

\name{SYSargs2-class}
\Rdversion{1.1}
\docType{class}
% Class
\alias{SYSargs2-class}
% Subsetting and Quick access
\alias{[,SYSargs2,ANY,ANY,ANY-method}
\alias{[[,SYSargs2,ANY,missing-method}
\alias{[[<-,SYSargs2,ANY,ANY,ANY-method}
\alias{[[<-,SYSargs2,ANY,ANY-method}
\alias{$,SYSargs2-method}
\alias{length,SYSargs2-method}
\alias{names,SYSargs2-method}
\alias{show,SYSargs2-method}
% Coercion
\alias{coerce,list,SYSargs2-method}
\alias{coerce,SYSargs2,list-method}
\alias{sysargs2}
\alias{sysargs2,SYSargs2-method}
%Accessors
\alias{targets}
\alias{targets,SYSargs2-method}
\alias{targetsheader,SYSargs2-method}
\alias{modules}
\alias{modules,SYSargs2-method}
\alias{infile1,SYSargs2-method}
\alias{infile2,SYSargs2-method}
\alias{wf}
\alias{wf,SYSargs2-method}
\alias{clt}
\alias{clt,SYSargs2-method}
%\alias{yamlinput}
\alias{yamlinput,SYSargs2-method}
%\alias{cmdlist}
\alias{cmdlist,SYSargs2-method}
\alias{input}
\alias{input,SYSargs2-method}
\alias{output}
\alias{output,SYSargs2-method}
\alias{files}
\alias{files,SYSargs2-method}
\alias{inputvars}
\alias{inputvars,SYSargs2-method}
\alias{cmdToCwl}
\alias{cmdToCwl,SYSargs2-method}
\alias{status}
\alias{status,SYSargs2-method}
\alias{internal_outfiles}
\alias{internal_outfiles,SYSargs2-method}
%Methods
%\alias{baseCommand}
\alias{baseCommand,SYSargs2-method}
\alias{SampleName,SYSargs2-method}
% Replacement
%\alias{yamlinput<-}
\alias{yamlinput<-,SYSargs2-method}
\alias{yamlinput<-,SYSargs2,ANY,ANY-method}
\alias{cmdToCwl<-}
\alias{cmdToCwl<-,SYSargs2-method}

\title{Class \code{"SYSargs2"}}
\description{
\code{SYSargs2 class} stores all the information and instructions needed for 
processing a set of input files with a specific command-line or a series of 
command-line within a workflow. The \code{SYSargs2} S4 class object is created 
from the \code{loadWF} and \code{renderWF} function, which populates all the 
command-line for each sample in each step of the particular workflow. Each sample 
level input/outfile operation uses its own \code{SYSargs2} instance. The output 
of \code{SYSargs2} define all the expected output files for each step in the 
workflow, which usually it is the sample input for the next step in an \code{SYSargs2}
instance. By chaining several \code{SYSargs2} steps together one can construct 
complex workflows involving many sample-level input/output file operations with 
any combination of command-line or R-based software. 
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SYSargs2", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{targets}:}{Object of class \code{"list"} storing data from each sample from \code{targets} file }
    \item{\code{targetsheader}:}{Object of class \code{"list"} storing header/comment lines of targets file }
    \item{\code{modules}:}{Object of class \code{"list"} storing software versions from module system }
    \item{\code{wf}:}{Object of class \code{"list"} storing data from Workflow \code{CWL parameters} file }
    \item{\code{clt}:}{Object of class \code{"list"} storing data from each \code{CommandLineTool}
                        substep in the Workflow or the single \code{CommandLineTool} \code{CWL parameters} file }
    \item{\code{yamlinput}:}{Object of class \code{"list"} storing data from \code{input (*.yml)} file }
    \item{\code{cmdlist}:}{Object of class \code{"list"} storing all command-line used to execute external software }
    \item{\code{input}:}{Object of class \code{"list"} storing data from each target defined in \code{inputvars} }
    \item{\code{output}:}{Object of class \code{"list"} paths to final outputs files }
    \item{\code{files}:}{Object of class \code{"list"} paths to \code{input} and \code{CWL parameters} files }
    \item{\code{inputvars}:}{Object of class \code{"list"} storing data from each \code{inputvars} }
    \item{\code{cmdToCwl}:}{Object of class \code{"list"} storing data from each \code{cmdToCwl} }
    \item{\code{status}:}{Object of class \code{"list"} storing data from each \code{status} }
    \item{\code{internal_outfiles}:}{Object of class \code{"list"} storing raw data from each \code{output} }
  }
}
\section{Methods}{
  \describe{
    \item{[}{ Subsetting of class with bracket operator. }
    \item{[[}{ Subsetting of class with bracket operator. }
    \item{[[<-}{ Replacement method for \code{"SYSargs2"} class. }
    \item{$}{ Extracting slots elements by name. }
    \item{length}{ Extracts number of samples. }
    \item{names}{ Extracts slot names. }
    \item{show}{ Summary view of \code{SYSargs2} objects. }

    % Coerce
    \item{coerce}{ \code{signature(from = "list", to = "SYSargs2")}: \code{as(list, "SYSargs2")} }
    \item{coerce}{ \code{signature(from = "SYSargs2", to = "list")}\code{as(SYSargs2, "list")} }
    \item{coerce}{ \code{signature(from = "SYSargs2", to = "DataFrame")}: \code{as(x, "DataFrame")}; for targets slot. }
    \item{sysargs2}{ Coerce back to list \code{as(SYSargs2, "list")} }
    
    % Accessors
    \item{targets}{ Extract data from \code{targets} slot. }
    \item{targetsheader}{ Extracts data from \code{targetsheader} slot. }
    \item{modules}{ Extracts data from \code{modules} slot. }
    \item{wf}{ Extracts data from \code{wf} slot. }
    \item{clt}{ Extracts data from \code{clt} slot. }
    \item{yamlinput}{ Extracts data from \code{yamlinput} slot. }
    \item{cmdlist}{ Extracts data from \code{cmdlist} slot. }
    \item{input}{ Extracts data from \code{input} slot. }
    \item{output}{ Extracts data from \code{cmdlist} slot. }
    \item{files}{ Extracts data from \code{files} slot. }
    \item{inputvars}{ Extracts data from \code{inputvars} slot. }
    \item{cmdToCwl}{ Extracts data from \code{cmdToCwl} slot. }
    \item{status}{ Extracts data from \code{status} slot. }
    
    % Methods
    \item{infile1}{extracting paths to first FASTQ file. }
    \item{infile2}{extracting paths to second FASTQ file if data is PE. }
    \item{baseCommand}{ Extracts baseCommand from command-line used to execute external software. }
    \item{SampleName}{ Extracts all samples names. }

        % Replacement
    \item{yamlinput<-}{ Replacement method for \code{yamlinput} slot input. }
	 }
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
\code{loadWF} and \code{renderWF} and \code{runCommandline} and \code{clusterRun}
}
\examples{
showClass("SYSargs2")

## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targetspath, 
                  wf_file="example/workflow_example.cwl", 
                  input_file="example/example.yml", 
                  dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(Message = "_STRING_", SampleName = "_SAMPLE_"))
WF

## Methods
names(WF)
length(WF)
baseCommand(WF)
SampleName(WF)

## Accessors
targets(WF)
targetsheader(WF)
modules(WF)
yamlinput(WF)
cmdlist(WF)
input(WF)
output(WF)
files(WF)
inputvars(WF)
cmdToCwl(WF)
status(WF)

## The subsetting operator '[' allows to select specific command-line/sample
WF2 <- WF[1:2]

\dontrun{
## Execute SYSargs2 on single machine
WF2 <- runCommandline(WF2)
}
\dontrun{
## Execute SYSargs2 on multiple machines of a compute cluster. The following
## example uses the conf and template files for the Slurm scheduler. Please 
## read the instructions on how to obtain the corresponding files for other schedulers.  
file.copy(system.file("extdata", ".batchtools.conf.R", package="systemPipeR"), ".")
file.copy(system.file("extdata", "batchtools.slurm.tmpl", package="systemPipeR"), ".")
resources <- list(walltime=120, ntasks=1, ncpus=4, memory=1024) 
reg <- clusterRun(WF, FUN = runCommandline, conffile=".batchtools.conf.R", 
                  template="batchtools.slurm.tmpl", Njobs=2, runid="01", resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)

}
}
\keyword{ classes }

\name{symLink2bam}
\alias{symLink2bam}
\title{
Symbolic links for IGV
}
\description{
Function for creating symbolic links to view BAM files in a genome browser such as IGV.
}
\usage{
symLink2bam(sysargs, command="ln -s", htmldir, ext = c(".bam", ".bai"), urlbase, urlfile)
}
\arguments{
  \item{sysargs}{
	Object of class \code{SYSargs} or \code{SYSargs2} or \code{named character vector} 
	with BAM files PATH and the elements names should be the sampleID.
}
  \item{command}{
	Shell command, defaults to "ln -s"
}
  \item{htmldir}{
	Path to HTML directory with http access.
}
  \item{ext}{
	File name extensions to use for BAM and index files.
}
  \item{urlbase}{
	The base URL structure to use in URL file.
}
  \item{urlfile}{
	Name and path of URL file.
}
}
\value{
	symbolic links and url file
}
\author{
Thomas Girke
}
\examples{
## Construct SYSargs2 object from param and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args

\dontrun{
## Run alignments
args <- runCommandline(args, dir = FALSE, make_bam = TRUE)

## Create sym links and URL file for IGV
symLink2bam(sysargs=args, command="ln -s", htmldir=c("~/.html/", "somedir/"), ext=c(".bam", ".bai"), urlbase="http://myserver.edu/~username/", urlfile="IGVurl.txt")
}
}
\keyword{ utilities }

\name{LineWise-class}
\Rdversion{1.1}
\docType{class}
% Class
\alias{LineWise-class}
% Constructor 
\alias{LineWise}
% Subsetting and Quick access
\alias{[,LineWise,ANY,ANY,ANY-method}
\alias{[[,LineWise,ANY,missing-method}
\alias{[[<-,LineWise,ANY,ANY,ANY-method}
\alias{[[<-,LineWise,ANY,ANY-method}
\alias{$,LineWise-method}
\alias{length,LineWise-method}
\alias{names,LineWise-method}
\alias{show,LineWise-method}
% Coercion
\alias{coerce,LineWise,list-method}
\alias{coerce,list,LineWise-method}
\alias{linewise}
\alias{linewise,LineWise-method}
%Accessors
\alias{codeLine,LineWise-method}
\alias{codeChunkStart}
\alias{codeChunkStart,LineWise-method}
\alias{rmdPath}
\alias{rmdPath,LineWise-method}
\alias{stepName,LineWise-method}
\alias{dependency,LineWise-method}
\alias{status,LineWise-method}
\alias{files,LineWise-method}
\alias{runInfo,LineWise-method}
%Replacement
\alias{appendCodeLine,LineWise-method}
%\alias{appendCodeLine<-}
\alias{appendCodeLine<-,LineWise-method}
%\alias{appendCodeLine<-,LineWise,ANY,ANY,ANY-method}
%\alias{replaceCodeLine<-}
\alias{replaceCodeLine,LineWise-method}
\alias{replaceCodeLine<-,LineWise-method}
%\alias{replaceCodeLine<-,LineWise,ANY,ANY,ANY-method}

\title{Class \code{"LineWise"}}
\description{
S4 class container for storing R-based code for a workflow step.
\code{LineWise class} instances are constructed by the \code{LineWise} function, 
based on the R-based code, step name, and dependency tree. 
When the container is built from the R Markdown, using \code{\link{importWF}}
function, two other slots are populated: \code{codeChunkStart} and \code{rmdPath}.
\code{codeChunkStart} will store the first line of each R chunk, and \code{rmdPath}
will store the R Markdown file path. 
}
\usage{
## Constructor

LineWise(code, step_name = "default", codeChunkStart = integer(), 
            rmdPath = character(), dependency="", 
            run_step = "mandatory",
            run_session = "management", 
            run_remote_resources = NULL) 
        
}
\arguments{
  \item{code}{
  R code separated either by a semi-colon (\code{\;}), or by a newline, and 
  enclosed by braces (\code{\{ \}}).
}
  \item{step_name}{
  character. Step name needs to be unique and is required when appending this
  step to the workflow.
}
  \item{codeChunkStart}{
  integer. R Markdown code chunk line start. This element will be populated when
  the object is built by \code{\link{importWF}}.
}
  \item{rmdPath}{
  character. Path of R Markdown file used by \code{\link{importWF}}.
}
  \item{dependency}{
  character. Dependency tree, required when appending this step to 
  the workflow. Character name of a previous step in the workflow. 
  Default is empty string \code{""}.
}
  \item{run_step}{
  character. If the step has "mandatory" or "optional" flag for the execution.
}
  \item{run_session}{
  character. If the step has "management" or "compute" flag for the execution.
}
  \item{run_remote_resources}{
  \code{List} for reserving for each cluster job sufficient computing resources
  including memory (Megabyte), number of nodes, CPU cores, walltime (minutes),
  etc. It is necessary two aditional files: \code{conffile} and \code{template}. 
  \code{conffile} is the path to conf file (default location 
  \code{./.batchtools.conf.R}). This file contains in its simplest form just one 
  command, such as this line for the Slurm scheduler: 
  \code{cluster.functions <- makeClusterFunctionsSlurm(template="batchtools.slurm.tmpl")}. 
  For more detailed information visit this page: https://mllg.github.io/batchtools/index.html
  \code{template} The template files for a specific queueing/scheduling systems 
  can be downloaded from here: 
  https://github.com/mllg/batchtools/tree/master/inst/templates. Slurm, 
  PBS/Torque, and Sun Grid Engine (SGE) templates are provided
  }
}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("LineWise", ...)}.

}
\section{Slots}{
  \describe{
    \item{\code{codeLine}:}{Object of class \code{"expression"} storing R-based 
    code.}
    \item{\code{codeChunkStart}:}{Object of class \code{"interger"} storing start 
                                line from the \code{rmdPath} file, when the 
                                \code{"LineWise"} is built from R Markdown.}
    \item{\code{stepName}:}{Object of class \code{"character"} storing step name.}
    \item{\code{dependency}:}{Object of class \code{"list"} storing dependency 
                             tree.}
    \item{\code{status}:}{Object of class \code{"list"} storing status steps.}
    \item{\code{files}:}{Object of class \code{"list"} storing file for
                          R Markdown file and the file  containing
                        stdout and stderr after running the R-based code.}
    \item{\code{runInfo}:}{Object of class \code{"list"} storing all the
                            \code{runInfo} information of the workflow }
  }
}
\section{Functions and Methods}{
   See 'Usage' for details on invocation.
  
  Constructor:
  \describe{
    \item{LineWise:}{Returns a \code{LineWise} object.}
  }

  Accessors:  
  \describe{
    % Accessors
    \item{codeLine}{ Printing method for the \code{CodeLine} slot.}
    \item{codeChunkStart}{ Extract start line of the R Markdown R chunk.}
    \item{rmdPath}{ Extract Rmarkdown file path.}
    \item{stepName}{ Extract the step name.}
    \item{dependency}{ Extract the dependency tree.}
    \item{status}{ Extract status of the step.}
    \item{files}{ Extract log file path storing stdout and stderr after running step.}
    % Replacement
    \item{appendCodeLine<-}{ Replacement method for append a R code line.}
    \item{replaceCodeLine<-}{ Replacement method for replace a R code line.}
 }
 
   Methods:  
  \describe{
    % General
    \item{[}{ Return a new \code{LineWise} object made of the selected R code lines.}
    \item{[[}{ Extract the slot information from \code{LineWine} object.}
    \item{[[<-}{ Replacement method for \code{LineWine} slots.}
    \item{$}{ Extract slots elements by name. }
    \item{length}{ Extract number of R-based code lines. }
    \item{names}{ Extract slot names. }
    \item{show}{ Summary view of \code{LineWise} elements.}
    % Coerce
    \item{coerce}{ \code{signature(from = "LineWise", to = "list")}\code{as(LineWise, "list")} }
    \item{coerce}{ \code{signature(from = "list", to = "LineWise")}\code{as(list, "LineWise")} }
    \item{linewise}{ Coerce back to list \code{as(LineWise, "list")} }
 }
}
\author{
Daniela Cassol
}
\seealso{
 \code{\linkS4class{SYSargsList}}
}
\examples{
showClass("LineWise")
lw <- LineWise(code = {
              log_out <- log(10)
              },
              step_name = "R_log")

codeLine(lw)

## ImportWF option
file_path <- system.file("extdata/spr_simple_lw.Rmd", package="systemPipeR")
sal <- SPRproject(overwrite = TRUE)
# file_path <- "../inst/extdata/spr_simple_lw.Rmd"
sal <- importWF(sal, file_path)
sal <- runWF(sal)
lw2 <- sal$stepsWF[[2]]
lw2
names(lw2)
length(lw2)

## Accessors
codeLine(lw2)
codeChunkStart(lw2)
rmdPath(lw2)
stepName(lw2)
dependency(lw2)
status(lw2)
files(lw2)

## Replacement
appendCodeLine(lw2, after = 0) <- "log <- log(10)"
codeLine(lw2)
replaceCodeLine(lw2, 1) <- "plot(iris)"
codeLine(lw2)

## Coerce
lw2 <- linewise(lw2) ## OR lw2 <- as(lw2, "list") 
lw2 <- as(lw2, "LineWise")
}
\keyword{classes}

\name{tryPath}
\alias{tryPath}
\title{
Validation of the files or directories
}
\description{
Function to check if the full path (file or directory) exists. 
}
\usage{
tryPath(path)
}
\arguments{
  \item{path}{
a character vector of full path name.
}
}
\details{
This function produces a character vector of the file or directory name defined on the \code{path} argument.
}
\value{
A character vector containing the name of the file or directory. If the path does not exist, it will return an error message. 
}
\author{
Daniela Cassol
}
\examples{
file <- system.file("extdata/", "targets.txt", package="systemPipeR")
tryPath(path=file)
}
\keyword{ utilities }

\name{write_SYSargsList}
\alias{write_SYSargsList}
\title{
Writeout SYSargsList object
}
\description{
Function to writeout \code{SYSargsList} workflow control environment (S4 object) 
object.

}
\usage{
write_SYSargsList(sysargs, sys.file=".SPRproject/SYSargsList.yml", silent=TRUE)
}
\arguments{
  \item{sysargs}{
  object of class \code{SYSargsList}.
}
  \item{sys.file}{
  name and path of the SYSargsList file which will store all the project configuration 
  information. Default is \code{.SPRproject/SYSargsList.yml}.
}
  \item{silent}{
if set to TRUE, all messages returned by the function will be suppressed.
}
}
\value{
\code{write_SYSargsList} will return a \code{sys.file} path.
}
\author{
Daniela Cassol 
}
\seealso{
See also as \code{SYSargsList-class}.
}
\examples{
## Construct SYSargsList object from Rmd file
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", package="systemPipeR"),
                               inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")

sal <- write_SYSargsList(sal)
sal
}
\keyword{ utilities }

\name{overLapper}
\alias{overLapper}
\alias{setlist}
\alias{setlist-methods}
\alias{intersectmatrix}
\alias{intersectmatrix-methods}
\alias{complexitylevels}
\alias{complexitylevels-methods}
\alias{vennlist}
\alias{vennlist-methods}
\alias{intersectlist}
\alias{intersectlist-methods}
\title{
Set Intersect and Venn Diagram Functions
}
\description{
Function for computing Venn intersects or standard intersects among large
numbers of label sets provided as \code{list} of \code{vectors}. The resulting
intersect objects can be used for plotting 2-5 way Venn diagrams or intersect
bar plots using the functions \code{vennPlot} or \code{olBarplot}, respectively.
The \code{overLapper} function scales to 2-20 or more label vectors for Venn
intersect calculations and to much larger sample numbers for standard
intersects. The different intersect types are explained below under the
definition of the \code{type} argument. The upper Venn limit around 20 label
sets is unavoidable because the complexity of Venn intersects increases
exponentially with the label set number \code{n} according to this
relationship: \code{2^n - 1}. The current implementation of
the plotting function \code{vennPlot} supports Venn diagrams for 2-5 label
sets. To visually analyze larger numbers of label sets, a variety of intersect
methods are introduced in the \code{olBarplot} help file. These methods are
much more scalable than Venn diagrams, but lack their restrictive intersect
logic. 
}

\usage{
overLapper(setlist, complexity = "default", sep = "_", cleanup = FALSE, keepdups = FALSE, type)
}

\arguments{
  \item{setlist}{
Object of class \code{list} where each list component stores a label set as
\code{vector} and the name of each label set is stored in the name slot of 
each list component. The names are used for naming the label sets in all 
downstream analysis steps and plots.
}
  \item{complexity}{
Complexity level of intersects specified as integer vector. For Venn intersects 
it needs to be assigned \code{1:length(setlist)} (default). If \code{complexity=2}
the function returns all pairwise intersects.
}
  \item{sep}{
Character used to separate set labels. 
}
  \item{cleanup}{
If set to \code{TRUE} then all characters of the label sets are set to upper case,
and leading and trailing spaces are removed. The default \code{cleanup=FALSE} omits 
this step.
}
  \item{keepdups}{
By default all duplicates are removed from the label sets. The setting
\code{keepdups=TRUE} will retain duplicates by appending a counter to each entry.
}
  \item{type}{
With the default setting \code{type="vennsets"} the overLapper function
computes the typical Venn intersects for the label sets provided under
\code{setlist}. With the setting \code{type="intersects"} the function will
compute pairwise intersects (not compatible with Venn diagrams). Venn
intersects follow the typical 'only in' intersect logic of Venn comparisons, such
as: labels present only in set A, labels present only in the intersect of A
& B, etc. Due to this restrictive intersect logic, the combined Venn sets
contain no duplicates. In contrast to this, regular intersects follow this
logic: labels present in the intersect of A & B, labels present in the
intersect of A & B & C, etc. This approach results usually in many duplications
of labels among the intersect sets.  
}
}
\details{
Additional Venn diagram resources are provided by the packages \code{limma}, 
\code{gplots}, \code{vennerable}, \code{eVenn} and \code{VennDiagram}, or
online resources such as shapes, Venn Diagram Generator and Venny.
}
\value{
\code{overLapper} returns standard intersect and Venn intersect results as
\code{INTERSECTset} or \code{VENNset} objects, respectively. These S4 objects
contain the following components:
	\item{setlist}{Original label sets accessible with \code{setlist()}.}
	\item{intersectmatrix}{Present-absent matrix accessible with \code{intersectmatrix()}, 
where each overlap set in the \code{vennlist} data component is labeled according to 
the label set names provided under \code{setlist}. For instance, the composite name 
'ABC' indicates that the entries are restricted to A, B and C. The seperator used 
for naming the intersect sets can be specified under the \code{sep} argument.} 
	\item{complexitylevels}{Complexity levels accessible with \code{complexitylevels()}.}
	\item{vennlist}{Venn intersects for \code{VENNset} objects accessible with \code{vennlist()}.}
	\item{intersectlist}{Standard intersects for \code{INTERSECTset} objects accessible with \code{intersectlist()}.}
}
\references{
See examples in 'The Electronic Journal of Combinatorics': 
http://www.combinatorics.org/files/Surveys/ds5/VennSymmExamples.html
}
\author{
Thomas Girke
}
\note{
The functions provided here are an extension of the Venn diagram resources on this 
site: http://manuals.bioinformatics.ucr.edu/home/R_BioCondManual#TOC-Venn-Diagrams
}
\seealso{
\code{vennPlot}, \code{olBarplot}
}
\examples{
## Sample data
setlist <- list(A=sample(letters, 18), B=sample(letters, 16),
                C=sample(letters, 20), D=sample(letters, 22),
                E=sample(letters, 18), F=sample(letters, 22))

## 2-way Venn diagram
vennset <- overLapper(setlist[1:2], type="vennsets")
vennPlot(vennset)

## 3-way Venn diagram
vennset <- overLapper(setlist[1:3], type="vennsets")
vennPlot(vennset)

## 4-way Venn diagram
vennset <- overLapper(setlist[1:4], type="vennsets")
vennPlot(list(vennset, vennset))

## Pseudo 4-way Venn diagram with circles
vennPlot(vennset, type="circle")

## 5-way Venn diagram
vennset <- overLapper(setlist[1:5], type="vennsets")
vennPlot(vennset)

## Alternative Venn count input to vennPlot (not recommended!)
counts <- sapply(vennlist(vennset), length)
vennPlot(counts)

## 6-way Venn comparison as bar plot
vennset <- overLapper(setlist[1:6], type="vennsets")
olBarplot(vennset, mincount=1)

## Bar plot of standard intersect counts
interset <- overLapper(setlist, type="intersects")
olBarplot(interset, mincount=1)

## Accessor methods for VENNset/INTERSECTset objects
names(vennset)
names(interset)
setlist(vennset)
intersectmatrix(vennset)
complexitylevels(vennset)
vennlist(vennset)
intersectlist(interset)

## Coerce VENNset/INTERSECTset object to list
as.list(vennset)
as.list(interset)

## Pairwise intersect matrix and heatmap
olMA <- sapply(names(setlist), 
		function(x) sapply(names(setlist), 
		function(y) sum(setlist[[x]] \%in\% setlist[[y]])))
olMA
heatmap(olMA, Rowv=NA, Colv=NA)

## Presence-absence matrices for large numbers of sample sets
interset <- overLapper(setlist=setlist, type="intersects", complexity=2)
(paMA <- intersectmatrix(interset))
heatmap(paMA, Rowv=NA, Colv=NA, col=c("white", "gray")) 
}
\keyword{ utilities }

\name{listCmdTools}
\alias{listCmdTools}
\alias{listCmdModules}
\title{
List/check the existence of command-line tools of a workflow
}
\description{
These functions list/check whether required command-line tools/modules are installed in the PATH and are callable.
}

\usage{
listCmdTools(sal, check_path = FALSE, check_module = FALSE)

listCmdModules(sal, check_module = FALSE)
}

\arguments{
  \item{sal}{
	SPR workflow object in \code{SYSargsList} class.
  }
  \item{check_path}{
    logical, whether to check if the required tools are in PATH.
  }
  \item{check_module}{
    logical, whether to check if the required modules are installed.
  }
}

\details{
Both functions by default will not check the existence of tools or modules. The default is to list the requirement.
}

\value{
Both functions print out the list/check results as dataframe. The first column is workflow step names that
require certain tools/modules. The second column is the tool/module names. The third column is logical, \code{TRUE} for
the existence of the tool in PATH/modular system, if \code{check_path = TRUE} or \code{check_module = TRUE}. Otherwise,
the third column will be \code{NA}.

In the case of both \code{check_path = TRUE, check_module = TRUE} for \code{listCmdTools}, the returned dataframe is
still results for tool PATH checking but not module checking results. If one wish to obtain the module checking results,
please use \code{listCmdModules}.

When the current workflow has no command-line (SYSargs) step, or there is no module required, or there is no modular
system installed, the return will be \code{NULL}.

These two functions are automatically performed when \code{importWF} is called.
}

\seealso{
\code{importWF}
\code{module}
}

\author{
Le Zhang
}

\examples{
# See examples of `importWF`
}
\keyword{ utilities }

\name{writeTargetsRef}
\alias{writeTargetsRef}
\title{
Generate targets file with reference
}
\description{
Generates targets file with sample-wise reference as required for some NGS
applications, such as ChIP-Seq containing input samples. The reference sample
information needs to be provided in the input file in a column called
\code{SampleReference} where the values reference the labels used in the
\code{SampleName} column. Sample rows without reference assignments will be
removed automatically.
}
\usage{
writeTargetsRef(infile, outfile, silent = FALSE, overwrite = FALSE, ...)
}
\arguments{
  \item{infile}{
Path to input targets file.
}
  \item{outfile}{
Path to output targets file.
}
  \item{silent}{
If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{overwrite}{
If set to \code{TRUE}, existing files of same name will be overwritten.
}
  \item{\dots}{
To pass on additional arguments.
}
}
\value{
Generates modified targets file with the paths to the reference samples in the second column named \code{FileName2}. 
Note, sample rows not assigned reference samples are removed automatically.
}
\author{
Thomas Girke
}
\seealso{
\code{writeTargetsout}, \code{mergeBamByFactor}
}
\examples{
## Path to input targets file
targets <- system.file("extdata", "targets_chip.txt", package="systemPipeR")

\dontrun{
## Write modified targets file with reference (e.g. input) sample
writeTargetsRef(infile=targets, outfile="~/targets_refsample.txt", silent=FALSE, overwrite=FALSE)
}
}
\keyword{ utilities }

\name{check.output}
\alias{check.output}
\alias{check.outfiles}
\title{
Checking if the outfiles files exist
}
\description{
This function returns a \code{data.frame} indicating the number of existing files
and how many files are missing.
}
\usage{
check.output(sysargs, type="data.frame")
check.outfiles(sysargs, type="data.frame")
}

\arguments{
  \item{sysargs}{
    object of class \code{SYSargs2} or \code{SYSargsList}.
}
  \item{type}{
    return object option. It can be \code{data.frame} or \code{list}.
}
}
\value{
\code{data.frame} or \code{list} containing all the \code{outfiles} file information. 
}
\seealso{
- \code{\link{SYSargs2-class}}

- \code{\link{SYSargsList-class}}
}
\author{
Daniela Cassol and Thomas Girke
}
\examples{
## Construct SYSargs2 object 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF
## Check output
check.output(WF)
check.output(WF, "list")

## Construct SYSargsList object 
sal <- SPRproject(overwrite=TRUE) 
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "echo", 
                      targets=targetspath, dir=TRUE,
                      wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                      dir_path = system.file("extdata/cwl", package="systemPipeR"),
                      inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
## Check outfiles
check.outfiles(sal)
}
\keyword{ utilities }

\name{predORF}
\alias{predORF}
\title{
Predict ORFs 
}
\description{
Predicts open reading frames (ORFs) and coding sequences (CDSs) in DNA sequences provided as \code{DNAString} or \code{DNAStringSet} objects. 
}
\usage{
predORF(x, n = 1, type = "grl", mode = "orf", strand = "sense", longest_disjoint=FALSE, startcodon = "ATG", stopcodon = c("TAA", "TAG", "TGA"))
}
\arguments{
  \item{x}{
DNA query sequence(s) provided as \code{DNAString} or \code{DNAStringSet} object.
}
  \item{n}{
Defines the maximum number of ORFs to return for each input sequence. The ORFs identified are sorted decreasingly 
by their length. For instance, \code{n=1} (default) returns the longest ORF, \code{n=2} the two longest ones, and so on. 
}
  \item{type}{
One of three options provided as character values: \code{'df'} returns results as \code{data.frame}, while \code{'gr'} and \code{'grl'} (default) return them as \code{GRanges} or \code{GRangesList} objects, respectively.
}
  \item{mode}{
The setting \code{mode='ORF'} returns a continuous reading frame that begins with a start codon and ends with a stop codon. The setting \code{mode='CDS'} 
return continuous reading frames that do not need to begin or end with start or stop codons, respectively. 
}
  \item{strand}{
One of three options passed on as character vector of length one: \code{'sense'} performs the predictions only for the sense strand of the query sequence(s), 
\code{'antisense'} does it only for the antisense strand and \code{'both'} does it for both strands.
}
  \item{longest_disjoint}{
    If set to \code{TRUE} and \code{n='all'}, the results will be subsetted to non-overlapping ORF set containing longest ORF. 
}
  \item{startcodon}{
Defines the start codon(s) for ORF predictions. The default is set to the standard start codon 'ATG'. Any custom set of triplet DNA sequences can be assigned here.
}
  \item{stopcodon}{
Defines the stop codon(s) for ORF predictions. The default is set to the three standard stop codons 'TAA', 'TAG' and 'TGA'. Any custom set of triplet DNA sequences can be assigned here.
}
}
\value{
Returns ORF/CDS ranges identified in query sequences as \code{GRanges} or
\code{data.frame} object. The \code{type} argument defines which one of them
will be returned. The objects contain the following columns:
    \itemize{
        \item{\code{seqnames}: names of query sequences}
        \item{\code{subject_id}: identified ORF/CDS ranges numbered by query} 
        \item{\code{start/end}: start and end positions of ORF/CDS ranges}
        \item{\code{strand}: strand of query sequence used for prediction}
        \item{\code{width}: length of subject range in bases}
        \item{\code{inframe2end}: frame of identified ORF/CDS relative to 3'
end of query sequence. This can be important if the query sequence was
extracted directly upstream of an ORF (e.g. 5' UTR upstream of main ORF). 
The value 1 stands for in-frame with downstream ORF, while 2 or 3 indicates 
a shift of one or two bases, respectively. } }
}
\author{
Thomas Girke
}

\seealso{
\code{scaleRanges}
}
\examples{
## Load DNA sample data set from Biostrings package
file <- system.file("extdata", "someORF.fa", package="Biostrings")
dna <- readDNAStringSet(file)

## Predict longest ORF for sense strand in each query sequence
(orf <- predORF(dna[1:4], n=1, type="gr", mode="orf", strand="sense"))

\dontrun{
## Usage for more complex example
library(txdbmaker); library(systemPipeRdata)
gff <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=gff, format="gff3", organism="Arabidopsis")
futr <- fiveUTRsByTranscript(txdb, use.names=TRUE)
genome <- system.file("extdata/annotation", "tair10.fasta", package="systemPipeRdata")
dna <- extractTranscriptSeqs(FaFile(genome), futr)
uorf <- predORF(dna, n="all", mode="orf", longest_disjoint=TRUE, strand="sense")
grl_scaled <- scaleRanges(subject=futr, query=uorf, type="uORF", verbose=TRUE)
export.gff3(unlist(grl_scaled), "uorf.gff")
}
}
\keyword{ utilities }

\name{EnvModules-class}
\docType{class}
\alias{EnvModules-class}
\alias{[[,EnvModules,ANY,missing-method}
\alias{[[<-,EnvModules-method}
\alias{[,EnvModules,ANY,ANY,ANY-method}
\alias{[[,EnvModules,ANY,ANY-method}
\alias{[[<-,EnvModules,ANY,ANY,ANY-method}
\alias{[[<-,EnvModules,ANY,ANY-method}
\alias{$,EnvModules-method}
\alias{available_modules,EnvModules-method}
\alias{coerce,EnvModules,list-method}
\alias{coerce,list,EnvModules-method}
\alias{default_modules,EnvModules-method}
\alias{EnvModules,EnvModules-method}
\alias{loaded_modules,EnvModules-method}
\alias{modulecmd,EnvModules-method}
\alias{names,EnvModules-method}
\alias{show,EnvModules-method}

\title{Class \code{"EnvModules"}}
\description{
The function \code{module} enables use of the Environment Modules system
(http://modules.sourceforge.net/) from within the R environment.  By default
the user's login shell environment (ie. \code{bash -l}) will be used to
initialize the current session.  The module function can also; load or unload
specific software, list all the loaded software within the current session, and
list all the applications available for loading from the module system.
Lastly, the module function can remove all loaded software from the current
session.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("EnvModules", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{available_modules}:}{Object of class \code{"list"} ~~ }
    \item{\code{loaded_modules}:}{Object of class \code{"list"} ~~ }
    \item{\code{default_modules}:}{Object of class \code{"list"} ~~ }
    \item{\code{modulecmd}:}{Object of class \code{"character"} ~~ }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "EnvModules")}: ... }
    \item{[[}{\code{signature(x = "EnvModules", i = "ANY", j = "missing")}: ... }
    \item{[[<-}{\code{signature(x = "EnvModules")}: ... }
    \item{$}{\code{signature(x = "EnvModules")}: ... }
    \item{available_modules}{\code{signature(x = "EnvModules")}: ... }
    \item{coerce}{\code{signature(from = "EnvModules", to = "list")}: ... }
    \item{coerce}{\code{signature(from = "list", to = "EnvModules")}: ... }
    \item{default_modules}{\code{signature(x = "EnvModules")}: ... }
    \item{EnvModules}{\code{signature(x = "EnvModules")}: ... }
    \item{loaded_modules}{\code{signature(x = "EnvModules")}: ... }
    \item{modulecmd}{\code{signature(x = "EnvModules")}: ... }
    \item{names}{\code{signature(x = "EnvModules")}: ... }
    \item{show}{\code{signature(object = "EnvModules")}: ... }
	 }
}
\author{
Jordan Hayes and Daniela Cassol
}

\examples{
showClass("EnvModules")
}
\keyword{classes}

\name{output_update}
\alias{output_update}

\title{
Updates the output files paths in the \code{SYSargs2} object
}
\description{
After executing all the command-lines by the \code{runCommadline} function, the output files can be created in specific directories rather then \code{results} in a particular directory. Also, the \code{runCommadline} function allows converting the SAM file outputs to sorted and indexed BAM files. Thus, the \code{output_update} function allows updating the location of these files in the output of the \code{SYSargs2}  object.
}
\usage{
output_update(args, dir = FALSE, dir.name = NULL, replace = FALSE, extension = NULL, make_bam=FALSE, del_sam=TRUE)
}
\arguments{
  \item{args}{
	object of class \code{SYSargs2}.
}
  \item{dir}{
  assign \code{TRUE} to update the location of the output files in the \code{args} object accordingly with the workflow name directory. Default is \code{dir=FALSE}.
}
  \item{dir.name}{
  if the results directory name is not specified in the \code{input} file, it is possible to specify here the name. This argument is required if the path name return \code{NULL} from the \code{input} file. Default is \code{dir.name=NULL}.
}
  \item{replace}{
  replace the extension for selected output files in the \code{args} object. Default is \code{replace=FALSE}.
}
  \item{extension}{
  object of class \code{"character"} storing the current extension of the files and the respective replacement. For example, \code{runCommandline} function by default autodetects SAM file outputs in the \code{args} object and create the BAM files. In order to update the output of \code{args} object, the extension argument should be set: extension = c(\code{".sam"}, \code{".bam"}).
}
  \item{make_bam}{
	Auto detects SAM file outputs and update them on the \code{SYSargs2} object for sorted and indexed BAM files. Default is \code{make_bam=FALSE}. This argument should be used in integration with \code{runCommandline} function. 
}
  \item{del_sam}{
	This option allows deleting the SAM files created when the \code{make_BAM} converts the SAM files to sorted and indexed BAM files. Default is \code{del_sam=TRUE}.
}
}
\value{
\code{SYSargs2} object with output location files updated.
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
To check directory name in the \code{input} file: \code{yamlinput(WF)$results_path$path}.
}
\examples{ 
## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF
output(WF)

\dontrun{
runCommandline(args=WF, make_bam=TRUE)
## Output paths update
WF <- output_update(WF, dir=FALSE, replace=TRUE, extension=c(".sam", ".bam"))

runCommandline(args=WF, make_bam=TRUE, dir=TRUE)
## Output paths update
WF <- output_update(WF, dir=TRUE, replace=TRUE, extension=c(".sam", ".bam"))
}
}
\keyword{ utilities }

\name{sysargs}
\alias{targetsin}
\alias{targetsin-methods}
\alias{targetsout}
\alias{targetsout-methods}
%\alias{targetsheader}
\alias{targetsheader-methods}
\alias{modules-methods}
\alias{software}
\alias{software-methods}
\alias{cores}
\alias{cores-methods}
\alias{other}
\alias{other-methods}
\alias{reference}
\alias{reference-methods}
\alias{results}
\alias{results-methods}
\alias{infile1}
\alias{infile1-methods}
\alias{infile2}
\alias{infile2-methods}
\alias{outfile1}
\alias{outfile1-methods}
%\alias{SampleName}
\alias{SampleName-methods}
\alias{sysargs}
\alias{sysargs-methods}
\alias{outpaths}
\alias{outpaths-methods}
\docType{data}
\title{ SYSargs accessor methods}

\description{
	Methods to access information from \code{SYSargs} object.
}
\usage{
	sysargs(x)
}
\arguments{
  \item{x}{
	object of class \code{SYSargs}
}
}
\value{
	various outputs
}
\author{
Thomas Girke
}
\examples{
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "hisat2.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); modules(args); cores(args); outpaths(args); sysargs(args)
}
\keyword{ utilities }

\name{renderReport}
\alias{renderReport}
\title{
Render RMarkdown Report
}
\description{
Render the technical report file to the specified output format using pandoc.
}
\usage{
renderReport(sysargs, fileName ="SPR_Report",
              rmd_title = "SPR workflow Template - Report",
              rmd_author = "Author",
              rmd_date= "Last update: `r format(Sys.time(), '\%d \%B, \%Y')`",
              type = c("html_document"),
              desc = "This is a workflow template.",
              quiet = FALSE, open_file = TRUE)
}
\arguments{
  \item{sysargs}{
  object of class \code{SYSargsList}.
}
  \item{fileName}{
  character string naming a file output. Default is \code{"spr_report.Rmd"}.
}
  \item{rmd_title}{
  string, title of the Rmd.
}
  \item{rmd_author}{
  string, author(s) of the Rmd, put all authors in a single character string.
}
  \item{rmd_date}{
  string, date header of Rmd.
}
  \item{type}{
  The R Markdown output format to convert to. The option 
  can be the name of a format (e.g. \code{"pdf_document"} or \code{"html_document"}).
}
  \item{desc}{
  string, or character vector of strings, some description text in format 
  Rmarkdown that will be added to the document before the workflow steps start. 
  It can be a single line or multiple lines by providing a character vector,
  each item is one line.
}
  \item{quiet}{
  If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{open_file}{
  Default is \code{TRUE}. 
}
}
\value{
It will return an \code{SYSargsList} updated, with the file path location.
}
\author{
Daniela Cassol 
}
\seealso{
See also as \code{SYSargsList-class}.
}
\examples{
sal <- SPRproject(overwrite = TRUE)
file_path <- system.file("extdata", "spr_simple_wf.Rmd", package = "systemPipeR")
sal <- importWF(sal, file_path = file_path, verbose = FALSE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package = "systemPipeR")
appendStep(sal) <- SYSargsList(step_name = "echo", 
                              targets = targetspath, dir = TRUE,
                              wf_file = "example/workflow_example.cwl", input_file = "example/example.yml", 
                              dir_path = system.file("extdata/cwl", package = "systemPipeR"),
                              inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
sal <- renderReport(sal, open_file = FALSE)
}
\keyword{ utilities }

\name{systemArgs}
\alias{systemArgs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Constructs SYSargs object from param and targets files
}
\description{
Constructs \code{SYSargs} S4 class objects from two simple tablular files: a
\code{targets} file and a \code{param} file. The latter is optional for
workflow steps lacking command-line software. Typically, a \code{SYSargs}
instance stores all sample-level inputs as well as the paths to the
corresponding outputs generated by command-line- or R-based software generating
sample-level output files. Each sample level input/outfile operation uses its
own \code{SYSargs} instance. The outpaths of \code{SYSargs} usually define the
sample inputs for the next \code{SYSargs} instance. This connectivity is
established by writing the outpaths with the \code{writeTargetsout} function to a
new targets file that serves as input to the next \code{systemArgs} call. By
chaining several \code{SYSargs} steps together one can construct complex
workflows involving many sample-level input/output file operations with any
combinaton of command-line or R-based software.
}
\usage{
systemArgs(sysma, mytargets, type = "SYSargs")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sysma}{ path to 'param' file; file structure follows a simple name/value syntax that
	converted into JSON format; for details about the file structure see sample files provided
	by package. Assign \code{NULL} to run the pipeline without 'param' file. This 
        can be useful for running partial workflows, e.g. with pregenerated BAM files.
}
  \item{mytargets}{ path to targets file
}
  \item{type}{ \code{type="SYSargs"} returns \code{SYSargs}, \code{type="json"} returns param file 
		content in JSON format (requires \code{rjson} library)
}
}
\value{
\code{SYSargs} object or \code{character} string in JSON format
}
\author{
Thomas Girke
}
\seealso{
\code{showClass("SYSargs")}
}
\examples{
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "tophat.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); modules(args); cores(args); outpaths(args); sysargs(args)

\dontrun{
## Execute SYSargs on single machine
runCommandline(args=args)

## Execute SYSargs on multiple machines of a compute cluster
resources <- list(walltime=120, ntasks=1, ncpus=cores(args), memory=1024) 
reg <- clusterRun(args, conffile=".batchtools.conf.R", template="batchtools.slurm.tmpl", Njobs=18, runid="01", resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)
file.exists(outpaths(args))
sapply(1:length(args), function(x) loadResult(reg, x)) # Works once all jobs have completed successfully.

## Alignment stats
read_statsDF <- alignStats(args) 
write.table(read_statsDF, "results/alignStats.xls", row.names=FALSE, quote=FALSE, sep="\t")

## Write outpaths to new targets file for next SYSargs step
writeTargetsout(x=args, file="default")
}
}
\keyword{utilities}

\name{moduleload}
\alias{module}
\alias{moduleload}
\alias{modulelist}
\alias{moduleAvail}
\alias{moduleClear}
\alias{moduleInit}
\alias{moduleUnload}
\title{
Interface to allow full use of the Environment Modules system for Unix
}
\description{
The function \code{module} enables use of the Environment Modules system
(http://modules.sourceforge.net/) from within the R environment. 
The user's login shell environment (i.e. \code{bash -l}) will be used to 
initialize the current session. The module function can also; load or unload 
specific software, list all the loaded software within the current session, 
and list all the applications available for loading from the module system.
Lastly, the module function can remove all loaded software from the current
session.
}

\usage{
module(action_type, module_name = NULL)
moduleload(module_name)
moduleUnload(module_name)
modulelist()
moduleAvail()
moduleClear()
moduleInit()
}

\arguments{
  \item{action_type}{
	Name of the action to be executed as character vector. The following switches are accepted: \code{avail}, \code{list}, \code{init}, \code{load}, \code{unload}, and \code{clear}.
  }
  \item{module_name}{
	Name of software to load as character vector. Examples: \code{"hisat2"}, 
	\code{"hisat2/2.1.0"}, \code{c("hisat2", "samtools")}.
  }
}

\details{
Partial failure would also result `FALSE`, e.g. "load" two modules, one 
successful and the other failed, then the return is `FALSE`.
For "unload" action will always return `TRUE` even if the module is not 
loaded at all or not found.
}

\author{
Tyler Backman, Jordan Hayes and Thomas Girke
}

\examples{
\dontrun{
## List all available software from the module system
avail <- moduleAvail()

## List loaded software in the current session
modulelist()

## Example for loading a software into the shell environment
moduleload("hisat2") 
moduleload("hisat2/2.2.1")

## Example for removing software from the shell environment
moduleUnload("hisat2")

## Clear all of the software from the shell's initialization files
moduleClear()

## List and load all the software loaded in users default login shell into the 
current session (default)
moduleInit()
}
}
\keyword{ utilities }

\name{run_DESeq2}
\alias{run_DESeq2}
\title{
Runs DESeq2 
}
\description{
Convenience wrapper function to identify differentially expressed genes
(DEGs) in batch mode with \code{DESeq2} for any number of pairwise sample
comparisons specified under the \code{cmp} argument.  Users are strongly
encouraged to consult the \code{DESeq2} vignette for more detailed information
on this topic and how to properly run \code{DESeq2} on data sets with more
complex experimental designs.
}
\usage{
run_DESeq2(countDF, targets, cmp, independent = FALSE, lfcShrink=FALSE, type="normal")
}
\arguments{
  \item{countDF}{
    \code{date.frame} containing raw read counts
}
  \item{targets}{
    targets \code{data.frame}
}
  \item{cmp}{
    \code{character matrix} where comparisons are defined in two columns. This matrix should be generated with the \code{readComp()} function from the targets file. Values used for comparisons need to match those in the \code{Factor} column of the targets file.
}
  \item{independent}{
    If \code{independent=TRUE} then the \code{countDF} will be subsetted for each comparison. This behavior can be useful when working with samples from unrelated studies. For samples from the same or comparable studies, the setting \code{independent=FALSE} is usually preferred.
}
  \item{lfcShrink}{
  logiacal. If \code{TRUE} adds shrunken log2 fold changes (LFC) to the object.
}
  \item{type}{
   please check \code{\link[DESeq2:lfcShrink]{DESeq2::lfcShrink()}} documentation. Available \code{character} alternatives: "apeglm"; "ashr"; "normal".
}
}
\value{
\code{data.frame} containing \code{DESeq2} results from all comparisons. Comparison labels are appended to column titles for tracking.
}
\references{
Please properly cite the \code{DESeq2} papers when using this function:
http://www.bioconductor.org/packages/devel/bioc/html/DESeq2.html
}
\author{
Thomas Girke
}
\seealso{
\code{run_edgeR}, \code{readComp} and \code{DESeq2} vignette
}
\examples{
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
targets <- read.delim(targetspath, comment.char = "#")
cmp <- readComp(file=targetspath, format="matrix", delim="-")
countfile <- system.file("extdata", "countDFeByg.xls", package="systemPipeR")
countDF <- read.delim(countfile, row.names=1)
degseqDF <- run_DESeq2(countDF=countDF, targets=targets, cmp=cmp[[1]], independent=FALSE)
pval <- degseqDF[, grep("_FDR$", colnames(degseqDF)), drop=FALSE]
fold <- degseqDF[, grep("_logFC$", colnames(degseqDF)), drop=FALSE]
DEG_list <- filterDEGs(degDF=degseqDF, filter=c(Fold=2, FDR=10))
names(DEG_list)
DEG_list$Summary
}
\keyword{ utilities }

\name{olRanges}
\alias{olRanges}
\title{
Identify Range Overlaps for IRanges and GRanges Object
}
\description{
Function for identifying consensus peak among two peaks sets sharing a minimum relative overlap.
}
\usage{
olRanges(query, subject, output = "gr")
}
\arguments{
  \item{query}{
  Object of class \code{GRanges}, which is a vector of genomic locations and associated annotations.
}
  \item{subject}{
  Object of class \code{GRanges}.

}
  \item{output}{
  By default \code{"gr"} returns any overlap with OL length information in an object of class \code{GRanges}. Also, can returns an object of class \code{data.frame} with \code{"df"}.
}
}
\author{
Thomas Girke
}
\examples{
## Sample Data Sets
grq <- GRanges(seqnames = Rle(c("chr1", "chr2", "chr1", "chr3"), c(1, 3, 2, 4)), ranges = IRanges::IRanges(seq(1, 100, by=10), end = seq(30, 120, by=10)), strand = Rle(strand(c("-", "+", "-")), c(1, 7, 2)))
grs <- shift(grq[c(2,5,6)], 5)
## Run olRanges function
olRanges(query=grq, subject=grs, output="df") 
olRanges(query=grq, subject=grs, output="gr") 
}
\keyword{ utilities }

\name{trimbatch}
\alias{trimbatch}
\title{
Genome read coverage by transcript models
}
\description{
## Trims adaptors hierarchically from longest to shortest match from right end of read. 
## If 'internalmatch=TRUE' then internal matches will trigger the same behavior. The 
## argument minpatternlength defines shortest adaptor match to consider for reads 
## containing only partial adaptors at the right end.

}
\usage{
trimbatch(fq, pattern, internalmatch=FALSE, minpatternlength=8, 
                            Nnumber=1, polyhomo=100, minreadlength=18, 
                            maxreadlength)
}
\arguments{
  \item{fq}{
    \code{character} path to fastq file that contains the target sequences.
}
  \item{pattern}{
    \code{character} pattern used to trim the sequence.
}
  \item{internalmatch}{
    The default is \code{FALSE}. Trims adaptors hierarchically from longest to 
    shortest match from right end of read. If 'internalmatch=TRUE' then internal 
    matches will trigger the same behavior.
}
  \item{minpatternlength}{
    It defines shortest adaptor match to consider for reads containing only 
    partial adaptors at the right end.
}
  \item{Nnumber}{
    A numeric value representing a minimum criterion for the filter. It selects
    elements with fewer than \code{Nnumber} 'N' symbols in each element.
}
  \item{polyhomo}{
    A numeric value representing a maximum criterion for the filter. It selects 
    elements with fewer than threshold copies of any nucleotide.
}
  \item{minreadlength}{
\code{numeric} value representing minimum read length.
}
  \item{maxreadlength}{
  \code{numeric} value representing maximun read length.
}
}
\author{
Thomas Girke
}
\examples{
## Preprocessing of paired-end reads
dir_path <- system.file("extdata/cwl/preprocessReads/trim-pe", package="systemPipeR")
targetspath <- system.file("extdata", "targetsPE.txt", package="systemPipeR")
trim <- loadWorkflow(targets=targetspath, wf_file="trim-pe.cwl", input_file="trim-pe.yml", dir_path=dir_path)
trim <- renderWF(trim, inputvars=c(FileName1="_FASTQ_PATH1_", FileName2="_FASTQ_PATH2_", SampleName="_SampleName_"))
trim
\dontrun{
iterTrim <- "trimbatch(fq, pattern='ACACGTCT', internalmatch=FALSE, minpatternlength=6, Nnumber=1, polyhomo=50, minreadlength=16, maxreadlength=101)" 
preprocessReads(args=trim[1], Fct=iterTrim, batchsize=100000, overwrite=TRUE, compress=TRUE)
}
}
\keyword{ utilities }

\name{runWF}
\alias{runWF}
\title{
Execute SYSargsList
}
\description{
Function to execute all the code list specified in SYSargsList object.
}
\usage{
runWF(sysargs, steps = NULL, targets = NULL,
                  force = FALSE, saveEnv = TRUE,
                  run_step = "ALL", ignore.dep = FALSE,
                  warning.stop = FALSE, error.stop = TRUE, silent = FALSE, ...)
}
\arguments{
  \item{sysargs}{
    object of class \code{SYSargsList}.
}
  \item{steps}{
    character or numeric. Step name or index. If \code{NULL}, all the steps
    will be executed.
}
  \item{targets}{
    This option allows selecting which targets file and, by consequence which 
    command line will be executed for each \code{SYSargs2} class step.
    Default is \code{NULL}, in which all command lines will be executed.
    
}
  \item{force}{
    Internally, the option checks if the expected \code{output} files exist, 
    and it skips the command lines when the respective files exist. 
    If the argument \code{force} is set to \code{TRUE}, the command line will 
    be executed and the files overwrite. Default is \code{force=FALSE}. 
}
  \item{saveEnv}{
    If set to \code{TRUE}, the environment will be saved to an RDS file. 
    To check the RDS file location, please use 
    \code{projectInfo(sysargs)[["envir"]]}.
}
  \item{run_step}{
    character. If the step has "mandatory" or "optional" flag for the execution.
    When \code{ALL}, all the steps will be executed. 
}
  \item{ignore.dep}{
    logical. This option allow to igonore the dependency tree, when \code{TRUE}.
}
  \item{warning.stop}{
    If set to \code{TRUE}, the process will be interrupted when a warning is detected.
}
  \item{error.stop}{
    If set to \code{TRUE}, the process will be interrupted when a error is detected.
}
  \item{silent}{
    If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{\dots}{
    Additional arguments to pass on from \code{runCommandline()}.
}
}
\value{
It will return an \code{SYSargsList} updated.
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
See also as \code{SYSargsList-class}.
}
\examples{
## Construct SYSargsList object from Rmd file
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", package="systemPipeR"),
                               inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")
\dontrun{
sal <- runWF(sal)
}
}
\keyword{ utilities }

\name{loadWorkflow}
\alias{loadWorkflow}
\alias{loadWF}
\alias{renderWF}
\alias{updateWF}
\title{
Constructs SYSargs2 object from CWL param and targets files
}
\description{
The constructor functions create an \code{SYSargs2} S4 class object from three 
input files: a \code{CWL param} and \code{input} files, and one simple tabular 
or yml file, a \code{targets} file. The latter is optional for workflow steps 
lacking input files. The\code{CWL param} provides all the parameters required 
for running command-line software, following the standard and specification 
defined on \href{https://www.commonwl.org/}{Common Workflow Language (CWL)}. 
The \code{input} file provides additional information for the command-line, 
allowing each sample level input/outfile operation uses its own \code{SYSargs2} 
instance. In the \code{targets} file users could provide the paths to the initial 
sample input files (e.g. FASTQ) along with sample labels, and if appropriate 
biological replicate and contrast information for controlling differential 
abundance analyses.

The \code{renderWF} function populates all the command-line for each sample in 
each step of the particular workflow. Each sample level input/outfile operation 
uses its own \code{SYSargs2} instance. The output of \code{SYSargs2} define all 
the expected output files for each step in the workflow, which usually it is the
sample input for the next step in an \code{SYSargs2} instance. 
By chaining several \code{SYSargs2} steps together one can construct complex 
workflows involving many sample-level input/output file operations with any 
combination of command-line or R-based software. Between different instances, 
this connectivity is established by \code{`appendStep<-`} method. Please 
check more details from \code{\link{SYSargsList-class}} class.
}
\usage{
loadWorkflow(targets = NULL, wf_file, input_file, dir_path = "param/cwl", id = "SampleName")

renderWF(WF, inputvars = NULL)

updateWF(WF, write.yaml=FALSE, name.yaml="default", new_targets=NULL,
                     new_targetsheader=NULL, inputvars=NULL, silent=FALSE)
}
\arguments{
  \item{targets}{
  either the path to \code{targets} file or an object of \code{SummarizedExperiment} class.
  The \code{targets} file can be either a simple tabular or yml file. Also,
  it is possible to assign \code{NULL} to run the pipeline without the 'targets'
  file. This can be useful for running specific workflows that do not require input files.
}
  \item{wf_file}{
  name and path to \code{CWL parameters} file.
}
  \item{input_file}{
  name and path to \code{input parameters} file.
}
  \item{dir_path}{
  path to the \code{parameters} directory with the \code{wf_file} and 
  \code{input_file} files.
  It is recommended to keep both files in the same directory. 
}
  \item{id}{
  A column from \code{targets} file, which will be used as an id for each one
  of the samples. It is required to be unique.
  }
  \item{WF}{
  Object of class \code{SYSargs2}, generated by \code{loadWF} .
}
  \item{inputvars}{
  named character vector. Variables defined in the \code{input} file that matches 
  the column names defined in the \code{targets} file.
}
  \item{write.yaml}{
  logical. If set to \code{TRUE}, it will write to file the content of the 
  CWL files: \code{*.yml}. Default is \code{FALSE}.
}
  \item{name.yaml}{
   name and path to \code{input parameters} file, if \code{write.yaml} is set to
   \code{TRUE}. Default value will write a file at the same directory of 
   \code{dir_path} appending to the file name the current date.
}
  \item{new_targets}{
  new targets files as list. 'targets' \code{data.frame} can be converted by 
  \code{targets.as.list} function. Default is \code{NULL}, 
  and it will maintain the original.
}
  \item{new_targetsheader}{
  character. New header/comment lines of targets file. Default is \code{NULL}, 
  and it will maintain the original.
}
  \item{silent}{
  If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
}
\value{
\code{SYSargs2} object.
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
\code{showClass("SYSargs2")}
}
\examples{
## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF

## If required to update the object
yamlinput(WF, "thread")  <- 6L
WF <- updateWF(WF)
cmdlist(WF)[1]
yamlinput(WF)$thread
}
\keyword{ utilities }

\name{sal2rmd}
\alias{sal2rmd}
\title{
Translate SYSargsList back to a workflow template Rmarkdown file
}
\description{
This function takes a SYSargsList object and translate it to SPR workflow 
template Rmarkdown format.
}
\usage{
sal2rmd(sal, out_path = "spr_template.Rmd", rmd_title = "SPR workflow template", 
        rmd_author = "my name", 
        rmd_date = "Last update: `r format(Sys.time(), '\%d \%B, \%Y')`", 
        rmd_output = "html_document", 
        desc = "This is a workflow template.", verbose = TRUE)
}
\arguments{
  \item{sal}{
  \code{SYSargsList} object.
}
  \item{out_path}{
   string, output file name.
}
  \item{rmd_title}{
  string, title of the Rmd.
}
  \item{rmd_author}{
  string, author(s) of the Rmd, put all authors in a single character string.
}
  \item{rmd_date}{
  string, date header of Rmd.
}
  \item{rmd_output}{
  string, output format of Rmd, used in header.
}
  \item{desc}{
  string, or character vector of strings, some description text in format 
  Rmarkdown that will be added to the document before the workflow steps start. 
  It can be a single line or multiple lines by providing a character vector,
  each item is one line.
}
  \item{verbose}{
  logical. If \code{TRUE} will show you more information as 
  the function runs.
}
}
\value{
    no return
}

\author{
    Le Zhang and Daniela Cassol
}
\examples{
file_path <- system.file("extdata/spr_simple_wf.Rmd", package="systemPipeR")
sal <- SPRproject(overwrite = TRUE)
sal <- importWF(sal, file_path)
sal2rmd(sal)
}
\keyword{ utilities }

\name{config.param}
\alias{config.param}
\title{
Adding param file
}
\description{
Replace or adding a input configuration setting at "YML" param file
}
\usage{
config.param(input_file = NULL, param, file = "default", silent = FALSE)
}
\arguments{
  \item{input_file}{
  a \code{list} of parameters, \code{param file} path, or \code{SYSargs2} object.
}
  \item{param}{
  object of class \code{list}, expressing the values and names to be added or 
  replace at the command-line definition or the configuration files.
}
  \item{file}{
   name and path of the new file. If set to \code{default}, the name of the 
   write file will have the pattern: \code{<Date-Time>_<OriginalName>.yml}.
   If set to \code{append}, the \code{param} information it will be append on the 
   same file.
}
  \item{silent}{
  if set to TRUE, all messages returned by the function will be suppressed.
}
}
\author{
Daniela Cassol
}
\examples{
\dontrun{
input_file <- system.file("extdata", "cwl/hisat2/hisat2-mapping-se.yml", package="systemPipeR")
param <- list(thread=10, fq=list(class="File", path="./results2"))
input <- config.param(input_file=input_file, param, file="default")
 }
}
\keyword{ utilities }

\name{writeTargets}
\alias{writeTargets}
\title{
Write updated targets out to file from \code{SYSargsList}
}
\description{
Convenience write function for generating targets files containing the paths to 
files generated by input processes. These processes can be commandline- 
or R-based software. Typically, the paths to the inputs are stored in the 
targets infile \code{targetsWF(sysargs)} for \code{SYSargsList} objects. 
Note: by default the function cannot overwrite any existing files. If a file 
exists then the user has to explicitly remove it or set \code{overwrite=TRUE}. 
}
\usage{
writeTargets(sysargs, step, file = "default", silent = FALSE, overwrite = FALSE)
}
\arguments{
  \item{sysargs}{
Object of class \code{SYSargsList}.
}
  \item{step}{
    character with the step name. To check all the names, please 
    use \code{stepName(sysargs)}.
}
  \item{file}{
    Name and path of the output file. If set to "default" then the name of the 
    output file will have the pattern 'targets_<stepName>.txt'.
}
  \item{silent}{
    If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{overwrite}{
    If set to \code{TRUE}, existing files of same name will be overwritten.
}
}
\value{
    Writes tabular targes files containing the header/comment lines from 
    \code{stepsWF(sysargs)[[step]][["targetsheader"]]} and the 
    columns from \code{targetsWF(sysargs)[[step]]}.
}
\author{
Daniela Cassol 
}

\examples{
## Construct SYSargsList object from Rmd file
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", package="systemPipeR"),
                               inputvars = c(Message = "_STRING_", SampleName = "_SAMPLE_"))
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")
writeTargets(sal, "echo")
}
\keyword{ utilities }

\name{scaleRanges}
\alias{scaleRanges}
\title{
Scale spliced ranges to genome coordinates
}
\description{
Function to scale mappings of spliced features (query ranges) to their
corresponding genome coordinates (subject ranges). The method accounts for
introns in the subject ranges that are absent in the query ranges. A use case
example are uORFs predicted in the 5' UTRs sequences using \code{predORF}.
These query ranges are given relative to the 5' UTR sequence. The
\code{scaleRanges} function will scale them to the corresponding genome
coordinates. This way they can be used in RNA-Seq expression experiments
like other gene ranges. 
}
\usage{
scaleRanges(subject, query, type = "custom", verbose = TRUE)
}
\arguments{
  \item{subject}{
Genomic ranges provided as \code{GRangesList} object. Their name and length
requirements are described under \code{query}.
}
  \item{query}{
Feature level ranges provided as \code{GRangesList} object. The names of the 
query ranges need to match the names of the \code{GRangesList} object 
assigened to the \code{subject} argument. In addition, the length of 
each \code{query} range cannot exceed the total length of the corresponding 
\code{subject} range set. 
}
  \item{type}{
Feature name to use in \code{type} column of \code{GRangesList} result.  
}
  \item{verbose}{
The setting \code{verbose=FALSE} suppresses all print messages.
}
}
\value{
Object of class \code{GRangesList}
}
\author{
Thomas Girke
}

\seealso{
\code{predORF}
}
\examples{
library(IRanges)
## Usage for simple example
subject <- GRanges(seqnames="Chr1", IRanges(c(5,15,30),c(10,25,40)), strand="+") 
query <- GRanges(seqnames="myseq", IRanges(1, 9), strand="+")
scaleRanges(GRangesList(myid1=subject), GRangesList(myid1=query), type="test")

\dontrun{
## Usage for more complex example
library(txdbmaker); library(systemPipeRdata)
gff <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=gff, format="gff3", organism="Arabidopsis")
futr <- fiveUTRsByTranscript(txdb, use.names=TRUE)
genome <- system.file("extdata/annotation", "tair10.fasta", package="systemPipeRdata")
dna <- extractTranscriptSeqs(FaFile(genome), futr)
uorf <- predORF(dna, n="all", mode="orf", longest_disjoint=TRUE, strand="sense")
grl_scaled <- scaleRanges(subject=futr, query=uorf, type="uORF", verbose=TRUE)
export.gff3(unlist(grl_scaled), "uorf.gff")
}
}
\keyword{ utilities }

\name{sal2bash}
\alias{sal2bash}
\title{
Translate SYSargsList back to a bash workflow
}
\description{
    This function takes a SYSargsList object and translate it to an 
    executable bash script, so one can run the workflow without loading SPR or 
    using an R console.
}
\usage{
sal2bash(sal, out_dir = ".", bash_path = "/bin/bash", stop_on_error = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sal}{
    \code{SYSargsList} object.
}
  \item{out_dir}{
    string, a relative or absolute path to a directory. If the 
    directory does not exist, this function will first try to create it. 
}
  \item{bash_path}{
    string, the path to the bash executable program
}
  \item{stop_on_error}{
  bool, should the bash script stop if any error happens in running
}
}
\details{
    ## out files 
    
    1. The main executable bash file will be created to the root of `out_dir`
    
    2. All R steps will be stored as R scripts and along with other supporting 
    files inside a folder called `spr_bash` under `out_dir`
    
    3. Not all R steps will have an individual file. This function will "collapse"
    adjacent R steps into one file as much as possible. Namely, if there is no 
    sysArgs steps in between, R steps will be merged into one file, otherwise 
    they will be in different files. 
    
    ## R steps 
    
    Similarly as running the workflow in R console, all R steps will share the same 
    environment variables and loaded packages. This is done by loading and saving 
    the R environment into a file `spr_wf.RData` before and after the R script execution.
    Therefore, it will be good to keep all R steps bundle together as much as possible 
    to avoid the package and environment loading/saving overhead time. 
    
    Initially, this environment only contains the SYSargsList object that was used to 
    create the bash script. Note: the SYSargsList object name will be the same 
    as what you pass to `sal2bash`. If you have `sal2bash(my_sal)`, then in the 
    `spr_wf.RData` there will be an object called `my_sal` saved there. It is important 
    to keep using the same name for the SYSargsList object managing the workflow 
    and in workflow running. For example, if you have an R step that requires to 
    query a column from the outfiles of the SAL, `getColumn(sal, "FileName1")`, but you 
    pass `my_sal` to `sal2bash(my_sal)`, this will cause this R step cannot find 
    the SAL object when run the workflow from bash.  
    
    ## Execution
    
    This way of execution is not able to handle complex dependency graphs. The original 
    step dependencies from SAL object will be ignored, so all steps will be executed 
    in a linear manner. It is recommended to adjust the workflow order before using 
    this function. 
}
\value{
    no return
}
\author{
    Le Zhang and Daniela Cassol
}
\examples{
file_path <- system.file("extdata/spr_simple_wf.Rmd", package="systemPipeR")
sal <- SPRproject(overwrite = TRUE)
sal <- importWF(sal, file_path)
sal2bash(sal)
}
\keyword{ utilities }

\name{readComp}
\alias{readComp}
\title{
Import sample comparisons from targets file
}
\description{
Parses sample comparisons specified in \code{<CMP>} line(s) of targets file
or in \code{targetsheader} slot of \code{SYSargs} object. All possible comparisons 
can be specified with 'CMPset: ALL'.
}
\usage{
readComp(file, format = "vector", delim = "-")
}
\arguments{
  \item{file}{
	Path to targets file. Alternatively, a \code{SYSargs} or \code{SYSargs2} object can be assigned.
}
  \item{format}{
	Object type to return: \code{vector} or  \code{matrix}.
}
  \item{delim}{
	Delimiter to use when sample comparisons are returned as \code{vector}.
}
}
\value{
	\code{list} where each component is named according to the name(s) used in the \code{<CMP>} line(s) of the targets file. The list will contain as many sample comparisons sets (list components) as there are sample comparisons lines in the corresponding targets file.
}
\author{
Thomas Girke
}
\examples{
## Return comparisons from targets file
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
read.delim(targetspath, comment.char = "#")
readComp(file=targetspath, format="vector", delim="-")

## Return comparisons from SYSargs2 object
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args
readComp(args, format = "vector", delim = "-")
}
\keyword{ utilities }

\name{importWF}
\alias{importWF}
\title{
Import R Markdown file as workflow
}
\description{
Import R Markdown file as workflow. Each R code chunk will be set as a step in the
workflow. This operation requires a few extra settings on the R Markdown chunk
options, to include a particular code chunk in the workflow analysis. Please check
\code{Details}.
}
\usage{
importWF(
    sysargs, file_path, ignore_eval = TRUE,
    update = FALSE, confirm = FALSE,
    check_tool = !update,
    check_module = check_tool,
    verbose = TRUE
)
}
\arguments{
  \item{sysargs}{
  \code{\link{SYSargsList}} empty object. More information on \code{Details}.
}
  \item{file_path}{
  string, file path of the workflow file.
}
  \item{ignore_eval}{
  logical, treat all R chunks' \code{eval} option as \code{TRUE} in workflow
  \code{Rmd} file even if some chunks have \code{eval=FALSE}.
}
  \item{update}{
  logical, If you have ever changed the template and want to sync new changes,
  turn \code{TRUE} to update the workflow. This function will find the
  difference between old template and this new template, update line number
  records, update preprocessing code, and try to import new steps. The
  updated template is useful in \code{renderReport()} function.
}
  \item{confirm}{
  logical, Only useful when you combine \code{update = TRUE}, some questions
  will be asked during update. Changing this to \code{TRUE} would
  skip these questions and directly say "Yes" to all answers. Useful
  in non-interactive mode. Default is to say "No" in  non-interactive mode.
}
  \item{check_tool}{
  logical, whether to check all required tools by this workflow are in PATH (callable).
  It uses the \code{listCmdTools} function to perform the check.
  The default is the reverse of \code{update}. It means if it is the first importing the workflow, tools and modules
  will be checked. If it is updating the existing workflow, tools will not be checked.
}
  \item{check_module}{
  logical, whether to check all required modules are available. To do so, a modular system has be to installed.
  If no modular system, this check will be skipped, even if \code{check_module = TRUE}.
  It uses the \code{listCmdModules} function to perform the check.
  Check the help of \code{\link{module}} to know more about modular system.
}
  \item{verbose}{
  logical, print out verbose message while function running.
}
}
\value{
\code{importWF} will return an \code{SYSargsList} object.
}
\details{
To include a particular code chunk from the R Markdown file in the workflow
analysis, please use the following code chunk options:

  - \code{spr = 'r'}: for code chunks with R code lines;
  - \code{spr = 'sysargs'}: for code chunks with an `SYSargsList` object;
  - \code{spr.dep = <StepName>}: for specify the previous dependency. If this options
  is not found, it will automaticly add the previous step.

For \code{spr = 'sysargs'}, the last object assigned needs to be the
\code{\link{SYSargsList}}.
If the \code{spr} flag is not found, the R chunk will not be included in the workflow.

It is required to start a project using \code{SPRproject()} function, and use the
object to populate the steps from R Markdown file.
}
\author{
Le Zhang and Daniela Cassol
}
\seealso{
\code{\link{SYSargsList}}
\code{\link{renderReport}}
}
\examples{
file_path <- system.file("extdata/spr_simple_lw.Rmd", package="systemPipeR")
sal <- SPRproject(overwrite = TRUE)
sal <- importWF(sal, file_path)
}
\keyword{ utilities }

\name{SPRproject}
\alias{SPRproject}
\title{
Workflow Project Initiation
}
\description{
Function to construct \code{SYSargsList} workflow control environment (S4 object). 
This function creates and checks the directory structure. If the expected directories
are not available, it is possible to create those. 
The project directory default structure expected is: 

\itemize{
  \item{\code{SPRproject/}}
    \itemize{
      \item{\code{data/}}
      \item{\code{param/}}
      \item{\code{results/}}
  }
}
The project working directory names can be modified, but users need to edit
the code accordingly.   
}
\usage{
SPRproject(projPath = getwd(), data = "data", param = "param", results = "results",
                      logs.dir= ".SPRproject", sys.file="SYSargsList.yml", 
                      envir = new.env(), 
                      restart = FALSE, resume=FALSE, 
                      load.envir = FALSE,
                      overwrite = FALSE, silent = FALSE)
}
\arguments{
  \item{projPath}{
  a character vector of a full project path name. Default is the current path. 
}
  \item{data}{
  a character vector of a \code{data} directory name. Default is \code{data}. 
This subdirectory in the project stores all the raw data, reference, and annotation files.
}
  \item{param}{
  a character vector of a \code{param} directory name. Default is \code{param}.
This subdirectory in the project stores all the parameter and configuration files.
}
  \item{results}{
  a character vector of a \code{results} directory name. Default is \code{results}. 
This subdirectory in the project stores all the analysis results, including but 
not limited: alignment, variant, and peak files (BAM, VCF, BED); tabular result files; 
and image/plot files.
}
  \item{logs.dir}{
  a character vector of a \code{logs} directory name. Default is \code{.SPRproject}.
}
  \item{sys.file}{
  a character vector of \code{SYSargsList} file name which will store all the 
  project configuration information. 
  Default is \code{SYSargsList.yml} and it will be save in the \code{logs.dir}
  folder.
}
  \item{envir}{
  the environment in which workflow will be evaluated. Default will create
  a \code{new.env()}. 
}
  \item{restart}{
  if set to \code{TRUE}, existing \code{SYSargsList} object saved in the 
  \code{logs.dir} directory will be used to restart the workflow. This option
  will delete all the log files. 
}
  \item{resume}{
  if set to \code{TRUE}, existing \code{SYSargsList} object saved in the 
  \code{logs.dir} directory will be used to resume the workflow.
}
  \item{load.envir}{
  This argument allows to load the environment and recover all the objects saved
  during the workflow execution (please check \code{runWF} function for more 
  details). This argument can be set as \code{TRUE} when \code{restart = TRUE} 
  or \code{resume = TRUE} are used.
}
  \item{overwrite}{
  if set to \code{TRUE}, existing \code{logs.dir} directory and all the content,
  as logs files and \code{SYSargsList} file will be removed, and a new and 
  empty \code{SYSargsList} object will be created. 
  This option should be used with caution!
}
  \item{silent}{
  if set to TRUE, all messages returned by the function will be suppressed.
}
}
\details{
  If an \code{SYSargsList} instance was created before or independent of the 
  project initialization, it is possible to append this instance after the 
  project is created. Please see check \code{appendStep<-} function.
}
\value{
\code{SPRproject} will return a \code{SYSargsList} object.
}
\author{
Daniela Cassol 
}
\seealso{
See also as \code{SYSargsList-class}.
}
\examples{
sal <- SPRproject(projPath = tempdir())
sal
}
\keyword{ utilities }

\name{showDF}
\alias{showDF}
\title{Create an HTML table using DT package with fixed columns}
\usage{
showDF(data, ...)
}
\arguments{
\item{data}{data object (either a matrix or a data frame).}

\item{...}{Additional arguments used by dDT::atatable() function.}
}
\value{
returns an object of \code{datatables} and \code{htmlwidget}.
}
\description{
Create an HTML table using DT package with fixed columns
}
\examples{
showDF(iris)
}

\name{VENNset-class}
\Rdversion{1.1}
\docType{class}
\alias{VENNset-class}
\alias{as.list,VENNset-method}
\alias{coerce,list,VENNset-method}
\alias{complexitylevels,VENNset-method}
\alias{intersectmatrix,VENNset-method}
\alias{length,VENNset-method}
\alias{names,VENNset-method}
\alias{setlist,VENNset-method}
\alias{show,VENNset-method}
\alias{vennlist,VENNset-method}

\title{Class \code{"VENNset"}}
\description{
Container for storing Venn intersect results created by the \code{overLapper} function.
The \code{setlist} slot stores the original label sets as \code{vectors} in a \code{list};
\code{intersectmatrix} organizes the label sets in a present-absent matrix; \code{complexitylevels}
represents the number of comparisons considered for each comparison set as vector of integers;
and \code{vennlist} contains the Venn intersect vectors. 
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("VENNset", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{setlist}:}{Object of class \code{"list"}: \code{list} of \code{vectors} }
    \item{\code{intersectmatrix}:}{Object of class \code{"matrix"}: binary \code{matrix}}
    \item{\code{complexitylevels}:}{Object of class \code{"integer"}: \code{vector} of \code{integers}}
    \item{\code{vennlist}:}{Object of class \code{"list"}: \code{list} of \code{vectors} }
  }
}
\section{Methods}{
  \describe{
    \item{as.list}{\code{signature(x = "VENNset")}: coerces \code{VENNset} to \code{list} }
    \item{coerce}{\code{signature(from = "list", to = "VENNset")}: \code{as(list, "VENNset")} }
    \item{complexitylevels}{\code{signature(x = "VENNset")}: extracts data from \code{complexitylevels} slot }
    \item{intersectmatrix}{\code{signature(x = "VENNset")}: extracts data from \code{intersectmatrix} slot }
    \item{length}{\code{signature(x = "VENNset")}: returns number of original label sets }
    \item{names}{\code{signature(x = "VENNset")}: extracts slot names }
    \item{setlist}{\code{signature(x = "VENNset")}: extracts data from \code{setlist} slot }
    \item{show}{\code{signature(object = "VENNset")}: summary view of \code{VENNset} objects }
    \item{vennlist}{\code{signature(x = "VENNset")}: extracts data from \code{vennset} slot }
	 }
}
\author{
Thomas Girke
}
\seealso{
\code{overLapper}, \code{vennPlot}, \code{olBarplot}, \code{INTERSECTset-class}
}
\examples{
showClass("VENNset")

## Sample data
setlist <- list(A=sample(letters, 18), B=sample(letters, 16),
                C=sample(letters, 20), D=sample(letters, 22),
                E=sample(letters, 18), F=sample(letters, 22))

## Create VENNset
vennset <- overLapper(setlist[1:5], type="vennsets")
class(vennset)

## Accessor methods for VENNset/INTERSECTset objects
names(vennset)
setlist(vennset)
intersectmatrix(vennset)
complexitylevels(vennset)
vennlist(vennset)

## Coerce VENNset/INTERSECTset object to list
as.list(vennset)
}
\keyword{classes}

\name{targets.as.df}
\alias{targets.as.df}
\alias{targets.as.list}
\title{
Convert targets to list or data.frame
}
\description{
Convert targets files to \code{list} or \code{data.frame} object. 
}
\usage{
targets.as.df(x)
targets.as.list(x, id="SampleName")
}
\arguments{
  \item{x}{
  An object of the class \code{"list"} or \code{"data.frame"} that stores data 
  from each target file, as \code{targets(WF)}.
  }
    \item{id}{
    A column from \code{targets} file, which will be used as an id for each one
    of the samples. It is required to be unique.
  }
}
\value{
\code{data.frame} or \code{list} containing all the \code{targets} file information. 
}
\seealso{
\code{showClass("SYSargs2")}
}
\author{
Daniela Cassol
}
\examples{
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
targets <- read.delim(targetspath, comment.char = "#")
targetslist <- targets.as.list(x=targets)
targets.as.df(x=targetslist)
}
\keyword{ utilities }

\name{plotWF}
\alias{plotWF}
\alias{plotwfOutput}
\alias{renderPlotwf}
\title{Visualize SPR workflow and status}

\description{
  Visualize SPR workflow and status. \code{plotWF} is the general function
  that creates the plot.
  \code{plotwfOutput} and \code{renderPlotwf} are used in Shiny UI and server
  respectively, similar to \code{plotOutput} and \code{renderPlot}.
}

\usage{
plotWF(
  sysargs,
  width = NULL, height = NULL,
  elementId = NULL,
  responsive = TRUE,
  branch_method = "auto",
  branch_no = NULL,
  layout = "compact",
  no_plot = FALSE,
  plot_method = "svg",
  out_format = "plot",
  out_path = NULL,
  show_legend = TRUE,
  mark_main_branch = FALSE,
  rstudio = FALSE,
  in_log = FALSE,
  rmarkdown = "detect",
  verbose = FALSE,
  show_warns = FALSE,
  plot_ctr = TRUE,
  pan_zoom = FALSE,
  exit_point = 0
)

plotwfOutput(
  outputId,
  width = '100\%',
  height = '400px'
)

renderPlotwf(
  expr,
  env = parent.frame(),
  quoted = FALSE
)
}
\arguments{
  \item{sysargs}{object of class \code{SYSargsList}.}

  \item{width}{string, a valid CSS string for width, like "500px", "100\%".}

  \item{height}{string, a valid CSS string for height, like "500px", "100\%".}

  \item{elementId}{string, optional ID value for the plot.}

  \item{responsive}{bool, should the plot be responsive? useful in Rstudio built-in
  viewer, Rmarkdown, Shiny or embed it into other web pages.}

  \item{branch_method}{string, one of "auto", "choose". How to determine the
  main branch of the workflow. "auto" will be determined by internal alrgothrim:
  Branches connecting the frist and last step and/or the longest will be favored.
  "choose" will list all possible branches and you can make a choice.}

  \item{branch_no}{numeric, only works if \code{branch_method == "choose"}. Specify a
  branch number to be the main branch instead of choosing from the prompt. This
  option can be good if you are in a non-interactive mode, e.g. rendering Rmd.}

  \item{layout}{string, one of "compact", "vertical", "horizontal", "execution".}

  \item{no_plot}{bool, if you want to assgin the plot to a variable and do not want
  to see it interactively, change this to \code{FALSE}.}

  \item{plot_method}{string, one of "svg", "png", how to make plot, use svg or png
  to embed the plot.}

  \item{out_format}{string, one of "plot", "html", "dot", "dot_print"
  \itemize{
    \item plot: directly open your viewer or browser of the plot
    \item html: save the plot to a html file
    \item dot: save the plot in DOT language, need a dot engine to remake the plot
    \item dot_print: directly cat the DOT code on console
  }
  See \code{details} section if one wish to generate other output format,
  such as \code{jpg} or \code{png}.
  }




  \item{out_path}{string, if the \code{out_format} is not "plot" or "dot_print",
  provide a path of where to save the plot.}

  \item{show_legend}{bool, show plot legend?}

  \item{mark_main_branch}{bool, color the main branch on the plot?}

  \item{rstudio}{bool, if you are using Rstudio, open the built-in viewer to see the
  plot? Default is no, open the browser tab to see it plot. The default viewer is
  too small to see the full plot clearly, so we recommend to use the browser tab.
  However, if you are using this plot in Shiny apps, always turn \code{rstudio = TRUE}.}

  \item{in_log}{bool, is this plot been made in a SPR log file? If \code{TRUE} will add
  links of steps to the corresponding log sections.}

  \item{rmarkdown}{are you rendering this plot in a Rmarkdown document? default value is
  "detect", this function will determine based on current R environment, or you
  can force it to be \code{TRUE} or \code{FALSE}.}

  \item{verbose}{bool, turn on verbose mode will give you more information.}

  \item{show_warns}{bool, print the warning messages on the plot?.}

  \item{plot_ctr}{bool, add the plot control panel to the plot? This requires you
  to have internet connection. It will download some additional javascript
  libraries, and allow you to save the plot as png, jpg, svg, pdf or graphviz
  directly from the browser.}

  \item{pan_zoom}{ bool, allow panning and zooming of the plot? Use mouse wheel
  or touch pad to zoom in and out of the plot. You need to have internet
  connection, additional javascript libraries will be loaded automatically online.
  Cannot be used with \code{responsive = TRUE} together. If both
  \code{TRUE}, \code{responsive} will be automatically set to \code{FALSE}.}

  \item{exit_point}{numeric, for advanced debugging only, see details}

  \item{outputId}{string, shiny output ID}

  \item{expr}{An expression that generates a plotwf, like \code{plotWF(sal)}}

  \item{env}{The environment in which to evaluate \code{expr}.}

  \item{quoted}{Is \code{expr} a quoted expression (with \code{quote()})?
This is useful if you want to save an expression in a variable.}
}
\value{
see \code{out_format} and \code{exit_point}
}

\details{
\subsection{layout}{
  \itemize{
  \item compact: try to plot steps as close as possible.
  \item vertical: main branch will be placed vertically and side branches will be placed
  on the same horizontal level and sub steps of side branches will be placed
  vertically.
  \item horizontal: main branch is placed horizontally and side branches and sub
  steps will be placed vertically.
  \item execution: a linear plot to show the workflow execution order of all steps.
}
}

\subsection{exit_point}{

return intermediate results at different points and exit the function
\itemize{
  \item 0: no early exit
  \item 1: after all branches are found, return tree
  \item 2: after the new tree has been built, return new nodes
  \item 3: after dot translation, return graph string
}
}

\subsection{Rmarkdown}{

Rmarkdown will change some of the format and cause conflicts. If the plot can be
rendered outside Rmd but cannot within Rmd, try to turn this option on. Some additional
javascript processing will be performed to avoid the conflict but may cause unknown
issues.
}

\subsection{Other output formats}{

The plot rendering uses \code{htmlwidgets}, which generates an interactive HTML page.
Saving these plots directly to standard image files, such as \code{png}, is not possible.
However, a few workarounds exist to save to these image formats:

\itemize{
  \item 1: use \code{webshot2::webshot} function.
  \item 2: use the interactive panel located on the top-left corner to download as an image
           after the plot is rendered.
  \item 3: use \code{plotWF(sal, plot_method = "png")} to embed the plot as \code{png}, and
           then right-click to save the image.
}

Please see our website for examples: https://systempipe.org/sp/spr/sp_run/step_vis/
}
\subsection{Shiny}{

When the plot is rendered in a Shiny app, the \code{rstudio} option must be turned on,
\code{plotWF(sal, rstudio = TRUE, ...)}.
}
}

\name{catDB-class}
\Rdversion{1.1}
\docType{class}
\alias{catDB-class}
\alias{catlist,catDB-method}
\alias{catmap,catDB-method}
\alias{coerce,list,catDB-method}
\alias{idconv,catDB-method}
\alias{names,catDB-method}
\alias{show,catDB-method}

\title{Class \code{"catDB"}}
\description{
Container for storing mappings of genes to annotation categories
such as gene ontologies (GO), pathways or conserved sequence domains.  
The \code{catmap} slot stores a \code{list} of \code{data.frames} providing the direct
assignments of genes to annotation categories (e.g. gene-to-GO mappings);
\code{catlist} is a \code{list} of \code{lists} of all direct and indirect associations to
the annotation categories (e.g. genes mapped to a pathway); and \code{idconv}
allows to store a lookup-table for converting identifiers (e.g. array feature
ids to gene ids). 
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("catDB", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{catmap}:}{Object of class \code{"list"} \code{list} of \code{data.frames} }
    \item{\code{catlist}:}{Object of class \code{"list"} \code{list} of \code{lists} }
    \item{\code{idconv}:}{Object of class \code{"ANY"} \code{list} of \code{data.frames} }
  }
}
\section{Methods}{
  \describe{
    \item{catlist}{\code{signature(x = "catDB")}: extracts data from \code{catlist} slot }
    \item{catmap}{\code{signature(x = "catDB")}: extracts data from \code{catmap} slot }
    \item{coerce}{\code{signature(from = "list", to = "catDB")}: \code{as(list, "catDB")} }
    \item{idconv}{\code{signature(x = "catDB")}: extracts data from \code{idconv} slot }
    \item{names}{\code{signature(x = "catDB")}: extracts slot names }
    \item{show}{\code{signature(object = "catDB")}: summary view of \code{catDB} objects }
	 }
}
\author{
Thomas Girke
}
\seealso{
\code{makeCATdb}, \code{GOHyperGAll}, \code{GOHyperGAll_Subset}, \code{GOHyperGAll_Simplify}, \code{GOCluster_Report}, \code{goBarplot} 
}
\examples{
showClass("catDB")
\dontrun{
## Obtain annotations from BioMart
library("biomaRt")
listMarts()  # To choose BioMart database
listMarts(host = "plants.ensembl.org")
m <- useMart("plants_mart", host = "plants.ensembl.org")
listDatasets(m)
m <- useMart("plants_mart", dataset = "athaliana_eg_gene", host = "plants.ensembl.org")
listAttributes(m)  # Choose data types you want to download
go <- getBM(attributes = c("go_id", "tair_locus", "namespace_1003"), mart = m)
go <- go[go[, 3] != "", ]
go[, 3] <- as.character(go[, 3])
go[go[, 3] == "molecular_function", 3] <- "F"
go[go[, 3] == "biological_process", 3] <- "P"
go[go[, 3] == "cellular_component", 3] <- "C"
go[1:4, ]

dir.create("./data/GO", recursive = TRUE)
write.table(go, "data/GO/GOannotationsBiomart_mod.txt", quote = FALSE, row.names = FALSE,
            col.names = FALSE, sep = "\t")
            
## Create catDB instance (takes a while but needs to be done only once)
catdb <- makeCATdb(myfile = "data/GO/GOannotationsBiomart_mod.txt", lib = NULL, org = "",
                   colno = c(1, 2, 3), idconv = NULL)
catdb
save(catdb, file = "data/GO/catdb.RData")
load("data/GO/catdb.RData")
}
}
\keyword{classes}

\name{olBarplot}
\alias{olBarplot}
\title{
Bar plot for intersect sets
}
\description{
Generates bar plots of the intersect counts of \code{VENNset} and
\code{INTERSECTset} objects generated by the \code{overLapper} function. It is
an alternative to Venn diagrames (e.g. \code{vennPlot}) that scales to larger numbers
of label sets. By default the bars in the plot are colored and grouped by complexity 
levels of the intersect sets. 
}
\usage{
olBarplot(x, mincount = 0, complexity="default", myxlabel = "default", myylabel="Counts", mytitle = "default", ...)
}
\arguments{
  \item{x}{
Object of class \code{VENNset} or \code{INTERSECTset}.
}
  \item{mincount}{
Sets minimum number of counts to consider in the bar plot. Default \code{mincount=0} 
considers all counts.
}
  \item{complexity}{
Allows user to limit the bar plot to specific complexity levels of intersects
by specifying the chosen ones with an integer vector. Default
\code{complexity="default"} considers all complexity levels. 
}
  \item{myxlabel}{
Defines label of x-axis.
}
  \item{myylabel}{
Defines label of y-axis.
}
  \item{mytitle}{
Defines main title of plot. 
}
  \item{\dots}{
Allows to pass on additional arguments to \code{geom_bar} from \code{ggplot2}.
For instance, \code{fill=seq(along=vennlist(x))} or
\code{fill=seq(along=intersectlist(x))} will assign a different color to each
bar, or \code{fill="blue"} will color all of them blue. The default bar
coloring is by complexity levels of the intersect sets.
}
}
\value{
Bar plot.
}
\author{
Thomas Girke
}
\note{
The functions provided here are an extension of the Venn diagram resources on this
site: http://manuals.bioinformatics.ucr.edu/home/R_BioCondManual#TOC-Venn-Diagrams
}

\seealso{
\code{overLapper}, \code{vennPlot}
}
\examples{
## Sample data: list of vectors with object labels
setlist <- list(A=sample(letters, 18), B=sample(letters, 16),
                C=sample(letters, 20), D=sample(letters, 22),
                E=sample(letters, 18), F=sample(letters, 22))

## 2-way Venn diagram
vennset <- overLapper(setlist[1:2], type="vennsets")
vennPlot(vennset)

## 3-way Venn diagram
vennset <- overLapper(setlist[1:3], type="vennsets")
vennPlot(vennset)

## 4-way Venn diagram
vennset <- overLapper(setlist[1:4], type="vennsets")
vennPlot(list(vennset, vennset))

## Pseudo 4-way Venn diagram with circles
vennPlot(vennset, type="circle")

## 5-way Venn diagram
vennset <- overLapper(setlist[1:5], type="vennsets")
vennPlot(vennset)

## Alternative Venn count input to vennPlot (not recommended!)
counts <- sapply(vennlist(vennset), length)
vennPlot(counts)

## 6-way Venn comparison as bar plot
vennset <- overLapper(setlist[1:6], type="vennsets")
olBarplot(vennset, mincount=1)

## Bar plot of standard intersect counts
interset <- overLapper(setlist, type="intersects")
olBarplot(interset, mincount=1)

## Accessor methods for VENNset/INTERSECTset objects
names(vennset)
names(interset)
setlist(vennset)
intersectmatrix(vennset)
complexitylevels(vennset)
vennlist(vennset)
intersectlist(interset)

## Coerce VENNset/INTERSECTset object to list
as.list(vennset)
as.list(interset)

## Pairwise intersect matrix and heatmap
olMA <- sapply(names(setlist), 
		function(x) sapply(names(setlist), 
		function(y) sum(setlist[[x]] \%in\% setlist[[y]])))
olMA
heatmap(olMA, Rowv=NA, Colv=NA)

## Presence-absence matrices for large numbers of sample sets
interset <- overLapper(setlist=setlist, type="intersects", complexity=2)
(paMA <- intersectmatrix(interset))
heatmap(paMA, Rowv=NA, Colv=NA, col=c("white", "gray")) 
}
\keyword{ utilities }

\name{printParam}
\alias{printParam}
\alias{subsetParam}
\alias{replaceParam}
\alias{renameParam}
\alias{appendParam}

\title{
Accessories function to modify the Command-line Version 1
}
\description{
Accessories function to modify the Command-line Version 1
}
\usage{
printParam(sysargs, position, index = NULL)
subsetParam(sysargs, position, index = NULL, trim = TRUE, mute = FALSE)
replaceParam(sysargs, position, index = NULL, replace, mute = FALSE)
renameParam(sysargs, position, index = FALSE, rename, mute = FALSE)
appendParam(sysargs, position, index = NULL, append, after, mute = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sysargs}{
  Object of class \code{SYSargs2}. Output from the \code{createParamFiles} function.
}
  \item{position}{
  string, one of \code{baseCommand}, \code{inputs}, \code{outputs} to view or apply a modification.
}
  \item{index}{
  numeric or character vector, index to view or change a single item in
  \code{baseCommand}, \code{inputs}, \code{outputs}.
}
  \item{trim}{
  logical, only keep arguments specified by \code{index}. Default is "TRUE".
}
  \item{replace}{
  named list, replace arguments in different positions. Replace list length
  must be the same as \code{index}. Different positions will have different requirements.
}
  \item{rename}{
  character vector, rename items in different positions. \code{rename} vector length
  must be the same as \code{index}.
}
  \item{append}{
  named list, same requirements as \code{replace}, however it cannot append \code{baseCommand}.
}
  \item{after}{
  a subscript, after which the values are to be appended. If \code{NULL} will be
  after the last argument or specify a numeric integer.
}
  \item{mute}{
  logical, print the raw command-line string and output after replacing or rename.
}
}

\details{
- \code{printParam}: prints its arguments defined by \code{position} and \code{index}.

- \code{subsetParam}: returns subsets of command-line, keeping the arguments defined by \code{position} and \code{index}.

- \code{replaceParam}: replaces the values in command-line with indices given in list by those given in values

- \code{renameParam}: rename the names of the arguments.

- \code{appendParam}: Add arguments to the original command line.
}
\value{
\code{SYSargs2} object
}
\references{
For more details on \code{CWL}, please consult the following page: https://www.commonwl.org/
}
\author{
Le Zhang and Daniela Cassol
}
\seealso{
\code{writeParamFiles}
\code{createParamFiles}
\code{loadWorkflow}
\code{renderWF}
\code{showClass("SYSargs2")}
}

\examples{
command <- "
hisat2 \
    -S <F, out: ./results/M1A.sam> \
    -x <F: ./data/tair10.fasta> \
    -k <int: 1> \
    -min-intronlen <int: 30> \
    -max-intronlen <int: 3000> \
    -threads <int: 4> \
    -U <F: ./data/SRR446027_1.fastq.gz> \
    --verbose
"
cmd <- createParamFiles(command)
cmdlist(cmd)
}

\keyword{ utilities }

\name{SYSargs-class}
\Rdversion{1.1}
\docType{class}
\alias{SYSargs-class}
\alias{[,SYSargs,ANY,ANY,ANY-method}
\alias{coerce,list,SYSargs-method}
\alias{cores,SYSargs-method}
\alias{infile1,SYSargs-method}
\alias{infile2,SYSargs-method}
\alias{modules,SYSargs-method}
\alias{names,SYSargs-method}
\alias{length,SYSargs-method}
\alias{other,SYSargs-method}
\alias{results,SYSargs-method}
\alias{outfile1,SYSargs-method}
\alias{outpaths,SYSargs-method}
\alias{reference,SYSargs-method}
\alias{show,SYSargs-method}
\alias{software,SYSargs-method}
\alias{sysargs,SYSargs-method}
\alias{SampleName,SYSargs-method}
\alias{targetsheader,SYSargs-method}
\alias{targetsin,SYSargs-method}
\alias{targetsout,SYSargs-method}

\title{Class \code{"SYSargs"}}
\description{
S4 class container for storing parameters of command-line- or R-based software.
\code{SYSargs} instances are constructed by the \code{systemArgs} function
from two simple tabular files: a \code{targets} file and a \code{param} file.
The latter is optional for workflow steps lacking command-line software.
Typically, a \code{SYSargs} instance stores all sample-level inputs as well as
the paths to the corresponding outputs generated by command-line- or R-based
software generating sample-level output files. Each sample level input/outfile
operation uses its own \code{SYSargs} instance. The outpaths of \code{SYSargs}
usually define the sample inputs for the next \code{SYSargs} instance. This
connectivity is achieved by writing the outpaths with the
\code{writeTargetsout} function to a new targets file that serves as input to
the next \code{systemArgs} call. By chaining several \code{SYSargs} steps
together one can construct complex workflows involving many sample-level
input/output file operations with any combination of command-line or R-based
software.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SYSargs", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{targetsin}:}{Object of class \code{"data.frame"} storing tabular data from targets input file }
    \item{\code{targetsout}:}{Object of class \code{"data.frame"} storing tabular data from targets output file }
    \item{\code{targetsheader}:}{Object of class \code{"character"} storing header/comment lines of targets file }
    \item{\code{modules}:}{Object of class \code{"character"} storing software versions from module system }
    \item{\code{software}:}{Object of class \code{"character"} name of executable of command-line software  }
    \item{\code{cores}:}{Object of class \code{"numeric"} number of CPU cores to use }
    \item{\code{other}:}{Object of class \code{"character"} additional arguments }
    \item{\code{reference}:}{Object of class \code{"character"} path to reference genome file }
    \item{\code{results}:}{Object of class \code{"character"} path to results directory }
    \item{\code{infile1}:}{Object of class \code{"character"} paths to first FASTQ file }
    \item{\code{infile2}:}{Object of class \code{"character"} paths to second FASTQ file if data is PE }
    \item{\code{outfile1}:}{Object of class \code{"character"} paths to output files generated by command-line software }
    \item{\code{sysargs}:}{Object of class \code{"character"} full commands used to execute external software}
    \item{\code{outpaths}:}{Object of class \code{"character"} paths to final outputs including postprocessing by \code{Rsamtools} }
  }
}
\section{Methods}{
  \describe{
    \item{SampleName}{\code{signature(x = "SYSargs")}: extracts sample names }
    \item{[}{\code{signature(x = "SYSargs")}: subsetting of class with bracket operator }
    \item{coerce}{\code{signature(from = "list", to = "SYSargs")}: \code{as(list, "SYSargs")} }
    \item{cores}{\code{signature(x = "SYSargs")}: extracts data from \code{cores} slot }
    \item{infile1}{\code{signature(x = "SYSargs")}: extracts data from \code{infile1} slot }
    \item{infile2}{\code{signature(x = "SYSargs")}: extracts data from \code{infile2} slot }
    \item{modules}{\code{signature(x = "SYSargs")}: extracts data from \code{modules} slot }
    \item{names}{\code{signature(x = "SYSargs")}: extracts slot names }
    \item{length}{\code{signature(x = "SYSargs")}: extracts number of samples }
    \item{other}{\code{signature(x = "SYSargs")}: extracts data from \code{other} slot}
    \item{outfile1}{\code{signature(x = "SYSargs")}: extracts data from \code{outfile1} slot }
    \item{outpaths}{\code{signature(x = "SYSargs")}: extracts data from \code{outpath} slot }
    \item{reference}{\code{signature(x = "SYSargs")}: extracts data from \code{reference} slot }
    \item{results}{\code{signature(x = "SYSargs")}: extracts data from \code{results} slot }
    \item{show}{\code{signature(object = "SYSargs")}: summary view of \code{SYSargs} objects }
    \item{software}{\code{signature(x = "SYSargs")}: extracts data from \code{software} slot }
    \item{targetsheader}{\code{signature(x = "SYSargs")}: extracts data from \code{targetsheader} slot }
    \item{targetsin}{\code{signature(x = "SYSargs")}: extracts data from \code{targetsin} slot }
    \item{targetsout}{\code{signature(x = "SYSargs")}: extracts data from \code{targetsout} slot }
	 }
}
\author{
Thomas Girke
}
\seealso{
\code{systemArgs} and \code{runCommandline}
}
\examples{
showClass("SYSargs")
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "tophat.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); targetsin(args); targetsout(args); targetsheader(args); 
software(args); modules(args); cores(args); outpaths(args) 
sysargs(args); other(args); reference(args); results(args); infile1(args)
infile2(args); outfile1(args); SampleName(args)

## Return sample comparisons
readComp(args, format = "vector", delim = "-")

## The subsetting operator '[' allows to select specific samples
args[1:4]

\dontrun{
## Execute SYSargs on single machine
runCommandline(args=args)

## Execute SYSargs on multiple machines  
qsubargs <- getQsubargs(queue="batch", Nnodes="nodes=1", cores=cores(args), 
                        memory="mem=10gb", time="walltime=20:00:00")
qsubRun(appfct="runCommandline(args=args)", appargs=args, qsubargs=qsubargs, 
        Nqsubs=1, submitdir="results", package="systemPipeR")

## Write outpaths to new targets file for next SYSargs step
writeTargetsout(x=args, file="default")
}
}
\keyword{classes}

\name{tryCMD}
\alias{tryCMD}
\alias{tryCL}
\title{
Collect information about the third-party software
}
\description{
Function to check if third-party software or utility is installed and set in 
the PATH.
}
\usage{
tryCMD(command, silent = FALSE)
}
\arguments{
  \item{command}{
a character vector containing the command line name to be tested.
}
  \item{silent}{
If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
}
\value{
It will return a positive message if the software is set on the PATH or an error 
message if the software is not set it. 
}
\note{
Please note that not necessary the software is not installed if the message 
indicates an error,  but it has not been exported on the current PATH.
}

\author{
Danela Cassol
}
\examples{
\dontrun{
tryCMD(command="R") 
tryCMD(command="blastp") 
tryCMD(command="hisat2") 
  }
}
\keyword{ utilities }

\name{clusterRun}
\alias{clusterRun}
\title{
Submit command-line tools to cluster
}
\description{
Submits non-R command-line software to queueing/scheduling systems of compute 
clusters using run specifications defined by functions similar to 
\code{runCommandline}. \code{clusterRun} can be used with most queueing systems 
since it is based on utilities from the \code{batchtools} package which supports 
the use of template files (\code{*.tmpl}) for defining the run parameters of 
the different schedulers. The path to the \code{*.tmpl} file needs to be 
specified in a conf file provided under the \code{conffile} argument.
}
\usage{
clusterRun(args, 
            FUN = runCommandline, 
            more.args = list(args = args, make_bam = TRUE), 
            conffile = ".batchtools.conf.R", 
            template = "batchtools.slurm.tmpl", 
            Njobs, 
            runid = "01", 
            resourceList)
}
\arguments{
  \item{args}{
	Object of class \code{SYSargs} or \code{SYSargs2}.
}
  \item{FUN}{
	Accepts functions such as \code{runCommandline(args, ...)} where the 
	\code{args} argument is mandatory and needs to be of class \code{SYSargs} 
	or \code{SYSargs2}.
}
  \item{more.args}{
  Object of class \code{list}, which provides the arguments that control the 
  \code{FUN} function. 
}
  \item{conffile}{
	Path to conf file (default location \code{./.batchtools.conf.R}). This file 
	contains in its simplest form just one command, such as this line for the 
	Slurm scheduler: \code{cluster.functions <- makeClusterFunctionsSlurm(template="batchtools.slurm.tmpl")}. 
	For more detailed information visit this page: https://mllg.github.io/batchtools/index.html
}
  \item{template}{
	The template files for a specific queueing/scheduling systems can be 
	downloaded from here: 
https://github.com/mllg/batchtools/tree/master/inst/templates. 
Slurm, PBS/Torque, and Sun Grid Engine (SGE) templates are provided.
}
  \item{Njobs}{
	Interger defining the number of cluster jobs. For instance, if \code{args} 
	contains 18 command-line jobs and \code{Njobs=9}, then the function will
	distribute them accross 9 cluster jobs each running 2 command-line jobs. 
	To increase the number of CPU cores used by each process, one can do this 
	under the corresonding argument of the command-line tool, e.g. \code{-p} 
	argument for Tophat.
}
  \item{runid}{
	Run identifier used for log file to track system call commands. 
	Default is \code{"01"}.
}
  \item{resourceList}{
	\code{List} for reserving for each cluster job sufficient computing resources
	including memory (Megabyte), number of nodes, CPU cores, walltime (minutes),
	etc. For more details, one can consult the template file for each 
	queueing/scheduling system.
}
}
\value{Object of class \code{Registry}, as well as files and directories 
created by the executed command-line tools.
}
\references{
For more details on \code{batchtools}, please consult the following 
page: https://github.com/mllg/batchtools/
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
	\code{clusterRun} replaces the older functions \code{getQsubargs} 
	and \code{qsubRun}.
}
\examples{
#########################################
## Examples with \code{SYSargs} object ##
#########################################
## Construct SYSargs object from param and targets files 
param <- system.file("extdata", "hisat2.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args <- systemArgs(sysma=param, mytargets=targets)
args
names(args); modules(args); cores(args); outpaths(args); sysargs(args)

\dontrun{
## Execute SYSargs on multiple machines of a compute cluster. The following
## example uses the conf and template files for the Slurm scheduler. Please 
## read the instructions on how to obtain the corresponding files for other schedulers. 
file.copy(system.file("extdata", ".batchtools.conf.R", package="systemPipeR"), ".")
file.copy(system.file("extdata", "batchtools.slurm.tmpl", package="systemPipeR"), ".")
resources <- list(walltime=120, ntasks=1, ncpus=cores(args), memory=1024) 
reg <- clusterRun(args, FUN = runCommandline, 
                    more.args = list(args = args, make_bam = TRUE), 
                    conffile=".batchtools.conf.R", 
                    template="batchtools.slurm.tmpl", 
                    Njobs=18, runid="01", 
                    resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)
file.exists(outpaths(args))
}

##########################################
## Examples with \code{SYSargs2} object ##
##########################################
## Construct SYSargs2 object from CWl param, CWL input, and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF
names(WF); modules(WF); targets(WF)[1]; cmdlist(WF)[1:2]; output(WF)

\dontrun{
## Execute SYSargs2 on multiple machines of a compute cluster. The following
## example uses the conf and template files for the Slurm scheduler. Please 
## read the instructions on how to obtain the corresponding files for other schedulers.  
file.copy(system.file("extdata", ".batchtools.conf.R", package="systemPipeR"), ".")
file.copy(system.file("extdata", "batchtools.slurm.tmpl", package="systemPipeR"), ".")
resources <- list(walltime=120, ntasks=1, ncpus=4, memory=1024) 
reg <- clusterRun(WF, FUN = runCommandline, 
                    more.args = list(args = WF, make_bam = TRUE),
                    conffile=".batchtools.conf.R", 
                    template="batchtools.slurm.tmpl",
                    Njobs=18, runid="01", resourceList=resources)

## Monitor progress of submitted jobs
getStatus(reg=reg)

## Updates the path in the object \code{output(WF)}
WF <- output_update(WF, dir=FALSE, replace=TRUE, extension=c(".sam", ".bam"))

## Alignment stats
read_statsDF <- alignStats(WF) 
read_statsDF <- cbind(read_statsDF[targets$FileName,], targets)
write.table(read_statsDF, "results/alignStats.xls", row.names=FALSE, 
                quote=FALSE, sep="\t")
}
}
\keyword{ utilities }

\name{plotfeaturetypeCounts}
\alias{plotfeaturetypeCounts}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Plot read distribution across genomic features
}
\description{
Function to visualize the distribution of reads across different feature types
for many alignment files in parallel. The plots are stacked bar plots
representing the raw or normalized read counts for the sense and antisense
strand of each feature. The graphics results are generated with
\code{ggplot2}. Typically, the expected input is generated with the
affiliated \code{featuretypeCounts} function. 
}
\usage{
plotfeaturetypeCounts(x, graphicsfile, graphicsformat = "pdf", scales = "fixed", anyreadlength = FALSE, 
                      drop_N_total_aligned = TRUE, scale_count_val = 10^6, scale_length_val = NULL)
}
\arguments{
  \item{x}{
\code{data.frame} with feature counts generated by the \code{featuretypeCounts}
function.
}
  \item{graphicsfile}{
Path to file where to write the output graphics. Note, the function returns
the graphics instructions from \code{ggplot2} for interactive plotting in R.
However, due to the complexity of the graphics generated here, the finished results
are written to a file directly. 
}
  \item{graphicsformat}{
Graphics file format. Currently, supported formats are: pdf, png or jpeg.
Argument accepts one of them as character string. 
}
  \item{scales}{
Scales setting passed on to the \code{facet_wrap} function of \code{ggplot2}. 
For details see \code{ggplot2::facet_wrap}. The default \code{fixed} assures a
constant scale across all bar plot panels, while \code{free} uses the optimum
scale within each bar plot panel. To evaluate plots in all their details, it
may be necessary to generate two graphics files one for each scaling option. 
}
  \item{anyreadlength}{
If set to \code{TRUE} read length specific read counts will be summed up to 
a single count value to plot read counts for any read length. Otherwise 
the bar plots will show the counts for each read length value.
}
  \item{drop_N_total_aligned}{
If set to \code{TRUE} the special feature count \code{N_total_aligned} 
will not be included as a separate feature in the plots. However, the 
information will still be used internally for scaling the read counts
to a fixed value if this option is requested under the 
\code{scale_count_val} argument.
}
  \item{scale_count_val}{
Scales (normalizes) the read counts to a fixed value of aligned reads
in each sample such as counts per million aligned reads (default is 10^6). 
For this calculation the \code{N_total_aligned} values are used that are 
reported in the input \code{data.frame} generated by the upstream 
\code{featuretypeCounds} function. Assign \code{NULL} to turn off
scaling by aligned reads. 
}
  \item{scale_length_val}{
Allows to adjust the raw or scaled read counts to a constant length interval
(e.g. \code{scale_length_val=10^3} in bps) considering the total genomic length 
of the corresponding feature type. The required genomic length information for 
each feature type is obtained from the \code{Featuretypelength} column of the 
input \code{data.frame} generated by the \code{featuretypeCount} function. To 
turn off feature length adjustment, assign \code{NULL} (default).
}
}
\value{
The function returns bar plot graphics for aligned read counts with read
length resolution if the input contains this information and argument
\code{anyreadlength} is set to \code{FALSE}. If the input contains counts for
any read length and/or \code{anyreadlength=TRUE} then there will be only one
bar per feature and sample. Due to the complexity of the plots, the results
are directly written to file in the chosen graphics format. However, the
function also returns the plotting instructions returned by \code{ggplot2} to
display the result components using R's plotting device.
}
\author{
Thomas Girke
}

\seealso{
\code{featuretypeCounts}, \code{genFeatures}
}
\examples{
## Construct SYSargs2 object from param and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args

\dontrun{
## Run alignments
args <- runCommandline(args, dir = FALSE, make_bam = TRUE)
outpaths <- subsetWF(args, slot = "output", subset = 1, index = 1)

## Features from sample data of systemPipeRdata package
library(txdbmaker)
file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")
feat <- genFeatures(txdb, featuretype="all", reduce_ranges=TRUE, upstream=1000, downstream=0, verbose=TRUE)

## Generate and plot feature counts for specific read lengths
fc <- featuretypeCounts(bfl=BamFileList(outpaths, yieldSize=50000), grl=feat, singleEnd=TRUE, readlength=c(74:76,99:102), type="data.frame")
p <- plotfeaturetypeCounts(x=fc, graphicsfile="featureCounts.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=FALSE)

## Generate and plot feature counts for any read length  
fc2 <- featuretypeCounts(bfl=BamFileList(outpaths, yieldSize=50000), grl=feat, singleEnd=TRUE, readlength=NULL, type="data.frame")
p2 <- plotfeaturetypeCounts(x=fc2, graphicsfile="featureCounts2.pdf", graphicsformat="pdf", scales="fixed", anyreadlength=TRUE)
}
}
\keyword{ utilities }

\name{addAssay-methods}
\alias{addAssay-methods}
\alias{addAssay,SummarizedExperiment-method}
\alias{addMetadata-methods}
\alias{addMetadata,SummarizedExperiment-method}
\alias{addAssay}
\alias{addMetadata}

\title{Extension accessor methods for SummarizedExperiment object}
\description{
Accessors for adding new data to the 'assay' and 'metadata' slot of a SummarizedExperiment object
}
\usage{
addAssay(x, ...)
addMetadata(x, ...)
}
\arguments{
  \item{x}{
	Object of class \code{SummarizedExperiment}. 
}
  \item{...}{
	dots, name of the object. 
}
}
\section{Methods}{
\describe{
   \item{addAssay}{\code{signature(x = "SummarizedExperiment")}: add new dataset to \code{assays} slot }
    \item{addMetadata}{\code{signature(x = "SummarizedExperiment")}: add new dataset to \code{metadata} slot }
}
}
\author{
Daniela Cassol
}
\keyword{methods}

\name{writeTargetsout}
\alias{writeTargetsout}
\title{
Write updated targets out to file
}
\description{
Convenience write function for generating targets files with updated
\code{FileName} columns containing the paths to files generated
by input/output processes. These processes can be commandline- or R-based software.
Typically, the paths to the inputs are stored in the targets infile 
(\code{targetsin(args)} for \code{SYSargs} objects or \code{targets.as.df(targets(WF))} 
for \code{SYSargs2} objects) and the outputs are stored in the targets outfile 
(\code{targetsout(args)} for \code{SYSargs} objects or \code{output(WF)}) for 
\code{SYSargs2} objects. Note: by default the function cannot overwrite 
any existing files. If a file exists then the user has to explicitly 
remove it or set \code{overwrite=TRUE}. 
}
\usage{
writeTargetsout(x, file = "default", silent = FALSE, overwrite = FALSE, step = NULL, new_col=NULL, new_col_output_index=NULL, remove=FALSE, ...)
}
\arguments{
  \item{x}{
Object of class \code{SYSargs} or \code{SYSargs2}.
}
  \item{file}{
Name and path of the output file. If set to "default" then the name of the output file will have the pattern 'targets_<software>.txt', where <software> will be what \code{software(x)} returns, when \code{x} is an object of class \code{SYSargs}. For an object of class \code{SYSargs2}, the output file will have the pattern 'targets_<software>_<step>.txt', where <software> will be the workflow name (\code{files(x)$cwl}) and <step> will be the step chosen in the argument \code{step}.
}
  \item{silent}{
If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{overwrite}{
If set to \code{TRUE}, existing files of same name will be overwritten.
}
  \item{step}{
Name or numeric position of the step in the workflow to write the output files. The names can be check running \code{names(x$clt)}.
}
  \item{new_col}{
A vector of character strings of the new column name to add to target file.
}
  \item{new_col_output_index}{
A vector of numeric index positions of the file in \code{SYSargs2} class \code{output}. It requires \code{new_col} definition.
}
  \item{remove}{
To remove the original columns. Default is \code{FALSE}. 
}
  \item{\dots}{
To pass on additional arguments.
}
}
\value{
Writes tabular targes files containing the header/comment lines from \code{targetsheader(x)}
and the columns from \code{targetsout(x)}. 
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
\code{writeTargetsRef}
}
\examples{
##########################################
## Examples with \code{SYSargs2} object ##
##########################################
## Construct SYSargs2 object 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF
## Write targets out file
names(WF$clt)
writeTargetsout(x=WF, file="default", step=1, new_col=c("sam_file"), new_col_output_index=c(1))

}
\keyword{ utilities }

\name{featureCoverage}
\alias{featureCoverage}
\title{
Genome read coverage by transcript models
}
\description{
Computes read coverage along single and multi component features based on
genomic alignments. The coverage segments of component features are spliced to
continuous ranges, such as exons to transcripts or CDSs to ORFs.  The results
can be obtained with single nucleotide resolution (e.g. around start and stop
codons) or as mean coverage of relative bin sizes, such as 100 bins for each
feature. The latter allows comparisons of coverage trends among transcripts of
variable length. The results can be obtained for single or many features (e.g.
any number of transcritpts) at once.  Visualization of the coverage results is
facilitated by a downstream \code{plotfeatureCoverage} function. 
}
\usage{
featureCoverage(bfl, grl, resizereads = NULL, readlengthrange = NULL, Nbins = 20, 
                method = mean, fixedmatrix, resizefeatures, upstream, downstream, 
                outfile, overwrite = FALSE)

}
\arguments{
  \item{bfl}{
Paths to BAM files provided as \code{BamFileList} object. The name slot of the
BAM files will be used for naming samples in the results.
}
  \item{grl}{
Genomic ranges provided as \code{GRangesList} typically generated form
\code{txdb} instances with operations like: \code{cdsBy(txdb, "tx")} or
\code{exonsBy(txdb, "tx")}. Single component features will be processed the
same way as multi component features. 
}
  \item{resizereads}{
Positive integer defining the length alignments should be resized to prior to the 
coverage calculation. \code{NULL} will omit the resizing step. 
}
  \item{readlengthrange}{
Positive integer of length 2 determining the read length range to use for
the coverage calculation. Reads falling outside of the specified length range
will be excluded from the coverage calculation. For instance,
\code{readlengthrange=c(30:40)} will base the coverage calculation on reads
between 30 to 40 bps. Assigning \code{NULL} will skip this filtering step.
}
  \item{Nbins}{
Single positive integer defining the number of segments the coverage of each
feature should be binned into in order to obtain coverage summaries of constant
length, e.g. for plotting purposes. 
}
  \item{method}{
Defines the summary statistics to use for binning. The default is \code{method=mean}.
}
  \item{fixedmatrix}{
If set to \code{TRUE}, a coverage matrix with single nucleotide resolution will be
returned for any number of transcripts centered around precise anchor points in
a genome annotation, such a stop/start codons or transcription start sites. For instance, a 
matrix with coverage information 20bps upstream and downstream of the stop/start codons can be 
obtained with \code{fixedmatrix=TRUE, upstream=20, downstream=20} along with a \code{grl} 
instance containing the CDS exon ranges required for this operation, e.g. generated 
with \code{cdsBy(txdb, "tx")}.
}
  \item{resizefeatures}{
Needs to be set to \code{TRUE} when \code{fixedmatrix=TRUE}. Internally, this will use
the \code{systemPipeR::.resizeFeature} function to extend single and multi component
features at their most left and most right end coordinates. The corresponding extension 
values are specified under the \code{upstream} and \code{downstream} arguments.
}
  \item{upstream}{
Single positive integer specifying the upstream extension length relative to the orientation
of each feature in the genome. More details are given above.
}
  \item{downstream}{
Single positive integer specifying the downstream extension length relative to the orientation
of each feature in the genome. More details are given above.
}
  \item{outfile}{
Default \code{NULL} omits writing of the results to a file. If a file name is specified then
the results are written to a tabular file. If \code{bfl} contains the paths to several BAM files
then the results will be appended to the same file where the first column specifies the
sample labels. Redirecting the results to file is particularly useful when processing large 
files of many sample where computation times can be significant.
}
  \item{overwrite}{
If set to \code{TRUE} any existing file assigned to \code{outfile} will be overwritten.
}
}
\value{
The function allows to return the following four distinct outputs. The settings to return
these instances are illustrated below in the example section.
\item{(A)}{\code{data.frame} containing binned coverage where rows are features and columns 
coverage bins. The first four columns contain (i) the sample names, (ii) the number of 
total aligned reads in the corresponding BAM files (useful for normalization), (iii) the
feature IDs, (iv) strand of the coverage. All following columns are numeric and contain
the actual coverage data for the sense and antisense strand of each feature. 
}
\item{(B)}{\code{data.frame} containing coverage with single nucleotide
resolution around anchor points such as start and stop codons. The two matrix
components are appended column-wise. To clearly distinguish the two data components, 
they are separated by a specialty column containing pipe characters. The first four 
columns are the same as described under (A). The column title for the
anchor point is 0. For instance, if the features are CDSs then the first 0 corresponds to the
first nucleotide of the start codon and the second 0 to the last nucleotide of
the stop codon. Upstream and downstream positions are indicated by negative and
positive column numbers, respectively.
} 
\item{(C)}{\code{data.frame} containing combined results of (A) and (B) where the
first set of columns contains to the coverage around the start codons, the second one
the binned coverage of the CDSs and the third one the coverage around the stop codons 
separated by the same pipe columns mentioned under (B).
}
\item{(D)}{\code{Rle} list containing the nucleotide level coverage of each feature
}
}
\author{
Thomas Girke
}
\seealso{
\code{plotfeatureCoverage}
}
\examples{
## Construct SYSargs2 object from param and targets files 
targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targetspath, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args

\dontrun{
## Features from sample data of systemPipeRdata package
library(txdbmaker)
file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")

targetspath <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targetspath, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args <- runCommandline(args, make_bam = TRUE, dir = TRUE)
outpaths <- subsetWF(args , slot="output", subset=1, index=1)
file.exists(outpaths)

## (A) Generate binned coverage for two BAM files and 4 transcripts
grl <- cdsBy(txdb, "tx", use.names=TRUE)
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=20, method=mean, fixedmatrix=FALSE, 
                    resizefeatures=TRUE, upstream=20, downstream=20,
                    outfile="results/featureCoverage.xls", overwrite=TRUE)
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (B) Coverage matrix upstream and downstream of start/stop codons
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=NULL, method=mean, fixedmatrix=TRUE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/featureCoverage_up_down.xls", overwrite=TRUE)
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (C) Combined matrix for both binned and start/stop codon 
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=20, method=mean, fixedmatrix=TRUE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/featureCoverage_binned.xls", overwrite=TRUE)
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (D) Rle coverage objects one for each query feature
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=NULL, method=mean, fixedmatrix=FALSE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/featureCoverage_query.xls", overwrite=TRUE)
}
}
\keyword{ utilities }

\name{vennPlot}
\alias{vennPlot}
\title{
Plot 2-5 way Venn diagrams
}
\description{
Ploting function of 2-5 way Venn diagrams from 'VENNset' objects or count set
vectors. A useful feature is the possiblity to combine the counts from several
Venn comparisons with the same number of label sets in a single Venn diagram.
}
\usage{
vennPlot(x, mymain = "Venn Diagram", mysub = "default", setlabels = "default", yoffset = seq(0, 10, by = 0.34), ccol = rep(1, 31), colmode = 1, lcol = c("#FF0000", "#008B00", "#0000FF", "#FF00FF", "#CD8500"), lines = c("#FF0000", "#008B00", "#0000FF", "#FF00FF", "#CD8500"), mylwd = 3, diacol = 1, type = "ellipse", ccex = 1, lcex = 1, sepsplit = "_", ...)
}
\arguments{
  \item{x}{
\code{VENNset} or list of \code{VENNset} objects. Alternatively, a
\code{vector} of Venn counts or a \code{list} of vectors of Venn counts can be
provided as input. If several Venn comparisons are provided in a \code{list} 
then their results are combined in a single Venn diagram, where the count sets
are organized above each other.}
  \item{mymain}{
Main title of plot.
}
  \item{mysub}{
Subtitle of plot. Default \code{mysub="default"} reports the number of unique
items in all sets, as well as the number of unique items in each individual set,
respectively.
}
  \item{setlabels}{
The argument \code{setlabels} allows to provide a vector of custom sample labels.
However, assigning the proper names in the name slots of the initial \code{setlist} 
is preferred for tracking purposes.
}
  \item{yoffset}{
The results from several Venn comparisons can be combined in a single Venn diagram 
by assigning to \code{x} a \code{list} with several \code{VENNsets} or count vectors. 
The positonal offset of the count sets in the plot can be controlled with the 
\code{yoffset} argument. The argument setting \code{colmode} allows to assign 
different colors to each count set. For instance, with \code{colmode=2} one can 
assign to \code{ccol} a color vector or a list, such as \code{ccol=c("blue", "red")}
 or \code{ccol=list(1:8, 8:1)}.
}
  \item{ccol}{
Character or numeric \code{vector} to define colors of count values, e.g. 
\code{ccol=c("black","black","red")}.
}
  \item{colmode}{
See argument \code{yoffset}.
}
  \item{lcol}{
Character or numeric \code{vector} to define colors of set labels, e.g. 
\code{lcol=c("red", "green")}
}
  \item{lines}{
Character or numeric \code{vector} to define colors of lines in plot. 
}
  \item{mylwd}{
Defines line width of shapes used in plot. 
}
  \item{diacol}{
See argument \code{type}.
}
  \item{type}{
Defines shapes used to plot 4-way Venn diagram. Default \code{type="ellipse"} uses
ellipses. The setting \code{type="circle"} returns an incomplete 4-way Venn diagram as 
circles. This representation misses two overlap sectors, but is sometimes easier to 
navigate than the default ellipse version. The missing Venn intersects are reported
below the Venn diagram. Their font color can be controled with the argument \code{diacol}.
}
  \item{ccex}{
Controls font size for count values.
}
  \item{lcex}{
Controls font size for set labels.
}
  \item{sepsplit}{
Character used to separate sample labels in Venn counts.
}
  \item{\dots}{
Additional arguments to pass on.
}
}
\value{
Venn diagram plot.
}
\references{
See examples in 'The Electronic Journal of Combinatorics':
http://www.combinatorics.org/files/Surveys/ds5/VennSymmExamples.html
}
\author{
Thomas Girke
}
\note{
The functions provided here are an extension of the Venn diagram resources on this 
site: http://manuals.bioinformatics.ucr.edu/home/R_BioCondManual#TOC-Venn-Diagrams
}

\seealso{
\code{overLapper}, \code{olBarplot}
}
\examples{
## Sample data
setlist <- list(A=sample(letters, 18), B=sample(letters, 16),
                C=sample(letters, 20), D=sample(letters, 22),
                E=sample(letters, 18), F=sample(letters, 22))

## 2-way Venn diagram
vennset <- overLapper(setlist[1:2], type="vennsets")
vennPlot(vennset)

## 3-way Venn diagram
vennset <- overLapper(setlist[1:3], type="vennsets")
vennPlot(vennset)

## 4-way Venn diagram
vennset <- overLapper(setlist[1:4], type="vennsets")
vennPlot(list(vennset, vennset))

## Pseudo 4-way Venn diagram with circles
vennPlot(vennset, type="circle")

## 5-way Venn diagram
vennset <- overLapper(setlist[1:5], type="vennsets")
vennPlot(vennset)

## Alternative Venn count input to vennPlot (not recommended!)
counts <- sapply(vennlist(vennset), length)
vennPlot(counts)

## 6-way Venn comparison as bar plot
vennset <- overLapper(setlist[1:6], type="vennsets")
olBarplot(vennset, mincount=1)

## Bar plot of standard intersect counts
interset <- overLapper(setlist, type="intersects")
olBarplot(interset, mincount=1)

## Accessor methods for VENNset/INTERSECTset objects
names(vennset)
names(interset)
setlist(vennset)
intersectmatrix(vennset)
complexitylevels(vennset)
vennlist(vennset)
intersectlist(interset)

## Coerce VENNset/INTERSECTset object to list
as.list(vennset)
as.list(interset)

## Pairwise intersect matrix and heatmap
olMA <- sapply(names(setlist), 
		function(x) sapply(names(setlist), 
		function(y) sum(setlist[[x]] \%in\% setlist[[y]])))
olMA
heatmap(olMA, Rowv=NA, Colv=NA)

## Presence-absence matrices for large numbers of sample sets
interset <- overLapper(setlist=setlist, type="intersects", complexity=2)
(paMA <- intersectmatrix(interset))
heatmap(paMA, Rowv=NA, Colv=NA, col=c("white", "gray")) 
}
\keyword{ utilities }

\name{GOHyperGAll}
\alias{GOHyperGAll}
\alias{GOHyperGAll_Subset}
\alias{GOHyperGAll_Simplify}
\alias{GOCluster_Report}
\alias{makeCATdb}
\alias{goBarplot}
\title{
	GO term enrichment analysis for large numbers of gene sets 
}
\description{
To test a sample population of genes for over-representation of GO terms, the
core function \code{GOHyperGAll} computes for all nodes in the three GO networks
(BP, CC and MF) an enrichment test based on the hypergeometric distribution and 
returns the corresponding raw and Bonferroni corrected p-values. 
Subsequently, a filter function supports GO Slim analyses using default or 
custom GO Slim categories. Several convenience functions are provided to process
large numbers of gene sets (e.g. clusters from partitioning results) and to 
visualize the results. 

Note: \code{GOHyperGAll} provides similar utilities as the \code{GOHyperG}
function in the \code{GOstats} package. The main difference is that
\code{GOHyperGAll} simplifies processing of large numbers of gene sets, as well
as the usage of custom array-to-gene and gene-to-GO mappings.
}
\usage{
## Generate gene-to-GO mappings and store as catDB object 
makeCATdb(myfile, lib = NULL, org = "", colno = c(1, 2, 3), idconv = NULL, 
            rootUK=FALSE)

## Enrichment function
GOHyperGAll(catdb, gocat = "MF", sample, Nannot = 2)

## GO slim analysis
GOHyperGAll_Subset(catdb, GOHyperGAll_result, sample = test_sample, 
            type = "goSlim", myslimv)

## Reduce GO term redundancy 
GOHyperGAll_Simplify(GOHyperGAll_result, gocat = "MF", cutoff = 0.001, correct = TRUE)

## Batch analysis of many gene sets
GOCluster_Report(catdb, setlist, id_type = "affy", method = "all", CLSZ = 10, 
            cutoff = 0.001, gocats = c("MF", "BP", "CC"), myslimv = "default",
            correct = TRUE, recordSpecGO = NULL, ...)

## Bar plot of GOCluster_Report results
goBarplot(GOBatchResult, gocat)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{myfile}{
	File with gene-to-GO mappings. Sample files can be downloaded from geneontology.org (http://geneontology.org/GO.downloads.annotations.shtml) or from BioMart as shown in example below.
}
  \item{colno}{
	Column numbers referencing in \code{myfile} the three target columns containing GOID, GeneID and GOCAT, in that order.
}
  \item{org}{
	Optional argument. Currently, the only valid option is \code{org="Arabidopsis"} to get rid of transcript duplications in this particular annotation. 
}
  \item{lib}{
	If the gene-to-GO mappings are obtained from a \code{*.db} package from Bioconductor then the package name can be specified under the \code{lib} argument of the \code{sampleDFgene2GO} function. 
}
  \item{idconv}{
	Optional id conversion \code{data.frame}
}
  \item{catdb}{
	\code{catdb} object storing mappings of genes to annotation categories. For details, see ?"SYSargs-class".
}
  \item{rootUK}{
	If the argument \code{rootUK} is set to \code{TRUE} then the root nodes are treated as terminal nodes to account for the new unknown terms.
}
  \item{sample}{
	\code{character vector} containing the test set of gene identifiers 
}
  \item{Nannot}{
	Defines the minimum number of direct annotations per GO node from the sample 
        set to determine the number of tested hypotheses for the p-value adjustment.  
}
  \item{gocat}{
	Specifies the GO type, can be assigned one of the following character values: "MF", "BP" and "CC". 
}
  \item{GOHyperGAll_result}{
	\code{data.frame} generated by \code{GOHyperGAll}
}
  \item{type}{
	The function \code{GOHyperGAll_Subset} subsets the \code{GOHyperGAll}
	results by directly assigned GO nodes or custom \code{goSlim} categories. 
	The argument \code{type} can be assigned the values \code{goSlim} or \code{assigned}.
}
  \item{myslimv}{
	optional argument to provide custom \code{goSlim} vector
}
  \item{cutoff}{
	p-value cutoff for GO terms to show in result \code{data.frame}
}
  \item{correct}{
	If \code{TRUE} the function will favor the selection of terminal (informationich) 
        GO terms that have at the same time a large number of sample matches. 
}
  \item{setlist}{
	\code{list} of \code{character vectors} containing gene IDs (or array feature 
	IDs). The names of the \code{list} components correspond to the set labels, 
	e.g. DEG comparisons or cluster IDs.
}
  \item{id_type}{
	specifies type of IDs in input, can be assigned \code{gene} or \code{affy}
}
  \item{method}{
	Specifies analysis type. Current options are \code{all} for \code{GOHyperGAll}, 
	\code{slim} for \code{GOHyperGAll_Subset} or \code{simplify} for 
	\code{GOHyperGAll_Simplify}.
}
  \item{CLSZ}{
	minimum gene set (cluster) size to consider. Gene sets below this cutoff 
	will be ignored.
}
  \item{gocats}{
	Specifies GO type, can be assigned the values "MF", "BP" and "CC". 
}
  \item{recordSpecGO}{
	argument to report in the result \code{data.frame} specific GO IDs for any 
	of the 3 ontologies disregarding whether they meet the specified p-value \code{cutoff}, e.g: \code{recordSpecGO=c("GO:0003674", "GO:0008150", "GO:0005575")} 
}
  \item{GOBatchResult}{
	\code{data.frame} generated by \code{GOCluster_Report}
}
  \item{\dots}{
	additional arguments to pass on
}
}
\details{
	\code{GOHyperGAll_Simplify}: The result data frame from \code{GOHyperGAll}
	will often contain several connected GO terms with significant scores which 
	can complicate the interpretation of large sample sets. To reduce this redundancy,
	the function \code{GOHyperGAll_Simplify} subsets the data frame
	by a user specified p-value cutoff and removes from it all GO nodes with 
        overlapping children sets (OFFSPRING), while the best scoring nodes are 
	retained in the result \code{data.frame}.

	\code{GOCluster_Report}: performs the three types of GO term enrichment 
	analyses in batch mode: \code{GOHyperGAll}, \code{GOHyperGAll_Subset} or 
	\code{GOHyperGAll_Simplify}. It processes many gene sets (e.g. gene expression 
        clusters) and returns the results conveniently organized in a single result data frame.
}
\value{
	\code{makeCATdb} generates \code{catDB} object from file. 
}
\references{
This workflow has been published in Plant Physiol (2008) 147, 41-57.
}
\author{
Thomas Girke
}
\seealso{
\code{GOHyperGAll_Subset}, \code{GOHyperGAll_Simplify}, \code{GOCluster_Report}, \code{goBarplot}
}
\examples{
\dontrun{

## Obtain annotations from BioMart
listMarts() # To choose BioMart database
m <- useMart("ENSEMBL_MART_PLANT"); listDatasets(m) 
m <- useMart("ENSEMBL_MART_PLANT", dataset="athaliana_eg_gene")
listAttributes(m) # Choose data types you want to download
go <- getBM(attributes=c("go_accession", "tair_locus", 
            "go_namespace_1003"), mart=m)
go <- go[go[,3]!="",]; go[,3] <- as.character(go[,3])
write.table(go, "GOannotationsBiomart_mod.txt", quote=FALSE, 
            row.names=FALSE, col.names=FALSE, sep="\t")

## Create catDB instance (takes a while but needs to be done only once)
catdb <- makeCATdb(myfile="GOannotationsBiomart_mod.txt", lib=NULL, org="",
                    colno=c(1,2,3), idconv=NULL)
catdb

## Create catDB from Bioconductor annotation package
# catdb <- makeCATdb(myfile=NULL, lib="ath1121501.db", org="", 
                    colno=c(1,2,3), idconv=NULL)

## AffyID-to-GeneID mappings when working with AffyIDs 
# affy2locusDF <- systemPipeR:::.AffyID2GeneID(map = "ftp://ftp.arabidopsis.org/home/tair/Microarrays/Affymetrix/affy_ATH1_array_elements-2010-12-20.txt",
                                                download=TRUE)
# catdb_conv <- makeCATdb(myfile="GOannotationsBiomart_mod.txt", lib=NULL, org="", 
                            colno=c(1,2,3), idconv=list(affy=affy2locusDF))
# systemPipeR:::.AffyID2GeneID(catdb=catdb_conv, 
                                affyIDs=c("244901_at", "244902_at"))

## Next time catDB can be loaded from file
save(catdb, file="catdb.RData") 
load("catdb.RData")

## Perform enrichment test on single gene set
test_sample <- unique(as.character(catmap(catdb)$D_MF[1:100,"GeneID"]))
GOHyperGAll(catdb=catdb, gocat="MF", sample=test_sample, Nannot=2)[1:20,]

## GO Slim analysis by subsetting results accordingly
GOHyperGAll_result <- GOHyperGAll(catdb=catdb, gocat="MF", sample=test_sample, Nannot=2)
GOHyperGAll_Subset(catdb, GOHyperGAll_result, sample=test_sample, type="goSlim") 

## Reduce GO term redundancy in 'GOHyperGAll_results'
simplifyDF <- GOHyperGAll_Simplify(GOHyperGAll_result, gocat="MF", 
                                    cutoff=0.001, correct=T)
# Returns the redundancy reduced data set. 
data.frame(GOHyperGAll_result[GOHyperGAll_result[,1] %in% simplifyDF[,1], -8], GO_OL_Match=simplifyDF[,2])

## Batch Analysis of Gene Clusters
testlist <- list(Set1=test_sample)
GOBatchResult <- GOCluster_Report(catdb=catdb, setlist=testlist, method="all", 
                                    id_type="gene", CLSZ=10, cutoff=0.001, 
                                    gocats=c("MF", "BP", "CC"), 
                                    recordSpecGO=c("GO:0003674", "GO:0008150", "GO:0005575"))

## Plot 'GOBatchResult' as bar plot
goBarplot(GOBatchResult, gocat="MF")

}
}
\keyword{utilities}

\docType{package}
\name{systemPipeR-package}
\alias{systemPipeR-package}
\title{systemPipeR package for Workflow Environment}
\description{
The systemPipeR package provides a suite of R/Bioconductor for designing, building 
and running end-to-end analysis workflows on local machines, HPC clusters and cloud 
systems, while generating at the same time publication quality analysis reports.

For detailed information on usage, see the package vignette, by typing
vignette("systemPipeR"), or more information on the project here: https://systempipe.org/spr

All software-related questions should be posted to the Bioconductor Support Site: https://support.bioconductor.org

The code can be viewed at the GitHub repository: https://github.com/tgirke/systemPipeR
}
\references{
Backman TWH, Girke T (2016) systemPipeR: NGS workflow and report generation 
environment. BMC Bioinformatics 17 (1). https://doi.org/10.1186/s12859-016-1241-0
}
\author{
Daniela Cassol, Tyler Backman, Thomas Girke
}
\keyword{package}

\name{plotfeatureCoverage}
\alias{plotfeatureCoverage}
\title{
Plot feature coverage results
}
\description{
Plots the 3 tabular data types (A-C) generated by the \code{featureCoverage} 
function. It accepts data from single or many features (e.g. CDSs) and
samples (BAM files). The coverage from multiple features will be summarized
using methods such as \code{mean}, while the data from multiple samples will 
be plotted in separate panels.  
}
\usage{
plotfeatureCoverage(covMA, method = mean, scales = "fixed", extendylim=2, 
                    scale_count_val = 10^6)
}
\arguments{
  \item{covMA}{
Object of class \code{data.frame} generated by \code{featureCoverage} function.
}
  \item{method}{
Defines the summary statistics to use when \code{covMA} contains coverage 
data from  multiple features (e.g. transcripts). The default calculates the 
mean coverage for each positon and/or bin of the corresponding coverage 
vectors.
}
  \item{scales}{
Scales setting passed on to the \code{facet_wrap} function of \code{ggplot2}. 
For details see \code{ggplot2::facet_wrap}. The default \code{fixed} assures a
constant scale across all bar plot panels, while \code{free} uses the optimum
scale within each bar plot panel. To evaluate plots in all their details, it
may be necessary to generate two graphics files one for each scaling option. 
}
  \item{extendylim}{
 Allows to extend the upper limit of the y axis when \code{scales=fixed}. Internally, the 
function identifies the maximum value in the data and then multiplies this maximum value 
by the value provided under \code{extendylim}. The default is set to \code{extendylim=2}.
}
  \item{scale_count_val}{
Scales (normalizes) the read counts to a fixed value of aligned reads
in each sample such as counts per million aligned reads (default is 10^6). 
For this calculation the \code{N_total_aligned} values are used that are 
reported in the input \code{data.frame} generated by the upstream 
\code{featureCoverage} function. Assign \code{NULL} to turn off
scaling. 
}
}
\value{
Currently, the function returns ggplot2 bar plot graphics. 
}
\author{
Thomas Girke
}
\seealso{
\code{featureCoverage}
}
\examples{
## Construct SYSargs2 object from param and targets files 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
args <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
args <- renderWF(args, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
args

\dontrun{
## Run alignments
args <- runCommandline(args, dir = FALSE, make_bam = TRUE)
outpaths <- subsetWF(args, slot = "output", subset = 1, index = 1)

## Features from sample data of systemPipeRdata package
library(txdbmaker)
file <- system.file("extdata/annotation", "tair10.gff", package="systemPipeRdata")
txdb <- makeTxDbFromGFF(file=file, format="gff3", organism="Arabidopsis")

## (A) Generate binned coverage for two BAM files and 4 transcripts
grl <- cdsBy(txdb, "tx", use.names=TRUE)
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=20, method=mean, fixedmatrix=FALSE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/featureCoverage.xls")
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (B) Coverage matrix upstream and downstream of start/stop codons
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=NULL, method=mean, fixedmatrix=TRUE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/featureCoverage_UpDown.xls")
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (C) Combined matrix for both binned and start/stop codon 
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=20, method=mean, fixedmatrix=TRUE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/test.xls")
plotfeatureCoverage(covMA=fcov, method=mean, scales="fixed", scale_count_val=10^6)

## (D) Rle coverage objects one for each query feature
fcov <- featureCoverage(bfl=BamFileList(outpaths[1:2]), grl=grl[1:4], resizereads=NULL, 
                    readlengthrange=NULL, Nbins=NULL, method=mean, fixedmatrix=FALSE, 
                    resizefeatures=TRUE, upstream=20, downstream=20, 
                    outfile="results/RleCoverage.xls")
}
}

\keyword{ utilities }

\name{runDiff}
\alias{runDiff}
\title{
Differential abundance analysis for many range sets
}
\description{
Convenience wrapper function for \code{run_edgeR} and \code{run_DESeq2} to
perform differential expression or abundance analysis iteratively for several
count tables. The latter can be peak calling results for several samples or
counts generated for different genomic feature types. The function also returns 
the filtering results and plots from \code{filterDEGs}. 
}
\usage{
runDiff(args, outfiles=NULL, diffFct, targets, cmp, dbrfilter, ...)
}
\arguments{
  \item{args}{
    An instance of \code{SYSargs} or \code{SYSargs2} constructed from a
    \code{targets} file where the first column (\code{targetsin(args)} or 
    \code{targets.as.df(targets(args))}) contains the paths to the  tabular 
    read count data files. Another possibily is \code{named character vector}
    with the paths to the tabular range data files and the elements names should
    be the sampleID.
}
  \item{outfiles}{
    Default is \code{NULL}. When \code{args} is an object of \code{named 
    character vector} class, \code{outfile} argument is required. 
    \code{Named character vector} with the paths to the resulting count tables
    and the elements names should be the sampleID.
}
  \item{diffFct}{
    Defines which function should be used for the differential abundance analysis.
    Can be \code{diffFct=run_edgeR} or \code{diffFct=run_DESeq2}.
}
  \item{targets}{
    targets \code{data.frame}
}
  \item{cmp}{
    \code{character matrix} where comparisons are defined in two columns. This matrix should be generated with \code{readComp()} from the targets file. Values used for comparisons need to match those in the \code{Factor} column of the targets file.
}
  \item{dbrfilter}{
    Named vector with filter cutoffs of format \code{c(Fold=2, FDR=1)} where \code{Fold} refers to the fold change cutoff (unlogged) and \code{FDR} to the p-value cutoff. Those values are passed on to the \code{filterDEGs} function.
}
  \item{\dots}{
    Arguments to be passed on to the internally used \code{run_edgeR} or 
    \code{run_DESeq2} function.
}
}
\value{
Returns \code{list} containing the \code{filterDEGs} results for each
count table. Each result set is a \code{list} with four components 
which are described under \code{?filterDEGs}. The result files
contain the \code{edgeR} or \code{DESeq2} results from the comparisons
specified under \code{cmp}. The base names of the result files are the 
same as the corresponding input files specified under \code{countfiles} 
and the value of \code{extension} appended. 
}
\author{
Thomas Girke
}
\seealso{
\code{run_edgeR}, \code{run_DESeq2}, \code{filterDEGs}
}
\examples{
## Paths to BAM files
param <- system.file("extdata", "bowtieSE.param", package="systemPipeR")
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
args_bam <- systemArgs(sysma=param, mytargets=targets)
bfl <- BamFileList(outpaths(args_bam), yieldSize=50000, index=character())

\dontrun{
## SYSargs with paths to range data and count files
args <- systemArgs(sysma="param/count_rangesets.param", mytargets="targets_macs.txt")

## Iterative read counting
countDFnames <- countRangeset(bfl, args, mode="Union", ignore.strand=TRUE)
writeTargetsout(x=args, file="targets_countDF.txt", overwrite=TRUE)

## Run differential abundance analysis
cmp <- readComp(file=args_bam, format="matrix")
args_diff <- systemArgs(sysma="param/rundiff.param", mytargets="targets_countDF.txt")
dbrlist <- runDiff(args, diffFct=run_edgeR, targets=targetsin(args_bam), cmp=cmp[[1]], independent=TRUE, dbrfilter=c(Fold=2, FDR=1))
writeTargetsout(x=args_diff, file="targets_rundiff.txt", overwrite=TRUE)
}
}
\keyword{ utilities }

\name{subsetWF}
\alias{subsetWF}

\title{
Subsetting SYSargs2 class slots  
}
\description{
Return subsets of \code{character} for the \code{input}, \code{output} or the list of command-line for each workflow \code{step}.
}
\usage{
subsetWF(args, slot, subset=NULL, index=NULL, delete=FALSE)
}
\arguments{
  \item{args}{
	object of class \code{SYSargs2}.
}
  \item{slot}{
  three options available: \code{type="input"} returns input slot from \code{SYSargs2} object; \code{type="output"} returns output slot from \code{SYSargs2} object; and \code{type="step"} returns all the command-line for each workflow step from \code{SYSargs2} object.
}
  \item{subset}{
  name or numeric position of the values to be subsetting in the \code{slot}. If \code{slot="input"}, the \code{subset} are the variables defined in the \code{param.yml} file. If \code{slot="step"}, the \code{subset} is the command line defined on the \code{SYSargs2} object for all the steps of the workflow. If \code{slot="output"}, the \code{subset} is the path for the expected output files for all the steps in the workflow. Default is \code{subset=NULL}
}
  \item{index}{
  A numeric index positions of the file in \code{SYSargs2} object, slot \code{output}. It requires a \code{subset} to be defined. Default is \code{index=NULL}.
}
  \item{delete}{
  allows to delete a subset of files in the case of \code{slot="output"}. Default is \code{delete=NULL}.
}
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
\code{loadWorkflow}
\code{renderWF}
}
\examples{
## Construct SYSargs2 object 
targets <- system.file("extdata", "targets.txt", package="systemPipeR")
dir_path <- system.file("extdata/cwl", package="systemPipeR")
WF <- loadWorkflow(targets=targets, wf_file="hisat2/hisat2-mapping-se.cwl", 
                  input_file="hisat2/hisat2-mapping-se.yml", dir_path=dir_path)
WF <- renderWF(WF, inputvars=c(FileName="_FASTQ_PATH1_", SampleName="_SampleName_"))
WF

## Testing subset_wf function
input <- subsetWF(WF, slot="input", subset='FileName')
output <- subsetWF(WF, slot="output", subset=1, index=1)
step.cmd <- subsetWF(WF, slot="step", subset=1) ## subset all the HISAT2 commandline 
# subsetWF(WF, slot="output", subset=1, index=1, delete=TRUE) ## in order to delete the subset files list
}
\keyword{ utilities }

\name{SYSargsList-class}
\Rdversion{1.1}
\docType{class}
\alias{SYSargsList-class}
% Accessors
\alias{stepsWF}
\alias{stepsWF,SYSargsList-method}
\alias{statusWF}
\alias{statusWF,SYSargsList-method}
\alias{targetsWF}
\alias{targetsWF,SYSargsList-method}
\alias{outfiles}
\alias{outfiles,SYSargsList-method}
\alias{SE}
\alias{SE,SYSargsList-method}
\alias{dependency}
\alias{dependency,SYSargsList-method}
\alias{targets_connection}
\alias{targets_connection,SYSargsList-method}
\alias{projectInfo}
\alias{projectInfo,SYSargsList-method}
\alias{runInfo}
\alias{runInfo,SYSargsList-method}
% Subsetting and Quick access
\alias{[,SYSargsList,ANY,ANY,ANY-method}
\alias{[[,SYSargsList,ANY,missing-method}
\alias{$,SYSargsList-method}
\alias{names,SYSargsList-method}
\alias{show,SYSargsList-method}
\alias{length,SYSargsList-method}
% Coercion
\alias{coerce,list,SYSargsList-method}
\alias{coerce,SYSargsList,list-method}
\alias{sysargslist}
\alias{sysargslist,SYSargsList-method}
% Methods 
\alias{subset}
\alias{subset,SYSargsList-method}
\alias{getColumn}
\alias{getColumn,SYSargsList-method}
\alias{baseCommand}
\alias{baseCommand,SYSargsList-method}
\alias{SampleName}
\alias{SampleName,SYSargsList-method}
\alias{stepName}
\alias{stepName,SYSargsList-method}
\alias{targetsheader}
\alias{targetsheader,SYSargsList-method}
\alias{yamlinput}
\alias{yamlinput,SYSargsList-method}
\alias{addResources}
\alias{addResources,SYSargsList-method}
% Methods LineWise
\alias{codeLine}
\alias{codeLine,SYSargsList-method}
\alias{copyEnvir}
\alias{copyEnvir,SYSargsList-method}
\alias{viewEnvir}
\alias{viewEnvir,SYSargsList-method}
\alias{cmdlist}
\alias{cmdlist,SYSargsList-method}
% Replacement Methods
\alias{[[<-,SYSargsList,ANY,ANY,ANY-method}
\alias{[[<-,SYSargsList,ANY,ANY-method}
\alias{appendStep<-}
\alias{appendStep<-,SYSargsList-method}
\alias{yamlinput<-}
\alias{yamlinput<-,SYSargsList-method}
\alias{replaceStep<-}
\alias{replaceStep<-,SYSargsList-method}
\alias{renameStep<-}
\alias{renameStep<-,SYSargsList-method}
\alias{dependency<-}
\alias{dependency<-,SYSargsList-method}
\alias{appendCodeLine<-}
\alias{appendCodeLine<-,SYSargsList-method}
\alias{replaceCodeLine<-}
\alias{replaceCodeLine<-,SYSargsList-method}
\alias{updateColumn<-}
\alias{updateColumn<-,SYSargsList-method}
\alias{SE<-}
\alias{SE<-,SYSargsList-method}

\title{Class \code{"SYSargsList"}}
\description{
\code{SYSargsList} S4 class is a list-like container where each instance stores 
all the input/output paths and parameter components required for a particular 
data analysis step based on command-line- or R-based software.

\code{SYSargsList} instances are constructed by the \code{SYSargsList} function.
}
\usage{
## Accessors

stepsWF(x)
statusWF(x)
targetsWF(x)
outfiles(x)
SE(x, ...)
dependency(x)
projectInfo(x)
runInfo(x)

## Methods

cmdlist(x, ...)
codeLine(x, ...)
SampleName(x, ...)
stepName(x)
baseCommand(x, ...)
targetsheader(x, ...)
yamlinput(x, ...)
viewEnvir(x, silent = FALSE)
copyEnvir(x, list = character(), new.env = globalenv(), silent = FALSE)
addResources(x, step, resources)

## Subset Methods

subset(x, ...)
getColumn(x, step, position = c("outfiles", "targetsWF"), column = 1, 
          names = SampleName(x, step))

## Replacement

appendStep(x, after = length(x), ...) <- value
yamlinput(x, paramName, ...) <- value
replaceStep(x, step, step_name = "default") <- value
renameStep(x, step, ...) <- value
dependency(x, step, ...) <- value
appendCodeLine(x, after = length(x), ...) <- value
replaceCodeLine(x, line, ...) <- value
updateColumn(x, step, position = c("outfiles", "targetsWF")) <- value
}

\arguments{
  \item{x}{
  An instance of class \code{SYSargsList}.
}
  \item{step}{
  character or numeric. Workflow step name or position index.
}
  \item{silent}{
  If set to \code{TRUE}, all messages returned by the function will be suppressed.
}
  \item{list}{
  a character vector naming objects to be copyied from the enviroment.
}
  \item{new.env}{
  An environment to copy to. Default is \code{globalenv()}.
}
  \item{resources}{
  \code{List} for reserving for each cluster job sufficient computing resources
  including memory (Megabyte), number of nodes (Int), CPU cores, walltime (Minutes),
  etc. It is necessary two additional files: \code{conffile} and \code{template}. 
  \code{conffile} is the path to configuration file (default location 
  \code{./.batchtools.conf.R}). This file contains in its simplest form just one 
  command, such as this line for the scheduler: 
  \code{cluster.functions <- makeClusterFunctionsSlurm(template="batchtools.slurm.tmpl")}. 
  For more detailed information visit this page: https://mllg.github.io/batchtools/index.html.
  \code{template} The template files for a specific queueing/scheduling systems 
  can be downloaded from here: 
  https://github.com/mllg/batchtools/tree/master/inst/templates. Slurm, 
  PBS/Torque, and Sun Grid Engine (SGE) templates are provided within the package
  demo data.
}
  \item{position}{
  character. Options are \code{"outfiles" or "targetsWF"} slots.
}
  \item{column}{
  character or numeric. Which column will be subset from the \code{position}
  argument.
}
  \item{names}{
  character vector. Names of the workflow step. 
}
  \item{after}{
  A subscript, after which the values are to be appended.
}
  \item{paramName}{
  character. Input name from \code{yamlinput(x)}, which value should be replaced. 
}
  \item{step_name}{
  character with the new step name. Default value will automatically give a name:
  \code{step_<step index position>}.
}
  \item{line}{
  numeric. Index position of the code line to be added or replaced.
}
  \item{value}{
  object containing the values to be replaced to \code{SYSargsList}. Values may
  be of the same class as the orginal values. For \code{updateColumn<-} a 
  \code{DataFrame} must have the same rows as the original \code{DataFrame}.
  However, if there is no column/rows in the original \code{DataFrame}, the new
  \code{DataFrame} will replace the empty one. If there is a non-empty 
  \code{DataFrame}, any existing columns with the same name as this new 
  \code{DataFrame} will be replaced. Any columns that do not exist in the 
  original \code{DataFrame} will be added to the original \code{DataFrame}.
}
  \item{...}{
  Further arguments to be passed to or from other methods.
}
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SYSargsList", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{stepsWF}:}{Object of class \code{"list"} storing all the 
    steps objects of the workflow. Each step can either be \code{SYSargs2} or
    \code{LineWise}. }
    \item{\code{statusWF}:}{Object of class \code{"list"} storing all the 
    success and failure of each step in the workflow. }
    \item{\code{targetsWF}:}{Object of class \code{"list"} storing all the 
    targets \code{DataFrame} for each step in the workflow. For the 
    \code{LineWise} steps, a \code{DataFrame} with 0 rows and 0 columns will
    be displayed. }
    \item{\code{outfiles}:}{Object of class \code{"list"} storing all the 
    output \code{DataFrame} for each step in the workflow. For the 
    \code{LineWise} steps, a \code{DataFrame} with 0 rows and 0 columns will be
    displayed. }
    \item{\code{SE}:}{Object of class \code{"list"} storing all the 
    \code{SummarizedExperiment} objects in the workflow. }
    \item{\code{dependency}:}{Object of class \code{"list"} storing all the 
    dependency graphs in the workflow. }
    \item{\code{projectInfo}:}{Object of class \code{"list"} storing all the 
    \code{projectInfo} information of the workflow. }
    \item{\code{runInfo}:}{Object of class \code{"list"} storing all the
    \code{runInfo} information of each step in the workflow. }
    \item{\code{targets_connection}:}{Object of class \code{"list"} storing all 
    targets files connection in the workflow. }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "SYSargsList", i = "ANY", j = "ANY", drop = "ANY")}: 
              subsetting of class with bracket operator }
    \item{[[}{\code{signature(x = "SYSargsList", i = "ANY", j = "ANY")}:
              subsetting of class with bracket operator }
    \item{$}{\code{signature(x = "SYSargsList")}: 
              extracting slots elements by name }
    \item{coerce}{\code{signature(from = "list", to = "SYSargsList")}:
              \code{as(list, "SYSargsList")} }
    \item{coerce}{\code{signature(from = "SYSargsList", to = "list")}: 
              \code{as(SYSargsList, "list")} }
    \item{sysargslist}{\code{signature(x = "SYSargsList")}: Coerce back to 
              list \code{as(SYSargsList, "list")} }
    \item{length}{\code{signature(x = "SYSargsList")}: extracts number of 
              \code{SYSargsList} steps }
    \item{names}{\code{signature(x = "SYSargsList")}: extracts slot names }
    \item{show}{\code{signature(object = "SYSargsList")}: summary view of 
              \code{SYSargsList} steps }
    \item{stepsWF}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{stepsWF} slot }
    \item{statusWF}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{statusWF} slot }
    \item{targetsWF}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{targetsWF} slot }
    \item{outfiles}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{outfiles} slot }
    \item{SE}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{SE} slot }
    \item{dependency}{\code{signature(x = "SYSargsList")}: extract data from 
              \code{dependency} slot }
    \item{projectInfo}{\code{signature(x = "SYSargsList")}: extract data from
              \code{projectInfo} slot }
    \item{runInfo}{\code{signature(x = "SYSargsList")}: extract data from
              \code{runInfo} slot }
    \item{cmdlist}{\code{signature(x = "SYSargsList", ...)}: 
              extracts data from \code{cmdlist} slot for each \code{SYSargs2} 
              step }
    \item{codeLine}{\code{signature(x = "SYSargsList", step)}: 
              extracts data from \code{codeLine} slot for \code{LineWise} 
              step }
    \item{SampleName}{\code{signature(x = "SYSargsList", step)}: 
              extracts Sample ID from \code{SYSargs2} instance step }
    \item{stepName}{\code{signature(x = "SYSargsList")}: 
              extracts steps names from workflow instance }
    \item{baseCommand}{\code{signature(x = "SYSargsList", step)}: 
              extracts \code{baseCommand} from \code{SYSargs2} instance step }
    \item{targetsheader}{\code{signature(x = "SYSargsList", step)}: 
               extracts \code{targetsheader} from \code{SYSargs2} instance step }
    \item{yamlinput}{\code{signature(x = "SYSargsList", step)}: 
              extracts data from \code{yamlinput} slot for each \code{SYSargs2} 
              step }
    \item{viewEnvir}{\code{signature(x = "SYSargsList", silent = FALSE)}: 
              return a vector of character strings giving the names of the 
              objects in the \code{SYSargsList} environment }
    \item{copyEnvir}{\code{signature(x = "SYSargsList", list = character(), 
                            new.env = globalenv(), silent = FALSE)}:
            copy of the contents or select objects from \code{SYSargsList}
            environment and place them into new.env }
    \item{addResources}{\code{signature(x = "SYSargsList", step, resources)}:
            Adds the computing resources for one or multiple steps in the workflow.
            If the particular step(s) is set to be executed "management section,"
            when the resources is added, the step(s) will be executed on the
            "compute section." }
    \item{getColumn}{\code{signature(x = "SYSargsList", step, 
            position = c("outfiles", "targetsWF"), column = 1, 
            names = SampleName(x, step))}:
            extracts the information for \code{targetsWF} or \code{outfiles} 
            slots. The information can be used in an R code downstream }
    \item{[[<-}{\code{signature(x = "SYSargsList", i = "ANY", j = "ANY", value = "ANY")}: 
              replacement method for \code{SYSargsList} class }
    \item{appendStep<-}{\code{signature(x = "SYSargsList", after = length(x))}:
              insert the \code{SYSargsList} or \code{LineWise} object onto x at 
              the position given by \code{after} }
    \item{yamlinput<-}{\code{signature(x = "SYSargsList", step, paramName )}: 
              replace a value in the \code{yamlinput} slot for a specific step instance }
    \item{replaceStep<-}{\code{signature(x = "SYSargsList", step, step_name = "default")}:
              replace a specific step in the workflow instance }
    \item{renameStep<-}{\code{signature(x = "SYSargsList")}: 
              rename a \code{stepName} in the workflow instance }
    \item{dependency<-}{\code{signature(x = "SYSargsList", step)}: 
              replace dependency graph for a specific step instance }
    \item{appendCodeLine<-}{\code{signature(x = "SYSargsList", step, after = length(x))}:
              insert the R code in a specific step at the position given by \code{after} }
    \item{replaceCodeLine<-}{\code{signature(x = "SYSargsList", step, line)}:
              replace the R code in a specific step at the position given by \code{line} }
    \item{updateColumn<-}{\code{signature(x = "SYSargsList", step, 
              position = c("outfiles", "targetsWF"))}:
              update or add a new column in \code{targetsWF} or \code{outfiles} slots }
  }
}
\author{
Daniela Cassol and Thomas Girke
}
\seealso{
\code{SYSargs2}, \code{LineWise}, and \code{SPRproject}
}
\examples{
sal <- SPRproject(overwrite=TRUE)
targetspath <- system.file("extdata/cwl/example/targets_example.txt", 
                            package="systemPipeR")

## Constructor and `appendStep<-`
appendStep(sal) <- SYSargsList(step_name = "echo", 
                               targets=targetspath, dir=TRUE,
                               wf_file="example/workflow_example.cwl", 
                               input_file="example/example.yml", 
                               dir_path = system.file("extdata/cwl", 
                               package="systemPipeR"),
                               inputvars = c(Message = "_STRING_",
                               SampleName = "_SAMPLE_"))
                               
appendStep(sal) <- LineWise(code = {
                            hello <- lapply(getColumn(sal, step=1, 'outfiles'), function(x) yaml::read_yaml(x))
                            }, 
                            step_name = "R_read", 
                            dependency = "echo")
sal 

length(sal)
names(sal)

## Accessors

stepsWF(sal)
statusWF(sal)
targetsWF(sal)
outfiles(sal)
SE(sal)
dependency(sal)
projectInfo(sal)
runInfo(sal)

## Methods

cmdlist(sal, step=1, targets=1:2) ## SYSargs2 step
codeLine(sal, step=2) ## LineWise step
SampleName(sal, step="echo")
stepName(sal)
baseCommand(sal, 1) ## SYSargs2 step
targetsheader(sal, step=1) ## SYSargs2 step
yamlinput(sal, step=1) ## SYSargs2 step
viewEnvir(sal)
copyEnvir(sal, list = character(), new.env = globalenv())

resources <- list(conffile= system.file("extdata/.batchtools.conf.R", 
                            package="systemPipeR"),
                  template= system.file("extdata/batchtools.slurm.tmpl", 
                            package="systemPipeR"),
                  Njobs=3, ## Usually, the samples number
                  walltime=60, ## minutes
                  ntasks=1,
                  ncpus=4, 
                  memory=1024 ## Mb
)
addResources(sal, 1, resources= resources)

## Subset Methods

sal_sub <- subset(sal, subset_steps=1, input_targets=1:2, keep_steps = TRUE)
sal_sub
targetsIn <- getColumn(sal, step=1, position = c("outfiles"))
targetsIn

## Replacement
renameStep(sal, step=1) <- "new_echo"
dependency(sal, step=2) <- "new_echo"
updateColumn(sal, step=2, position = c("targetsWF")) <- data.frame(targetsIn)
targetsWF(sal)

replaceStep(sal, step=2) <- LineWise(code = {
                            hello <- "Printing a new message"
                            }, 
                            step_name = "R_hello", 
                            dependency = "new_echo")
codeLine(sal)
yamlinput(sal, step=1, paramName="results_path") <- list(results_path=list(
                                            class="Directory", path="./data"))
cmdlist(sal, step = 1, targets = 1)
appendCodeLine(sal, step=2, after = 0) <- "log <- log(10)"
codeLine(sal, 2)
replaceCodeLine(sal, step=2, line=1) <- LineWise(code = {
                            log <- log(50)
                            })
codeLine(sal, 2)
}
\keyword{ classes }

\name{mergeBamByFactor}
\alias{mergeBamByFactor}
\title{
Merge BAM files based on factor
}
\description{
Merges BAM files based on sample groupings provided by a factor using internally
the \code{mergeBam} function from the \code{Rsamtools} package. The function
also returns an updated \code{SYSargs} or \code{SYSargs2} object containing
the paths to the merged BAM files as well as to the unmerged BAM files if there
are any. All rows of merged parent samples are removed. When a \code{named
character vector} is provided as input, a \code{data.frame} with a target
containing the paths to the merged BAM files as output.

The functionality provided by \code{mergeBamByFactor} is useful for experiments
where pooling of replicates is advantageous to maximize the depth of read
coverage, such as prior to peak calling in ChIP-Seq or miRNA gene prediction
experiments.
}
\usage{
mergeBamByFactor(args, targetsDF = NULL, mergefactor = "Factor",
                out_dir = file.path("results", "merge_bam"),
                overwrite = FALSE, silent = FALSE, ...)
}
\arguments{
  \item{args}{
    An instance of \code{SYSargs} or \code{SYSargs2} constructed from a
    \code{targets} file where the first column (\code{targetsin(args)} or
    \code{targets.as.df(targets(args))}) contains the paths to the BAM files
    along with the column title \code{FileName}. Another possibily is
    \code{named character vector} with BAM files PATH and the elements names
    should be the sampleID.
}
  \item{targetsDF}{
    This argument is required when \code{named character vector} is provided as
    input. Default is \code{NULL}.
    Object of class \code{DFrame}, and it can be obtained with
    \code{targetsWF(<SYSargsList>)}.
}
  \item{mergefactor}{
    \code{factor} containing the grouping information required for merging the
    BAM files referenced in the first column of \code{targetsin(args)} or
    \code{targets.as.df(targets(args))}. The default uses \code{Factor} column
    from the \code{targets} files as factor. The latter merges BAM files for
    which replicates are specified in the \code{Factor} column.
}
  \item{out_dir}{
    The directory path to store merged bam files. Default uses \code{"merge_bam"}
    directory inside the results directory. directory not existing before
    running the function is alllowed. It will be created while running.
}
  \item{overwrite}{
    If \code{overwrite=FALSE} existing BAM files of the same name will not be
    overwritten.
}
  \item{silent}{
    If \code{silent=TRUE} print statements will be suppressed.
}
  \item{\dots}{
    To pass on additional arguments to the internally used \code{mergeBam}
    function from \code{Rsamtools}.
}
}
\value{
The merged BAM files will be written to output files with the following naming
convention: <first_BAM_file_name>_<grouping_label_of_factor>.<bam>. In
addition, the function returns an updated \code{SYSargs} or \code{SYSargs2}
object where all output file paths contain the paths to the merged BAM files.
When a \code{named character vector} is provided as input, a \code{data.frame}
with a target containing the paths to the merged BAM files as output.
The rows of the merged parent samples are removed and the rows of the unmerged
samples remain unchanged.
}
\author{
Thomas Girke
}
\seealso{
\code{writeTargetsout}, \code{writeTargetsRef}
}
\examples{
## Construct initial SYSargs object
targetspath <- system.file("extdata", "targets_chip.txt", package="systemPipeR")
parampath <- system.file("extdata", "bowtieSE.param", package="systemPipeR")
args <- systemArgs(sysma=parampath, mytargets=targetspath)

\dontrun{
## After running alignmets (e.g. with Bowtie2) generate targets file
## for the corresponding BAM files. The alignment step is skipped here.
writeTargetsout(x=args, file="targets_bam.txt", overwrite=TRUE)
args <- systemArgs(sysma=NULL, mytargets="targets_bam.txt")

## Merge BAM files and return updated SYSargs object
args_merge <- mergeBamByFactor(args, overwrite=TRUE, silent=FALSE)

## Export modified targets file
writeTargetsout(x=args_merge, file="targets_mergeBamByFactor.txt", overwrite=TRUE)
}
}
\keyword{ utilities }
